'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Chad Chen
 创建时间 : 2015-04-15
 说明     : 应用程序模块注册
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.price' /*价格模块*/, {
            url: '/price',
            templateUrl: 'Module/Price/priceListView.html',
            controller: 'priceListController'
        }).state('main.price.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/Price/priceEditView.html',
            controller: 'priceEditController'
        }).state('main.storeretailtarget' /*门店零售目标额模块*/, {
            url: '/storeretailtarget',
            templateUrl: 'Module/StoreRetailTarget/storeretailtargetListView.html?v=' + win.htmlFileVersion,
            controller: 'storeretailtargetListController'
        }).state('main.storeretailtarget.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/StoreRetailTarget/storeretailtargetEditView.html?v=' + win.htmlFileVersion,
            controller: 'storeretailtargetEditController'
        }).state('main.chainaccount' /*连锁总部*/, {
            url: '/chainaccount',
            templateUrl: 'Module/ChainAccount/chainaccountListView.html?v=' + win.htmlFileVersion,
            controller: 'chainaccountListController'
        }).state('main.chainaccount.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/ChainAccount/chainaccountEditView.html?v=' + win.htmlFileVersion,
            controller: 'chainaccountEditController'
        }).state('main.salesregion' /*销售区域*/, {
            url: '/salesregion',
            templateUrl: 'Module/SalesRegion/salesregionListView.html?v=' + win.htmlFileVersion,
            controller: 'salesregionListController'
        }).state('main.salesregion.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/SalesRegion/salesregionEditView.html?v=' + win.htmlFileVersion,
            controller: 'salesregionEditController'
        }).state('main.salesactivity' /*营销活动模块*/, {
            url: '/salesactivity',
            templateUrl: 'Module/SalesActivity/salesactivityListView.html?v=' + win.htmlFileVersion,
            controller: 'salesactivityListController'
        }).state('main.salesactivity.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/SalesActivity/salesactivityEditView.html?v=' + win.htmlFileVersion,
            controller: 'salesactivityEditController'
        }).state('main.accountcarerulebirthday' /*生日关怀模块*/, {
            url: '/accountcarerulebirthday',
            templateUrl: 'Module/AccountCareRuleBirthday/accountCareRuleBirthdayListView.html?v=' + win.htmlFileVersion,
            controller: 'accountCareRuleBirthdayListController'
        }).state('main.accountcarerulebirthday.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/AccountCareRuleBirthday/accountCareRuleBirthdayEditView.html?v=' + win.htmlFileVersion,
            controller: 'accountCareRuleBirthdayEditController'
        }).state('main.generalcampaign', {
            templateUrl: 'Module/GeneralCampaign/generalcampaignListView.html?v=' + win.htmlFileVersion
        }).state('main.generalcampaign.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/GeneralCampaign/generalcampaignEditView.html?v=' + win.htmlFileVersion
        }).state('main.birthdaycampaign2', {
            templateUrl: 'Module/BirthdayCampaign2/birthdaycampaign2ListView.html?v=' + win.htmlFileVersion
        }).state('main.birthdaycampaign2.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/BirthdayCampaign2/birthdaycampaign2EditView.html?v=' + win.htmlFileVersion
        }).state('main.tag' /*客户标签*/, {
            url: '/tag',
            templateUrl: 'Module/Tag/tagListView.html?v=' + win.htmlFileVersion,
            controller: 'tagListController'
        }).state('main.tag.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/Tag/tagEditView.html?v=' + win.htmlFileVersion,
            controller: 'tagEditController'
        })
        // .state('main.memberLevel'/*会员等级*/, {
        //     url: '/product_category',
        //     templateUrl: 'Module/memberLevel/memberLevelListView.html?v=' + win.htmlFileVersion,
        //     controller: 'memberLevelListController'
        // })
        // .state('main.memberLevel.edit', {
        //     url: '/edit/:id',
        //     templateUrl: 'Module/memberLevel/memberLevelEditView.html?v=' + win.htmlFileVersion,
        //     controller: 'memberLevelEditController'
        // })
        .state('main.productCategory' /*产品类别*/, {
            url: '/product_category',
            templateUrl: 'Module/ProductCategory/productCategoryListView.html?v=' + win.htmlFileVersion,
            controller: 'productCategoryListController'
        }).state('main.productCategory.editcategory', {
            url: '/editcategory/:id/:hasChildren',
            templateUrl: 'Module/ProductCategory/productCategoryEditView.html?v=' + win.htmlFileVersion,
            controller: 'productCategoryEditController'
        }).state('main.productCategory.editproduct', {
            url: '/editproduct/:id',
            templateUrl: 'Module/Product/productEditView.html?v=' + win.htmlFileVersion,
            controller: 'productEditController'
        }).state('main.product' /*产品*/, {
            url: '/product',
            templateUrl: 'Module/Product/ProductListView.html?v=' + win.htmlFileVersion,
            controller: 'productListController'
        }).state('main.product.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/Product/productEditView.html?v=' + win.htmlFileVersion,
            controller: 'productEditController'
        }).state('main.ratinglog.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/Ratinglog/ratinglogEditView.html?v=' + win.htmlFileVersion,
            controller: 'ratinglogEditController'
        }).state('main.email', {
            url: '/email',
            templateUrl: 'Module/Email/emailListView.html?v=' + win.htmlFileVersion
        }).state('main.sms', {
            url: '/sms',
            templateUrl: 'Module/SMS/smsListView.html?v=' + win.htmlFileVersion
        }).state('main.phonecall', {
            url: '/phonecall',
            templateUrl: 'Module/PhoneCall/phonecallListView.html?v=' + win.htmlFileVersion
        }).state('main.phonecall.edit', {
            url: '/edit',
            templateUrl: 'Module/PhoneCall/phonecallEditView.html?v=' + win.htmlFileVersion
        }).state('main.serviceinvest', {
            url: '/serviceinvest',
            templateUrl: 'Module/ServiceInvest/serviceInvestListView.html?v=' + win.htmlFileVersion,
            controller: 'serviceInvestListController'
        }).state('main.serviceinvest.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/ServiceInvest/serviceInvestEditView.html?v=' + win.htmlFileVersion,
            controller: 'serviceInvestEditController'
        }).state('main.couponrecords', {
            url: '/couponrecords',
            templateUrl: 'Module/CouponRecords/couponrecordsListView.html?v=' + win.htmlFileVersion
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/10/20
 说明     : 大区经理拜访统计表（OTC）（佐力）
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.bigdepmanageotcvisitreport' /*大区经理拜访统计表（OTC）*/, {
            url: '/bigdepmanageotcvisitreport',
            templateUrl: 'Jolly/BigDepManageOTCVisitReport/bigDepManageOTCVisitReportView.html?v=' + win.htmlFileVersion,
            controller: 'bigDepManageOTCVisitReportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016/10/20
 说明     : 大区经理拜访统计表(按医生)(佐力)
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.bigdepmanagevisitreport' /*大区经理拜访统计表*/, {
            url: '/bigdepmanagevisitreport',
            templateUrl: 'Jolly/BigDepManageVisitReport/bigDepManageVisitReportListView.html?v=' + win.htmlFileVersion,
            controller: 'bigDepManageVisitReportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016/10/18
 说明     : 代表拜访统计表(按医生)(佐力)
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.delegatevisitreport' /*代表拜访统计表*/, {
            url: '/delegatevisitreport',
            templateUrl: 'Jolly/DelegateVisitReport/delegateVisitReportListView.html?v=' + win.htmlFileVersion,
            controller: 'delegateVisitReportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016/10/21
 说明     : OTC代表拜访统计表(佐力)
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.otcdelegatevisitreport' /*otc代表拜访统计表*/, {
            url: '/otcdelegatevisitreport',
            templateUrl: 'Jolly/OTCDelegateVisitReport/OTCDelegateVisitReportListView.html?v=' + win.htmlFileVersion,
            controller: 'OTCDelegateVisitReportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2016/10/20
 说明     : OTC地区经理拜访统计表(按医生)(佐力)
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.otcregionmanagervisitreport' /*OTC地区经理拜访统计表*/, {
            url: '/otcregionmanagervisitreport',
            templateUrl: 'Jolly/OTCRegionManagerVisitReport/otcRegionManagerVisitReportListView.html?v=' + win.htmlFileVersion,
            controller: 'otcRegionManagerVisitReportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2016/10/20
 说明     : 拜访明细查询(OTC)(佐力)
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.otcvisitdetailsreport' /*代表拜访统计表*/, {
            url: '/otcvisitdetailsreport',
            templateUrl: 'Jolly/OTCVisitDetailsReport/OTCVisitDetailsReportListView.html?v=' + win.htmlFileVersion,
            controller: 'OTCVisitDetailsReportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2016/10/19
 说明     : 地区经理拜访统计表(按医生)(佐力)
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.regionmanagervisitreport' /*代表拜访统计表*/, {
            url: '/regionmanagervisitreport',
            templateUrl: 'Jolly/RegionManagerVisitReport/regionManagerVisitReportListView.html?v=' + win.htmlFileVersion,
            controller: 'regionManagerVisitReportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2016/10/19
 说明     : 代表负责客户
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.representativeowneraccount' /*代表拜访统计表*/, {
            url: '/representativeowneraccount',
            templateUrl: 'Jolly/RepresentativeOwnerAccount/RepresentativeOwnerAccountListView.html?v=' + win.htmlFileVersion,
            controller: 'RepresentativeOwnerAccountController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2016/10/19
 说明     : 拜访明细查询(按医生)(佐力)
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.visitdetailsreport' /*代表拜访统计表*/, {
            url: '/visitdetailsreport',
            templateUrl: 'Jolly/VisitDetailsReport/visitDetailsReportListView.html?v=' + win.htmlFileVersion,
            controller: 'visitDetailsReportController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2016-03-29
 说明     : 请假
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.absence' /*请假列表*/, {
            url: '/absence',
            templateUrl: 'OA/Absence/absenceListView.html?v=' + win.htmlFileVersion,
            controller: 'absenceListController'
        }).state('main.absence.edit' /*请假编辑*/, {
            url: '/edit/:id',
            templateUrl: 'OA/Absence/absenceEditView.html?v=' + win.htmlFileVersion,
            controller: 'absenceEditController'
        }).state('main.absence.readonly' /*请假只读*/, {
            url: '/readonly/:id',
            templateUrl: 'OA/Absence/absenceReadOnlyView.html?v=' + win.htmlFileVersion,
            controller: 'absenceReadOnlyController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Kevin Zhou
 创建时间 : 2016-04-07
 说明     : 外勤管理
 ********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.attendance' /*外勤签到查询*/, {
            url: '/attendance',
            templateUrl: 'OA/Attendance/attendanceListView.html?v=' + win.htmlFileVersion,
            controller: 'attendanceController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2016-03-29
 说明     : 出差
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.businessTrip' /*出差列表*/, {
            url: '/businessTrip',
            templateUrl: 'OA/BusinessTrip/businessTripListView.html?v=' + win.htmlFileVersion,
            controller: 'businessTripListController'
        }).state('main.businessTrip.edit' /*出差编辑*/, {
            url: '/edit/:id',
            templateUrl: 'OA/BusinessTrip/businessTripEditView.html?v=' + win.htmlFileVersion,
            controller: 'businessTripEditController'
        }).state('main.businessTrip.readonly' /*出差只读*/, {
            url: '/readonly/:id',
            templateUrl: 'OA/BusinessTrip/businessTripReadOnlyView.html?v=' + win.htmlFileVersion,
            controller: 'businessTripReadOnlyController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-02-29
 说明     : 日报
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.dailyreport' /*日报列表*/, {
            url: '/dailyreport',
            templateUrl: 'OA/DailyReport/dailyreportListView.html?v=' + win.htmlFileVersion,
            controller: 'dailyreportListController'
        }).state('main.dailyreport.edit' /*日报编辑*/, {
            url: '/edit/:id',
            templateUrl: 'OA/DailyReport/dailyreportEditView.html?v=' + win.htmlFileVersion,
            controller: 'dailyreportEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016-03-30
 说明     : 报销申请
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.expense' /*报销申请列表*/, {
            url: '/expense',
            templateUrl: 'OA/Expense/expenseListView.html?v=' + win.htmlFileVersion,
            controller: 'expenseListController'
        }).state('main.expense.edit' /*报销申请编辑*/, {
            url: '/edit/:id',
            templateUrl: 'OA/Expense/expenseEditView.html?v=' + win.htmlFileVersion,
            controller: 'expenseEditController'
        }).state('main.expense.readonly' /*报销只读*/, {
            url: '/readonly/:id',
            templateUrl: 'OA/Expense/expenseReadOnlyView.html?v=' + win.htmlFileVersion,
            controller: 'expenseReadOnlyController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/4/8
 说明     : 审批 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.flowapproval' /*审批列表*/, {
            url: '/flowapproval',
            templateUrl: 'OA/FlowApproval/flowapprovalListView.html?v=' + win.htmlFileVersion,
            controller: 'flowapprovalListController'
        }).state('main.flowapproval.edit1' /*请假编辑*/, {
            url: '/edit1/:id',
            templateUrl: 'OA/Absence/absenceReadOnlyView.html?v=' + win.htmlFileVersion,
            controller: 'absenceReadOnlyController'
        }).state('main.flowapproval.edit2' /*通用申请编辑*/, {
            url: '/edit2/:id',
            templateUrl: 'cmm/commonapplication/commonapplicationReadOnlyView.html?v=' + win.htmlFileVersion,
            controller: 'commonapplicationReadOnlyController'
        }).state('main.flowapproval.edit3' /*出差编辑*/, {
            url: '/edit3/:id',
            templateUrl: 'OA/BusinessTrip/businessTripReadOnlyView.html?v=' + win.htmlFileVersion,
            controller: 'businessTripReadOnlyController'
        }).state('main.flowapproval.edit4' /*报销申请编辑*/, {
            url: '/edit4/:id',
            templateUrl: 'OA/Expense/expenseReadOnlyView.html?v=' + win.htmlFileVersion,
            controller: 'expenseReadOnlyController'
        }).state('main.flowapproval.edit5' /*订单申请编辑*/, {
            url: '/edit5/:id',
            templateUrl: 'Module/SalesOrder/salesorderEditView.html?v=' + win.htmlFileVersion,
            controller: 'salesorderEditController'
        }).state('main.flowapproval.edit6' /*订单申请编辑*/, {
            url: '/edit6/:id',
            templateUrl: 'Module/Leads/leadsEditView.html?v=' + win.htmlFileVersion,
            controller: 'leadsEditController'
        }).state('main.flowapproval.edit7' /*机构变更申请编辑*/, {
            url: '/edit7/:id',
            templateUrl: 'Module/AccountApp/accountAppReadView.html?v=' + win.htmlFileVersion,
            controller: 'accountAppReadController'
        }).state('main.flowapproval.edit8' /*医生变更申请编辑*/, {
            url: '/edit8/:id',
            templateUrl: 'Module/ContactApp/contactAppReadView.html?v=' + win.htmlFileVersion,
            controller: 'contactAppReadController'
        }).state('main.flowapproval.edit9' /*医生评级申请编辑*/, {
            url: '/edit9/:id',
            templateUrl: 'Module/ContactGradeApp/contactGradeAppReadOnlyView.html?v=' + win.htmlFileVersion,
            controller: 'contactGradeAppReadOnlyController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar
 创建时间 : 2018/2/2
 说明     :通用审批流程设置  路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.flowapprovalcommon', {
            url: '/flowapprovalcommon',
            templateUrl: 'OA/FlowApprovalCommon/flowapprovalcommonListView.html?v=' + win.htmlFileVersion,
            controller: 'flowapprovalcommonListController'
        }).state('main.flowapprovalcommon.edit', {
            url: '/edit/:id',
            templateUrl: 'OA/FlowApprovalCommon/flowapprovalcommonEditView.html?v=' + win.htmlFileVersion,
            controller: 'flowapprovalcommonEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lecrean Pan
 创建时间 : 2018/1/30
 说明     : 审批角色 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.flowrole', { /*审批角色列表页面*/
            url: '/flowrole',
            templateUrl: 'OA/FlowRole/flowRoleListView.html?v=' + win.htmlFileVersion,
            controller: 'flowRoleListController'
        }).state('main.flowrole.edit', { /*审批角色编辑页面*/
            url: '/edit/:id',
            templateUrl: 'OA/FlowRole/flowRoleEditView.html?v=' + win.htmlFileVersion,
            controller: 'flowRoleEditController'
        }).state('main.flowrole.edit1', { /*审批角色人员编辑页面*/
            url: '/edit1/:id',
            templateUrl: 'OA/FlowRole/flowRoleUserEditView.html?v=' + win.htmlFileVersion,
            controller: 'flowRoleUserEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-03-01
 说明     : 月报
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.monthlyreport' /*月报列表*/, {
            url: '/monthlyreport',
            templateUrl: 'OA/MonthlyReport/monthlyreportListView.html?v=' + win.htmlFileVersion,
            controller: 'monthlyreportListController'
        }).state('main.monthlyreport.edit' /*月报编辑*/, {
            url: '/edit/:id',
            templateUrl: 'OA/MonthlyReport/monthlyreportEditView.html?v=' + win.htmlFileVersion,
            controller: 'monthlyreportEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Kevin Zhou
 创建时间 : 2016-04-07
 说明     : 考勤管理
 ********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.officeattendance' /*考勤管理查询*/, {
            url: '/officeattendance',
            templateUrl: 'OA/OfficeAttendance/officeattendanceListView.html?v=' + win.htmlFileVersion,
            controller: 'officeattendanceController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-02-26
 说明     : 任务
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.Xcrmtask' /*任务列表*/, {
            url: '/task',
            templateUrl: 'OA/Task/taskListView.html?v=' + win.htmlFileVersion,
            controller: 'taskListController'
        }).state('main.Xcrmtask.edit' /*任务编辑*/, {
            url: '/edit/:id',
            templateUrl: 'OA/Task/taskEditView.html?v=' + win.htmlFileVersion,
            controller: 'taskEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Kevin Zhou
 创建时间 : 2016-03-01
 说明     : 周报
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.weeklyreport' /*周报列表*/, {
            url: '/WeeklyReport',
            templateUrl: 'OA/WeeklyReport/weeklyreportListView.html?v=' + win.htmlFileVersion,
            controller: 'weeklyreportListController'
        }).state('main.weeklyreport.edit' /*周报编辑*/, {
            url: '/edit/:id',
            templateUrl: 'OA/WeeklyReport/weeklyreportEditView.html?v=' + win.htmlFileVersion,
            controller: 'weeklyreportEditController'
        });
    }]);
})(window);
'use strict';

/**********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2017-02-07
 说明     : 周报
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.zlweeklyreport' /*周报列表*/, {
            url: '/zlWeeklyReport',
            templateUrl: 'OA/WeeklyReport_zl/zlweeklyreportListView.html?v=' + win.htmlFileVersion,
            controller: 'zlweeklyreportListController'
        }).state('main.zlweeklyreport.edit' /*周报编辑*/, {
            url: '/edit/:id',
            templateUrl: 'OA/WeeklyReport_zl/zlweeklyreportEditView.html?v=' + win.htmlFileVersion,
            controller: 'zlweeklyreportEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-04-06
 说明     : 工作报告 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.workreportread' /*工作报告列表*/, {
            url: '/workreportread',
            templateUrl: 'OA/WorkReportRead/workreportreadListView.html?v=' + win.htmlFileVersion,
            controller: 'workreportreadListController'
        }).state('main.workreportread.edit1' /*日报编辑*/, {
            url: '/edit1/:id',
            templateUrl: 'OA/DailyReport/dailyreportEditView.html?v=' + win.htmlFileVersion,
            controller: 'dailyreportEditController'
        }).state('main.workreportread.edit2' /*周报编辑*/, {
            url: '/edit2/:id',
            templateUrl: 'OA/WeeklyReport/weeklyreportEditView.html?v=' + win.htmlFileVersion,
            controller: 'weeklyreportEditController'
        }).state('main.workreportread.edit3' /*月报编辑*/, {
            url: '/edit3/:id',
            templateUrl: 'OA/MonthlyReport/monthlyreportEditView.html?v=' + win.htmlFileVersion,
            controller: 'monthlyreportEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016/6/17
 说明     : 商业发货统计 路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.businessdeliverystatistics', {
            url: '/businessdeliverystatistics',
            templateUrl: 'Module/BusinessDeliveryStatistics/businessDeliveryStatisticsListView.html?v=' + win.htmlFileVersion,
            controller: 'businessDeliveryStatisticsController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016/6/17
 说明     : 商业分销统计 路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.businessdistributevendition', {
            url: '/businessdistributevendition',
            templateUrl: 'Module/BusinessDistributeVendition/businessDistributeVenditionListView.html?v=' + win.htmlFileVersion,
            controller: 'businessDistributeVenditionListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016-5-5
 说明     :商务整体回款
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.businessBackSection', {
            url: '/businessBackSection',
            templateUrl: 'Module/BusinessLineReport/BEBackSectionList.html?v=' + win.htmlFileVersion,
            controller: 'BEBackSectionController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2016/1/29
 说明     : 商业psi
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.businesspsi', {
            url: '/businesspsiView',
            templateUrl: 'Module/BusinessLineReport/PsiListView.html?v=' + win.htmlFileVersion,
            controller: 'PsiListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2016/6/15
 说明     : 部门药品清单管理
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.businessunitproduct' /*部门药品清单列表*/, {
            url: '/BusinessUnitProduct',
            templateUrl: 'Module/BusinessUnitProduct/businessUnitProductListView.html?v=' + win.htmlFileVersion,
            controller: 'businessUnitProductListController'
        }).state('main.businessunitproduct.edit' /*部门药品清单编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/BusinessUnitProduct/businessUnitProductEditView.html?v=' + win.htmlFileVersion,
            controller: 'businessUnitProductEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-6
 说明     :商业拜访
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.BusinessVisit' /*商业拜访列表*/, {
            url: '/businessvisit',
            templateUrl: 'Module/BusinessVisit/BusinessVisitListView.html?v=' + win.htmlFileVersion,
            controller: 'businessvisitListController'
        }).state('main.BusinessVisit.edit' /*拜访计划编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/BusinessVisit/BusinessVisitEditView.html?v=' + win.htmlFileVersion,
            controller: 'businessvisitEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/5/15
 说明     : 流向处理 - 计算流向归属 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.caldrugflowassignment', {
            url: '/caldrugflowassignment/:ym/:frombuid /:fromaccid',
            //url: '/caldrugflowassignment',
            templateUrl: 'Module/CalDrugFlowAssignment/calDrugFlowAssignmentListView.html?v=' + win.htmlFileVersion,
            controller: 'CalDrugFlowAssignmentListController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： ludwig-Dong
 *电子邮箱：ludwigdong@reltect.com.cn
 *创建时间：2016/6/28
 *描述：市场活动
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.campaign' /*市场活动*/, {
            url: '/campaign',
            templateUrl: 'Module/Campaign/campaignList.html?v=' + win.htmlFileVersion,
            controller: 'campaignListController'
        }).state('main.campaign.edit' /*市场活动编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/Campaign/campaignEditView.html?v=' + win.htmlFileVersion,
            controller: 'campaignEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-12-13
 说明     :市场活动出勤统计 路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.campaignjoinreport' /*市场活动出勤统计*/, {
            url: '/campaignjoinreport',
            templateUrl: 'Module/CampaignJoinReport/campaignjoinreportListView.html?v=' + win.htmlFileVersion,
            controller: 'campaignjoinreportController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/3/2
 *描述：回款管理
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.cashback' /*回款管理*/, {
            url: '/CashBack',
            templateUrl: 'Module/CashBack/cashbackListView.html?v=' + win.htmlFileVersion,
            controller: 'cashbackListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2017-04-20
 说明     : 竞品终端销量采集
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.competingprocollect' /*列表*/, {
            url: '/competingprocollect',
            templateUrl: 'Module/CompetingproCollect/competingproCollectListView.html?v=' + win.htmlFileVersion,
            controller: 'competingproCollectListController'
        }).state('main.competingprocollect.edit' /*编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/CompetingproCollect/competingproCollectEditView.html?v=' + win.htmlFileVersion,
            controller: 'competingproCollectEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/20
 说明     : 竞品信息 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.competing_product' /*竞品信息 列表*/, {
            url: '/competing_product',
            templateUrl: 'Module/CompetingProduct/CompetingProductListView.html?v=' + win.htmlFileVersion,
            controller: 'CompetingProductListController'
        }).state('main.competing_product.edit' /*竞品信息 编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/CompetingProduct/CompetingProductEditView.html?v=' + win.htmlFileVersion,
            controller: 'CompetingProductEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2016/1/29
 说明     : 医生档案管理
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.accountcontact' /*联系人档案列表*/, {
            url: '/contact',
            templateUrl: 'Module/Contact/contactListView.html?v=' + win.htmlFileVersion,
            controller: 'contactListController'
        }).state('main.accountcontact.edit' /*联系人档案编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/Contact/contactEditView.html?v=' + win.htmlFileVersion,
            controller: 'contactEditController'
        }).state('main.hospitalcontact' /*医生档案列表*/, {
            url: '/hospitalcontact',
            templateUrl: 'Module/HospitalContact/hospitalcontactListView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalcontactListController'
        }).state('main.hospitalcontact.edit' /*医生档案编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/HospitalContact/hospitalcontactEditView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalcontactEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2018-03-09
 说明     : 医生分级模型-路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.contactgradepattern' /*医院分级模型列表*/, {
            url: '/contactgradepattern',
            templateUrl: 'Module/ContactGradePattern/contactGradePatternListView.html?v=' + win.htmlFileVersion,
            controller: 'contactGradePatternListController'
        }).state('main.contactgradepattern.edit' /*代理商档案列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/CotactGradeEvalScoreRule/cotactGradeEvalScoreRuleEditView.html',
            controller: 'cotactGradeEvalScoreRuleEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2018-03-14
 说明     : 医生分级-分值区间-路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.cotactgradeevalscorerule' /*代理商档案列表*/, {
            url: '/cotactgradeevalscorerule',
            templateUrl: 'Module/CotactGradeEvalScoreRule/cotactGradeEvalScoreRuleListView.html?v=' + win.htmlFileVersion,
            controller: 'cotactGradeEvalScoreRuleListController'
        }).state('main.cotactgradeevalscorerule.edit' /*代理商档案列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/CotactGradeEvalScoreRule/cotactGradeEvalScoreRuleEditView.html',
            controller: 'cotactGradeEvalScoreRuleEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Gale Ge
创建时间 : 2016-12-19
说明     : 课程
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.course' /*医院档案列表*/, {
            url: '/course',
            templateUrl: 'Module/Course/courseListView.html?v=' + win.htmlFileVersion,
            controller: 'courseListController'
        }).state('main.course.edit' /*医院档案列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/Course/courseEditView.html',
            controller: 'courseEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Gale Ge
创建时间 : 2016-12-20
说明     : 课程类别
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.courseCategory' /*医院档案列表*/, {
            url: '/courseCategory',
            templateUrl: 'Module/CourseCategory/courseCategoryListView.html?v=' + win.htmlFileVersion,
            controller: 'courseCategoryListController'
        }).state('main.courseCategory.edit' /*医院档案列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/CourseCategory/courseCategoryEditView.html',
            controller: 'courseCategoryEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Gale Ge
创建时间 : 2016-12-20
说明     : 课程章节
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.courseChapter' /*医院档案列表*/, {
            url: '/courseChapter',
            templateUrl: 'Module/CourseChapter/courseChapterListView.html?v=' + win.htmlFileVersion,
            controller: 'courseChapterListController'
        }).state('main.courseChapter.edit' /*医院档案列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/CourseChapter/courseChapterEditView.html',
            controller: 'courseChapterEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/17
 说明     : 课程首页设计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.courseui' /*课程首页设计 列表*/, {
            url: '/courseui',
            templateUrl: 'Module/CourseUI/courseUIListView.html?v=' + win.htmlFileVersion,
            controller: 'CourseUIListController'
        }).state('main.courseui.edit' /*课程首页设计 编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/CourseUI/courseUIEditView.html?v=' + win.htmlFileVersion,
            controller: 'CourseUIEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-10-18
 说明     : 运营情况分析 路由
 ********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.csmreportlogin' /*运营情况分析*/, {
            url: '/csmreportlogin',
            templateUrl: 'Module/CsmReportLogin/csmReportLoginListView.html?v=' + win.htmlFileVersion,
            controller: 'csmReportLoginController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016-04-29
 说明     : 自定义类别
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.customcategory' /*自定义类别列表*/, {
            url: '/customcategory',
            templateUrl: 'Module/CustomCategory/customcategoryListView.html?v=' + win.htmlFileVersion,
            controller: 'customcategoryListController'
        }).state('main.customcategory.edit' /*自定义类别编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/CustomCategory/customcategoryEditView.html?v=' + win.htmlFileVersion,
            controller: 'customcategoryEditController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-05-15
 说明     : 客户别名库
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.ddmaccountalias' /*客户别名库*/, {
            url: '/ddmaccountalias',
            templateUrl: 'Module/DdmAccountAlias/DdmaccountaliasListView.html?v=' + win.htmlFileVersion,
            controller: 'ddmaccountaliasListController'
        }).state('main.ddmaccountalias.edit' /*客户别名库*/, {
            url: '/edit/:id',
            templateUrl: 'Module/DdmAccountAlias/DdmaccountaliasEditView.html?v=' + win.htmlFileVersion,
            controller: 'ddmaccountaliasEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/5/12
 说明     : 流向数据-流向调整 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.ddmadjdata' /*列表*/, {
            url: '/ddmadjdata',
            templateUrl: 'Module/DdmAdjData/ddmAdjDataListView.html?v=' + win.htmlFileVersion,
            controller: 'DdmAdjDataListController'
        }).state('main.ddmadjdata.edit' /*编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/DdmAdjData/ddmAdjDataEditView.html?v=' + win.htmlFileVersion,
            controller: 'DdmAdjDataEditController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-05-18
 说明     : 流向数据-b2b运行日志
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.ddmb2brunninglog' /*流向数据-b2b运行日志*/, {
            url: '/ddmb2brunninglog',
            templateUrl: 'Module/Ddmb2bRunningLog/Ddmb2bRunningLogListView.html?v=' + win.htmlFileVersion,
            controller: 'ddmb2brunninglogListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/05/15
 说明     : 流向数据-匹配别名
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.ddmcleandataproduct' /*匹配产品别名*/, {
            url: '/DDMCleanDataProduct/:ym/:frombuid /:fromaccid',
            templateUrl: 'Module/DDMCleanData/ddmcleandataproductListView.html?v=' + win.htmlFileVersion,
            controller: 'ddmcleandataproductListController'
        }).state('main.ddmcleandataaccount' /*匹配客户别名*/, {
            url: '/DDMCleanDataAccount/:ym/:frombuid /:fromaccid',
            templateUrl: 'Module/DDMCleanData/ddmcleandataaccountListView.html?v=' + win.htmlFileVersion,
            controller: 'ddmcleandataaccountListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/5/17
 说明     : 流向处理 - 流向数据锁定及下发 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.ddmlockdata', {
            url: '/ddmlockdata',
            templateUrl: 'Module/DdmLockData/ddmLockDataListView.html?v=' + win.htmlFileVersion,
            controller: 'DdmLockDataListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2017-05-16
 说明     :流向数据处理-主页面
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.ddmmanage' /*流向数据处理-主页面*/, {
            url: '/ddmmanage',
            templateUrl: 'Module/DDMManage/ddmManageView.html?v=' + win.htmlFileVersion,
            controller: 'ddmManageController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-05-16
 说明     : B2B流向数据
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.ddmrawdatab2b' /*B2B流向数据*/, {
            url: '/ddmrawdatab2b',
            templateUrl: 'Module/DdmRawDatab2b/ddmrawdatab2bListView.html?v=' + win.htmlFileVersion,
            controller: 'ddmrawdatab2bController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2017-05-12
 说明     :流向原始数据导入
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.ddmrawdataexcel' /*流向原始数据导入*/, {
            url: '/ddmrawdataexcel/:ym/:frombuid',
            templateUrl: 'Module/DDMRawDataExcel/ddmRawDataExcelView.html?v=' + win.htmlFileVersion,
            controller: 'ddmRawDataExcelController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Kevin Zhou
 创建时间 : 2016-04-14
 说明     : 代表排名 路由
 ********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.delegatevisitrank' /*代表排名查询*/, {
            url: '/delegatevisitrank',
            templateUrl: 'Module/DelegateVisitRank/delegatevisitrankListView.html?v=' + win.htmlFileVersion,
            controller: 'delegatevisitrankController'
        }).state('main.reportdata.delegatevisitrank' /*代表排名查询*/, {
            url: '/delegatevisitrank2',
            templateUrl: 'Module/DelegateVisitRank/delegatevisitrankListView.html?v=' + win.htmlFileVersion,
            controller: 'delegatevisitrankController'
        }).state('main.delegatevisitrank.edit' /*代表排名分数显示*/, {
            url: '/edit/:id',
            templateUrl: 'Module/DelegateVisitRank/delegatevisitrankScoreView.html?v=' + win.htmlFileVersion,
            controller: 'delegatevisitrankScoreController'
        }).state('main.reportdata.delegatevisitrank.edit' /*代表排名分数显示*/, {
            url: '/edit/:id',
            templateUrl: 'Module/DelegateVisitRank/delegatevisitrankScoreView.html?v=' + win.htmlFileVersion,
            controller: 'delegatevisitrankScoreController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/3/2
 *描述：发货管理
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.delivery' /*药品流向管理*/, {
            url: '/Delivery',
            templateUrl: 'Module/Delivery/deliveryListView.html?v=' + win.htmlFileVersion,
            controller: 'deliveryListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2016/2/1
 说明     : 科室管理
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.department' /*科室列表*/, {
            url: '/department',
            templateUrl: 'Module/Department/DepartmentListView.html?v=' + win.htmlFileVersion,
            controller: 'departmentListController'
        }).state('main.department.edit' /*科室编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/Department/DepartmentEditView.html?v=' + win.htmlFileVersion,
            controller: 'departmentEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/6/16
 说明     : 开发医院路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.developHospital' /*开发医院档案列表*/, {
            url: '/developHospital',
            templateUrl: 'Module/DevelopHospital/developHospitalListView.html?v=' + win.htmlFileVersion,
            controller: 'developHospitalListController'
        }).state('main.developHospital.edit' /*医院档案列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/DevelopHospital/developHospitalEditView.html',
            controller: 'developHospitalEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-02-07
 说明     : 医院开发跟进明细
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.activity' /*医院开发跟进明细*/, {
            url: '/activity',
            templateUrl: 'Module/DevelopHospitalActivityH/activityListView.html?v=' + win.htmlFileVersion,
            controller: 'activityController'
        });
    }]);
})(window);
'use strict';

/******************************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
 创建人   : Lecrean Pan
 创建时间 : 2018-3-2
 说明     : 疾病类型路由
******************************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.diseaseType' /*疾病类型列表页面*/, {
            url: '/disease_type',
            templateUrl: 'Module/DiseaseType/diseaseTypeListView.html?v=' + win.htmlFileVersion,
            controller: 'diseaseTypeListController'
        }).state('main.diseaseType.edit' /*疾病类型编辑页面*/, {
            url: '/edit/:id',
            templateUrl: 'Module/DiseaseType/diseaseTypeEditView.html?v=' + win.htmlFileVersion,
            controller: 'diseaseTypeEditController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Ludwig Dong
 *创建时间：2016/5/4
 *说明：分销分析
 *************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.distributionreach', {
            url: '/DistributiochView',
            templateUrl: 'Module/DistributionReach/DrListView.html?v=' + win.htmlFileVersion,
            controller: 'DrListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016/4/26
 说明     : 回款任务指标
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.distributiontask' /*分销任务指标*/, {
            url: '/distributiontask',
            templateUrl: 'Module/DistributionTask/distributiontaskListView.html?v=' + win.htmlFileVersion,
            controller: 'distributiontaskListController'
        }).state('main.distributiontask.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/DistributionTask/distributiontaskEditView.html?v=' + win.htmlFileVersion,
            controller: 'distributiontaskEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/5/9
 说明     : 医生DC量统计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.doctordcreport', {
            url: '/doctordcreport',
            templateUrl: 'Module/DoctorDCReport/DoctorDCReportView.html?v=' + win.htmlFileVersion,
            controller: 'DoctorDCReportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-10-09
 说明     : 客户热度（按医生） 路由
 ********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.doctorheatreport' /*客户热度(按医生)查询*/, {
            url: '/doctorheatreport',
            templateUrl: 'Module/DoctorHeatReport/doctorheatreportListView.html?v=' + win.htmlFileVersion,
            controller: 'doctorheatreportController'
        }).state('main.reportdata.doctorheatreport' /*客户热度(按医生)查询*/, {
            url: '/doctorheatreport2',
            templateUrl: 'Module/DoctorHeatReport/doctorheatreportListView.html?v=' + win.htmlFileVersion,
            controller: 'doctorheatreportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Kevin Zhou
 创建时间 : 2016-04-14
 说明     : 代表排名 路由
 ********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.doctorvisitedanalysis' /*代表排名查询*/, {
            url: '/doctorvisitedanalysis',
            templateUrl: 'Module/DoctorVisitedAnalysis/doctorvisitedanalysisListView.html?v=' + win.htmlFileVersion,
            controller: 'doctorvisitedanalysisController'
        }).state('main.reportdata.doctorvisitedanalysis' /*代表排名查询*/, {
            url: '/doctorvisitedanalysis2',
            templateUrl: 'Module/DoctorVisitedAnalysis/doctorvisitedanalysisListView.html?v=' + win.htmlFileVersion,
            controller: 'doctorvisitedanalysisController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2016/2/5
 说明     : 药品流向管理
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.drugflow' /*药品流向管理*/, {
            url: '/DrugFlow',
            templateUrl: 'Module/DrugFlow/drugflowListView.html?v=' + win.htmlFileVersion,
            controller: 'drugflowListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2017/05/12
 说明     : 药品流向 确认
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.drugflowconfirm' /*药品流向确认*/, {
            url: '/DrugFlowConfirm',
            templateUrl: 'Module/DrugFlowConfirm/drugflowconfirmListView.html?v=' + win.htmlFileVersion,
            controller: 'drugflowconfirmListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2018-01-12
 说明     : 流向数据-导入锁定
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.drugflowimportlock' /*列表*/, {
            url: '/drugflowimportlock',
            templateUrl: 'Module/DrugFlowImportLock/drugFlowImportLockListView.html?v=' + win.htmlFileVersion,
            controller: 'drugFlowImportLockListController'
        }).state('main.drugflowimportlock.edit' /*编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/DrugFlowImportLock/drugFlowImportLockEditView.html?v=' + win.htmlFileVersion,
            controller: 'drugFlowImportLockEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-06-28
 说明     : 流向计算 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.drugflowsettle', {
            url: '/drugflowsettle',
            templateUrl: 'Module/DrugFlowSettle/DrugFlowSettleView.html?v=' + win.htmlFileVersion,
            controller: 'DrugFlowSettleController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Julie Zhu
 创建时间 : 2018-1-9
 说明     :动销分析：流向铺货率分析
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.drugflowdistribution', {
            url: '/drugflowdistribution',
            templateUrl: 'Module/DynamicPinAnalysis/DistributionFlowListView.html?v=' + win.htmlFileVersion,
            controller: 'DistributionFlowListController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-01-18
 说明     : 考试
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.exam' /*考试列表*/, {
            url: '/exam',
            templateUrl: 'Module/Exam/ExamListView.html?v=' + win.htmlFileVersion,
            controller: 'examListController'
        }).state('main.exam.edit' /*考试编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/Exam/ExamEditView.html?v=' + win.htmlFileVersion,
            controller: 'examEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-8
 说明     :PC端医院协访
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.HospitalAssistance' /*商业协访列表*/, {
            url: '/hospitalassistance',
            templateUrl: 'Module/HospitalAssistance/HospitalAssistanceListView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalAssistanceListController'
        }).state('main.HospitalAssistance.edit' /*拜访计划编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/HospitalAssistance/HospitalAssistanceEditView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalAssistanceEditController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orangehong
 创建时间 : 2017-02-27
 说明     : 医院市场容量
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.hospitalmarketcapacity' /*医院市场容量列表*/, {
            url: '/hospitalmarketcapacity',
            templateUrl: 'Module/HospitalMarketCapacity/hospitalmarketcapacityListView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalmarketcapacityListController'
        }).state('main.hospitalmarketcapacity.edit' /*医院市场容量编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/HospitalMarketCapacity/hospitalmarketcapacityEditView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalmarketcapacityEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/5/6
 说明     : 临床线-代表指标达成路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.hospitalownertarget', {
            url: '/.hospitalownertarget',
            templateUrl: 'Module/HospitalOwnerTarget/hospitalOwnerTargetListView.html?v=' + win.htmlFileVersion,
            controller: 'HospitalOwnerTargetListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/5/9
 说明     : 按医院纯销统计 路由(entType参数 区分终端类型)
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.hospitalpurevendition', {
            url: '/hospitalpurevendition/:entType',
            templateUrl: 'Module/HospitalPureVendition/hospitalPureVenditionListView.html?v=' + win.htmlFileVersion,
            controller: 'HospitalPureVenditionController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016/4/26
 说明     : 纯销任务指标
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.hospitalsaletask' /*纯销任务指标*/, {
            url: '/hospitalsaletask',
            templateUrl: 'Module/HospitalSaleTask/hospitalsaletaskListView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalsaletaskListController'
        }).state('main.hospitalsaletask.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/HospitalSaleTask/hospitalsaletaskEditView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalsaletaskEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-6
 说明     :PC端医院拜访
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.HospitalVisit' /*医院拜访列表*/, {
            url: '/hospitalvisit',
            templateUrl: 'Module/HospitalVisit/HospitalVisitListView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalvisitListController'
        }).state('main.HospitalVisit.edit' /*拜访计划编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/HospitalVisit/HospitalVisitEditView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalvisitEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : oscar
 创建时间 : 2017-05-18
 说明     :PC端医院协访计划
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.HospitalVisitAssist' /*医院拜访列表*/, {
            url: '/hospitalvisitassist',
            templateUrl: 'Module/HospitalVisitAssistPlan/HospitalVisitAssistPlanListView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalVisitAssistPlanListController'
        }).state('main.HospitalVisitAssist.edit' /*拜访计划查看*/, {
            url: '/edit/:id',
            templateUrl: 'Module/HospitalVisitAssistPlan/HospitalVisitAssistPlanEditView.html',
            controller: 'hospitalVisitAssistPlanEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
     创建人   : Cherry Xu
 创建时间 : 2016/8/31
 说明     : 医院拜访计划维护 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.hospitalvisitplan' /*医院拜访计划维护*/, {
            url: '/hospitalvisitplan',
            templateUrl: 'Module/HospitalVisitPlan/HospitalVisitPlanListView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalVisitPlanListController'
        }).state('main.hospitalvisitplan.edit' /*拜访计划查看*/, {
            url: '/edit/:id',
            templateUrl: 'Module/HospitalVisit/HospitalVisitEditView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalvisitEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/5/11
 说明     : 重点医院指标达成 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.importanthospitaltarget', {
            url: '/importanthospitaltarget',
            templateUrl: 'Module/ImportantHospitalTarget/importantHospitalTargetListView.html?v=' + win.htmlFileVersion,
            controller: 'ImportantHospitalTargetListController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-05-15
 说明     : 客户别名库
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.incbusettlepricelist' /*客户别名库*/, {
            url: '/incbusettlepricelist',
            templateUrl: 'Module/IncBuSettlePricelist/IncBuSettlePricelistListView.html?v=' + win.htmlFileVersion,
            controller: 'IncBuSettlePricelistListController'
        }).state('main.incbusettlepricelist.edit' /*客户别名库*/, {
            url: '/edit/:id',
            templateUrl: 'Module/IncBuSettlePricelist/IncBuSettlePricelistEditView.html?v=' + win.htmlFileVersion,
            controller: 'IncBuSettlePricelistEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar
 创建时间 : 2017/06/28
 说明     : 流向结算金额 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.incdrugflowsettlerule' /*流向结算金额*/, {
            url: '/incdrugflowsettlerule',
            templateUrl: 'Module/IncDrugflowSettleRule/incDrugflowSettleRuleListView.html?v=' + win.htmlFileVersion,
            controller: 'incDrugflowSettleRuleListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar
 创建时间 : 2017/06/28
 说明     : 终端客户数据 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.incendaccountsettlepricelist' /*终端客户数据 列表*/, {
            url: '/incendaccountsettlepricelist',
            templateUrl: 'Module/IncEndAccountSettlePricelist/incEndAccountSettlePricelistListView.html?v=' + win.htmlFileVersion,
            controller: 'incEndAccountSettlePricelistListController'
        }).state('main.incendaccountsettlepricelist.edit' /*编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/IncEndAccountSettlePricelist/incEndAccountSettlePricelistEditView.html',
            controller: 'incEndAccountSettlePricelistEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : julie zhu
 创建时间 : 2018/2/6
 说明     : 机构签到
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.InstitutionSign', {
            url: '/InstitutionSign',
            templateUrl: 'Module/InstitutionSign/InstitutionSignListView.html?v=' + win.htmlFileVersion,
            controller: 'InstitutionSignListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2017-03-02
 说明     :PC端潜在代理商
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.leads' /*潜在代理商列表*/, {
            url: '/leads',
            templateUrl: 'Module/Leads/leadsListView.html?v=' + win.htmlFileVersion,
            controller: 'leadsListController'
        }).state('main.leads.edit' /*潜在代理商编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/Leads/leadsEditView.html',
            controller: 'leadsEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-02-08
 说明     : 潜在代理商创建明细
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.leadsreport' /*潜在代理商创建明细*/, {
            url: '/leadsreport',
            templateUrl: 'Module/LeadsReport/leadsreportListView.html?v=' + win.htmlFileVersion,
            controller: 'leadsreportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-09-29
 说明     : 部门拜访 路由
 ********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.managervisitassanalysis' /*部门拜访分析*/, {
            url: '/managervisitAssAnalysis',
            templateUrl: 'Module/ManagervisitAssAnalysis/ManagervisitAssAnalysisListView.html?v=' + win.htmlFileVersion,
            controller: 'ManagervisitAssAnalysisController'
        }).state('main.reportdata.managervisitassanalysis' /*部门拜访分析*/, {
            url: '/managervisitAssAnalysis2',
            templateUrl: 'Module/ManagervisitAssAnalysis/ManagervisitAssAnalysisListView.html?v=' + win.htmlFileVersion,
            controller: 'ManagervisitAssAnalysisController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2016-09-28
 说明     : 部门拜访分析(医生) 路由
 ********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.managervisitcontactanalysis' /*部门拜访分析(医生)*/, {
            url: '/managervisitcontactanalysis',
            templateUrl: 'Module/ManagerVisitContactAnalysis/managerVisitContactAnalysisListView.html?v=' + win.htmlFileVersion,
            controller: 'managerVisitContactAnalysisListController'
        }).state('main.reportdata.managervisitcontactanalysis' /*部门拜访分析(医生)*/, {
            url: '/managervisitcontactanalysis2',
            templateUrl: 'Module/ManagerVisitContactAnalysis/managervisitcontactanalysisListView.html?v=' + win.htmlFileVersion,
            controller: 'managerVisitContactAnalysisListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2017-1-9
 说明     : 用户积分规则
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.rankrule', { /*积分规则列表*/
            url: '/rankrule',
            templateUrl: 'Module/MemberRankRule/memberRankRuleListView.html?v=' + win.htmlFileVersion,
            controller: 'memberRankRuleListController'
        }).state('main.rankrule.edit', { /*积分规则编辑*/
            url: '/edit/:id',
            templateUrl: 'Module/MemberRankRule/memberRankRuleEditView.html?v=' + win.htmlFileVersion,
            controller: 'memberRankRuleEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2018-1-4
 说明     : 系统手册
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.systemmanual', { /*系统手册列表*/
            url: '/systemmanual',
            templateUrl: 'Module/MineUseManual/mineUseManualListView.html?v=' + win.htmlFileVersion,
            controller: 'mineUseManualListController'
        }).state('main.systemmanual.edit', { /*系统手册编辑*/
            url: '/edit/:id',
            templateUrl: 'Module/MineUseManual/mineUseManualEditView.html?v=' + win.htmlFileVersion,
            controller: 'mineUseManualEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016/6/27
 说明     : 样板区县指标达成
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.modelcountyreach', {
            url: '/modelcountyreach',
            templateUrl: 'Module/ModelCountyReach/modelcountyreachListView.html?v=' + win.htmlFileVersion,
            controller: 'modelcountyreachListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016/6/24
 说明     : 样板区县指标
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.modelcountytarget' /*样板区县指标*/, {
            url: '/modelcountytarget',
            templateUrl: 'Module/ModelCountyTarget/modelcountytargetListView.html?v=' + win.htmlFileVersion,
            controller: 'modelcountytargetListController'
        }).state('main.modelcountytarget.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/ModelCountyTarget/modelcountytargetEditView.html?v=' + win.htmlFileVersion,
            controller: 'modelcountytargetEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016/6/28
 说明     : 新开发医院任务指标
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.newlyhospitaltask' /*新开发医院任务指标*/, {
            url: '/newlyhospitaltask',
            templateUrl: 'Module/NewlyHospitalTask/newlyHospitalTaskListView.html?v=' + win.htmlFileVersion,
            controller: 'newlyHospitalTaskListController'
        }).state('main.newlyhospitaltask.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/NewlyHospitalTask/newlyHospitalTaskEditView.html?v=' + win.htmlFileVersion,
            controller: 'newlyHospitalTaskEditController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/6/28
 *说明：新开发医院数达成分析
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.newlyhospitaltaskanalysis', {
            url: '/NewlyHospitalTaskAnalysisView',
            templateUrl: 'Module/NewlyHospitalTaskAnalysis/newlyHospitalTaskAnalysisListView.html?v=' + win.htmlFileVersion,
            controller: 'newlyHospitalTaskAnalysisListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Tonny Huang
 创建时间 : 2018-01-30
 说明     :PC专家大数据
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odpdoctorkol' /*专家大数据-列表*/, {
            url: '/odpdoctorkol',
            templateUrl: 'Module/OdpDoctorKol/odpdoctorkolListView.html?v=' + win.htmlFileVersion,
            controller: 'odpDoctorKolListController'
        }).state('main.odpdoctorkol.edit' /*专家大数据-只读*/, {
            url: '/edit/:id',
            templateUrl: 'Module/OdpDoctorKol/odpdoctorkolEditView.html',
            controller: 'odpdoctorkolEditController'
        });
    }]);
})(window);

// (function (win) {
//     'use strict';
//     angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
//         $stateProvider
//             .state('main.odpdoctorkol'/*医院档案列表*/, {
//                 url: '/odpdoctorkol',
//                 templateUrl: 'Module/OdpDoctorKol/odpdoctorkolListView.html?v=' + win.htmlFileVersion,
//                 controller: 'odpDoctorKolListController'
//             })
//             .state('main/odpdoctorkol/edit'/*医院档案列表编辑页*/, {
//                 url: '/edit/:id',
//                 templateUrl: 'Module/OdpDoctorKol/odpdoctorkolEditView.html',
//                 controller: 'odpdoctorkolEditController'
//             })
//             ;
//     }]);
// })(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/5/12
 说明     : 代表纯销统计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.ownerpurevendition', {
            url: '/.ownerpurevendition',
            templateUrl: 'Module/OwnerPureVendition/ownerPureVenditionListView.html?v=' + win.htmlFileVersion,
            controller: 'OwnerPureVenditionController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Chad Chen
 创建时间 : 2016-08-16
 说明     : DC
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.prescription' /*DC列表*/, {
            url: '/prescription',
            templateUrl: 'Module/prescription/prescriptionListView.html?v=' + win.htmlFileVersion,
            controller: 'prescriptionListController'
        }).state('main.prescription.edit' /*DC编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/prescription/prescriptionEditView.html?v=' + win.htmlFileVersion,
            controller: 'prescriptionEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2017/05/12
 说明     : 流向数据-产品别名 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.productalias' /*产品进目录情况列表*/, {
            url: '/productalias',
            templateUrl: 'Module/ProductAlias/productaliasListView.html?v=' + win.htmlFileVersion,
            controller: 'productaliasListController'
        }).state('main.productalias.edit' /*编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/ProductAlias/productaliasEditView.html',
            controller: 'productaliasEditController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/4/26
 *说明：药品编码映射
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.ProductErpMap' /*映射列表*/, {
            url: '/producterpmap',
            templateUrl: 'Module/ProductErpMap/productErpMapListView.html?v=' + win.htmlFileVersion,
            controller: 'productErpMapListController'
        }).state('main.ProductErpMap.edit' /*映射编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/ProductErpMap/productErpMapEditView.html?v=' + win.htmlFileVersion,
            controller: 'productErpMapEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2016/8/22
 说明     : 产品进目录情况 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.productIntoDirectory' /*产品进目录情况列表*/, {
            url: '/productIntoDirectory',
            templateUrl: 'Module/ProductIntoDirectory/productIntoDirectoryListView.html?v=' + win.htmlFileVersion,
            controller: 'productIntoDirectoryListController'
        }).state('main.productIntoDirectory.edit' /*编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/ProductIntoDirectory/productIntoDirectoryEditView.html',
            controller: 'productIntoDirectoryEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2016/9/7
 说明     : 药品推广信息 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.productPromoteInformation' /*药品推广信息列表*/, {
            url: '/productPromoteInformation',
            templateUrl: 'Module/ProductPromoteInformation/productPromoteInformationListView.html?v=' + win.htmlFileVersion,
            controller: 'productPromoteInformationListController'
        }).state('main.productPromoteInformation.edit' /*编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/ProductPromoteInformation/productPromoteInformationEditView.html',
            controller: 'productPromoteInformationEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Gale Ge
创建时间 : 2017-01-04
说明     : 促销活动 路由
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.promotionCampaign' /*医院档案列表*/, {
            url: '/promotionCampaign',
            templateUrl: 'Module/PromotionCampaign/promotionCampaignListView.html?v=' + win.htmlFileVersion,
            controller: 'promotionCampaignListController'
        }).state('main.promotionCampaign.edit' /*医院档案列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/PromotionCampaign/promotionCampaignEditView.html',
            controller: 'promotionCampaignEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Gale Ge
创建时间 : 2017-01-04
说明     : 促销活动-目标门店 路由
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.promotionCampaignAccount' /*促销活动-目标门店列表*/, {
            url: '/promotionCampaignAccount',
            templateUrl: 'Module/PromotionCampaignAccount/promotionCampaignAccountListView.html?v=' + win.htmlFileVersion,
            controller: 'promotionCampaignAccountListController'
        }).state('main.promotionCampaignAccount.edit' /*促销活动-目标门店编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/PromotionCampaignAccount/promotionCampaignAccountEditView.html',
            controller: 'promotionCampaignAccountEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/2/27
 说明     : 省份-基础数据 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.provincebasicdata' /*省份-基础数据 列表*/, {
            url: '/provincebasicdata',
            templateUrl: 'Module/ProvinceBasicData/provinceBasicDataListView.html?v=' + win.htmlFileVersion,
            controller: 'ProvinceBasicDataListController'
        }).state('main.provincebasicdata.edit' /*省份-基础数据 编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/ProvinceBasicData/provinceBasicDataEditView.html?v=' + win.htmlFileVersion,
            controller: 'ProvinceBasicDataEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/2/27
 说明     : 省份-发病数据 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.provincediseasedata' /*省份-发病数据 列表*/, {
            url: '/provincediseasedata',
            templateUrl: 'Module/ProvinceDiseaseData/provinceDiseaseDataListView.html?v=' + win.htmlFileVersion,
            controller: 'ProvinceDiseaseDataListController'
        }).state('main.provincediseasedata.edit' /*省份-发病数据 编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/ProvinceDiseaseData/provinceDiseaseDataEditView.html?v=' + win.htmlFileVersion,
            controller: 'ProvinceDiseaseDataEditController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orangehong
 创建时间 : 2017-02-24
 说明     : 省份-医院终端-数量
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.provincehospitalqty' /*省份-医院终端-数量列表*/, {
            url: '/provincehospitalqty',
            templateUrl: 'Module/ProvinceHospitalQty/provincehospitalqtyListView.html?v=' + win.htmlFileVersion,
            controller: 'provincehospitalqtyListController'
        }).state('main.provincehospitalqty.edit' /*省份-医院终端-数量编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/ProvinceHospitalQty/provincehospitalqtyEditView.html?v=' + win.htmlFileVersion,
            controller: 'provincehospitalqtyEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/2/27
 说明     : 省份-市场容量 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.provincemarketcapacity' /*省份-市场容量 列表*/, {
            url: '/provincemarketcapacity',
            templateUrl: 'Module/ProvinceMarketCapacity/provinceMarketCapacityListView.html?v=' + win.htmlFileVersion,
            controller: 'ProvinceMarketCapacityListController'
        }).state('main.provincemarketcapacity.edit' /*省份-市场容量 编辑*/, {
            url: 'edit/:id',
            templateUrl: 'Module/ProvinceMarketCapacity/provinceMarketCapacityEditView.html?v=' + win.htmlFileVersion,
            controller: 'ProvinceMarketCapacityEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/2/28
 说明     : 区域市场占有率分析 路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.provincemarketoccupancy', {
            url: '/provincemarketoccupancy2',
            templateUrl: 'Module/ProvinceMarketOccupancy/provinceMarketOccupancyView.html?v=' + win.htmlFileVersion,
            controller: 'ProvinceMarketOccupancyController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/7
 说明     : 代表纯销指标达成（金额） 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.pureownertargetbyamount', {
            url: '/pureownertargetbyamount2',
            templateUrl: 'Module/PureOwnerTargetByAmount/PureOwnerTargetByAmountListView.html?v=' + win.htmlFileVersion,
            controller: 'PureOwnerTargetByAmountListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/7
 说明     : 代表纯销指标达成（数量） 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.pureownertargetbyqty', {
            url: '/pureownertargetbyqty2',
            templateUrl: 'Module/PureOwnerTargetByQty/PureOwnerTargetByQtyListView.html?v=' + win.htmlFileVersion,
            controller: 'PureOwnerTargetByQtyListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2018/1/5
 说明     : 纯销毛利统计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.purevenditionprofit', {
            url: '/purevenditionprofit',
            templateUrl: 'Module/PureVenditionProfit/pureVenditionProfitListView.html?v=' + win.htmlFileVersion,
            controller: 'PureVenditionProfitListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/5/5
 说明     : 省区纯销指标达成 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.purevenditiontarget', {
            url: '/purevenditiontarget2',
            templateUrl: 'Module/PureVenditionTarget/pureVenditionTargetListView.html?v=' + win.htmlFileVersion,
            controller: 'PureVenditionTargetListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/6
 说明     : 省区纯销指标达成（金额） 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.purevenditiontargetbyamount', {
            url: '/purevenditiontargetbyamount2',
            templateUrl: 'Module/PureVenditionTargetByAmount/pureVenditionTargetByAmountListView.html?v=' + win.htmlFileVersion,
            controller: 'PureVenditionTargetByAmountListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/7
 说明     : 省区纯销指标达成（数量） 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.purevenditiontargetbyqty', {
            url: '/purevenditiontargetbyqty2',
            templateUrl: 'Module/PureVenditionTargetByQty/pureVenditionTargetByQtyListView.html?v=' + win.htmlFileVersion,
            controller: 'PureVenditionTargetByQtyListController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-01-16
 说明     : 考试题目
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.question' /*考试题目列表*/, {
            url: '/question',
            templateUrl: 'Module/Question/QuestionListView.html?v=' + win.htmlFileVersion,
            controller: 'questionListController'
        }).state('main.question.edit' /*考试题目编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/Question/QuestionEditView.html?v=' + win.htmlFileVersion,
            controller: 'questionEditController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-01-10
 说明     : 考试题目选项
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.questionoption' /*考试题目选项列表*/, {
            url: '/questionoption',
            templateUrl: 'Module/QuestionOption/QuestionOptionListView.html?v=' + win.htmlFileVersion,
            controller: 'questionoptionListController'
        }).state('main.questionoption.edit' /*考试题目选项编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/QuestionOption/QuestionOptionListView.html?v=' + win.htmlFileVersion,
            controller: 'questionoptionEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016/06/22
 说明     : 人员招聘达成
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.recruitcompletion' /*人员招聘指标*/, {
            url: '/recruitcompletion',
            templateUrl: 'Module/RecruitCompletion/recruitcompletionListView.html?v=' + win.htmlFileVersion,
            controller: 'recruitcompletionListController'
        }).state('main.recruitcompletion.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/RecruitCompletion/recruitcompletionEditView.html?v=' + win.htmlFileVersion,
            controller: 'recruitcompletionEditController'
        });
    }]);
})(window);
'use strict';

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.recruitreach' /*人员招聘达成*/, {
            url: '/recruitreach',
            templateUrl: 'Module/RecruitReachReport/recruitreachList.html?v=' + win.htmlFileVersion,
            controller: 'recruitreachController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016/06/22
 说明     : 人员招聘指标
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.recruittarget' /*人员招聘指标*/, {
            url: '/recruittarget',
            templateUrl: 'Module/RecruitTarget/recruittargetListView.html?v=' + win.htmlFileVersion,
            controller: 'recruittargetListController'
        }).state('main.recruittarget.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/RecruitTarget/recruittargetEditView.html?v=' + win.htmlFileVersion,
            controller: 'recruittargetEditController'
        });
    }]);
})(window);
'use strict';

/**********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar
 创建时间 : 2017/07/18
 说明     : 红包统计
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.redpackstatistics', {
            url: '/redpackstatistics',
            templateUrl: 'Module/RedPackStatistics/redpackstatisticsListView.html?v=' + win.htmlFileVersion,
            controller: 'redpackstatisticsListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-5-5
 说明     :异常终端
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.abnormalterminal', {
            url: '/abnormalterminal2/:entType',
            templateUrl: 'Module/Reportterminal/abnormalterListView.html?v=' + win.htmlFileVersion,
            controller: 'abnormalterListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-5-4
 说明     :新开发医院
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.newlydevelopedhos', {
            url: '/newlyhosView2/:entType',
            templateUrl: 'Module/Reportterminal/newlyhosListView.html?v=' + win.htmlFileVersion,
            controller: 'newlyhosListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-5-5
 说明     :僵尸医院路由管理
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.zombiehos', {
            url: '/zombiehos2/:entType',
            templateUrl: 'Module/Reportterminal/zombiehosListView.html?v=' + win.htmlFileVersion,
            controller: 'zombiehosListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Jerry Wu
 创建时间 : 2018-3-5
 说明     :商业返利占比分析 路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.accountRebateAnalyze', {
            url: '/accountRebateAnalyze',
            templateUrl: 'Module/ReportData/accountRebateAnalyzeViewList.html?v=' + win.htmlFileVersion,
            controller: 'accountRebateAnalyzeController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Lucifer Wang
 *创建时间：2017/2/08
 *说明：招商经理拜访明细路由
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.agentvisitdetaillist', {
            url: '/AgentVisitDetailList',
            templateUrl: 'Module/ReportData/AgentVisitDetailListView.html?v=' + win.htmlFileVersion,
            controller: 'AgentVisitDetailController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lecrean Pan
 创建时间 : 2018-1-8
 说明     :区域生动化分析 路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.areaVivid', {
            url: '/areaVivid',
            templateUrl: 'Module/ReportData/areaVividListView.html?v=' + win.htmlFileVersion,
            controller: 'areaVividListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2017/12/7
 说明     : 按部门流向统计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.busidrugflowreport', {
            url: '/busidrugflowreport',
            templateUrl: 'Module/ReportData/busidrugflowreportListView.html?v=' + win.htmlFileVersion,
            controller: 'busidrugflowreportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-04-07
 说明     : 按事业部发货统计
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.businessdeliveryreport' /*按事业部发货统计*/, {
            url: '/businessdeliveryreport',
            templateUrl: 'Module/ReportData/businessdeliveryListView.html?v=' + win.htmlFileVersion,
            controller: 'businessdeliveryController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Eric Zheng
 创建时间 : 2018-3-2
 说明     :部门费效比分析 路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.businessUnitCostEffectiveness', {
            url: '/businessUnitCostEffectiveness',
            templateUrl: 'Module/ReportData/businessUnitCostEffectivenessListView.html?v=' + win.htmlFileVersion,
            controller: 'businessUnitCostEffectivenessController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-02-08
 说明     :市场活动微信签到统计 路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.campaignsigninreport' /*市场活动出勤统计*/, {
            url: '/campaignsigninreport',
            templateUrl: 'Module/ReportData/campaignsigninreportListView.html?v=' + win.htmlFileVersion,
            controller: 'campaignsigninreportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lecrean Pan
 创建时间 : 2018-1-8
 说明     :连锁生动化分析 路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.chainVivid', {
            url: '/chainVivid',
            templateUrl: 'Module/ReportData/chainVividListView.html?v=' + win.htmlFileVersion,
            controller: 'chainVividListController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Lucifer Wang
 *创建时间：2017/1/16
 *说明：代表拜访排名路由
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.delegatevisitranklist', {
            url: '/DelegateVisitRankList',
            templateUrl: 'Module/ReportData/DelegateVisitRankList.html?v=' + win.htmlFileVersion,
            controller: 'DelegateVisitRankListController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Gale Ge
 *创建时间：2017/10/31
 *说明：医院开发进度统计路由
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.develophospitalratelist', {
            url: '/DevelopHospitalRateList',
            templateUrl: 'Module/ReportData/deveolphospitalRateListView.html?v=' + win.htmlFileVersion,
            controller: 'DevelopHospitalRateController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2017/04/17
 说明     : 季度药品医院覆盖率 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.drughospitalcoverage', {
            url: '/drughospitalcoverage2',
            templateUrl: 'Module/ReportData/drugHospitalCoverageListView.html?v=' + win.htmlFileVersion,
            controller: 'drugHospitalCoverageListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2017/04/17
 说明     : 药品品规替换情况统计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.drugreplace', {
            url: '/drugreplace2',
            templateUrl: 'Module/ReportData/drugReplaceListView.html?v=' + win.htmlFileVersion,
            controller: 'drugReplaceListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2016/11/25
 说明     : 门店药品促销情况统计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.drugSalePolicy', {
            url: '/drugSalePolicy2',
            templateUrl: 'Module/ReportData/drugSalePolicyListView.html?v=' + win.htmlFileVersion,
            controller: 'drugSalePolicyListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2016/11/25
 说明     : 门店缺损统计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.drugstoredefectstatistics', {
            url: '/drugstoreDefectstatistics2',
            templateUrl: 'Module/ReportData/drugstoreDefectstatisticsListView.html?v=' + win.htmlFileVersion,
            controller: 'drugstoreDefectstatisticsListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2016/11/25
 说明     : 门店陈列统计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.drugstoredisplaystatistics', {
            url: '/drugstoreDisplaystatistics2',
            templateUrl: 'Module/ReportData/drugstoreDisplaystatisticsListView.html?v=' + win.htmlFileVersion,
            controller: 'drugstoreDisplaystatisticsListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Ludwig Dong
 创建时间 : 2016/11/21
 说明     : 门店进销存统计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.drugstorePSIstatistics', {
            url: '/drugstorePSIstatistics',
            templateUrl: 'Module/ReportData/drugstorePSIstatisticsListView.html?v=' + win.htmlFileVersion,
            controller: 'drugstorePSIstatisticsListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2016/11/25
 说明     : 门店缺货统计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.drugstorestockoutstatistics', {
            url: '/drugstoreStockoutstatistics2',
            templateUrl: 'Module/ReportData/drugstoreStockoutstatisticsListView.html?v=' + win.htmlFileVersion,
            controller: 'drugstoreStockoutstatisticsListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017/06/06
 说明     : 门店拜访明细查询 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.drugstorevisit', {
            url: '/drugstorevisit2',
            templateUrl: 'Module/ReportData/drugstoreVisitListView.html?v=' + win.htmlFileVersion,
            controller: 'drugstorevisitListController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Tonny Huang
 *创建时间：2018/3/19
 *说明：DTP出库查询
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.DTPOutgoingQuery', {
            url: '/DTPOutgoingQuery',
            templateUrl: 'Module/ReportData/DTPOutgoingQueryListView.html?v=' + win.htmlFileVersion,
            controller: 'DTPOutgoingQueryListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lecrean Pan
 创建时间 : 2018/03/06
 说明     : DTP进销存(PSI) 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.DTPPSI', {
            url: '/DTPPSI',
            templateUrl: 'Module/ReportData/DTPPSIListView.html?v=' + win.htmlFileVersion,
            controller: 'DTPPSIListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lecrean Pan
 创建时间 : 2018/03/05
 说明     : DTP库存查询 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.DTPStock', {
            url: '/DTPStock',
            templateUrl: 'Module/ReportData/DTPStockListView.html?v=' + win.htmlFileVersion,
            controller: 'DTPStockListController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Tonny Huang
 *创建时间：2018/3/15
 *说明：DTP入库查询
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.DTPStorageQuery', {
            url: '/DTPStorageQuery',
            templateUrl: 'Module/ReportData/DTPStorageQueryListView.html?v=' + win.htmlFileVersion,
            controller: 'DTPStorageQueryListController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Lucifer Wang
 *创建时间：2017/1/19
 *说明：dashboard
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.examonline', {
            url: '/examonlinereport',
            templateUrl: 'Module/ReportData/ExamOnlineReportView.html?v=' + win.htmlFileVersion,
            controller: 'ExamOnlineReportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-02-27
 说明     : 医院覆盖率分析
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.hospitalcoveragereport' /*医院覆盖率分析*/, {
            url: '/hospitalcoveragereport',
            templateUrl: 'Module/ReportData/hospitalcoverageListView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalcoverageController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Jerry Wu
 创建时间 : 2018-2-26
 说明     :医院费效比分析 路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.hospitalCostEffectiveness', {
            url: '/hospitalCostEffectiveness',
            templateUrl: 'Module/ReportData/hospitalCostEffectivenessListView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalCostEffectivenessController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-03-03
 说明     : 医院终端占有率分析
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.hospitalsharereport' /*医院终端占有率分析*/, {
            url: '/hospitalsharereport',
            templateUrl: 'Module/ReportData/hospitalshareListView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalshareController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2017/04/17
 说明     : 药品重点医院态势 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.hospitalsituation', {
            url: '/hospitalsituation2',
            templateUrl: 'Module/ReportData/hospitalSituationListView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalSituationListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2017/03/20
 说明     : 潜在代理商转换率分析 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.leadsConversionRate', {
            url: '/leadsConversionRate2',
            templateUrl: 'Module/ReportData/leadsConversionRateView.html?v=' + win.htmlFileVersion,
            controller: 'leadsConversionRateController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2017-04-20
 说明     : 积分排行榜路由
 ********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.memberpointlist', {
            url: '/MemberPointList',
            templateUrl: 'Module/ReportData/MemberPointListView.html?v=' + win.htmlFileVersion,
            controller: 'MemberPointListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Tonny Huang 
 创建时间 : 2017/01/19
 说明     : 患者信息查询
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.PatientInformation', {
            url: '/PatientInformation',
            templateUrl: 'Module/ReportData/PatientInformationListView.html?v=' + win.htmlFileVersion,
            controller: 'PatientInformationListController'
        }).state('main.reportdata.PatientInformation.readonly', {
            url: '/readonly/:id',
            templateUrl: 'Module/ReportData/PatientInformationReadonlyView.html',
            controller: 'PatientInformationReadonlyController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/01/10
 说明     : 门店促销执行统计
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.promotionactionstatistics', {
            url: '/promotionactionstatistics',
            templateUrl: 'Module/ReportData/promotionActionStatisticsView.html?v=' + win.htmlFileVersion,
            controller: 'promotionActionStatisticsController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/2/19
 *描述：报表数据模块的所有路由
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata' /*报表菜单*/, {
            url: '/reportmenu',
            templateUrl: 'Module/ReportData/reportMenuView.html?v=' + win.htmlFileVersion,
            controller: 'reportMenuController'
        }).state('main.purevenditionbycity' /*城市纯销排名模块*/, {
            url: '/purevenditionbycity',
            templateUrl: 'Module/ReportData/purevenditionbycityListView.html?v=' + win.htmlFileVersion,
            controller: 'purevenditionbycityController'
        }).state('main.reportdata.purevenditionbycity' /*城市纯销排名模块*/, {
            url: '/purevenditionbycity2',
            templateUrl: 'Module/ReportData/purevenditionbycityListView.html?v=' + win.htmlFileVersion,
            controller: 'purevenditionbycityController'
        }).state('main.purevenditionbyprov' /*省份纯销排名模块*/, {
            url: '/purevenditionbyprov',
            templateUrl: 'Module/ReportData/purevenditionbyprovListView.html?v=' + win.htmlFileVersion,
            controller: 'purevenditionbyprovController'
        }).state('main.reportdata.purevenditionbyprov' /*省份纯销排名模块*/, {
            url: '/purevenditionbyprov2',
            templateUrl: 'Module/ReportData/purevenditionbyprovListView.html?v=' + win.htmlFileVersion,
            controller: 'purevenditionbyprovController'
        }).state('main.busisalerank' /*商业销量排名*/, {
            url: '/busisalerank',
            templateUrl: 'Module/ReportData/BusiSaleRankView.html?v=' + win.htmlFileVersion,
            controller: 'BusiSaleRankController'
        }).state('main.reportdata.busisalerank' /*商业销量排名*/, {
            url: '/busisalerank2',
            templateUrl: 'Module/ReportData/BusiSaleRankView.html?v=' + win.htmlFileVersion,
            controller: 'BusiSaleRankController'
        }).state('main.agentsalerank' /*代理商销量排名*/, {
            url: '/agentsalerank',
            templateUrl: 'Module/ReportData/AgentBusiSaleRankView.html?v=' + win.htmlFileVersion,
            controller: 'AgentBusiSaleRankController'
        }).state('main.reportdata.agentsalerank' /*代理商销量排名*/, {
            url: '/agentsalerank2',
            templateUrl: 'Module/ReportData/AgentBusiSaleRankView.html?v=' + win.htmlFileVersion,
            controller: 'AgentBusiSaleRankController'
        }).state('main.operatecharacterbyprov' /*商业经营特性分析(按省)*/, {
            url: '/operatecharacterbyprov',
            templateUrl: 'Module/ReportData/CharacterByProvView.html?v=' + win.htmlFileVersion,
            controller: 'CharacterByProvController'
        }).state('main.reportdata.operatecharacterbyprov' /*商业经营特性分析(按省)*/, {
            url: '/operatecharacterbyprov2',
            templateUrl: 'Module/ReportData/CharacterByProvView.html?v=' + win.htmlFileVersion,
            controller: 'CharacterByProvController'
        }).state('main.operatecharacterbyent' /*商业经营特性分析(按商业)*/, {
            url: '/operatecharacterbyent',
            templateUrl: 'Module/ReportData/CharacterByEntView.html?v=' + win.htmlFileVersion,
            controller: 'CharacterByEntController'
        }).state('main.reportdata.operatecharacterbyent' /*商业经营特性分析(按商业)*/, {
            url: '/operatecharacterbyent2',
            templateUrl: 'Module/ReportData/CharacterByEntView.html?v=' + win.htmlFileVersion,
            controller: 'CharacterByEntController'
        }).state('main.busisalelost' /*商业流失分析*/, {
            url: '/busisalelost',
            templateUrl: 'Module/ReportData/BusiSaleLostView.html?v=' + win.htmlFileVersion,
            controller: 'BusiSaleLostController'
        }).state('main.reportdata.busisalelost' /*商业流失分析*/, {
            url: '/busisalelost2',
            templateUrl: 'Module/ReportData/BusiSaleLostView.html?v=' + win.htmlFileVersion,
            controller: 'BusiSaleLostController'
        }).state('main.circulationefficiency' /*省级流通效率分析*/, {
            url: '/circulationefficiency',
            templateUrl: 'Module/ReportData/circulationefficiencyView.html?v=' + win.htmlFileVersion,
            controller: 'circulationEfficiencyController'
        }).state('main.reportdata.circulationefficiency' /*省级流通效率分析*/, {
            url: '/circulationefficiency2',
            templateUrl: 'Module/ReportData/circulationefficiencyView.html?v=' + win.htmlFileVersion,
            controller: 'circulationEfficiencyController'
        }).state('main.nationalfleeinggoods' /*全国串货分析*/, {
            url: '/nationalfleeinggoods',
            templateUrl: 'Module/ReportData/nationalfleeinggoodsListView.html?v=' + win.htmlFileVersion,
            controller: 'nationalfleeinggoodsController'
        }).state('main.reportdata.nationalfleeinggoods' /*全国串货分析*/, {
            url: '/nationalfleeinggoods2',
            templateUrl: 'Module/ReportData/nationalfleeinggoodsListView.html?v=' + win.htmlFileVersion,
            controller: 'nationalfleeinggoodsController'
        }).state('main.getfleeingdatas' /*省份窜货分析*/, {
            url: '/getfleeingdatas',
            templateUrl: 'Module/ReportData/GetFleeingDatasView.html?v=' + win.htmlFileVersion,
            controller: 'GetFleeingDatasController'
        }).state('main.reportdata.getfleeingdatas' /*省份窜货分析*/, {
            url: '/getfleeingdatas2',
            templateUrl: 'Module/ReportData/GetFleeingDatasView.html?v=' + win.htmlFileVersion,
            controller: 'GetFleeingDatasController'
        }).state('main.terminalsalescity' /*城市纯销排名*/, {
            url: '/terminalsalescity',
            templateUrl: 'Module/ReportData/terminalsalescityListView.html?v=' + win.htmlFileVersion,
            controller: 'terminalsalescityController'
        }).state('main.reportdata.terminalsalescity' /*城市纯销排名*/, {
            url: '/terminalsalescity2',
            templateUrl: 'Module/ReportData/terminalsalescityListView.html?v=' + win.htmlFileVersion,
            controller: 'terminalsalescityController'
        }).state('main.terminalsales' /*终端纯销排名*/, {
            url: '/terminalsales',
            templateUrl: 'Module/ReportData/terminalsalesListView.html?v=' + win.htmlFileVersion,
            controller: 'terminalsalesController'
        }).state('main.reportdata.terminalsales' /*终端纯销排名*/, {
            url: '/terminalsales2',
            templateUrl: 'Module/ReportData/terminalsalesListView.html?v=' + win.htmlFileVersion,
            controller: 'terminalsalesController'
        }).state('main.terminalloss' /*终端流失分析*/, {
            url: '/terminalloss',
            templateUrl: 'Module/ReportData/terminallossListView.html?v=' + win.htmlFileVersion,
            controller: 'terminallossController'
        }).state('main.reportdata.terminalloss' /*终端流失分析*/, {
            url: '/terminalloss2',
            templateUrl: 'Module/ReportData/terminallossListView.html?v=' + win.htmlFileVersion,
            controller: 'terminallossController'
        }).state('main.drugflowbymonth' /*流向查询（按月）*/, {
            url: '/drugflowbymonth',
            templateUrl: 'Module/ReportData/drugflowbymonthListView.html?v=' + win.htmlFileVersion,
            controller: 'drugflowbymonthController'
        }).state('main.reportdata.drugflowbymonth' /*流向查询（按月）*/, {
            url: '/drugflowbymonth2',
            templateUrl: 'Module/ReportData/drugflowbymonthListView.html?v=' + win.htmlFileVersion,
            controller: 'drugflowbymonthController'
        }).state('main.drugflowbybatchno' /*流向查询（按批次）*/, {
            url: '/drugflowbybatchno',
            templateUrl: 'Module/ReportData/drugflowbybatchnoListView.html?v=' + win.htmlFileVersion,
            controller: 'drugflowbybatchnoController'
        }).state('main.reportdata.drugflowbybatchno' /*流向查询（按批次）*/, {
            url: '/drugflowbybatchno2',
            templateUrl: 'Module/ReportData/drugflowbybatchnoListView.html?v=' + win.htmlFileVersion,
            controller: 'drugflowbybatchnoController'
        }).state('main.busisaledetailbyent' /*流向查询（按商业）*/, {
            url: '/busisaledetailbyent',
            templateUrl: 'Module/ReportData/busisaledetailbyentListView.html?v=' + win.htmlFileVersion,
            controller: 'busisaledetailbyentController'
        }).state('main.reportdata.busisaledetailbyent' /*流向查询（按商业）*/, {
            url: '/busisaledetailbyent2',
            templateUrl: 'Module/ReportData/busisaledetailbyentListView.html?v=' + win.htmlFileVersion,
            controller: 'busisaledetailbyentController'
        }).state('main.busisaledetailbyterminal' /*流向查询（按终端）*/, {
            url: '/busisaledetailbyterminal',
            templateUrl: 'Module/ReportData/busisaledetailbyterminalListView.html?v=' + win.htmlFileVersion,
            controller: 'busisaledetailbyterminalController'
        }).state('main.reportdata.busisaledetailbyterminal' /*流向查询（按终端）*/, {
            url: '/busisaledetailbyterminal2',
            templateUrl: 'Module/ReportData/busisaledetailbyterminalListView.html?v=' + win.htmlFileVersion,
            controller: 'busisaledetailbyterminalController'
        }).state('main.fleeinggoodsdetail' /*窜货明细查询*/, {
            url: '/fleeinggoodsdetail',
            templateUrl: 'Module/ReportData/fleeinggoodsdetailListView.html?v=' + win.htmlFileVersion,
            controller: 'fleeinggoodsdetailController'
        }).state('main.reportdata.fleeinggoodsdetail' /*窜货明细查询*/, {
            url: '/fleeinggoodsdetail2',
            templateUrl: 'Module/ReportData/fleeinggoodsdetailListView.html?v=' + win.htmlFileVersion,
            controller: 'fleeinggoodsdetailController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Ludwig Dong
 创建时间 : 2016/11/22
 说明     : 代表市场活动分析 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.representstatisticsbycampaign', {
            url: '/representstatisticsbycampaign2',
            templateUrl: 'Module/ReportData/representstatisticsbycampaignListView.html?v=' + win.htmlFileVersion,
            controller: 'representstatisticsbycampaignController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-04-10
 说明     : 培训活动代表邀请明细
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.trainingactivitiesreport' /*培训活动代表邀请明细*/, {
            url: '/trainingactivitiesreport',
            templateUrl: 'Module/ReportData/trainingactivitiesListView.html?v=' + win.htmlFileVersion,
            controller: 'trainingactivitiesController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : jeoli
 创建时间 : 2018-03-01
 说明     : 培训活动代表邀请明细
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.userCostEffectiveness' /*培训活动代表邀请明细*/, {
            url: '/userCostEffectiveness',
            templateUrl: 'Module/ReportData/UserCostEffectivenessListView.html?v=' + win.htmlFileVersion,
            controller: 'UserCostEffectivenessListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2017/1/9
 说明     : 门店竞品采集统计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.visitCompetingProduct', {
            url: '/visitCompetingProduct2',
            templateUrl: 'Module/ReportData/visitCompetingProductListView.html?v=' + win.htmlFileVersion,
            controller: 'visitCompetingProductListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016/11/25
 说明     : 门店临逾期药品统计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.visitexpiredProduct', {
            url: '/visitexpiredProduct2',
            templateUrl: 'Module/ReportData/visitexpiredProductListView.html?v=' + win.htmlFileVersion,
            controller: 'visitexpiredProductListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Ludwig Dong    
 创建时间 : 2016-10-27
 说明     : 代表拜访频率分析
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.visitfrequencyAcc', {
            url: '/visitfrequencyAcc2',
            templateUrl: 'Module/ReportData/visitfrequencyAccListView.html?v=' + win.htmlFileVersion,
            controller: 'visitfrequencyAccListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/9/28
 说明     : 代表计划完成分析 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.representativevisitanalysis' /*终端热度查询*/, {
            url: '/representativevisitanalysis',
            templateUrl: 'Module/RepresentativeVisitAnalysis/RepresentativeVisitAnalysisView.html?v=' + win.htmlFileVersion,
            controller: 'RepresentativeVisitAnalysisController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-8
 说明     :PC端门店协访
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.RetailAssistance' /*门店协访列表*/, {
            url: '/retailassistance',
            templateUrl: 'Module/RetailAssistance/RetailAssistanceListView.html?v=' + win.htmlFileVersion,
            controller: 'retailAssistanceListController'
        }).state('main.RetailAssistance.edit' /*拜访计划编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/RetailAssistance/RetailAssistanceEditView.html?v=' + win.htmlFileVersion,
            controller: 'retailAssistanceEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-6
 说明     :PC端门店拜访
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.RetailVisit' /*门店拜访列表*/, {
            url: '/retailvisit',
            templateUrl: 'Module/RetailVisit/RetailVisitListView.html?v=' + win.htmlFileVersion,
            controller: 'retailvisitListController'
        }).state('main.RetailVisit.edit' /*拜访计划编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/RetailVisit/RetailVisitEditView.html?v=' + win.htmlFileVersion,
            controller: 'retailvisitEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/12/06
 说明     : 门店拜访进货统计 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.retailpsianalysis' /*门店拜访进货统计*/, {
            url: '/retailpsianalysis',
            templateUrl: 'Module/RetailPsiStatistics/RetailPsiAnalysisListView.html?v=' + win.htmlFileVersion,
            controller: 'RetailPsiAnalysisListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : oscar
 创建时间 : 2017/5/19
 说明     : 门店协访计划维护 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.retailvisitassistplan' /*协访计划列表*/, {
            url: '/retailvisitassistplan',
            templateUrl: 'Module/RetailVisitAssistPlan/RetailVisitAssistPlanListView.html?v=' + win.htmlFileVersion,
            controller: 'retailVisitAssistPlanListController'
        }).state('main.retailvisitassistplan.edit' /*协访计划查看*/, {
            url: '/edit/:id',
            templateUrl: 'Module/RetailVisit/RetailVisitEditView.html?v=' + win.htmlFileVersion,
            controller: 'retailvisitEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016/4/26
 说明     : 回款任务指标
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.returnmoneytask' /*回款任务指标*/, {
            url: '/returnmoneytask',
            templateUrl: 'Module/ReturnMoneyTask/returnmoneytaskListView.html?v=' + win.htmlFileVersion,
            controller: 'returnmoneytaskListController'
        }).state('main.returnmoneytask.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/ReturnMoneyTask/returnmoneytaskEditView.html?v=' + win.htmlFileVersion,
            controller: 'returnmoneytaskEditController'
        }).state('main.deliverytask' /*发货任务指标*/, {
            url: '/deliverytask',
            templateUrl: 'Module/DeliveryTask/deliverytaskListView.html?v=' + win.htmlFileVersion,
            controller: 'deliverytaskListController'
        }).state('main.deliverytask.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/DeliveryTask/deliverytaskEditView.html?v=' + win.htmlFileVersion,
            controller: 'deliverytaskEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/8/2
 说明     : 门店拜访计划维护 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.retailvisitplan' /*拜访计划列表*/, {
            url: '/retailvisitplan',
            templateUrl: 'Module/RetailVisitPlan/RetailVisitPlanListView.html?v=' + win.htmlFileVersion,
            controller: 'retailVisitPlanListController'
        }).state('main.retailvisitplan.edit' /*拜访计划查看*/, {
            url: '/edit/:id',
            templateUrl: 'Module/RetailVisit/RetailVisitEditView.html?v=' + win.htmlFileVersion,
            controller: 'retailvisitEditController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/2/18
 *描述：销售协议模块路由
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.salesagreement' /*销售协议列表*/, {
            url: '/salesagreement',
            templateUrl: 'Module/SalesAgreement/salesagreementListView.html?v=' + win.htmlFileVersion,
            controller: 'salesagreementListController'
        }).state('main.salesagreement.edit' /*销售协议列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/SalesAgreement/salesagreementEditView.html',
            controller: 'salesagreementEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2017/11/15
 说明     : 销售预测 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.salesforecast', {
            url: '/salesforecast',
            templateUrl: 'Module/SalesForecast/SalesForecastListView.html?v=' + win.htmlFileVersion,
            controller: 'SalesForecastListController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2017-01-18
 说明     : 销售订单
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.salesorder' /*列表*/, {
            url: '/salesorder',
            templateUrl: 'Module/SalesOrder/salesorderListView.html?v=' + win.htmlFileVersion,
            controller: 'salesorderListController'
        }).state('main.salesorder.edit' /*编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/SalesOrder/salesorderEditView.html?v=' + win.htmlFileVersion,
            controller: 'salesorderEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/02/27
 说明     : 代表结算价格表
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.salesreppricelist' /*代表结算价格表列表*/, {
            url: '/salesreppricelist',
            templateUrl: 'Module/SalesRepPricelist/salesreppricelistListView.html?v=' + win.htmlFileVersion,
            controller: 'salesreppricelistListController'
        }).state('main.salesreppricelist.edit' /*代表结算价格表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/SalesRepPricelist/salesreppricelistEditView.html',
            controller: 'salesreppricelistEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/2/8
 说明     : 招商经理行为统计 - 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.samzhsdone' /*招商经理行为统计*/, {
            url: '/samzhsdone',
            templateUrl: 'Module/SamZhsDone/SamZhsDoneListView.html?v=' + win.htmlFileVersion,
            controller: 'SamZhsDoneController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/2/28
 说明     : 代表结算金额统计 - 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.salesrepreport' /*招商经理行为统计*/, {
            url: '/salesrepreport',
            templateUrl: 'Module/SalesRepReport/SalesRepReportListView.html?v=' + win.htmlFileVersion,
            controller: 'SalesRepReportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Julie Zhu
 创建时间 : 2018-1-9
 说明     :动销分析：巡店缺货门店分析
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.shopshortstoredistribution', {
            url: '/shopshortstoredistribution',
            templateUrl: 'Module/ShopShortStore/ShopShortStoreListView.html?v=' + win.htmlFileVersion,
            controller: 'ShopShortStoreListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Julie Zhu
 创建时间 : 2018-1-9
 说明     :动销分析：巡店铺货率分析
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.shopinspectiondistribution', {
            url: '/shopinspectiondistribution',
            templateUrl: 'Module/ShopInspection/ShopInspectionListView.html?v=' + win.htmlFileVersion,
            controller: 'ShopInspectionListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/6/23
 说明     : 代表签到打印
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.signinlog', {
            url: '/signinlog',
            templateUrl: 'Module/SignInLog/signInLogView.html?v=' + win.htmlFileVersion,
            controller: 'SignInLogController'
        }).state('main.signinlog.print', {
            url: '/signinlogprint',
            templateUrl: 'Module/SignInLog/printView.html?v=' + win.htmlFileVersion,
            controller: 'SignInLogController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2016/1/29
 说明     : 医生档案管理
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.systemusercontact' /*联系人档案列表*/, {
            url: '/systemusercontact',
            templateUrl: 'Module/SystemUserContact/systemUserContactListView.html?v=' + win.htmlFileVersion,
            controller: 'systemUserContactListController'
        }).state('main.systemusercontact.edit' /*联系人档案编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/SystemUserContact/systemUserContactEditView.html?v=' + win.htmlFileVersion,
            controller: 'systemUserContactEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Ludwig Dong
 创建时间 : 2016-08-11
 说明     : 系统操作记录统计
 ********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.operatinganalysis' /*系统操作记录统计*/, {
            url: '/operatinganalysis',
            templateUrl: 'Module/SystemAnalysis/OperatingAnalysisView.html?v=' + win.htmlFileVersion,
            controller: 'OperatingAnalysisController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Kevin Zhou
 创建时间 : 2016-04-13
 说明     : 终端热度 路由
 ********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.terminalheatreport' /*终端热度查询*/, {
            url: '/terminalheatreport',
            templateUrl: 'Module/TerminalHeatReport/terminalheatreportListView.html?v=' + win.htmlFileVersion,
            controller: 'terminalheatreportController'
        }).state('main.reportdata.terminalheatreport' /*终端热度查询*/, {
            url: '/terminalheatreport2',
            templateUrl: 'Module/TerminalHeatReport/terminalheatreportListView.html?v=' + win.htmlFileVersion,
            controller: 'terminalheatreportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2017/3/15
 说明     : 终端纯销统计报表
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.terminalsalesreport', {
            url: '/terminalsalesreport',
            templateUrl: 'Module/TerminalSalesReport/TerminalSalesReportListView.html?v=' + win.htmlFileVersion,
            controller: 'TerminalSalesReportController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-03-27
 说明     : 培训活动
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.trainingcampaign' /*培训活动列表*/, {
            url: '/trainingcampaign',
            templateUrl: 'Module/TrainingCampaign/trainingcampaignListView.html?v=' + win.htmlFileVersion,
            controller: 'trainingcampaignListController'
        }).state('main.trainingcampaign.edit' /*培训活动编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/TrainingCampaign/trainingcampaignEditView.html?v=' + win.htmlFileVersion,
            controller: 'trainingcampaignEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/5/19
 说明     : 客户协访
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.visitassistance' /*医院档案列表*/, {
            url: '/visitassistance',
            templateUrl: 'Module/VisitAssistance/visitAssistanceListView.html?v=' + win.htmlFileVersion,
            controller: 'visitAssistanceListController'
        }).state('main.visitassistanceedit' /*医院档案列表编辑页*/, {
            url: '/visitassistance/:id',
            templateUrl: 'Module/VisitAssistance/visitAssistanceEditView.html',
            controller: 'visitAssistanceEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-11-8
 说明     : 代表拜访时长分析
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.visitduration' /*代表拜访统计表*/, {
            url: '/visitduration',
            templateUrl: 'Module/Visitduration/visitdurationListView.html?v=' + win.htmlFileVersion,
            controller: 'visitdurationController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2017-05-18
 说明     :协访-项目设定
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.visitassistanceitemsetting' /*列表*/, {
            url: '/visitassistanceitemsetting',
            templateUrl: 'Module/VisitAssistanceItemSetting/visitAssistanceItemSettingListView.html?v=' + win.htmlFileVersion,
            controller: 'visitAssistanceItemSettingListController'
        }).state('main.visitassistanceitemsetting.edit' /*编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/VisitAssistanceItemSetting/visitAssistanceItemSettingEditView.html',
            controller: 'visitAssistanceItemSettingEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/10/24
 说明     : 拜访-流程设置 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.visitflow' /*拜访-流程设置 列表*/, {
            url: '/visitflow',
            templateUrl: 'Module/VisitFlow/visitFlowListView.html?v=' + win.htmlFileVersion,
            controller: 'visitFlowListController'
        }).state('main.visitflow.edit' /*拜访-流程设置 编辑*/, {
            url: '/:id',
            templateUrl: 'Module/VisitFlow/visitFlowEditView.html',
            controller: 'visitFlowEditController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/3/9
 *描述：拜访计划
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.BusinessVisitPlam' /*拜访计划列表*/, {
            url: '/visitplan',
            templateUrl: 'Module/VisitPlan/visitplanListView.html?v=' + win.htmlFileVersion,
            controller: 'visitplanListController'
        }).state('main.BusinessVisitPlan.edit' /*拜访计划编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/VisitPlan/visitplanEditView.html?v=' + win.htmlFileVersion,
            controller: 'visitplanEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2016/10/27
 说明     : 代表拜访频率分析
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.visitfrequency' /*代表拜访统计表*/, {
            url: '/visitfrequency',
            templateUrl: 'Module/VisitFrequency/visitFrequencyListView.html?v=' + win.htmlFileVersion,
            controller: 'visitFrequencyController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : CherryXu
 创建时间 : 2017-11-24
 说明     :PC端拜访线路
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.visitroute' /*拜访线路列表*/, {
            url: '/visitroute',
            templateUrl: 'Module/VisitRoute/visitrouteListView.html?v=' + win.htmlFileVersion,
            controller: 'visitrouteListController'
        }).state('main.visitroute.edit' /*拜访线路编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/VisitRoute/visitrouteEditView.html',
            controller: 'visitrouteEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2016/1/29
 说明     : 日报统计分析报表
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.workreportstatistcs', {
            url: '/workreportstatistcsView',
            templateUrl: 'Module/WorkReportStatistics/workReportStatisticsListView.html?v=' + win.htmlFileVersion,
            controller: 'workReportStatisticsListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : CherryXu
 创建时间 : 2017-11-24
 说明     :PC端拜访线路
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.visitrouteweekly' /*拜访线路-周循环列表*/, {
            url: '/visitrouteweekly',
            templateUrl: 'Module/VisitRouteWeekly/visitrouteweeklyListView.html?v=' + win.htmlFileVersion,
            controller: 'visitrouteweeklyListController'
        }).state('main.visitrouteweekly.edit' /*拜访线路-周循环编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/VisitRouteWeekly/visitrouteweeklyEditView.html',
            controller: 'visitrouteweeklyEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2016/1/29
 说明     : 医院档案管理
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.account' /*医院档案列表*/, {
            url: '/account',
            templateUrl: 'Module/Account/accountListView.html?v=' + win.htmlFileVersion,
            controller: 'accountListController'
        }).state('main.account.edit' /*医院档案列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/Account/accountEditView.html',
            controller: 'accountEditController'
        });
    }]);
})(window);
'use strict';

/*********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2018/01/30
 说明     : 机构变更
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.accountapp', { //列表
            url: '/accountapp',
            templateUrl: 'Module/AccountApp/accountAppListView.html?v=' + win.htmlFileVersion,
            controller: 'accountAppListController'
        }).state('main.accountapp.read', { //只读
            url: '/read/:id',
            templateUrl: 'Module/AccountApp/accountAppReadView.html',
            controller: 'accountAppReadController'
        }).state('main.accountapp.search', { //搜索
            url: '/search/:id',
            templateUrl: 'Module/AccountApp/accountAppSearchView.html',
            controller: 'accountAppSearchController'
        }).state('main.accountapp.businessedit', { //商业编辑
            url: '/businessedit/:id/:accountId/:accountIdName/:changeType',
            templateUrl: 'Module/AccountApp/accountAppBusinessEditView.html',
            controller: 'accountAppBusinessEditController'
        }).state('main.accountapp.hospitaledit', { //医院编辑
            url: '/hospitaledit/:id/:accountId/:accountIdName/:changeType',
            templateUrl: 'Module/AccountApp/accountAppHospitalEditView.html',
            controller: 'accountAppHospitalEditController'
        }).state('main.accountapp.drugstoreedit', { //门店编辑
            url: '/drugstoreedit/:id/:accountId/:accountIdName/:changeType',
            templateUrl: 'Module/AccountApp/accountAppDrugstoreEditView.html',
            controller: 'accountAppDrugstoreEditController'
        }).state('main.accountapp.basicedit', { //基层医疗编辑
            url: '/basicedit/:id/:accountId/:accountIdName/:changeType',
            templateUrl: 'Module/AccountApp/accountAppBasicEditView.html',
            controller: 'accountAppBasicEditController'
        }).state('main.accountapp.agentedit', { //代理商编辑
            url: '/agentedit/:id/:accountId/:accountIdName/:changeType',
            templateUrl: 'Module/AccountApp/accountAppAgentEditView.html',
            controller: 'accountAppAgentEditController'
        }).state('main.accountapp.chainedit', { //连锁总部编辑
            url: '/chainedit/:id/:accountId/:accountIdName/:changeType',
            templateUrl: 'Module/AccountApp/accountAppChainEditView.html',
            controller: 'accountAppChainEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2016/2/5
 说明     : 商业库存导入
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.accountinv' /*商业库存导入*/, {
            url: '/AccountInv',
            templateUrl: 'Module/AccountInv/accountinvListView.html?v=' + win.htmlFileVersion,
            controller: 'accountinvListController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-10-12
 说明     : 客户价格表
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.accountprice' /*客户价格表列表*/, {
            url: '/accountprice',
            templateUrl: 'Module/AccountPrice/AccountPriceListView.html?v=' + win.htmlFileVersion,
            controller: 'accountpriceListController'
        }).state('main.accountprice.edit' /*客户价格表编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/AccountPrice/AccountPriceEditView.html?v=' + win.htmlFileVersion,
            controller: 'accountpriceEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Eric Zheng
 创建时间 : 2018/2/28
 说明     : 商业返利系数
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.accountRebateRate' /*商业返利系数列表*/, {
            url: '/accountRebateRate',
            templateUrl: 'Module/AccountRebateRate/accountRebateRateListView.html?v=' + win.htmlFileVersion,
            controller: 'accountRebateRateListController'
        }).state('main.accountRebateRate.edit' /*商业返利系数编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/AccountRebateRate/accountRebateRateEditView.html?v=' + win.htmlFileVersion,
            controller: 'accountRebateRateEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2016/2/5
 说明     : 商业安全库存
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.accountsafeinv' /*商业安全库存*/, {
            url: '/AccountSafeInv',
            templateUrl: 'Module/AccountSafeInv/accountsafeinvListView.html?v=' + win.htmlFileVersion,
            controller: 'accountsafeinvListController'
        }).state('main.accountsafeinv.edit' /*商业安全库存编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/AccountSafeInv/accountsafeinvEditView.html?v=' + win.htmlFileVersion,
            controller: 'accountsafeinvEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2017/12/12
 说明     : 客户-标签类型
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.accounttagtype' /*列表*/, {
            url: '/accounttagtype',
            templateUrl: 'Module/AccountTagType/accountTagTypeListView.html?v=' + win.htmlFileVersion,
            controller: 'accountTagTypeListController'
        }).state('main.accounttagtype.edit' /*编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/AccountTagType/accountTagTypeEditView.html',
            controller: 'accountTagTypeEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2016/1/29
 说明     : 医院档案管理
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.accountvisit' /*医院档案列表*/, {
            url: '/accountvisit',
            templateUrl: 'Module/AccountVisit/accountVisitListView.html?v=' + win.htmlFileVersion,
            controller: 'accountVisitListController'
        }).state('main.accountvisit.edit' /*医院档案列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/AccountVisit/accountVisitEditView.html',
            controller: 'accountVisitEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-13
 说明     :PC端代理商
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.agent' /*代理商档案列表*/, {
            url: '/agent',
            templateUrl: 'Module/Agent/agentListView.html?v=' + win.htmlFileVersion,
            controller: 'agentListController'
        }).state('main.agent.edit' /*代理商档案列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/Agent/agentEditView.html',
            controller: 'agentEditController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/4/13
 *说明：文件描述...
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.AgentBusinessAssistance' /**/, {
            url: '/agentbusinessassistance',
            templateUrl: 'Module/AgentBusinessAssistance/AgentBusinessAssistanceListView.html?v=' + win.htmlFileVersion,
            controller: 'AgentBusinessAssistanceListController'
        }).state('main.AgentBusinessAssistance.edit' /**/, {
            url: '/edit/:id',
            templateUrl: 'Module/AgentBusinessAssistance/AgentBusinessAssistanceEditView.html?v=' + win.htmlFileVersion,
            controller: 'AgentBusinessAssistanceEditController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/4/13
 *说明：文件描述...
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.AgentBusinessVisit' /*代理商拜访列表*/, {
            url: '/agengtbusinessvisit',
            templateUrl: 'Module/AgentBusinessVisit/AgentBusinessVisitListView.html?v=' + win.htmlFileVersion,
            controller: 'AgentBusinessVisitListController'
        }).state('main.AgentBusinessVisit.edit' /*代理商拜访计划编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/AgentBusinessVisit/AgentBusinessVisitEditView.html?v=' + win.htmlFileVersion,
            controller: 'AgentBusinessVisitEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2017-04-24
 说明     : 应收数据
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.arvoucher' /*列表*/, {
            url: '/arvoucher',
            templateUrl: 'Module/ArVoucher/arvoucherListView.html?v=' + win.htmlFileVersion,
            controller: 'arvoucherListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2017/6/12
 说明     : 代表签到查询 路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.attendancereport', {
            url: '/attendancereport',
            templateUrl: 'Module/AttendanceReport/attendancereportView.html?v=' + win.htmlFileVersion,
            controller: 'attendancereportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016-07-08
 说明     : 考勤规则设定
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.attendancerule' /*自定义类别列表*/, {
            url: '/attendancerule',
            templateUrl: 'Module/AttendanceRule/attendanceruleListView.html?v=' + win.htmlFileVersion,
            controller: 'attendanceruleListController'
        }).state('main.attendancerule.edit' /*自定义类别编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/AttendanceRule/attendanceruleEditView.html?v=' + win.htmlFileVersion,
            controller: 'attendanceruleEditController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/6/28
 *说明：基药线动销率报表
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.baselinedynamicrate', {
            url: '/BaseLineDynamicRateView',
            templateUrl: 'Module/BaseLineDynamicRate/baseLineDynamicRateListView.html?v=' + win.htmlFileVersion,
            controller: 'baseLineDynamicRateListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2016/2/3
 说明     : 基层医疗机构
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.BasicMedical' /*基层医疗机构列表*/, {
            url: '/BasicMedical',
            templateUrl: 'Module/BasicMedical/BasicMedicalListView.html?v=' + win.htmlFileVersion,
            controller: 'BasicMedicalListController'
        }).state('main.BasicMedical.edit' /*基层医疗机构编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/BasicMedical/BasicMedicalEditView.html?v=' + win.htmlFileVersion,
            controller: 'BasicMedicalEditController'
        });
    }]);
})(window);
'use strict';

/*********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2017/6/28
 说明     : 商业公司数据
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.bizaccountcosts' /*商业公司数据*/, {
            url: '/BizAccountCosts',
            templateUrl: 'Module/BizAccountCosts/BizAccountCostsListView.html?v=' + win.htmlFileVersion,
            controller: 'BizAccountCostsListController'
        }).state('main.bizaccountcosts.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/BizAccountCosts/BizAccountCostsEditView.html?v=' + win.htmlFileVersion,
            controller: 'BizAccountCostsEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/02/24
 说明     : 商业开票价格表
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.bizaccountpricelist' /*医院档案列表*/, {
            url: '/bizaccountpricelist',
            templateUrl: 'Module/BizAccountPricelist/bizaccountpricelistListView.html?v=' + win.htmlFileVersion,
            controller: 'bizaccountpricelistListController'
        }).state('main.bizaccountpricelist.edit' /*医院档案列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/BizAccountPricelist/bizaccountpricelistEditView.html',
            controller: 'bizaccountpricelistEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/2/28
 说明     : 商业开票金额统计 - 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.bizaccountreport' /*招商经理行为统计*/, {
            url: '/bizaccountreport',
            templateUrl: 'Module/BizAccountReport/BizAccountReportListView.html?v=' + win.htmlFileVersion,
            controller: 'BizAccountReportController'
        });
    }]);
})(window);
'use strict';

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.businessaccount' /*商业客户档案*/, {
            url: '/businessaccount',
            templateUrl: 'Module/BusinessAccount/businessaccountListView.html?v=' + win.htmlFileVersion,
            controller: 'businessaccountListController'
        }).state('main.businessaccount.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/BusinessAccount/businessaccountEditView.html?v=' + win.htmlFileVersion,
            controller: 'businessaccountEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-8
 说明     :PC端商业协访
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.BusinessAssistance' /*商业协访列表*/, {
            url: '/businessassistance',
            templateUrl: 'Module/BusinessAssistance/BusinessAssistanceListView.html?v=' + win.htmlFileVersion,
            controller: 'businessAssistanceListController'
        }).state('main.BusinessAssistance.edit' /*拜访计划编辑*/, {
            url: '/edit/:id',
            templateUrl: 'Module/BusinessAssistance/BusinessAssistanceEditView.html?v=' + win.htmlFileVersion,
            controller: 'businessAssistanceEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016/7/4
 说明     : 商业回款统计 路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.businesscashbacksatistics', {
            url: '/businesscashbacksatistics',
            templateUrl: 'Module/BusinessCashBackStatistics/businesscashbacksatisticsListView.html?v=' + win.htmlFileVersion,
            controller: 'businesscashbacksatisticsController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016-5-6
 说明     :商务流通品种发货
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.businesscirculatevardeliver', {
            url: '/.businesscirculatevardeliver',
            templateUrl: 'Module/BusinessLineReport/BusinessCirculateVarDeliverListView.html?v=' + win.htmlFileVersion,
            controller: 'BusinessCirculateVarDeliverListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Eric Zheng
 创建时间 : 2018/2/27
 说明     : 部门投入费用路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.businessUnitExpense' /*部门投入费用列表*/, {
            url: '/businessUnitExpense',
            templateUrl: 'Module/BusinessUnitExpense/businessUnitExpenseList.html?v=' + win.htmlFileVersion,
            controller: 'businessUnitExpenseListController'
        }).state('main.businessUnitExpense.edit' /*部门投入费用编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/BusinessUnitExpense/businessUnitExpenseEditView.html?v=' + win.htmlFileVersion,
            controller: 'businessUnitExpenseEditController'
        });
    }]);
})(window);
'use strict';

/*********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2018/02/28
 说明     : 医生变更 路由
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.contactapp', { //列表
            url: '/contactapp',
            templateUrl: 'Module/ContactApp/contactAppListView.html?v=' + win.htmlFileVersion,
            controller: 'contactAppListController'
        }).state('main.contactapp.read', { //只读
            url: '/read/:id',
            templateUrl: 'Module/ContactApp/contactAppReadView.html',
            controller: 'contactAppReadController'
        }).state('main.contactapp.search', { //搜索
            url: '/search/:id',
            templateUrl: 'Module/ContactApp/contactAppSearchView.html',
            controller: 'contactAppSearchController'
        }).state('main.contactapp.doctoredit', { //医生编辑
            url: '/hospitaledit/:id/:accountId/:accountIdName/:contactId/:contactIdName/:changeType',
            templateUrl: 'Module/ContactApp/contactAppDoctorEditView.html',
            controller: 'contactAppDoctorEditController'
        });
    }]);
})(window);
'use strict';

/*********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2018/04/02
 说明     : 医生评级
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.contactgradeapp', { //列表
            url: '/contactgradeapp',
            templateUrl: 'Module/ContactGradeApp/contactGradeAppListView.html?v=' + win.htmlFileVersion,
            controller: 'contactGradeAppListController'
        }).state('main.contactgradeapp.readonly', { //只读
            url: '/readonly/:id',
            templateUrl: 'Module/ContactGradeApp/contactGradeAppReadOnlyView.html',
            controller: 'contactGradeAppReadOnlyController'
        }).state('main.contactgradeapp.edit', { //编辑
            url: '/edit/:id',
            templateUrl: 'Module/ContactGradeApp/contactGradeAppEditView.html',
            controller: 'contactGradeAppEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : JerryWu
 创建时间 : 2018/03/12
 说明     : 联系人-标签类型
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.contactTagType' /*列表*/, {
            url: '/contactTagType',
            templateUrl: 'Module/ContactTagType/contactTagTypeListView.html?v=' + win.htmlFileVersion,
            controller: 'contactTagTypeListController'
        }).state('main.contactTagType.edit' /*编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/ContactTagType/contactTagTypeEditView.html',
            controller: 'contactTagTypeEditController'
        });
    }]);
})(window);
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/4/6
 *说明：dashboard
 *************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.dashboard', {
            url: '/dashboardView',
            templateUrl: 'Module/Dashboard/dashboardhome.html?v=' + win.htmlFileVersion,
            controller: 'dashboardhomeController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/08/04
 说明     : odp医生
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odpdoctor' /*医院档案列表*/, {
            url: '/odpdoctor',
            templateUrl: 'Module/OdpDoctor/odpDoctorListView.html?v=' + win.htmlFileVersion,
            controller: 'odpDoctorListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2016/1/29
 说明     : 医院档案管理
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odpHospital' /*医院档案列表*/, {
            url: '/odpHospital',
            templateUrl: 'Module/OdpHospital/odpHospitalListView.html?v=' + win.htmlFileVersion,
            controller: 'odpHospitalListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/09/12
 说明     : odp门店
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odpdrugstore' /*门店档案列表*/, {
            url: '/odpdrugstore',
            templateUrl: 'Module/OdpDrugStore/odpDrugStoreListView.html?v=' + win.htmlFileVersion,
            controller: 'odpDrugStoreListController'
        });
    }]);
})(window);
'use strict';

/*
 * /********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-10-11
 说明     : 组织信息
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.organizationinfo' /*组织信息编辑*/, {
            url: '/organizationinfo',
            templateUrl: 'Module/OrganizationInfo/OrganizationInfoEditView.html?v=' + win.htmlFileVersion,
            controller: 'organizationinfoListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
创建人   : Berry Ding
创建时间 : 2018/1/4
说明     : 产品箱毛利
*********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.productboxprofit' /*列表*/, {
            url: '/productboxprofit/list',
            templateUrl: 'Module/ProductBoxProfit/productBoxProfitListView.html?v=' + win.htmlFileVersion,
            controller: 'productBoxProfitListController'
        }).state('main.productboxprofit.edit' /*编辑*/, {
            url: '/productboxprofit/edit/:id',
            templateUrl: 'Module/ProductBoxProfit/productBoxProfitEditView.html',
            controller: 'productBoxProfitEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : JeoLi
 创建时间 : 2018-02-26
 说明     :省中标价格
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.provinceBiddingPrice' /*列表*/, {
            url: '/provinceBiddingPrice',
            templateUrl: 'Module/ProvinceBiddingPrice/ProvinceBiddingPriceListView.html?v=' + win.htmlFileVersion,
            controller: 'ProvinceBiddingPriceListController'
        }).state('main.provinceBiddingPrice.edit' /*列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/ProvinceBiddingPrice/ProvinceBiddingPriceEditView.html?v=' + win.htmlFileVersion,
            controller: 'ProvinceBiddingPriceEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/11
 说明     : 运营设置 - 短信验证码 路由
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.smsverificationcodeloghis' /*短信验证码 列表*/, {
            url: '/smsverificationcodeloghis',
            templateUrl: 'Module/SmsVerificationCodeLog/smsVerificationCodeLogListView.html?v=' + win.htmlFileVersion,
            controller: 'SmsVerificationCodeLogListController'
        });
    }]);
})(window);
'use strict';

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.terminalaccount' /*零售终端档案*/, {
            url: '/terminalaccount',
            templateUrl: 'Module/TerminalAccount/terminalaccountListView.html?v=' + win.htmlFileVersion,
            controller: 'terminalaccountListController'
        }).state('main.terminalaccount.edit', {
            url: '/edit/:id',
            templateUrl: 'Module/TerminalAccount/terminalaccountEditView.html?v=' + win.htmlFileVersion,
            controller: 'terminalaccountEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2017/3/15
 说明     : 终端销量分析报表
 *********************************************************/

(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.reportdata.terminalanalysissalesreport', {
            url: '/terminalanalysissalesreport',
            templateUrl: 'Module/TerminalSalesAnalysisReport/TerminalSalesAnalysisReportListView.html?v=' + win.htmlFileVersion,
            controller: 'TerminalSalesAnalysisReportController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Chad Chen
 创建时间 : 2017-11-20
 说明     : 辖区模块 
 *********************************************************/

(function () {
    angular.module('xrmApp').config(['$stateProvider', xrmAppConfig]);
    function xrmAppConfig($stateProvider) {
        $stateProvider.state('main.territory' /*业务部门*/, {
            url: '/territory',
            templateUrl: 'module/territory/territoryListView.html',
            controller: 'territoryListController'
        }).state('main.territory.businessunit' /*业务部门*/, {
            url: '/territory/businessunit/:id',
            templateUrl: 'module/TerritoryBusinessManage/territorybusinessmanageEditView.html',
            controller: 'territorybusinessmanageEditController'
        }).state('main.territory.region' /*业务部门*/, {
            url: '/territory/region/:id',
            templateUrl: 'module/TerritoryRegionManage/territoryregionmanageEditView.html',
            controller: 'territoryregionmanageEditController'
        });
    }
})();
'use strict';

/*********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/12/14
 说明     : 动销激励审查
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.trainingcampaignticketupload' /*动销激励审查*/, {
            url: '/trainingcampaignticketupload',
            templateUrl: 'Module/TrainingCampaignTicketUpload/TrainingCampaignTicketUploadListView.html?v=' + win.htmlFileVersion,
            controller: 'TrainingCampaignTicketUploadListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : JeoLi
 创建时间 : 2018-02-26
 说明     :代表投入费用
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.userExpense' /*列表*/, {
            url: '/userExpense',
            templateUrl: 'Module/UserExpense/UserExpenseListView.html?v=' + win.htmlFileVersion,
            controller: 'UserExpenseListController'
        }).state('main.userExpense.edit' /*列表编辑页*/, {
            url: '/edit/:id',
            templateUrl: 'Module/UserExpense/UserExpenseEditView.html?v=' + win.htmlFileVersion,
            controller: 'UserExpenseEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2017/7/27
 说明     : 医院别名库
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odpaccountalias', {
            url: '/odpaccountalias',
            templateUrl: 'Odp/AliasManage/accountaliasListView.html?v=' + win.htmlFileVersion,
            controller: 'odpaccountaliasListController'
        }).state('main.odpaccountalias.edit', {
            url: '/edit/:id',
            templateUrl: 'Odp/AliasManage/accountaliasEditView.html?v=' + win.htmlFileVersion,
            controller: 'odpaccountaliasEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/08/22
 说明     : 城市别名库
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odpcityalias', {
            url: '/odpcityalias',
            templateUrl: 'Odp/AliasManage/cityaliasListView.html?v=' + win.htmlFileVersion,
            controller: 'odpcityaliasListController'
        }).state('main.odpcityalias.edit', {
            url: '/edit/:id',
            templateUrl: 'Odp/AliasManage/cityaliasEditView.html?v=' + win.htmlFileVersion,
            controller: 'odpcityaliasEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/08/22
 说明     : 区县别名库
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odpcountyalias', {
            url: '/odpcountyalias',
            templateUrl: 'Odp/AliasManage/countyaliasListView.html?v=' + win.htmlFileVersion,
            controller: 'odpcountyaliasListController'
        }).state('main.odpcountyalias.edit', {
            url: '/edit/:id',
            templateUrl: 'Odp/AliasManage/countyaliasEditView.html?v=' + win.htmlFileVersion,
            controller: 'odpcountyaliasEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2017/7/27
 说明     : 科室别名库
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odpdepartmentalias', {
            url: '/odpdepartmentalias',
            templateUrl: 'Odp/AliasManage/departmentaliasListView.html?v=' + win.htmlFileVersion,
            controller: 'odpdepartmentaliasListController'
        }).state('main.odpdepartmentalias.edit', {
            url: '/edit/:id',
            templateUrl: 'Odp/AliasManage/departmentaliasEditView.html?v=' + win.htmlFileVersion,
            controller: 'odpdepartmentaliasEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2017/7/27
 说明     : 爬虫抓取的 科室
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odpdepartmentcrawler', {
            url: '/odpdepartmentcrawler',
            templateUrl: 'Odp/CrawlerDepartment/odpdepartmentcrawlerListView.html?v=' + win.htmlFileVersion,
            controller: 'odpdepartmentcrawlerListController'
        }).state('main.syncdepartmentcrawler', {
            url: '/syncdepartmentcrawler',
            templateUrl: 'Odp/CrawlerDepartment/syncdepartmentcrawlerListView.html?v=' + win.htmlFileVersion,
            controller: 'syncdepartmentcrawlerListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2017/7/27
 说明     : 爬虫抓取的 医生
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odpdoctorcrawler', {
            url: '/odpdoctorcrawler',
            templateUrl: 'Odp/CrawlerDoctor/odpdoctorcrawlerListView.html?v=' + win.htmlFileVersion,
            controller: 'odpdoctorcrawlerListController'
        }).state('main.syncdoctorcrawler', {
            url: '/syncdoctorcrawler',
            templateUrl: 'Odp/CrawlerDoctor/syncdoctorcrawlerListView.html?v=' + win.htmlFileVersion,
            controller: 'syncdoctorcrawlerListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2017/7/27
 说明     : 爬虫抓取的 门店
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odpdrugstorecrawler', {
            url: '/odpdrugstorecrawler',
            templateUrl: 'Odp/CrawlerDrugStore/odpdrugstorecrawlerListView.html?v=' + win.htmlFileVersion,
            controller: 'odpdrugstorecrawlerListController'
        }).state('main.syncdrugstorecrawler', {
            url: '/syncdrugstorecrawler',
            templateUrl: 'Odp/CrawlerDrugStore/syncdrugstorecrawlerListView.html?v=' + win.htmlFileVersion,
            controller: 'syncdrugstorecrawlerListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar gao
 创建时间 : 2017/7/27
 说明     : 爬虫抓取的 医院
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odphospitalcrawler' /*医院(爬虫)档案列表*/, {
            url: '/odphospitalcrawler',
            templateUrl: 'Odp/CrawlerHospital/odphospitalcrawlerListView.html?v=' + win.htmlFileVersion,
            controller: 'odphospitalcrawlerListController'
        }).state('main.synchospitalcrawler', {
            url: '/synchospitalcrawler',
            templateUrl: 'Odp/CrawlerHospital/synchospitalcrawlerListView.html?v=' + win.htmlFileVersion,
            controller: 'synchospitalcrawlerListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-08-21
 说明     : 科室类型 路由
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odpdepartmenttype', {
            url: '/odpdepartmenttype',
            templateUrl: 'Odp/DepartmentType/departmentTypeListView.html?v=' + win.htmlFileVersion,
            controller: 'departmentTypeListController'
        }).state('main.odpdepartmenttype.edit', {
            url: '/edit/:id',
            templateUrl: 'Odp/DepartmentType/departmentTypeEditView.html?v=' + win.htmlFileVersion,
            controller: 'departmentTypeEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-09-12
 说明     : 门店数据清洗 路由
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.drugstoredatadlean', {
            url: '/drugstoredatadlean',
            templateUrl: 'Odp/DrugStoreDataClean/DrugStoreDataCleanListView.html?v=' + win.htmlFileVersion,
            controller: 'DrugStoreDataCleanListController'
        }).state('main.drugstoredatadleanhandle', {
            url: '/drugstoredatadleanhandle',
            templateUrl: 'Odp/DrugStoreDataClean/DrugStoreDataCleanHandleView.html?v=' + win.htmlFileVersion,
            controller: 'DrugStoreDataCleanHandleController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2017-08-21
 说明     : 医院级别 路由
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.hospitallevel', {
            url: '/hospitallevel',
            templateUrl: 'Odp/HospitalLevel/hospitalLevelListView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalLevelListController'
        }).state('main.hospitallevel.edit', {
            url: '/edit/:id',
            templateUrl: 'Odp/HospitalLevel/hospitalLevelEditView.html?v=' + win.htmlFileVersion,
            controller: 'hospitalLevelEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-07-26
 说明     : 协议租户设置 路由
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odptenant', {
            url: '/odptenant',
            templateUrl: 'Odp/Tenant/tenantListView.html?v=' + win.htmlFileVersion,
            controller: 'tenantListController'
        }).state('main.odptenant.edit', {
            url: '/edit/:id',
            templateUrl: 'Odp/Tenant/tenantEditView.html?v=' + win.htmlFileVersion,
            controller: 'tenantEditController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-08-01
 说明     : 客户数据清洗 路由
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odptenantdataclean', {
            url: '/odptenantdataclean',
            templateUrl: 'Odp/TenantDataClean/tenantDataCleanListView.html?v=' + win.htmlFileVersion,
            controller: 'tenantDataCleanListController'
        }).state('main.odptenantdatacleanhandle', {
            url: '/odptenantdatacleanhandle',
            templateUrl: 'Odp/TenantDataClean/tenantDataCleanHandleView.html?v=' + win.htmlFileVersion,
            controller: 'tenantDataCleanHandleController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-08-01
 说明     : 主数据-科室-租户 路由
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odptenantdepartment', {
            url: '/odptenantdepartment',
            templateUrl: 'Odp/TenantDepartment/tenantDepartmentListView.html?v=' + win.htmlFileVersion,
            controller: 'tenantDepartmentListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-08-01
 说明     : 主数据-医生-租户 路由
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odptenantdoctor', {
            url: '/odptenantdoctor',
            templateUrl: 'Odp/TenantDoctor/tenantDoctorListView.html?v=' + win.htmlFileVersion,
            controller: 'tenantDoctorListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-09-12
 说明     : 主数据-门店-租户 路由
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odptenantdrugstore', {
            url: '/odptenantdrugstore',
            templateUrl: 'Odp/TenantDrugStore/tenantDrugStoreListView.html?v=' + win.htmlFileVersion,
            controller: 'tenantDrugStoreListController'
        });
    }]);
})(window);
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-07-31
 说明     : 主数据-医院-租户 路由
*********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.odptenanthosptail', {
            url: '/odptenanthosptail',
            templateUrl: 'Odp/TenantHospital/tenantHospitalListView.html?v=' + win.htmlFileVersion,
            controller: 'tenantHospitalListController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2016/10/13
 说明     : 瑞云客户资料
 *********************************************************/
(function (win) {
    'use strict';

    angular.module('xrmApp').config(['$stateProvider', function ($stateProvider) {
        $stateProvider.state('main.csmcustomer', {
            url: '/csmcustomer',
            templateUrl: 'Oms/CsmCustomer/csmCustomerListView.html?v=' + win.htmlFileVersion,
            controller: 'csmCustomerListController'
        }).state('main.csmcustomer.edit', {
            url: '/edit/:id',
            templateUrl: 'Oms/CsmCustomer/csmCustomerEditView.html?v=' + win.htmlFileVersion,
            controller: 'csmCustomerEditController'
        });
    }]);
})(window);
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2016-03-29
 说明     : 请假
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('absenceService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'absence';
        // @@ 选项集
        this.picklists = ['StateCode', 'absence_type'];
        //审批实体名字
        this.approvalTypeName = 'absence';
    }]).controller('absenceListController', ['$injector', '$scope', 'absenceService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        function _getApprovalStatus(id, i) {
            var url2 = 'api/FlowApproval/GetFormApprovalStatus?objectId=' + id;
            rt.get(url2).then(function (resp2) {
                if (!rt.isNull(resp2.data.ApprovalStatus)) {
                    if (rt.isNull(resp2.data.ApprovalStatus.approval_result) || resp2.data.ApprovalStatus.approval_result.Value == 1) {
                        $scope.vm.data[i].approvalStatus = '待审批';
                    } else {
                        $scope.vm.data[i].approvalStatus = resp2.data.ApprovalStatus.approval_resultName;
                    }
                }
            }).catch(function (resp2) {
                rt.errorMessage(resp2.data);
            });
        }
        $scope.vm.actions.loadComplete = function () {
            if (!rt.isNull($scope.vm.data)) {
                for (var i = 0; i < $scope.vm.data.length; i++) {
                    _getApprovalStatus($scope.vm.data[i].Id, i);
                }
            }
        };
    }]).controller('absenceEditController', ['$injector', '$scope', 'absenceService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.loadComplete = function () {
            $scope.flag = 0;
            $scope.fjs = [];
            $scope.selectedFiles = null;
            $scope.selectedFilesArr = [];
            $scope.selectedFileName = null;

            if ($scope.vm.form.type === 'Edit') rt.GetFilesByObjectId("absence", $scope.vm.form.data.Id).success(function (data) {
                var data = data.DataList;
                if (data != null) {
                    for (var i = 0; i < data.length; i++) {
                        $scope.fjs.push({ Id: data[i].Id, FileName: data[i].FileName, DownFile: true });
                    }
                }
            }).error(function (message) {
                rt.errorMessage(message);
            });
        };

        $scope.vm.form.postSave = function () {
            if (!rt.isEmptyArray($scope.selectedFiles)) {
                rt.uploadFiles($scope.selectedFiles, "absence", $scope.vm.form.data.Id, false);
                $scope.selectedFiles = null;
            }
        };

        //选择附件
        $scope.vm.form.selectFile = function (files) {
            if (files && files.length && files.length > 0) {
                for (var i = 0; i < files.length; i++) {
                    $scope.selectedFilesArr.push(files[i]);
                }

                $scope.selectedFiles = $scope.selectedFilesArr;
                for (var i = 0; i < files.length; i++) {
                    $scope.fjs.push({ Id: rt.newGuid(), FileName: files[i].name, DownFile: false });
                }
            }
        };

        //删除附件
        $scope.vm.form.deletedFile = function () {
            if ($scope.vm.view.selectedIds.length == 0) {
                rt.errorMessage("请选择附件。");
                return;
            }
            var mmm = rt.deleteFile("absence", $scope.vm.view.selectedIds).error(function (message) {
                rt.errorMessage(message);
            }).success(function (data) {
                $scope.selectedFileName = null;
                for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                    for (var k = 0; k < $scope.fjs.length; k++) {
                        if ($scope.fjs[k].Id === $scope.vm.view.selectedIds[j]) {
                            if ($scope.selectedFiles != null) {
                                for (var i = 0; i < $scope.selectedFiles.length; i++) {
                                    if ($scope.selectedFiles[i].name === $scope.fjs[k].FileName) {
                                        $scope.selectedFiles.splice(i, 1);
                                    }
                                }
                            }
                        }
                    }
                }
                for (var i = 0; i < $scope.fjs.length; i++) {
                    for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                        if ($scope.fjs[i].Id === $scope.vm.view.selectedIds[j]) {
                            $scope.fjs.splice(i, 1);
                        }
                    }
                }

                rt.successMessage("删除成功。");
            });
        };

        $scope.vm.form.preSave = function () {
            if ($scope.vm.form.data.start_date > $scope.vm.form.data.end_date) {
                rt.errorMessage("开始时间不能大于结束时间");
                return "开始时间不能大于结束时间";
            }
        };
    }]).controller('absenceReadOnlyController', ['$injector', '$scope', 'absenceService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $state = myService.$state;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.tabIndex = 1;

        //切换Tab
        $scope.chooseTab = function (tabIndex) {
            $scope.vm.tabIndex = tabIndex;
        };

        //重新提交
        $scope.vm.form.reSubmit = function () {
            $state.go("main.absence.edit", { id: $scope.vm.form.data.Id }, { location: true });
        };

        //下载附件
        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("absence", fileId);
        };

        $scope.vm.form.loadComplete = function () {
            //加载附件信息
            rt.GetFilesByObjectId("absence", $scope.vm.form.data.Id).error(function (message) {
                rt.errorMessage(message);
            }).success(function (data) {
                var data = data.DataList;
                if (data != null) {
                    $scope.fjs = [];
                    for (var i = 0; i < data.length; i++) {
                        $scope.fjs.push({ Id: data[i].Id, FileName: data[i].FileName, DownFile: true });
                    }
                }
            });

            //加载审批流信息
            myService.getApprovalStatus($scope.vm.form.data.Id).then(function (resp) {
                if (!rt.isNull(resp.data)) {
                    $scope.vm.form.approvalStatus = resp.data.ApprovalStatus;
                    $scope.vm.form.approverList = resp.data.ApproverList;
                }

                $scope.vm.form.isFlowApprover = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.ApprovingBy) && rt.isSameGuid($scope.vm.form.approvalStatus.ApprovingBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;

                $scope.vm.form.isFlowSubmitter = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.SubmittedBy) && rt.isSameGuid($scope.vm.form.approvalStatus.SubmittedBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;
            }).catch(function (resp) {
                rt.errorMessage(resp.data);
            });
        };

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Kevin Zhou
 创建时间 : 2016-04-07
 说明     : 外勤管理服务
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('attendanceService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'XcrmAttendance';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('attendanceController', ['$injector', '$compile', '$timeout', '$scope', 'attendanceService', function ($injector, $compile, $timeout, $scope, myService) {
        var rt = myService.rt;
        this.viewTag = "Web";

        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.startTime) && !rt.isNull($scope.vm.endTime)) {
                that.searchList.push({ Type: 3, Key: "time", Value: [$scope.vm.startTime, moment(new Date($scope.vm.endTime)).add(1, 'days').format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.startTime) && !rt.isNull($scope.vm.endTime)) {
                that.searchList.push({ Type: 3, Key: "time", Value: [$scope.vm.startTime, moment(new Date($scope.vm.endTime)).add(1, 'days').format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        _initYmSelected();
        _getAllBuid();

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.startTime = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.endTime = moment().format('YYYY-MM-DD');
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = null;
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        $scope.overHeightTable = function () {
            overHeightTable();
        };
        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }

        //图片浏览
        $scope.vm.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
    }]);
})();
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2016-03-30
 说明     : 出差
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('businessTripService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'businessTrip';
        // @@ 选项集
        this.picklists = ['StateCode'];
        //审批实体名字
        this.approvalTypeName = 'business_trip';
    }]).controller('businessTripListController', ['$injector', '$scope', 'businessTripService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        function _getApprovalStatus(id, i) {
            var url2 = 'api/FlowApproval/GetFormApprovalStatus?objectId=' + id;
            rt.get(url2).then(function (resp2) {
                if (!rt.isNull(resp2.data.ApprovalStatus)) {
                    if (resp2.data.ApprovalStatus.approval_result.Value == 1) {
                        $scope.vm.data[i].approvalStatus = '待审批';
                    } else {
                        $scope.vm.data[i].approvalStatus = resp2.data.ApprovalStatus.approval_resultName;
                    }
                }
            }).catch(function (resp2) {
                rt.errorMessage(resp2.data);
            });
        }
        $scope.vm.actions.loadComplete = function () {
            if (!rt.isNull($scope.vm.data)) {
                for (var i = 0; i < $scope.vm.data.length; i++) {
                    _getApprovalStatus($scope.vm.data[i].Id, i);
                }
            }
        };
    }]).controller('businessTripEditController', ['$injector', '$scope', 'businessTripService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.loadComplete = function () {
            $scope.vm.form.detail = {};
            $scope.flag = 0;
            $scope.fjs = [];
            $scope.selectedFiles = null;
            $scope.selectedFilesArr = [];
            $scope.selectedFileName = null;

            if ($scope.vm.form.type === 'Edit') rt.GetFilesByObjectId("businessTrip", $scope.vm.form.data.Id).success(function (data) {
                var data = data.DataList;
                if (data != null) {
                    for (var i = 0; i < data.length; i++) {
                        $scope.fjs.push({ Id: data[i].Id, FileName: data[i].FileName, DownFile: true });
                    }
                }
            }).error(function (message) {
                rt.errorMessage(message);
            });
        };

        $scope.vm.form.postSave = function () {
            if (!rt.isEmptyArray($scope.selectedFiles)) {
                rt.uploadFiles($scope.selectedFiles, "businessTrip", $scope.vm.form.data.Id, false);
                $scope.selectedFiles = null;
            }
        };

        //选择附件
        $scope.vm.form.selectFile = function (files) {
            if (files && files.length && files.length > 0) {
                for (var i = 0; i < files.length; i++) {
                    $scope.selectedFilesArr.push(files[i]);
                }

                $scope.selectedFiles = $scope.selectedFilesArr;
                for (var i = 0; i < files.length; i++) {
                    $scope.fjs.push({ Id: rt.newGuid(), FileName: files[i].name, DownFile: false });
                }
            }
        };

        //删除附件
        $scope.vm.form.deletedFile = function () {
            if ($scope.vm.view.selectedIds.length == 0) {
                rt.errorMessage("请选择附件。");
                return;
            }
            var mmm = rt.deleteFile("businessTrip", $scope.vm.view.selectedIds).error(function (message) {
                rt.errorMessage(message);
            }).success(function (data) {
                $scope.selectedFileName = null;
                for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                    for (var k = 0; k < $scope.fjs.length; k++) {
                        if ($scope.fjs[k].Id === $scope.vm.view.selectedIds[j]) {
                            if ($scope.selectedFiles != null) {
                                for (var i = 0; i < $scope.selectedFiles.length; i++) {
                                    if ($scope.selectedFiles[i].name === $scope.fjs[k].FileName) {
                                        $scope.selectedFiles.splice(i, 1);
                                    }
                                }
                            }
                        }
                    }
                }
                for (var i = 0; i < $scope.fjs.length; i++) {
                    for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                        if ($scope.fjs[i].Id === $scope.vm.view.selectedIds[j]) {
                            $scope.fjs.splice(i, 1);
                        }
                    }
                }

                rt.successMessage("删除成功。");
            });
        };

        $scope.vm.form.preSave = function () {
            if ($scope.vm.form.data.total_days !== "" && $scope.vm.form.data.total_days !== undefined && $scope.vm.form.data.total_days !== null) {
                if (!/^[0-9]*[1-9][0-9]*$/.test($scope.vm.form.data.total_days)) {
                    rt.errorMessage("出差天数请输入正整数");
                    return;
                }
            }

            if (rt.isNull($scope.vm.form.data.DetailList) || $scope.vm.form.data.DetailList.length === 0) {
                rt.errorMessage("请至少输入一条行程明细！");
                return "请至少输入一条报销明细！";
            }
        };

        $scope.vm.form.delDetail = function (index) {
            $scope.vm.form.data.DetailList.splice(index, 1);
        };

        $scope.addDetail = function (detail) {
            if ($scope.vm.form.detail.start_date > $scope.vm.form.detail.end_date) {
                rt.errorMessage("行程明细开始时间不能大于结束时间");
                return;
            }
            if (rt.isNull($scope.vm.form.data.DetailList)) {
                $scope.vm.form.data.DetailList = [];
            }
            if (rt.isNull(detail.start_date)) {
                rt.errorMessage("请输入开始时间");
                return;
            }
            if (rt.isNull(detail.end_date)) {
                rt.errorMessage("请输入结束时间");
                return;
            }
            if (rt.isNull(detail.location)) {
                rt.errorMessage("请输入出差地点");
                return;
            }
            $scope.vm.form.data.DetailList.push({
                business_trip_detailId: rt.newGuid(),
                location: detail.location,
                start_date: detail.start_date,
                end_date: detail.end_date
            });
            $scope.vm.form.detail = {};
        };
    }]).controller('businessTripReadOnlyController', ['$injector', '$scope', 'businessTripService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $state = myService.$state;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.tabIndex = 1;

        //切换Tab
        $scope.chooseTab = function (tabIndex) {
            $scope.vm.tabIndex = tabIndex;
        };

        //重新提交
        $scope.vm.form.reSubmit = function () {
            $state.go("main.businessTrip.edit", { id: $scope.vm.form.data.Id }, { location: true });
        };

        //下载附件
        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("businessTrip", fileId);
        };

        $scope.vm.form.loadComplete = function () {
            //加载附件信息
            rt.GetFilesByObjectId("businessTrip", $scope.vm.form.data.Id).error(function (message) {
                rt.errorMessage(message);
            }).success(function (data) {
                var data = data.DataList;
                if (data != null) {
                    $scope.fjs = [];
                    for (var i = 0; i < data.length; i++) {
                        $scope.fjs.push({ Id: data[i].Id, FileName: data[i].FileName, DownFile: true });
                    }
                }
            });

            //加载审批流信息
            myService.getApprovalStatus($scope.vm.form.data.Id).then(function (resp) {
                if (!rt.isNull(resp.data)) {
                    $scope.vm.form.approvalStatus = resp.data.ApprovalStatus;
                    $scope.vm.form.approverList = resp.data.ApproverList;
                }

                $scope.vm.form.isFlowApprover = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.ApprovingBy) && rt.isSameGuid($scope.vm.form.approvalStatus.ApprovingBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;

                $scope.vm.form.isFlowSubmitter = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.SubmittedBy) && rt.isSameGuid($scope.vm.form.approvalStatus.SubmittedBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;
            }).catch(function (resp) {
                rt.errorMessage(resp.data);
            });
        };

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-02-29
 说明     : 日报
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('dailyreportService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'dailyreport';

        // @@ 选项集
        this.picklists = ['StateCode'];

        //获取阅读次数
        this.getReadTimes = function (objectId) {
            var apiUrl = "api/DailyReport/GetReadTimes?objectId=" + objectId;
            return rt.get(apiUrl);
        };

        //更改阅读状态
        this.updateReadState = function (objectId) {
            var url = 'api/WorkReportRead/UpdateReadState?objectId=' + objectId;
            return rt.get(url);
        };

        this.getAttachmentList = function (id) {
            // 如果请求的Id为空，则直接返回承诺，不需要再请求服务器
            if (rt.isNull(id) || id.length === 0) {
                var deferred = $q.defer();
                deferred.resolve({ data: null });
                return deferred.promise;
            }

            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };

        //获取已读人列表
        this.getReaderList = function (objectId) {
            var apiUrl = "api/WorkReportRead/GetReaderList?objectId=" + objectId;
            return rt.get(apiUrl);
        };

        this.GetCurrentWorkContent = function () {
            return rt.get("api/DailyReport/GetCurrentWorkContent");
        };
    }]).controller('dailyreportListController', ['$injector', '$timeout', '$scope', 'dailyreportService', function ($injector, $timeout, $scope, myService) {
        var rt = myService.rt;
        var that = this;
        this.searchList = [];
        this.viewTag = "Web";
        this.preExport = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.startTime) && !rt.isNull($scope.vm.endTime)) {
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [$scope.vm.startTime, moment(new Date($scope.vm.endTime)).add(1, 'days').format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.startTime) && !rt.isNull($scope.vm.endTime)) {
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [$scope.vm.startTime, moment(new Date($scope.vm.endTime)).add(1, 'days').format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        function _init() {
            _getAllBuid();
            _initYmSelected();
        }
        _init();
        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.startTime = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.endTime = moment().format('YYYY-MM-DD');
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = null;
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        $scope.overHeightTable = function () {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        };
    }]).controller('dailyreportEditController', ['$injector', '$compile', '$scope', 'dailyreportService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;
        var $stateParams = myService.$stateParams;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.attachmentList = [];
        $scope.vm.isComment = true;
        $scope.vm.sendstatus = 2;
        var wasSelected = localStorage.getItem("dailyreport_25948a76-18d1-421f-b54d-3936eb0aea88");
        $scope.vm.form.readerList = !rt.isNull(wasSelected) ? JSON.parse(wasSelected) : [];

        $scope.vm.form.deleteReaderList = function (index) {
            $scope.vm.form.readerList.splice(index, 1);
        };

        $scope.vm.form.newSave = function () {
            if (rt.isNullOrEmptyString($scope.vm.form.data.finish_work) && rt.isNullOrEmptyString($scope.vm.form.data.unfinished_work) && rt.isNullOrEmptyString($scope.vm.form.data.coordinate_work)) {
                rt.errorMessage("抱歉，内容至少填写一项");
                return;
            }
            if ($scope.vm.form.readerList.length == 0) {
                rt.errorMessage("请添加发送人！");
                return;
            }
            var waiting = rt.showWaiting();
            $scope.flagBTN = 1;
            $scope.vm.form.data.attachment_count = $scope.vm.form.attachmentList.length;
            localStorage.setItem("dailyreport_25948a76-18d1-421f-b54d-3936eb0aea88", JSON.stringify($scope.vm.form.readerList));

            $scope.vm.form.save(false).then(function () {
                $scope.vm.form.fileSave().then(function () {
                    _getFile();
                });
                $scope.vm.form.readerSubmit();
            });
            waiting.close();
        };

        $scope.vm.form.readerSubmit = function () {
            var reqData = {
                ObjectId: $scope.vm.form.id,
                ObjectTypeName: "daily_report",
                ReaderList: $scope.vm.form.readerList
            };

            var url = 'api/WorkReportRead/ReaderSubmit';
            return rt.post(url, reqData);
        };

        $scope.vm.form.preLoad = function (data) {
            if ($scope.vm.form.type === 'Edit') {
                _getFile();

                myService.getReadTimes($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.times = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });

                myService.getReaderList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.readed = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });

                myService.updateReadState($scope.vm.form.id);

                myService.getCommentListById($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.commentList = data;
                }).error(function (error) {
                    rt.showErrorToast(error);
                });
            } else {
                myService.GetCurrentWorkContent().success(function (data) {
                    $scope.vm.current_work = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }
        };

        //发送评论
        $scope.vm.form.sendComment = function () {
            if (rt.isNullOrEmptyString($scope.vm.sendComment)) {
                rt.errorMessage("请输入文字内容");
                return;
            }

            $scope.vm.isComment = false;
            myService.sendComment({ object_id: $scope.vm.form.id, text: $scope.vm.sendComment }).success(function () {
                try {
                    rt.successMessage("发送成功");
                } catch (e) {}
                $scope.vm.sendComment = "";
                $scope.vm.isComment = true;
                $scope.$emit('rt-reload');
                $scope.$broadcast('rt-reload');
            }).error(function (error) {
                rt.showErrorToast(error);
            });
        };

        $scope.addApprover = function () {
            var params = { moduleName: 'dailyreport', filtered: false };

            var html = '<div rt-include rt-template="OA/ApproveU2/approveU2ListView.html" rt-controller="ApproveU2Controller" rt-include-params=\'' + JSON.stringify(params) + '\'></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        $scope.$on('to-parent', function (event, data) {
            if (rt.isNull($scope.vm.form.readerList) || $scope.vm.form.readerList === '') {
                $scope.vm.form.readerList = data;
            } else {
                $scope.vm.readerLists = $scope.vm.form.readerList;
                for (var i = 0; i < data.length; i++) {
                    var approverExit = true;
                    for (var j = 0; j < $scope.vm.readerLists.length; j++) {
                        if (data[i].OwnerId.Id === $scope.vm.readerLists[j].OwnerId.Id) {
                            approverExit = false;
                        }
                    }
                    if (approverExit) {
                        $scope.vm.form.readerList.push(data[i]);
                    }
                }
            }
        });

        $scope.vm.hideForm = function () {
            $scope.vm.dialog.close();
        };

        /* start 附件相关*/
        function _getFile() {
            if ($scope.vm.form.id != "") {
                myService.getAttachmentList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.attachmentList = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            } else {
                $scope.vm.form.attachmentList = [];
            }
        }

        $scope.selectedFiles = null;
        $scope.selectedFilesArr = [];
        $scope.selectedFileName = null;

        $scope.vm.form.fileSelect = function (files) {
            if (files && files.length && files.length > 0) {
                for (var i = 0; i < files.length; i++) {
                    $scope.selectedFilesArr.push(files[i]);
                }
                $scope.selectedFiles = $scope.selectedFilesArr;

                for (var i = 0; i < files.length; i++) {
                    $scope.vm.form.attachmentList.push({
                        Id: rt.newGuid(),
                        FileName: files[i].name
                    });
                }
            }
        };

        $scope.vm.form.fileSave = function () {
            if (!rt.isEmptyArray($scope.selectedFiles)) {
                return rt.uploadFiles($scope.selectedFiles, "daily_report", $scope.vm.form.data.Id, false, function (data) {
                    $scope.selectedFiles = null;
                    $scope.selectedFilesArr = [];
                    $scope.flagBTN = 0;
                });
            } else {
                var deferred = $q.defer();
                deferred.reject("没有添加附件");
                return deferred.promise;
            }
        };

        $scope.vm.form.deleteFile = function () {
            $scope.selectedFileName = null;

            if ($scope.vm.view.selectedIds.length == 0) {
                rt.errorMessage("至少选择一项要删除的文件！");
                return;
            }

            for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                for (var k = 0; k < $scope.vm.form.attachmentList.length; k++) {
                    if ($scope.vm.form.attachmentList[k].Id === $scope.vm.view.selectedIds[j]) {
                        if ($scope.selectedFiles != null) {
                            for (var i = 0; i < $scope.selectedFiles.length; i++) {
                                if ($scope.selectedFiles[i].name === $scope.vm.form.attachmentList[k].FileName) {
                                    $scope.selectedFiles.splice(i, 1);
                                }
                            }
                        }
                    }
                }
            }

            for (var i = 0; i < $scope.vm.form.attachmentList.length; i++) {
                for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                    if ($scope.vm.form.attachmentList[i].Id === $scope.vm.view.selectedIds[j]) {
                        $scope.vm.form.attachmentList.splice(i, 1);
                    }
                }
            }

            $scope.vm.view.selectedIds = [];
            rt.successMessage("删除成功。");
            //$scope.$emit('rt-reload');
            //$scope.$broadcast('rt-reload');
        };

        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("daily_report", fileId);
        };
        /* end 附件相关*/
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016-03-29
 说明     : 通用申请
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('expenseService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'expense';
        this.approvalTypeName = 'expense';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('expenseListController', ['$injector', '$scope', 'expenseService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        function _getApprovalStatus(id, i) {
            var url2 = 'api/FlowApproval/GetFormApprovalStatus?objectId=' + id;
            rt.get(url2).then(function (resp2) {
                if (!rt.isNull(resp2.data.ApprovalStatus)) {
                    if (resp2.data.ApprovalStatus.approval_result.Value == 1) {
                        $scope.vm.data[i].approvalStatus = '待审批';
                    } else {
                        $scope.vm.data[i].approvalStatus = resp2.data.ApprovalStatus.approval_resultName;
                    }
                }
            }).catch(function (resp2) {
                rt.errorMessage(resp2.data);
            });
        }
        $scope.vm.actions.loadComplete = function () {
            if (!rt.isNull($scope.vm.data)) {
                for (var i = 0; i < $scope.vm.data.length; i++) {
                    _getApprovalStatus($scope.vm.data[i].Id, i);
                }
            }
        };
    }]).controller('expenseEditController', ['$injector', '$scope', 'expenseService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.loadComplete = function () {
            $scope.flag = 0;
            $scope.fjs = [];
            $scope.selectedFiles = null;
            $scope.selectedFilesArr = [];
            $scope.selectedFileName = null;

            if ($scope.vm.form.type === 'Edit') rt.GetFilesByObjectId("expense", $scope.vm.form.data.Id).success(function (data) {
                var data = data.DataList;
                if (data != null) {
                    for (var i = 0; i < data.length; i++) {
                        $scope.fjs.push({ Id: data[i].Id, FileName: data[i].FileName, DownFile: true });
                    }
                }
            }).error(function (message) {
                rt.errorMessage(message);
            });
        };

        $scope.vm.form.postSave = function () {
            if (!rt.isEmptyArray($scope.selectedFiles)) {
                rt.uploadFiles($scope.selectedFiles, "expense", $scope.vm.form.data.Id, false);
                $scope.selectedFiles = null;
            }
        };

        //选择附件
        $scope.vm.form.selectFile = function (files) {
            if (files && files.length && files.length > 0) {
                for (var i = 0; i < files.length; i++) {
                    $scope.selectedFilesArr.push(files[i]);
                }

                $scope.selectedFiles = $scope.selectedFilesArr;
                for (var i = 0; i < files.length; i++) {
                    $scope.fjs.push({ Id: rt.newGuid(), FileName: files[i].name, DownFile: false });
                }
            }
        };

        //删除附件
        $scope.vm.form.deletedFile = function () {
            if ($scope.vm.view.selectedIds.length == 0) {
                rt.errorMessage("请选择附件。");
                return;
            }
            var mmm = rt.deleteFile("expense", $scope.vm.view.selectedIds).error(function (message) {
                rt.errorMessage(message);
            }).success(function (data) {
                $scope.selectedFileName = null;
                for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                    for (var k = 0; k < $scope.fjs.length; k++) {
                        if ($scope.fjs[k].Id === $scope.vm.view.selectedIds[j]) {
                            if ($scope.selectedFiles != null) {
                                for (var i = 0; i < $scope.selectedFiles.length; i++) {
                                    if ($scope.selectedFiles[i].name === $scope.fjs[k].FileName) {
                                        $scope.selectedFiles.splice(i, 1);
                                    }
                                }
                            }
                        }
                    }
                }
                for (var i = 0; i < $scope.fjs.length; i++) {
                    for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                        if ($scope.fjs[i].Id === $scope.vm.view.selectedIds[j]) {
                            $scope.fjs.splice(i, 1);
                        }
                    }
                }

                rt.successMessage("删除成功。");
            });
        };

        $scope.vm.form.preSave = function () {
            if (rt.isNull($scope.vm.form.data.DetailList) || $scope.vm.form.data.DetailList.length === 0) {
                rt.errorMessage("请至少输入一条报销明细！");
                return "请至少输入一条报销明细！";
            }
        };

        $scope.deleteDetail = function ($index) {
            $scope.vm.form.data.total_amount = Number($scope.vm.form.data.total_amount) - Number($scope.vm.form.data.DetailList[$index].amount);
            $scope.vm.form.data.DetailList.splice($index, 1);
            if ($scope.vm.form.data.total_amount == 0) $scope.vm.form.data.total_amount = "";
        };

        $scope.addExpenseDetail = function (detail) {
            if (rt.isNull($scope.vm.form.data.DetailList)) {
                $scope.vm.form.data.DetailList = [];
            }

            if (rt.isNull(detail) || detail === "" || detail.amount === "" || rt.isNull(detail.amount)) {
                rt.errorMessage("请输入报销金额");
                return;
            } else if (isNaN(detail.amount)) {
                rt.errorMessage("报销金额必须为数字");
                detail.amount === "";
                return;
            }

            if (rt.isNull(detail.type)) {
                rt.errorMessage("请输入报销类别");
                return;
            }

            $scope.vm.form.data.DetailList.push({
                amount: detail.amount,
                type: detail.type,
                description: detail.description
            });
            if (rt.isNull($scope.vm.form.data.total_amount)) {
                $scope.vm.form.data.total_amount = 0;
            }
            $scope.vm.form.data.total_amount = Number($scope.vm.form.data.total_amount) + Number(detail.amount);
            $scope.vm.form.data.detail = [];
        };
    }]).controller('expenseReadOnlyController', ['$injector', '$scope', 'expenseService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $state = myService.$state;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.tabIndex = 1;

        //切换Tab
        $scope.chooseTab = function (tabIndex) {
            $scope.vm.tabIndex = tabIndex;
        };

        //重新提交
        $scope.vm.form.reSubmit = function () {
            $state.go("main.expense.edit", { id: $scope.vm.form.data.Id }, { location: true });
        };

        //下载附件
        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("expense", fileId);
        };

        $scope.vm.form.loadComplete = function () {
            //加载附件信息
            rt.GetFilesByObjectId("expense", $scope.vm.form.data.Id).error(function (message) {
                rt.errorMessage(message);
            }).success(function (data) {
                var data = data.DataList;
                if (data != null) {
                    $scope.fjs = [];
                    for (var i = 0; i < data.length; i++) {
                        $scope.fjs.push({ Id: data[i].Id, FileName: data[i].FileName, DownFile: true });
                    }
                }
            });

            //加载审批流信息
            myService.getApprovalStatus($scope.vm.form.data.Id).then(function (resp) {
                if (!rt.isNull(resp.data)) {
                    $scope.vm.form.approvalStatus = resp.data.ApprovalStatus;
                    $scope.vm.form.approverList = resp.data.ApproverList;
                }

                $scope.vm.form.isFlowApprover = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.ApprovingBy) && rt.isSameGuid($scope.vm.form.approvalStatus.ApprovingBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;

                $scope.vm.form.isFlowSubmitter = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.SubmittedBy) && rt.isSameGuid($scope.vm.form.approvalStatus.SubmittedBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;
            }).catch(function (resp) {
                rt.errorMessage(resp.data);
            });
        };

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/4/8
 说明     : 审批列表
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('flowapprovalService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'FlowApproval';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getViewDataStatus = function (viewId, quickSearch, searchList, orderBy, pageSize, pageIndex) {
            var url = 'api/FlowApproval/GetViewDataSubmitted' + '?viewId=' + viewId + '&quickSearch=' + encodeURIComponent(quickSearch) + "&searchList=" + (rt.isNull(searchList) ? "" : encodeURIComponent(JSON.stringify(searchList))) + '&orderBy=' + orderBy + '&pageSize=' + pageSize + '&pageIndex=' + pageIndex;

            return rt.get(url);
        };
    }]).controller('flowapprovalListController', ['$injector', '$scope', 'flowapprovalService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;

        if (rt.isNull(myService.oldGetViewData)) {
            myService.oldGetViewData = myService.getViewData;
        }

        this.reload = function () {
            if ($scope.vm.view.selectedView.Id == "4131E7C2-5CBD-466C-A84B-CFB02590BE32") {
                myService.getViewData = myService.getViewDataStatus;
            } else {
                myService.getViewData = myService.oldGetViewData;
            }

            var view = $scope.vm.view.selectedView;
            if (rt.isNull(view) || rt.isNull(view.Id)) {
                return;
            }

            // 默认视图
            if ($scope.vm.view.type == 'default') {
                myService.getViewData(view.Id, $scope.vm.view.searchText, $scope.vm.view.searchList, $scope.vm.view.sortField, $scope.vm.page.size, $scope.vm.page.index).then(function (resp) {
                    $scope.vm.data = resp.data.DataList;
                    $scope.vm.page.recordCount = resp.data.TotalRecords;
                });
            }

            // 关联视图
            if ($scope.vm.view.type == 'grid') {
                var relatedAttr = $scope.rtIncludeParams.relatedAttr;
                var relatedAttrValue = $scope.$parent.vm.form.id;
                myService.getViewData(view.Id, $scope.vm.view.searchText, [{ Key: relatedAttr, Value: relatedAttrValue, Type: 1 }], $scope.vm.view.sortField, $scope.vm.page.size, $scope.vm.page.index).then(function (resp) {
                    $scope.vm.data = resp.data.DataList;
                    $scope.vm.page.recordCount = resp.data.TotalRecords;
                });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.filterFlowAppropval = function () {
            $scope.vm.view.queryValue = $("input[name='object_type_name']:checked").val();
            if ($scope.vm.view.queryValue != "") {
                $scope.vm.view.searchList = [{ Type: 1, Key: "object_type_name", Value: $scope.vm.view.queryValue }];
            } else {
                $scope.vm.view.searchList = [];
            }
            $scope.vm.view.search();
        };
    }]);
    //.controller('flowapprovalEditController', ['$injector','$scope', 'flowapprovalService', function ($injector, $scope, myService) {
    //    var rt = myService.rt;
    //    var $q = myService.$q;
    //    $injector.invoke(entityEditController, this, {
    //        $scope: $scope,
    //        myService: myService
    //    });
    //}]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : oscar
 创建时间 : 2018/2/2
 说明     : 通用审批流程设置
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('flowapprovalcommonService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'FlowApprovalCommon';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.formsave = function (formdata) {
            var url = "api/FlowApprovalCommon/SaveData";
            return rt.post(url, formdata);
        };

        this.GetFlowStepData = function (id) {
            var url = "api/FlowApprovalCommon/GetFlowStepData?id=" + id;
            return rt.get(url);
        };
    }]).controller('flowapprovalcommonListController', ['$injector', '$scope', 'flowapprovalcommonService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('flowapprovalcommonEditController', ['$injector', '$scope', '$compile', '$stateParams', 'flowapprovalcommonService', function ($injector, $scope, $compile, $stateParams, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        var id = $scope.vm.form.id ? $scope.vm.form.id : $stateParams.id;
        //添加审核步骤
        $scope.vm.addFlowStep = function (data) {
            var dataStr = '';
            if (rt.isNull(data)) {
                dataStr = '';
            } else {
                dataStr = JSON.stringify(data);
            }
            var html = '<div rt-include rt-template="OA/FlowApprovalCommon/addFlowStepView.html" rt-controller="addFlowStepController" rt-include-params=' + dataStr + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '设置审批人',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        $scope.vm.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.vm.flowsteps = []; //所有流程节点
        $scope.$on('to-parent', function (event, data) {
            var step_seq = data.step_seq;
            if (rt.isNull(step_seq)) {
                //新增
                if (rt.isNull($scope.vm.flowsteps) || $scope.vm.flowsteps.length == 0) {
                    data.step_seq = 10;
                } else {
                    data.step_seq = $scope.vm.flowsteps.length * 10 + 10;
                }
                data.flowid = id;
                data.name = _getFlowStepName(data);
                $scope.vm.flowsteps.push(data);
            } else {
                //编辑
                _.forEach($scope.vm.flowsteps, function (n, i) {
                    if (n.step_seq == step_seq) {
                        $scope.vm.flowsteps[i] = data;
                        $scope.vm.flowsteps[i].flowid = id;
                        $scope.vm.flowsteps[i].name = _getFlowStepName(data);
                    }
                });
            }
        });

        //生成节点名称
        function _getFlowStepName(flowstep) {
            var name = "";
            switch (flowstep.approver_type.Value) {
                case "10":
                    if (flowstep.step_approval_mode.Value == "10") {
                        name = flowstep.manager_level.Name;
                    } else if (flowstep.step_approval_mode.Value == "20") {
                        name = flowstep.manager_level.Name + "(会签)";
                    } else {
                        name = flowstep.manager_level.Name + "(或签)";
                    }
                    break;
                case "20":
                    name = "从直接主管到发起人向上的";
                    if (flowstep.manager_level.Value == "10") {
                        name += "第一级主管";
                    } else {
                        name += flowstep.manager_level.Name;
                    }
                    break;
                case "30":
                    name = "指定成员" + flowstep.approval_users.length + "人";
                    if (flowstep.step_approval_mode.Value == "20") {
                        name += "(会签)";
                    } else {
                        name += "(或签)";
                    }
                    break;
                case "40":
                    name = flowstep.approval_roleid.Name;
                    if (flowstep.step_approval_mode.Value == "20") {
                        name += "(会签)";
                    } else if (flowstep.step_approval_mode.Value == "30") {
                        name += "(或签)";
                    }
                    break;
                case "50":
                    name = "发起人";
                    break;
            }
            return name;
        }

        //删除流程节点
        $scope.vm.delFlowStep = function (index) {
            $scope.vm.flowsteps.splice(index, 1); //删除元素
            //重新计算元素step_seq
            _.forEach($scope.vm.flowsteps, function (n, i) {
                n.step_seq = (i + 1) * 10;
            });
        };

        //编辑节点
        $scope.vm.editFlowStep = function (index) {
            $scope.vm.addFlowStep($scope.vm.flowsteps[index]);
        };

        //重写保存方法，保存审批流程步骤
        $scope.vm.form.save = function (nextStep) {
            if (rt.isNullOrEmptyString($scope.vm.form.data.name)) {
                rt.errorMessage("请输入审批流程名称");
                return "请输入审批流程名称";
            }
            if (rt.isNull($scope.vm.form.data.tblentityid)) {
                rt.errorMessage("请输入关联实体");
                return "请输入关联实体";
            }
            var waiting = rt.showWaiting();
            $scope.vm.formdata = {};
            $scope.vm.formdata.flowModel = $scope.vm.form.data;
            if (rt.isNull($scope.vm.form.data.Id)) {
                $scope.vm.formdata.flowModel.id = rt.newGuid();
            }
            $scope.vm.formdata.flowStepModels = $scope.vm.flowsteps;
            myService.formsave($scope.vm.formdata).then(function (resp) {
                waiting.close();
                if (!nextStep) {
                    $scope.vm.form.id = resp.data;
                } else {
                    $scope.vm.form.id = "";
                }
                // 刷新数据
                $scope.$emit('rt-reload');
                $scope.$broadcast('rt-reload');
            }, function () {
                waiting.close();
            }).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        $scope.vm.form.loadComplete = function () {
            var id = $scope.vm.form.id;
            myService.GetFlowStepData(id).then(function (resp) {
                $scope.vm.flowsteps = resp.data;
            }).catch(function (error) {
                rt.showErrorToast(error);
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lecrean Pan
 创建时间 : 2018/1/30
 说明     : 审批角色 服务
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('flowRoleService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'FlowRole';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('flowRoleListController', ['$injector', '$scope', 'flowRoleService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('flowRoleEditController', ['$injector', '$scope', 'flowRoleService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lecrean Pan
 创建时间 : 2018/2/1
 说明     : 审批角色人员 服务
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('flowRoleUserService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'FlowRoleUser';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('flowRoleUserListController', ['$injector', '$scope', 'flowRoleUserService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('flowRoleUserEditController', ['$injector', '$scope', 'flowRoleUserService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : BerryDing
 创建时间 : 2018-03-14
 说明     : 审批提交-Service
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('flowUserService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        this.GetFlowApproverList = function (objectId, entityName, conditionField) {
            var apiUrl = "api/FlowApprovalCommon/GetFlowApproverList?objectId=" + objectId + "&entityName=" + entityName;
            return rt.post(apiUrl, conditionField);
        };
    }]).controller('flowUserListController', ['$scope', '$injector', 'flowUserService', function ($scope, $injector, myService) {
        var rt = myService.rt;
        var $compile = myService.$compile;

        _init();

        function _init() {
            if (rt.isNullOrEmptyString($scope.rtIncludeParams.approvalTypeName)) {
                rt.errorMessage("审批单关联的实体名称不能为空。");
                return;
            }
            $scope.vm = {};

            myService.GetFlowApproverList($scope.rtIncludeParams.objectId, $scope.rtIncludeParams.approvalTypeName, rt.isNull($scope.rtIncludeParams.conditionField) ? [] : $scope.rtIncludeParams.conditionField).then(function (resp) {
                $scope.approverList = resp.data.flowApprovalList;
                $scope.not_allow_choose_user = resp.data.not_allow_choose_user;
                $scope.include_role_type = resp.data.include_role_type;
            }).catch(function (error) {
                rt.errorMessage(error);
            });
        }

        //确认提交
        $scope.okClick = function () {
            if ($scope.approverList.length === 0) {
                rt.errorMessage("审批人不能为空。");
                return;
            }
            $scope.$parent.vm.form.approverList = $scope.approverList;
            $scope.closeDialog();
            $scope.$emit('rt-flow-ok-click');
        };

        //计算头像背景颜色
        $scope.getAvatarColor = function (index) {
            var i = index % 4;
            var color = _avatarColors[i];
            return {
                'background-color': color
            };
        };

        //头像背景颜色数组
        var _avatarColors = ["#2ec7c9", "#feb358", "#33bc98", "#b6a2de"];

        //删除审批人
        $scope.delApprover = function (index) {
            if ($scope.approverList[index].not_allow_modified) {
                rt.errorMessage("该审批人不能删除！");
                return;
            }

            //当前审批人列表中有【角色】步骤，则要检查至少选择一个人
            if ($scope.include_role_type) {
                var count = 0;
                _.forEach($scope.approverList, function (u) {
                    if (u.not_allow_modified === false) count++;
                });

                if (count == 1) {
                    rt.errorMessage("该审批人不能删除，角色成员至少保留一位。");
                    return;
                }
            }
            $scope.approverList.splice(index, 1);
        };

        //添加审批人
        $scope.addApprover = function () {
            var html = '<div rt-include rt-template="OA/ApproveU/approveUListView.html" rt-controller="ApproveUController" rt-include-params=' + "" + '></div>';
            $scope.approverDialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //关闭窗口
        $scope.closeDialog = function () {
            $scope.$parent.vm.flowUserDialog.close();
            delete $scope.$parent.vm.flowUserDialog;
        };

        $scope.$on('to-parent', function (event, data) {
            for (var i = 0; i < data.length; i++) {
                //重复性检查
                var existsIndex = _.findIndex($scope.approverList, function (a) {
                    return a.OwnerId.Id == data[i].OwnerId.Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("审批人已存在，请勿重复添加。");
                } else {
                    $scope.approverList.push(data[i]);
                }
            }
        });

        $scope.vm.hideForm = function () {
            $scope.approverDialog.close();
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-03-01
 说明     : 月报
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('monthlyreportService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'monthlyreport';

        // @@ 选项集
        this.picklists = ['StateCode'];

        //获取阅读次数
        this.getReadTimes = function (objectId) {
            var apiUrl = "api/MonthlyReport/GetReadTimes?objectId=" + objectId;
            return rt.get(apiUrl);
        };

        //更改阅读状态
        this.updateReadState = function (objectId) {
            var url = 'api/WorkReportRead/UpdateReadState?objectId=' + objectId;
            return rt.get(url);
        };

        this.getAttachmentList = function (id) {
            // 如果请求的Id为空，则直接返回承诺，不需要再请求服务器
            if (rt.isNull(id) || id.length === 0) {
                var deferred = $q.defer();
                deferred.resolve({ data: null });
                return deferred.promise;
            }

            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };

        //获取已读人列表
        this.getReaderList = function (objectId) {
            var apiUrl = "api/WorkReportRead/GetReaderList?objectId=" + objectId;
            return rt.get(apiUrl);
        };
        this.GetCurrentWorkContent = function () {
            return rt.get("api/MonthlyReport/GetCurrentWorkContent");
        };
    }]).controller('monthlyreportListController', ['$injector', '$timeout', '$scope', 'monthlyreportService', function ($injector, $timeout, $scope, myService) {
        var rt = myService.rt;
        var that = this;
        this.searchList = [];
        this.viewTag = "Web";
        this.preExport = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.startTime) && !rt.isNull($scope.vm.endTime)) {
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [$scope.vm.startTime, moment(new Date($scope.vm.endTime)).add(1, 'days').format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.startTime) && !rt.isNull($scope.vm.endTime)) {
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [$scope.vm.startTime, moment(new Date($scope.vm.endTime)).add(1, 'days').format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        function _init() {
            _getAllBuid();
            _initYmSelected();
        }
        _init();
        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.startTime = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.endTime = moment().format('YYYY-MM-DD');
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = null;
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        $scope.overHeightTable = function () {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        };
    }]).controller('monthlyreportEditController', ['$injector', '$compile', '$scope', 'monthlyreportService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;
        var $stateParams = myService.$stateParams;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.attachmentList = [];
        $scope.vm.isComment = true;
        $scope.vm.search = _search;
        var wasSelected = localStorage.getItem("monthlyreport_25948a76-18d1-421f-b54d-3936eb0aea88");
        $scope.vm.form.readerList = !rt.isNull(wasSelected) ? JSON.parse(wasSelected) : [];

        $scope.vm.form.deleteReaderList = function (index) {
            $scope.vm.form.readerList.splice(index, 1);
        };

        $scope.vm.form.newSave = function () {
            if (rt.isNullOrEmptyString($scope.vm.form.data.finish_work) && rt.isNullOrEmptyString($scope.vm.form.data.summary) && rt.isNullOrEmptyString($scope.vm.form.data.schedule) && rt.isNullOrEmptyString($scope.vm.form.data.coordinate_work)) {
                rt.errorMessage("抱歉，内容至少填写一项");
                return;
            }
            if ($scope.vm.form.readerList.length == 0) {
                rt.errorMessage("请添加发送人！");
                return;
            }
            var waiting = rt.showWaiting();
            $scope.flagBTN = 1;
            $scope.vm.form.data.attachment_count = $scope.vm.form.attachmentList.length;
            localStorage.setItem("monthlyreport_25948a76-18d1-421f-b54d-3936eb0aea88", JSON.stringify($scope.vm.form.readerList));

            $scope.vm.form.save(false).then(function () {
                $scope.vm.form.fileSave().then(function () {
                    _getFile();
                });
                $scope.vm.form.readerSubmit();
            });
            waiting.close();
        };

        $scope.vm.form.readerSubmit = function () {
            var reqData = {
                ObjectId: $scope.vm.form.id,
                ObjectTypeName: "monthly_report",
                ReaderList: $scope.vm.form.readerList
            };

            var url = 'api/WorkReportRead/ReaderSubmit';
            return rt.post(url, reqData);
        };

        function _loadData() {
            $scope.vm.text = "";
            var apiUrl = "api/Course/GetComment?courseId=" + $scope.vm.form.id;
            rt.get(apiUrl).then(function (resp) {
                var data = resp.data[0];
                if (data) {
                    $scope.vm.score = data.score_value;
                    if (data.text) {
                        $scope.vm.text = data.text;
                    } else {
                        $scope.vm.text = "";
                    }
                }
            });
        }

        //评分
        $scope.vm.StarClick1 = function (index) {
            $scope.vm.score = 2 * index;
        };

        $scope.vm.form.preLoad = function (data) {
            if ($scope.vm.form.type === 'Edit') {
                _getFile();

                myService.getReadTimes($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.times = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });

                myService.getReaderList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.readed = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });

                myService.updateReadState($scope.vm.form.id);

                $scope.vm.pageIndex = 1;
                $scope.vm.pageSize = rt.getPaginationSize();
                _search();
                _loadData();
            } else {
                myService.GetCurrentWorkContent().success(function (data) {
                    $scope.vm.current_work = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }
        };

        function _search() {
            var waiting = rt.showLoading2();
            var url = 'api/Course/GetCommentList?courseId=' + $scope.vm.form.id + "&pageSize=" + $scope.vm.pageSize + "&pageIndex=" + $scope.vm.pageIndex;
            rt.get(url).then(function (resp) {
                $scope.vm.form.commentList = resp.data.DataList;
                $scope.vm.form.recordCount = resp.data.TotalRecords;
                waiting.close();
            }, function () {
                waiting.close();
            });
        };

        //评论
        $scope.vm.commentClick = function () {
            if (!$scope.vm.score) {
                rt.errorMessage("你还没有打分哦。");
                return;
            }
            if (rt.isNullOrEmptyString($scope.vm.text)) {
                rt.errorMessage("请输入文字内容");
                return;
            }
            $scope.vm.isComment = false;

            rt.post("api/Course/CreateComment", { courseId: $scope.vm.form.id, score: $scope.vm.score, text: $scope.vm.text }).then(function () {
                $scope.vm.isComment = true;
                $scope.$emit('rt-reload');
                $scope.$broadcast('rt-reload');
            });
        };

        //发送评论显示
        $scope.vm.form.sendshow = function (statusvalue) {
            $scope.vm.sendstatus = statusvalue;
        };

        $scope.addApprover = function () {
            var params = { moduleName: 'monthlyreport', filtered: false };

            var html = '<div rt-include rt-template="OA/ApproveU2/approveU2ListView.html" rt-controller="ApproveU2Controller" rt-include-params=\'' + JSON.stringify(params) + '\'></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        $scope.$on('to-parent', function (event, data) {
            if (rt.isNull($scope.vm.form.readerList) || $scope.vm.form.readerList === '') {
                $scope.vm.form.readerList = data;
            } else {
                $scope.vm.readerLists = $scope.vm.form.readerList;
                for (var i = 0; i < data.length; i++) {
                    var approverExit = true;
                    for (var j = 0; j < $scope.vm.readerLists.length; j++) {
                        if (data[i].OwnerId.Id === $scope.vm.readerLists[j].OwnerId.Id) {
                            approverExit = false;
                        }
                    }
                    if (approverExit) {
                        $scope.vm.form.readerList.push(data[i]);
                    }
                }
            }
        });

        $scope.vm.hideForm = function () {
            $scope.vm.dialog.close();
        };

        /* start 附件相关*/
        function _getFile() {
            if ($scope.vm.form.id != "") {
                myService.getAttachmentList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.attachmentList = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            } else {
                $scope.vm.form.attachmentList = [];
            }
        }

        $scope.selectedFiles = null;
        $scope.selectedFilesArr = [];
        $scope.selectedFileName = null;

        $scope.vm.form.fileSelect = function (files) {
            if (files && files.length && files.length > 0) {
                for (var i = 0; i < files.length; i++) {
                    $scope.selectedFilesArr.push(files[i]);
                }
                $scope.selectedFiles = $scope.selectedFilesArr;

                for (var i = 0; i < files.length; i++) {
                    $scope.vm.form.attachmentList.push({
                        Id: rt.newGuid(),
                        FileName: files[i].name
                    });
                }
            }
        };

        $scope.vm.form.fileSave = function () {
            if (!rt.isEmptyArray($scope.selectedFiles)) {
                return rt.uploadFiles($scope.selectedFiles, "monthly_report", $scope.vm.form.data.Id, false, function (data) {
                    $scope.selectedFiles = null;
                    $scope.selectedFilesArr = [];
                    $scope.flagBTN = 0;
                });
            } else {
                var deferred = $q.defer();
                deferred.reject("没有添加附件");
                return deferred.promise;
            }
        };

        $scope.vm.form.deleteFile = function () {
            $scope.selectedFileName = null;

            if ($scope.vm.view.selectedIds.length == 0) {
                rt.errorMessage("至少选择一项要删除的文件！");
                return;
            }

            for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                for (var k = 0; k < $scope.vm.form.attachmentList.length; k++) {
                    if ($scope.vm.form.attachmentList[k].Id === $scope.vm.view.selectedIds[j]) {
                        if ($scope.selectedFiles != null) {
                            for (var i = 0; i < $scope.selectedFiles.length; i++) {
                                if ($scope.selectedFiles[i].name === $scope.vm.form.attachmentList[k].FileName) {
                                    $scope.selectedFiles.splice(i, 1);
                                }
                            }
                        }
                    }
                }
            }

            for (var i = 0; i < $scope.vm.form.attachmentList.length; i++) {
                for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                    if ($scope.vm.form.attachmentList[i].Id === $scope.vm.view.selectedIds[j]) {
                        $scope.vm.form.attachmentList.splice(i, 1);
                    }
                }
            }

            $scope.vm.view.selectedIds = [];
            rt.successMessage("删除成功。");
            //$scope.$emit('rt-reload');
            //$scope.$broadcast('rt-reload');
        };

        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("monthly_report", fileId);
        };
        /* end 附件相关*/
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Kevin Zhou
 创建时间 : 2016-04-08
 说明     : 考勤管理服务
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('officeattendanceService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'officeattendance';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('officeattendanceController', ['$injector', '$compile', '$timeout', '$scope', 'officeattendanceService', function ($injector, $compile, $timeout, $scope, myService) {
        var rt = myService.rt;

        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.startDate) && !rt.isNull($scope.vm.endDate)) {
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [$scope.vm.startDate, moment(new Date($scope.vm.endDate)).add(1, 'days').format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.startDate) && !rt.isNull($scope.vm.endDate)) {
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [$scope.vm.startDate, moment(new Date($scope.vm.endDate)).add(1, 'days').format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
        };

        this.viewTag = "Web";
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        _initYmSelected();
        _getAllBuid();

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.startDate = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.endDate = moment().format('YYYY-MM-DD');
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = null;
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        $scope.overHeightTable = function () {
            overHeightTable();
        };
        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }

        //图片浏览

        $scope.vm.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
        //     $scope.vm.showImage = function (obiectId) {
        //         var relatedHtml = '';
        //         var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
        //         $scope.vm.dialog = BootstrapDialog.show({
        //             title: '',
        //             type: BootstrapDialog.TYPE_DEFAULT,
        //             message: html,
        //             size: BootstrapDialog.SIZE_WIDE,
        //             onshow: function (dialog) {
        //                 dialog.getModalHeader().hide();
        //                 dialog.getModalFooter().hide();
        //                 var obj = dialog.getModalBody().contents();
        //                 $compile(obj)($scope);
        //             }
        //         });
        //     };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-02-26
 说明     : 任务
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('taskService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'Xcrmtask';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('taskListController', ['$scope', 'taskService', entityListController]).controller('taskEditController', ['$injector', '$scope', '$stateParams', 'taskService', function ($injector, $scope, $stateParams, myService) {
        var rt = myService.rt;
        var $compile = myService.$compile;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.fjs = [];
        _getdfile();

        function _getdfile() {
            if ($scope.vm.form.id != "") {
                rt.GetFilesByObjectId("task", $scope.vm.form.id).error(function (message) {
                    rt.errorMessage(message);
                }).success(function (data) {
                    var data = data.DataList;
                    if (data != null) {
                        $scope.fjs = [];
                        for (var i = 0; i < data.length; i++) {
                            $scope.fjs.push({ Id: data[i].Id, FileName: data[i].FileName, DownFile: true });
                        }
                    }
                });
            }
        }

        $scope.vm.form.loadComplete = function () {
            $scope.vm.OwnerId = $scope.vm.form.data.OwnerId;
        };

        $scope.vm.form.filesave = function (taskid) {
            if (!rt.isEmptyArray($scope.selectedFiles)) {
                var num = rt.uploadFiles($scope.selectedFiles, "task", taskid, false, function (data) {
                    //_getdfile();
                });
                //$scope.selectedFiles = null;
            }
        };
        $scope.selectedFiles = null;
        $scope.selectedFilesArr = [];
        $scope.selectedFileName = null;
        $scope.vm.form.fileselect = function (files) {
            if (files && files.length && files.length > 0) {
                for (var i = 0; i < files.length; i++) {
                    $scope.selectedFilesArr.push(files[i]);
                }
                $scope.selectedFiles = $scope.selectedFilesArr;
                for (var i = 0; i < files.length; i++) {
                    $scope.fjs.push({ Id: rt.newGuid(), FileName: files[i].name, DownFile: false });
                }
            }
        };
        $scope.vm.form.downloadfile = function (fileId) {
            rt.downloadFile("task", fileId);
        };
        $scope.vm.form.deletedfile = function () {
            if ($scope.vm.view.selectedIds.length == 0) {
                rt.errorMessage("请选择附件。");
                return;
            }
            var mmm = rt.deleteFile("task", $scope.vm.view.selectedIds).error(function (message) {
                rt.errorMessage(message);
            }).success(function (data) {
                $scope.selectedFileName = null;
                for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                    for (var k = 0; k < $scope.fjs.length; k++) {
                        if ($scope.fjs[k].Id === $scope.vm.view.selectedIds[j]) {
                            if ($scope.selectedFiles != null) {
                                for (var i = 0; i < $scope.selectedFiles.length; i++) {
                                    if ($scope.selectedFiles[i].name === $scope.fjs[k].FileName) {
                                        $scope.selectedFiles.splice(i, 1);
                                    }
                                }
                            }
                        }
                    }
                }
                for (var i = 0; i < $scope.fjs.length; i++) {
                    for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                        if ($scope.fjs[i].Id === $scope.vm.view.selectedIds[j]) {
                            $scope.fjs.splice(i, 1);
                        }
                    }
                }
                rt.successMessage("删除成功。");
            });
        };

        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.form.data.name)) {
                return "请选择填写待办任务标题.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.form.data.description)) {
                return "请填写任务详情.";
            }
            if (rt.isNull($scope.vm.form.data.scheduled_end)) {
                return "请填写截止时间.";
            }
            if (moment($scope.vm.form.data.scheduled_end).toDate() < moment().toDate()) {
                return "截止时间不能小于当前时间";
            }
            if (rt.isNull($scope.vm.OwnerId)) {
                return "负责人不能为空";
            }
            return "";
        }

        $scope.vm.form.newsave = function (flag) {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var waiting = rt.showWaiting();
            if ($scope.vm.form.type === 'Create') {
                var ss = JSON.stringify($scope.vm.OwnerId);
                var url = 'api/Xcrmtask/CreateTaskData?owners=' + JSON.stringify($scope.vm.OwnerId);
                return rt.post(url, $scope.vm.form.data).then(function (resp) {
                    var ids = resp.data;
                    var taskids = ids.split(","); //字符分割 
                    for (var i = 0; i < taskids.length; i++) {
                        $scope.vm.form.filesave(taskids[i]);
                    }

                    waiting.close();
                    $scope.$emit('rt-on-dialog-close-click');
                });
            } else {
                $scope.vm.form.save(false).then(function () {
                    $scope.vm.form.filesave($scope.vm.form.id);
                });
                waiting.close();
            };
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-03-01
 说明     : 周报
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('weeklyreportService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'weeklyreport';

        // @@ 选项集
        this.picklists = ['StateCode'];

        //获取阅读次数
        this.getReadTimes = function (objectId) {
            var apiUrl = "api/WeeklyReport/GetReadTimes?objectId=" + objectId;
            return rt.get(apiUrl);
        };

        //更改阅读状态
        this.updateReadState = function (objectId) {
            var url = 'api/WorkReportRead/UpdateReadState?objectId=' + objectId;
            return rt.get(url);
        };

        this.getAttachmentList = function (id) {
            // 如果请求的Id为空，则直接返回承诺，不需要再请求服务器
            if (rt.isNull(id) || id.length === 0) {
                var deferred = $q.defer();
                deferred.resolve({ data: null });
                return deferred.promise;
            }

            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };

        //获取已读人列表
        this.getReaderList = function (objectId) {
            var apiUrl = "api/WorkReportRead/GetReaderList?objectId=" + objectId;
            return rt.get(apiUrl);
        };
        this.GetCurrentWorkContent = function () {
            return rt.get("api/WeeklyReport/GetCurrentWorkContent");
        };
        //获取当前是年度第几周
        this.GetWeekOfYear = function () {
            return rt.get("api/WeeklyReport/GetWeekOfYear");
        };
    }]).controller('weeklyreportListController', ['$injector', '$timeout', '$scope', 'weeklyreportService', function ($injector, $timeout, $scope, myService) {
        var rt = myService.rt;
        var that = this;
        this.searchList = [];
        this.viewTag = "Web";
        this.preExport = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.startTime) && !rt.isNull($scope.vm.endTime)) {
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [$scope.vm.startTime, moment(new Date($scope.vm.endTime)).add(1, 'days').format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.startTime) && !rt.isNull($scope.vm.endTime)) {
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [$scope.vm.startTime, moment(new Date($scope.vm.endTime)).add(1, 'days').format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        function _init() {
            _getAllBuid();
            _initYmSelected();
        }
        _init();
        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.startTime = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.endTime = moment().format('YYYY-MM-DD');
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = null;
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        $scope.overHeightTable = function () {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        };
    }]).controller('weeklyreportEditController', ['$injector', '$compile', '$scope', 'weeklyreportService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;
        var $stateParams = myService.$stateParams;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.attachmentList = [];
        $scope.vm.isComment = true;
        $scope.vm.search = _search;
        var wasSelected = localStorage.getItem("weeklyreport_25948a76-18d1-421f-b54d-3936eb0aea88");
        $scope.vm.form.readerList = !rt.isNull(wasSelected) ? JSON.parse(wasSelected) : [];

        $scope.vm.form.deleteReaderList = function (index) {
            $scope.vm.form.readerList.splice(index, 1);
        };

        $scope.vm.form.newSave = function () {
            if (rt.isNullOrEmptyString($scope.vm.form.data.finish_work) && rt.isNullOrEmptyString($scope.vm.form.data.summary) && rt.isNullOrEmptyString($scope.vm.form.data.schedule) && rt.isNullOrEmptyString($scope.vm.form.data.coordinate_work)) {
                rt.errorMessage("抱歉，内容至少填写一项");
                return;
            }
            if ($scope.vm.form.readerList.length == 0) {
                rt.errorMessage("请添加发送人！");
                return;
            }
            var waiting = rt.showWaiting();
            $scope.flagBTN = 1;
            $scope.vm.form.data.attachment_count = $scope.vm.form.attachmentList.length;
            $scope.vm.form.data.weeknum = $scope.vm.currentweeknum;
            localStorage.setItem("weeklyreport_25948a76-18d1-421f-b54d-3936eb0aea88", JSON.stringify($scope.vm.form.readerList));

            $scope.vm.form.save(false).then(function () {
                $scope.vm.form.fileSave().then(function () {
                    _getFile();
                });
                $scope.vm.form.readerSubmit();
            });
            waiting.close();
        };

        $scope.vm.form.readerSubmit = function () {
            var reqData = {
                ObjectId: $scope.vm.form.id,
                ObjectTypeName: "weekly_report",
                ReaderList: $scope.vm.form.readerList
            };

            var url = 'api/WorkReportRead/ReaderSubmit';
            return rt.post(url, reqData);
        };

        function _loadData() {
            $scope.vm.text = "";
            var apiUrl = "api/Course/GetComment?courseId=" + $scope.vm.form.id;
            rt.get(apiUrl).then(function (resp) {
                var data = resp.data[0];
                if (data) {
                    $scope.vm.score = data.score_value;
                    if (data.text) {
                        $scope.vm.text = data.text;
                    } else {
                        $scope.vm.text = "";
                    }
                }
            });
        }

        //评分
        $scope.vm.StarClick1 = function (index) {
            $scope.vm.score = 2 * index;
        };

        $scope.vm.form.preLoad = function (data) {
            if ($scope.vm.form.type === 'Edit') {
                _getFile();

                myService.getReadTimes($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.times = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });

                myService.getReaderList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.readed = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });

                myService.updateReadState($scope.vm.form.id);

                //获取所有评论
                // myService.getCommentListById($scope.vm.form.id)
                //     .success(function (data) {
                //         $scope.vm.form.commentList = data;
                //     })
                //     .error(function (error) {
                //         rt.showErrorToast(error);
                //     });
                $scope.vm.pageIndex = 1;
                $scope.vm.pageSize = rt.getPaginationSize();
                _search();
                _loadData();
            } else {
                myService.GetCurrentWorkContent().success(function (data) {
                    $scope.vm.current_work = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
                myService.GetWeekOfYear().success(function (data) {
                    $scope.vm.currentweeknum = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }
        };

        function _search() {
            var waiting = rt.showLoading2();
            var url = 'api/Course/GetCommentList?courseId=' + $scope.vm.form.id + "&pageSize=" + $scope.vm.pageSize + "&pageIndex=" + $scope.vm.pageIndex;
            rt.get(url).then(function (resp) {
                $scope.vm.form.commentList = resp.data.DataList;
                $scope.vm.form.recordCount = resp.data.TotalRecords;
                waiting.close();
            }, function () {
                waiting.close();
            });
        };

        $scope.vm.commentClick = function () {
            if (!$scope.vm.score) {
                rt.errorMessage("你还没有打分哦。");
                return;
            }
            if (rt.isNullOrEmptyString($scope.vm.text)) {
                rt.errorMessage("请输入文字内容");
                return;
            }
            $scope.vm.isComment = false;

            rt.post("api/Course/CreateComment", { courseId: $scope.vm.form.id, score: $scope.vm.score, text: $scope.vm.text }).then(function () {
                $scope.vm.isComment = true;
                $scope.$emit('rt-reload');
                $scope.$broadcast('rt-reload');
            });
        };

        $scope.addApprover = function () {
            var params = { moduleName: 'weeklyreport', filtered: false };

            var html = '<div rt-include rt-template="OA/ApproveU2/approveU2ListView.html" rt-controller="ApproveU2Controller" rt-include-params=\'' + JSON.stringify(params) + '\'></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        $scope.$on('to-parent', function (event, data) {
            if (rt.isNull($scope.vm.form.readerList) || $scope.vm.form.readerList === '') {
                $scope.vm.form.readerList = data;
            } else {
                $scope.vm.readerLists = $scope.vm.form.readerList;
                for (var i = 0; i < data.length; i++) {
                    var approverExit = true;
                    for (var j = 0; j < $scope.vm.readerLists.length; j++) {
                        if (data[i].OwnerId.Id === $scope.vm.readerLists[j].OwnerId.Id) {
                            approverExit = false;
                        }
                    }
                    if (approverExit) {
                        $scope.vm.form.readerList.push(data[i]);
                    }
                }
            }
        });

        $scope.vm.hideForm = function () {
            $scope.vm.dialog.close();
        };

        /* start 附件相关*/
        function _getFile() {
            if ($scope.vm.form.id != "") {
                myService.getAttachmentList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.attachmentList = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            } else {
                $scope.vm.form.attachmentList = [];
            }
        }

        $scope.selectedFiles = null;
        $scope.selectedFilesArr = [];
        $scope.selectedFileName = null;

        $scope.vm.form.fileSelect = function (files) {
            if (files && files.length && files.length > 0) {
                for (var i = 0; i < files.length; i++) {
                    $scope.selectedFilesArr.push(files[i]);
                }
                $scope.selectedFiles = $scope.selectedFilesArr;

                for (var i = 0; i < files.length; i++) {
                    $scope.vm.form.attachmentList.push({
                        Id: rt.newGuid(),
                        FileName: files[i].name
                    });
                }
            }
        };

        $scope.vm.form.fileSave = function () {
            if (!rt.isEmptyArray($scope.selectedFiles)) {
                return rt.uploadFiles($scope.selectedFiles, "weekly_report", $scope.vm.form.data.Id, false, function (data) {
                    $scope.selectedFiles = null;
                    $scope.selectedFilesArr = [];
                    $scope.flagBTN = 0;
                });
            } else {
                var deferred = $q.defer();
                deferred.reject("没有添加附件");
                return deferred.promise;
            }
        };

        $scope.vm.form.deleteFile = function () {
            $scope.selectedFileName = null;

            if ($scope.vm.view.selectedIds.length == 0) {
                rt.errorMessage("至少选择一项要删除的文件！");
                return;
            }

            for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                for (var k = 0; k < $scope.vm.form.attachmentList.length; k++) {
                    if ($scope.vm.form.attachmentList[k].Id === $scope.vm.view.selectedIds[j]) {
                        if ($scope.selectedFiles != null) {
                            for (var i = 0; i < $scope.selectedFiles.length; i++) {
                                if ($scope.selectedFiles[i].name === $scope.vm.form.attachmentList[k].FileName) {
                                    $scope.selectedFiles.splice(i, 1);
                                }
                            }
                        }
                    }
                }
            }

            for (var i = 0; i < $scope.vm.form.attachmentList.length; i++) {
                for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                    if ($scope.vm.form.attachmentList[i].Id === $scope.vm.view.selectedIds[j]) {
                        $scope.vm.form.attachmentList.splice(i, 1);
                    }
                }
            }

            $scope.vm.view.selectedIds = [];
            rt.successMessage("删除成功。");
            //$scope.$emit('rt-reload');
            //$scope.$broadcast('rt-reload');
        };

        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("weekly_report", fileId);
        };
        /* end 附件相关*/
    }]);
})();
'use strict';

/**********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2017-02-07
 说明     : 佐力周报
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('zlweeklyreportService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'WeeklyReportZL';

        // @@ 选项集
        this.picklists = ['StateCode'];

        //获取阅读次数
        this.getReadTimes = function (objectId) {
            var apiUrl = "api/WeeklyReportZL/GetReadTimes?objectId=" + objectId;
            return rt.get(apiUrl);
        };

        //更改阅读状态
        this.updateReadState = function (objectId) {
            var url = 'api/WorkReportRead/UpdateReadState?objectId=' + objectId;
            return rt.get(url);
        };

        this.getAttachmentList = function (id) {
            // 如果请求的Id为空，则直接返回承诺，不需要再请求服务器
            if (rt.isNull(id) || id.length === 0) {
                var deferred = $q.defer();
                deferred.resolve({ data: null });
                return deferred.promise;
            }

            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };

        this.getEditReadData = function (objectId) {
            var url = 'api/WorkReportRead/GetEditReaderList?objectId=' + objectId;
            return rt.get(url);
        };

        //获取已读人列表
        this.getReaderList = function (objectId) {
            var apiUrl = "api/WorkReportRead/GetReaderList?objectId=" + objectId;
            return rt.get(apiUrl);
        };
    }]).controller('zlweeklyreportListController', ['$injector', '$timeout', '$scope', 'zlweeklyreportService', function ($injector, $timeout, $scope, myService) {
        var rt = myService.rt;
        var that = this;
        this.searchList = [];
        this.viewTag = "Web";
        this.preExport = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.startTime) && !rt.isNull($scope.vm.endTime)) {
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [$scope.vm.startTime, moment(new Date($scope.vm.endTime)).add(1, 'days').format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.startTime) && !rt.isNull($scope.vm.endTime)) {
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [$scope.vm.startTime, moment(new Date($scope.vm.endTime)).add(1, 'days').format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        function _init() {
            _getAllBuid();
            _initYmSelected();
        }
        _init();

        //点击查询时判断开始时间不能大于结束时间
        $scope.vm.judgeTime = function () {

            if (moment($scope.vm.startTime).format('YYYY-MM-DD') > $scope.vm.endTime) {
                rt.errorMessage("开始时间不能大于结束时间！");
                return;
            }
            $scope.vm.view.search(1);
        };

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.startTime = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.endTime = moment().format('YYYY-MM-DD');
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = null;
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        $scope.overHeightTable = function () {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        };
    }]).controller('zlweeklyreportEditController', ['$injector', '$compile', '$scope', 'zlweeklyreportService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;
        var $stateParams = myService.$stateParams;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.attachmentList = [];
        $scope.vm.isComment = true;
        $scope.vm.search = _search;
        var wasSelected = localStorage.getItem("zlweeklyreport_25948a76-18d1-421f-b54d-3936eb0aea88");
        $scope.vm.form.readerList = !rt.isNull(wasSelected) ? JSON.parse(wasSelected) : [];

        //监听用户输入，当用户输入为字符的时候，回退
        $scope.vm.form.deleteReaderList = function (index) {
            $scope.vm.form.readerList.splice(index, 1);
        };

        $scope.$watch("vm.form.data.purchase", function (newValue, oldValue) {
            if (rt.isNull(newValue)) {
                return;
            }
            if (newValue != oldValue) {
                if (!rt.isIntegerString(newValue)) {
                    $scope.vm.form.data.purchase = oldValue;
                }
            }
        });
        $scope.$watch("vm.form.data.sale", function (newValue, oldValue) {
            if (rt.isNull(newValue)) {
                return;
            }
            if (newValue != oldValue) {
                if (!rt.isIntegerString(newValue)) {
                    $scope.vm.form.data.sale = oldValue;
                }
            }
        });
        $scope.$watch("vm.form.data.stock", function (newValue, oldValue) {
            if (rt.isNull(newValue)) {
                return;
            }
            if (newValue != oldValue) {
                if (!rt.isIntegerString(newValue)) {
                    $scope.vm.form.data.stock = oldValue;
                }
            }
        });

        $scope.vm.form.newSave = function () {
            if (rt.isNullOrEmptyString($scope.vm.form.data.purchase) && rt.isNullOrEmptyString($scope.vm.form.data.sale) && rt.isNullOrEmptyString($scope.vm.form.data.stock) && rt.isNullOrEmptyString($scope.vm.form.data.importa_account_visit_follow) && rt.isNullOrEmptyString($scope.vm.form.data.conference_invite_follow) && rt.isNullOrEmptyString($scope.vm.form.data.product_knowledge_study) && rt.isNullOrEmptyString($scope.vm.form.data.team_building)) {
                rt.errorMessage("抱歉，内容至少填写一项");
                return;
            }
            if (rt.isNullOrEmptyString($scope.vm.form.data.product_knowledge_study)) {
                rt.errorMessage("请填写产品知识学习");
                return;
            }
            if ($scope.vm.form.readerList.length == 0) {
                rt.errorMessage("请添加发送人！");
                return;
            }

            var waiting = rt.showWaiting();
            $scope.flagBTN = 1;
            $scope.vm.form.data.attachment_count = $scope.vm.form.attachmentList.length;
            localStorage.setItem("zlweeklyreport_25948a76-18d1-421f-b54d-3936eb0aea88", JSON.stringify($scope.vm.form.readerList));

            $scope.vm.form.save(false).then(function () {
                $scope.vm.form.fileSave().then(function () {
                    _getFile();
                });
                $scope.vm.form.readerSubmit();
            });
            waiting.close();
        };

        $scope.vm.form.readerSubmit = function () {
            var reqData = {
                ObjectId: $scope.vm.form.id,
                ObjectTypeName: "weekly_report_zl",
                ReaderList: $scope.vm.form.readerList
            };

            var url = 'api/WorkReportRead/ReaderSubmit';
            return rt.post(url, reqData);
        };

        function _loadData() {
            $scope.vm.text = "";
            var apiUrl = "api/Course/GetComment?courseId=" + $scope.vm.form.id;
            rt.get(apiUrl).then(function (resp) {
                var data = resp.data[0];
                if (data) {
                    $scope.vm.score = data.score_value;
                    if (data.text) {
                        $scope.vm.text = data.text;
                    } else {
                        $scope.vm.text = "";
                    }
                }
            });
        }

        //评分
        $scope.vm.StarClick1 = function (index) {
            $scope.vm.score = 2 * index;
        };

        $scope.vm.form.preLoad = function (data) {
            if ($scope.vm.form.type === 'Edit') {
                _getFile();

                myService.getReadTimes($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.times = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });

                myService.getReaderList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.readed = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
                myService.getEditReadData($scope.vm.form.id).success(function (data) {
                    if (!rt.isNull(data) && data.length > 0) {
                        $scope.vm.form.readerList = [];
                    }
                    data.map(function (item) {
                        $scope.vm.form.readerList.push({
                            OwnerId: {
                                Id: item.ReadBy.Id,
                                Name: item.ReadBy.Name
                            }
                        });
                    });
                }).error(function (error) {
                    rt.errorMessage(error);
                });

                myService.updateReadState($scope.vm.form.id);

                $scope.vm.pageIndex = 1;
                $scope.vm.pageSize = rt.getPaginationSize();
                _search();
                _loadData();
            }
        };

        function _search() {
            var waiting = rt.showLoading2();
            var url = 'api/Course/GetCommentList?courseId=' + $scope.vm.form.id + "&pageSize=" + $scope.vm.pageSize + "&pageIndex=" + $scope.vm.pageIndex;
            rt.get(url).then(function (resp) {
                $scope.vm.form.commentList = resp.data.DataList;
                $scope.vm.form.recordCount = resp.data.TotalRecords;
                waiting.close();
            }, function () {
                waiting.close();
            });
        };

        $scope.vm.commentClick = function () {
            if (!$scope.vm.score) {
                rt.errorMessage("你还没有打分哦。");
                return;
            }
            if (rt.isNullOrEmptyString($scope.vm.text)) {
                rt.errorMessage("请输入文字内容");
                return;
            }
            $scope.vm.isComment = false;

            rt.post("api/Course/CreateComment", { courseId: $scope.vm.form.id, score: $scope.vm.score, text: $scope.vm.text }).then(function () {
                $scope.vm.isComment = true;
                $scope.$emit('rt-reload');
                $scope.$broadcast('rt-reload');
            });
        };

        $scope.addApprover = function () {
            var params = { moduleName: 'weeklyreport_zl', filtered: false };

            var html = '<div rt-include rt-template="OA/ApproveU2/approveU2ListView.html" rt-controller="ApproveU2Controller" rt-include-params=\'' + JSON.stringify(params) + '\'></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        $scope.$on('to-parent', function (event, data) {
            if (rt.isNull($scope.vm.form.readerList) || $scope.vm.form.readerList === '') {
                $scope.vm.form.readerList = data;
            } else {
                $scope.vm.readerLists = $scope.vm.form.readerList;
                for (var i = 0; i < data.length; i++) {
                    var approverExit = true;
                    for (var j = 0; j < $scope.vm.readerLists.length; j++) {
                        if (data[i].OwnerId.Id === $scope.vm.readerLists[j].OwnerId.Id) {
                            approverExit = false;
                        }
                    }
                    if (approverExit) {
                        $scope.vm.form.readerList.push(data[i]);
                    }
                }
            }
        });

        $scope.vm.hideForm = function () {
            $scope.vm.dialog.close();
        };

        /* start 附件相关*/
        function _getFile() {
            if ($scope.vm.form.id != "") {
                myService.getAttachmentList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.attachmentList = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            } else {
                $scope.vm.form.attachmentList = [];
            }
        }

        $scope.selectedFiles = null;
        $scope.selectedFilesArr = [];
        $scope.selectedFileName = null;

        $scope.vm.form.fileSelect = function (files) {
            if (files && files.length && files.length > 0) {
                for (var i = 0; i < files.length; i++) {
                    $scope.selectedFilesArr.push(files[i]);
                }
                $scope.selectedFiles = $scope.selectedFilesArr;

                for (var i = 0; i < files.length; i++) {
                    $scope.vm.form.attachmentList.push({
                        Id: rt.newGuid(),
                        FileName: files[i].name
                    });
                }
            }
        };

        $scope.vm.form.fileSave = function () {
            if (!rt.isEmptyArray($scope.selectedFiles)) {
                return rt.uploadFiles($scope.selectedFiles, "weekly_report_zl", $scope.vm.form.data.Id, false, function (data) {
                    $scope.selectedFiles = null;
                    $scope.selectedFilesArr = [];
                    $scope.flagBTN = 0;
                });
            } else {
                var deferred = $q.defer();
                deferred.reject("没有添加附件");
                return deferred.promise;
            }
        };

        $scope.vm.form.deleteFile = function () {
            $scope.selectedFileName = null;

            if ($scope.vm.view.selectedIds.length == 0) {
                rt.errorMessage("至少选择一项要删除的文件！");
                return;
            }

            for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                for (var k = 0; k < $scope.vm.form.attachmentList.length; k++) {
                    if ($scope.vm.form.attachmentList[k].Id === $scope.vm.view.selectedIds[j]) {
                        if ($scope.selectedFiles != null) {
                            for (var i = 0; i < $scope.selectedFiles.length; i++) {
                                if ($scope.selectedFiles[i].name === $scope.vm.form.attachmentList[k].FileName) {
                                    $scope.selectedFiles.splice(i, 1);
                                }
                            }
                        }
                    }
                }
            }

            for (var i = 0; i < $scope.vm.form.attachmentList.length; i++) {
                for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                    if ($scope.vm.form.attachmentList[i].Id === $scope.vm.view.selectedIds[j]) {
                        $scope.vm.form.attachmentList.splice(i, 1);
                    }
                }
            }

            $scope.vm.view.selectedIds = [];
            rt.successMessage("删除成功。");
        };

        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("weekly_report_zl", fileId);
        };
        /* end 附件相关*/
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/4/6
 说明     : 工作报告
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('workreportreadService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'workreportread';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('workreportreadListController', ['$injector', '$scope', 'workreportreadService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;
        this.viewTag = "Web";

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.filterReport = function () {
            $scope.vm.view.queryValue = $("input[name='object_type_name']:checked").val();
            if ($scope.vm.view.queryValue != "") {
                $scope.vm.view.searchList = [{ Type: 1, Key: "object_type_name", Value: $scope.vm.view.queryValue }];
            } else {
                $scope.vm.view.searchList = [];
            }
            $scope.vm.view.search();
        };
    }]).controller('workreportreadEditController', ['$injector', '$scope', 'workreportreadService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016-02-01
 说明     : 医院管理
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('accountService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'account';

        // @@ 选项集
        this.picklists = ['StateCode', 'account_grade', 'accounttype', 'accountclassificationcode', 'account_grade_level', "rx_potential", "rx_attitude"];

        //获取归属信息
        this.GetSalesRegionInfo = function (accountId) {
            return rt.get("api/Account/GetSalesRegionInfo?accountId=" + accountId);
        };

        //保存归属信息
        this.SaveSalesRegionInfo = function (accountId, dataList) {
            return rt.post("api/SalesRegionAccount/SaveSalesRegionInfo?accountId=" + accountId, dataList);
        };

        //根据销售区域Id获取部门和用户信息
        this.GetBusinessAndOwnerInfoById = function (sales_regionId) {
            return rt.get("api/SalesRegion/GetBusinessAndOwnerInfoById?sales_regionId=" + sales_regionId);
        };
    }]).controller('accountListController', ['$injector', '$compile', '$scope', 'accountService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        $scope.viewTag = "Web";
        this.viewTag = "Web";

        var that = this;
        this.isPost = true;
        this.searchList = [];
        this.bodySearchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
            that.bodySearchList.length = 0;

            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            if (!rt.isNullOrEmptyString(unitids)) {
                var idArray = unitids.split(",");
                that.bodySearchList.push({ Type: 2, Key: "BusinessUnitId", Value: idArray });
            }

            if (!rt.isNull($scope.vm.stateSelected)) that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.Value });

            if (!rt.isNull($scope.vm.gradeSelected)) that.searchList.push({ Type: 1, Key: "account_grade", Value: $scope.vm.gradeSelected.Value });

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.province) && !rt.isNullOrEmptyString($scope.vm.areaSelected.province.Id)) {
                that.searchList.push({ Type: 1, Key: "provinceid", Value: $scope.vm.areaSelected.province.Id });
            }

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.city) && !rt.isNullOrEmptyString($scope.vm.areaSelected.city.Id)) {
                that.searchList.push({ Type: 1, Key: "cityid", Value: $scope.vm.areaSelected.city.Id });
            }

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.county) && !rt.isNullOrEmptyString($scope.vm.areaSelected.county.Id)) {
                that.searchList.push({ Type: 1, Key: "countyid", Value: $scope.vm.areaSelected.county.Id });
            }

            if (!rt.isNullOrEmptyString($scope.vm.tagSelected)) {
                if ($scope.vm.tagSelected.indexOf('：') < 0 && $scope.vm.tagSelected.indexOf(':') < 0) {
                    return "请按照正确格式输入：标签名称：内容1，内容2；";
                }
                that.searchList.push({ Type: 5, Key: "account_tag", Value: $scope.vm.tagSelected });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.showForm = _showForm;

        function _showForm() {
            var html = '<div rt-include rt-template="Module/ExcelImport/ExcelImportView.html" rt-controller="ExcelImportController" ></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                type: BootstrapDialog.TYPE_PRIMARY,
                title: '导入医院档案',
                message: html,
                size: BootstrapDialog.SIZE_NORMAL,
                closable: true,
                onshow: function onshow(dialog) {
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }

        $scope.vm.actions.loadComplete = function () {
            if (!rt.isNull($scope.vm.data)) {
                for (var i = 0; i < $scope.vm.data.length; i++) {
                    if (!rt.isNull($scope.vm.data[i].account_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.data[i].account_tag) {
                            tagstring += o + "：" + $scope.vm.data[i].account_tag[o] + "；";
                        }
                        $scope.vm.data[i].tagstring = tagstring;
                    }
                }
            }
        };
    }]).controller('accountEditController', ['$injector', '$compile', '$scope', 'accountService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.$watch("vm.form.data.cityid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.delSelected = [];
        //加载归属信息
        $scope.vm.form.loadComplete = function () {
            $scope.vm.getSalesRegionInfo();
            $scope.isCheckAll = false;
            $scope.vm.form.tagList = [];
            if (!rt.isNull($scope.vm.form.data.account_tag)) {
                var tagstring = "";
                for (var o in $scope.vm.form.data.account_tag) {
                    tagstring = o + "：" + $scope.vm.form.data.account_tag[o];
                    $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
                }
            }
        };

        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/BusinessAccount/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            var valueList = data.Value.split(/[,，]/);
            var list = [];
            for (var i = 0; i < valueList.length; i++) {
                if (!rt.isNullOrWhiteSpace(valueList[i])) {
                    list.push(valueList[i]);
                }
            }
            if (rt.isNull($scope.vm.form.data.account_tag)) {
                $scope.vm.form.data.account_tag = {};
            }
            $scope.vm.form.data.account_tag[data.Name] = list;
            $scope.vm.form.tagList = [];
            var tagstring = "";
            for (var o in $scope.vm.form.data.account_tag) {
                tagstring = o + "：" + $scope.vm.form.data.account_tag[o];
                $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
            }
        });

        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.form.tagList, { 'checked': true });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.form.tagList = _.where($scope.vm.form.tagList, { 'checked': false });
            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.account_tag = tag;
        };

        //保存之前
        $scope.vm.form.preSave = function (data) {
            if ($scope.salesRegionInfoList.length == 0) {
                rt.errorMessage("至少选择一条医院归属信息。");
                return "至少选择一条医院归属信息。";
            }
            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.account_tag = tag;
        };

        //保存之后
        $scope.vm.form.postSave = function () {
            //保存归属信息
            $scope.vm.saveSalesRegionInfo();
        };

        $scope.vm.getSalesRegionInfo = function () {
            //打开客户编辑页面时获取归属信息
            if (rt.isNull($scope.rtIncludeParams) || !rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                myService.GetSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id).then(function (resp) {
                    $scope.salesRegionInfoList = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            }
        };

        //保存归属信息
        $scope.vm.saveSalesRegionInfo = function () {
            myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {}).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.salesRegionInfoList = _.remove($scope.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    //编辑客户时，删除归属信息才和后台数据库交互
                    if (!rt.isNullOrEmptyString($scope.vm.form.data.Id)) {
                        $scope.vm.saveSalesRegionInfo();
                    }

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegion").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //编辑客户-归属信息
        $scope.vm.showForm = function (row, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params="{rtIncludeId:\'' + row + '\'' + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //新建客户-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=' + JSON.stringify(list) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品种。");
                return "必须提供品种。";
            }

            if (rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                $scope.salesRegionInfoList = $scope.rtIncludeParams;
            }

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品种，不能再添加其他品种。");
                    return "已选择了全品种，不能再添加其他品种。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };
            // 编辑客户时，直接保存到数据库，并刷新数据
            if (!rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {
                    $scope.$emit('rt-on-dialog-close-click');
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            } else
                // 新建客户时，广播到编辑页面
                $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.salesRegionInfoList);
        };

        // 新建客户-编辑归属信息页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.salesRegionInfoList = list;
        });

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };
    }]);
})();
'use strict';

/*********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2018/01/30
 说明     : 机构变更
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('accountAppService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'AccountApp';

        //审批实体名字
        this.approvalTypeName = 'account_app';

        // @@ 选项集
        this.picklists = ['StateCode'];

        //搜索机构名称
        this.GetAccountList = function (searchText, pageIndex, pageSize) {
            return rt.get("api/AccountApp/GetAccountList?searchText=" + encodeURIComponent(searchText) + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize);
        };

        //获取商业相关的参数组-acc_level
        this.getAccLevelPickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=acc_level";
            return rt.get(url);
        };

        //获取商业、医院、门店、基层医疗、代理商、连锁药店相关的参数组-account_level
        this.getAccountGradeLevelPickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=account_level";
            return rt.get(url);
        };

        //获取商业相关的参数组-credit
        this.getCreditPickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=credit";
            return rt.get(url);
        };

        //获取商业相关的参数组-acc_type
        this.getAccTypePickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=acc_type";
            return rt.get(url);
        };

        //获取商业相关的参数组-partnership
        this.getPartnershipPickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=partnership";
            return rt.get(url);
        };

        //获取商业相关的参数组-accountlevel
        this.getAccountLevelPickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=accountlevel";
            return rt.get(url);
        };

        //获取商业相关的参数组-creditdegree
        this.getCreditDegreePickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=creditdegree";
            return rt.get(url);
        };

        //获取医院相关的参数组-account_grade
        this.getAccountGradePickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=account_grade";
            return rt.get(url);
        };

        //获取医院相关的参数组-account_type
        this.getAccountTypePickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=account_type";
            return rt.get(url);
        };

        //获取门店相关的参数组-yaotype
        this.getYaoTypePickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=yaotype";
            return rt.get(url);
        };

        //获取门店相关的参数组-st_type
        this.getStTypePickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=st_type";
            return rt.get(url);
        };

        //获取基层医疗相关的参数组-org_type
        this.getOrgTypePickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=org_type";
            return rt.get(url);
        };

        //获取代理商相关的参数组-agent_type
        this.getAgentTypePickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=agent_type";
            return rt.get(url);
        };

        //获取连锁总部相关的参数组-chain_type
        this.getChainTypePickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=chain_type";
            return rt.get(url);
        };

        //获取商业明细
        this.GetBusinessDetail = function (accountId) {
            return rt.get("api/BusinessAccount/GetData?id=" + accountId);
        };

        //获取医院明细
        this.GetHospitalDetail = function (accountId) {
            return rt.get("api/Account/GetData?id=" + accountId);
        };

        //获取门店明细
        this.GetDrugstorelDetail = function (accountId) {
            return rt.get("api/TerminalAccount/GetData?id=" + accountId);
        };

        //获取基层医疗明细
        this.GetBasicDetail = function (accountId) {
            return rt.get("api/BasicMedical/GetData?id=" + accountId);
        };

        //获取代理商明细
        this.GetAgentDetail = function (accountId) {
            return rt.get("api/Agent/GetData?id=" + accountId);
        };

        //获取连锁总部明细
        this.GetChainDetail = function (accountId) {
            return rt.get("api/ChainAccount/GetData?id=" + accountId);
        };

        //根据销售区域Id获取部门和用户信息
        this.GetBusinessAndOwnerInfoById = function (sales_regionId) {
            return rt.get("api/SalesRegion/GetBusinessAndOwnerInfoById?sales_regionId=" + sales_regionId);
        };
    }]).controller('accountAppListController', ['$scope', '$injector', 'accountAppService', function ($scope, $injector, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        //重构的获取列表数据方法
        myService.getViewData = function () {
            return rt.get("api/AccountApp/GetDataList" + "?pageIndex=" + encodeURIComponent($scope.vm.page.index) + "&pageSize=" + rt.getPaginationSize() + "&searchText=" + $scope.vm.view.searchText);
        };
    }]).controller('accountAppReadController', ['$injector', '$scope', '$state', 'accountAppService', function ($injector, $scope, $state, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.preBindFormData = function (data) {
            //新增客户
            if (data.app_type.Value === '10') {
                $scope.vm.tabIndex = 1; //初始显示的tab
            }

            //变更客户信息
            if (data.app_type.Value === '20') {
                $scope.vm.tabIndex = 2; //初始显示的tab

                //商业
                if (data.accountclassificationcode.Value == '1') {
                    //处理差异信息中的布尔类型字段
                    var index1 = _.findIndex(data.account_info_diff, function (diff) {
                        return diff.diffParam.Value == 'acc_ispost';
                    });

                    if (index1 != -1) {
                        if (!rt.isNull(data.account_info_diff[index1].oldValue)) data.account_info_diff[index1].oldValue = data.account_info_diff[index1].oldValue ? '是' : '否';
                        if (!rt.isNull(data.account_info_diff[index1].newValue)) data.account_info_diff[index1].newValue = data.account_info_diff[index1].newValue ? '是' : '否';
                    }

                    var index2 = _.findIndex(data.account_info_diff, function (diff) {
                        return diff.diffParam.Value == 'is_bmdistributor';
                    });

                    if (index2 != -1) {
                        if (!rt.isNull(data.account_info_diff[index2].oldValue)) data.account_info_diff[index2].oldValue = data.account_info_diff[index2].oldValue ? '是' : '否';
                        if (!rt.isNull(data.account_info_diff[index2].newValue)) data.account_info_diff[index2].newValue = data.account_info_diff[index2].newValue ? '是' : '否';
                    }
                }

                //医院
                if (data.accountclassificationcode.Value == '2') {
                    //处理差异信息中的日期字段
                    var index1 = _.findIndex(data.account_info_diff, function (diff) {
                        return diff.diffParam.Value == 'acc_org_validdate';
                    });

                    if (index1 != -1) {
                        if (!rt.isNull(data.account_info_diff[index1].oldValue)) data.account_info_diff[index1].oldValue = moment(data.account_info_diff[index1].oldValue).format("YYYY-MM-DD");
                        if (!rt.isNull(data.account_info_diff[index1].newValue)) data.account_info_diff[index1].newValue = moment(data.account_info_diff[index1].newValue).format("YYYY-MM-DD");
                    }

                    var index2 = _.findIndex(data.account_info_diff, function (diff) {
                        return diff.diffParam.Value == 'acc_passport_validdate';
                    });

                    if (index2 != -1) {
                        if (!rt.isNull(data.account_info_diff[index2].oldValue)) data.account_info_diff[index2].oldValue = moment(data.account_info_diff[index2].oldValue).format("YYYY-MM-DD");
                        if (!rt.isNull(data.account_info_diff[index2].newValue)) data.account_info_diff[index2].newValue = moment(data.account_info_diff[index2].newValue).format("YYYY-MM-DD");
                    }

                    //处理差异信息中的布尔类型字段
                    var index3 = _.findIndex(data.account_info_diff, function (diff) {
                        return diff.diffParam.Value == 'is_secondrebate';
                    });

                    if (index3 != -1) {
                        if (!rt.isNull(data.account_info_diff[index3].oldValue)) data.account_info_diff[index3].oldValue = data.account_info_diff[index3].oldValue ? '是' : '否';
                        if (!rt.isNull(data.account_info_diff[index3].newValue)) data.account_info_diff[index3].newValue = data.account_info_diff[index3].newValue ? '是' : '否';
                    }

                    var index4 = _.findIndex(data.account_info_diff, function (diff) {
                        return diff.diffParam.Value == 'is_trusteeship';
                    });

                    if (index4 != -1) {
                        if (!rt.isNull(data.account_info_diff[index4].oldValue)) data.account_info_diff[index4].oldValue = data.account_info_diff[index4].oldValue ? '是' : '否';
                        if (!rt.isNull(data.account_info_diff[index4].newValue)) data.account_info_diff[index4].newValue = data.account_info_diff[index4].newValue ? '是' : '否';
                    }
                }

                //门店
                if (data.accountclassificationcode.Value == '3') {
                    //处理差异信息中的布尔类型字段
                    var index1 = _.findIndex(data.account_info_diff, function (diff) {
                        return diff.diffParam.Value == 'st_isclinet';
                    });

                    if (index1 != -1) {
                        if (!rt.isNull(data.account_info_diff[index1].oldValue)) data.account_info_diff[index1].oldValue = data.account_info_diff[index1].oldValue ? '是' : '否';
                        if (!rt.isNull(data.account_info_diff[index1].newValue)) data.account_info_diff[index1].newValue = data.account_info_diff[index1].newValue ? '是' : '否';
                    }
                }

                //基层医疗
                if (data.accountclassificationcode.Value == '4') {
                    //处理差异信息中的日期字段
                    var index1 = _.findIndex(data.account_info_diff, function (diff) {
                        return diff.diffParam.Value == 'acc_org_validdate';
                    });

                    if (index1 != -1) {
                        if (!rt.isNull(data.account_info_diff[index1].oldValue)) data.account_info_diff[index1].oldValue = moment(data.account_info_diff[index1].oldValue).format("YYYY-MM-DD");
                        if (!rt.isNull(data.account_info_diff[index1].newValue)) data.account_info_diff[index1].newValue = moment(data.account_info_diff[index1].newValue).format("YYYY-MM-DD");
                    }

                    var index2 = _.findIndex(data.account_info_diff, function (diff) {
                        return diff.diffParam.Value == 'acc_passport_validdate';
                    });

                    if (index2 != -1) {
                        if (!rt.isNull(data.account_info_diff[index2].oldValue)) data.account_info_diff[index2].oldValue = moment(data.account_info_diff[index2].oldValue).format("YYYY-MM-DD");
                        if (!rt.isNull(data.account_info_diff[index2].newValue)) data.account_info_diff[index2].newValue = moment(data.account_info_diff[index2].newValue).format("YYYY-MM-DD");
                    }

                    //处理差异信息中的布尔类型字段
                    var index3 = _.findIndex(data.account_info_diff, function (diff) {
                        return diff.diffParam.Value == 'iscontents';
                    });

                    if (index3 != -1) {
                        if (!rt.isNull(data.account_info_diff[index3].oldValue)) data.account_info_diff[index3].oldValue = data.account_info_diff[index3].oldValue ? '是' : '否';
                        if (!rt.isNull(data.account_info_diff[index3].newValue)) data.account_info_diff[index3].newValue = data.account_info_diff[index3].newValue ? '是' : '否';
                    }

                    var index4 = _.findIndex(data.account_info_diff, function (diff) {
                        return diff.diffParam.Value == 'isgov';
                    });

                    if (index4 != -1) {
                        if (!rt.isNull(data.account_info_diff[index4].oldValue)) data.account_info_diff[index4].oldValue = data.account_info_diff[index4].oldValue ? '是' : '否';
                        if (!rt.isNull(data.account_info_diff[index4].newValue)) data.account_info_diff[index4].newValue = data.account_info_diff[index4].newValue ? '是' : '否';
                    }
                }
            }

            //申请权限
            if (data.app_type.Value === '30') {
                $scope.vm.tabIndex = 3; //初始显示的tab
            }
        };

        //切换Tab
        $scope.chooseTab = function (tabIndex) {
            $scope.vm.tabIndex = tabIndex;
        };

        $scope.vm.form.loadComplete = function () {
            //加载审批流信息
            myService.getApprovalStatus($scope.vm.form.id).then(function (resp) {
                if (!rt.isNull(resp.data)) {
                    $scope.vm.form.approvalStatus = resp.data.ApprovalStatus;
                    $scope.vm.form.approverList = resp.data.ApproverList;
                }

                $scope.vm.form.isFlowApprover = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.ApprovingBy) && rt.isSameGuid($scope.vm.form.approvalStatus.ApprovingBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;

                $scope.vm.form.isFlowSubmitter = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.SubmittedBy) && rt.isSameGuid($scope.vm.form.approvalStatus.SubmittedBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;
            }).catch(function (resp) {
                rt.errorMessage(resp.data);
            });
        };

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        //重新提交
        $scope.vm.form.reSubmit = function () {
            switch ($scope.vm.form.data.accountclassificationcode.Value) {
                case "1":
                    //商业
                    $state.go("main.accountapp.businessedit", {
                        id: $scope.vm.form.data.Id,
                        accountId: $scope.vm.form.data.app_type.Value === '10' ? '' : $scope.vm.form.data.accountId.Id,
                        accountIdName: $scope.vm.form.data.app_type.Value === '20' ? '' : $scope.vm.form.data.accountId.Name,
                        changeType: $scope.vm.form.data.app_type.Value !== '30' ? 'info' : 'privilege'
                    }, {
                        location: true
                    });
                    break;
                case "2":
                    //医院
                    $state.go("main.accountapp.hospitaledit", {
                        id: $scope.vm.form.data.Id,
                        accountId: $scope.vm.form.data.app_type.Value === '10' ? '' : $scope.vm.form.data.accountId.Id,
                        accountIdName: $scope.vm.form.data.app_type.Value === '20' ? '' : $scope.vm.form.data.accountId.Name,
                        changeType: $scope.vm.form.data.app_type.Value !== '30' ? 'info' : 'privilege'
                    });
                    break;
                case "3":
                    //门店
                    $state.go("main.accountapp.drugstoreedit", {
                        id: $scope.vm.form.data.Id,
                        accountId: $scope.vm.form.data.app_type.Value === '10' ? '' : $scope.vm.form.data.accountId.Id,
                        accountIdName: $scope.vm.form.data.app_type.Value === '20' ? '' : $scope.vm.form.data.accountId.Name,
                        changeType: $scope.vm.form.data.app_type.Value !== '30' ? 'info' : 'privilege'
                    });
                    break;
                case "4":
                    //基层医疗
                    $state.go("main.accountapp.basicedit", {
                        id: $scope.vm.form.data.Id,
                        accountId: $scope.vm.form.data.app_type.Value === '10' ? '' : $scope.vm.form.data.accountId.Id,
                        accountIdName: $scope.vm.form.data.app_type.Value === '20' ? '' : $scope.vm.form.data.accountId.Name,
                        changeType: $scope.vm.form.data.app_type.Value !== '30' ? 'info' : 'privilege'
                    });
                    break;
                case "5":
                    //代理商
                    $state.go("main.accountapp.agentedit", {
                        id: $scope.vm.form.data.Id,
                        accountId: $scope.vm.form.data.app_type.Value === '10' ? '' : $scope.vm.form.data.accountId.Id,
                        accountIdName: $scope.vm.form.data.app_type.Value === '20' ? '' : $scope.vm.form.data.accountId.Name,
                        changeType: $scope.vm.form.data.app_type.Value !== '30' ? 'info' : 'privilege'
                    });
                    break;
                case "6":
                    //连锁总部
                    $state.go("main.accountapp.chainedit", {
                        id: $scope.vm.form.data.Id,
                        accountId: $scope.vm.form.data.app_type.Value === '10' ? '' : $scope.vm.form.data.accountId.Id,
                        accountIdName: $scope.vm.form.data.app_type.Value === '20' ? '' : $scope.vm.form.data.accountId.Name,
                        changeType: $scope.vm.form.data.app_type.Value !== '30' ? 'info' : 'privilege'
                    });
                    break;
            }
        };
    }]).controller('accountAppSearchController', ['$injector', '$state', '$scope', 'accountAppService', 'businessaccountService', 'accountService', 'terminalaccountService', 'BasicMedicalService', 'agentService', 'chainaccountService', function ($injector, $state, $scope, myService, businessaccountService, accountService, terminalaccountService, BasicMedicalService, agentService, chainaccountService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.vm.pageIndex = 1;
        $scope.vm.recordCount = 0;
        $scope.vm.pageSize = rt.getPaginationSize();
        $scope.vm.accountTypes = [{
            name: '商业',
            code: 'business'
        }, {
            name: '医院',
            code: 'hospital'
        }, {
            name: '门店',
            code: 'drugstore'
        }, {
            name: '基层医疗',
            code: 'basic'
        }, {
            name: '代理商',
            code: 'agent'
        }, {
            name: '连锁总部',
            code: 'chain'
        }];

        $scope.vm.form.hide = function () {
            $scope.$emit('rt-on-dialog-close-click');
        };

        //搜索机构
        $scope.vm.form.searchAccount = function () {
            if (rt.isNullOrEmptyString($scope.vm.searchText)) {
                rt.errorMessage("机构名称不能为空。");
                return;
            }

            $scope.vm.selectedAccountId = '';
            $scope.vm.selectedAccountIdName = '';
            $scope.vm.selectedAccountType = '';

            //置空radio
            $("input[name=accountList]").each(function () {
                $(this).attr("checked", false);
            });

            $scope.vm.searchAccountIdName = $scope.vm.searchText;

            myService.GetAccountList($scope.vm.searchText, $scope.vm.pageIndex, $scope.vm.pageSize).then(function (resp) {
                $scope.vm.accountList = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;

                //如果搜索的机构只有一个，则默认选中
                if ($scope.vm.recordCount === 1) {
                    $scope.vm.selectedAccountId = $scope.vm.accountList[0].Id;
                    $scope.vm.selectedAccountIdName = $scope.vm.accountList[0].name;
                    _getAccountType($scope.vm.accountList[0].accountclassificationcode.Value);
                }
            }).catch(function (error) {
                rt.errorMessage(error);
            });
        };

        function _getAccountType(code) {
            switch (code) {
                case "1":
                    //商业
                    $scope.vm.selectedAccountType = 'business';
                    break;
                case "2":
                    //医院
                    $scope.vm.selectedAccountType = 'hospital';
                    break;
                case "3":
                    //门店
                    $scope.vm.selectedAccountType = 'drugstore';
                    break;
                case "4":
                    //基层医疗
                    $scope.vm.selectedAccountType = 'basic';
                    break;
                case "5":
                    //代理商
                    $scope.vm.selectedAccountType = 'agent';
                    break;
                case "6":
                    //连锁总部
                    $scope.vm.selectedAccountType = 'chain';
                    break;
            }
        }

        //客户类型-单选框点击事件
        $scope.vm.form.selectAccountType = function (index) {
            $scope.vm.selectedAccountType = $scope.vm.accountTypes[index].code;
        };

        //新增机构
        $scope.vm.form.addAccount = function () {
            if (rt.isNullOrEmptyString($scope.vm.selectedAccountType)) {
                rt.errorMessage("请选择新增机构的类型。");
                return;
            }
            switch ($scope.vm.selectedAccountType) {
                case 'business':
                    //商业
                    $state.go("main.accountapp.businessedit", {
                        id: '',
                        accountId: '',
                        accountIdName: $scope.vm.searchText,
                        changeType: 'info'
                    }, {
                        location: true
                    });
                    break;
                case 'hospital':
                    //医院
                    $state.go("main.accountapp.hospitaledit", {
                        id: '',
                        accountId: '',
                        accountIdName: $scope.vm.searchText,
                        changeType: 'info'
                    });
                    break;
                case 'drugstore':
                    //门店
                    $state.go("main.accountapp.drugstoreedit", {
                        id: '',
                        accountId: '',
                        accountIdName: $scope.vm.searchText,
                        changeType: 'info'
                    });
                    break;
                case 'basic':
                    //基层医疗
                    $state.go("main.accountapp.basicedit", {
                        id: '',
                        accountId: '',
                        accountIdName: $scope.vm.searchText,
                        changeType: 'info'
                    });
                    break;
                case 'agent':
                    //代理商
                    $state.go("main.accountapp.agentedit", {
                        id: '',
                        accountId: '',
                        accountIdName: $scope.vm.searchText,
                        changeType: 'info'
                    });
                    break;
                case 'chain':
                    //连锁总部
                    $state.go("main.accountapp.chainedit", {
                        id: '',
                        accountId: '',
                        accountIdName: $scope.vm.searchText,
                        changeType: 'info'
                    });
                    break;
            }
        };

        //客户列表-单选框点击事件
        $scope.vm.form.selectAccount = function (index) {
            $scope.vm.selectedAccountId = $scope.vm.accountList[index].Id;
            $scope.vm.selectedAccountIdName = $scope.vm.accountList[index].name;
            _getAccountType($scope.vm.accountList[index].accountclassificationcode.Value);
        };

        //变更客户信息
        $scope.vm.form.changeAccountInfo = function () {
            if (rt.isNullOrEmptyString($scope.vm.selectedAccountId)) {
                rt.errorMessage("请选择一家机构。");
                return;
            }

            //如果当前用户没有此客户的权限，则不允许变更客户信息
            //商业
            if ($scope.vm.selectedAccountType == 'business') {
                $state.go("main.accountapp.businessedit", {
                    id: '',
                    accountId: $scope.vm.selectedAccountId,
                    accountIdName: '',
                    changeType: 'info'
                }, {
                    location: true
                });
            }

            //医院
            if ($scope.vm.selectedAccountType == 'hospital') {
                $state.go("main.accountapp.hospitaledit", {
                    id: '',
                    accountId: $scope.vm.selectedAccountId,
                    accountIdName: '',
                    changeType: 'info'
                }, {
                    location: true
                });
            }

            //门店
            if ($scope.vm.selectedAccountType == 'drugstore') {
                $state.go("main.accountapp.drugstoreedit", {
                    id: '',
                    accountId: $scope.vm.selectedAccountId,
                    accountIdName: '',
                    changeType: 'info'
                }, {
                    location: true
                });
            }

            //基层医疗
            if ($scope.vm.selectedAccountType == 'basic') {
                $state.go("main.accountapp.basicedit", {
                    id: '',
                    accountId: $scope.vm.selectedAccountId,
                    accountIdName: '',
                    changeType: 'info'
                }, {
                    location: true
                });
            }

            //代理商
            if ($scope.vm.selectedAccountType == 'agent') {
                $state.go("main.accountapp.agentedit", {
                    id: '',
                    accountId: $scope.vm.selectedAccountId,
                    accountIdName: '',
                    changeType: 'info'
                }, {
                    location: true
                });
            }

            //连锁总部
            if ($scope.vm.selectedAccountType == 'chain') {
                $state.go("main.accountapp.chainedit", {
                    id: '',
                    accountId: $scope.vm.selectedAccountId,
                    accountIdName: '',
                    changeType: 'info'
                }, {
                    location: true
                });
            }
        };

        //申请客户权限
        $scope.vm.form.changeAccountPrivilege = function () {
            if (rt.isNullOrEmptyString($scope.vm.selectedAccountId)) {
                rt.errorMessage("请选择一家机构。");
                return;
            }

            switch ($scope.vm.selectedAccountType) {
                case "business":
                    //商业
                    $state.go("main.accountapp.businessedit", {
                        id: '',
                        accountId: $scope.vm.selectedAccountId,
                        accountIdName: $scope.vm.selectedAccountIdName,
                        changeType: 'privilege'
                    }, {
                        location: true
                    });
                    break;
                case "hospital":
                    //医院
                    $state.go("main.accountapp.hospitaledit", {
                        id: '',
                        accountId: $scope.vm.selectedAccountId,
                        accountIdName: $scope.vm.selectedAccountIdName,
                        changeType: 'privilege'
                    });
                    break;
                case "drugstore":
                    //门店
                    $state.go("main.accountapp.drugstoreedit", {
                        id: '',
                        accountId: $scope.vm.selectedAccountId,
                        accountIdName: $scope.vm.selectedAccountIdName,
                        changeType: 'privilege'
                    });
                    break;
                case "basic":
                    //基层医疗
                    $state.go("main.accountapp.basicedit", {
                        id: '',
                        accountId: $scope.vm.selectedAccountId,
                        accountIdName: $scope.vm.selectedAccountIdName,
                        changeType: 'privilege'
                    });
                    break;
                case "agent":
                    //代理商
                    $state.go("main.accountapp.agentedit", {
                        id: '',
                        accountId: $scope.vm.selectedAccountId,
                        accountIdName: $scope.vm.selectedAccountIdName,
                        changeType: 'privilege'
                    });
                    break;
                case "chain":
                    //连锁总部
                    $state.go("main.accountapp.chainedit", {
                        id: '',
                        accountId: $scope.vm.selectedAccountId,
                        accountIdName: $scope.vm.selectedAccountIdName,
                        changeType: 'privilege'
                    });
                    break;
            }
        };
    }]).controller('accountAppBusinessEditController', ['$injector', '$compile', '$scope', 'accountAppService', 'businessaccountService', function ($injector, $compile, $scope, myService, businessaccountService) {
        var rt = myService.rt;
        var $stateParams = myService.$stateParams;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        $scope.vm.changeType = $stateParams.changeType; //申请类型，info客户信息，privilege客户权限
        $scope.vm.isCreateAccount = rt.isNullOrEmptyString($stateParams.accountId) ? true : false; //是否新建客户
        $scope.vm.accountInfo = {};
        $scope.vm.salesRegionInfoList = [];
        $scope.delSelected = []; //归属信息删除列表
        $scope.isCheckAll = false;

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            if (data.Type === 'addTag') {
                var valueList = data.Value.split(/[,，]/);
                var list = [];
                for (var i = 0; i < valueList.length; i++) {
                    if (!rt.isNullOrWhiteSpace(valueList[i])) {
                        list.push(valueList[i]);
                    }
                }
                if (rt.isNull($scope.vm.accountInfo.account_tag)) {
                    $scope.vm.accountInfo.account_tag = {};
                }
                $scope.vm.accountInfo.account_tag[data.Name] = list;
                $scope.vm.tagList = [];
                var tagstring = "";
                for (var o in $scope.vm.accountInfo.account_tag) {
                    tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                    $scope.vm.tagList.push({
                        "value": tagstring,
                        "checked": false
                    });
                }
            } else return;
        });

        $scope.$watch('vm.accountInfo.provinceid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.accountInfo.cityid = null;
                $scope.vm.accountInfo.countyid = null;
                return;
            }
        });

        $scope.$watch('vm.accountInfo.cityid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.accountInfo.countyid = null;
                return;
            }
        });

        //保存之前
        $scope.vm.form.preSave = function (data) {
            //新建客户、申请客户权限
            if ($scope.vm.changeType === 'privilege' || $scope.vm.isCreateAccount) {
                if ($scope.vm.salesRegionInfoList.length == 0) {
                    rt.errorMessage("至少选择一条归属信息");
                    return "至少选择一条归属信息";
                }
            }

            //申请单字段赋值
            $scope.vm.form.data.accountclassificationcode = {
                Name: '商业',
                Value: '1'
            };

            //新增客户
            if ($scope.vm.isCreateAccount) {
                $scope.vm.accountInfo.accountclassificationcode = {
                    Name: '商业',
                    Value: '1'
                };

                $scope.vm.form.data.app_type = {
                    Name: '新增客户',
                    Value: '10'
                };
                $scope.vm.form.data.accountId = {
                    Id: '',
                    Name: $scope.vm.accountInfo.name
                };
                $scope.vm.form.data.account_info = $scope.vm.accountInfo;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }

            //变更客户信息
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'info') {
                $scope.vm.form.data.app_type = {
                    Name: '变更客户信息',
                    Value: '20'
                };
                $scope.vm.form.data.accountId = {
                    Id: $stateParams.accountId,
                    Name: $scope.vm.preAccountIdName
                };
                $scope.vm.form.data.accountnumber = $scope.vm.preAccountNumber;
                $scope.vm.form.data.account_info = $scope.vm.accountInfo;
            }

            //申请客户权限
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'privilege') {
                $scope.vm.form.data.app_type = {
                    Name: '申请权限',
                    Value: '30'
                };
                $scope.vm.form.data.accountId = {
                    Id: $stateParams.accountId,
                    Name: $stateParams.accountIdName
                };
                $scope.vm.form.data.accountnumber = $scope.vm.preAccountNumber;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }
        };

        $scope.vm.form.GetDefaultSalesRegion = function () {
            businessaccountService.GetSalesRegionInfo('').then(function (resp) {
                $scope.vm.salesRegionInfoList = resp.data;
            }).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除小区记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.vm.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.vm.salesRegionInfoList = _.remove($scope.vm.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegion").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.vm.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //新建客户-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=' + JSON.stringify(list) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品种。");
                return "必须提供品种。";
            }

            $scope.vm.salesRegionInfoList = $scope.rtIncludeParams;

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品种，不能再添加其他品种。");
                    return "已选择了全品种，不能再添加其他品种。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.vm.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.vm.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };

            $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.vm.salesRegionInfoList);
        };

        // 新建客户-编辑归属信息页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.vm.salesRegionInfoList = list;
        });

        $scope.vm.form.preBindFormData = function (data) {
            //新增客户、变更客户信息，需要先加载参数组
            if ($scope.vm.changeType === 'info') {
                myService.getAccLevelPickList().then(function (resp) {
                    $scope.vm.picklist.acc_level = resp.data;
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
                myService.getAccountGradeLevelPickList().then(function (resp) {
                    $scope.vm.picklist.account_grade_level = resp.data;
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
                myService.getCreditPickList().then(function (resp) {
                    $scope.vm.picklist.credit = resp.data;
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
                myService.getAccTypePickList().then(function (resp) {
                    $scope.vm.picklist.acc_type = resp.data;
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
                myService.getPartnershipPickList().then(function (resp) {
                    $scope.vm.picklist.partnership = resp.data;
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
                myService.getAccountLevelPickList().then(function (resp) {
                    $scope.vm.picklist.accountlevel = resp.data;
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
                myService.getCreditDegreePickList().then(function (resp) {
                    $scope.vm.picklist.creditdegree = resp.data;
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
            }
            if ($scope.vm.form.type === 'Edit') {
                $scope.vm.accountInfo = data.account_info;
                $scope.vm.salesRegionInfoList = data.account_region_diff;
                //绑定标签列表
                $scope.vm.tagList = [];
                if (!rt.isNull($scope.vm.accountInfo.account_tag)) {
                    var tagstring = "";
                    for (var o in $scope.vm.accountInfo.account_tag) {
                        tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                        $scope.vm.tagList.push({
                            "value": tagstring,
                            "checked": false
                        });
                    }
                }
            }
        };

        $scope.vm.form.preLoad = function () {
            //新增客户信息
            if ($scope.vm.isCreateAccount) {
                //将搜索页面的机构名称带入
                $scope.vm.accountInfo.name = $stateParams.accountIdName;

                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }

            //变更客户信息
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'info') {
                //获取客户原信息
                myService.GetBusinessDetail($stateParams.accountId).then(function (resp) {
                    $scope.vm.accountInfo = resp.data;

                    $scope.vm.preAccountIdName = $scope.vm.accountInfo.name;
                    $scope.vm.preAccountNumber = $scope.vm.accountInfo.accountnumber;
                    //绑定标签列表
                    $scope.vm.tagList = [];
                    if (!rt.isNull($scope.vm.accountInfo.account_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.accountInfo.account_tag) {
                            tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                            $scope.vm.tagList.push({
                                "value": tagstring,
                                "checked": false
                            });
                        }
                    }
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
            }

            //申请客户权限
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'privilege') {
                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }
        };

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };

        //增加标签
        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/BusinessAccount/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        //删除标签
        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.tagList, {
                'checked': true
            });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.tagList = _.where($scope.vm.tagList, {
                'checked': false
            });
            tag = {};
            for (var i = 0; i < $scope.vm.tagList.length; i++) {
                var tagNameValueList = $scope.vm.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            }
            $scope.vm.accountInfo.account_tag = tag;
        };
    }]).controller('accountAppHospitalEditController', ['$injector', '$compile', '$scope', 'accountAppService', 'accountService', function ($injector, $compile, $scope, myService, accountService) {
        var rt = myService.rt;
        var $stateParams = myService.$stateParams;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        $scope.vm.changeType = $stateParams.changeType; //申请类型，info客户信息，privilege客户权限
        $scope.vm.isCreateAccount = rt.isNullOrEmptyString($stateParams.accountId) ? true : false; //是否新建客户
        $scope.vm.accountInfo = {};
        $scope.vm.salesRegionInfoList = [];
        $scope.delSelected = []; //归属信息删除列表
        $scope.isCheckAll = false;

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            if (data.Type === 'addTag') {
                var valueList = data.Value.split(/[,，]/);
                var list = [];
                for (var i = 0; i < valueList.length; i++) {
                    if (!rt.isNullOrWhiteSpace(valueList[i])) {
                        list.push(valueList[i]);
                    }
                }
                if (rt.isNull($scope.vm.accountInfo.account_tag)) {
                    $scope.vm.accountInfo.account_tag = {};
                }
                $scope.vm.accountInfo.account_tag[data.Name] = list;
                $scope.vm.tagList = [];
                var tagstring = "";
                for (var o in $scope.vm.accountInfo.account_tag) {
                    tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                    $scope.vm.tagList.push({
                        "value": tagstring,
                        "checked": false
                    });
                }
            } else return;
        });

        $scope.$watch('vm.accountInfo.provinceid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.accountInfo.cityid = null;
                $scope.vm.accountInfo.countyid = null;
                return;
            }
        });

        $scope.$watch('vm.accountInfo.cityid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.accountInfo.countyid = null;
                return;
            }
        });

        //保存之前
        $scope.vm.form.preSave = function (data) {
            //新建客户、申请客户权限
            if ($scope.vm.changeType === 'privilege' || $scope.vm.isCreateAccount) {
                if ($scope.vm.salesRegionInfoList.length == 0) {
                    rt.errorMessage("至少选择一条归属信息");
                    return "至少选择一条归属信息";
                }
            }

            //申请单字段赋值
            $scope.vm.form.data.accountclassificationcode = {
                Name: '医院',
                Value: '2'
            };

            //新增客户
            if ($scope.vm.isCreateAccount) {
                $scope.vm.accountInfo.accountclassificationcode = {
                    Name: '医院',
                    Value: '2'
                };

                $scope.vm.form.data.app_type = {
                    Name: '新增客户',
                    Value: '10'
                };
                $scope.vm.form.data.accountId = {
                    Id: '',
                    Name: $scope.vm.accountInfo.name
                };
                $scope.vm.form.data.account_info = $scope.vm.accountInfo;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }

            //变更客户信息
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'info') {
                $scope.vm.form.data.app_type = {
                    Name: '变更客户信息',
                    Value: '20'
                };
                $scope.vm.form.data.accountId = {
                    Id: $stateParams.accountId,
                    Name: $scope.vm.preAccountIdName
                };
                $scope.vm.form.data.accountnumber = $scope.vm.preAccountNumber;
                $scope.vm.form.data.account_info = $scope.vm.accountInfo;
            }

            //申请客户权限
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'privilege') {
                $scope.vm.form.data.app_type = {
                    Name: '申请权限',
                    Value: '30'
                };
                $scope.vm.form.data.accountId = {
                    Id: $stateParams.accountId,
                    Name: $stateParams.accountIdName
                };
                $scope.vm.form.data.accountnumber = $scope.vm.preAccountNumber;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }
        };

        $scope.vm.form.GetDefaultSalesRegion = function () {
            accountService.GetSalesRegionInfo('').then(function (resp) {
                $scope.vm.salesRegionInfoList = resp.data;
            }).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除小区记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.vm.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.vm.salesRegionInfoList = _.remove($scope.vm.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegion").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.vm.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //新建客户-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=' + JSON.stringify(list) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品种。");
                return "必须提供品种。";
            }

            $scope.vm.salesRegionInfoList = $scope.rtIncludeParams;

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品种，不能再添加其他品种。");
                    return "已选择了全品种，不能再添加其他品种。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.vm.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.vm.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };

            $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.vm.salesRegionInfoList);
        };

        // 新建客户-编辑归属信息页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.vm.salesRegionInfoList = list;
        });

        $scope.vm.form.preBindFormData = function (data) {
            //新增客户、变更客户信息，需要先加载参数组
            if ($scope.vm.changeType === 'info') {
                myService.getAccountGradePickList().then(function (resp) {
                    $scope.vm.picklist.account_grade = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
                myService.getAccountTypePickList().then(function (resp) {
                    $scope.vm.picklist.accounttype = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
                myService.getAccountGradeLevelPickList().then(function (resp) {
                    $scope.vm.picklist.account_grade_level = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            }

            if ($scope.vm.form.type === 'Edit') {
                $scope.vm.accountInfo = data.account_info;
                $scope.vm.salesRegionInfoList = data.account_region_diff;
                //绑定标签列表
                $scope.vm.tagList = [];
                if (!rt.isNull($scope.vm.accountInfo.account_tag)) {
                    var tagstring = "";
                    for (var o in $scope.vm.accountInfo.account_tag) {
                        tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                        $scope.vm.tagList.push({
                            "value": tagstring,
                            "checked": false
                        });
                    }
                }
            }
        };

        $scope.vm.form.preLoad = function () {
            //新增客户信息
            if ($scope.vm.isCreateAccount) {
                //将搜索页面的机构名称带入
                $scope.vm.accountInfo.name = $stateParams.accountIdName;

                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }

            //变更客户信息
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'info') {
                //获取客户原信息
                myService.GetHospitalDetail($stateParams.accountId).then(function (resp) {
                    $scope.vm.accountInfo = resp.data;

                    $scope.vm.preAccountIdName = $scope.vm.accountInfo.name;
                    $scope.vm.preAccountNumber = $scope.vm.accountInfo.accountnumber;
                    //绑定标签列表
                    $scope.vm.tagList = [];
                    if (!rt.isNull($scope.vm.accountInfo.account_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.accountInfo.account_tag) {
                            tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                            $scope.vm.tagList.push({
                                "value": tagstring,
                                "checked": false
                            });
                        }
                    }
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
            }

            //申请客户权限
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'privilege') {
                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }
        };

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };

        //增加标签
        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/BusinessAccount/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        //删除标签
        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.tagList, {
                'checked': true
            });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.tagList = _.where($scope.vm.tagList, {
                'checked': false
            });
            tag = {};
            for (var i = 0; i < $scope.vm.tagList.length; i++) {
                var tagNameValueList = $scope.vm.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            }
            $scope.vm.accountInfo.account_tag = tag;
        };
    }]).controller('accountAppDrugstoreEditController', ['$injector', '$compile', '$scope', 'accountAppService', 'terminalaccountService', function ($injector, $compile, $scope, myService, terminalaccountService) {
        var rt = myService.rt;
        var $stateParams = myService.$stateParams;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        $scope.vm.changeType = $stateParams.changeType; //申请类型，info客户信息，privilege客户权限
        $scope.vm.isCreateAccount = rt.isNullOrEmptyString($stateParams.accountId) ? true : false; //是否新建客户
        $scope.vm.accountInfo = {};
        $scope.vm.salesRegionInfoList = [];
        $scope.delSelected = []; //归属信息删除列表
        $scope.isCheckAll = false;

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            if (data.Type === 'addTag') {
                var valueList = data.Value.split(/[,，]/);
                var list = [];
                for (var i = 0; i < valueList.length; i++) {
                    if (!rt.isNullOrWhiteSpace(valueList[i])) {
                        list.push(valueList[i]);
                    }
                }
                if (rt.isNull($scope.vm.accountInfo.account_tag)) {
                    $scope.vm.accountInfo.account_tag = {};
                }
                $scope.vm.accountInfo.account_tag[data.Name] = list;
                $scope.vm.tagList = [];
                var tagstring = "";
                for (var o in $scope.vm.accountInfo.account_tag) {
                    tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                    $scope.vm.tagList.push({
                        "value": tagstring,
                        "checked": false
                    });
                }
            } else return;
        });

        $scope.$watch('vm.accountInfo.provinceid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.accountInfo.cityid = null;
                $scope.vm.accountInfo.countyid = null;
                return;
            }
        });

        $scope.$watch('vm.accountInfo.cityid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.accountInfo.countyid = null;
                return;
            }
        });

        //保存之前
        $scope.vm.form.preSave = function (data) {
            //新建客户、申请客户权限
            if ($scope.vm.changeType === 'privilege' || $scope.vm.isCreateAccount) {
                if ($scope.vm.salesRegionInfoList.length == 0) {
                    rt.errorMessage("至少选择一条归属信息");
                    return "至少选择一条归属信息";
                }
            }

            //申请单字段赋值
            $scope.vm.form.data.accountclassificationcode = {
                Name: '零售终端',
                Value: '3'
            };

            //新增客户
            if ($scope.vm.isCreateAccount) {
                $scope.vm.accountInfo.accountclassificationcode = {
                    Name: '零售终端',
                    Value: '3'
                };

                $scope.vm.form.data.app_type = {
                    Name: '新增客户',
                    Value: '10'
                };
                $scope.vm.form.data.accountId = {
                    Id: '',
                    Name: $scope.vm.accountInfo.name
                };
                $scope.vm.form.data.account_info = $scope.vm.accountInfo;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }

            //变更客户信息
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'info') {
                $scope.vm.form.data.app_type = {
                    Name: '变更客户信息',
                    Value: '20'
                };
                $scope.vm.form.data.accountId = {
                    Id: $stateParams.accountId,
                    Name: $scope.vm.preAccountIdName
                };
                $scope.vm.form.data.accountnumber = $scope.vm.preAccountNumber;
                $scope.vm.form.data.account_info = $scope.vm.accountInfo;
            }

            //申请客户权限
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'privilege') {
                $scope.vm.form.data.app_type = {
                    Name: '申请权限',
                    Value: '30'
                };
                $scope.vm.form.data.accountId = {
                    Id: $stateParams.accountId,
                    Name: $stateParams.accountIdName
                };
                $scope.vm.form.data.accountnumber = $scope.vm.preAccountNumber;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }
        };

        $scope.vm.form.GetDefaultSalesRegion = function () {
            terminalaccountService.GetSalesRegionInfo('').then(function (resp) {
                $scope.vm.salesRegionInfoList = resp.data;
            }).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除小区记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.vm.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.vm.salesRegionInfoList = _.remove($scope.vm.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegion").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.vm.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //新建客户-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=' + JSON.stringify(list) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品种。");
                return "必须提供品种。";
            }

            $scope.vm.salesRegionInfoList = $scope.rtIncludeParams;

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品种，不能再添加其他品种。");
                    return "已选择了全品种，不能再添加其他品种。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.vm.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.vm.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };

            $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.vm.salesRegionInfoList);
        };

        // 新建客户-编辑归属信息页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.vm.salesRegionInfoList = list;
        });

        $scope.vm.form.preBindFormData = function (data) {
            //新增客户、变更客户信息，需要先加载参数组
            if ($scope.vm.changeType === 'info') {
                myService.getYaoTypePickList().then(function (resp) {
                    $scope.vm.picklist.yaotype = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
                myService.getStTypePickList().then(function (resp) {
                    $scope.vm.picklist.st_type = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
                myService.getAccountGradeLevelPickList().then(function (resp) {
                    $scope.vm.picklist.account_grade_level = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            }

            if ($scope.vm.form.type === 'Edit') {
                $scope.vm.accountInfo = data.account_info;
                $scope.vm.salesRegionInfoList = data.account_region_diff;
                //绑定标签列表
                $scope.vm.tagList = [];
                if (!rt.isNull($scope.vm.accountInfo.account_tag)) {
                    var tagstring = "";
                    for (var o in $scope.vm.accountInfo.account_tag) {
                        tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                        $scope.vm.tagList.push({
                            "value": tagstring,
                            "checked": false
                        });
                    }
                }
            }
        };

        $scope.vm.form.preLoad = function () {
            //新增客户信息
            if ($scope.vm.isCreateAccount) {
                //将搜索页面的机构名称带入
                $scope.vm.accountInfo.name = $stateParams.accountIdName;

                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }

            //变更客户信息
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'info') {
                //获取客户原信息
                myService.GetDrugstorelDetail($stateParams.accountId).then(function (resp) {
                    $scope.vm.accountInfo = resp.data;

                    $scope.vm.preAccountIdName = $scope.vm.accountInfo.name;
                    $scope.vm.preAccountNumber = $scope.vm.accountInfo.accountnumber;
                    //绑定标签列表
                    $scope.vm.tagList = [];
                    if (!rt.isNull($scope.vm.accountInfo.account_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.accountInfo.account_tag) {
                            tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                            $scope.vm.tagList.push({
                                "value": tagstring,
                                "checked": false
                            });
                        }
                    }
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
            }

            //申请客户权限
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'privilege') {
                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }
        };

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };

        //增加标签
        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/BusinessAccount/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        //删除标签
        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.tagList, {
                'checked': true
            });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.tagList = _.where($scope.vm.tagList, {
                'checked': false
            });
            tag = {};
            for (var i = 0; i < $scope.vm.tagList.length; i++) {
                var tagNameValueList = $scope.vm.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            }
            $scope.vm.accountInfo.account_tag = tag;
        };
    }]).controller('accountAppBasicEditController', ['$injector', '$compile', '$scope', 'accountAppService', 'BasicMedicalService', function ($injector, $compile, $scope, myService, BasicMedicalService) {
        var rt = myService.rt;
        var $stateParams = myService.$stateParams;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        $scope.vm.changeType = $stateParams.changeType; //申请类型，info客户信息，privilege客户权限
        $scope.vm.isCreateAccount = rt.isNullOrEmptyString($stateParams.accountId) ? true : false; //是否新建客户
        $scope.vm.accountInfo = {};
        $scope.vm.salesRegionInfoList = [];
        $scope.delSelected = []; //归属信息删除列表
        $scope.isCheckAll = false;

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            if (data.Type === 'addTag') {
                var valueList = data.Value.split(/[,，]/);
                var list = [];
                for (var i = 0; i < valueList.length; i++) {
                    if (!rt.isNullOrWhiteSpace(valueList[i])) {
                        list.push(valueList[i]);
                    }
                }
                if (rt.isNull($scope.vm.accountInfo.account_tag)) {
                    $scope.vm.accountInfo.account_tag = {};
                }
                $scope.vm.accountInfo.account_tag[data.Name] = list;
                $scope.vm.tagList = [];
                var tagstring = "";
                for (var o in $scope.vm.accountInfo.account_tag) {
                    tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                    $scope.vm.tagList.push({
                        "value": tagstring,
                        "checked": false
                    });
                }
            } else return;
        });

        $scope.$watch('vm.accountInfo.provinceid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.accountInfo.cityid = null;
                $scope.vm.accountInfo.countyid = null;
                return;
            }
        });

        $scope.$watch('vm.accountInfo.cityid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.accountInfo.countyid = null;
                return;
            }
        });

        //保存之前
        $scope.vm.form.preSave = function (data) {
            //新建客户、申请客户权限
            if ($scope.vm.changeType === 'privilege' || $scope.vm.isCreateAccount) {
                if ($scope.vm.salesRegionInfoList.length == 0) {
                    rt.errorMessage("至少选择一条归属信息");
                    return "至少选择一条归属信息";
                }
            }

            //申请单字段赋值
            $scope.vm.form.data.accountclassificationcode = {
                Name: '基层医疗机构',
                Value: '4'
            };

            //新增客户
            if ($scope.vm.isCreateAccount) {
                $scope.vm.accountInfo.accountclassificationcode = {
                    Name: '基层医疗机构',
                    Value: '4'
                };

                $scope.vm.form.data.app_type = {
                    Name: '新增客户',
                    Value: '10'
                };
                $scope.vm.form.data.accountId = {
                    Id: '',
                    Name: $scope.vm.accountInfo.name
                };
                $scope.vm.form.data.account_info = $scope.vm.accountInfo;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }

            //变更客户信息
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'info') {
                $scope.vm.form.data.app_type = {
                    Name: '变更客户信息',
                    Value: '20'
                };
                $scope.vm.form.data.accountId = {
                    Id: $stateParams.accountId,
                    Name: $scope.vm.preAccountIdName
                };
                $scope.vm.form.data.accountnumber = $scope.vm.preAccountNumber;
                $scope.vm.form.data.account_info = $scope.vm.accountInfo;
            }

            //申请客户权限
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'privilege') {
                $scope.vm.form.data.app_type = {
                    Name: '申请权限',
                    Value: '30'
                };
                $scope.vm.form.data.accountId = {
                    Id: $stateParams.accountId,
                    Name: $stateParams.accountIdName
                };
                $scope.vm.form.data.accountnumber = $scope.vm.preAccountNumber;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }
        };

        $scope.vm.form.GetDefaultSalesRegion = function () {
            BasicMedicalService.GetSalesRegionInfo('').then(function (resp) {
                $scope.vm.salesRegionInfoList = resp.data;
            }).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除小区记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.vm.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.vm.salesRegionInfoList = _.remove($scope.vm.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegion").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.vm.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //新建客户-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=' + JSON.stringify(list) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品种。");
                return "必须提供品种。";
            }

            $scope.vm.salesRegionInfoList = $scope.rtIncludeParams;

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品种，不能再添加其他品种。");
                    return "已选择了全品种，不能再添加其他品种。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.vm.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.vm.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };

            $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.vm.salesRegionInfoList);
        };

        // 新建客户-编辑归属信息页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.vm.salesRegionInfoList = list;
        });

        $scope.vm.form.preBindFormData = function (data) {
            //新增客户、变更客户信息，需要先加载参数组
            if ($scope.vm.changeType === 'info') {
                myService.getOrgTypePickList().then(function (resp) {
                    $scope.vm.picklist.orgtype = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
                myService.getAccountGradeLevelPickList().then(function (resp) {
                    $scope.vm.picklist.account_grade_level = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            }

            if ($scope.vm.form.type === 'Edit') {
                $scope.vm.accountInfo = data.account_info;
                $scope.vm.salesRegionInfoList = data.account_region_diff;
                //绑定标签列表
                $scope.vm.tagList = [];
                if (!rt.isNull($scope.vm.accountInfo.account_tag)) {
                    var tagstring = "";
                    for (var o in $scope.vm.accountInfo.account_tag) {
                        tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                        $scope.vm.tagList.push({
                            "value": tagstring,
                            "checked": false
                        });
                    }
                }
            }
        };

        $scope.vm.form.preLoad = function () {
            //新增客户信息
            if ($scope.vm.isCreateAccount) {
                //将搜索页面的机构名称带入
                $scope.vm.accountInfo.name = $stateParams.accountIdName;

                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }

            //变更客户信息
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'info') {
                //获取客户原信息
                myService.GetBasicDetail($stateParams.accountId).then(function (resp) {
                    $scope.vm.accountInfo = resp.data;

                    $scope.vm.preAccountIdName = $scope.vm.accountInfo.name;
                    $scope.vm.preAccountNumber = $scope.vm.accountInfo.accountnumber;
                    //绑定标签列表
                    $scope.vm.tagList = [];
                    if (!rt.isNull($scope.vm.accountInfo.account_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.accountInfo.account_tag) {
                            tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                            $scope.vm.tagList.push({
                                "value": tagstring,
                                "checked": false
                            });
                        }
                    }
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
            }

            //申请客户权限
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'privilege') {
                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }
        };

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };

        //增加标签
        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/BusinessAccount/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        //删除标签
        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.tagList, {
                'checked': true
            });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.tagList = _.where($scope.vm.tagList, {
                'checked': false
            });
            tag = {};
            for (var i = 0; i < $scope.vm.tagList.length; i++) {
                var tagNameValueList = $scope.vm.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            }
            $scope.vm.accountInfo.account_tag = tag;
        };
    }]).controller('accountAppAgentEditController', ['$injector', '$compile', '$scope', 'accountAppService', 'agentService', function ($injector, $compile, $scope, myService, agentService) {
        var rt = myService.rt;
        var $stateParams = myService.$stateParams;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        $scope.vm.changeType = $stateParams.changeType; //申请类型，info客户信息，privilege客户权限
        $scope.vm.isCreateAccount = rt.isNullOrEmptyString($stateParams.accountId) ? true : false; //是否新建客户
        $scope.vm.accountInfo = {};
        $scope.vm.salesRegionInfoList = [];
        $scope.delSelected = []; //归属信息删除列表
        $scope.isCheckAll = false;

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            if (data.Type === 'addTag') {
                var valueList = data.Value.split(/[,，]/);
                var list = [];
                for (var i = 0; i < valueList.length; i++) {
                    if (!rt.isNullOrWhiteSpace(valueList[i])) {
                        list.push(valueList[i]);
                    }
                }
                if (rt.isNull($scope.vm.accountInfo.account_tag)) {
                    $scope.vm.accountInfo.account_tag = {};
                }
                $scope.vm.accountInfo.account_tag[data.Name] = list;
                $scope.vm.tagList = [];
                var tagstring = "";
                for (var o in $scope.vm.accountInfo.account_tag) {
                    tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                    $scope.vm.tagList.push({
                        "value": tagstring,
                        "checked": false
                    });
                }
            } else return;
        });

        $scope.$watch('vm.accountInfo.provinceid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.accountInfo.cityid = null;
                $scope.vm.accountInfo.countyid = null;
                return;
            }
        });

        $scope.$watch('vm.accountInfo.cityid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.accountInfo.countyid = null;
                return;
            }
        });

        //保存之前
        $scope.vm.form.preSave = function (data) {
            //新建客户、申请客户权限
            if ($scope.vm.changeType === 'privilege' || $scope.vm.isCreateAccount) {
                if ($scope.vm.salesRegionInfoList.length == 0) {
                    rt.errorMessage("至少选择一条归属信息");
                    return "至少选择一条归属信息";
                }
            }

            //申请单字段赋值
            $scope.vm.form.data.accountclassificationcode = {
                Name: '代理商',
                Value: '5'
            };

            //新增客户
            if ($scope.vm.isCreateAccount) {
                $scope.vm.accountInfo.accountclassificationcode = {
                    Name: '代理商',
                    Value: '5'
                };

                $scope.vm.form.data.app_type = {
                    Name: '新增客户',
                    Value: '10'
                };
                $scope.vm.form.data.accountId = {
                    Id: '',
                    Name: $scope.vm.accountInfo.name
                };
                $scope.vm.form.data.account_info = $scope.vm.accountInfo;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }

            //变更客户信息
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'info') {
                $scope.vm.form.data.app_type = {
                    Name: '变更客户信息',
                    Value: '20'
                };
                $scope.vm.form.data.accountId = {
                    Id: $stateParams.accountId,
                    Name: $scope.vm.preAccountIdName
                };
                $scope.vm.form.data.accountnumber = $scope.vm.preAccountNumber;
                $scope.vm.form.data.account_info = $scope.vm.accountInfo;
            }

            //申请客户权限
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'privilege') {
                $scope.vm.form.data.app_type = {
                    Name: '申请权限',
                    Value: '30'
                };
                $scope.vm.form.data.accountId = {
                    Id: $stateParams.accountId,
                    Name: $stateParams.accountIdName
                };
                $scope.vm.form.data.accountnumber = $scope.vm.preAccountNumber;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }
        };

        $scope.vm.form.GetDefaultSalesRegion = function () {
            agentService.GetSalesRegionInfo('').then(function (resp) {
                $scope.vm.salesRegionInfoList = resp.data;
            }).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除小区记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.vm.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.vm.salesRegionInfoList = _.remove($scope.vm.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegion").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.vm.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //新建客户-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=' + JSON.stringify(list) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品种。");
                return "必须提供品种。";
            }

            $scope.vm.salesRegionInfoList = $scope.rtIncludeParams;

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品种，不能再添加其他品种。");
                    return "已选择了全品种，不能再添加其他品种。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.vm.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.vm.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };

            $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.vm.salesRegionInfoList);
        };

        // 新建客户-编辑归属信息页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.vm.salesRegionInfoList = list;
        });

        $scope.vm.form.preBindFormData = function (data) {
            //新增客户、变更客户信息，需要先加载参数组
            if ($scope.vm.changeType === 'info') {
                myService.getAgentTypePickList().then(function (resp) {
                    $scope.vm.picklist.agent_type = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
                myService.getAccountGradeLevelPickList().then(function (resp) {
                    $scope.vm.picklist.account_grade_level = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            }

            if ($scope.vm.form.type === 'Edit') {
                $scope.vm.accountInfo = data.account_info;
                $scope.vm.salesRegionInfoList = data.account_region_diff;
                //绑定标签列表
                $scope.vm.tagList = [];
                if (!rt.isNull($scope.vm.accountInfo.account_tag)) {
                    var tagstring = "";
                    for (var o in $scope.vm.accountInfo.account_tag) {
                        tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                        $scope.vm.tagList.push({
                            "value": tagstring,
                            "checked": false
                        });
                    }
                }
            }
        };

        $scope.vm.form.preLoad = function () {
            //新增客户信息
            if ($scope.vm.isCreateAccount) {
                //将搜索页面的机构名称带入
                $scope.vm.accountInfo.name = $stateParams.accountIdName;

                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }

            //变更客户信息
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'info') {
                //获取客户原信息
                myService.GetAgentDetail($stateParams.accountId).then(function (resp) {
                    $scope.vm.accountInfo = resp.data;

                    $scope.vm.preAccountIdName = $scope.vm.accountInfo.name;
                    $scope.vm.preAccountNumber = $scope.vm.accountInfo.accountnumber;
                    //绑定标签列表
                    $scope.vm.tagList = [];
                    if (!rt.isNull($scope.vm.accountInfo.account_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.accountInfo.account_tag) {
                            tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                            $scope.vm.tagList.push({
                                "value": tagstring,
                                "checked": false
                            });
                        }
                    }
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
            }

            //申请客户权限
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'privilege') {
                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }
        };

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };

        //增加标签
        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/BusinessAccount/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        //删除标签
        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.tagList, {
                'checked': true
            });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.tagList = _.where($scope.vm.tagList, {
                'checked': false
            });
            tag = {};
            for (var i = 0; i < $scope.vm.tagList.length; i++) {
                var tagNameValueList = $scope.vm.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            }
            $scope.vm.accountInfo.account_tag = tag;
        };
    }]).controller('accountAppChainEditController', ['$injector', '$compile', '$scope', 'accountAppService', 'chainaccountService', function ($injector, $compile, $scope, myService, chainaccountService) {
        var rt = myService.rt;
        var $stateParams = myService.$stateParams;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        $scope.vm.changeType = $stateParams.changeType; //申请类型，info客户信息，privilege客户权限
        $scope.vm.isCreateAccount = rt.isNullOrEmptyString($stateParams.accountId) ? true : false; //是否新建客户
        $scope.vm.accountInfo = {};
        $scope.vm.salesRegionInfoList = [];
        $scope.delSelected = []; //归属信息删除列表
        $scope.isCheckAll = false;

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            if (data.Type === 'addTag') {
                var valueList = data.Value.split(/[,，]/);
                var list = [];
                for (var i = 0; i < valueList.length; i++) {
                    if (!rt.isNullOrWhiteSpace(valueList[i])) {
                        list.push(valueList[i]);
                    }
                }
                if (rt.isNull($scope.vm.accountInfo.account_tag)) {
                    $scope.vm.accountInfo.account_tag = {};
                }
                $scope.vm.accountInfo.account_tag[data.Name] = list;
                $scope.vm.tagList = [];
                var tagstring = "";
                for (var o in $scope.vm.accountInfo.account_tag) {
                    tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                    $scope.vm.tagList.push({
                        "value": tagstring,
                        "checked": false
                    });
                }
            } else return;
        });

        $scope.$watch('vm.accountInfo.provinceid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.accountInfo.cityid = null;
                $scope.vm.accountInfo.countyid = null;
                return;
            }
        });

        $scope.$watch('vm.accountInfo.cityid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.accountInfo.countyid = null;
                return;
            }
        });

        //保存之前
        $scope.vm.form.preSave = function (data) {
            //新建客户、申请客户权限
            if ($scope.vm.changeType === 'privilege' || $scope.vm.isCreateAccount) {
                if ($scope.vm.salesRegionInfoList.length == 0) {
                    rt.errorMessage("至少选择一条归属信息");
                    return "至少选择一条归属信息";
                }
            }

            //申请单字段赋值
            $scope.vm.form.data.accountclassificationcode = {
                Name: '连锁总部',
                Value: '6'
            };

            //新增客户
            if ($scope.vm.isCreateAccount) {
                $scope.vm.accountInfo.accountclassificationcode = {
                    Name: '连锁总部',
                    Value: '6'
                };

                $scope.vm.form.data.app_type = {
                    Name: '新增客户',
                    Value: '10'
                };
                $scope.vm.form.data.accountId = {
                    Id: '',
                    Name: $scope.vm.accountInfo.name
                };
                $scope.vm.form.data.account_info = $scope.vm.accountInfo;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }

            //变更客户信息
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'info') {
                $scope.vm.form.data.app_type = {
                    Name: '变更客户信息',
                    Value: '20'
                };
                $scope.vm.form.data.accountId = {
                    Id: $stateParams.accountId,
                    Name: $scope.vm.preAccountIdName
                };
                $scope.vm.form.data.accountnumber = $scope.vm.preAccountNumber;
                $scope.vm.form.data.account_info = $scope.vm.accountInfo;
            }

            //申请客户权限
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'privilege') {
                $scope.vm.form.data.app_type = {
                    Name: '申请权限',
                    Value: '30'
                };
                $scope.vm.form.data.accountId = {
                    Id: $stateParams.accountId,
                    Name: $stateParams.accountIdName
                };
                $scope.vm.form.data.accountnumber = $scope.vm.preAccountNumber;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }
        };

        $scope.vm.form.GetDefaultSalesRegion = function () {
            chainaccountService.GetSalesRegionInfo('').then(function (resp) {
                $scope.vm.salesRegionInfoList = resp.data;
            }).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除小区记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.vm.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.vm.salesRegionInfoList = _.remove($scope.vm.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegion").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.vm.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //新建客户-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=' + JSON.stringify(list) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品种。");
                return "必须提供品种。";
            }

            $scope.vm.salesRegionInfoList = $scope.rtIncludeParams;

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品种，不能再添加其他品种。");
                    return "已选择了全品种，不能再添加其他品种。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.vm.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.vm.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };

            $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.vm.salesRegionInfoList);
        };

        // 新建客户-编辑归属信息页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.vm.salesRegionInfoList = list;
        });

        $scope.vm.form.preBindFormData = function (data) {
            //新增客户、变更客户信息，需要先加载参数组
            if ($scope.vm.changeType === 'info') {
                myService.getChainTypePickList().then(function (resp) {
                    $scope.vm.picklist.chain_type = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
                myService.getAccountGradeLevelPickList().then(function (resp) {
                    $scope.vm.picklist.account_grade_level = resp.data;
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
            }

            if ($scope.vm.form.type === 'Edit') {
                $scope.vm.accountInfo = data.account_info;
                $scope.vm.salesRegionInfoList = data.account_region_diff;
                //绑定标签列表
                $scope.vm.tagList = [];
                if (!rt.isNull($scope.vm.accountInfo.account_tag)) {
                    var tagstring = "";
                    for (var o in $scope.vm.accountInfo.account_tag) {
                        tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                        $scope.vm.tagList.push({
                            "value": tagstring,
                            "checked": false
                        });
                    }
                }
            }
        };

        $scope.vm.form.preLoad = function () {
            //新增客户信息
            if ($scope.vm.isCreateAccount) {
                //将搜索页面的机构名称带入
                $scope.vm.accountInfo.name = $stateParams.accountIdName;

                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }

            //变更客户信息
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'info') {
                //获取客户原信息
                myService.GetChainDetail($stateParams.accountId).then(function (resp) {
                    $scope.vm.accountInfo = resp.data;

                    $scope.vm.preAccountIdName = $scope.vm.accountInfo.name;
                    $scope.vm.preAccountNumber = $scope.vm.accountInfo.accountnumber;
                    //绑定标签列表
                    $scope.vm.tagList = [];
                    if (!rt.isNull($scope.vm.accountInfo.account_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.accountInfo.account_tag) {
                            tagstring = o + "：" + $scope.vm.accountInfo.account_tag[o];
                            $scope.vm.tagList.push({
                                "value": tagstring,
                                "checked": false
                            });
                        }
                    }
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
            }

            //申请客户权限
            if (!$scope.vm.isCreateAccount && $scope.vm.changeType === 'privilege') {
                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }
        };

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };

        //增加标签
        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/BusinessAccount/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        //删除标签
        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.tagList, {
                'checked': true
            });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.tagList = _.where($scope.vm.tagList, {
                'checked': false
            });
            tag = {};
            for (var i = 0; i < $scope.vm.tagList.length; i++) {
                var tagNameValueList = $scope.vm.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            }
            $scope.vm.accountInfo.account_tag = tag;
        };
    }]);
})();
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/4/28
 *说明：商业库存
 *************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('accountinvService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'AccountInv';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('accountinvListController', ['$injector', '$scope', '$timeout', 'accountinvService', function ($injector, $scope, $timeout, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;
        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && $scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }
            if (!rt.isNullOrWhiteSpace($scope.vm.eYm) && _CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                return "开始日期必须小于结束日期";
            }

            if (!rt.isNull($scope.vm.productSelected) && $scope.vm.productSelected.length > 0) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                that.searchList.push({ Type: 2, key: "productid", Value: pmap });
            }
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdepartid", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "account_BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.accountName) && $scope.vm.accountName != "") {
                that.searchList.push({ Type: 0, key: "accountidName", Value: $scope.vm.accountName });
            }
            if (!rt.isNull($scope.vm.ownerIdName) && $scope.vm.ownerIdName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.ownerIdName });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";

            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && $scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }
            if (!rt.isNullOrWhiteSpace($scope.vm.eYm) && _CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                return "开始日期必须小于结束日期";
            }

            if (!rt.isNull($scope.vm.productSelected) && $scope.vm.productSelected.length > 0) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                that.searchList.push({ Type: 2, key: "productid", Value: pmap });
            }
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdepartid", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "account_BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.accountName) && $scope.vm.accountName != "") {
                that.searchList.push({ Type: 0, key: "accountidName", Value: $scope.vm.accountName });
            }
            if (!rt.isNull($scope.vm.ownerIdName) && $scope.vm.ownerIdName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.ownerIdName });
            }
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        _getAllBuid();
        _getAllProduct();

        //重写import方法
        $scope.vm.actions.import = function (headerMap) {
            $scope.importHeader = headerMap;
            BootstrapDialog.show({
                type: BootstrapDialog.TYPE_PRIMARY,
                title: '导入' + $scope.importHeader.Title,
                message: '<div rt-include rt-template="Module/AccountInv/accountinvExcelImportView.html" rt-controller="accountinvExcelImportController" ></div>',
                size: BootstrapDialog.SIZE_NORMAL,
                closable: true,
                onshow: function onshow(dialog) {
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
        $scope.overHeightTable = function () {
            overHeightTable();
        };
        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }
        //所有药品
        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = [];
            });
        }

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
            }, function (error) {
                $scope.vm.buidList = [];
            });
        }

        //获取上游商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            $scope.vm.bigDepSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.businessUnitSelected = null;
            $scope.vm.businessUnitList = [];
            $scope.vm.view.search(1);
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) return;

            rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                $scope.vm.bigDepList = resp.DataList;
            }, function (error) {
                $scope.vm.bigDepList = [];
            });
        });
        //获取上游省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];return;
            }
            $scope.vm.businessUnitSelected = null;
            $scope.vm.businessUnitList = [];
            $scope.vm.view.search(1);
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) return;

            rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.businessUnitList = data;
                }
            }, function (error) {
                $scope.vm.businessUnitList = [];
            });
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-10-12
 说明     : 客户价格表
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('AccountPriceService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'AccountPrice';

        // @@ 选项集
        this.picklists = ['Action_status'];
    }]).controller('accountpriceListController', ['$injector', '$scope', 'AccountPriceService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var that = this;
        this.searchList = [];

        this.preSearch = function (params) {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.accountid)) {
                that.searchList.push({ Type: 1, Key: "accountid", Value: $scope.vm.accountid.Id });
            }
            if (!rt.isNull($scope.vm.productid)) {
                that.searchList.push({ Type: 1, Key: "productid", Value: $scope.vm.productid.Id });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('accountpriceEditController', ['$injector', '$scope', 'AccountPriceService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //检查条件
        function _checkOption() {
            if (!rt.isNullOrEmptyString($scope.vm.form.data.begindate) && !rt.isNullOrEmptyString($scope.vm.form.data.enddate)) {
                if (moment($scope.vm.form.data.begindate).format('YYYY-MM-DD') > moment($scope.vm.form.data.enddate).format('YYYY-MM-DD')) {
                    return "有效期-止必须大于等于有效期-从。";
                }
            }
            return "";
        }

        //保存按钮
        $scope.vm.form.newsave = function (flag) {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            } else {
                $scope.vm.form.save(flag);
            }
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Eric Zheng
 创建时间 :2018-03-01
 说明     : 商业返利系数
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('accountRebateRateService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'AccountRebateRate';

        // @@ 选项集
        this.picklists = ['StateCode'];
        this.getProductSize = function (id) {
            var url = 'api/Product/GetProductById?id=' + id;
            return rt.get(url);
        };
    }]).controller('accountRebateRateListController', ['$injector', '$scope', 'accountRebateRateService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        this.searchList = [];
        this.isPost = true;
        var _that = this;
        this.bodySearchList = [];
        this.preExport = function (params) {
            _that.searchList.length = 0;
            _that.bodySearchList.length = 0;
            if (!rt.isNull($scope.vm.stateSelected)) {
                _that.searchList.push({
                    Type: 1,
                    Key: "StateCode",
                    Value: $scope.vm.stateSelected.Value
                });
            }
            if (!rt.isNull($scope.vm.searchList.sYm) && !rt.isNull($scope.vm.searchList.eYm)) {
                _that.searchList.push({
                    Type: 3,
                    Key: "start_date",
                    Value: [$scope.vm.searchList.sYm, moment(new Date($scope.vm.searchList.eYm)).add(1, 'days').format('YYYY-MM-DD')]
                });
            }
            if (!rt.isNull($scope.vm.nodeSelected)) {
                var idArray = $scope.vm.nodeSelected.ids.split(",");
                _that.bodySearchList.push({
                    Type: 2,
                    Key: "BusinessUnitId",
                    Value: idArray
                });
            }
            if (!rt.isNull($scope.vm.searchList.fromAccId)) {
                _that.searchList.push({
                    Type: 1,
                    Key: "from_accountid",
                    Value: $scope.vm.searchList.fromAccId.Id
                });
            }
            if (!rt.isNull($scope.vm.searchList.toAccId)) {
                _that.searchList.push({
                    Type: 1,
                    Key: "to_accountid",
                    Value: $scope.vm.searchList.toAccId.Id
                });
            }
            if (!rt.isNull($scope.vm.searchList.productId)) {
                _that.searchList.push({
                    Type: 1,
                    Key: "productid",
                    Value: $scope.vm.searchList.productId.Id
                });
            }
        };

        this.preSearch = function (params) {
            _that.searchList.length = 0;
            _that.bodySearchList.length = 0;
            if (!rt.isNull($scope.vm.stateSelected)) {
                _that.searchList.push({
                    Type: 1,
                    Key: "StateCode",
                    Value: $scope.vm.stateSelected.Value
                });
            }
            if (!rt.isNull($scope.vm.searchList.sYm) && !rt.isNull($scope.vm.searchList.eYm)) {
                _that.searchList.push({
                    Type: 3,
                    Key: "start_date",
                    Value: [$scope.vm.searchList.sYm, moment(new Date($scope.vm.searchList.eYm)).add(1, 'days').format('YYYY-MM-DD')]
                });
            }
            if (!rt.isNull($scope.vm.nodeSelected)) {
                var idArray = $scope.vm.nodeSelected.ids.split(",");
                _that.bodySearchList.push({
                    Type: 2,
                    Key: "BusinessUnitId",
                    Value: idArray
                });
            }
            if (!rt.isNull($scope.vm.searchList.fromAccId)) {
                _that.searchList.push({
                    Type: 1,
                    Key: "from_accountid",
                    Value: $scope.vm.searchList.fromAccId.Id
                });
            }
            if (!rt.isNull($scope.vm.searchList.toAccId)) {
                _that.searchList.push({
                    Type: 1,
                    Key: "to_accountid",
                    Value: $scope.vm.searchList.toAccId.Id
                });
            }
            if (!rt.isNull($scope.vm.searchList.productId)) {
                _that.searchList.push({
                    Type: 1,
                    Key: "productid",
                    Value: $scope.vm.searchList.productId.Id
                });
            }
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('accountRebateRateEditController', ['$injector', '$scope', 'accountRebateRateService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        //保存前
        $scope.vm.form.preSave = function () {
            var arrS = $scope.vm.form.data.start_date.split("-");
            var arrE = $scope.vm.form.data.end_date.split("-");
            var starttime = new Date(arrS[0], arrS[1], arrS[2].substring(0, 2));
            var endtime = new Date(arrE[0], arrE[1], arrE[2].substring(0, 2));
            if (starttime.getTime() > endtime.getTime()) {
                rt.warningMessage("失效日期不能小于生效日期");
                return "失效日期不能小于生效日期";
            }
        };

        $scope.$watch("vm.form.data.productid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                //带出药品规格
                myService.getProductSize($scope.vm.form.data.productid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.form.data.product_size = resp.data.productsize;
                    } else {
                        $scope.vm.form.data.product_size = '';
                    }
                });
                return;
            }
        });
    }]);
})();
'use strict';

/*************************************************
* Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
*创建人： Oscar Gao
*创建时间：2016/4/28
*说明：商业安全库存
*************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('accountsafeinvService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'AccountSafeInv';
        // @@ 选项集
        this.picklists = ['StateCode'];
        this.getProductSize = function (id) {
            var url = 'api/Product/GetProductById?id=' + id;
            return rt.get(url);
        };
    }]).controller('accountsafeinvListController', ['$injector', '$scope', 'accountsafeinvService', function ($injector, $scope, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;
        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";

            if (!rt.isNull($scope.vm.productSelected) && $scope.vm.productSelected.length > 0) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                that.searchList.push({ Type: 2, key: "productid", Value: pmap });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdepartid", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.accountName) && $scope.vm.accountName != "") {
                that.searchList.push({ Type: 0, key: "accountidName", Value: $scope.vm.accountName });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";

            if (!rt.isNull($scope.vm.productSelected) && $scope.vm.productSelected.length > 0) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                that.searchList.push({ Type: 2, key: "productid", Value: pmap });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdepartid", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = $scope.vm.businessUnitSelected.map(function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.accountName) && $scope.vm.accountName != "") {
                that.searchList.push({ Type: 0, key: "accountidName", Value: $scope.vm.accountName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        _getAllProduct();
        _getAllBuid();

        //所有药品
        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = [];
            });
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
            }, function (error) {
                $scope.vm.buidList = [];
            });
        }

        //获取上游商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            $scope.vm.bigDepSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.businessUnitSelected = null;
            $scope.vm.businessUnitList = [];
            $scope.vm.view.search(1);
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) return;

            rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                $scope.vm.bigDepList = resp.DataList;
            }, function (error) {
                $scope.vm.bigDepList = [];
            });
        });
        //获取上游省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];return;
            }
            $scope.vm.businessUnitSelected = null;
            $scope.vm.businessUnitList = [];
            $scope.vm.view.search(1);
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) return;

            rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.businessUnitList = data;
                }
            }, function (error) {
                $scope.vm.businessUnitList = [];
            });
        });
    }]).controller('accountsafeinvEditController', ['$injector', '$scope', 'accountsafeinvService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        //带出药品规格
        $scope.$watch("vm.form.data.productid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                //带出药品规格
                myService.getProductSize($scope.vm.form.data.productid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.form.data.productsize = resp.data.productsize;
                    } else {
                        $scope.vm.form.data.productsize = '';
                    }
                });
                return;
            }
        });
        //保存前
        $scope.vm.form.preSave = function () {
            var inv_qty = $scope.vm.form.data.safe_inv_count;
            if (parseInt(inv_qty) <= 0) {
                rt.errorMessage("安全库存必须大于0");
                return "安全库存必须大于0";
            }
        };

        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/**
 * /********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2017/12/12
 说明     : 客户-标签类型
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('accountTagTypeService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'AccountTagType';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('accountTagTypeListController', ['$injector', '$compile', '$scope', 'accountTagTypeService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('accountTagTypeEditController', ['$injector', '$scope', 'accountTagTypeService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.preSave = function () {
            var re = /[,:;，：；]/gi;
            if (re.test($scope.vm.form.data.name.trim())) {
                rt.errorMessage("名称不能有特殊字符。");
                return "名称不能有特殊字符。";
            }
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-03-12
 说明     : 客户拜访
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('accountVisitService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'AccountVisit';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getAttachmentList = function (id) {
            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };

        //获取客户类型
        this.GetAccountTypeById = function (accountId) {
            return rt.get("api/Account/GetAccountTypeById?accountId=" + accountId);
        };

        //根据客户类型获取拜访目的
        this.getVisitPurpose = function (code) {
            return rt.get("api/SystemParam/GetSystemParamByCode?code=" + code);
        };

        this.GetDepartmentByContactId = function (contactId) {
            return rt.get("api/Department/GetDepartmentByContactId?contactId=" + contactId);
        };

        this.getDbDateTime = function () {
            var apiUrl = "api/VisitRecord/GetDbDateTime";
            return rt.get(apiUrl);
        };
    }]).controller('accountVisitListController', ['$injector', '$scope', '$compile', 'accountVisitService', function ($injector, $scope, $compile, myService) {
        var rt = myService.rt;
        $scope.viewTag = "Web";
        this.viewTag = "Web";
        this.isPost = true;

        var that = this;
        this.searchList = [];
        this.bodySearchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
            that.bodySearchList.length = 0;
            if (!rt.isNull($scope.vm.visitStatusSelected) && !rt.isNull($scope.vm.visitStatusSelected.id)) {
                that.searchList.push({ Type: 1, Key: "visit_status", Value: $scope.vm.visitStatusSelected.id });
            }
            if (!rt.isNull($scope.vm.sYm) && !rt.isNull($scope.vm.eYm)) {
                that.searchList.push({ Type: 3, Key: "start_time,plan_time,end_time", Value: [moment($scope.vm.sYm).format('YYYY-MM-DD'), moment($scope.vm.eYm).add('days', 1).format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.nodeSelected) && !rt.isNull($scope.vm.nodeSelected.ids)) {
                that.bodySearchList.push({ Type: 2, Key: "businessunitid", Value: $scope.vm.nodeSelected.ids.split(",") });
            }
        };

        this.preExport = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.visitStatusSelected) && !rt.isNull($scope.vm.visitStatusSelected.id)) {
                that.searchList.push({ Type: 1, Key: "visit_status", Value: $scope.vm.visitStatusSelected.id });
            }
            if (!rt.isNull($scope.vm.sYm) && !rt.isNull($scope.vm.eYm)) {
                that.searchList.push({ Type: 3, Key: "start_time,plan_time,end_time", Value: [moment($scope.vm.sYm).format('YYYY-MM-DD'), moment($scope.vm.eYm).add('days', 1).format('YYYY-MM-DD')] });
            }
            if (!rt.isNull($scope.vm.nodeSelected) && !rt.isNull($scope.vm.nodeSelected.ids)) {
                that.searchList.push({ Type: 2, Key: "businessunitid", Value: $scope.vm.nodeSelected.ids.split(",") });
            }
            that.searchList.push({ Type: 1, Key: "viewId", Value: $scope.vm.view.selectedView.Id });
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.sYm = moment(moment().format('YYYY-MM') + '-01').toDate();
        $scope.vm.eYm = moment(moment().format("YYYY-MM-DD")).toDate();
        _getAllBuid();

        //获取拜访类型
        function _getAllBuid() {
            rt.queryData("VisitRecord.GetVisitStatus", { '@queryValue': '' }, function (resp) {
                $scope.vm.visitStatusList = resp.DataList;
            }, function (error) {
                $scope.vm.visitStatusList = [];
            });
        }

        $scope.vm.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
    }]).controller('accountVisitEditController', ['$injector', '$scope', 'accountVisitService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        function _getAllOwner() {
            rt.queryData("UserInfo.GetAllUser", { '@queryValue': '' }, function (resp) {
                $scope.OwnerList = [];
                var data = resp.DataList;
                for (var i = 0; i < data.length; i++) {
                    $scope.OwnerList.push({ Id: data[i].id, Name: data[i].name });
                }
            }, function (error) {});
        }

        $scope.vm.form.preLoad = function (data) {
            //获取所有代表
            _getAllOwner();
            if ($scope.vm.form.type === 'Edit') {
                myService.getAttachmentList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.attachmentList = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }
            myService.getDbDateTime().then(function (d) {
                $scope.vm.tomorrow = moment(d.data, 'YYYY-MM-DD').add('days', 1).toDate();
            });
        };

        $scope.$watch("vm.form.data.accountid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                var accType = "";
                myService.GetAccountTypeById(newValue).then(function (resp) {
                    switch (resp.data) {
                        case 1:
                            accType = "business_visit_purpose";
                            $scope.vm.form.data.visit_type = { Value: 10, Name: "商业拜访" };
                            break;
                        case 2:
                            accType = "hospital_visit_purpose";
                            $scope.vm.form.data.visit_type = { Value: 20, Name: "医院拜访" };
                            break;
                        case 3:
                            accType = "retail_visit_purpose";
                            $scope.vm.form.data.visit_type = { Value: 30, Name: "零售终端拜访" };
                            break;
                        case 4:
                            accType = "thirdterminal_visit_purpose";
                            $scope.vm.form.data.visit_type = { Value: 40, Name: "基层医疗拜访" };
                            break;
                        case 5:
                            accType = "agent_visit_purpose";
                            $scope.vm.form.data.visit_type = { Value: 50, Name: "代理商拜访" };
                            break;
                        case 6:
                            accType = "chain_visit_purpose";
                            $scope.vm.form.data.visit_type = { Value: 60, Name: "连锁拜访" };
                            break;
                    }
                    myService.getVisitPurpose(accType).then(function (resp) {
                        $scope._visitpurpose = array_diff(resp.data, $scope.vm.form.data.VisitPurpose);
                    });
                });
            }
        });

        function array_diff(a, b) {
            if (rt.isNull(b)) b = [];
            for (var i = 0; i < b.length; i++) {
                for (var j = 0; j < a.length; j++) {
                    if (a[j].Value == b[i].Value) {
                        a.splice(j, 1);
                        j = j - 1;
                    }
                }
            }
            return a;
        }

        $scope.$watch("vm.form.data.contactid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(newValue)) {
                if ($scope.vm.form.data.visit_type.Value == 20) {
                    myService.GetDepartmentByContactId(newValue).then(function (resp) {
                        var data = resp.data;
                        if (data) {
                            $scope.vm.form.data.departid = { Id: data.Id, Name: data.name };
                        }
                    });
                }
            }
        });

        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("visit", fileId);
        };

        $scope.vm.form.loadComplete = function () {
            var newassList = [];
            if ($scope.vm.form.data.assistanceList != null) {
                angular.forEach($scope.vm.form.data.assistanceList, function (entity) {
                    newassList.push({ Id: entity.OwnerId.Id, Name: entity.OwnerIdName, done_time: entity.done_time === null ? '' : moment(entity.done_time).format('YYYY-MM-DD HH:mm:SS') });
                });
                $scope.vm.form.data.assistanceList = newassList;
            }
        };

        $scope.vm.form.preSave = function () {
            if (moment($scope.vm.form.data.plan_time).toDate() < $scope.vm.tomorrow) {
                rt.errorMessage("计划拜访时间必须大于今日");
                return "计划拜访时间必须大于今日";
            }
            if ($scope.vm.form.data.is_assist) {
                if (rt.isNull($scope.vm.form.data.assistanceList)) {
                    rt.errorMessage("请选择协访人。");
                    return "请选择协访人。";
                }
            }
            $scope.vm.form.data.visit_status = { Value: 10, Name: "待拜访" };
            $scope.vm.form.data.visitpurposes = JSON.stringify($scope.vm.form.data.VisitPurpose);
            var assistanceList = $scope.vm.form.data.assistanceList;
            if ($scope.vm.form.data.is_assist) {
                for (var i = 0; i < assistanceList.length; i++) {
                    if (assistanceList.visit_assistanceId == null || assistanceList.visit_assistanceId == '') {
                        $scope.vm.form.data.assistanceList[i].visit_assistanceId = rt.newGuid();
                        $scope.vm.form.data.assistanceList[i].OwnerId = {
                            Id: assistanceList[i].Id,
                            Name: assistanceList[i].Name
                        };
                        $scope.vm.form.data.assistanceList[i].Id = assistanceList[i].visit_assistanceId;
                    }
                    $scope.vm.form.data.assistanceList[i].visit_recordId = { Id: $scope.vm.form.data.Id };
                }
            }
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-06-05
 说明     : 竞品采集
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('competingService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitCompeting';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getAttachmentList = function (id) {
            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
    }]).controller('competingListController', ['$injector', '$scope', '$compile', 'competingService', function ($injector, $scope, $compile, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-06-05
 说明     : 缺损上报
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('defectService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'Visitdefect';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getAttachmentList = function (id) {
            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
    }]).controller('defectListController', ['$injector', '$scope', '$compile', 'defectService', function ($injector, $scope, $compile, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-06-05
 说明     : 临逾期上报
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('expiredService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'Visitexpired';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getAttachmentList = function (id) {
            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
    }]).controller('expiredListController', ['$injector', '$scope', '$compile', 'expiredService', function ($injector, $scope, $compile, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-06-05
 说明     : 陈列检查
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('productdisplayService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitProductDisplay';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getAttachmentList = function (id) {
            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
    }]).controller('productdisplayListController', ['$injector', '$scope', '$compile', 'productdisplayService', function ($injector, $scope, $compile, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-06-05
 说明     : 缺损上报
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('promotionService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitPromotion';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getAttachmentList = function (id) {
            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
    }]).controller('promotionListController', ['$injector', '$scope', '$compile', 'promotionService', function ($injector, $scope, $compile, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-06-02
 说明     : 进销存
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('psiService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitPSI';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('psiListController', ['$injector', '$scope', '$compile', 'psiService', function ($injector, $scope, $compile, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-06-05
 说明     : 陈列检查
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('salepolicyService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitSalePolicy';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getAttachmentList = function (id) {
            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
    }]).controller('salepolicyListController', ['$injector', '$scope', '$compile', 'salepolicyService', function ($injector, $scope, $compile, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-06-05
 说明     : 缺货上报
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('stockoutService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'Visitstockout';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getAttachmentList = function (id) {
            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
    }]).controller('stockoutListController', ['$injector', '$scope', '$compile', 'stockoutService', function ($injector, $scope, $compile, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2017-01-11
 说明     : 生动化检查
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('visitvividcheckService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitVividCheck';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getAttachmentList = function (id) {
            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
    }]).controller('visitvividcheckListController', ['$injector', '$scope', '$compile', 'visitvividcheckService', function ($injector, $scope, $compile, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-13
 说明     :PC端代理商
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('agentService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'agent';

        // @@ 选项集
        this.picklists = ['StateCode', 'account_grade', 'accountclassificationcode', 'agent_type', 'account_grade_level'];

        //获取归属信息
        this.GetSalesRegionInfo = function (accountId) {
            return rt.get("api/Account/GetSalesRegionInfo?accountId=" + accountId);
        };

        //保存归属信息
        this.SaveSalesRegionInfo = function (accountId, dataList) {
            return rt.post("api/SalesRegionAccount/SaveSalesRegionInfo?accountId=" + accountId, dataList);
        };

        //根据销售区域Id获取部门和用户信息
        this.GetBusinessAndOwnerInfoById = function (sales_regionId) {
            return rt.get("api/SalesRegion/GetBusinessAndOwnerInfoById?sales_regionId=" + sales_regionId);
        };
    }]).controller('agentListController', ['$injector', '$compile', '$scope', 'agentService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        $scope.viewTag = "Web";
        this.viewTag = "Web";

        var that = this;
        this.isPost = true;
        this.searchList = [];
        this.bodySearchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
            that.bodySearchList.length = 0;

            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            if (!rt.isNullOrEmptyString(unitids)) {
                var idArray = unitids.split(",");
                that.bodySearchList.push({ Type: 2, Key: "BusinessUnitId", Value: idArray });
            }

            if (!rt.isNull($scope.vm.stateSelected)) that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.Value });

            if (!rt.isNull($scope.vm.typeSelected)) that.searchList.push({ Type: 1, Key: "agent_type", Value: $scope.vm.typeSelected.Value });

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.province) && !rt.isNullOrEmptyString($scope.vm.areaSelected.province.Id)) {
                that.searchList.push({ Type: 1, Key: "provinceid", Value: $scope.vm.areaSelected.province.Id });
            }

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.city) && !rt.isNullOrEmptyString($scope.vm.areaSelected.city.Id)) {
                that.searchList.push({ Type: 1, Key: "cityid", Value: $scope.vm.areaSelected.city.Id });
            }

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.county) && !rt.isNullOrEmptyString($scope.vm.areaSelected.county.Id)) {
                that.searchList.push({ Type: 1, Key: "countyid", Value: $scope.vm.areaSelected.county.Id });
            }

            if (!rt.isNullOrEmptyString($scope.vm.tagSelected)) {
                if ($scope.vm.tagSelected.indexOf('：') < 0 && $scope.vm.tagSelected.indexOf(':') < 0) {
                    return "请按照正确格式输入：标签名称：内容1，内容2；";
                }
                that.searchList.push({ Type: 5, Key: "account_tag", Value: $scope.vm.tagSelected });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.loadComplete = function () {
            if (!rt.isNull($scope.vm.data)) {
                for (var i = 0; i < $scope.vm.data.length; i++) {
                    if (!rt.isNull($scope.vm.data[i].account_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.data[i].account_tag) {
                            tagstring += o + "：" + $scope.vm.data[i].account_tag[o] + "；";
                        }
                        $scope.vm.data[i].tagstring = tagstring;
                    }
                }
            }
        };
    }]).controller('agentEditController', ['$injector', '$compile', '$scope', 'agentService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.$watch("vm.form.data.cityid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.vm.form.change = function () {
            $scope.$broadcast('rt-reload');
        };

        $scope.delSelected = [];
        //加载归属信息
        $scope.vm.form.loadComplete = function () {
            $scope.vm.getSalesRegionInfo();
            $scope.isCheckAll = false;
            $scope.vm.form.tagList = [];
            if (!rt.isNull($scope.vm.form.data.account_tag)) {
                var tagstring = "";
                for (var o in $scope.vm.form.data.account_tag) {
                    tagstring = o + "：" + $scope.vm.form.data.account_tag[o];
                    $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
                }
            }
        };

        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/BusinessAccount/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            var valueList = data.Value.split(/[,，]/);
            var list = [];
            for (var i = 0; i < valueList.length; i++) {
                if (!rt.isNullOrWhiteSpace(valueList[i])) {
                    list.push(valueList[i]);
                }
            }
            if (rt.isNull($scope.vm.form.data.account_tag)) {
                $scope.vm.form.data.account_tag = {};
            }
            $scope.vm.form.data.account_tag[data.Name] = list;
            $scope.vm.form.tagList = [];
            var tagstring = "";
            for (var o in $scope.vm.form.data.account_tag) {
                tagstring = o + "：" + $scope.vm.form.data.account_tag[o];
                $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
            }
        });

        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.form.tagList, { 'checked': true });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.form.tagList = _.where($scope.vm.form.tagList, { 'checked': false });
            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.account_tag = tag;
        };

        //保存之前
        $scope.vm.form.preSave = function (data) {
            if ($scope.salesRegionInfoList.length == 0) {
                rt.errorMessage("至少选择一条代理商归属信息。");
                return "至少选择一条代理商归属信息。";
            }
            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.account_tag = tag;
        };

        //保存之后
        $scope.vm.form.postSave = function () {
            //保存归属信息
            $scope.vm.saveSalesRegionInfo();
        };

        $scope.vm.getSalesRegionInfo = function () {
            //打开客户编辑页面时获取归属信息
            if (rt.isNull($scope.rtIncludeParams) || !rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                myService.GetSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id).then(function (resp) {
                    $scope.salesRegionInfoList = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            }
        };

        //保存归属信息
        $scope.vm.saveSalesRegionInfo = function () {
            myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {}).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.salesRegionInfoList = _.remove($scope.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    //编辑客户时，删除归属信息才和后台数据库交互
                    if (!rt.isNullOrEmptyString($scope.vm.form.data.Id)) {
                        $scope.vm.saveSalesRegionInfo();
                    }

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegion").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //编辑客户-归属信息
        $scope.vm.showForm = function (row, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params="{rtIncludeId:\'' + row + '\'' + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //新建客户-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=' + JSON.stringify(list) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品种。");
                return "必须提供品种。";
            }

            if (rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                $scope.salesRegionInfoList = $scope.rtIncludeParams;
            }

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品种，不能再添加其他品种。");
                    return "已选择了全品种，不能再添加其他品种。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };
            // 编辑客户时，直接保存到数据库，并刷新数据
            if (!rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {
                    $scope.$emit('rt-on-dialog-close-click');
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            } else
                // 新建客户时，广播到编辑页面
                $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.salesRegionInfoList);
        };

        // 新建客户-编辑归属信息页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.salesRegionInfoList = list;
        });

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-8
 说明     :PC端商业协访
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('AgentBusinessAssistanceService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'AgentBusinessAssistance';
        // @@ 选项集
        this.picklists = ['StateCode'];
        //检查账号是否是医院
        this.CheckAccountIsHos = function (id) {
            return rt.get("api/Account/CheckAccountIsHospital?accountId=" + id);
        };
    }]).controller('AgentBusinessAssistanceListController', ['$scope', 'AgentBusinessAssistanceService', entityListController]).controller('AgentBusinessAssistanceEditController', ['$injector', '$scope', 'AgentBusinessAssistanceService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.loadComplete = function () {
            if ($scope.vm.form.data.assistanceList == null) {
                $scope.vm.form.data.assistanceList = [{
                    visit_recordId: '',
                    OwnerId: { Id: '', Name: '' },
                    summary: ''
                    /* visit_assistanceId:''*/
                }];
            }
        };

        $scope.vm.form.preSave = function () {
            if ($scope.vm.form.data.is_assist) {
                for (var i = 0; i < $scope.vm.form.data.assistanceList.length; i++) {
                    if ($scope.vm.form.data.assistanceList[i].visit_assistanceId == null || $scope.vm.form.data.assistanceList[i].visit_assistanceId == '') {
                        $scope.vm.form.data.assistanceList[i].visit_assistanceId = rt.newGuid();
                    }
                    $scope.vm.form.data.assistanceList[i].visit_recordId = { Id: $scope.vm.form.data.Id };
                }
            }
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-6
 说明     :PC端商业拜访
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('AgentBusinessVisitService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'AgentBusinessVisit';
        // @@ 选项集
        this.picklists = ['StateCode'];
        //获取代理商的拜访目的
        this.getAttachmentList = function (id) {
            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
        this.getAgentVisitPurpose = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=agent_visit_purpose";
            return rt.get(url);
        };
    }]).controller('AgentBusinessVisitListController', ['$scope', 'AgentBusinessVisitService', entityListController]).controller('AgentBusinessVisitEditController', ['$injector', '$scope', 'AgentBusinessVisitService', function ($injector, $scope, myService) {
        $scope.vm = {};

        var rt = myService.rt;
        var $q = myService.$q;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope._visitpurpose = [];
        var waiting = rt.showLoading2();
        $q.all([myService.getAgentVisitPurpose()]).then(function (resp) {
            $scope._visitpurpose = resp[0].data;
        }).catch(function (err) {
            rt.errorMessage(err);
        }).finally(function () {
            waiting.close();
        });

        function _getAllOwner() {
            $q.all([myService.getAgentVisitPurpose()]).then(function (resp) {
                $scope._visitpurpose = resp[0].data;
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
            rt.queryData("UserInfo.GetAllUser", { '@queryValue': '' }, function (resp) {
                $scope.OwnerList = [];
                var data = resp.DataList;
                for (var i = 0; i < data.length; i++) {
                    $scope.OwnerList.push({ Id: data[i].id, Name: data[i].name });
                }
            }, function (error) {});
        }

        $scope.$watch("vm.form.data.accountid.Id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            if (!rt.isNull($scope.vm.form.data.accountid.Id)) {
                $scope.vm.form.data.customer_type = $scope.vm.form.data.accountid.Customertype;
                $scope.vm.form.data.accountid = { Id: $scope.vm.form.data.accountid.Id, Name: $scope.vm.form.data.accountid.Name };
            }
        });

        $scope.vm.form.preLoad = function (data) {
            //获取所有代表
            _getAllOwner();
            if ($scope.vm.form.type === 'Edit') {
                myService.getAttachmentList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.attachmentList = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }
        };

        $scope.vm.form.loadComplete = function () {
            var newassList = [];
            if ($scope.vm.form.data.assistanceList != null) {
                angular.forEach($scope.vm.form.data.assistanceList, function (entity) {
                    newassList.push({ Id: entity.OwnerId.Id, Name: entity.OwnerIdName });
                });
                $scope.vm.form.data.assistanceList = newassList;
            }
        };

        $scope.vm.form.preSave = function () {
            $scope.vm.form.data.visitpurposes = JSON.stringify($scope.vm.form.data.VisitPurpose);
            var assistanceList = $scope.vm.form.data.assistanceList;
            if ($scope.vm.form.data.is_assist) {
                for (var i = 0; i < assistanceList.length; i++) {
                    if (assistanceList.visit_assistanceId == null || assistanceList.visit_assistanceId == '') {
                        $scope.vm.form.data.assistanceList[i].visit_assistanceId = rt.newGuid();
                        $scope.vm.form.data.assistanceList[i].OwnerId = {
                            Id: assistanceList[i].Id,
                            Name: assistanceList[i].Name
                        };
                        $scope.vm.form.data.assistanceList[i].Id = assistanceList[i].visit_assistanceId;
                    }
                    $scope.vm.form.data.assistanceList[i].visit_recordId = { Id: $scope.vm.form.data.Id };
                }
            }
        };

        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("business_visit", fileId);
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-13
 说明     :
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('agentcontactService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'agentcontact';

        // @@ 选项集
        this.picklists = ['StateCode', 'preferredcontactmethod', 'gendercode', 'familystatuscode', 'bachelor'];
    }]).controller('agentcontactListController', ['$injector', '$compile', '$scope', 'agentcontactService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        $scope.viewTag = "Web";
        this.viewTag = "Web";
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('agentcontactEditController', ['$injector', '$scope', 'agentcontactService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch('vm.form.data.accountid', function (newValue, oldValue) {
            if (oldValue != newValue && $scope.vm.form.type === 'Create') {
                if (!rt.isNull($scope.vm.form.data.accountid)) {
                    var id = $scope.vm.form.data.accountid.Id;
                    var waiting = rt.showLoading2();
                    var url = 'api/AccountContact/GetContactBusinessUnit?id=' + id;
                    rt.get(url).then(function (resp) {
                        var data = resp.data[0];
                        if (data) {
                            $scope.vm.form.data.BusinessUnitId = {
                                Id: data.BusinessUnitId,
                                Name: data.BusinessUnitIdName
                            };
                            $scope.vm.form.data.OwnerId = {
                                Id: data.OwnerId,
                                Name: data.OwnerIdName
                            };
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                    var url2 = 'api/Department/GetCodeById?id=' + id;
                    rt.get(url2).then(function (resp) {
                        $scope.vm.form.data.accountnumber = resp.data;
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                    var url3 = 'api/accountcontact/GetContactProvince?id=' + id;
                    rt.get(url3).then(function (resp) {
                        $scope.vm.form.data.provinceid = {
                            Id: resp.data.Id,
                            Name: resp.data.Name
                        };
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        vm.isLoading = false;
                    });
                }
            }
        });

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        //修改业务部门 业务负责人清空
        $scope.$watch("vm.form.data.BusinessUnitId.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2017-04-24
 说明     : 应收数据
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('arvoucherService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'ArVoucher';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('arvoucherListController', ['$injector', '$compile', '$scope', 'arvoucherService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        var that = this;
        this.searchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
        };
        this.preExport = function () {
            that.searchList.length = 0;
            that.searchList.push({ Type: 1, Key: "viewId", Value: $scope.vm.view.selectedView.Id });
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016-07-08
 说明     : 考勤规则设定
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('attendanceruleService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'attendancerule';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('attendanceruleListController', ['$scope', 'attendanceruleService', entityListController]).controller('attendanceruleEditController', ['$injector', '$scope', 'attendanceruleService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //$scope.vm.form.preSave = function () {
        //    $scope.vm.workonstr=[];
        //    $scope.vm.workoffstr=[];
        //    if(!rt.isNullOrWhiteSpace($scope.vm.form.data.workOn)){
        //        $scope.vm.workonstr=$scope.vm.form.data.workOn.split(':');
        //    }
        //    if(!rt.isNullOrWhiteSpace($scope.vm.form.data.workOff)){
        //        $scope.vm.workoffstr=$scope.vm.form.data.workOff.split(':');
        //    }
        //    if ($scope.vm.workonstr[0]>=24||$scope.vm.workonstr[0]<0||$scope.vm.workonstr[1]>=60||
        //        $scope.vm.workonstr[1]<0) {
        //        rt.errorMessage ("请输入正确的开始时间");
        //        return "请输入正确的开始时间";
        //    }
        //    if ($scope.vm.workoffstr[0]>=24||$scope.vm.workoffstr[0]<0||$scope.vm.workoffstr[1]>=60||
        //        $scope.vm.workoffstr[1]<0) {
        //        rt.errorMessage ("请输入正确的结束时间");
        //        return "请输入正确的结束时间";
        //    }
        //    if ($scope.vm.workonstr[0].length!=2||$scope.vm.workoffstr[0].length!=2) {
        //        rt.errorMessage ("请输入正确时间格式：如'09:00'");
        //        return "请输入正确的结束时间";
        //    }
        //    if ($scope.vm.workonstr[0]>$scope.vm.workoffstr[0]||($scope.vm.workonstr[0]=$scope.vm.workoffstr[0]&&$scope.vm.workonstr[1]>$scope.vm.workoffstr[1])) {
        //        rt.errorMessage ("结束时间须大于开始时间");
        //        return "请输入正确的结束时间";
        //    }

        //}
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016-02-03
 说明     : 基层医疗机构
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('BasicMedicalService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'BasicMedical';

        // @@ 选项集
        this.picklists = ['StateCode', 'orgtype', 'account_grade_level'];

        //获取归属信息
        this.GetSalesRegionInfo = function (accountId) {
            return rt.get("api/Account/GetSalesRegionInfo?accountId=" + accountId);
        };

        //保存归属信息
        this.SaveSalesRegionInfo = function (accountId, dataList) {
            return rt.post("api/SalesRegionAccount/SaveSalesRegionInfo?accountId=" + accountId, dataList);
        };

        //根据销售区域Id获取部门和用户信息
        this.GetBusinessAndOwnerInfoById = function (sales_regionId) {
            return rt.get("api/SalesRegion/GetBusinessAndOwnerInfoById?sales_regionId=" + sales_regionId);
        };
    }]).controller('BasicMedicalListController', ['$injector', '$compile', '$scope', 'BasicMedicalService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        $scope.viewTag = "Web";
        this.viewTag = "Web";

        var that = this;
        this.isPost = true;
        this.searchList = [];
        this.bodySearchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
            that.bodySearchList.length = 0;

            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            if (!rt.isNullOrEmptyString(unitids)) {
                var idArray = unitids.split(",");
                that.bodySearchList.push({ Type: 2, Key: "BusinessUnitId", Value: idArray });
            }

            if (!rt.isNull($scope.vm.stateSelected)) that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.Value });

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.province) && !rt.isNullOrEmptyString($scope.vm.areaSelected.province.Id)) {
                that.searchList.push({ Type: 1, Key: "provinceid", Value: $scope.vm.areaSelected.province.Id });
            }

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.city) && !rt.isNullOrEmptyString($scope.vm.areaSelected.city.Id)) {
                that.searchList.push({ Type: 1, Key: "cityid", Value: $scope.vm.areaSelected.city.Id });
            }

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.county) && !rt.isNullOrEmptyString($scope.vm.areaSelected.county.Id)) {
                that.searchList.push({ Type: 1, Key: "countyid", Value: $scope.vm.areaSelected.county.Id });
            }

            if (!rt.isNullOrEmptyString($scope.vm.tagSelected)) {
                if ($scope.vm.tagSelected.indexOf('：') < 0 && $scope.vm.tagSelected.indexOf(':') < 0) {
                    return "请按照正确格式输入：标签名称：内容1，内容2；";
                }
                that.searchList.push({ Type: 5, Key: "account_tag", Value: $scope.vm.tagSelected });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.loadComplete = function () {
            if (!rt.isNull($scope.vm.data)) {
                for (var i = 0; i < $scope.vm.data.length; i++) {
                    if (!rt.isNull($scope.vm.data[i].account_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.data[i].account_tag) {
                            tagstring += o + "：" + $scope.vm.data[i].account_tag[o] + "；";
                        }
                        $scope.vm.data[i].tagstring = tagstring;
                    }
                }
            }
        };
    }]).controller('BasicMedicalEditController', ['$injector', '$compile', '$scope', 'BasicMedicalService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });
        $scope.$watch("vm.form.data.cityid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.delSelected = [];
        //加载归属信息
        $scope.vm.form.loadComplete = function () {
            $scope.vm.getSalesRegionInfo();
            $scope.isCheckAll = false;
            $scope.vm.form.tagList = [];
            if (!rt.isNull($scope.vm.form.data.account_tag)) {
                var tagstring = "";
                for (var o in $scope.vm.form.data.account_tag) {
                    tagstring = o + "：" + $scope.vm.form.data.account_tag[o];
                    $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
                }
            }
        };

        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/BusinessAccount/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            var valueList = data.Value.split(/[,，]/);
            var list = [];
            for (var i = 0; i < valueList.length; i++) {
                if (!rt.isNullOrWhiteSpace(valueList[i])) {
                    list.push(valueList[i]);
                }
            }
            if (rt.isNull($scope.vm.form.data.account_tag)) {
                $scope.vm.form.data.account_tag = {};
            }
            $scope.vm.form.data.account_tag[data.Name] = list;
            $scope.vm.form.tagList = [];
            var tagstring = "";
            for (var o in $scope.vm.form.data.account_tag) {
                tagstring = o + "：" + $scope.vm.form.data.account_tag[o];
                $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
            }
        });

        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.form.tagList, { 'checked': true });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.form.tagList = _.where($scope.vm.form.tagList, { 'checked': false });
            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.account_tag = tag;
        };

        //保存之前
        $scope.vm.form.preSave = function (data) {
            if ($scope.salesRegionInfoList.length == 0) {
                rt.errorMessage("至少选择一条基层医疗机构归属信息。");
                return "至少选择一条基层医疗机构归属信息。";
            }
            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.account_tag = tag;
        };

        //保存之后
        $scope.vm.form.postSave = function () {
            //保存归属信息
            $scope.vm.saveSalesRegionInfo();
        };

        $scope.vm.getSalesRegionInfo = function () {
            //打开客户编辑页面时获取归属信息
            if (rt.isNull($scope.rtIncludeParams) || !rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                myService.GetSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id).then(function (resp) {
                    $scope.salesRegionInfoList = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            }
        };

        //保存归属信息
        $scope.vm.saveSalesRegionInfo = function () {
            myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {}).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.salesRegionInfoList = _.remove($scope.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    //编辑客户时，删除归属信息才和后台数据库交互
                    if (!rt.isNullOrEmptyString($scope.vm.form.data.Id)) {
                        $scope.vm.saveSalesRegionInfo();
                    }

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegion").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //编辑客户-归属信息
        $scope.vm.showForm = function (row, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params="{rtIncludeId:\'' + row + '\'' + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //新建客户-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=' + JSON.stringify(list) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品种。");
                return "必须提供品种。";
            }

            if (rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                $scope.salesRegionInfoList = $scope.rtIncludeParams;
            }

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品种，不能再添加其他品种。");
                    return "已选择了全品种，不能再添加其他品种。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };
            // 编辑客户时，直接保存到数据库，并刷新数据
            if (!rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {
                    $scope.$emit('rt-on-dialog-close-click');
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            } else
                // 新建客户时，广播到编辑页面
                $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.salesRegionInfoList);
        };

        // 新建客户-编辑归属信息页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.salesRegionInfoList = list;
        });

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };
    }]).service('basicmedicalcontactService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'basicmedicalcontact';

        // @@ 选项集
        this.picklists = ['StateCode', 'preferredcontactmethod', 'gendercode', 'familystatuscode', 'bachelor'];
    }]).controller('basicmedicalcontactListController', ['$scope', 'basicmedicalcontactService', entityListController]).controller('basicmedicalcontactEditController', ['$injector', '$scope', 'basicmedicalcontactService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch('vm.form.data.accountid', function (newValue, oldValue) {
            if (oldValue != newValue && $scope.vm.form.type === 'Create') {
                if (!rt.isNull($scope.vm.form.data.accountid)) {
                    var id = $scope.vm.form.data.accountid.Id;
                    var waiting = rt.showLoading2();
                    var url = 'api/AccountContact/GetContactBusinessUnit?id=' + id;
                    rt.get(url).then(function (resp) {
                        var data = resp.data[0];
                        if (data) {
                            $scope.vm.form.data.BusinessUnitId = {
                                Id: data.BusinessUnitId,
                                Name: data.BusinessUnitIdName
                            };
                            $scope.vm.form.data.OwnerId = {
                                Id: data.OwnerId,
                                Name: data.OwnerIdName
                            };
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                    var url2 = 'api/Department/GetCodeById?id=' + id;
                    rt.get(url2).then(function (resp) {
                        $scope.vm.form.data.accountnumber = resp.data;
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                    var url3 = 'api/accountcontact/GetContactProvince?id=' + id;
                    rt.get(url3).then(function (resp) {
                        $scope.vm.form.data.provinceid = {
                            Id: resp.data.Id,
                            Name: resp.data.Name
                        };
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        vm.isLoading = false;
                    });
                }
            }
        });

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        //修改业务部门 业务负责人清空
        $scope.$watch("vm.form.data.BusinessUnitId.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : SummerXu
 创建时间 : 2016-04-26
 说明     : 基药纯销任务指标
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('basicmedicalsaletaskService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'basicmedicalsaletask';
        // @@ 选项集
        this.picklists = ['StateCode', 'tasklevel', 'type', 'year', 'month'];
    }]).controller('basicmedicalsaletaskListController', ['$injector', '$scope', 'basicmedicalsaletaskService', function ($injector, $scope, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.showForm = _showForm;
        function _showForm() {
            var html = '<div rt-include rt-template="Module/MissionTarget/missiontargetExcelImportView.html" rt-controller="missiontargetExcelImportController" ></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '<span style="color:#09f"><i class="fa fa-download fa-2x"></i>　导出任务指标数据</span>',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_NORMAL,
                onshow: function onshow(dialog) {
                    //dialog.getModalHeader().hide();
                    //dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }
    }]).controller('basicmedicalsaletaskEditController', ['$injector', '$scope', 'basicmedicalsaletaskService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Lucifer Wang
创建时间 : 2017/6/28
说明     : 商业公司数据
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('BizAccountCostsService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        this.controllerName = 'BizAccountCosts';
        // @@ 选项集
        this.picklists = ['StateCode', 'term_type'];
    }]).controller('BizAccountCostsListController', ['$scope', 'BizAccountCostsService', entityListController]).controller('BizAccountCostsEditController', ['$scope', 'BizAccountCostsService', entityEditController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-02-27
 说明     : 商业开票价格表
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('bizaccountpricelistService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        var rt = entityService.rt;

        // @@设置WebAPI的控制器名称
        this.controllerName = 'BizAccountPricelist';

        // @@ 选项集
        this.picklists = ['StateCode'];

        this.GetAccountData = function (id) {
            return rt.get("api/Account/GetDataById?id=" + id);
        };

        this.GetProductData = function (id) {
            return rt.get("api/Product/GetProductById?id=" + id);
        };
    }]).controller('bizaccountpricelistListController', ['$injector', '$scope', 'bizaccountpricelistService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('bizaccountpricelistEditController', ['$injector', '$scope', 'bizaccountpricelistService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //获取商业编码
        $scope.$watch("vm.form.data.accountId.Id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            if (!rt.isNullOrWhiteSpace(newValue)) {
                myService.GetAccountData($scope.vm.form.data.accountId.Id).then(function (resp) {
                    $scope.vm.form.data.accountnumber = resp.data.accountnumber;
                });
            } else {
                $scope.vm.form.data.accountnumber = null;
            }
        });

        //获取产品编码
        $scope.$watch("vm.form.data.productid.Id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            if (!rt.isNullOrWhiteSpace(newValue)) {
                myService.GetProductData($scope.vm.form.data.productid.Id).then(function (resp) {
                    $scope.vm.form.data.productnumber = resp.data.code;
                });
            } else {
                $scope.vm.form.data.productnumber = null;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-02-01
 说明     : 商业客户档案
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('businessaccountService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        var rt = entityService.rt;

        // @@设置WebAPI的控制器名称
        this.controllerName = 'businessaccount';

        // @@ 选项集
        this.picklists = ['StateCode', 'acc_level', 'credit', 'acc_type', 'partnership', 'creditdegree', 'accountlevel', 'salesmodel', 'account_grade_level', 'bachelor'];

        //获取归属信息
        this.GetSalesRegionInfo = function (accountId) {
            return rt.get("api/Account/GetSalesRegionInfo?accountId=" + accountId);
        };

        //保存归属信息
        this.SaveSalesRegionInfo = function (accountId, dataList) {
            return rt.post("api/SalesRegionAccount/SaveSalesRegionInfo?accountId=" + accountId, dataList);
        };

        //根据销售区域Id获取部门和用户信息
        this.GetBusinessAndOwnerInfoById = function (sales_regionId) {
            return rt.get("api/SalesRegion/GetBusinessAndOwnerInfoById?sales_regionId=" + sales_regionId);
        };
    }]).controller('businessaccountListController', ['$injector', '$scope', 'businessaccountService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $scope.viewTag = "Web";
        this.viewTag = "Web";

        var that = this;
        this.isPost = true;
        this.searchList = [];
        this.bodySearchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
            that.bodySearchList.length = 0;
            if (!rt.isNull($scope.vm.accountLevelSelected) && !rt.isNullOrWhiteSpace($scope.vm.accountLevelSelected.id)) {
                that.searchList.push({ Type: 1, Key: "acc_level", Value: $scope.vm.accountLevelSelected.code });
            }

            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            if (!rt.isNullOrEmptyString(unitids)) {
                var idArray = unitids.split(",");
                that.bodySearchList.push({ Type: 2, Key: "BusinessUnitId", Value: idArray });
            }

            if (!rt.isNull($scope.vm.stateSelected)) that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.Value });

            if (!rt.isNull($scope.vm.gradeSelected)) that.searchList.push({ Type: 1, Key: "acc_level", Value: $scope.vm.gradeSelected.Value });

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.province) && !rt.isNullOrEmptyString($scope.vm.areaSelected.province.Id)) {
                that.searchList.push({ Type: 1, Key: "provinceid", Value: $scope.vm.areaSelected.province.Id });
            }

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.city) && !rt.isNullOrEmptyString($scope.vm.areaSelected.city.Id)) {
                that.searchList.push({ Type: 1, Key: "cityid", Value: $scope.vm.areaSelected.city.Id });
            }

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.county) && !rt.isNullOrEmptyString($scope.vm.areaSelected.county.Id)) {
                that.searchList.push({ Type: 1, Key: "countyid", Value: $scope.vm.areaSelected.county.Id });
            }

            if (!rt.isNullOrEmptyString($scope.vm.tagSelected)) {
                if ($scope.vm.tagSelected.indexOf('：') < 0 && $scope.vm.tagSelected.indexOf(':') < 0) {
                    return "请按照正确格式输入：标签名称：内容1，内容2；";
                }
                that.searchList.push({ Type: 5, Key: "account_tag", Value: $scope.vm.tagSelected });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        _getAllAccountLevel();

        //获取所有商业等级
        function _getAllAccountLevel() {
            rt.queryData("Account.BusinessAccountLevel", { '@queryValue': '' }, function (resp) {
                $scope.vm.accountLevelList = resp.DataList;
            }, function (error) {
                $scope.vm.accountLevelList = [];
            });
        }

        $scope.vm.actions.loadComplete = function () {
            if (!rt.isNull($scope.vm.data)) {
                for (var i = 0; i < $scope.vm.data.length; i++) {
                    if (!rt.isNull($scope.vm.data[i].account_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.data[i].account_tag) {
                            tagstring += o + "：" + $scope.vm.data[i].account_tag[o] + "；";
                        }
                        $scope.vm.data[i].tagstring = tagstring;
                    }
                }
            }
        };
    }]).controller('businessaccountEditController', ['$injector', '$compile', '$scope', 'businessaccountService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch('vm.form.data.provinceid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.$watch('vm.form.data.cityid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.delSelected = [];
        //加载归属信息
        $scope.vm.form.loadComplete = function () {
            $scope.vm.getSalesRegionInfo();
            $scope.isCheckAll = false;
            $scope.vm.form.tagList = [];
            if (!rt.isNull($scope.vm.form.data.account_tag)) {
                var tagstring = "";
                for (var o in $scope.vm.form.data.account_tag) {
                    tagstring = o + "：" + $scope.vm.form.data.account_tag[o];
                    $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
                }
            }
        };

        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/BusinessAccount/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            var valueList = data.Value.split(/[,，]/);
            var list = [];
            for (var i = 0; i < valueList.length; i++) {
                if (!rt.isNullOrWhiteSpace(valueList[i])) {
                    list.push(valueList[i]);
                }
            }
            if (rt.isNull($scope.vm.form.data.account_tag)) {
                $scope.vm.form.data.account_tag = {};
            }
            $scope.vm.form.data.account_tag[data.Name] = list;
            $scope.vm.form.tagList = [];
            var tagstring = "";
            for (var o in $scope.vm.form.data.account_tag) {
                tagstring = o + "：" + $scope.vm.form.data.account_tag[o];
                $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
            }
        });

        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.form.tagList, { 'checked': true });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.form.tagList = _.where($scope.vm.form.tagList, { 'checked': false });
            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.account_tag = tag;
        };

        //保存之前
        $scope.vm.form.preSave = function (data) {
            if ($scope.salesRegionInfoList.length == 0) {
                rt.errorMessage("至少选择一条商业归属信息。");
                return "至少选择一条商业归属信息。";
            }
            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.account_tag = tag;
        };

        //保存之后
        $scope.vm.form.postSave = function () {
            //保存归属信息
            $scope.vm.saveSalesRegionInfo();
        };

        $scope.vm.getSalesRegionInfo = function () {
            //打开客户编辑页面时获取归属信息
            if (rt.isNull($scope.rtIncludeParams) || !rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                myService.GetSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id).then(function (resp) {
                    $scope.salesRegionInfoList = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            }
        };

        //保存归属信息
        $scope.vm.saveSalesRegionInfo = function () {
            myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {}).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.salesRegionInfoList = _.remove($scope.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    //编辑客户时，删除归属信息才和后台数据库交互
                    if (!rt.isNullOrEmptyString($scope.vm.form.data.Id)) {
                        $scope.vm.saveSalesRegionInfo();
                    }

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegion").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //编辑客户-归属信息
        $scope.vm.showForm = function (row, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params="{rtIncludeId:\'' + row + '\'' + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //新建客户-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=' + JSON.stringify(list) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品种。");
                return "必须提供品种。";
            }

            if (rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                $scope.salesRegionInfoList = $scope.rtIncludeParams;
            }

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品种，不能再添加其他品种。");
                    return "已选择了全品种，不能再添加其他品种。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };
            // 编辑客户时，直接保存到数据库，并刷新数据
            if (!rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {
                    $scope.$emit('rt-on-dialog-close-click');
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            } else
                // 新建客户时，广播到编辑页面
                $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.salesRegionInfoList);
        };

        // 新建客户-编辑归属信息页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.salesRegionInfoList = list;
        });

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };
    }]).service('businesscontactService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'businesscontact';

        // @@ 选项集
        this.picklists = ['StateCode', 'preferredcontactmethod', 'gendercode', 'familystatuscode', 'bachelor'];
    }]).controller('businesscontactListController', ['$scope', 'businesscontactService', entityListController]).controller('businesscontactEditController', ['$injector', '$scope', 'businesscontactService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch('vm.form.data.accountid', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.accountid) && $scope.vm.form.type === 'Create') {
                    var id = $scope.vm.form.data.accountid.Id;
                    var waiting = rt.showLoading2();
                    var url = 'api/BusinessContact/GetContactBusinessUnit?id=' + id;
                    rt.get(url).then(function (resp) {
                        var data = resp.data[0];
                        if (data) {
                            $scope.vm.form.data.BusinessUnitId = {
                                Id: data.BusinessUnitId,
                                Name: data.BusinessUnitIdName
                            };
                            $scope.vm.form.data.OwnerId = {
                                Id: data.OwnerId,
                                Name: data.OwnerIdName
                            };
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                    var url2 = 'api/Department/GetCodeById?id=' + id;
                    rt.get(url2).then(function (resp) {
                        $scope.vm.form.data.accountnumber = resp.data;
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                    var url3 = 'api/accountcontact/GetContactProvince?id=' + id;
                    rt.get(url3).then(function (resp) {
                        $scope.vm.form.data.provinceid = {
                            Id: resp.data.Id,
                            Name: resp.data.Name
                        };
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        vm.isLoading = false;
                    });
                }
            }
        });

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        //修改业务部门 业务负责人清空
        $scope.$watch("vm.form.data.BusinessUnitId.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-8
 说明     :PC端商业协访
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('BusinessAssistanceService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessAssistance';
        // @@ 选项集
        this.picklists = ['StateCode'];
        //检查账号是否是医院
        this.CheckAccountIsHos = function (id) {
            return rt.get("api/Account/CheckAccountIsHospital?accountId=" + id);
        };
    }]).controller('businessAssistanceListController', ['$scope', 'BusinessAssistanceService', entityListController]).controller('businessAssistanceEditController', ['$injector', '$scope', 'BusinessAssistanceService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.loadComplete = function () {
            if ($scope.vm.form.data.assistanceList == null) {
                $scope.vm.form.data.assistanceList = [{
                    visit_recordId: '',
                    OwnerId: { Id: '', Name: '' },
                    summary: ''
                    /* visit_assistanceId:''*/
                }];
            }
        };

        $scope.vm.form.preSave = function () {
            if ($scope.vm.form.data.is_assist) {
                for (var i = 0; i < $scope.vm.form.data.assistanceList.length; i++) {
                    if ($scope.vm.form.data.assistanceList[i].visit_assistanceId == null || $scope.vm.form.data.assistanceList[i].visit_assistanceId == '') {
                        $scope.vm.form.data.assistanceList[i].visit_assistanceId = rt.newGuid();
                    }
                    $scope.vm.form.data.assistanceList[i].visit_recordId = { Id: $scope.vm.form.data.Id };
                }
            }
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Eric Zheng
 创建时间 : 2018-02-27
 说明     :部门投入费用
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('businessUnitExpenseService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessUnitExpense';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('businessUnitExpenseListController', ['$injector', '$scope', 'businessUnitExpenseService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        this.searchList = [];
        var that = this;

        this.preExport = function (params) {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.stateSelected)) {
                that.searchList.push({
                    Type: 1,
                    Key: "StateCode",
                    Value: $scope.vm.stateSelected.Value
                });
            }
            if (!rt.isNullOrWhiteSpace($scope.vm.sDate) && !rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                if ($scope.vm.sDate.substr(0, 4) !== $scope.vm.eDate.substr(0, 4)) {
                    rt.errorMessage("只可查询同一年的数据");
                    return false;
                }
                if (_CalculateDays($scope.vm.sDate, $scope.vm.eDate) < 0) {
                    rt.errorMessage("开始日期必须小于结束日期");
                    return false;
                }
                var sArr = $scope.vm.sDate.split("-");
                var eArr = $scope.vm.eDate.split("-");
                that.searchList.push({
                    Type: 1,
                    Key: "year",
                    Value: sArr[0]
                });
                that.searchList.push({
                    Type: 3,
                    Key: "month",
                    Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1]
                });
            }
        };

        this.preSearch = function (params) {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.stateSelected)) {
                that.searchList.push({
                    Type: 1,
                    Key: "StateCode",
                    Value: $scope.vm.stateSelected.Value
                });
            }
            if (!rt.isNullOrWhiteSpace($scope.vm.sDate) && !rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                if ($scope.vm.sDate.substr(0, 4) !== $scope.vm.eDate.substr(0, 4)) {
                    rt.errorMessage("只可查询同一年的数据");
                    return false;
                }
                if (_CalculateDays($scope.vm.sDate, $scope.vm.eDate) < 0) {
                    rt.errorMessage("开始日期必须小于结束日期");
                    return false;
                }
                var sArr = $scope.vm.sDate.split("-");
                var eArr = $scope.vm.eDate.split("-");
                that.searchList.push({
                    Type: 1,
                    Key: "year",
                    Value: sArr[0]
                });
                that.searchList.push({
                    Type: 3,
                    Key: "month",
                    Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1]
                });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sDate = d.getFullYear() + "-" + '01';
            $scope.vm.eDate = moment().format('YYYY-MM');
        }

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
    }]).controller('businessUnitExpenseEditController', ['$injector', '$scope', 'businessUnitExpenseService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Oscar Gao
创建时间 : 2016-06-15
说明     : 部门药品清单
*********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('businessUnitProductService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        this.controllerName = 'BusinessUnitProduct';
        this.picklists = ['StateCode'];
        this.mutipleSelects = ['BusinessUnits'];
    }]).controller('businessUnitProductListController', ['$scope', 'businessUnitProductService', entityListController]).controller('businessUnitProductEditController', ['$scope', '$injector', 'businessUnitProductService', function ($scope, $injector, myService) {
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        var rt = myService.rt;
        function init() {
            $scope.businessUnits = [];
        }
        init();
        $scope.vm.form.preLoad = function () {
            $scope.businessUnits = [];
            rt.queryData("TblBusinessUnit.GetBusinessUnitNameTree", { '@id': '' }, function (resp) {
                $scope.businessUnits = [];
                for (var i = 0; i < resp.DataList.length; i++) {
                    $scope.businessUnits.push({ Id: resp.DataList[i].id, Name: resp.DataList[i].name });
                }
            }, function (error) {
                $scope.businessUnits = [];
            });
        };
        $scope.vm.form.loadComplete = function () {
            if (!rt.isNullOrWhiteSpace($scope.vm.form.data.business_unit_org)) {
                $scope.vm.form.data.business_unit_id.Name = $scope.vm.form.data.business_unit_org;
            }
        };
    }]).service('BusinessUnitProductDetailService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessUnitProductDetail';
        // @@ 选项集
        this.picklists = ['StateCode'];
        this.getProductSize = function (id) {
            var url = 'api/Product/GetProductById?id=' + id;
            return rt.get(url);
        };
    }]).controller('BusinessUnitProductDetailListController', ['$scope', 'BusinessUnitProductDetailService', entityListController]).controller('BusinessUnitProductDetailEditController', ['$scope', '$injector', 'BusinessUnitProductDetailService', function ($scope, $injector, myService) {
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        var rt = myService.rt;
        var $stateParams = myService.$stateParams;
        function init() {
            $scope.vm.pids = '';
            $scope.vm.unitid = $stateParams.id;
        }
        init();
        $scope.$watch("vm.form.data.productid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                //带出药品规格
                myService.getProductSize($scope.vm.form.data.productid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.form.data.product_size = resp.data.productsize;
                    } else {
                        $scope.vm.form.data.product_size = '';
                    }
                });
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-6
 说明     :PC端商业拜访
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('BusinessVisitService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessVisit';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getAttachmentList = function (id) {
            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
        //获取商业的拜访目的
        this.getBusinessVisitPurpose = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=business_visit_purpose";
            return rt.get(url);
        };
    }]).controller('businessvisitListController', ['$scope', 'BusinessVisitService', entityListController]).controller('businessvisitEditController', ['$injector', '$scope', 'BusinessVisitService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        var waiting = rt.showLoading2();
        $q.all([myService.getBusinessVisitPurpose()]).then(function (resp) {
            $scope._visitpurpose = resp[0].data;
        }).catch(function (err) {
            rt.errorMessage(err);
        }).finally(function () {
            waiting.close();
        });

        function _getAllOwner() {
            rt.queryData("UserInfo.GetAllUser", { '@queryValue': '' }, function (resp) {
                $scope.OwnerList = [];
                var data = resp.DataList;
                for (var i = 0; i < data.length; i++) {
                    $scope.OwnerList.push({ Id: data[i].id, Name: data[i].name });
                }
            }, function (error) {});
        }

        $scope.vm.form.preLoad = function (data) {
            //获取所有代表
            _getAllOwner();
            if ($scope.vm.form.type === 'Edit') {
                myService.getAttachmentList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.attachmentList = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }
        };

        $scope.vm.form.loadComplete = function () {
            var newassList = [];
            if ($scope.vm.form.data.assistanceList != null) {
                angular.forEach($scope.vm.form.data.assistanceList, function (entity) {
                    newassList.push({ Id: entity.OwnerId.Id, Name: entity.OwnerIdName });
                });
                $scope.vm.form.data.assistanceList = newassList;
            }
        };

        $scope.vm.form.preSave = function () {
            $scope.vm.form.data.visitpurposes = JSON.stringify($scope.vm.form.data.VisitPurpose);
            var assistanceList = $scope.vm.form.data.assistanceList;
            if ($scope.vm.form.data.is_assist) {
                for (var i = 0; i < assistanceList.length; i++) {
                    if (assistanceList.visit_assistanceId == null || assistanceList.visit_assistanceId == '') {
                        $scope.vm.form.data.assistanceList[i].visit_assistanceId = rt.newGuid();
                        $scope.vm.form.data.assistanceList[i].OwnerId = {
                            Id: assistanceList[i].Id,
                            Name: assistanceList[i].Name
                        };
                        $scope.vm.form.data.assistanceList[i].Id = assistanceList[i].visit_assistanceId;
                    }
                    $scope.vm.form.data.assistanceList[i].visit_recordId = { Id: $scope.vm.form.data.Id };
                }
            }
        };

        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("business_visit", fileId);
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/5/15
 说明     : 流向处理 - 计算流向归属
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('CalDrugFlowAssignmentService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'CalDrugFlowAssignment';

        this.getDataList = function (yM, businessunitId, accountId, flowType, pageIndex) {
            var url = 'api/CalDrugFlowAssignment/GetDataList?yM=' + yM;
            url += '&businessunitId=' + businessunitId;
            url += '&accountId=' + accountId;
            url += '&flowType=' + flowType;
            url += '&pageSize=' + rt.getPaginationSize();
            url += '&pageIndex=' + pageIndex;
            return rt.get(url);
        };

        this.getUnAssignCount = function (yM, businessunitId, accountId) {
            var url = 'api/CalDrugFlowAssignment/GetUnAssignCount?yM=' + yM;
            url += '&businessunitId=' + businessunitId;
            url += '&accountId=' + accountId;
            return rt.get(url);
        };

        this.calDrugFlowAssignment = function (yM, businessunitId, accountId, flowType) {
            var url = 'api/CalDrugFlowAssignment/CalDrugFlowAssignment?yM=' + yM;
            url += '&businessunitId=' + businessunitId;
            url += '&accountId=' + accountId;
            url += '&flowType=' + flowType;
            return rt.get(url);
        };

        this.saveData = function (list) {
            var url = 'api/CalDrugFlowAssignment/SaveData';
            return rt.post(url, list);
        };
    }]).controller('CalDrugFlowAssignmentListController', ['$injector', '$compile', '$scope', '$state', 'CalDrugFlowAssignmentService', function ($injector, $compile, $scope, $state, myService) {
        var rt = myService.rt;

        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            _that.searchList.length = 0;

            if (rt.isNullOrWhiteSpace($scope.vm.yM)) {
                return "请选择年月";
            } else {
                _that.searchList.push({ Type: 1, Key: "yM", Value: moment($scope.vm.yM).format('YYYY-MM') });
            }
            _that.searchList.push({ Type: 1, Key: "businessunitId", Value: rt.isNull($scope.vm.businessunitId.Id) ? '' : $scope.vm.businessunitId.Id });
            _that.searchList.push({ Type: 1, Key: "accountId", Value: rt.isNull($scope.vm.accountId.Id) ? '' : $scope.vm.accountId.Id });
            _that.searchList.push({ Type: 1, Key: "flowType", Value: $scope.vm.flowType });
            _that.searchList.push({ Type: 1, Key: "importType", Value: $scope.vm.importType });
        };

        this.preSearch = function (params) {
            if (rt.isNullOrWhiteSpace($scope.vm.yM)) {
                return "请选择年月";
            }
        };

        this.reload = function _loadData(pageIndex) {
            if (pageIndex && typeof pageIndex === 'number') $scope.vm.page.index = pageIndex;

            var preSearchMessage = $scope.vm.actions.preSearch();
            if (!rt.isNull(preSearchMessage) && preSearchMessage.length > 0) {
                rt.errorMessage(preSearchMessage);
                return;
            }

            _getDataList();
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        var $stateParams = myService.$stateParams;
        $scope.vm.isShowBack = !rt.isNullOrWhiteSpace($stateParams.ym);
        $scope.vm.yM = moment(rt.isNullOrWhiteSpace($stateParams.ym) ? moment().add('months', -1) : $stateParams.ym).format('YYYY-MM');
        $scope.vm.businessunitId = rt.isNullOrWhiteSpace($stateParams.frombuid) ? { Id: '' } : JSON.parse($stateParams.frombuid);
        $scope.vm.accountId = rt.isNullOrWhiteSpace($stateParams.fromaccid) ? { Id: '' } : JSON.parse($stateParams.fromaccid);
        $scope.vm.flowType = 'unAssign';
        $scope.vm.importType = '';
        $scope.vm.isSaveShow = false;
        $scope.vm.actions.getDataList = _getDataList;
        $scope.goBack = _goBack;
        _getDataList();

        function _goBack() {
            $state.go("main.ddmmanage", {}, { location: true });
        }

        //初始化表格数据
        function _getDataList() {
            if (rt.isNullOrWhiteSpace($scope.vm.yM)) {
                rt.errorMessage("请选择年月");
                return false;
            }

            var waiting = rt.showLoading2();
            myService.getDataList($scope.vm.yM, rt.isNull($scope.vm.businessunitId.Id) ? '' : $scope.vm.businessunitId.Id, rt.isNull($scope.vm.accountId.Id) ? '' : $scope.vm.accountId.Id, $scope.vm.flowType, $scope.vm.page.index).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;

                myService.getUnAssignCount($scope.vm.yM, rt.isNull($scope.vm.businessunitId.Id) ? '' : $scope.vm.businessunitId.Id, rt.isNull($scope.vm.accountId.Id) ? '' : $scope.vm.accountId.Id).then(function (resp) {
                    $scope.vm.unAssignCount = resp.data;
                }).catch(function (err) {
                    rt.errorMessage(err);
                });
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }

        //计算流向归属
        $scope.vm.actions.calDrugFlowAssignment = function () {
            var waiting = rt.showWaiting();
            myService.calDrugFlowAssignment($scope.vm.yM, rt.isNull($scope.vm.businessunitId.Id) ? '' : $scope.vm.businessunitId.Id, rt.isNull($scope.vm.accountId.Id) ? '' : $scope.vm.accountId.Id, $scope.vm.flowType).then(function (resp) {
                $scope.vm.isSaveShow = true;
                _getDataList();
                rt.successMessage('计算成功');
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        };

        //完成归属，写入数据库 
        $scope.vm.actions.saveData = function () {
            if ($scope.vm.data.length == 0) {
                rt.errorMessage('没有数据可以操作');
                return;
            }

            var waiting = rt.showWaiting();
            myService.saveData($scope.vm.data).then(function (resp) {
                rt.successMessage('保存成功');
                _getDataList();
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        };

        $scope.vm.actions.chooseFlowType = function () {
            $scope.vm.flowType = $("input[name='flowType']:checked").val();
            // _getDataList();
        };

        $scope.vm.actions.import = function (headerMap) {
            $scope.vm.importHeader = headerMap;
            BootstrapDialog.show({
                type: BootstrapDialog.TYPE_PRIMARY,
                title: '导入' + $scope.vm.importHeader.Title,
                message: '<div rt-include rt-template="Module/CalDrugFlowAssignment/calDrugFlowAssignmentImportView.html" rt-controller="CalDrugFlowAssignmentImportController" ></div>',
                size: BootstrapDialog.SIZE_NORMAL,
                closable: true,
                onshow: function onshow(dialog) {
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : ludwig-Dong
 创建时间 : 2016-06-28
 说明     : 市场活动
 *********************************************************/
(function () {
	'use strict';

	angular.module('xrmApp').service('campaignService', ['entityService', function (entityService) {
		angular.extend(this, entityService);
		var rt = entityService.rt;
		// @@设置WebAPI的控制器名称
		this.controllerName = 'campaign';
		// @@ 选项集
		this.picklists = ['StateCode', 'campaign_type', 'action_status'];

		this.getAttachmentList = function (id) {
			// 如果请求的Id为空，则直接返回承诺，不需要再请求服务器
			if (rt.isNull(id) || id.length === 0) {
				var deferred = $q.defer();
				deferred.resolve({ data: null });
				return deferred.promise;
			}

			var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
			return rt.get(url);
		};

		this.completeInvite = function (campaignid) {
			return rt.get("api/Campaign/CompleteInvite?campaignid=" + campaignid);
		};
	}]).controller('campaignListController', ['$injector', '$compile', '$scope', 'campaignService', function ($injector, $compile, $scope, myService) {
		var rt = myService.rt;
		var that = this;
		this.searchList = [];

		this.preSearch = function () {
			var unitids = _CalculateUnitids();
			that.searchList.length = 0;
			that.searchList.push({ Type: 1, Key: "campaignid", Value: $scope.vm.attactingSelected.id });
			that.searchList.push({ Type: 1, Key: "action_status", Value: $scope.vm.statusSelected.Value });
			if (!rt.isNull($scope.vm.timeSelected.sYm) && !rt.isNull($scope.vm.timeSelected.eYm)) {
				var sYm = moment($scope.vm.timeSelected.sYm).format('YYYY-MM-DD');
				var eYm = moment($scope.vm.timeSelected.eYm).format('YYYY-MM-DD');
				that.searchList.push({ Type: 1, key: "sYm", Value: sYm });
				that.searchList.push({ Type: 1, key: "eYm", Value: eYm });
			}
			if (!rt.isNull($scope.vm.timeSelected.CreatedOnsYm) && !rt.isNull($scope.vm.timeSelected.CreatedOneYm)) {
				var CreatedOnsYm = moment($scope.vm.timeSelected.CreatedOnsYm).format('YYYY-MM-DD');
				var CreatedOneYm = moment($scope.vm.timeSelected.CreatedOneYm).format('YYYY-MM-DD');
				that.searchList.push({ Type: 1, key: "CreatedOnsYm", Value: CreatedOnsYm });
				that.searchList.push({ Type: 1, key: "CreatedOneYm", Value: CreatedOneYm });
			}
			if ($scope.vm.campaign_type != undefined && $scope.vm.campaign_type != "") {
				that.searchList.push({ Type: 1, key: "campaign_type", Value: $scope.vm.campaign_type.Value });
			}
			if (!rt.isNull(unitids) && unitids != "") {
				that.searchList.push({ Type: 1, key: "unitids", Value: unitids });
			}
		};
		$injector.invoke(entityListController, this, {
			$scope: $scope,
			myService: myService
		});
		$scope.vm.timeFilter = [];
		$scope.vm.attactingFilter = [];
		$scope.vm.statusFilter = [];
		$scope.vm.timeSelected = {};
		$scope.vm.campaign_type = {};
		$scope.vm.attactingSelected = {};
		$scope.vm.statusSelected = {};
		inIt();

		function getBusinessUnitList() {
			rt.filteredQueryData("TblBusinessUnit.BusinessUnitId", {
				'@queryValue': ''
			}, function (resp) {
				$scope.vm.businessUnitSelected = null;
				$scope.vm.businessUnitList = [];
				var data = resp.DataList;
				if (!rt.isNull(data) && data.length > 0) {
					$scope.vm.businessUnitList = data;
				}
			}, function (error) {
				$scope.vm.businessUnitList = [];
			});
		}

		//逗号分隔部门
		function _CalculateUnitids() {
			var unitids = "";
			if (!rt.isNull($scope.vm.businessUnitSelected)) {
				var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
					return item.id;
				});
				unitids = unitmap.join(",");
			}
			return unitids;
		}

		function inIt() {
			var d = new Date();
			getStatus().then(function (resp) {
				if (!rt.isNull(resp.data) && !rt.isNull(resp.data.action_status)) {
					$scope.vm.statusFilter = resp.data.action_status;
				}
				$scope.vm.statusFilter.push({ Value: 0, Name: '全部活动' });
				$scope.vm.statusSelected = $scope.vm.statusFilter[5];
			});
			$scope.vm.attactingFilter = [{ id: 1, name: '我参与的活动' }, { id: 2, name: '我负责的活动' }, { id: 3, name: '所有的活动' }];
			$scope.vm.attactingSelected = $scope.vm.attactingFilter[2];
			$scope.vm.exportExcelId = rt.newGuid();

			getBusinessUnitList();
		}

		function getStatus() {
			return rt.get("api/campaign/GetPickListData?fieldCodes=action_status");
		}

		$scope.vm.showImage = function (obiectId) {
			var relatedHtml = '';
			var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
			$scope.vm.dialog = BootstrapDialog.show({
				title: '',
				type: BootstrapDialog.TYPE_DEFAULT,
				message: html,
				size: BootstrapDialog.SIZE_WIDE,
				onshow: function onshow(dialog) {
					dialog.getModalHeader().hide();
					dialog.getModalFooter().hide();
					var obj = dialog.getModalBody().contents();
					$compile(obj)($scope);
				}
			});
		};
	}]).controller('campaignEditController', ['$injector', '$compile', '$scope', 'campaignService', function ($injector, $compile, $scope, myService) {
		var rt = myService.rt;
		var localUserId = rt.getUserId();

		$injector.invoke(entityEditController, this, {
			$scope: $scope,
			myService: myService
		});
		$scope.vm.form.attachmentList = [];
		$scope.vm.isOwner = false; // 是否为该市场活动负责人
		$scope.vm.form.loadComplete = function () {
			if ($scope.vm.form.type == "Create") $scope.vm.isOwner = true;else if (localUserId.toUpperCase() == $scope.vm.form.data.OwnerId.Id.toUpperCase()) {
				$scope.vm.isOwner = true;
			}
			_getFile();
		};

		$scope.vm.form.preSave = function () {
			if (moment($scope.vm.form.data.starttime).add('minutes', 5).toDate() < moment()) {
				rt.errorMessage('计划时间必须大于当前时间');
				return "计划时间必须大于当前时间";
			}

			if (rt.isNull($scope.vm.form.data.Id)) {
				$scope.vm.form.data.action_status = { Value: 10, Name: "规划中" };
			}
		};

		$scope.vm.form.completeInvite = function () {
			myService.completeInvite($scope.vm.form.data.Id).then(function () {
				rt.successMessage("邀请成功");
				$scope.$emit('rt-reload');
			});
		};

		/* start 附件相关*/
		function _getFile() {
			if ($scope.vm.form.id != "") {
				return rt.GetFilesByObjectId("unknown", $scope.vm.form.id).error(function (message) {
					rt.errorMessage(message);
				}).success(function (data) {
					if (data != null) {
						var data1 = data.DataList;
						$scope.attchmentcount = data1.length;
						$scope.fjs = [];
						for (var i = 0; i < data1.length; i++) {
							$scope.fjs.push({
								Id: data1[i].Id,
								FileName: data1[i].FileName,
								DownFile: true
							});
						}
					} else {
						$scope.attchmentcount = 0;
					}
				});
			}
		}

		$scope.vm.form.downloadfile = function (fileId) {
			rt.downloadFile("unknown", fileId);
		};
		/* end 附件相关*/

		//保存并新建
		$scope.truesave = function () {
			$scope.vm.form.save(true).then(function () {
				$scope.fjs = []; //清空附件
			});
		};
	}])

	// 市场活动联系人模块
	.service('campaigncontactService', ['entityService', function (entityService) {
		angular.extend(this, entityService);
		// @@设置WebAPI的控制器名称
		this.controllerName = 'campaigncontact';
		// @@ 选项集
		this.picklists = ['StateCode'];
	}]).controller('campaigncontactListController', ['$injector', '$compile', '$scope', 'campaigncontactService', function ($injector, $compile, $scope, myService) {
		var rt = myService.rt;
		$injector.invoke(entityListController, this, {
			$scope: $scope,
			myService: myService
		});
		$scope.vm.actions.loadComplete = function () {
			$scope.vm.isOwner = $scope.$parent.vm.isOwner;
			$scope.vm.actionStatus = $scope.$parent.vm.form.data.action_status.Value; //市场活动的活动状态 10规划中 20执行中 30入场签到 40结束评估 50已完成
		};
	}]).controller('campaigncontactEditController', ['$injector', '$scope', 'campaigncontactService', function ($injector, $scope, myService) {
		var rt = myService.rt;
		$injector.invoke(entityEditController, this, {
			$scope: $scope,
			myService: myService
		});
		$scope.vm.form.loadComplete = function () {
			$scope.vm.isOwner = $scope.$parent.vm.isOwner;
			$scope.vm.actionStatus = $scope.$parent.vm.actionStatus;
		};
	}])

	//市场活动参与人模块
	.service('campaignuserService', ['entityService', function (entityService) {
		angular.extend(this, entityService);
		// @@设置WebAPI的控制器名称
		this.controllerName = 'campaignuser';
		// @@ 选项集
		this.picklists = ['StateCode'];
	}]).controller('campaignuserListController', ['$injector', '$compile', '$scope', 'campaignuserService', function ($injector, $compile, $scope, myService) {
		var rt = myService.rt;
		$injector.invoke(entityListController, this, {
			$scope: $scope,
			myService: myService
		});
		$scope.vm.actions.loadComplete = function () {
			$scope.vm.isOwner = $scope.$parent.vm.isOwner;
			$scope.vm.actionStatus = $scope.$parent.vm.form.data.action_status.Value; //市场活动的活动状态 10规划中 20执行中 30入场签到 40结束评估 50已完成
		};
	}]).controller('campaignuserEditController', ['$injector', '$scope', 'campaignuserService', function ($injector, $scope, myService) {
		var rt = myService.rt;
		$injector.invoke(entityEditController, this, {
			$scope: $scope,
			myService: myService
		});
		$scope.vm.form.loadComplete = function () {
			$scope.vm.isOwner = $scope.$parent.vm.isOwner;
			$scope.vm.actionStatus = $scope.$parent.vm.actionStatus;
		};
	}])

	// 市场活动微信签到模块
	.service('campaignwechatService', ['entityService', function (entityService) {
		angular.extend(this, entityService);
		// @@设置WebAPI的控制器名称
		this.controllerName = 'CampaignWeChatSignIn';
	}]).controller('campaignwechatListController', ['$injector', '$compile', '$scope', 'campaignwechatService', function ($injector, $compile, $scope, myService) {
		var rt = myService.rt;
		$injector.invoke(entityListController, this, {
			$scope: $scope,
			myService: myService
		});
		$scope.vm.actions.loadComplete = function () {
			$scope.vm.isOwner = $scope.$parent.vm.isOwner;
			$scope.vm.actionStatus = $scope.$parent.vm.form.data.action_status.Value; //市场活动的活动状态 10规划中 20执行中 30入场签到 40结束评估 50已完成
		};
	}]);
})();
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/3/2
 *描述：商业回款导入脚本
 *************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('cashbackService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'cashback';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('cashbackListController', ['$injector', '$scope', '$timeout', 'cashbackService', function ($injector, $scope, $timeout, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;
        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }
            if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                return "开始日期必须小于结束日期";
            }
            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join("','");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join("','");
            }
            var sArr = $scope.vm.sYm.split("-");
            var eArr = $scope.vm.eYm.split("-");
            that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
            that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.businessName) && $scope.vm.businessName != "") {
                that.searchList.push({ Type: 0, key: "accountidName", Value: $scope.vm.businessName });
            }
            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }
            if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                return "开始日期必须小于结束日期";
            }
            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join("','");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join("','");
            }
            var sArr = $scope.vm.sYm.split("-");
            var eArr = $scope.vm.eYm.split("-");
            that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
            that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }

            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.businessName) && $scope.vm.businessName != "") {
                that.searchList.push({ Type: 0, key: "accountidName", Value: $scope.vm.businessName });
            }
            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.showForm = _showForm;
        //--新增多条件查询--//
        //--CreateTime:2016-05-19--//
        $scope.vm.searchFormHide = true;
        $scope.vm.buidList = [];
        $scope.vm.buidSelected = null;
        $scope.vm.bigDepList = [];
        $scope.vm.bigDepSelected = null;
        $scope.vm.businessUnitList = [];
        $scope.vm.businessUnitSelected = [];
        $scope.vm.depType = 0;
        $scope.vm.businessName = "";
        $scope.vm.OwnerName = "";
        $scope.vm.clickForm = function () {};
        _getAllBuid();
        _initYmSelected();
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }
        //--新增结束--//
        function _showForm() {
            var html = '<div rt-include rt-template="Module/CashBack/cashbackExcelImportView.html" rt-controller="cashbackExcelImportController" ></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '<span style="color:#09f"><i class="fa fa-upload fa-2x"></i>　导入商业回款数据</span>',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_NORMAL,
                modal: false,
                onshow: function onshow(dialog) {
                    //dialog.getModalHeader().hide();
                    //dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }

        //-新增参数化查询数据-CreateTime：2016-05-19-//

        $scope.overHeightTable = function () {
            overHeightTable();
        };
        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }
        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });

        //-新增结束--//
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2016-09-27
 说明     : 连锁总部
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('chainaccountService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        var rt = entityService.rt;

        // @@设置WebAPI的控制器名称
        this.controllerName = 'chainaccount';

        // @@ 选项集
        this.picklists = ['StateCode', 'chain_type', 'account_grade_level'];

        //获取归属信息
        this.GetSalesRegionInfo = function (accountId) {
            return rt.get("api/Account/GetSalesRegionInfo?accountId=" + accountId);
        };

        //保存归属信息
        this.SaveSalesRegionInfo = function (accountId, dataList) {
            return rt.post("api/SalesRegionAccount/SaveSalesRegionInfo?accountId=" + accountId, dataList);
        };

        //根据销售区域Id获取部门和用户信息
        this.GetBusinessAndOwnerInfoById = function (sales_regionId) {
            return rt.get("api/SalesRegion/GetBusinessAndOwnerInfoById?sales_regionId=" + sales_regionId);
        };
    }]).controller('chainaccountListController', ['$injector', '$compile', '$scope', 'chainaccountService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        $scope.viewTag = "Web";
        this.viewTag = "Web";

        var that = this;
        this.isPost = true;
        this.searchList = [];
        this.bodySearchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
            that.bodySearchList.length = 0;

            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            if (!rt.isNullOrEmptyString(unitids)) {
                var idArray = unitids.split(",");
                that.bodySearchList.push({ Type: 2, Key: "BusinessUnitId", Value: idArray });
            }

            if (!rt.isNull($scope.vm.stateSelected)) that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.Value });

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.province) && !rt.isNullOrEmptyString($scope.vm.areaSelected.province.Id)) {
                that.searchList.push({ Type: 1, Key: "provinceid", Value: $scope.vm.areaSelected.province.Id });
            }

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.city) && !rt.isNullOrEmptyString($scope.vm.areaSelected.city.Id)) {
                that.searchList.push({ Type: 1, Key: "cityid", Value: $scope.vm.areaSelected.city.Id });
            }

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.county) && !rt.isNullOrEmptyString($scope.vm.areaSelected.county.Id)) {
                that.searchList.push({ Type: 1, Key: "countyid", Value: $scope.vm.areaSelected.county.Id });
            }

            if (!rt.isNullOrEmptyString($scope.vm.tagSelected)) {
                if ($scope.vm.tagSelected.indexOf('：') < 0 && $scope.vm.tagSelected.indexOf(':') < 0) {
                    return "请按照正确格式输入：标签名称：内容1，内容2；";
                }
                that.searchList.push({ Type: 5, Key: "account_tag", Value: $scope.vm.tagSelected });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.loadComplete = function () {
            if (!rt.isNull($scope.vm.data)) {
                for (var i = 0; i < $scope.vm.data.length; i++) {
                    if (!rt.isNull($scope.vm.data[i].account_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.data[i].account_tag) {
                            tagstring += o + "：" + $scope.vm.data[i].account_tag[o] + "；";
                        }
                        $scope.vm.data[i].tagstring = tagstring;
                    }
                }
            }
        };
    }]).controller('chainaccountEditController', ['$injector', '$compile', '$scope', 'chainaccountService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.$watch("vm.form.data.cityid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.delSelected = [];
        //加载归属信息
        $scope.vm.form.loadComplete = function () {
            $scope.vm.getSalesRegionInfo();
            $scope.isCheckAll = false;
            $scope.vm.form.tagList = [];
            if (!rt.isNull($scope.vm.form.data.account_tag)) {
                var tagstring = "";
                for (var o in $scope.vm.form.data.account_tag) {
                    tagstring = o + "：" + $scope.vm.form.data.account_tag[o];
                    $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
                }
            }
        };

        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/BusinessAccount/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            var valueList = data.Value.split(/[,，]/);
            var list = [];
            for (var i = 0; i < valueList.length; i++) {
                if (!rt.isNullOrWhiteSpace(valueList[i])) {
                    list.push(valueList[i]);
                }
            }
            if (rt.isNull($scope.vm.form.data.account_tag)) {
                $scope.vm.form.data.account_tag = {};
            }
            $scope.vm.form.data.account_tag[data.Name] = list;
            $scope.vm.form.tagList = [];
            var tagstring = "";
            for (var o in $scope.vm.form.data.account_tag) {
                tagstring = o + "：" + $scope.vm.form.data.account_tag[o];
                $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
            }
        });

        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.form.tagList, { 'checked': true });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.form.tagList = _.where($scope.vm.form.tagList, { 'checked': false });
            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.account_tag = tag;
        };

        //保存之前
        $scope.vm.form.preSave = function (data) {
            if ($scope.salesRegionInfoList.length == 0) {
                rt.errorMessage("至少选择一条连锁总部归属信息。");
                return "至少选择一条连锁总部归属信息。";
            }
            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.account_tag = tag;
        };

        //保存之后
        $scope.vm.form.postSave = function () {
            //保存归属信息
            $scope.vm.saveSalesRegionInfo();
        };

        $scope.vm.getSalesRegionInfo = function () {
            //打开客户编辑页面时获取归属信息
            if (rt.isNull($scope.rtIncludeParams) || !rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                myService.GetSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id).then(function (resp) {
                    $scope.salesRegionInfoList = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            }
        };

        //保存归属信息
        $scope.vm.saveSalesRegionInfo = function () {
            myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {}).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.salesRegionInfoList = _.remove($scope.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    //编辑客户时，删除归属信息才和后台数据库交互
                    if (!rt.isNullOrEmptyString($scope.vm.form.data.Id)) {
                        $scope.vm.saveSalesRegionInfo();
                    }

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegion").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //编辑客户-归属信息
        $scope.vm.showForm = function (row, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params="{rtIncludeId:\'' + row + '\'' + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //新建客户-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=' + JSON.stringify(list) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品种。");
                return "必须提供品种。";
            }

            if (rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                $scope.salesRegionInfoList = $scope.rtIncludeParams;
            }

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品种，不能再添加其他品种。");
                    return "已选择了全品种，不能再添加其他品种。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };
            // 编辑客户时，直接保存到数据库，并刷新数据
            if (!rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {
                    $scope.$emit('rt-on-dialog-close-click');
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            } else
                // 新建客户时，广播到编辑页面
                $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.salesRegionInfoList);
        };

        // 新建客户-编辑归属信息页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.salesRegionInfoList = list;
        });

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };
    }]).service('chaincontactService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'chaincontact';

        // @@ 选项集
        this.picklists = ['StateCode', 'preferredcontactmethod', 'gendercode', 'familystatuscode', 'bachelor'];
    }]).controller('chaincontactListController', ['$injector', '$compile', '$scope', 'chaincontactService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        $scope.viewTag = "Web";
        this.viewTag = "Web";
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('chaincontactEditController', ['$injector', '$scope', 'chaincontactService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch('vm.form.data.accountid', function (newValue, oldValue) {
            if (oldValue == newValue) return;
            if (rt.isNull($scope.vm.form.data.accountid) || rt.isNullOrWhiteSpace($scope.vm.form.data.accountid.Id)) return;
            if ($scope.vm.form.type !== 'Create') return;
            var id = $scope.vm.form.data.accountid.Id;
            var waiting = rt.showLoading2();
            var url = 'api/AccountContact/GetContactBusinessUnit?id=' + id;
            rt.get(url).then(function (resp) {
                var data = resp.data[0];
                if (data) {
                    $scope.vm.form.data.BusinessUnitId = {
                        Id: data.BusinessUnitId,
                        Name: data.BusinessUnitIdName
                    };
                    $scope.vm.form.data.OwnerId = {
                        Id: data.OwnerId,
                        Name: data.OwnerIdName
                    };
                }
            }).catch(function (msg) {
                rt.errorMessage(msg);
            }).finally(function () {
                waiting.close();
            });

            var url2 = 'api/Department/GetCodeById?id=' + id;
            rt.get(url2).then(function (resp) {
                $scope.vm.form.data.accountnumber = resp.data;
            }).catch(function (msg) {
                rt.errorMessage(msg);
            }).finally(function () {
                waiting.close();
            });

            var url3 = 'api/accountcontact/GetContactProvince?id=' + id;
            rt.get(url3).then(function (resp) {
                $scope.vm.form.data.provinceid = {
                    Id: resp.data.Id,
                    Name: resp.data.Name
                };
            }).catch(function (msg) {
                rt.errorMessage(msg);
            }).finally(function () {
                vm.isLoading = false;
            });
        });

        $scope.$watch('vm.form.data.buid.Id', function (newValue, oldValue) {
            if (oldValue == newValue || rt.isNull(oldValue)) return;
            $scope.vm.form.data.bigdepartid = null;
            $scope.vm.unitSelected = null;
            $scope.vm.unitList = [];
        });

        $scope.$watch('vm.form.data.bigdepartid.Id', function (newValue, oldValue) {
            if (oldValue == newValue || rt.isNull(oldValue)) return;
            $scope.vm.form.data.BusinessUnitId = null;
            $scope.vm.unitList = [];
        });

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue == newValue || rt.isNull(oldValue)) return;
            $scope.vm.form.data.cityid = null;
            $scope.vm.form.data.countyid = null;
        });

        //修改业务部门 业务负责人清空
        $scope.$watch("vm.form.data.BusinessUnitId.Id", function (newValue, oldValue) {
            if (oldValue == newValue || rt.isNull(oldValue)) return;
            $scope.vm.form.data.OwnerId = null;
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2017-04-20
 说明     : 竞品终端销量采集
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('competingproCollectService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'CompetingproCollect';

        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getCompetitorById = function (id) {
            return rt.get("api/CompetingProduct/GetCompetitorByCompetingProductId?id=" + id);
        };
    }]).controller('competingproCollectListController', ['$injector', '$compile', '$scope', 'competingproCollectService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        var that = this;
        this.searchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.stateSelected) && !rt.isNull($scope.vm.stateSelected.value)) {
                that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.value });
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }

            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdepartid", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.Id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        _getAllBuid();
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
            }, function (error) {
                $scope.vm.buidList = [];
            });
        }

        //获取上游商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            $scope.vm.bigDepSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.businessUnitSelected = null;
            $scope.vm.businessUnitList = [];

            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) return;

            rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                $scope.vm.bigDepList = resp.DataList;
            }, function (error) {
                $scope.vm.bigDepList = [];
            });
        });
        //获取上游省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            $scope.vm.businessUnitSelected = null;
            $scope.vm.businessUnitList = [];

            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) return;

            rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    data.forEach(function (e) {
                        $scope.vm.businessUnitList.push({ Name: e.name, Id: e.id });
                    });
                }
            }, function (error) {
                $scope.vm.businessUnitList = [];
            });
        });
    }]).controller('competingproCollectEditController', ['$injector', '$scope', 'competingproCollectService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.loadComplete = function () {
            if (!rt.isNull($scope.vm.form.data) && !rt.isNull($scope.vm.form.data.year_month)) {
                $scope.vm.ym = moment().set({ 'year': $scope.vm.form.data.year_month / 100, 'month': $scope.vm.form.data.year_month % 100 }).add(-1, 'month');
            }
        };

        $scope.vm.form.preSave = function () {
            $scope.vm.form.data.year_month = moment($scope.vm.ym).year() * 100 + moment($scope.vm.ym).month() + 1;
        };

        $scope.$watch("vm.form.data.competing_product_id.Id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            if (!rt.isNullOrWhiteSpace(newValue)) {
                myService.getCompetitorById(newValue).then(function (resp) {
                    $scope.vm.form.data.competitorid = resp.data;
                });
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/20
 说明     : 竞品信息
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('CompetingProductService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'CompetingProduct';

        this.picklists = ['StateCode', 'product_type'];
    }]).controller('CompetingProductListController', ['$injector', '$scope', 'CompetingProductService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('CompetingProductEditController', ['$injector', '$scope', 'CompetingProductService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016-02-01
 说明     : 医生档案
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('contactService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'accountcontact';

        // @@ 选项集
        this.picklists = ['StateCode', 'jobtitle', 'preferredcontactmethod', 'gendercode', 'familystatuscode', 'bachelor', 'contact_level', "rx_potential", "rx_attitude"];

        //隐秘字段权限
        this.operatingNames = ['btnMktSpouseName_c3a02938-15ba-4544-bfb3-25c77b2b8156', 'btnMktPersonnalMark_0aa3567d-b940-4218-b7f1-1d1b3c84f024', 'btnMktBooks_0f29daca-3605-40dc-8007-bc80f1d234a3', 'btnMktResearchResult_a52a0f24-f9eb-4a8f-b522-e4cc252a5e9e'];

        //检查账号是否是医院
        this.CheckAccountIsHos = function (id) {
            return rt.get("api/Account/CheckAccountIsHospital?accountId=" + id);
        };

        //检查账号是否是商业
        this.CheckAccountIsBus = function (id) {
            return rt.get("api/Account/CheckAccountIsBusiness?accountId=" + id);
        };

        //获取归属信息
        this.GetSalesRegionInfo = function (contactId) {
            return rt.get("api/accountcontact/GetSalesRegionInfo?contactId=" + contactId);
        };

        //保存归属信息
        this.SaveSalesRegionInfo = function (contactId, dataList) {
            return rt.post("api/SystemUserContact/SaveSalesRegionInfo?contactId=" + contactId, dataList);
        };

        //根据销售区域Id获取部门和用户信息
        this.GetBusinessAndOwnerInfoById = function (sales_regionId) {
            return rt.get("api/SalesRegion/GetBusinessAndOwnerInfoById?sales_regionId=" + sales_regionId);
        };
    }]).controller('contactListController', ['$injector', '$compile', '$scope', 'contactService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        var that = this;

        this.searchList = [];

        this.preSearch = function (params) {
            that.searchList.length = 0;
            if (!rt.isNullOrEmptyString($scope.vm.tagSelected)) {
                if ($scope.vm.tagSelected.indexOf('：') < 0 && $scope.vm.tagSelected.indexOf(':') < 0) {
                    return "请按照正确格式输入：标签名称：内容1，内容2；";
                }
                that.searchList.push({ Type: 5, Key: "contact_tag", Value: $scope.vm.tagSelected });
            }
            if (!rt.isNull($scope.vm.stateSelected)) that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.Value });
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.loadComplete = function () {
            if (!rt.isNull($scope.vm.data)) {
                for (var i = 0; i < $scope.vm.data.length; i++) {
                    if (!rt.isNull($scope.vm.data[i].contact_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.data[i].contact_tag) {
                            tagstring += o + "：" + $scope.vm.data[i].contact_tag[o] + "；";
                        }
                        $scope.vm.data[i].tagstring = tagstring;
                    }
                }
            }
        };
    }]).controller('contactEditController', ['$injector', '$compile', '$scope', 'contactService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.preSave = function () {
            if (!isCardNo($scope.vm.form.data.idcard) && !rt.isNullOrWhiteSpace($scope.vm.form.data.idcard)) {
                rt.errorMessage("请输入正确的身份证号");
                return "请输入正确的身份证号";
            }

            if ($scope.vm.form.data.is_hospital && $scope.salesRegionInfoList.length == 0) {
                rt.errorMessage("至少选择一条医生归属信息。");
                return "至少选择一条医生归属信息。";
            }
        };

        function isCardNo(card) {
            // 身份证号码为15位或者18位，15位时全为数字，18位前17位为数字，最后一位是校验位，可能为数字或字符X 
            var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
            return reg.test(card);
        }

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.$watch('vm.form.data.accountid', function (newValue, oldValue) {
            if (oldValue != newValue) {
                myService.CheckAccountIsHos($scope.vm.form.data.accountid.Id).then(function (resp) {
                    var isH = resp.data;
                    if (isH === "1") {
                        $scope.vm.form.data.is_hospital = true;
                    } else {
                        $scope.vm.form.data.is_hospital = false;
                    }
                });
                myService.CheckAccountIsBus($scope.vm.form.data.accountid.Id).then(function (resp) {
                    var isH = resp.data;
                    if (isH === "1") {
                        $scope.vm.is_business = true;
                    } else {
                        $scope.vm.is_business = false;
                    }
                });
                if (!rt.isNull($scope.vm.form.data.accountid) && $scope.vm.form.type === 'Create') {
                    var id = $scope.vm.form.data.accountid.Id;
                    var waiting = rt.showLoading2();
                    var url2 = 'api/Department/GetCodeById?id=' + id;
                    rt.get(url2).then(function (resp) {
                        $scope.vm.form.data.accountnumber = resp.data;
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                    var url3 = 'api/accountcontact/GetContactProvince?id=' + id;
                    rt.get(url3).then(function (resp) {
                        $scope.vm.form.data.provinceid = {
                            Id: resp.data.Id,
                            Name: resp.data.Name
                        };
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        vm.isLoading = false;
                    });
                }
            }
        });

        $scope.delSelected = [];

        //加载归属信息
        $scope.vm.form.loadComplete = function () {
            if (rt.isNull($scope.vm.form.data.is_hospital)) $scope.vm.form.data.is_hospital = true;
            $scope.vm.getSalesRegionInfo();
            $scope.isCheckAll = false;
            $scope.vm.form.tagList = [];
            if (!rt.isNull($scope.vm.form.data.contact_tag)) {
                var tagstring = "";
                for (var o in $scope.vm.form.data.contact_tag) {
                    tagstring = o + "：" + $scope.vm.form.data.contact_tag[o];
                    $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
                }
            }
        };

        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/Contact/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };
        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            var valueList = data.Value.split(/[,，]/);
            var list = [];
            for (var i = 0; i < valueList.length; i++) {
                if (!rt.isNullOrWhiteSpace(valueList[i])) {
                    list.push(valueList[i]);
                }
            }
            if (rt.isNull($scope.vm.form.data.contact_tag)) {
                $scope.vm.form.data.contact_tag = {};
            }
            $scope.vm.form.data.contact_tag[data.Name] = list;
            $scope.vm.form.tagList = [];
            var tagstring = "";
            for (var o in $scope.vm.form.data.contact_tag) {
                tagstring = o + "：" + $scope.vm.form.data.contact_tag[o];
                $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
            }
        });

        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.form.tagList, { 'checked': true });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.form.tagList = _.where($scope.vm.form.tagList, { 'checked': false });
            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.contact_tag = tag;
        };

        //保存之前
        $scope.vm.form.preSave = function (data) {

            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.contact_tag = tag;
        };

        //保存之后
        $scope.vm.form.postSave = function () {
            //保存归属信息
            $scope.vm.saveSalesRegionInfo();
        };

        $scope.vm.getSalesRegionInfo = function () {
            if ($scope.vm.form.data.is_hospital)
                //打开医生编辑页面时获取归属信息
                myService.GetSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id).then(function (resp) {
                    $scope.salesRegionInfoList = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
        };

        //保存归属信息
        $scope.vm.saveSalesRegionInfo = function () {
            if ($scope.vm.form.data.is_hospital) myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {}).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.salesRegionInfoList = _.remove($scope.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    //编辑医生时，删除归属信息才和后台数据库交互
                    if (!rt.isNullOrEmptyString($scope.vm.form.data.Id)) {
                        $scope.vm.saveSalesRegionInfo();
                    }

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegionDoctor").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //编辑医生-归属信息
        $scope.vm.showForm = function (row, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params="{rtIncludeId:\'' + row + '\'' + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //新建医生-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=\'{rtIncludeId:"' + '' + '"' + ', salesRegionList:' + JSON.stringify(list) + '}\'' + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品类。");
                return "必须提供品类。";
            }

            if (rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                $scope.salesRegionInfoList = $scope.rtIncludeParams.salesRegionList;
            }

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品类，不能再添加其他品类。");
                    return "已选择了全品类，不能再添加其他品类。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };

            // 编辑医生时，直接保存到数据库，并刷新数据
            if (!rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {
                    $scope.$emit('rt-on-dialog-close-click');
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            } else
                // 新建医生时，广播到编辑页面
                $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.salesRegionInfoList);
        };

        // 新建医生-编辑归属信息页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.salesRegionInfoList = list;
        });

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };
    }]);
})();
'use strict';

/*********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2018/02/28
 说明     : 医生变更
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('contactAppService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'ContactApp';

        //审批实体名字
        this.approvalTypeName = 'contact_app';

        // @@ 选项集
        this.picklists = ['StateCode'];

        //搜索医生名称
        this.GetContactList = function (accountId, searchText, pageIndex, pageSize) {
            return rt.get("api/ContactApp/GetContactList?accountId=" + accountId + "&searchText=" + searchText + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize);
        };

        //获取参数组-rx_potential
        this.getRxPotentialPickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=rx_potential";
            return rt.get(url);
        };

        //获取参数组-rx_attitude
        this.getRxAttitudePickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=rx_attitude";
            return rt.get(url);
        };

        //获取参数组-gendercode
        this.getGendercodePickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=gender";
            return rt.get(url);
        };

        //获取参数组-familystatuscode
        this.getFamilystatuscodePickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=familystatus";
            return rt.get(url);
        };

        //获取参数组-bachelor
        this.getBachelorPickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=bachelor";
            return rt.get(url);
        };

        //获取参数组-contact_level
        this.getContactLevelPickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=contact_level";
            return rt.get(url);
        };

        //获取参数组-roomtype
        this.getRoomTypePickList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=room_type";
            return rt.get(url);
        };

        //获取医生明细
        this.GetDoctorDetail = function (contactId) {
            return rt.get("api/HospitalContact/GetData?id=" + contactId);
        };

        //根据销售区域Id获取部门和用户信息
        this.GetBusinessAndOwnerInfoById = function (sales_regionId) {
            return rt.get("api/SalesRegion/GetBusinessAndOwnerInfoById?sales_regionId=" + sales_regionId);
        };
    }]).controller('contactAppListController', ['$scope', '$injector', 'contactAppService', function ($scope, $injector, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        //重构的获取列表数据方法
        myService.getViewData = function () {
            return rt.get("api/ContactApp/GetDataList" + "?pageIndex=" + encodeURIComponent($scope.vm.page.index) + "&pageSize=" + rt.getPaginationSize() + "&searchText=" + $scope.vm.view.searchText);
        };
    }]).controller('contactAppReadController', ['$injector', '$scope', '$state', 'contactAppService', function ($injector, $scope, $state, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.preBindFormData = function (data) {
            //新增联系人
            if (data.app_type.Value === '10') {
                $scope.vm.tabIndex = 1; //初始显示的tab
            }

            //变更联系人信息
            if (data.app_type.Value === '20') {
                $scope.vm.tabIndex = 2; //初始显示的tab

                //处理差异信息中的日期字段
                var index1 = _.findIndex(data.contact_info_diff, function (diff) {
                    return diff.diffParam.Value == 'birthdate';
                });

                if (index1 != -1) {
                    if (!rt.isNull(data.contact_info_diff[index1].oldValue)) data.contact_info_diff[index1].oldValue = moment(data.contact_info_diff[index1].oldValue).format("YYYY-MM-DD");
                    if (!rt.isNull(data.contact_info_diff[index1].newValue)) data.contact_info_diff[index1].newValue = moment(data.contact_info_diff[index1].newValue).format("YYYY-MM-DD");
                }

                //处理差异信息中的布尔类型字段
                var index2 = _.findIndex(data.contact_info_diff, function (diff) {
                    return diff.diffParam.Value == 'is_department_manager';
                });

                if (index2 != -1) {
                    if (!rt.isNull(data.contact_info_diff[index2].oldValue)) data.contact_info_diff[index2].oldValue = data.contact_info_diff[index2].oldValue ? '是' : '否';
                    if (!rt.isNull(data.contact_info_diff[index2].newValue)) data.contact_info_diff[index2].newValue = data.contact_info_diff[index2].newValue ? '是' : '否';
                }

                var index3 = _.findIndex(data.contact_info_diff, function (diff) {
                    return diff.diffParam.Value == 'is_speaker';
                });

                if (index3 != -1) {
                    if (!rt.isNull(data.contact_info_diff[index3].oldValue)) data.contact_info_diff[index3].oldValue = data.contact_info_diff[index3].oldValue ? '是' : '否';
                    if (!rt.isNull(data.contact_info_diff[index3].newValue)) data.contact_info_diff[index3].newValue = data.contact_info_diff[index3].newValue ? '是' : '否';
                }

                var index4 = _.findIndex(data.contact_info_diff, function (diff) {
                    return diff.diffParam.Value == 'isPAC';
                });

                if (index4 != -1) {
                    if (!rt.isNull(data.contact_info_diff[index4].oldValue)) data.contact_info_diff[index4].oldValue = data.contact_info_diff[index4].oldValue ? '是' : '否';
                    if (!rt.isNull(data.contact_info_diff[index4].newValue)) data.contact_info_diff[index4].newValue = data.contact_info_diff[index4].newValue ? '是' : '否';
                }

                var index5 = _.findIndex(data.contact_info_diff, function (diff) {
                    return diff.diffParam.Value == 'isKOL';
                });

                if (index5 != -1) {
                    if (!rt.isNull(data.contact_info_diff[index5].oldValue)) data.contact_info_diff[index5].oldValue = data.contact_info_diff[index5].oldValue ? '是' : '否';
                    if (!rt.isNull(data.contact_info_diff[index5].newValue)) data.contact_info_diff[index5].newValue = data.contact_info_diff[index5].newValue ? '是' : '否';
                }
            }

            //申请权限
            if (data.app_type.Value === '30') {
                $scope.vm.tabIndex = 3; //初始显示的tab
            }
        };

        //切换Tab
        $scope.chooseTab = function (tabIndex) {
            $scope.vm.tabIndex = tabIndex;
        };

        $scope.vm.form.loadComplete = function () {
            //加载审批流信息
            myService.getApprovalStatus($scope.vm.form.id).then(function (resp) {
                if (!rt.isNull(resp.data)) {
                    $scope.vm.form.approvalStatus = resp.data.ApprovalStatus;
                    $scope.vm.form.approverList = resp.data.ApproverList;
                }

                $scope.vm.form.isFlowApprover = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.ApprovingBy) && rt.isSameGuid($scope.vm.form.approvalStatus.ApprovingBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;

                $scope.vm.form.isFlowSubmitter = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.SubmittedBy) && rt.isSameGuid($scope.vm.form.approvalStatus.SubmittedBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;
            }).catch(function (resp) {
                rt.errorMessage(resp.data);
            });
        };

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        //重新提交
        $scope.vm.form.reSubmit = function () {
            $state.go("main.contactapp.doctoredit", { id: $scope.vm.form.data.Id, accountId: $scope.vm.form.data.contact_info.accountid.Id, accountIdName: $scope.vm.form.data.contact_info.accountid.Name, contactId: $scope.vm.form.data.app_type.Value === '10' ? '' : $scope.vm.form.data.contactId.Id, contactIdName: $scope.vm.form.data.app_type.Value === '20' ? '' : $scope.vm.form.data.contactId.Name, changeType: $scope.vm.form.data.app_type.Value !== '30' ? 'info' : 'privilege' }, { location: true });
        };
    }]).controller('contactAppSearchController', ['$injector', '$state', '$scope', 'contactAppService', 'contactService', function ($injector, $state, $scope, myService, contactService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.vm.pageIndex = 1;
        $scope.vm.recordCount = 0;
        $scope.vm.pageSize = rt.getPaginationSize();

        $scope.vm.form.hide = function () {
            $scope.$emit('rt-on-dialog-close-click');
        };

        //搜索医生
        $scope.vm.form.searchContact = function () {
            if (rt.isNull($scope.vm.searchAccountId) || rt.isNullOrEmptyString($scope.vm.searchAccountId.Id)) {
                rt.errorMessage("医院名称不能为空。");
                return;
            }

            if (rt.isNullOrEmptyString($scope.vm.searchText)) {
                rt.errorMessage("医生姓名不能为空。");
                return;
            }

            $scope.vm.selectedContactId = '';
            $scope.vm.selectedContactIdName = '';

            //置空radio
            $("input[name=contactList]").each(function () {
                $(this).attr("checked", false);
            });

            $scope.vm.searchContactIdName = $scope.vm.searchText;

            myService.GetContactList($scope.vm.searchAccountId.Id, $scope.vm.searchText, $scope.vm.pageIndex, $scope.vm.pageSize).then(function (resp) {
                $scope.vm.contactList = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;

                //如果搜索的医生只有一个，则默认选中
                if ($scope.vm.recordCount === 1) {
                    $scope.vm.selectedContactId = $scope.vm.contactList[0].Id;
                    $scope.vm.selectedContactIdName = $scope.vm.contactList[0].name;
                    $scope.vm.selectedAccountId = $scope.vm.contactList[0].accountid.Id;
                    $scope.vm.selectedAccountIdName = $scope.vm.contactList[0].accountid.Name;
                }
            }).catch(function (error) {
                rt.errorMessage(error);
            });
        };

        //新增联系人
        $scope.vm.form.addContact = function () {
            if (rt.isNull($scope.vm.searchAccountId) || rt.isNullOrEmptyString($scope.vm.searchAccountId.Id)) {
                rt.errorMessage("医院名称不能为空。");
                return;
            }

            $state.go("main.contactapp.doctoredit", { id: '', accountId: $scope.vm.searchAccountId.Id, accountIdName: $scope.vm.searchAccountId.Name, contactId: '', contactIdName: $scope.vm.searchContactIdName, changeType: 'info' }, { location: true });
        };

        //联系人列表-单选框点击事件
        $scope.vm.form.selectContact = function (index) {
            $scope.vm.selectedContactId = $scope.vm.contactList[index].Id;
            $scope.vm.selectedContactIdName = $scope.vm.contactList[index].name;
            $scope.vm.selectedAccountId = $scope.vm.contactList[index].accountid.Id;
            $scope.vm.selectedAccountIdName = $scope.vm.contactList[index].accountid.Name;
        };

        //变更联系人信息
        $scope.vm.form.changeContactInfo = function () {
            if (rt.isNullOrEmptyString($scope.vm.selectedContactId)) {
                rt.errorMessage("请选择一名医生。");
                return;
            }

            $state.go("main.contactapp.doctoredit", { id: '', accountId: $scope.vm.selectedAccountId, accountIdName: $scope.vm.selectedAccountIdName, contactId: $scope.vm.selectedContactId, contactIdName: '', changeType: 'info' }, { location: true });
        };

        //申请客户权限
        $scope.vm.form.changeContactPrivilege = function () {
            if (rt.isNullOrEmptyString($scope.vm.selectedContactId)) {
                rt.errorMessage("请选择一名医生。");
                return;
            }

            $state.go("main.contactapp.doctoredit", { id: '', accountId: $scope.vm.selectedAccountId, accountIdName: $scope.vm.selectedAccountIdName, contactId: $scope.vm.selectedContactId, contactIdName: $scope.vm.selectedContactIdName, changeType: 'privilege' }, { location: true });
        };
    }]).controller('contactAppDoctorEditController', ['$injector', '$compile', '$scope', 'contactAppService', 'contactService', function ($injector, $compile, $scope, myService, contactService) {
        var rt = myService.rt;
        var $stateParams = myService.$stateParams;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        $scope.vm.changeType = $stateParams.changeType; //申请类型，info客户信息，privilege客户权限
        $scope.vm.isCreateContact = rt.isNullOrEmptyString($stateParams.contactId) ? true : false; //是否新建客户
        $scope.vm.contactInfo = {};
        $scope.vm.salesRegionInfoList = [];
        $scope.delSelected = []; //归属信息删除列表
        $scope.delSelectedGrade = []; //医生分级删除列表
        $scope.isCheckAll = false;
        $scope.isCheckAllGrade = false;

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            if (data.Type === 'addTag') {
                var valueList = data.Value.split(/[,，]/);
                var list = [];
                for (var i = 0; i < valueList.length; i++) {
                    if (!rt.isNullOrWhiteSpace(valueList[i])) {
                        list.push(valueList[i]);
                    }
                }
                if (rt.isNull($scope.vm.contactInfo.contact_tag)) {
                    $scope.vm.contactInfo.contact_tag = {};
                }
                $scope.vm.contactInfo.contact_tag[data.Name] = list;
                $scope.vm.tagList = [];
                var tagstring = "";
                for (var o in $scope.vm.contactInfo.contact_tag) {
                    tagstring = o + "：" + $scope.vm.contactInfo.contact_tag[o];
                    $scope.vm.tagList.push({
                        "value": tagstring,
                        "checked": false
                    });
                }
            } else return;
        });

        function isCardNo(card) {
            // 身份证号码为15位或者18位，15位时全为数字，18位前17位为数字，最后一位是校验位，可能为数字或字符X 
            var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
            return reg.test(card);
        }

        //保存之前
        $scope.vm.form.preSave = function (data) {
            //新建和变更联系人信息
            if ($scope.vm.changeType === 'info') {
                if (!isCardNo($scope.vm.contactInfo.idcard) && !rt.isNullOrWhiteSpace($scope.vm.contactInfo.idcard)) {
                    rt.errorMessage("请输入正确的身份证号");
                    return "请输入正确的身份证号";
                }
            }

            //新建联系人、申请权限
            if ($scope.vm.changeType === 'privilege' || $scope.vm.isCreateContact) {
                if ($scope.vm.salesRegionInfoList.length == 0) {
                    rt.errorMessage("至少选择一条归属信息");
                    return "至少选择一条归属信息";
                }
            }

            //申请单字段赋值
            $scope.vm.form.data.contact_type = { Name: '医院联系人', Value: '2' };

            //新增客户
            if ($scope.vm.isCreateContact) {
                $scope.vm.contactInfo.contact_type = { Name: '医院联系人', Value: '2' };

                $scope.vm.form.data.app_type = { Name: '新增联系人', Value: '10' };
                $scope.vm.form.data.contactId = { Id: '', Name: $scope.vm.contactInfo.name };
                $scope.vm.form.data.contact_info = $scope.vm.contactInfo;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }

            //变更客户信息
            if (!$scope.vm.isCreateContact && $scope.vm.changeType === 'info') {
                $scope.vm.form.data.app_type = { Name: '变更联系人信息', Value: '20' };
                $scope.vm.form.data.contactId = { Id: $stateParams.contactId, Name: $scope.vm.preContactIdName };
                $scope.vm.form.data.contact_info = $scope.vm.contactInfo;
            }

            //申请客户权限
            if (!$scope.vm.isCreateContact && $scope.vm.changeType === 'privilege') {
                $scope.vm.form.data.app_type = { Name: '申请权限', Value: '30' };
                $scope.vm.form.data.contactId = { Id: $stateParams.contactId, Name: $stateParams.contactIdName };
                $scope.vm.form.data.contact_info = $scope.vm.contactInfo;
                $scope.vm.form.data.account_region_diff = $scope.vm.salesRegionInfoList;
            }
        };

        $scope.vm.form.GetDefaultSalesRegion = function () {
            contactService.GetSalesRegionInfo('').then(function (resp) {
                $scope.vm.salesRegionInfoList = resp.data;
            }).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除小区记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.vm.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.vm.salesRegionInfoList = _.remove($scope.vm.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        //删除医生分级
        $scope.vm.delGrade = function () {
            if ($scope.delSelectedGrade.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelectedGrade.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelectedGrade, function (idx) {
                        $scope.vm.contactInfo.contactGradeList.splice(idx, 1, null);
                    });
                    $scope.vm.contactInfo.contactGradeList = _.remove($scope.vm.contactInfo.contactGradeList, function (item) {
                        return !rt.isNull(item);
                    });

                    $scope.delSelectedGrade = [];
                    document.getElementById("checkboxAllGrade").checked = false; //取消全选
                    $scope.isCheckAllGrade = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        var updateSelectedGrade = function updateSelectedGrade(action, index) {
            if (action == 'add') $scope.delSelectedGrade.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelectedGrade.indexOf(index);
                $scope.delSelectedGrade.splice(idx, 1);
            }
        };

        //复选框点击事件-归属
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //复选框点击事件-医生分级
        $scope.updateSelectionGrade = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelectedGrade(action, index);
        };

        //全选事件-归属
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegion").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.vm.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //全选事件-医生分级
        $scope.vm.selectAllGrade = function () {
            var inputs = document.getElementById("contactGrade").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAllGrade ? false : true;
                }
            }
            $scope.isCheckAllGrade = !$scope.isCheckAllGrade;
            $scope.delSelectedGrade = [];
            if ($scope.isCheckAllGrade) {
                for (var i = 0; i < $scope.vm.contactInfo.contactGradeList.length; i++) {
                    $scope.delSelectedGrade.push(i);
                }
            }
        };

        //新建客户-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=' + JSON.stringify(list) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品种。");
                return "必须提供品种。";
            }

            $scope.vm.salesRegionInfoList = $scope.rtIncludeParams;

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品种，不能再添加其他品种。");
                    return "已选择了全品种，不能再添加其他品种。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.vm.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.vm.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };

            $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.vm.salesRegionInfoList);
        };

        // 保存医生分级
        $scope.vm.addContactGrade = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.contact_level) || rt.isNull($scope.vm.form.data.contact_level.Value)) {
                rt.errorMessage("必须提供医生等级。");
                return "必须提供医生等级。";
            }

            if (rt.isNull($scope.vm.form.data.product_category) || rt.isNull($scope.vm.form.data.product_category.Id)) {
                rt.errorMessage("必须提供品类。");
                return "必须提供品类。";
            }

            $scope.vm.contactInfo.contactGradeList = $scope.rtIncludeParams;

            //重复性检查
            var existsIndex = _.findIndex($scope.vm.contactInfo.contactGradeList, function (a) {
                return a.contact_level.Value == $scope.vm.form.data.contact_level.Value && a.product_category.Id == $scope.vm.form.data.product_category.Id;
            });

            if (existsIndex >= 0) {
                rt.errorMessage("医生等级和品类不允许重复。");
                return "医生等级和品类不允许重复。";
            }

            //不存在就插入   
            $scope.vm.contactInfo.contactGradeList.push({
                contact_level: $scope.vm.form.data.contact_level,
                product_category: $scope.vm.form.data.product_category,
                contactid: { Id: $stateParams.contactId, Name: $scope.vm.preContactIdName }
            });

            $scope.$emit('rt-on-dialog-close-click-contact-grade', $scope.vm.contactInfo.contactGradeList);
        };

        // 归属信息编辑页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.vm.salesRegionInfoList = list;
        });

        // 医生分级编辑页面关闭事件
        $scope.$on('rt-on-dialog-close-click-contact-grade', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.vm.contactInfo.contactGradeList = list;
        });

        $scope.vm.form.preBindFormData = function (data) {
            //新增联系人、变更联系人信息，需要先加载参数组
            if ($scope.vm.changeType === 'info') {
                myService.getRxPotentialPickList().then(function (resp) {
                    $scope.vm.picklist.rx_potential = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
                myService.getRxAttitudePickList().then(function (resp) {
                    $scope.vm.picklist.rx_attitude = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
                myService.getGendercodePickList().then(function (resp) {
                    $scope.vm.picklist.gendercode = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
                myService.getFamilystatuscodePickList().then(function (resp) {
                    $scope.vm.picklist.familystatuscode = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
                myService.getBachelorPickList().then(function (resp) {
                    $scope.vm.picklist.bachelor = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
                myService.getContactLevelPickList().then(function (resp) {
                    $scope.vm.picklist.contact_level = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });

                //新增医生
                if ($scope.vm.isCreateContact) {
                    $scope.vm.contactInfo.accountid = { Id: $stateParams.accountId, Name: $stateParams.accountIdName };
                }
            }

            if ($scope.vm.form.type === 'Edit') {
                $scope.vm.contactInfo = data.contact_info;
                $scope.vm.salesRegionInfoList = data.account_region_diff;

                //绑定标签列表
                $scope.vm.tagList = [];
                if (!rt.isNull($scope.vm.contactInfo.contact_tag)) {
                    var tagstring = "";
                    for (var o in $scope.vm.contactInfo.contact_tag) {
                        tagstring = o + "：" + $scope.vm.contactInfo.contact_tag[o];
                        $scope.vm.tagList.push({
                            "value": tagstring,
                            "checked": false
                        });
                    }
                }

                if (!rt.isNull($scope.vm.contactInfo)) {
                    if (!rt.isNull($scope.vm.contactInfo.birthdate)) $scope.vm.contactInfo.birthdate = moment($scope.vm.contactInfo.birthdate).toDate();
                    if (!rt.isNull($scope.vm.contactInfo.anniversary)) $scope.vm.contactInfo.anniversary = moment($scope.vm.contactInfo.anniversary).toDate();
                }
            }
        };

        $scope.vm.form.preLoad = function () {
            if ($scope.vm.changeType === 'info') {
                //获取所属客户编码
                rt.get('api/Department/GetCodeById?id=' + $stateParams.accountId).then(function (resp) {
                    $scope.vm.accountnumber = resp.data;
                }).catch(function (msg) {
                    rt.errorMessage(msg);
                });
            }

            //新增联系人信息
            if ($scope.vm.isCreateContact) {
                //将搜索页面的机构名称带入
                $scope.vm.contactInfo.name = $stateParams.contactIdName;

                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }

            //变更联系人信息
            if (!$scope.vm.isCreateContact && $scope.vm.changeType === 'info' || $scope.vm.changeType === 'privilege') {
                //获取联系人原信息
                myService.GetDoctorDetail($stateParams.contactId).then(function (resp) {
                    $scope.vm.contactInfo = resp.data;
                    $scope.vm.preContactIdName = $scope.vm.contactInfo.name;

                    //绑定标签列表
                    $scope.vm.tagList = [];
                    if (!rt.isNull($scope.vm.contactInfo.contact_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.contactInfo.contact_tag) {
                            tagstring = o + "：" + $scope.vm.contactInfo.contact_tag[o];
                            $scope.vm.tagList.push({
                                "value": tagstring,
                                "checked": false
                            });
                        }
                    }

                    if (!rt.isNull($scope.vm.contactInfo.birthdate)) $scope.vm.contactInfo.birthdate = moment($scope.vm.contactInfo.birthdate).toDate();
                    if (!rt.isNull($scope.vm.contactInfo.anniversary)) $scope.vm.contactInfo.anniversary = moment($scope.vm.contactInfo.anniversary).toDate();
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
            }

            //申请客户权限
            if (!$scope.vm.isCreateContact && $scope.vm.changeType === 'privilege') {
                //显示归属信息
                $scope.vm.form.GetDefaultSalesRegion();
            }
        };

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };

        //增加标签
        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/Contact/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        //删除标签
        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.tagList, {
                'checked': true
            });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.tagList = _.where($scope.vm.tagList, {
                'checked': false
            });
            tag = {};
            for (var i = 0; i < $scope.vm.tagList.length; i++) {
                var tagNameValueList = $scope.vm.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            }
            $scope.vm.contactInfo.contact_tag = tag;
        };
    }]).controller('contactAppDepartmentEditController', ['$scope', '$injector', 'contactAppService', 'departmentService', function ($scope, $injector, myService, departmentService) {
        var rt = myService.rt;
        var $stateParams = myService.$stateParams;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.preBindFormData = function (data) {
            $scope.vm.form.data.accountid = { Id: $scope.rtIncludeParams.formAttrValue, Name: $scope.rtIncludeParams.formAttrName };

            rt.get('api/Department/GetCodeById?id=' + $scope.rtIncludeParams.formAttrValue).then(function (resp) {
                $scope.vm.form.data.accountnumber = resp.data;
            }).catch(function (msg) {
                rt.errorMessage(msg);
            }).finally(function () {
                waiting.close();
            });

            myService.getRoomTypePickList().then(function (resp) {
                $scope.vm.picklist.roomtype = resp.data;
            }).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        $scope.vm.form.hide = function () {
            // 获取表单
            var form = $scope[$scope.vm.form.name];
            if ($scope[$scope.vm.form.name] === undefined) {
                form = $scope.$$childTail[$scope.vm.form.name] || $scope.$$childHead[$scope.vm.form.name];
            }

            if (form.$dirty) rt.confirm("当前页面有未保存的数据，确认要关闭？", function (ok) {
                ok && $scope.$parent.vm.dialog.close();
            });else {
                $scope.$parent.vm.dialog.close();
            }
        };

        $scope.vm.form.save = function () {
            var waiting = rt.showWaiting();

            if (rt.isNull($scope.vm.form.data.Id) || $scope.vm.form.data.Id.length === 0) $scope.vm.form.data.Id = rt.newGuid();

            departmentService.createData($scope.vm.form.data).then(function (resp) {
                $scope.$parent.vm.dialog.close();
                $scope.$emit('rt-create-department-reload');
            }).finally(function () {
                waiting.close();
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016-02-01
 说明     : 医生档案
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('contactGradeService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'ContactGrade';
        // @@ 选项集
        this.picklists = ['StateCode', 'contact_level'];
    }]).controller('ContactGradeListController', ['$injector', '$scope', 'contactGradeService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $compile = myService.$compile;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('ContactGradeEditController', ['$scope', '$injector', 'contactGradeService', function ($scope, $injector, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/*********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2018/04/02
 说明     : 医生评级
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('contactGradeAppService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'ContactGradeApp';

        //审批实体名字
        this.approvalTypeName = 'contact_grade_app';

        // @@ 选项集
        this.picklists = ['StateCode'];

        //根据品种获取评估项目            
        this.getEvalItemList = function (product_categoryId) {
            var url = 'api/ContactGradeEvalItem/GetContactGradeEvalItemAndDetail?productid=' + product_categoryId;
            return rt.get(url);
        };
    }]).controller('contactGradeAppListController', ['$injector', '$scope', 'contactGradeAppService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        //重构的获取列表数据方法
        myService.getViewData = function () {
            return rt.get("api/ContactGradeApp/GetDataList" + "?pageIndex=" + encodeURIComponent($scope.vm.page.index) + "&pageSize=" + rt.getPaginationSize() + "&searchText=" + $scope.vm.view.searchText);
        };
    }]).controller('contactGradeAppReadOnlyController', ['$injector', '$scope', '$state', 'contactGradeAppService', function ($injector, $scope, $state, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.tabIndex = 1;

        //切换Tab
        $scope.chooseTab = function (tabIndex) {
            $scope.vm.tabIndex = tabIndex;
        };

        //重新提交
        $scope.vm.form.reSubmit = function () {
            $state.go("main.contactgradeapp.edit", { id: $scope.vm.form.data.Id }, { location: true });
        };

        $scope.vm.form.loadComplete = function () {
            //加载审批流信息
            myService.getApprovalStatus($scope.vm.form.data.Id).then(function (resp) {
                if (!rt.isNull(resp.data)) {
                    $scope.vm.form.approvalStatus = resp.data.ApprovalStatus;
                    $scope.vm.form.approverList = resp.data.ApproverList;
                }

                $scope.vm.form.isFlowApprover = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.ApprovingBy) && rt.isSameGuid($scope.vm.form.approvalStatus.ApprovingBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;

                $scope.vm.form.isFlowSubmitter = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.SubmittedBy) && rt.isSameGuid($scope.vm.form.approvalStatus.SubmittedBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;
            }).catch(function (resp) {
                rt.errorMessage(resp.data);
            });
        };

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };
    }]).controller('contactGradeAppEditController', ['$injector', '$scope', 'contactGradeAppService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $compile = myService.$compile;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.loadComplete = function () {
            if ($scope.vm.form.type == 'Create') $scope.vm.form.data.evalList = []; //初始化品种项目数组
        };

        $scope.vm.form.preSave = function () {
            if ($scope.vm.form.data.evalList.length === 0) {
                rt.errorMessage("至少选择一个品种");
                return "至少选择一个品种";
            }
        };

        //删除品种明细
        $scope.vm.form.deleteDetail = function ($index) {
            rt.confirm('是否删除该品种项目', function (ok) {
                if (ok) {
                    $scope.vm.form.data.evalList.splice($index, 1);
                    $scope.$apply();
                }
            });
        };

        //增加品种项目
        $scope.vm.form.addProductCategory = function (templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + '></div>';
            $scope.vm.evalItemDialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //品种项目窗口-关闭按钮
        $scope.vm.form.evalItemDialogHide = function () {
            $scope.$parent.vm.evalItemDialog.close();
        };

        //品种项目窗口-保存按钮
        $scope.vm.form.evalItemDialogSave = function () {
            if (rt.isNull($scope.vm.form.product_categoryId)) {
                rt.errorMessage("请选择品种。");
                return;
            }

            for (var j = 0; j < $scope.vm.form.itemList.length; j++) {
                //选项类型
                if ($scope.vm.form.itemList[j].eval_item_value_type.Value === '1') {
                    if (rt.isNull($scope.vm.form.itemList[j].pickValue)) {
                        rt.errorMessage("请填写" + $scope.vm.form.itemList[j].name);
                        return;
                    }
                } else {
                    if (rt.isNull($scope.vm.form.itemList[j].numberValue)) {
                        rt.errorMessage("请填写" + $scope.vm.form.itemList[j].name);
                        return;
                    } else if ($scope.vm.form.itemList[j].eval_item_value_type.Value === '3' && ($scope.vm.form.itemList[j].numberValue > 100 || $scope.vm.form.itemList[j].numberValue < 0)) {
                        rt.errorMessage($scope.vm.form.itemList[j].name + "只能填写0到100之间的数值");
                        return;
                    }
                }
            }

            $scope.$parent.vm.form.data.evalList.push({
                product_categoryId: $scope.vm.form.product_categoryId,
                itemList: $scope.vm.form.itemList
            });
            $scope.$parent.vm.evalItemDialog.close();
        };

        //品种项目窗口-选择品种后加载项目
        $scope.$watch('vm.form.product_categoryId', function () {
            if ($scope.vm.form.product_categoryId && !rt.isNullOrEmptyString($scope.vm.form.product_categoryId.Id)) {
                //重复性检查
                var existsIndex = _.findIndex($scope.$parent.vm.form.data.evalList, function (e) {
                    return e.product_categoryId.Id == $scope.vm.form.product_categoryId.Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的品种，不能重复添加。");
                    $scope.vm.form.product_categoryId = null;
                    return;
                } else myService.getEvalItemList($scope.vm.form.product_categoryId.Id).then(function (resp) {
                    if (resp.data.length === 0) {
                        rt.errorMessage("该品种没有评估项目。");
                        $scope.vm.form.product_categoryId = null;
                        return;
                    } else $scope.vm.form.itemList = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            } else {
                $scope.vm.form.itemList = [];
            }
        });

        $scope.$watch('vm.form.data.accountId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.departmentid = null;
                $scope.vm.form.data.contactId = null;
                return;
            }
        });

        $scope.$watch('vm.form.data.departmentid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.contactId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2018-03-09
 说明     : 医生分级模型-列表
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('contactGradePatternService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'ContactGradePattern';
        // @@ 选项集
        this.picklists = ['StateCode', 'pattern_type'];

        this.createcontactGradePattern = function (patternTypeValue, patternTypeValueName, contactLevelList) {
            var url = "api/ContactGradePattern/CreateData?patternTypeValue=" + patternTypeValue;
            url += "&patternTypeName=" + patternTypeValueName;
            return rt.post(url, contactLevelList);
        };

        this.getContactLevel = function () {
            var url = "api/ContactGradePattern/GetContactLevel";
            return rt.get(url);
        };
    }]).controller('contactGradePatternListController', ['$injector', '$scope', 'contactGradePatternService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.loadComplete = function () {
            _loadContactLevel();
        };

        //加载医生级别选项集
        function _loadContactLevel() {
            myService.getContactLevel().then(function (resp) {
                if (!rt.isNull(resp.data)) {
                    $scope.vm.contact_level = resp.data;

                    $scope.vm.canEdit = false;
                    if (!rt.isNull($scope.vm.data) && $scope.vm.data.length > 0) {
                        $scope.vm.patternTypeChange($scope.vm.data[0].pattern_type);
                    } else {
                        $scope.vm.isCheckedValue = 3;
                    }
                }
            }).catch(function (err) {
                rt.errorMessage(err);
            });
        }

        $scope.vm.patternTypeChange = function (item) {
            $scope.vm.patternType = item;
            $scope.vm.isCheckedValue = item.Value;
            if (item.Value == 1) {
                $scope.vm.canEdit = false;
                $scope.vm.contactLevelList = [{ Value: 1, Name: 'A' }, { Value: 2, Name: 'B' }, { Value: 3, Name: 'C' }, { Value: 4, Name: 'D' }];
            } else if (item.Value == 2) {
                $scope.vm.canEdit = false;
                $scope.vm.contactLevelList = [{ Value: 1, Name: 'A1' }, { Value: 2, Name: 'A2' }, { Value: 3, Name: 'A3' }, { Value: 4, Name: 'B1' }, { Value: 5, Name: 'B2' }, { Value: 6, Name: 'B3' }, { Value: 7, Name: 'C1' }, { Value: 8, Name: 'C2' }, { Value: 9, Name: 'C3' }];
            } else {
                $scope.vm.contactLevelList = $scope.vm.contact_level;
                $scope.vm.canEdit = true;
            }
        };

        $scope.addDetail = function () {
            $scope.vm.contactLevelList.push({
                Value: $scope.vm.contactLevelList.length + 1 + '',
                Name: ""
            });
        };

        //删除按钮
        $scope.del = function () {
            _.map($scope.vm.view.selectedIds, function (idx) {
                $scope.vm.contact_level.splice(idx, 1, null);
            });
            $scope.vm.contact_level = _.remove($scope.vm.contact_level, function (item) {
                return !rt.isNull(item);
            });
            $scope.vm.contactLevelList = $scope.vm.contact_level;
        };

        $scope.vm.saveData = function () {
            //必填项检查
            var existsIndex = _.findIndex($scope.vm.contactLevelList, function (a) {
                return rt.isNullOrEmptyString(a.Name) || rt.isNull(a.Value);
            });

            if (existsIndex >= 0) {
                rt.errorMessage("请填写必填项。");
                return "请填写必填项。。";
            }

            var waiting = rt.showWaiting();
            myService.createcontactGradePattern($scope.vm.patternType.Value, $scope.vm.patternType.Name, $scope.vm.contactLevelList).then(function (resp) {
                rt.successMessage("生成成功");
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        };
    }]).controller('developHospitalEditController', ['$injector', '$scope', 'contactGradePatternService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.preSave = function () {
            if (!rt.isNull($scope.vm.form.data.schedule_start_date) && !rt.isNull($scope.vm.form.data.schedule_end_date) && $scope.vm.form.data.schedule_start_date > $scope.vm.form.data.schedule_end_date) {
                rt.errorMessage('计划启动日期必须小于计划结束日期');
                return "计划启动日期必须小于计划结束日期";
            }
        };

        $scope.vm.form.loadComplete = function () {
            // 默认为当前用户
            if (rt.isNull($scope.vm.form.data.OwnerId)) {
                $scope.vm.form.data.OwnerId = {
                    Id: rt.getUserId(),
                    Name: rt.getUserName()
                };
            }
        };

        $scope.$watch("vm.form.data.product_categoryId.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.productId = null;
                return;
            }
        });

        $scope.$watch("vm.form.data.agent_customerId.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                $scope.vm.form.data.agent_contactId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : JeyyyWu
 创建时间 : 2018/03/12
 说明     : 联系人-标签类型
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('contactTagTypeService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'ContactTagType';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('contactTagTypeListController', ['$injector', '$compile', '$scope', 'contactTagTypeService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('contactTagTypeEditController', ['$injector', '$scope', 'contactTagTypeService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.preSave = function () {
            var re = /[,:;，：；]/gi;
            if (re.test($scope.vm.form.data.name.trim())) {
                rt.errorMessage("名称不能有特殊字符。");
                return "名称不能有特殊字符。";
            }
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2018-03-14
 说明     : 医生分级-分值区间-列表
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('cotactGradeEvalScoreRuleService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'ContactGradeEvalScoreRule';
        // @@ 选项集
        this.picklists = ['StateCode', 'eval_type', 'eval_value', 'eval_item_value_type'];

        this.getItemTypeLevel = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=eval_item_value_type";
            return rt.get(url);
        };

        //创建分值区间
        this.createScoreList = function (scoreList) {
            var url = "api/ContactGradeEvalScoreRule/CreatePotentialScoreData";
            return rt.post(url, scoreList);
        };

        //获取品种分级规则
        this.getGradeItemRule = function () {
            var url = "api/ContactGradeEvalScoreRule/GetGradeItemRule";
            return rt.get(url);
        };

        //创建品种分级规则项目明细
        this.createContactGradeEvalItem = function (productid, productname, data) {
            var url = "api/ContactGradeEvalItem/CreateContactGradeEvalItem?productid=" + encodeURIComponent(productid) + "&productname=" + encodeURIComponent(productname);
            return rt.post(url, data);
        };

        //获取品种分级规则项目明细
        this.getContactGradeEvalItemAndDetail = function (productid) {
            var url = "api/ContactGradeEvalItem/GetContactGradeEvalItemAndDetail?productid=" + encodeURIComponent(productid);
            return rt.get(url);
        };

        //删除品种分级规则
        this.delcotactGradeEvalScoreRuleList = function (selectedids) {
            var url = "api/ContactGradeEvalScoreRule/DelCotactGradeEvalScoreRuleList?selectedIds=" + selectedids;
            return rt.post(url);
        };
    }]).controller('cotactGradeEvalScoreRuleListController', ['$injector', '$scope', 'cotactGradeEvalScoreRuleService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.loadComplete = function () {
            $scope.vm.potentialScoreList = [];
            $scope.vm.attitudeScoreList = [];
            if (!rt.isNull($scope.vm.data) && $scope.vm.data.length > 0) {
                angular.forEach($scope.vm.data, function (entity) {
                    if (entity.eval_type.Value == '1') {
                        $scope.vm.potentialScoreList.push({ eval_type: { Value: entity.eval_type.Value, Name: entity.eval_type.Name }, eval_value: { Value: entity.eval_value.Value, Name: entity.eval_value.Name }, score_low: entity.score_low, score_hight: entity.score_hight });
                    }
                    if (entity.eval_type.Value == '2') {
                        $scope.vm.attitudeScoreList.push({ eval_type: { Value: entity.eval_type.Value, Name: entity.eval_type.Name }, eval_value: { Value: entity.eval_value.Value, Name: entity.eval_value.Name }, score_low: entity.score_low, score_hight: entity.score_hight });
                    }
                    // newassList.push({ Id: entity.OwnerId.Id, Name: entity.OwnerIdName });
                });
            } else {
                _loadpotentialScoreList();
                _loadattitudeScoreList();
            }
            _loadgradeitemrule();
            _loadItemTypeLevel();
            $scope.vm.scoreList = [];
        };

        //加载潜力分值区间
        function _loadpotentialScoreList() {
            $scope.vm.potentialScoreList = [{ eval_type: { Value: '1', Name: '潜力' }, eval_value: { Value: '1', Name: '低' }, score_low: 0, score_hight: 33 }, { eval_type: { Value: '1', Name: '潜力' }, eval_value: { Value: '2', Name: '中' }, score_low: 34, score_hight: 66 }, { eval_type: { Value: '1', Name: '潜力' }, eval_value: { Value: '3', Name: '高' }, score_low: 67, score_hight: 100 }];
        }

        //加载处方态度分值区间
        function _loadattitudeScoreList() {
            $scope.vm.attitudeScoreList = [{ eval_type: { Value: '2', Name: '贡献值' }, eval_value: { Value: '1', Name: '低' }, score_low: 0, score_hight: 33 }, { eval_type: { Value: '2', Name: '贡献值' }, eval_value: { Value: '2', Name: '中' }, score_low: 34, score_hight: 66 }, { eval_type: { Value: '2', Name: '贡献值' }, eval_value: { Value: '3', Name: '高' }, score_low: 67, score_hight: 100 }];
        }

        //加载品种分级规则
        function _loadgradeitemrule() {
            myService.getGradeItemRule().then(function (resp) {
                $scope.vm.gradeItemRuleList = resp.data;
            });
        }

        function _loadItemTypeLevel() {
            myService.getItemTypeLevel().then(function (resp) {
                $scope.vm.picklist.eval_item_value_type = resp.data;
            });
        }

        $scope.vm.saveData = function () {
            var waiting = rt.showWaiting();
            $scope.vm.scoreList.push($scope.vm.potentialScoreList);
            $scope.vm.scoreList.push($scope.vm.attitudeScoreList);
            myService.createScoreList(JSON.stringify($scope.vm.scoreList)).then(function (resp) {
                rt.successMessage("保存成功");
            }).finally(function () {
                $scope.vm.scoreList = [];
                waiting.close();
            });
        };

        $scope.vm.delData = function () {
            if ($scope.vm.view.selectedIds.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.vm.view.selectedIds.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    var selectedids = '';
                    var selectedmap = $scope.vm.view.selectedIds.map(function (item) {
                        return item;
                    });
                    selectedids = selectedmap.join(",");
                    myService.delcotactGradeEvalScoreRuleList(selectedids).then(function (resp) {
                        rt.successMessage('成功删除记录。');
                    }).finally(function () {
                        _loadgradeitemrule();
                    });
                }
            });
        };
    }]).controller('cotactGradeEvalScoreRuleEditController', ['$injector', '$scope', 'cotactGradeEvalScoreRuleService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $compile = myService.$compile;
        var $stateParams = myService.$stateParams;
        var id = $stateParams.id; //获取实体id

        $scope.vm.hideForm = function () {
            var form = $scope.$$childTail[""] || $scope.$$childHead[""];
            if (form.$dirty) rt.confirm("当前页面有未保存的数据，确认要关闭？", function (ok) {
                if (ok) $scope.$emit('rt-on-dialog-close-click');
            });else {
                $scope.$emit('rt-on-dialog-close-click');
            }
        };

        init();
        function init() {
            $scope.vm.itemList = [];
            $scope.delSelected = [];
            loadItemTypeLevel();
            if (rt.isNullOrEmptyString(id)) {
                $scope.vm.product_category = null;
                _loadpotentialItemList();
                _loadattitudeItemList();
            } else {
                myService.getContactGradeEvalItemAndDetail(id).then(function (resp) {
                    for (var i = 0; i < resp.data.length; i++) {
                        if (resp.data[i].eval_item_value_type.Value === '2') {
                            for (var j = 0; j < resp.data[i].itemOptionList.length; j++) {
                                if (resp.data[i].itemOptionList[j].eval_item_value_low !== null && resp.data[i].itemOptionList[j].eval_item_value_hight === null) {
                                    resp.data[i].itemOptionList[j].eval_item_value_hight = '无穷大';
                                }
                            }
                        }
                    }

                    var itemlist = _.groupBy(resp.data, function (item) {
                        return item.eval_type.Value == '1' ? 'potential' : 'attitude';
                    });
                    $scope.vm.product_category = itemlist.potential[0].product_categoryId;
                    $scope.vm.potentialItemList = itemlist.potential;
                    $scope.vm.attitudeItemList = itemlist.attitude;
                });
            }
        }

        function loadItemTypeLevel() {
            myService.getItemTypeLevel().then(function (resp) {
                $scope.vm.picklist.eval_item_value_type = resp.data;
            });
        }

        $scope.vm.saveItem = function () {
            if ($scope.vm.potentialItemList.length === 0) {
                rt.errorMessage("潜力项目不能为空");
                return false;
            }

            if ($scope.vm.attitudeItemList.length === 0) {
                rt.errorMessage("处方态度项目不能为空");
                return false;
            }

            var waiting = rt.showWaiting();
            var msg = checkForm($scope.vm.potentialItemList);
            msg = checkForm($scope.vm.attitudeItemList);

            $scope.vm.itemList.push($scope.vm.potentialItemList);
            $scope.vm.itemList.push($scope.vm.attitudeItemList);

            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                waiting.close();
                return false;
            } else {
                myService.createContactGradeEvalItem($scope.vm.product_category.Id, $scope.vm.product_category.Name, JSON.stringify($scope.vm.itemList)).then(function (resp) {
                    rt.successMessage("保存成功");
                    $scope.$emit('rt-on-dialog-close-click');
                }).catch(function (error) {
                    for (var i = 0; i < $scope.vm.itemList.length; i++) {
                        for (var n = 0; n < $scope.vm.itemList[i].length; n++) {
                            if ($scope.vm.itemList[i][n].eval_item_value_type.Value === '2' || $scope.vm.itemList[i][n].eval_item_value_type.Value === 2) {
                                for (var j = 0; j < $scope.vm.itemList[i][n].itemOptionList.length; j++) {
                                    if ($scope.vm.itemList[i][n].itemOptionList[j].eval_item_value_low !== null && $scope.vm.itemList[i][n].itemOptionList[j].eval_item_value_hight === null) {
                                        $scope.vm.itemList[i][n].itemOptionList[j].eval_item_value_hight = '无穷大';
                                    }
                                }
                            }
                        }
                    }
                }).finally(function () {
                    $scope.vm.itemList = [];
                    waiting.close();
                });
            }
        };

        function checkForm(itemList) {
            if (rt.isNull($scope.vm.product_category) || rt.isNullOrEmptyString($scope.vm.product_category.Id)) {
                return "请选择品类";
            }

            //重复性检查
            var namelist = _.map(itemList, 'name');
            var existsIndex = _.some(namelist, function (elt, index) {
                var s = namelist.indexOf(elt);
                return namelist.indexOf(elt) !== index;
            });

            if (existsIndex == true) {
                return "项目名称不能相同";
            }

            if (_.findIndex(itemList, function (a) {
                return rt.isNullOrEmptyString(a.name);
            }) > 0) {
                return "请填写项目名";
            };

            if (_.findIndex(itemList, function (a) {
                return rt.isNullOrEmptyString(a.eval_item_weight);
            }) > 0) {

                return "请填写权重";
            };

            if (_.findIndex(itemList, function (a) {
                return rt.isNull(a.eval_item_value_type);
            }) > 0) {
                return "请选择项目值类型";
            };

            angular.forEach(itemList, function (itemdetail) {
                angular.forEach(itemdetail.itemOptionList, function (detail) {
                    if (detail.eval_item_value_hight == '无穷大') {
                        detail.eval_item_value_hight = null;
                    }
                });
            });
        }

        //加载潜力项目
        function _loadpotentialItemList() {
            $scope.vm.potentialItemList = [{
                // product_categoryId:{Id:'',Name:''},
                eval_type: { Value: '1', Name: '潜力' },
                name: '在岗状态',
                eval_item_value_type: { Value: '1', Name: '选项' },
                eval_item_weight: '10',
                itemOptionList: [{ code: 1, name: '在岗', eval_item_value_low: '', eval_item_value_hight: '', score: '80' }, { code: 2, name: '进修', eval_item_value_low: '', eval_item_value_hight: '', score: '10' }, { code: 3, name: '轮换', eval_item_value_low: '', eval_item_value_hight: '', score: '10' }]
            }, {
                eval_type: { Value: '1', Name: '潜力' },
                name: '在岗性质',
                eval_item_value_type: { Value: '1', Name: '选项' },
                eval_item_weight: '20',
                itemOptionList: [{ code: 1, name: '门诊', eval_item_value_low: '', eval_item_value_hight: '', score: '40' }, { code: 2, name: '病房', eval_item_value_low: '', eval_item_value_hight: '', score: '30' }, { code: 3, name: '混合', eval_item_value_low: '', eval_item_value_hight: '', score: '30' }]
            }, {
                eval_type: { Value: '1', Name: '潜力' },
                name: '门诊量',
                eval_item_value_type: { Value: '2', Name: '数值区间' },
                eval_item_weight: '40',
                itemOptionList: [{ code: '', name: '', eval_item_value_low: '0', eval_item_value_hight: '100', score: '10' }, { code: '', name: '', eval_item_value_low: '101', eval_item_value_hight: '1000', score: '20' }, { code: '', name: '', eval_item_value_low: '1001', eval_item_value_hight: '无穷大', score: '100' }]
            }, {
                eval_type: { Value: '1', Name: '潜力' },
                name: '适应率',
                eval_item_value_type: { Value: '3', Name: '百分数' },
                eval_item_weight: '10',
                itemOptionList: [{ code: '', name: '', eval_item_value_low: '', eval_item_value_hight: '', score: '' }]
            }];
        }

        //加载处方态度分值区间
        function _loadattitudeItemList() {
            $scope.vm.attitudeItemList = [{
                eval_type: { Value: '2', Name: '贡献值' },
                name: '认可度',
                eval_item_value_type: { Value: '3', Name: '百分数' },
                eval_item_weight: '100',
                itemOptionList: [{ code: '', name: '', eval_item_value_low: '', eval_item_value_hight: '', score: '' }]
            }];
        }

        //新增项目明细
        $scope.vm.additemOptionList = function (item) {
            item.itemOptionList.push({ code: '', name: '', eval_item_value_low: '', eval_item_value_hight: '', score: '' });
        };

        //删除项目明细
        $scope.vm.delitemOptionList = function (itemList, item, index) {
            item.itemOptionList.splice(index, 1);
            if (item.itemOptionList.length == 0) {
                var namelist = _.map(itemList, 'name');
                if (namelist.indexOf(item.name) > 0) {
                    itemList.splice(namelist.indexOf(item.name), 1);
                }
            }
        };

        //新增项目主档
        $scope.vm.addItem = function (item, addType) {
            item.push({
                eval_type: { Value: addType, Name: addType === "1" ? '潜力' : '贡献度' },
                name: '',
                eval_item_value_type: { Value: '', Name: '' },
                eval_item_weight: '',
                itemOptionList: [{ code: '', name: '', eval_item_value_low: '', eval_item_value_hight: '', score: '' }]
            });
        };

        //删除项目主档
        $scope.vm.delItem = function (item, deleteType) {

            var item = _.remove(item, function (item) {
                if ($scope.vm.view.selectedIds.indexOf(item.name) < 0) {
                    return item;
                }
            });

            if (deleteType == "1") {
                $scope.vm.potentialItemList = item;
            } else if (deleteType == "2") {
                $scope.vm.attitudeItemList = item;
            }
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("attitudeItemList").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.vm.attitudeItemList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //删除记录
        $scope.vm.delAttitudeItem = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            _.map($scope.delSelected, function (idx) {
                $scope.vm.attitudeItemList.splice(idx, 1, null);
            });
            $scope.vm.attitudeItemList = _.remove($scope.vm.attitudeItemList, function (item) {
                return !rt.isNull(item);
            });

            $scope.delSelected = [];
            document.getElementById("checkboxAll").checked = false; //取消全选
            $scope.isCheckAll = false;
            $scope.$apply();
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2016-12-19
 说明     : 课程类别
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('courseService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // 服务端控制器名称
        this.controllerName = 'Course';

        this.picklists = ['StateCode'];

        this.GetCourseChapterNumber = function (id) {
            var url = 'api/' + this.controllerName + '/GetCourseChapterNumber?courseId=' + id;
            return rt.get(url);
        };
    }]).controller('courseListController', ['$injector', '$scope', 'courseService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            _that.searchList.length = 0;
            if (!rt.isNullOrEmptyString($scope.vm.view.searchText)) {
                _that.searchList.push({ Type: 0, Key: "name", Value: $scope.vm.view.searchText });
            }
        };
        this.preSearch = function () {
            _that.searchList.length = 0;
            if (!rt.isNullOrEmptyString($scope.vm.view.searchText)) {
                _that.searchList.push({ Type: 0, Key: "name", Value: $scope.vm.view.searchText });
            }
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.loadComplete = function () {
            angular.forEach($scope.vm.data, function (course, index) {
                myService.GetCourseChapterNumber(course.Id).then(function (resp) {
                    $scope.vm.data[index].chapterNum = resp.data;
                });
            });
        };
    }]).controller('courseEditController', ['$injector', '$scope', 'courseService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.coverImg = { id: '', fileName: '', imageSrc: '', base64Content: '', file: null };
        $scope.vm.bigImg = { id: '', fileName: '', imageSrc: '', base64Content: '', file: null };
        $scope.vm.smallImg = { id: '', fileName: '', imageSrc: '', base64Content: '', file: null };

        //选择图片
        $scope.vm.form.fileSelect = function (files, type) {
            if (!rt.isEmptyArray(files)) {
                if (files.length > 1) {
                    rt.errorMessage("图片不能超过1张");
                    return;
                }

                if (files[0].size > 102400) {
                    //单位是字节，此处不允许超过100k
                    rt.errorMessage("图片不能超过100k");
                    return;
                }

                var fileType = files[0].name.substring(files[0].name.lastIndexOf(".") + 1, files[0].name.length).toLowerCase();

                if (fileType != 'jpg' && fileType != 'png' && fileType != 'jpeg') {
                    rt.errorMessage("图片格式只支持:JPG,PNG,JPEG");
                    return;
                }

                readAsDataURL(files[0], $scope).then(function (result) {
                    if (type == 'cover') {
                        $scope.vm.coverImg = {
                            id: rt.isNullOrWhiteSpace($scope.vm.form.data.cover_imageId) ? rt.newGuid() : $scope.vm.form.data.cover_imageId,
                            fileName: files[0].name,
                            imageSrc: result,
                            file: files[0]
                        };
                        $scope.vm.form.data.cover_imageId = $scope.vm.coverImg.id;
                    }
                    if (type == 'small') {
                        $scope.vm.smallImg = {
                            id: rt.isNullOrWhiteSpace($scope.vm.form.data.list_image_smallId) ? rt.newGuid() : $scope.vm.form.data.list_image_smallId,
                            fileName: files[0].name,
                            imageSrc: result,
                            file: files[0]
                        };
                        $scope.vm.form.data.list_image_smallId = $scope.vm.smallImg.id;
                    }
                    if (type == 'big') {
                        $scope.vm.bigImg = {
                            id: rt.isNullOrWhiteSpace($scope.vm.form.data.list_image_bigId) ? rt.newGuid() : $scope.vm.form.data.list_image_bigId,
                            fileName: files[0].name,
                            imageSrc: result,
                            file: files[0]
                        };
                        $scope.vm.form.data.list_image_bigId = $scope.vm.bigImg.id;
                    }
                });
            }
        };

        //删除附件
        $scope.vm.form.deleteFile = function (type) {
            if (type == 'cover' && !rt.isNullOrWhiteSpace($scope.vm.coverImg.id)) {
                var waiting = rt.showWaiting();
                rt.deleteSingleFile("course", $scope.vm.coverImg.id).success(function () {
                    $scope.vm.coverImg = { id: '', fileName: '', imageSrc: '', base64Content: '', file: null };
                    $scope.vm.form.data.cover_imageId = null;
                    rt.successMessage("删除成功。");
                    waiting.close();
                }).error(function (message) {
                    rt.errorMessage(message);
                    waiting.close();
                });
            }

            if (type == 'small' && !rt.isNullOrWhiteSpace($scope.vm.smallImg.id)) {
                var waiting = rt.showWaiting();
                rt.deleteSingleFile("course", $scope.vm.smallImg.id).success(function () {
                    $scope.vm.smallImg = { id: '', fileName: '', imageSrc: '', base64Content: '', file: null };
                    $scope.vm.form.data.list_image_smallId = null;
                    rt.successMessage("删除成功。");
                    waiting.close();
                }).error(function (message) {
                    rt.errorMessage(message);
                    waiting.close();
                });
            }

            if (type == 'big' && !rt.isNullOrWhiteSpace($scope.vm.bigImg.id)) {
                var waiting = rt.showWaiting();
                rt.deleteSingleFile("course", $scope.vm.bigImg.id).success(function () {
                    $scope.vm.bigImg = { id: '', fileName: '', imageSrc: '', base64Content: '', file: null };
                    $scope.vm.form.data.list_image_bigId = null;
                    rt.successMessage("删除成功。");
                    waiting.close();
                }).error(function (message) {
                    rt.errorMessage(message);
                    waiting.close();
                });
            }
        };

        //获取附件
        function _getFile() {

            var _baseApiUrl = "/";
            if (!rt.isNullOrWhiteSpace(localStorage.XrmBaseUrl)) {
                _baseApiUrl = localStorage.XrmBaseUrl;
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.form.data.cover_imageId)) {
                myService.getAttachmentList($scope.vm.form.data.cover_imageId).success(function (data) {
                    if (!rt.isEmptyArray(data)) {
                        $scope.vm.coverImg = {
                            id: data[0].Id,
                            fileName: data[0].FileName,
                            base64Content: _baseApiUrl + "FileDownloadHandler.ashx?fileid=" + data[0].Id + "&moduletype=attachment"
                        };
                    }
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.form.data.list_image_smallId)) {
                myService.getAttachmentList($scope.vm.form.data.list_image_smallId).success(function (data) {
                    if (!rt.isEmptyArray(data)) {
                        $scope.vm.smallImg = {
                            id: data[0].Id,
                            fileName: data[0].FileName,
                            base64Content: _baseApiUrl + "FileDownloadHandler.ashx?fileid=" + data[0].Id + "&moduletype=attachment"
                        };
                    }
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.form.data.list_image_bigId)) {
                myService.getAttachmentList($scope.vm.form.data.list_image_bigId).success(function (data) {
                    if (!rt.isEmptyArray(data)) {
                        $scope.vm.bigImg = {
                            id: data[0].Id,
                            fileName: data[0].FileName,
                            base64Content: _baseApiUrl + "FileDownloadHandler.ashx?fileid=" + data[0].Id + "&moduletype=attachment"
                        };
                    }
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }
        }

        /*start 读取图片相关*/
        var onLoad = function onLoad(reader, deferred, scope) {
            return function () {
                scope.$apply(function () {
                    deferred.resolve(reader.result);
                });
            };
        };

        var onError = function onError(reader, deferred, scope) {
            return function () {
                scope.$apply(function () {
                    deferred.reject(reader.result);
                });
            };
        };

        var getReader = function getReader(deferred, scope) {
            var reader = new FileReader();
            reader.onload = onLoad(reader, deferred, scope);
            reader.onerror = onError(reader, deferred, scope);
            return reader;
        };

        var readAsDataURL = function readAsDataURL(file, scope) {
            var deferred = $q.defer();
            var reader = getReader(deferred, scope);
            reader.readAsDataURL(file);
            return deferred.promise;
        };
        /*end 读取图片相关*/

        $scope.vm.form.loadComplete = function () {
            if ($scope.vm.form.type === 'Edit') {
                _getFile();
            }
        };

        $scope.vm.form.fileSave = function () {
            if (!rt.isNull($scope.vm.coverImg.file)) {
                rt.uploadFiles($scope.vm.coverImg.file, "course", $scope.vm.coverImg.id, true, function () {}, function (error) {
                    rt.errorMessage(error);
                });
            }

            if (!rt.isNull($scope.vm.smallImg.file)) {
                rt.uploadFiles($scope.vm.smallImg.file, "course", $scope.vm.smallImg.id, true, function () {}, function (error) {
                    rt.errorMessage(error);
                });
            }

            if (!rt.isNull($scope.vm.bigImg.file)) {
                rt.uploadFiles($scope.vm.bigImg.file, "course", $scope.vm.bigImg.id, true, function () {}, function (error) {
                    rt.errorMessage(error);
                });
            }
        };

        $scope.vm.form.newsave = function (isCreate) {
            var waiting = rt.showWaiting();

            $q.all([$scope.vm.form.fileSave()]).then(function () {
                $scope.vm.form.save(isCreate);
                if (isCreate) {
                    //保存并新建，清空附件图片内容
                    $scope.vm.coverImg = { id: '', fileName: '', imageSrc: '', base64Content: '', file: null };
                    $scope.vm.bigImg = { id: '', fileName: '', imageSrc: '', base64Content: '', file: null };
                    $scope.vm.smallImg = { id: '', fileName: '', imageSrc: '', base64Content: '', file: null };
                }
            }, function (error) {
                rt.errorMessage(error);
            }).finally(function () {
                waiting.close();
            });
        };
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Gale Ge
创建时间 : 2016-12-20
说明     : 课程
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('courseCategoryService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // 服务端控制器名称
        this.controllerName = 'courseCategory';

        this.picklists = ['StateCode'];
    }]).controller('courseCategoryListController', ['$scope', 'courseCategoryService', entityListController]).controller('courseCategoryEditController', ['$injector', '$scope', 'courseCategoryService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.preSave = function () {
            if ($scope.vm.form.data.parentId) {
                if ($scope.vm.form.data.Id == $scope.vm.form.data.parentId.Id) {
                    rt.errorMessage("父级类别不能选择自己");
                    return "父级类别不能选择自己";
                }
            }
        };
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Gale Ge
创建时间 : 2016-12-20
说明     : 课程章节
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('courseChapterService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        this.controllerName = 'courseChapter';

        this.picklists = ['StateCode', 'content_type'];

        this.getAttachmentList = function (id) {
            if (rt.isNull(id) || id.length === 0) {
                var deferred = $q.defer();
                deferred.resolve({ data: null });
                return deferred.promise;
            }

            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
    }]).controller('courseChapterListController', ['$injector', '$scope', 'courseChapterService', function ($injector, $scope, myService) {
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('courseChapterEditController', ['$injector', '$scope', 'courseChapterService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;

        this.preLoad = function (data) {
            $scope.vm.form.attachmentList = [];

            if ($scope.vm.form.type === 'Edit') {
                _getFile();
            }
        };

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.newsave = function (isCreate) {
            var waiting = rt.showWaiting();
            $scope.vm.form.save(isCreate).then(function () {
                return $scope.vm.form.fileSave();
            }).then(function () {
                _getFile();
            }).finally(function () {
                waiting.close();
            });
        };

        /* start 附件相关*/
        function _getFile() {
            if ($scope.vm.form.id != "") {
                myService.getAttachmentList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.attachmentList = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }
        }

        $scope.selectedFiles = null;
        $scope.selectedFilesArr = [];

        $scope.vm.form.fileSelect = function (files) {

            if (!rt.isEmptyArray(files)) {
                var fileType;
                for (var i = 0; i < files.length; i++) {
                    fileType = files[i].name.substring(files[i].name.lastIndexOf(".") + 1, files[i].name.length);
                    // if (fileType !== 'PDF' && fileType !== 'pdf') {
                    //     rt.errorMessage("文件格式只支持:PDF");
                    //     return;
                    // }
                    if (files[i].size > 5242880 * 4) {
                        //单位是字节，此处不允许超过100k
                        rt.errorMessage("文件不能超过20M");
                        return;
                    }
                }
            }

            if (!rt.isEmptyArray(files) && files.length && files.length > 1 || $scope.vm.form.attachmentList.length > 0) {
                rt.errorMessage("只能上传一个文件");
                return;
            }

            if (files && files.length && files.length > 0) {
                for (var i = 0; i < files.length; i++) {
                    $scope.selectedFilesArr.push(files[i]);
                }
                $scope.selectedFiles = $scope.selectedFilesArr;

                for (var i = 0; i < files.length; i++) {
                    $scope.vm.form.attachmentList.push({
                        Id: rt.newGuid(),
                        FileName: files[i].name
                    });
                }
            }
        };

        $scope.vm.form.fileSave = function () {
            if (!rt.isEmptyArray($scope.selectedFiles)) {
                return rt.uploadFiles($scope.selectedFiles, "course_chapter", $scope.vm.form.data.Id, false, function (data) {
                    $scope.selectedFiles = null;
                    $scope.selectedFilesArr = [];
                });
            } else {
                var deferred = $q.defer();
                deferred.reject("没有添加附件");
                return deferred.promise;
            }
        };

        $scope.vm.form.deleteFile = function () {
            if ($scope.vm.view.selectedIds.length == 0) {
                rt.errorMessage("至少选择一项要删除的文件！");
                return;
            }

            var mmm = rt.deleteFile("course_chapter", $scope.vm.view.selectedIds).error(function (message) {
                rt.errorMessage(message);
            }).success(function () {
                for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                    for (var k = 0; k < $scope.vm.form.attachmentList.length; k++) {
                        if ($scope.vm.form.attachmentList[k].Id === $scope.vm.view.selectedIds[j]) {
                            if ($scope.selectedFiles != null) {
                                for (var i = 0; i < $scope.selectedFiles.length; i++) {
                                    if ($scope.selectedFiles[i].name === $scope.vm.form.attachmentList[k].FileName) {
                                        $scope.selectedFiles.splice(i, 1);
                                    }
                                }
                            }
                        }
                    }
                }

                for (var i = 0; i < $scope.vm.form.attachmentList.length; i++) {
                    for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
                        if ($scope.vm.form.attachmentList[i].Id === $scope.vm.view.selectedIds[j]) {
                            $scope.vm.form.attachmentList.splice(i, 1);
                        }
                    }
                }

                $scope.vm.view.selectedIds = [];
                rt.successMessage("删除成功。");
            });
        };

        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("course_chapter", fileId);
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/17
 说明     : 课程首页设计
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('CourseUIService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'CourseUIBanner';
    }]).controller('CourseUIListController', ['$injector', '$scope', 'CourseUIService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.selectView = function (view) {
            if (view.Id == "62A2C583-3313-4F94-A7FD-81EA6A6049E4") {
                myService.controllerName = 'CourseUIBanner';
            }
            if (view.Id == "28482DBF-9FD4-466D-92CE-C7F019F0FBA6") {
                myService.controllerName = 'CourseUIRecommend';
            }
            $scope.vm.view.select(view);
        };
    }]).controller('CourseUIEditController', ['$injector', '$scope', 'CourseUIService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016-04-29
 说明     : 自定义类别
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('customcategoryService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'customcategory';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('customcategoryListController', ['$injector', '$scope', 'customcategoryService', function ($injector, $scope, entityService) {
        var rt = entityService.rt;
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            _that.searchList.length = 0;
            if (!rt.isNullOrEmptyString($scope.vm.view.searchText)) {
                _that.searchList.push({ Type: 0, Key: "name", Value: $scope.vm.view.searchText });
            }
        };
        this.preSearch = function () {
            _that.searchList.length = 0;
            if (!rt.isNullOrEmptyString($scope.vm.view.searchText)) {
                _that.searchList.push({ Type: 0, Key: "name", Value: $scope.vm.view.searchText });
            }
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: entityService
        });
    }]).controller('customcategoryEditController', ['$injector', '$scope', 'customcategoryService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //重写删除，当有明细时，主档不能删除
        $scope.vm.del = function (ids) {
            var api = "api/CustomCategory/isCustomCategoryDetail?id=" + ids;
            rt.get(api).then(function (resp) {
                var flag = resp.data;
                if (flag === 0) {
                    rt.errorMessage("指标类别含明细药品，不能删除！");
                } else {
                    $scope.vm.form.del();
                }
            });
        };
    }]).service('customcategorydetailService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'customcategorydetail';

        // @@ 选项集
        this.picklists = ['StateCode'];
        this.getProductSize = function (id) {
            var url = 'api/Product/GetProductById?id=' + id;
            return rt.get(url);
        };
    }]).controller('customcategorydetailListController', ['$scope', 'customcategorydetailService', entityListController]).controller('customcategorydetailEditController', ['$injector', '$scope', 'customcategorydetailService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        //带出药品规格
        $scope.$watch("vm.form.data.productid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                //带出药品规格
                myService.getProductSize($scope.vm.form.data.productid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.form.data.product_size = resp.data.productsize;
                    } else {
                        $scope.vm.form.data.product_size = '';
                    }
                });
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-01-18
 说明     : 考试
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('DdmaccountaliasService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'DdmAccountAlias';

        // @@ 选项集
        this.picklists = ['Action_status'];
        this.getAccountTypeById2 = function (id) {
            var url = 'api/Account/GetAccountTypeById2?accountId=' + id;
            return rt.get(url);
        };
    }]).controller('ddmaccountaliasListController', ['$scope', 'DdmaccountaliasService', entityListController]).controller('ddmaccountaliasEditController', ['$scope', '$injector', 'DdmaccountaliasService', function ($scope, $injector, myService) {
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        var rt = myService.rt;
        var $stateParams = myService.$stateParams;
        $scope.$watch("vm.form.data.to_accountid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                //流向下游企业类型
                myService.getAccountTypeById2($scope.vm.form.data.to_accountid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.form.data.to_account_classificationcode = resp.data;
                    } else {
                        $scope.vm.form.data.to_account_classificationcode = '';
                    }
                });
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/5/12
 说明     : 流向数据-流向调整
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('DdmAdjDataService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'DdmAdjData';

        // @@ 选项集
        this.picklists = ['to_account_classificationcode'];

        this.getProductSizeById = function (id) {
            var url = 'api/Product/GetProductById?id=' + id;
            return rt.get(url);
        };

        this.getAccountTypeById2 = function (id) {
            var url = 'api/Account/GetAccountTypeById2?accountId=' + id;
            return rt.get(url);
        };
    }]).controller('DdmAdjDataListController', ['$injector', '$scope', 'DdmAdjDataService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('DdmAdjDataEditController', ['$injector', '$scope', 'DdmAdjDataService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.preSave = function () {
            $scope.vm.form.data.adj_year = parseInt($scope.vm.form.yM.substring(0, 4));
            $scope.vm.form.data.adj_month = parseInt($scope.vm.form.yM.substring(5, 7));
        };

        $scope.vm.form.loadComplete = function () {
            $scope.vm.form.yM = $scope.vm.form.data.adj_year + '-' + $scope.vm.form.data.adj_month;
        };

        //修改上游部门 上游负责人清空
        $scope.$watch("vm.form.data.from_businessunitid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.from_ownerid = null;
                return;
            }
        });

        //修改下游部门 下游负责人清空
        $scope.$watch("vm.form.data.to_businessunitid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.to_ownerid = null;
                return;
            }
        });

        //选择药品后自动带出药品规格
        $scope.$watch("vm.form.data.productid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                myService.getProductSizeById($scope.vm.form.data.productid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.form.data.productsize = resp.data.productsize;
                    } else {
                        $scope.vm.form.data.productsize = '';
                    }
                });
                return;
            }
        });

        //选择企业后自动带出企业类型
        $scope.$watch("vm.form.data.to_accountid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                myService.getAccountTypeById2($scope.vm.form.data.to_accountid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.form.data.to_account_classificationcode = resp.data;
                    } else {
                        $scope.vm.form.data.to_account_classificationcode = '';
                    }
                });
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-05-18
 说明     : 流向数据-b2b运行日志
 *********************************************************/

(function () {
            'use strict';

            angular.module('xrmApp').service('Ddmb2bRunningLogService', ['entityService', function (entityService) {
                        var rt = entityService.rt;

                        angular.extend(this, entityService);

                        // @@设置WebAPI的控制器名称
                        this.controllerName = 'Ddmb2bRunningLog';

                        // @@ 选项集
                        this.picklists = ['Action_status'];
            }]).controller('ddmb2brunninglogListController', ['$scope', 'Ddmb2bRunningLogService', entityListController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-05-15
 说明     : 流向数据-匹配别名
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('ddmcleandataService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DDMCleanData';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.DDMMatchingProduct = function (Ym, unitid, busiid, matchingType) {
            var apiUrl = 'api/DDMCleanData/DDMMatchingProduct?Ym=' + Ym;
            apiUrl += '&fromBuId=' + unitid;
            apiUrl += '&fromAccId=' + busiid;
            apiUrl += '&matchingType=' + matchingType;
            return rt.get(apiUrl);
        };

        this.UpdateProduct = function (id, productId) {
            var apiUrl = 'api/DDMCleanData/UpdateProduct?id=' + id;
            apiUrl += '&productId=' + productId;
            return rt.get(apiUrl);
        };

        this.GetUnMatchingCount = function (Ym, unitid, busiid, type) {
            var apiUrl = 'api/DDMCleanData/GetUnMatchingCount?Ym=' + Ym;
            apiUrl += '&fromBuId=' + unitid;
            apiUrl += '&fromAccId=' + busiid;
            apiUrl += '&type=' + type;
            return rt.get(apiUrl);
        };

        this.DDMMatchingAccount = function (Ym, unitid, busiid, matchingType) {
            var apiUrl = 'api/DDMCleanData/DDMMatchingAccount?Ym=' + Ym;
            apiUrl += '&fromBuId=' + unitid;
            apiUrl += '&fromAccId=' + busiid;
            apiUrl += '&matchingType=' + matchingType;
            return rt.get(apiUrl);
        };

        this.UpdateAccount = function (id, accountId) {
            var apiUrl = 'api/DDMCleanData/UpdateAccount?id=' + id;
            apiUrl += '&accountId=' + accountId;
            return rt.get(apiUrl);
        };
    }]).controller('ddmcleandataproductListController', ['$injector', '$scope', '$timeout', '$state', 'ddmcleandataService', function ($injector, $scope, $timeout, $state, myService) {
        var rt = myService.rt;
        var $stateParams = myService.$stateParams;
        var that = this;
        this.searchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
            _checkOption();
            that.searchList.push({ Type: 1, Key: "Ym", Value: $scope.vm.Ym });
            that.searchList.push({ Type: 1, Key: "businessunit", Value: $scope.vm.unitid });
            that.searchList.push({ Type: 1, Key: "business", Value: $scope.vm.busiid });
            that.searchList.push({ Type: 1, Key: "matchingType", Value: $scope.vm.matchingType.value });
            that.searchList.push({ Type: 1, Key: "type", Value: "product" });
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.goBack = _goBack;

        function _goBack() {
            $state.go("main.ddmmanage", {}, { location: true });
        }

        $scope.vm.isShowBack = !rt.isNullOrWhiteSpace($stateParams.ym);
        $scope.vm.Ym = $stateParams.ym;
        $scope.vm.unitSelected = rt.isNullOrWhiteSpace($stateParams.frombuid) ? {} : JSON.parse($stateParams.frombuid);
        $scope.vm.busiSelected = rt.isNullOrWhiteSpace($stateParams.fromaccid) ? {} : JSON.parse($stateParams.fromaccid);
        $scope.vm.typeFilter = [{ value: true, name: '未匹配别名的流向' }, { value: false, name: '所有的流向' }];
        $scope.vm.isMatching = false;
        $scope.vm.matchingType = $scope.vm.typeFilter[0];

        function _checkOption() {
            $scope.vm.unitid = "";
            $scope.vm.busiid = "";

            if (rt.isNullOrWhiteSpace($scope.vm.Ym)) {
                $scope.vm.Ym = moment().add(-1, 'months').format('YYYY-MM');
            }
            if (!rt.isNull($scope.vm.unitSelected)) {
                if (!rt.isNull($scope.vm.unitSelected.Id)) {
                    $scope.vm.unitid = $scope.vm.unitSelected.Id;
                }
            }
            if (!rt.isNull($scope.vm.busiSelected)) {
                if (!rt.isNull($scope.vm.busiSelected.Id)) {
                    $scope.vm.busiid = $scope.vm.busiSelected.Id;
                }
            }
        }

        function _getUnMatchingCount() {
            myService.GetUnMatchingCount($scope.vm.Ym, $scope.vm.unitid, $scope.vm.busiid, "product").then(function (resp) {
                $scope.vm.unMatching = resp.data;
            });
        }

        $scope.vm.actions.ddmMatchingProduct = function () {
            rt.showLoading('正在匹配数据中...');
            $scope.vm.isMatching = true;
            _checkOption();
            myService.DDMMatchingProduct($scope.vm.Ym, $scope.vm.unitid, $scope.vm.busiid, $scope.vm.matchingType.value).then(function (resp) {
                _getUnMatchingCount();
                $scope.vm.view.search();
            }).finally(function () {
                rt.hideLoading();
            });
        };

        $scope.vm.actions.updateProduct = function (data) {
            rt.showLoading('正在保存中...');
            data.forEach(function (element) {
                if (!rt.isNull(element.productid)) {
                    myService.UpdateProduct(element.Id, element.productid.Id);
                }
            });
            $timeout(function () {
                _getUnMatchingCount();
                rt.hideLoading();
                $scope.vm.view.search();
            }, 1000);
        };

        $scope.vm.actions.goMatchingAccount = function () {
            $state.go("main.ddmcleandataaccount", {
                "ym": moment($scope.vm.Ym).format('YYYY-MM'),
                "frombuid": JSON.stringify($scope.vm.unitSelected),
                "fromaccid": JSON.stringify($scope.vm.busiSelected)
            }, {
                location: true
            });
        };
    }]).controller('ddmcleandataaccountListController', ['$injector', '$scope', '$timeout', '$state', 'ddmcleandataService', function ($injector, $scope, $timeout, $state, myService) {
        var rt = myService.rt;
        var $stateParams = myService.$stateParams;
        var that = this;
        this.searchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
            _checkOption();
            that.searchList.push({ Type: 1, Key: "Ym", Value: $scope.vm.Ym });
            that.searchList.push({ Type: 1, Key: "businessunit", Value: $scope.vm.unitid });
            that.searchList.push({ Type: 1, Key: "business", Value: $scope.vm.busiid });
            that.searchList.push({ Type: 1, Key: "matchingType", Value: $scope.vm.matchingType.value });
            that.searchList.push({ Type: 1, Key: "type", Value: "account" });
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.Ym = $stateParams.ym;
        $scope.vm.unitSelected = rt.isNullOrWhiteSpace($stateParams.frombuid) ? {} : JSON.parse($stateParams.frombuid);
        $scope.vm.busiSelected = rt.isNullOrWhiteSpace($stateParams.fromaccid) ? {} : JSON.parse($stateParams.fromaccid);
        $scope.vm.typeFilter = [{ value: true, name: '未匹配别名的流向' }, { value: false, name: '所有的流向' }];
        $scope.vm.isMatching = false;
        $scope.vm.matchingType = $scope.vm.typeFilter[0];

        function _checkOption() {
            $scope.vm.unitid = "";
            $scope.vm.busiid = "";

            if (rt.isNullOrWhiteSpace($scope.vm.Ym)) {
                $scope.vm.Ym = moment().add(-1, 'months').format('YYYY-MM');
            }
            if (!rt.isNull($scope.vm.unitSelected)) {
                if (!rt.isNull($scope.vm.unitSelected.Id)) {
                    $scope.vm.unitid = $scope.vm.unitSelected.Id;
                }
            }
            if (!rt.isNull($scope.vm.busiSelected)) {
                if (!rt.isNull($scope.vm.busiSelected.Id)) {
                    $scope.vm.busiid = $scope.vm.busiSelected.Id;
                }
            }
        }

        function _getUnMatchingCount() {
            myService.GetUnMatchingCount($scope.vm.Ym, $scope.vm.unitid, $scope.vm.busiid, "account").then(function (resp) {
                $scope.vm.unMatching = resp.data;
            });
        }

        $scope.vm.actions.ddmMatchingAccount = function () {
            rt.showLoading('正在匹配数据中...');
            $scope.vm.isMatching = true;
            _checkOption();
            myService.DDMMatchingAccount($scope.vm.Ym, $scope.vm.unitid, $scope.vm.busiid, $scope.vm.matchingType.value).then(function (resp) {
                _getUnMatchingCount();
                $scope.vm.view.search();
            }).finally(function () {
                rt.hideLoading();
            });
        };

        $scope.vm.actions.updateAccount = function (data) {
            rt.showLoading('正在保存中...');
            data.forEach(function (element) {
                if (!rt.isNull(element.to_accountid)) {
                    myService.UpdateAccount(element.Id, element.to_accountid.Id);
                }
            });
            $timeout(function () {
                _getUnMatchingCount();
                rt.hideLoading();
                $scope.vm.view.search();
            }, 1000);
        };

        $scope.vm.actions.goCalAssignMent = function () {
            $state.go("main.caldrugflowassignment", {
                "ym": moment($scope.vm.Ym).format('YYYY-MM'),
                "frombuid": JSON.stringify($scope.vm.unitSelected),
                "fromaccid": JSON.stringify($scope.vm.busiSelected)
            }, {
                location: true
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/5/17
 说明     : 流向处理 - 流向数据锁定及下发
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('DdmLockDataService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'DdmLockData';

        this.getDataList = function (yM, dataStatus, businessunitId, ownerId, filterType, pageSize, pageIndex) {
            var url = 'api/DdmLockData/GetDataList?yM=' + yM;
            url += '&dataStatus=' + dataStatus;
            url += '&businessunitId=' + businessunitId;
            if (filterType == 2) //按照部门+代表查询
                url += '&ownerId=' + ownerId;
            url += '&pageSize=' + pageSize;
            url += '&pageIndex=' + pageIndex;
            return rt.get(url);
        };

        this.lock = function (yM, businessunitId, ownerId, filterType) {
            var url = 'api/DdmLockData/LockData?yM=' + yM;
            url += '&businessunitId=' + businessunitId;
            if (filterType == 2) //按照部门+代表查询
                url += '&ownerId=' + ownerId;
            return rt.get(url);
        };

        this.unlock = function (yM, businessunitId, ownerId, filterType) {
            var url = 'api/DdmLockData/UnLockData?yM=' + yM;
            url += '&businessunitId=' + businessunitId;
            if (filterType == 2) //按照部门+代表查询
                url += '&ownerId=' + ownerId;
            return rt.get(url);
        };
    }]).controller('DdmLockDataListController', ['$injector', '$scope', 'DdmLockDataService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var _that = this;
        this.searchList = [];

        this.preExport = function () {
            _that.searchList.length = 0;

            if (rt.isNullOrWhiteSpace($scope.vm.yM)) {
                return "请选择年月";
            } else {
                _that.searchList.push({ Type: 1, Key: "yM", Value: moment($scope.vm.yM).format('YYYY-MM') });
            }

            if (rt.isNull($scope.vm.dataStatus)) {
                return "请选择流向状态";
            } else {
                _that.searchList.push({ Type: 1, Key: "dataStatus", Value: $scope.vm.dataStatus.Value });
            }

            _that.searchList.push({ Type: 1, Key: "businessunitId", Value: rt.isNull($scope.vm.businessunitId) ? '' : $scope.vm.businessunitId.Id });
            _that.searchList.push({ Type: 1, Key: "ownerId", Value: rt.isNull($scope.vm.ownerId) ? '' : $scope.vm.ownerId.Id });
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        //筛选模式
        $scope.vm.filterList = [{ Name: '部门', Value: 1 }, { Name: '部门 + 代表', Value: 2 }];
        $scope.vm.selectedFilter = $scope.vm.filterList[0];
        $scope.vm.statusList = [{ Name: '待锁定下发', Value: 1 }, { Name: '待确认', Value: 2 }, { Name: '已确认生效', Value: 3 }];
        $scope.vm.dataStatus = $scope.vm.statusList[0];
        $scope.vm.yM = moment().add('months', -1).format('YYYY-MM');
        $scope.vm.search = _getDataList;

        //初始化表格数据
        function _getDataList() {
            if (rt.isNullOrWhiteSpace($scope.vm.yM)) {
                rt.errorMessage("请选择年月");
                return false;
            }

            if (rt.isNull($scope.vm.dataStatus)) {
                rt.errorMessage("请选择流向状态");
                return false;
            }

            var waiting = rt.showLoading2();
            myService.getDataList($scope.vm.yM, $scope.vm.dataStatus.Value, rt.isNull($scope.vm.businessunitId) ? '' : $scope.vm.businessunitId.Id, rt.isNull($scope.vm.ownerId) ? '' : $scope.vm.ownerId.Id, $scope.vm.selectedFilter.Value, $scope.vm.page.size, $scope.vm.page.index).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }

        $scope.vm.actions.lock = function () {
            var waiting = rt.showWaiting();
            myService.lock($scope.vm.yM, rt.isNull($scope.vm.businessunitId) ? '' : $scope.vm.businessunitId.Id, rt.isNull($scope.vm.ownerId) ? '' : $scope.vm.ownerId.Id, $scope.vm.selectedFilter.Value).then(function (resp) {
                rt.successMessage('锁定成功');
                $scope.vm.page.index = 1;
                _getDataList();
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        };

        $scope.vm.actions.unLock = function () {
            var waiting = rt.showWaiting();
            myService.unlock($scope.vm.yM, rt.isNull($scope.vm.businessunitId) ? '' : $scope.vm.businessunitId.Id, rt.isNull($scope.vm.ownerId) ? '' : $scope.vm.ownerId.Id, $scope.vm.selectedFilter.Value).then(function (resp) {
                rt.successMessage('解除锁定成功');
                $scope.vm.page.index = 1;
                _getDataList();
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        };
    }]);
})();
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/3/2
 *描述：文件描述...
 *************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('deliveryService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'delivery';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getSumData = function (quickSearch, searchList) {
            var url = 'api/Delivery/GetSumData?quickSearchValue=' + encodeURIComponent(quickSearch) + "&searchList=" + (rt.isNull(searchList) ? "" : encodeURIComponent(JSON.stringify(searchList)));
            return rt.get(url);
        };
    }]).controller('deliveryListController', ['$injector', '$scope', '$timeout', 'deliveryService', function ($injector, $scope, $timeout, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;
        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }
            if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                return "开始日期必须小于结束日期";
            }

            if (!rt.isNull($scope.vm.productSelected) && $scope.vm.productSelected.length > 0) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });

                that.searchList.push({ Type: 2, key: "productid", Value: pmap });
            }
            var sArr = $scope.vm.sYm.split("-");
            var eArr = $scope.vm.eYm.split("-");
            that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
            that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.accountName) && $scope.vm.accountName != "") {
                that.searchList.push({ Type: 0, key: "accountidName", Value: $scope.vm.accountName });
            }
            if (!rt.isNull($scope.vm.ownerIdName) && $scope.vm.ownerIdName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.ownerIdName });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }
            if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                return "开始日期必须小于结束日期";
            }

            if (!rt.isNull($scope.vm.productSelected) && $scope.vm.productSelected.length > 0) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });

                that.searchList.push({ Type: 2, key: "productid", Value: pmap });
            }
            var sArr = $scope.vm.sYm.split("-");
            var eArr = $scope.vm.eYm.split("-");
            that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
            that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.accountName) && $scope.vm.accountName != "") {
                that.searchList.push({ Type: 0, key: "accountidName", Value: $scope.vm.accountName });
            }
            if (!rt.isNull($scope.vm.ownerIdName) && $scope.vm.ownerIdName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.ownerIdName });
            }
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        // $scope.showForm = _showForm;
        $scope.vm.searchFormHide = true;
        $scope.vm.buidList = [];
        $scope.vm.buidSelected = null;
        $scope.vm.bigDepList = [];
        $scope.vm.bigDepSelected = null;
        $scope.vm.businessUnitList = [];
        $scope.vm.businessUnitSelected = [];
        $scope.vm.depType = 0;
        $scope.vm.accountName = "";
        $scope.vm.ownerIdName = "";
        $scope.vm.clickForm = function () {};
        _getAllProduct();
        _getAllBuid();
        _initYmSelected();
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        // function _showForm() {
        //     var html = '<div rt-include rt-template="Module/Delivery/deliveryExcelImportView.html" rt-controller="deliveryExcelImportController" ></div>';
        //     $scope.vm.dialog = BootstrapDialog.show({
        //         title: '<span style="color:#09f"><i class="fa fa-upload fa-2x"></i>　导入商业发货数据</span>',
        //         type: BootstrapDialog.TYPE_DEFAULT,
        //         message: html,
        //         size: BootstrapDialog.SIZE_NORMAL,
        //         modal: false,
        //         onshow: function (dialog) {
        //             var obj = dialog.getModalBody().contents();
        //             $compile(obj)($scope);
        //         }
        //     });
        // }

        //重写import方法
        $scope.vm.actions.import = function (headerMap, importType) {
            $scope.importHeader = headerMap;
            $scope.importType = importType;
            BootstrapDialog.show({
                type: BootstrapDialog.TYPE_PRIMARY,
                title: '导入' + $scope.importHeader.Title,
                message: '<div rt-include rt-template="Module/Delivery/deliveryExcelImportView.html" rt-controller="deliveryExcelImportController" ></div>',
                size: BootstrapDialog.SIZE_NORMAL,
                closable: true,
                onshow: function onshow(dialog) {
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
        //导出excel表格数据
        //function _showExpForm(){
        //    var html = '<div rt-include rt-template="Module/Delivery/deliveryExcelExportView.html" rt-controller="deliveryExcelExportController" ></div>';
        //    $scope.vm.expdialog = BootstrapDialog.show({
        //        title: '<span style="color:#09f"><i class="fa fa-download fa-2x"></i>　导出商业发货数据</span>',
        //        type: BootstrapDialog.TYPE_DEFAULT,
        //        message: html,
        //        size: BootstrapDialog.SIZE_NORMAL,
        //        onshow: function (dialog) {
        //            //dialog.getModalHeader().hide();
        //            //dialog.getModalFooter().hide();
        //            var obj = dialog.getModalBody().contents();
        //            $compile(obj)($scope);
        //        }
        //    });
        //}


        //-新增多条件查询-CreateTime:2016-05-19//

        $scope.overHeightTable = function () {
            overHeightTable();
        };
        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = [];
            });
        }
        //-新增结束--//

        $scope.vm.actions.loadComplete = function () {
            $scope.vm.sumPrice = 0;
            $scope.vm.sumCount = 0;
            $scope.vm.totalPrice = 0; // 金额总计
            $scope.vm.totalCount = 0; // 销量总计

            $scope.vm.data.forEach(function (item) {
                $scope.vm.sumPrice += item.delivery_amount; //本页总金额
                $scope.vm.sumCount += item.delivery_count; //本页发货数量
            });
            myService.getSumData($scope.vm.view.searchText, $scope.vm.searchList).then(function (resp) {
                var data = resp.data[0];
                if (!rt.isNull(data)) {
                    $scope.vm.totalPrice = data.sumPrice.toFixed(2); // 金额总计
                    $scope.vm.totalCount = data.sumCount; // 销量总计
                }
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : SummerXu
 创建时间 : 2016-04-26
 说明     : 回款任务指标
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('deliverytaskService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'deliverytask';
        // @@ 选项集
        this.picklists = ['StateCode', 'tasklevel', 'type', 'year', 'month', 'targettype'];
    }]).controller('deliverytaskListController', ['$injector', '$scope', '$timeout', 'deliverytaskService', function ($injector, $scope, $timeout, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;
        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            var accids = "";
            var staskLevel = 0;
            var category = "";
            var tabSelectId = $scope.vm.view.selectedView.Id;
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    rt.errorMessage("只可查询同一年的数据");
                    return false;
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    rt.errorMessage("开始日期必须小于结束日期");
                    return false;
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if (!rt.isNull($scope.vm.staskLevel)) {
                that.searchList.push({ Type: 1, Key: "tasklevel", Value: $scope.vm.staskLevel.Value });
            }
            if (!rt.isNull($scope.vm.custom_category)) {
                that.searchList.push({ Type: 1, Key: "custom_category", Value: $scope.vm.custom_category.Id });
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }

            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            var accids = "";
            var staskLevel = 0;
            var category = "";
            var tabSelectId = $scope.vm.view.selectedView.Id;
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    rt.errorMessage("只可查询同一年的数据");
                    return false;
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    rt.errorMessage("开始日期必须小于结束日期");
                    return false;
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if (!rt.isNull($scope.vm.staskLevel)) {
                that.searchList.push({ Type: 1, Key: "tasklevel", Value: $scope.vm.staskLevel.Value });
            }
            if (!rt.isNull($scope.vm.custom_category)) {
                that.searchList.push({ Type: 1, Key: "custom_category", Value: $scope.vm.custom_category.Id });
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }

            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.showForm = _showForm;
        function _showForm() {
            var html = '<div rt-include rt-template="Module/MissionTarget/missiontargetExcelImportView.html" rt-controller="missiontargetExcelImportController" ></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '<span style="color:#09f"><i class="fa fa-download fa-2x"></i>　导出任务指标数据</span>',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_NORMAL,
                onshow: function onshow(dialog) {
                    //dialog.getModalHeader().hide();
                    //dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }
        //-新增多条件查询-CreateTime：2016-05-20-//

        $scope.vm.searchFormHide = true;
        $scope.vm.buidList = [];
        $scope.vm.buidSelected = null;
        $scope.vm.bigDepList = [];
        $scope.vm.bigDepSelected = null;
        $scope.vm.businessUnitList = [];
        $scope.vm.businessUnitSelected = [];
        $scope.vm.depType = 0;
        $scope.vm.OwnerName = "";
        $scope.vm.clickForm = function () {};
        _getAllBuid();

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }
        //-新增结束--//

        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        $scope.overHeightTable = function () {
            overHeightTable();
        };
        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });

        //-新增结束--//
    }]).controller('deliverytaskEditController', ['$injector', '$scope', 'deliverytaskService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch('vm.form.data.buid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.bigdept = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.bigdept.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.BusinessUnitId = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016-02-02
 说明     : 科室管理
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('departmentService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'department';

        // @@ 选项集
        this.picklists = ['StateCode', 'roomtype'];
    }]).controller('departmentListController', ['$injector', '$compile', '$scope', 'departmentService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        $scope.viewTag = "Web";
        this.viewTag = "Web";
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('departmentEditController', ['$injector', '$scope', 'departmentService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.$watch("vm.form.data.accountid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.contactid = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/6/16
 说明     : 开发医院Service
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('developHospitalService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DevelopHospital';
        // @@ 选项集
        this.picklists = ['StateCode', 'develop_status', 'develop_current_step', 'failure_reason'];

        this.getViewData = function (ssYm, seYm, esYm, eeYm, stepCode, unitids, OwnerId, searchText, pageSize, pageIndex) {
            return rt.post("api/DevelopHospital/GetViewListv2?sSDate=" + ssYm + "&seDate=" + seYm + "&esdDate=" + esYm + "&eeDate=" + eeYm + "&stepCode=" + stepCode + "&ownerId=" + OwnerId + "&searchText=" + searchText + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex, unitids);
        };
    }]).controller('developHospitalListController', ['$injector', '$scope', 'developHospitalService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var params = $scope.vm.searchList;
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "ssYm", Value: rt.isNull(params.ssYm) ? '' : moment(params.ssYm).format('YYYY-MM-DD') });
            _that.searchList.push({ Type: 1, Key: "seYm", Value: rt.isNull(params.seYm) ? '' : moment(params.seYm).add('days', 1).format('YYYY-MM-DD') });
            _that.searchList.push({ Type: 1, Key: "esYm", Value: rt.isNull(params.esYm) ? '' : moment(params.esYm).format('YYYY-MM-DD') });
            _that.searchList.push({ Type: 1, Key: "eeYm", Value: rt.isNull(params.eeYm) ? '' : moment(params.eeYm).add('days', 1).format('YYYY-MM-DD') });
            _that.searchList.push({ Type: 1, Key: "stepCode", Value: rt.isNull(params.stepCode.id) ? 10 : params.stepCode.id });
            _that.searchList.push({ Type: 1, Key: "businessUnitIds", Value: rt.isNull($scope.vm.nodeSelected) ? "" : $scope.vm.nodeSelected.ids });
            _that.searchList.push({ Type: 1, Key: "OwnerId", Value: rt.isNull(params.OwnerId) ? '' : params.OwnerId.Id });
            _that.searchList.push({ Type: 1, Key: "searchText", Value: $scope.vm.view.searchText });
        };

        this.reload = function () {
            var waiting = rt.showLoading2();
            var params = $scope.vm.searchList;
            var ssYm = rt.isNull(params.ssYm) ? '' : moment(params.ssYm).format('YYYY-MM-DD');
            var seYm = rt.isNull(params.seYm) ? '' : moment(params.seYm).add('days', 1).format('YYYY-MM-DD');
            var esYm = rt.isNull(params.esYm) ? '' : moment(params.esYm).format('YYYY-MM-DD');
            var eeYm = rt.isNull(params.eeYm) ? '' : moment(params.eeYm).add('days', 1).format('YYYY-MM-DD');
            var stepCode = rt.isNull(params.stepCode.id) ? 10 : params.stepCode.id;
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var OwnerId = rt.isNull(params.OwnerId) ? '' : params.OwnerId.Id;

            myService.getViewData(ssYm, seYm, esYm, eeYm, stepCode, unitids, OwnerId, $scope.vm.view.searchText, rt.getPaginationSize(), $scope.vm.page.index).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.page.recordCount = resp.data.TotalRecords;
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.vm.searchList = myService.searchList = {};
        $scope.vm.stepType = [{ id: 10, name: "所有状态" }, { id: 20, name: "等待开发中" }, { id: 30, name: "开发进行中" }, { id: 40, name: "已结束开发" }];
        $scope.vm.searchList.stepCode = $scope.vm.stepType[0];
    }]).controller('developHospitalEditController', ['$injector', '$scope', 'developHospitalService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.preSave = function () {
            if (!rt.isNull($scope.vm.form.data.schedule_start_date) && !rt.isNull($scope.vm.form.data.schedule_end_date) && $scope.vm.form.data.schedule_start_date > $scope.vm.form.data.schedule_end_date) {
                rt.errorMessage('计划启动日期必须小于计划结束日期');
                return "计划启动日期必须小于计划结束日期";
            }
        };

        $scope.vm.form.loadComplete = function () {
            // 默认为当前用户
            if (rt.isNull($scope.vm.form.data.OwnerId)) {
                $scope.vm.form.data.OwnerId = {
                    Id: rt.getUserId(),
                    Name: rt.getUserName()
                };
            }
        };

        $scope.$watch("vm.form.data.product_categoryId.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.productId = null;
                return;
            }
        });

        $scope.$watch("vm.form.data.agent_customerId.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                $scope.vm.form.data.agent_contactId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/******************************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
 创建人   : Lecrean Pan
 创建时间 : 2018-3-2
 说明     : 疾病类型路由
******************************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('diseaseTypeService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DiseaseType';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('diseaseTypeListController', ['$injector', '$scope', 'diseaseTypeService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('diseaseTypeEditController', ['$injector', '$scope', 'diseaseTypeService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : SummerXu
 创建时间 : 2016-04-26
 说明     : 分销任务指标
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('distributiontaskService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'distributiontask';
        // @@ 选项集
        this.picklists = ['StateCode', 'tasklevel', 'type', 'year', 'month', 'targettype'];
    }]).controller('distributiontaskListController', ['$injector', '$scope', '$timeout', 'distributiontaskService', function ($injector, $scope, $timeout, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;

        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    return "只可查询同一年的数据";
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    return "开始日期必须小于结束日期";
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join("','");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.staskLevel)) {
                that.searchList.push({ Type: 1, Key: "tasklevel", Value: $scope.vm.staskLevel.Value });
            }
            if (!rt.isNull($scope.vm.custom_category)) {
                that.searchList.push({ Type: 1, Key: "custom_category", Value: $scope.vm.custom_category.Id });
            }
            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    return "只可查询同一年的数据";
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    return "开始日期必须小于结束日期";
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join("','");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.staskLevel)) {
                that.searchList.push({ Type: 1, Key: "tasklevel", Value: $scope.vm.staskLevel.Value });
            }
            if (!rt.isNull($scope.vm.custom_category)) {
                that.searchList.push({ Type: 1, Key: "custom_category", Value: $scope.vm.custom_category.Id });
            }
            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.showForm = _showForm;
        function _showForm() {
            var html = '<div rt-include rt-template="Module/MissionTarget/missiontargetExcelImportView.html" rt-controller="missiontargetExcelImportController" ></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '<span style="color:#09f"><i class="fa fa-download fa-2x"></i>　导出任务指标数据</span>',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_NORMAL,
                onshow: function onshow(dialog) {
                    //dialog.getModalHeader().hide();
                    //dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }
        //-新增多条件查询-CreateTime：2016-05-20-//

        $scope.vm.searchFormHide = true;
        $scope.vm.buidList = [];
        $scope.vm.buidSelected = null;
        $scope.vm.bigDepList = [];
        $scope.vm.bigDepSelected = null;
        $scope.vm.businessUnitList = [];
        $scope.vm.businessUnitSelected = [];
        $scope.vm.depType = 0;
        $scope.vm.OwnerName = "";
        $scope.vm.clickForm = function () {};
        _getAllBuid();

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }
        //-新增结束--//

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        $scope.overHeightTable = function () {
            overHeightTable();
        };
        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //-新增结束--//
    }]).controller('distributiontaskEditController', ['$injector', '$scope', 'distributiontaskService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch('vm.form.data.buid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.bigdept = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.bigdept.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.BusinessUnitId = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016-02-05
 说明     : 产品流向数据
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('drugflowService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DrugFlow';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.operatingNames = ['btnImportDrugflow_0648F78F-7BC3-43B9-B35D-1614DAE4194B', 'btnImportDrugflow_9A2D2593-F0B2-4B0D-97B8-25C6DF08BE69', 'btnImportDrugflow_5AFFD8B6-94BF-4F4B-884A-1EAC875020E6'];

        this.getSumPriceAndAmount = function (quickSearch, searchList) {
            var url = 'api/DrugFlow/GetSumPriceAndAmount?quickSearch=' + encodeURIComponent(quickSearch) + "&searchList=" + (rt.isNull(searchList) ? "" : encodeURIComponent(JSON.stringify(searchList)));
            return rt.get(url);
        };
    }]).controller('drugflowListController', ['$injector', '$scope', '$timeout', 'drugflowService', function ($injector, $scope, $timeout, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;

        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            var accids = "";
            var downaccids = "";
            var pids = "";
            var fromOwnerId = "";
            var fromAccountclassification = "";
            var toAccountclassification = "";
            var billStartDate = "";
            var billEndDate = "";
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                return "请选择开始年月.";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                return "请选择结束年月.";
            }
            if ($scope.vm.startDate.substr(0, 4) !== $scope.vm.endDate.substr(0, 4)) {
                return "只可查询同一年的数据.";
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) < 0) {
                return "开始日期必须小于结束日期";
            }
            if ($scope.vm.billStartDate > $scope.vm.billEndDate) {
                return "交易开始日期必须小于等于交易结束日期";
            }
            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join(",");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                $scope.vm.depType = 1;
                accids = $scope.vm.bigDepSelected.id;
            } else if (!rt.isNull($scope.vm.buidSelected)) {
                $scope.vm.depType = 2;
                accids = $scope.vm.buidSelected.id;
            }
            if ($scope.vm.downbusinessUnitSelected.length > 0) {
                var accmap = $scope.vm.downbusinessUnitSelected.map(function (item) {
                    return item.id;
                });
                downaccids = accmap.join(",");
                $scope.vm.downdepType = 0;
            } else if (!rt.isNull($scope.vm.downbigDepSelected)) {
                $scope.vm.downdepType = 1;
                downaccids = $scope.vm.downbigDepSelected.id;
            } else if (!rt.isNull($scope.vm.downbuidSelected)) {
                $scope.vm.downdepType = 2;
                downaccids = $scope.vm.downbuidSelected.id;
            }
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join(",");
            }
            if (!rt.isNull($scope.vm.fromOwnerId)) {
                fromOwnerId = $scope.vm.fromOwnerId.Id;
            }
            if (!rt.isNull($scope.vm.fromAccountclassificationSelected)) {
                var pmap = $scope.vm.fromAccountclassificationSelected.map(function (item) {
                    return item.Value;
                });
                fromAccountclassification = pmap.join(",");
            }
            if (!rt.isNull($scope.vm.toAccountclassificationSelected)) {
                var pmap = $scope.vm.toAccountclassificationSelected.map(function (item) {
                    return item.Value;
                });
                toAccountclassification = pmap.join(",");
            }
            if (!rt.isNull($scope.vm.billStartDate)) {
                billStartDate = $scope.vm.billStartDate;
            }
            if (!rt.isNull($scope.vm.billEndDate)) {
                billEndDate = $scope.vm.billEndDate;
            }

            that.searchList.push({
                Type: 1,
                Key: "sYm",
                Value: $scope.vm.startDate
            });
            that.searchList.push({
                Type: 1,
                Key: "eYm",
                Value: $scope.vm.endDate
            });
            that.searchList.push({
                Type: 1,
                Key: "bigdeptIds",
                Value: accids
            });
            that.searchList.push({
                Type: 1,
                Key: "depType",
                Value: $scope.vm.depType
            });
            that.searchList.push({
                Type: 1,
                Key: "downdepartIds",
                Value: downaccids
            });
            that.searchList.push({
                Type: 1,
                Key: "downdepType",
                Value: $scope.vm.downdepType
            });
            that.searchList.push({
                Type: 1,
                Key: "productIds",
                Value: pids
            });
            that.searchList.push({
                Type: 1,
                Key: "upEn",
                Value: $scope.vm.upCoName
            });
            that.searchList.push({
                Type: 1,
                Key: "downEn",
                Value: $scope.vm.downCoName
            });
            that.searchList.push({
                Type: 1,
                Key: "fromOwnerId",
                Value: fromOwnerId
            });
            that.searchList.push({
                Type: 1,
                Key: "fromAccountclassification",
                Value: fromAccountclassification
            });
            that.searchList.push({
                Type: 1,
                Key: "toAccountclassification",
                Value: toAccountclassification
            });
            that.searchList.push({
                Type: 1,
                Key: "billStartDate",
                Value: billStartDate
            });
            that.searchList.push({
                Type: 1,
                Key: "billEndDate",
                Value: billEndDate
            });
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;

            var accids = "";
            var downaccids = "";
            var pids = "";
            var billStartDate = "";
            var billEndDate = "";
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                return "请选择开始年月.";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                return "请选择结束年月.";
            }
            if ($scope.vm.startDate.substr(0, 4) !== $scope.vm.endDate.substr(0, 4)) {
                return "只可查询同一年的数据.";
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) < 0) {
                return "开始日期必须小于结束日期";
            }
            if ($scope.vm.billStartDate > $scope.vm.billEndDate) {
                return "交易开始日期必须小于等于交易结束日期";
            }
            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join(",");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                $scope.vm.depType = 1;
                accids = $scope.vm.bigDepSelected.id;
            } else if (!rt.isNull($scope.vm.buidSelected)) {
                $scope.vm.depType = 2;
                accids = $scope.vm.buidSelected.id;
            }
            if ($scope.vm.downbusinessUnitSelected.length > 0) {
                var accmap = $scope.vm.downbusinessUnitSelected.map(function (item) {
                    return item.id;
                });
                downaccids = accmap.join(",");
                $scope.vm.downdepType = 0;
            } else if (!rt.isNull($scope.vm.downbigDepSelected)) {
                $scope.vm.downdepType = 1;
                downaccids = $scope.vm.downbigDepSelected.id;
            } else if (!rt.isNull($scope.vm.downbuidSelected)) {
                $scope.vm.downdepType = 2;
                downaccids = $scope.vm.downbuidSelected.id;
            }
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join(",");
            }
            var fromOwnerId = "";
            if (!rt.isNull($scope.vm.fromOwnerId)) {
                fromOwnerId = $scope.vm.fromOwnerId.Id;
            }
            var fromAccountclassification = "";
            if (!rt.isNull($scope.vm.fromAccountclassificationSelected)) {
                var pmap = $scope.vm.fromAccountclassificationSelected.map(function (item) {
                    return item.Value;
                });
                fromAccountclassification = pmap.join(",");
            }
            var toAccountclassification = "";
            if (!rt.isNull($scope.vm.toAccountclassificationSelected)) {
                var pmap = $scope.vm.toAccountclassificationSelected.map(function (item) {
                    return item.Value;
                });
                toAccountclassification = pmap.join(",");
            }
            if (!rt.isNull($scope.vm.billStartDate)) {
                billStartDate = $scope.vm.billStartDate;
            }
            if (!rt.isNull($scope.vm.billEndDate)) {
                billEndDate = $scope.vm.billEndDate;
            }

            that.searchList.push({
                Type: 1,
                Key: "sYm",
                Value: $scope.vm.startDate
            });
            that.searchList.push({
                Type: 1,
                Key: "eYm",
                Value: $scope.vm.endDate
            });
            that.searchList.push({
                Type: 1,
                Key: "bigdeptIds",
                Value: accids
            });
            that.searchList.push({
                Type: 1,
                Key: "depType",
                Value: $scope.vm.depType
            });
            that.searchList.push({
                Type: 1,
                Key: "downdepartIds",
                Value: downaccids
            });
            that.searchList.push({
                Type: 1,
                Key: "downdepType",
                Value: $scope.vm.downdepType
            });
            that.searchList.push({
                Type: 1,
                Key: "productIds",
                Value: pids
            });
            that.searchList.push({
                Type: 1,
                Key: "upEn",
                Value: $scope.vm.upCoName
            });
            that.searchList.push({
                Type: 1,
                Key: "downEn",
                Value: $scope.vm.downCoName
            });
            that.searchList.push({
                Type: 1,
                Key: "fromOwnerId",
                Value: fromOwnerId
            });
            that.searchList.push({
                Type: 1,
                Key: "fromAccountclassification",
                Value: fromAccountclassification
            });
            that.searchList.push({
                Type: 1,
                Key: "toAccountclassification",
                Value: toAccountclassification
            });
            that.searchList.push({
                Type: 1,
                Key: "billStartDate",
                Value: billStartDate
            });
            that.searchList.push({
                Type: 1,
                Key: "billEndDate",
                Value: billEndDate
            });
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.showForm = _showForm;
        $scope.showExpForm = _showExpForm;
        //--新增开始 CreateTime:2016 -05 13
        $scope.dataForm = [];
        $scope.vm.buidList = [{
            name: "-请选择-",
            id: ""
        }];
        $scope.vm.bigDepList = [];
        $scope.vm.businessUnitList = [];
        $scope.vm.buidSelected = null;
        $scope.vm.bigDepSelected = null;
        $scope.vm.businessUnitSelected = [];
        $scope.vm.downbuidList = [{
            name: "-请选择-",
            id: ""
        }];
        $scope.vm.downbigDepList = [];
        $scope.vm.downbusinessUnitList = [];
        $scope.vm.downbuidSelected = null;
        $scope.vm.downbigDepSelected = null;
        $scope.vm.downbusinessUnitSelected = [];
        $scope.vm.upCoName = "";
        $scope.vm.downCoName = "";
        $scope.vm.depType = 0;
        $scope.vm.downdepType = 0;
        $scope.vm.searchFormHide = true;
        $scope.vm.clickForm = function () {
            _FormShow();
        };
        _getAllBuid();
        _initYmSelected();
        _getAccountClassificationCode();

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.startDate = d.getFullYear() + "-" + '01';
            $scope.vm.endDate = moment().format('YYYY-MM');
        }
        //--新增结束

        $scope.vm.actions.loadComplete = function () {
            $scope.vm.pagePriceSum = 0; // 每页金额总计
            $scope.vm.pageAmountSum = 0; // 每页销量总计
            $scope.vm.data.forEach(function (item) {
                $scope.vm.pagePriceSum += item.saleto_total_price;
                $scope.vm.pageAmountSum += item.saleto_count;
            });
            $scope.vm.totalPriceSum = 0; // 金额总计
            $scope.vm.totalAmountSum = 0; // 销量总计
            myService.getSumPriceAndAmount($scope.vm.view.searchText, $scope.vm.view.searchList).then(function (resp) {
                if (!rt.isNull(resp)) {
                    $scope.vm.totalPriceSum = resp.data.totalPrice.toFixed(4);
                    $scope.vm.totalAmountSum = resp.data.totalAmount;
                }
            });
        };

        $scope.overHeightTable = function () {
            overHeightTable();
        };

        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }

        function _showForm() {
            var html = '<div rt-include rt-template="Module/DrugFlow/drugflowExcelImportView.html" rt-controller="drugflowExcelImportController" ></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '<span style="color:#09f"><i class="fa fa-upload fa-2x"></i>　导入产品流向数据</span>',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_NORMAL,
                modal: false,
                onshow: function onshow(dialog) {
                    //dialog.getModalHeader().hide();
                    //dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }
        //导出excel表格数据
        function _showExpForm() {
            var html = '<div rt-include rt-template="Module/DrugFlow/drugflowExcelExportView.html" rt-controller="drugflowExcelExportController" ></div>';
            $scope.vm.expdialog = BootstrapDialog.show({
                title: '<span style="color:#09f"><i class="fa fa-download fa-2x"></i>　导出产品流向数据</span>',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_NORMAL,
                onshow: function onshow(dialog) {
                    //dialog.getModalHeader().hide();
                    //dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }
        //重写import方法
        $scope.vm.actions.import = function (headerMap, importType) {
            $scope.importHeader = headerMap;
            $scope.importType = importType;
            BootstrapDialog.show({
                type: BootstrapDialog.TYPE_PRIMARY,
                title: '导入' + $scope.importHeader.Title,
                message: '<div rt-include rt-template="Module/DrugFlow/drugflowExcelImportView.html" rt-controller="drugflowExcelImportController" ></div>',
                size: BootstrapDialog.SIZE_NORMAL,
                closable: true,
                onshow: function onshow(dialog) {
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        function _FormShow() {
            if ($scope.vm.searchFormHide) {
                $scope.vm.searchFormHide = false;
            } else {
                $scope.vm.searchFormHide = true;
            }
        }

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        //获取企业类型
        function _getAccountClassificationCode() {
            var url = 'api/SystemParam/GetSystemParamByCode?code=accountclassificationcode';
            return rt.get(url).then(function (resp) {
                $scope.vm.fromAccountclassificationList = resp.data;
                $scope.vm.toAccountclassificationList = resp.data;

                $scope.vm.fromAccountclassificationSelected = null;
                $scope.vm.toAccountclassificationSelected = null;
            });
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", {
                '@queryValue': ''
            }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.downbuidList = data;
                }
            }, function (error) {});
        }
        //获取上游商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.buidSelected ? $scope.vm.buidSelected.id : ''
                }, function (resp) {
                    $scope.vm.bigDepList = [{
                        name: "-请选择-",
                        id: ""
                    }];
                    //$scope.vm.bigDepSelected = { name: "", id: "" };
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    } else {
                        $scope.vm.bigDepList = [];
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取上游省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected ? $scope.vm.bigDepSelected.id : ''
                }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    } else {
                        $scope.vm.businessUnitList = [];
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取下游商业大区
        $scope.$watch("vm.downbuidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.downbuidSelected) || rt.isNullOrWhiteSpace($scope.vm.downbuidSelected.id)) {
                $scope.vm.downbigDepList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.downbuidSelected ? $scope.vm.downbuidSelected.id : ''
                }, function (resp) {
                    $scope.vm.downbigDepList = [{
                        name: "-请选择-",
                        id: ""
                    }];

                    $scope.vm.downbusinessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.downbigDepList = data;
                    } else {
                        $scope.vm.downbigDepList = [];
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.downbigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取下游省区/地区
        $scope.$watch("vm.downbigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.downbusinessUnitSelected = [];
                $scope.vm.downbusinessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.downbigDepSelected ? $scope.vm.downbigDepSelected.id : ''
                }, function (resp) {
                    $scope.vm.downbusinessUnitSelected = [];
                    $scope.vm.downbusinessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.downbusinessUnitList = data;
                    } else {
                        $scope.vm.downbusinessUnitList = [];
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.downbusinessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //--新增结束
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2017-05-12
 说明     : 流向数据确认
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('drugflowconfirmService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'drugflow';

        // @@ 选项集
        this.picklists = ['ddm_data_status'];
    }]).controller('drugflowconfirmListController', ['$injector', '$scope', 'drugflowconfirmService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;
        var that = this;
        this.searchList = [];

        this.preSearch = function (params) {
            if (rt.isNull($scope.vm.startDate)) {
                return "请选择年月";
            }
        };

        this.preExport = function () {
            if (rt.isNull($scope.vm.startDate)) {
                return "请选择年月";
            } else {
                that.searchList.push({ Type: 1, Key: "year", Value: moment($scope.vm.startDate).year() });
                that.searchList.push({ Type: 1, Key: "month", Value: moment($scope.vm.startDate).month() + 1 });
            }
        };

        this.reload = function _loadData(pageIndex) {
            if (pageIndex && typeof pageIndex === 'number') $scope.vm.page.index = pageIndex;

            var preSearchMessage = $scope.vm.actions.preSearch();
            if (!rt.isNull(preSearchMessage) && preSearchMessage.length > 0) {
                rt.errorMessage(preSearchMessage);
                return;
            }

            var queryMonth = moment($scope.vm.startDate);
            var url = "api/DrugFlow/GetDrugFlowPendingApproval?year=" + queryMonth.year() + "&month=" + (queryMonth.month() + 1) + "&toBusinessUnitId=" + (rt.isNull($scope.vm.toBuSelected) ? "" : encodeURIComponent($scope.vm.toBuSelected.Id)) + "&toOwnerId=" + (rt.isNull($scope.vm.toOwnerId) ? "" : encodeURIComponent($scope.vm.toOwnerId.Id)) + "&pageSize=" + rt.getPaginationSize() + "&pageIndex=" + $scope.vm.page.index + "&ddm_data_status=" + $scope.vm.selectedCheck.Value;
            return rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.page.recordCount = resp.data.TotalRecords;
            }).then($scope.vm.actions.loadComplete);
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.startDate = moment().add('month', -1);

        //筛选模式
        $scope.vm.CheckList = [{ Name: '待确认', Value: 2 }, { Name: '已确认生效', Value: 3 }];

        $scope.vm.selectedCheck = $scope.vm.CheckList[0];

        $scope.$watch('vm.toBuSelected.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.toOwnerId = null;
                return;
            }
        });
        //审核数据
        $scope.vm.actions.approve = function () {
            if ($scope.vm.selectedCheck.Value !== 2) {
                rt.errorMessage("请筛选'待确认'的流向数据进行审核！");
                return;
            }
            var preSearchMessage = $scope.vm.actions.preSearch();
            if (!rt.isNull(preSearchMessage) && preSearchMessage.length > 0) {
                rt.errorMessage(preSearchMessage);
                return;
            }
            if (!confirm("是否以筛选的数据为准审核通过？")) {
                return;
            }

            var queryMonth = moment($scope.vm.startDate);

            var url = "api/DrugFlow/ApproveDrugFlow?year=" + queryMonth.year() + "&month=" + (queryMonth.month() + 1) + "&toBusinessUnitId=" + (rt.isNull($scope.vm.toBuSelected) ? "" : encodeURIComponent($scope.vm.toBuSelected.Id)) + "&toOwnerId=" + (rt.isNull($scope.vm.toOwnerId) ? "" : encodeURIComponent($scope.vm.toOwnerId.Id));
            var waiting = rt.showWaiting();
            return rt.post(url).success(function () {
                rt.successMessage("审核数据成功！");
                $scope.vm.view.search();
            }).error(function () {
                rt.errorMessage("审核数据失败！");
            }).finally(function () {
                waiting.close();
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2018-01-12
 说明     : 流向数据-导入锁定
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('drugFlowImportLockService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DrugFlowImportLock';

        // @@ 选项集
        this.picklists = ['StateCode', 'lock_type'];
    }]).controller('drugFlowImportLockListController', ['$injector', '$compile', '$scope', 'drugFlowImportLockService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('drugFlowImportLockEditController', ['$injector', '$scope', 'drugFlowImportLockService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.loadComplete = function () {
            if (!rt.isNull($scope.vm.form.data) && !rt.isNull($scope.vm.form.data.lock_year) && !rt.isNull($scope.vm.form.data.lock_month)) {
                $scope.vm.ym = moment().set({
                    'year': $scope.vm.form.data.lock_year,
                    'month': $scope.vm.form.data.lock_month
                }).add(-1, 'month');
            }
        };

        $scope.vm.form.preSave = function () {
            $scope.vm.form.data.lock_year = moment($scope.vm.ym).year();
            $scope.vm.form.data.lock_month = moment($scope.vm.ym).month() + 1;
            $scope.vm.form.data.lock_year_month = moment($scope.vm.ym).year() * 100 + moment($scope.vm.ym).month() + 1;
        };

        $scope.vm.form.newsave = function () {
            $scope.vm.form.save(true);
            $scope.vm.ym = null;
        };

        $scope.$watch('vm.form.data.lock_type.Value', function (newValue, oldValue) {
            if (newValue === '10') {
                $scope.vm.form.data.lock_businessunitid = "";
                $scope.vm.form.data.lock_accountid = "";
            } else if (newValue === '20') {
                $scope.vm.form.data.lock_accountid = "";
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-01-18
 说明     : 考试
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('ExamService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'Exam';

        // @@ 选项集
        this.picklists = ['Action_status'];
    }]).controller('examListController', ['$scope', 'ExamService', entityListController]).controller('examEditController', ['$injector', '$scope', 'ExamService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.data.DetailList = {};

        // 数据加载后设置总分和及格分数的默认值
        $scope.vm.form.loadComplete = function () {
            if ($scope.vm.form.data.exam_Score === undefined) {
                $scope.vm.form.data.exam_Score = 100;
            }
            if ($scope.vm.form.data.exam_PassScore === undefined) {
                $scope.vm.form.data.exam_PassScore = 60;
            }
            if ($scope.vm.form.data.Qustion_Count === undefined) {
                $scope.vm.form.data.Qustion_Count = 1;
            }
        };

        //检查条件
        function checkOption() {
            var nowdate = moment().format('YYYY-MM-DD');
            if (rt.isNullOrWhiteSpace($scope.vm.form.data.exam_starttime)) {
                return "请选择开始日期";
            } else if (rt.isNullOrWhiteSpace($scope.vm.form.data.exam_endtime)) {
                return "请选择结束日期";
            } else if ($scope.vm.form.data.exam_endtime < nowdate) {
                return "结束日期不能小于当前日期";
            } else if ($scope.vm.form.data.exam_starttime > $scope.vm.form.data.exam_endtime) {
                return "开始日期不能大于结束日期";
            } else if ($scope.vm.form.data.exam_Score < $scope.vm.form.data.exam_PassScore) {
                return "及格分数不能大于总分数";
            } else {
                return "";
            }
        }

        //保存和保存并新建按钮
        $scope.rsave = function (flag) {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            } else {
                if ($scope.vm.form.data.Qustion_Count != undefined && $scope.vm.form.data.Qustion_Count != 0) {
                    $scope.vm.form.data.question_Score = $scope.vm.form.data.exam_Score / $scope.vm.form.data.Qustion_Count;
                }
                $scope.vm.form.save(flag);
            }
        };

        //添加考试题目
        // $scope.addDetail = function () {
        //     $scope.vm.form.data.Qustion_Count = "";
        //     $scope.vm.form.data.DetailList.push(
        //         {
        //             Id: rt.newGuid(),
        //             Score: $scope.vm.form.data.question_Score
        //         }
        //     );
        //     $scope.vm.form.data.Qustion_Count = $scope.vm.form.data.DetailList.length;
        // };

        //删除考试题目
        // $scope.del = function () {
        //     var idlist = _.map($scope.vm.form.data.DetailList, 'Id');
        //     var j = 0;
        //     rt.post("api/ExamQuestion/DeleteList", $scope.vm.view.selectedIds).then(function (resp) {
        //         $scope.vm.form.data.DetailList = _.remove($scope.vm.form.data.DetailList, function (item) {
        //             if ($scope.vm.view.selectedIds[j] != item.Id) {
        //                 return item;
        //             }
        //             j++;
        //         });
        //     });
        //     $scope.vm.form.data.Qustion_Count = $scope.vm.form.data.DetailList.length - $scope.vm.view.selectedIds.length;
        // };

        //添加参与人
        $scope.addDetailSystemuser = function () {
            $scope.vm.form.data.uDetailList.push({
                Id: rt.newGuid(),
                nameid: ""
            });
        };

        //删除参与人
        $scope.delSystemuser = function () {
            var idlist = _.map($scope.vm.form.data.uDetailList, 'Id');
            var j = 0;
            rt.post("api/ExamSystemuser/DeleteList", $scope.vm.view.selectedIdsSystemuser).then(function (resp) {
                $scope.vm.form.data.uDetailList = _.remove($scope.vm.form.data.uDetailList, function (item) {
                    if ($scope.vm.view.selectedIdsSystemuser[j] != item.Id) {
                        return item;
                    }
                    j++;
                });
            });
        };

        //是否可以发布
        $scope.isrelease = function (exammodel) {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            } else {
                if ($scope.vm.form.data.uDetailList.length != 0) {
                    $scope.vm.form.save(false).then(function () {
                        var waiting = rt.showWaiting();
                        rt.post("api/Exam/Release", exammodel).then(function () {
                            $scope.$emit('rt-reload');
                            $scope.$broadcast('rt-reload');
                            rt.successMessage("发布成功！");
                        }).finally(function () {
                            waiting.close();
                        });
                    });
                } else {
                    rt.errorMessage("请至少设置一个考试参与部门！");
                }
            }
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-8
 说明     :PC端医院协访
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('HospitalAssistanceService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'HospitalAssistance';
        // @@ 选项集
        this.picklists = ['StateCode'];
        //检查账号是否是医院
    }]).controller('hospitalAssistanceListController', ['$scope', 'HospitalAssistanceService', entityListController]).controller('hospitalAssistanceEditController', ['$injector', '$scope', 'HospitalAssistanceService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.loadComplete = function () {
            if ($scope.vm.form.data.assistanceList == null) {
                $scope.vm.form.data.assistanceList = [{
                    visit_recordId: '',
                    OwnerId: { Id: '', Name: '' },
                    visit_assistanceId: ''
                }];
            }
        };

        $scope.vm.form.preSave = function () {
            if ($scope.vm.form.data.is_assist) {
                for (var i = 0; i < $scope.vm.form.data.assistanceList.length; i++) {
                    if ($scope.vm.form.data.assistanceList[i].visit_assistanceId == null || $scope.vm.form.data.assistanceList[i].visit_assistanceId == '') {
                        $scope.vm.form.data.assistanceList[i].visit_assistanceId = rt.newGuid();
                    }
                    $scope.vm.form.data.assistanceList[i].visit_recordId = { Id: $scope.vm.form.data.Id };
                }
            }
        };
    }]);
})();
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/3/24
 *说明：文件描述...
 *************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('hospitalcontactService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'HospitalContact'; //后台api地址
        this.stateName = "hospitalcontact"; //路由名称
        // @@ 选项集
        this.picklists = ['StateCode', 'jobtitle', 'preferredcontactmethod', 'gendercode', 'familystatuscode', 'contact_level', 'bachelor', "rx_potential", "rx_attitude"];
    }])
    /*.controller('hospitalcontactListController', ['$scope','hospitalcontactService', entityListController])*/
    .controller('hospitalcontactListController', ['$injector', '$compile', '$scope', 'hospitalcontactService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        $scope.viewTag = "Web";
        this.viewTag = "Web";
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('hospitalcontactEditController', ['$injector', '$scope', 'hospitalcontactService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.preSave = function () {
            if (!isCardNo($scope.vm.form.data.idcard) && !rt.isNullOrWhiteSpace($scope.vm.form.data.idcard)) {
                rt.errorMessage("请输入正确的身份证号");
                return "请输入正确的身份证号";
            }
        };

        function isCardNo(card) {
            // 身份证号码为15位或者18位，15位时全为数字，18位前17位为数字，最后一位是校验位，可能为数字或字符X 
            var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
            return reg.test(card);
        }

        $scope.$watch('vm.form.data.accountid', function (newValue, oldValue) {
            if (oldValue != newValue && $scope.vm.form.type === 'Create') {
                if (!rt.isNull($scope.vm.form.data.accountid)) {
                    var id = $scope.vm.form.data.accountid.Id;
                    var waiting = rt.showLoading2();
                    var url = 'api/AccountContact/GetContactBusinessUnit?id=' + id;
                    rt.get(url).then(function (resp) {
                        var data = resp.data[0];
                        if (data) {
                            $scope.vm.form.data.BusinessUnitId = {
                                Id: data.BusinessUnitId,
                                Name: data.BusinessUnitIdName
                            };
                            $scope.vm.form.data.OwnerId = {
                                Id: data.OwnerId,
                                Name: data.OwnerIdName
                            };
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                    var url2 = 'api/Department/GetCodeById?id=' + id;
                    rt.get(url2).then(function (resp) {
                        $scope.vm.form.data.accountnumber = resp.data;
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                    var url3 = 'api/accountcontact/GetContactProvince?id=' + id;
                    rt.get(url3).then(function (resp) {
                        $scope.vm.form.data.provinceid = {
                            Id: resp.data.Id,
                            Name: resp.data.Name
                        };
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        vm.isLoading = false;
                    });
                }
            }
        });

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });
        //修改业务部门 业务负责人清空
        $scope.$watch("vm.form.data.BusinessUnitId.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orangehong
 创建时间 : 2017-02-24
 说明     : 省份-医院终端-数量
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('HospitalmarketcapacityService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'HospitalMarketCapacity';

        // @@ 选项集
        this.picklists = ['account_grade'];
    }]).controller('hospitalmarketcapacityListController', ['$injector', '$scope', 'HospitalmarketcapacityService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.calculate = function () {
            var waiting = rt.showWaiting();
            var url = 'api/HospitalMarketCapacity/CalculateMarketCapacity';
            return rt.post(url).then(function () {
                $scope.vm.view.search();
                waiting.close();
            });
        };
    }]).controller('hospitalmarketcapacityEditController', ['$injector', '$scope', 'HospitalmarketcapacityService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : SummerXu
 创建时间 : 2016-04-26
 说明     : 医院纯销任务指标
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('hospitalsaletaskService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'hospitalsaletask';
        // @@ 选项集
        this.picklists = ['StateCode', 'tasklevel', 'type', 'year', 'month'];
        this.getTerminalCode = function (id) {
            var url = "api/Account/GetDataById?id=" + id;
            return rt.get(url);
        };
    }]).controller('hospitalsaletaskListController', ['$injector', '$scope', '$timeout', 'hospitalsaletaskService', function ($injector, $scope, $timeout, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;

        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            var accids = "";
            var staskLevel = 0;
            var category = "";
            var tabSelectId = $scope.vm.view.selectedView.Id;
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    rt.errorMessage("只可查询同一年的数据");
                    return false;
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    rt.errorMessage("开始日期必须小于结束日期");
                    return false;
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if (!rt.isNull($scope.vm.ClientName) && $scope.vm.ClientName != "") {
                that.searchList.push({ Type: 0, Key: "hospitalName", Value: $scope.vm.ClientName });
            }
            if (!rt.isNull($scope.vm.staskLevel)) {
                that.searchList.push({ Type: 1, Key: "tasklevel", Value: $scope.vm.staskLevel.Value });
            }
            if (!rt.isNull($scope.vm.custom_category)) {
                that.searchList.push({ Type: 1, Key: "custom_category", Value: $scope.vm.custom_category.Id });
            }
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }

            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            var accids = "";
            var staskLevel = 0;
            var category = "";
            var tabSelectId = $scope.vm.view.selectedView.Id;
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    rt.errorMessage("只可查询同一年的数据");
                    return false;
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    rt.errorMessage("开始日期必须小于结束日期");
                    return false;
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if (!rt.isNull($scope.vm.ClientName) && $scope.vm.ClientName != "") {
                that.searchList.push({ Type: 0, Key: "hospitalName", Value: $scope.vm.ClientName });
            }
            if (!rt.isNull($scope.vm.staskLevel)) {
                that.searchList.push({ Type: 1, Key: "tasklevel", Value: $scope.vm.staskLevel.Value });
            }
            if (!rt.isNull($scope.vm.custom_category)) {
                that.searchList.push({ Type: 1, Key: "custom_category", Value: $scope.vm.custom_category.Id });
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }

            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        //-新增多条件查询-CreateTime：2016-05-20-//

        $scope.vm.searchFormHide = true;
        $scope.vm.buidList = [];
        $scope.vm.buidSelected = null;
        $scope.vm.bigDepList = [];
        $scope.vm.bigDepSelected = null;
        $scope.vm.businessUnitList = [];
        $scope.vm.businessUnitSelected = [];
        $scope.vm.depType = 0;
        $scope.vm.OwnerName = "";
        $scope.vm.ClientName = "";

        _getAllBuid();

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }
        //-新增结束--//

        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }

        $scope.overHeightTable = function () {
            overHeightTable();
        };
        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });

        //-新增结束--//

        //同步部门指标  选定范围内的代表来同步部门指标
        $scope.SyncMissionTask = function () {
            BootstrapDialog.show({
                type: BootstrapDialog.TYPE_PRIMARY,
                title: '同步部门指标',
                message: '<div rt-include rt-template="Module/HospitalSaleTask/syncTask.html" rt-controller="syncTaskController" ></div>',
                size: BootstrapDialog.SIZE_NORMAL,
                closable: true,
                onshow: function onshow(dialog) {
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
    }]).controller('hospitalsaletaskEditController', ['$injector', '$scope', 'hospitalsaletaskService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch('vm.form.data.buid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.bigdept = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.bigdept.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.BusinessUnitId = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.hospital.Id', function (newValue, oldValue) {
            if (oldValue != newValue) {
                myService.getTerminalCode($scope.vm.form.data.hospital.Id).then(function (resp) {
                    $scope.vm.form.data.accountnumber = resp.data.accountnumber;
                });
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-6
 说明     :PC端医院拜访
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('HospitalVisitService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'HospitalVisit';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getAttachmentList = function (id) {
            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
        //获取医院的拜访目的
        this.gethospitalVisitPurpose = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=hospital_visit_purpose";
            return rt.get(url);
        };
    }]).controller('hospitalvisitListController', ['$scope', 'HospitalVisitService', entityListController]).controller('hospitalvisitEditController', ['$injector', '$scope', 'HospitalVisitService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        var waiting = rt.showLoading2();
        $q.all([myService.gethospitalVisitPurpose()]).then(function (resp) {
            $scope._visitpurpose = resp[0].data;
        }).catch(function (err) {
            rt.errorMessage(err);
        }).finally(function () {
            waiting.close();
        });

        function _getAllOwner() {
            rt.queryData("UserInfo.GetAllUser", { '@queryValue': '' }, function (resp) {
                $scope.OwnerList = [];
                var data = resp.DataList;
                for (var i = 0; i < data.length; i++) {
                    $scope.OwnerList.push({ Id: data[i].id, Name: data[i].name });
                }
            }, function (error) {});
        }

        $scope.vm.form.preLoad = function (data) {
            //获取所有代表
            _getAllOwner();
            if ($scope.vm.form.type === 'Edit') {
                myService.getAttachmentList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.attachmentList = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }
        };

        $scope.$watch("vm.form.data.accountid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.departid = null;
                return;
            }
        });

        $scope.$watch("vm.form.data.departid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.contactid = null;
                return;
            }
        });
        $scope.vm.form.loadComplete = function () {
            var newassList = [];
            if ($scope.vm.form.data.assistanceList != null) {
                angular.forEach($scope.vm.form.data.assistanceList, function (entity) {
                    newassList.push({ Id: entity.OwnerId.Id, Name: entity.OwnerIdName });
                });
                $scope.vm.form.data.assistanceList = newassList;
            }
        };

        $scope.vm.form.preSave = function () {
            $scope.vm.form.data.visitpurposes = JSON.stringify($scope.vm.form.data.VisitPurpose);
            var assistanceList = $scope.vm.form.data.assistanceList;
            if ($scope.vm.form.data.is_assist) {
                for (var i = 0; i < assistanceList.length; i++) {
                    if (assistanceList.visit_assistanceId == null || assistanceList.visit_assistanceId == '') {
                        $scope.vm.form.data.assistanceList[i].visit_assistanceId = rt.newGuid();
                        $scope.vm.form.data.assistanceList[i].OwnerId = {
                            Id: assistanceList[i].Id,
                            Name: assistanceList[i].Name
                        };
                        $scope.vm.form.data.assistanceList[i].Id = assistanceList[i].visit_assistanceId;
                    }
                    $scope.vm.form.data.assistanceList[i].visit_recordId = { Id: $scope.vm.form.data.Id };
                }
            }
        };
        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("hospital_visit", fileId);
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : oscar
 创建时间 : 2017-05-18
 说明     : 医院协访计划维护
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('HospitalVisitAssistPlanService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'HospitalVisitAssistPlan';

        // @@ 选项集
        this.picklists = ['visit_purpose', 'hospital_visit_purpose', 'StateCode'];

        this.savePlan = function (visit_recordId, accountId, accountName, departid, departidName, contactid, contactidName, visitPurpose, planTime, visiterId) {
            var url = "api/HospitalVisitAssistPlan/savePlan?visit_recordId=" + visit_recordId + "&accountId=" + accountId + "&accountName=" + accountName + "&departid=" + departid + "&departidName=" + departidName + "&contactid=" + contactid + "&contactidName=" + contactidName + "&visitPurpose=" + visitPurpose + "&planTime=" + planTime + "&visiterId=" + visiterId;
            return rt.post(url);
        };

        this.deletePlan = function (visit_recordId) {
            var url = "api/HospitalVisitAssistPlan/deletePlan?visit_recordId=" + visit_recordId;
            return rt.get(url);
        };
        //获取医院的拜访目的
        this.gethospitalVisitPurpose = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=hospital_visit_purpose";
            return rt.get(url);
        };

        //获取医院的等级
        this.gethospitalLevel = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=account_level";
            return rt.get(url);
        };

        this.getDbDateTime = function () {
            var apiUrl = "api/VisitRecord/GetDbDateTime";
            return rt.get(apiUrl);
        };
    }]).controller('hospitalVisitAssistPlanListController', ['$injector', '$scope', 'HospitalVisitAssistPlanService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.visitStatusPickList = [{ Value: 0, Name: '不根据实际拜访情况过滤' }, { Value: 1, Name: '上周未拜访的医院' }, { Value: 2, Name: '本周未拜访的医院' }, { Value: 3, Name: '本月未拜访的的医院' }, { Value: 4, Name: '上月未拜访的医院' }, { Value: 5, Name: '自定义时间段' }];
        $scope.vm.visitStatus = $scope.vm.visitStatusPickList[0];
        $scope.vm.startTime = '';
        $scope.vm.endTime = '';
        _gethospitalLevel();

        $scope.vm.planData = [];
        $scope.vm.showData = [];
        $scope.vm.isShow = false;
        $scope.vm.showTimeFilterInput = false;
        //获取所有拜访人
        //_getAllOwner();

        //初始化医院
        function _getHospitalList() {
            var waiting = rt.showLoading2();
            var url = 'api/HospitalVisitAssistPlan/GetHospitalList?accountGrade=' + $scope.vm.account_grade_level.Value + "&visitStatus=" + $scope.vm.visitStatus.Value + "&startTime=" + $scope.vm.startTime + "&endTime=" + $scope.vm.endTime + "&accountId=" + ($scope.vm.accountId ? $scope.vm.accountId.Id : '') + "&contactId=" + ($scope.vm.contactId ? $scope.vm.contactId.Id : '') + "&visiterId=" + ($scope.vm.visiterId ? $scope.vm.visiterId.Id : '');
            return rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data;
                angular.forEach($scope.vm.data, function (data) {
                    if (rt.isNull(data.VisitPurpose)) {
                        data.VisitPurpose = [];
                    }
                });
                // _getHospitalVisitPurpose();
                waiting.close();
            });
        }

        //获取医院等级
        function _gethospitalLevel() {
            $q.all([myService.gethospitalLevel(), myService.getDbDateTime()]).then(function (resp) {
                $scope.vm.account_grade_levelPickList = resp[0].data;
                $scope.vm.account_grade_levelPickList.unshift({ Value: 0, Name: "所有" }); //在数组开头增加所有级别医院
                if ($scope.vm.account_grade_levelPickList.length > 0) {
                    $scope.vm.account_grade_level = $scope.vm.account_grade_levelPickList[0];
                    _getHospitalList();
                }
                $scope.vm.tomorrow = moment(resp[1].data, 'YYYY-MM-DD').add('days', 1).toDate();
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }

        $scope.vm.actions.isAllowFilter = function () {
            if ($scope.vm.visitStatus.Value !== 5) {
                $scope.vm.actions.filterRetailList();
            } else {
                $scope.vm.showTimeFilterInput = true;
            }
        };

        $scope.vm.actions.filterRetailList = function () {
            if ($scope.vm.visitStatus.Value == 5 && rt.isNullOrWhiteSpace($scope.vm.startTime)) {
                rt.errorMessage("请输入开始时间");
                return "请输入开始时间";
            }

            if ($scope.vm.visitStatus.Value == 5 && rt.isNullOrWhiteSpace($scope.vm.endTime)) {
                rt.errorMessage("请输入结束时间");
                return "请输入结束时间";
            }

            if ($scope.vm.startTime > $scope.vm.endTime) {
                rt.errorMessage("开始时间必须小于结束时间");
                return "开始时间必须小于结束时间";
            }

            var waiting = rt.showLoading2();
            var url = 'api/HospitalVisitAssistPlan/GetHospitalList?accountGrade=' + $scope.vm.account_grade_level.Value + "&visitStatus=" + $scope.vm.visitStatus.Value + "&startTime=" + moment($scope.vm.startTime).format('YYYY-MM-DD') + "&endTime=" + moment($scope.vm.endTime).add('days', 1).format('YYYY-MM-DD') + "&accountId=" + ($scope.vm.accountId ? $scope.vm.accountId.Id : '') + "&contactId=" + ($scope.vm.contactId ? $scope.vm.contactId.Id : '') + "&visiterId=" + ($scope.vm.visiterId ? $scope.vm.visiterId.Id : '');
            return rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data;
                waiting.close();
            });
        };

        $scope.vm.actions.savePlan = function () {
            angular.forEach($scope.vm.data, function (data) {
                if (rt.isNull(data.VisitPurpose)) {
                    data.VisitPurpose = [];
                }
            });
            $scope.vm.planData = [];
            //医院为空
            if ($scope.vm.data.length == 0) {
                return;
            }
            var msg = '';
            var haveFullData = false;
            angular.forEach($scope.vm.data, function (data) {
                if (!rt.isNullOrWhiteSpace(data.planTime) && data.VisitPurpose.length > 0 && !(rt.isNull(data.visiter) || rt.isNullOrWhiteSpace(data.visiter.Id))) {
                    if (moment(data.planTime).toDate() < $scope.vm.tomorrow) {
                        msg += data.name + "的计划时间必须大于今日    ";
                    } else {
                        haveFullData = true;
                    }
                } else if (rt.isNullOrWhiteSpace(data.planTime) && data.VisitPurpose.length == 0 && (rt.isNull(data.visiter) || rt.isNullOrWhiteSpace(data.visiter.Id))) {} else {
                    if (rt.isNullOrWhiteSpace(data.planTime)) {
                        msg += data.name + "的计划时间不能为空    ";
                    }
                    if (rt.isNull(data.VisitPurpose) || data.VisitPurpose.length == 0) {
                        msg += data.name + "的拜访目的不能为空     ";
                    }
                    if (rt.isNull(data.visiter) || rt.isNullOrWhiteSpace(data.visiter.Id)) {
                        msg += data.name + "的销售代表不能为空     ";
                    }
                }
            });
            if (!haveFullData) {
                if (!rt.isNullOrWhiteSpace(msg) || msg != '') {
                    return rt.errorMessage(msg);
                }
            }
            for (var i = 0; i < $scope.vm.data.length; i++) {
                if (!rt.isNullOrWhiteSpace($scope.vm.data[i].planTime) && $scope.vm.data[i].VisitPurpose.length > 0 && !(rt.isNull($scope.vm.data[i].visiter) || rt.isNullOrWhiteSpace($scope.vm.data[i].visiter.Id))) {
                    $scope.vm.planData.push($scope.vm.data[i]);
                    $scope.vm.data.splice(i, 1);
                    i = i - 1;
                }
            }

            //计划时间全为空
            if ($scope.vm.planData.length == 0) {
                rt.errorMessage("计划全部为空，不能生成计划");
                return;
            }

            var waiting = rt.showWaiting();

            for (var j = 0, len2 = $scope.vm.planData.length; j < len2; j++) {
                $scope.vm.planData[j].newVisit_recordId = rt.newGuid();
                myService.savePlan($scope.vm.planData[j].newVisit_recordId, $scope.vm.planData[j].accountId, $scope.vm.planData[j].name, $scope.vm.planData[j].departmentid, $scope.vm.planData[j].departmentidName, $scope.vm.planData[j].contactid, $scope.vm.planData[j].doctor, $scope.vm.planData[j].visitpurposes = JSON.stringify($scope.vm.planData[j].VisitPurpose), $scope.vm.planData[j].planTime, JSON.stringify($scope.vm.planData[j].visiter)).then(function (resp) {});
                $scope.vm.showData.push($scope.vm.planData[j]);
            }
            $scope.vm.planData = [];
            rt.successMessage("生成成功");
            waiting.close();
            $scope.vm.isShow = true;
        };

        $scope.vm.actions.deletePlan = function (row, index) {
            myService.deletePlan(row.newVisit_recordId);
            $scope.vm.data.unshift(row);
            $scope.vm.showData.splice(index, 1);
        };
    }]).controller('hospitalVisitAssistPlanEditController', ['$injector', '$scope', 'HospitalVisitAssistPlanService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        function _getAllOwner() {
            rt.queryData("UserInfo.GetAllUser", { '@queryValue': '' }, function (resp) {
                $scope.OwnerList = [];
                var data = resp.DataList;
                for (var i = 0; i < data.length; i++) {
                    $scope.OwnerList.push({ Id: data[i].id, Name: data[i].name });
                }
            }, function (error) {});
        }

        $scope.vm.form.preLoad = function (data) {
            //获取所有代表
            _getAllOwner();
            if ($scope.vm.form.type === 'Edit') {
                myService.getAttachmentList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.attachmentList = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }
        };

        $scope.$watch("vm.form.data.accountid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                var accType = "";
                myService.GetAccountTypeById(newValue).then(function (resp) {
                    switch (resp.data) {
                        case 1:
                            accType = "business_visit_purpose";
                            $scope.vm.form.data.visit_type = { Value: 10, Name: "商业拜访" };
                            break;
                        case 2:
                            accType = "hospital_visit_purpose";
                            $scope.vm.form.data.visit_type = { Value: 20, Name: "医院拜访" };
                            break;
                        case 3:
                            accType = "retail_visit_purpose";
                            $scope.vm.form.data.visit_type = { Value: 30, Name: "零售终端拜访" };
                            break;
                        case 4:
                            accType = "thirdterminal_visit_purpose";
                            $scope.vm.form.data.visit_type = { Value: 40, Name: "基层医疗拜访" };
                            break;
                        case 5:
                            accType = "agent_visit_purpose";
                            $scope.vm.form.data.visit_type = { Value: 50, Name: "代理商拜访" };
                            break;
                        case 6:
                            accType = "chain_visit_purpose";
                            $scope.vm.form.data.visit_type = { Value: 60, Name: "连锁拜访" };
                            break;
                    }
                    myService.getVisitPurpose(accType).then(function (resp) {
                        $scope._visitpurpose = array_diff(resp.data, $scope.vm.form.data.VisitPurpose);
                    });
                });
            }
        });

        function array_diff(a, b) {
            if (rt.isNull(b)) b = [];
            for (var i = 0; i < b.length; i++) {
                for (var j = 0; j < a.length; j++) {
                    if (a[j].Value == b[i].Value) {
                        a.splice(j, 1);
                        j = j - 1;
                    }
                }
            }
            return a;
        }

        $scope.$watch("vm.form.data.contactid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(newValue)) {
                if ($scope.vm.form.data.visit_type.Value == 20) {
                    myService.GetDepartmentByContactId(newValue).then(function (resp) {
                        var data = resp.data;
                        if (data) {
                            $scope.vm.form.data.departid = { Id: data.Id, Name: data.name };
                        }
                    });
                }
            }
        });

        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("visit", fileId);
        };

        $scope.vm.form.loadComplete = function () {
            var newassList = [];
            if ($scope.vm.form.data.assistanceList != null) {
                angular.forEach($scope.vm.form.data.assistanceList, function (entity) {
                    newassList.push({ Id: entity.OwnerId.Id, Name: entity.OwnerIdName });
                });
                $scope.vm.form.data.assistanceList = newassList;
            }
        };

        $scope.vm.form.preSave = function () {
            if ($scope.vm.form.data.is_assist) {
                if (rt.isNull($scope.vm.form.data.assistanceList)) {
                    rt.errorMessage("请选择协访人。");
                    return "请选择协访人。";
                }
            }
            $scope.vm.form.data.visit_status = { Value: 10, Name: "待拜访" };
            $scope.vm.form.data.visitpurposes = JSON.stringify($scope.vm.form.data.VisitPurpose);
            var assistanceList = $scope.vm.form.data.assistanceList;
            if ($scope.vm.form.data.is_assist) {
                for (var i = 0; i < assistanceList.length; i++) {
                    if (assistanceList.visit_assistanceId == null || assistanceList.visit_assistanceId == '') {
                        $scope.vm.form.data.assistanceList[i].visit_assistanceId = rt.newGuid();
                        $scope.vm.form.data.assistanceList[i].OwnerId = {
                            Id: assistanceList[i].Id,
                            Name: assistanceList[i].Name
                        };
                        $scope.vm.form.data.assistanceList[i].Id = assistanceList[i].visit_assistanceId;
                    }
                    $scope.vm.form.data.assistanceList[i].visit_recordId = { Id: $scope.vm.form.data.Id };
                }
            }
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016/8/31
 说明     : 医院拜访计划维护
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('HospitalVisitPlanService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'HospitalVisitPlan';

        // @@ 选项集
        this.picklists = ['visit_purpose', '	hospital_visit_purpose', 'StateCode'];

        this.savePlan = function (visit_recordId, accountId, accountName, departid, departidName, contactid, contactidName, visitPurpose, planTime, assisterId) {
            var url = "api/HospitalVisitPlan/savePlan?visit_recordId=" + visit_recordId + "&accountId=" + accountId + "&accountName=" + accountName + "&departid=" + departid + "&departidName=" + departidName + "&contactid=" + contactid + "&contactidName=" + contactidName + "&visitPurpose=" + visitPurpose + "&planTime=" + planTime + "&assisterId=" + assisterId;
            return rt.post(url);
        };

        this.deletePlan = function (visit_recordId) {
            var url = "api/HospitalVisitPlan/deletePlan?visit_recordId=" + visit_recordId;
            return rt.get(url);
        };
        //获取医院的拜访目的
        this.gethospitalVisitPurpose = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=hospital_visit_purpose";
            return rt.get(url);
        };

        //获取医院的等级
        this.gethospitalLevel = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=account_level";
            return rt.get(url);
        };

        this.getDbDateTime = function () {
            var apiUrl = "api/VisitRecord/GetDbDateTime";
            return rt.get(apiUrl);
        };
    }]).controller('hospitalVisitPlanListController', ['$injector', '$scope', 'HospitalVisitPlanService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        /*   $scope.vm.account_grade_levelPickList = [
               { Value: 0, Name: '所有级别医院' },
               { Value: 1, Name: 'A级别医院' },
               { Value: 2, Name: 'B级别医院' },
               { Value: 3, Name: 'C级别医院' },
               { Value: 4, Name: 'D级别医院' }
           ];*/
        //   $scope.vm.account_grade_level = $scope.vm.account_grade_levelPickList[0];

        $scope.vm.visitStatusPickList = [{ Value: 0, Name: '不根据实际拜访情况过滤' }, { Value: 1, Name: '上周未拜访的医院' }, { Value: 2, Name: '本周未拜访的医院' }, { Value: 3, Name: '本月未拜访的的医院' }, { Value: 4, Name: '上月未拜访的医院' }, { Value: 5, Name: '自定义时间段' }];
        $scope.vm.visitStatus = $scope.vm.visitStatusPickList[0];
        $scope.vm.startTime = '';
        $scope.vm.endTime = '';
        _gethospitalLevel();

        $scope.vm.planData = [];
        $scope.vm.showData = [];
        $scope.vm.isShow = false;
        $scope.vm.showTimeFilterInput = false;

        //初始化门店
        function _getHospitalList() {
            var waiting = rt.showLoading2();
            var url = 'api/HospitalVisitPlan/GetHospitalList?accountGrade=' + $scope.vm.account_grade_level.Value + "&visitStatus=" + $scope.vm.visitStatus.Value + "&startTime=" + $scope.vm.startTime + "&endTime=" + $scope.vm.endTime;
            return rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data;
                angular.forEach($scope.vm.data, function (data) {
                    if (rt.isNull(data.VisitPurpose)) {
                        data.VisitPurpose = [];
                    }
                });
                _getHospitalVisitPurpose();
                waiting.close();
            });
        }
        var waiting = rt.showLoading2();
        //获取医院等级
        function _gethospitalLevel() {
            $q.all([myService.gethospitalLevel()]).then(function (resp) {
                $scope.vm.account_grade_levelPickList = resp[0].data;
                $scope.vm.account_grade_levelPickList.unshift({ Value: 0, Name: "所有" }); //在数组开头增加所有级别医院
                if ($scope.vm.account_grade_levelPickList.length > 0) {
                    $scope.vm.account_grade_level = $scope.vm.account_grade_levelPickList[0];
                    _getHospitalList();
                }
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }

        function _getHospitalVisitPurpose() {
            $q.all([myService.gethospitalVisitPurpose(), myService.getDbDateTime()]).then(function (resp) {
                $scope._visitpurpose = resp[0].data;
                $scope.vm.tomorrow = moment(resp[1].data, 'YYYY-MM-DD').add('days', 1).toDate();
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }
        //获取所有代表
        _getAllOwner();
        function _getAllOwner() {
            rt.queryData("UserInfo.GetAllUser", { '@queryValue': '' }, function (resp) {
                $scope.OwnerList = [];
                var data = resp.DataList;
                for (var i = 0; i < data.length; i++) {
                    $scope.OwnerList.push({ Id: data[i].id, Name: data[i].name });
                }
            }, function (error) {});
        }
        $scope.vm.actions.isAllowFilter = function () {
            if ($scope.vm.visitStatus.Value !== 5) {
                $scope.vm.actions.filterRetailList();
            } else {
                $scope.vm.showTimeFilterInput = true;
            }
        };

        $scope.vm.actions.filterRetailList = function () {
            if ($scope.vm.visitStatus.Value == 5 && rt.isNullOrWhiteSpace($scope.vm.startTime)) {
                rt.errorMessage("请输入开始时间");
                return "请输入开始时间";
            }

            if ($scope.vm.visitStatus.Value == 5 && rt.isNullOrWhiteSpace($scope.vm.endTime)) {
                rt.errorMessage("请输入结束时间");
                return "请输入结束时间";
            }

            if ($scope.vm.startTime > $scope.vm.endTime) {
                rt.errorMessage("开始时间必须小于结束时间");
                return "开始时间必须小于结束时间";
            }

            var waiting = rt.showLoading2();
            var url = 'api/HospitalVisitPlan/GetHospitalList?accountGrade=' + $scope.vm.account_grade_level.Value + "&visitStatus=" + $scope.vm.visitStatus.Value + "&startTime=" + moment($scope.vm.startTime).format('YYYY-MM-DD') + "&endTime=" + moment($scope.vm.endTime).add('days', 1).format('YYYY-MM-DD');
            return rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data;
                waiting.close();
            });
        };

        $scope.vm.actions.savePlan = function () {
            angular.forEach($scope.vm.data, function (data) {
                if (rt.isNull(data.VisitPurpose)) {
                    data.VisitPurpose = [];
                }
            });
            $scope.vm.planData = [];
            //医院为空
            if ($scope.vm.data.length == 0) {
                return;
            }

            var msg = '';
            var haveFullData = false;
            angular.forEach($scope.vm.data, function (data) {
                if (!rt.isNullOrWhiteSpace(data.planTime) && data.VisitPurpose.length > 0) {
                    if (moment(data.planTime).toDate() < $scope.vm.tomorrow) {
                        msg += data.name + "的计划时间必须大于今日    ";
                    } else {
                        haveFullData = true;
                    }
                } else if (rt.isNullOrWhiteSpace(data.planTime) && data.VisitPurpose.length == 0) {} else {
                    if (rt.isNullOrWhiteSpace(data.planTime)) {
                        msg += data.name + "的计划时间不能为空    ";
                    }
                    if (rt.isNull(data.VisitPurpose) || data.VisitPurpose.length == 0) {
                        msg += data.name + "的拜访目的不能为空     ";
                    }
                }
            });
            if (!haveFullData) {
                if (!rt.isNullOrWhiteSpace(msg) || msg != '') {
                    return rt.errorMessage(msg);
                }
            }

            for (var i = 0; i < $scope.vm.data.length; i++) {
                if (!rt.isNullOrWhiteSpace($scope.vm.data[i].planTime) && $scope.vm.data[i].VisitPurpose.length > 0) {
                    $scope.vm.planData.push($scope.vm.data[i]);
                    $scope.vm.data.splice(i, 1);
                    i = i - 1;
                }
            }

            //计划时间全为空
            if ($scope.vm.planData.length == 0) {

                return rt.errorMessage("计划时间全部为空，不能生成计划");
            }

            var waiting = rt.showWaiting();
            for (var j = 0, len2 = $scope.vm.planData.length; j < len2; j++) {
                $scope.vm.planData[j].newVisit_recordId = rt.newGuid();
                var assister = $scope.vm.planData[j].assister;
                myService.savePlan($scope.vm.planData[j].newVisit_recordId, $scope.vm.planData[j].accountId, $scope.vm.planData[j].name, $scope.vm.planData[j].departmentid, $scope.vm.planData[j].departmentidName, $scope.vm.planData[j].contactid, $scope.vm.planData[j].doctor, $scope.vm.planData[j].visitpurposes = JSON.stringify($scope.vm.planData[j].VisitPurpose), $scope.vm.planData[j].planTime, rt.isNull(assister) || assister.length == 0 ? "" : JSON.stringify($scope.vm.planData[j].assister)).then(function (resp) {});
                $scope.vm.showData.push($scope.vm.planData[j]);
            }

            $scope.vm.planData = [];
            rt.successMessage("生成成功");
            waiting.close();
            $scope.vm.isShow = true;
        };

        $scope.vm.actions.deletePlan = function (row, index) {
            myService.deletePlan(row.newVisit_recordId);
            //row.planTime=new Date(row.planTime);
            $scope.vm.data.unshift(row);
            $scope.vm.showData.splice(index, 1);
        };

        //$(document).ready(function(){
        //    $("select").change(function(){
        //        _getRetailList();
        //    });
        //})
    }]).controller('hospitalVisitPlanEditController', ['$injector', '$scope', 'HospitalVisitPlanService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-06-28
 说明     : 省区基础数据
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('IncBuSettlePricelistService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'IncBuSettlePricelist';

        // @@ 选项集
        this.picklists = ['StateCode'];
        this.getProductSizeById = function (id) {
            var url = 'api/Product/GetProductById?id=' + id;
            return rt.get(url);
        };
    }]).controller('IncBuSettlePricelistListController', ['$scope', 'IncBuSettlePricelistService', entityListController]).controller('IncBuSettlePricelistEditController', ['$scope', '$injector', 'IncBuSettlePricelistService', function ($scope, $injector, myService) {
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        var rt = myService.rt;

        //选择药品后自动带出药品规格
        $scope.$watch("vm.form.data.productid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                myService.getProductSizeById($scope.vm.form.data.productid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.form.data.productsize = resp.data.productsize;
                    } else {
                        $scope.vm.form.data.productsize = '';
                    }
                });
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : oscar
 创建时间 : 2017-06-28
 说明     : 终端客户数据
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('incDrugflowSettleRuleService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = '';

        // @@ 选项集
        this.picklists = [];
    }]).controller('incDrugflowSettleRuleListController', ['$scope', 'incDrugflowSettleRuleService', function ($scope, myService) {
        var rt = myService.rt;
        $scope.saveClick = function () {
            rt.successMessage("保存成功");
            return;
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : oscar
 创建时间 : 2017-06-28
 说明     : 终端客户数据
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('incEndAccountSettlePricelistService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'IncEndAccountSettlePricelist';

        // @@ 选项集
        this.picklists = ['settle_type'];
        //获取药品品规
        this.getProductSize = function (id) {
            var url = 'api/Product/GetProductById?id=' + id;
            return rt.get(url);
        };
    }]).controller('incEndAccountSettlePricelistListController', ['$scope', 'incEndAccountSettlePricelistService', entityListController]).controller('incEndAccountSettlePricelistEditController', ['$injector', '$scope', 'incEndAccountSettlePricelistService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.productid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                //带出药品规格
                myService.getProductSize($scope.vm.form.data.productid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.form.data.productsize = resp.data.productsize;
                    } else {
                        $scope.vm.form.data.productsize = '';
                    }
                });
                return;
            }
        });

        //省区
        $scope.$watch("vm.form.data.bigdepartid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.BusinessUnitId = null;
            }
        });

        //办事处
        $scope.$watch("vm.form.data.BusinessUnitId.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
            }
        });

        //保存前
        $scope.vm.form.preSave = function () {
            if ($scope.vm.form.data.settle_type.Value == 1) {
                if (rt.isNullOrEmptyString($scope.vm.form.data.settle_price + '') || rt.isNull($scope.vm.form.data.productid)) {
                    rt.errorMessage("结算类型为'底价结算'时,药品和结算底价需必填！");
                    return "结算类型为'底价结算'时,药品和结算底价需必填！";
                }
            }
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2017-03-02
 说明     :PC端潜在代理商
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('leadsService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'leads';
        this.approvalTypeName = 'leads';

        // @@ 选项集
        this.picklists = ['StateCode', 'agent_type', 'alloc_or_dist', 'new_or_normal', 'sales_good_at', 'sales_potential', 'cooperate_intent', 'accountclassificationcode', 'team_size', 'legal_person_background', 'awareness_of_risks', 'popularity', 'tax_process_ability', 'successful_experiences', 'develop_ability', 'is_acc_margin_commission', 'is_cover_70per_target', 'target_department_alignment', 'is_estabLish_team', 'promotion_ability', 'limite_process_ability', 'gover_social_relation', 'call_bidding_ability', 'medical_insurance_ability', 'bargaining_ability', 'into_clinical_ability', 'leads_state'];

        //根据负责人带出省区 业务线 事业部
        this.GetBusinessUnitDetailByOwnerId = function (ownerId) {
            return rt.get("api/Account/GetBusinessUnitDetailByOwnerId?ownerId=" + ownerId);
        };

        this.flowApprove = function (reqData) {
            var url = 'api/FlowApproval/FlowApprove';
            return rt.post(url, reqData);
        };

        this.flowReject = function (reqData) {
            var url = 'api/FlowApproval/FlowReject';
            return rt.post(url, reqData);
        };

        this.flowRecall = function (reqData) {
            var url = 'api/FlowApproval/FlowRecall';
            return rt.post(url, reqData);
        };

        this.flowTransmit = function (reqData, userid) {
            var url = 'api/FlowApproval/FlowTransmit?userId=' + userid;
            return rt.post(url, reqData);
        };

        this.getApprovalStatus = function (id) {
            var url = 'api/FlowApproval/GetFormApprovalStatus?objectId=' + id;
            return rt.get(url);
        };
        this.getEditApprovalList = function (id, typename) {
            var url = 'api/FlowApproval/GetEditApprovalList?objectId=' + id + '&typename=' + typename;
            return rt.get(url);
        };
        this.getProductSize = function (id) {
            var url = 'api/Product/GetProductById?id=' + id;
            return rt.get(url);
        };
        this.createOrUpdateSalesAgreement = function (data) {
            var url = 'api/SalesAgreement/CreateOrUpdateSalesAgreement';
            return rt.post(url, data);
        };
        this.bulkCreateOrUpdteSalesAgreementTarget = function (salesAgreementId, listdata) {
            var url = 'api/SalesAgreementTarget/BulkCreateOrUpdteSalesAgreementTarget?salesAgreementId=' + salesAgreementId;
            return rt.post(url, listdata);
        };

        this.deleteSalesAgreement = function (salesAgreementId) {
            var url = 'api/SalesAgreement/DeleteSalesAgreementData?salesAgreementId=' + salesAgreementId;
            return rt.get(url);
        };
    }]).controller('leadsListController', ['$injector', '$compile', '$scope', 'leadsService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        var that = this;
        this.searchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }

            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdeptid", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.Id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.sDate) && !rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                if (moment($scope.vm.sDate).toDate() > moment($scope.vm.eDate).toDate()) {
                    return "开始时间必须小于结束时间";
                }
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [moment($scope.vm.sDate).toDate(), moment($scope.vm.eDate).add('days', 1)] });
            }
        };
        this.preExport = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }

            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdeptid", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.Id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.sDate) && !rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                if (moment($scope.vm.sDate).toDate() > moment($scope.vm.eDate).toDate()) {
                    return "开始时间必须小于结束时间";
                }
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [moment($scope.vm.sDate).toDate(), moment($scope.vm.eDate).add('days', 1)] });
            }

            that.searchList.push({ Type: 1, Key: "viewId", Value: $scope.vm.view.selectedView.Id });
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.sDate = moment().date(1).hour(0).minute(0);
        $scope.vm.eDate = moment().add('days', 1).hour(0).minute(0);

        $scope.vm.actions.loadComplete = function () {
            if (!rt.isNull($scope.vm.data)) {
                for (var i = 0; i < $scope.vm.data.length; i++) {
                    if (!rt.isNullOrWhiteSpace($scope.vm.data[i].product_operated) && $scope.vm.data[i].product_operated.length > 15) {
                        $scope.vm.data[i].product_operated = $scope.vm.data[i].product_operated.substring(0, 15) + "...";
                    }

                    $scope.vm.departmentsList = [];
                    if (!rt.isNull($scope.vm.data[i].department_good_at)) {
                        $scope.vm.departmentsList = JSON.parse($scope.vm.data[i].department_good_at);
                    }
                    $scope.vm.data[i].departmentsName = _getListNames($scope.vm.departmentsList);
                }
            }
        };

        function _getListNames(list) {
            var names = '';
            if (!rt.isNull(list) && list.length > 0) {
                list.forEach(function (item) {
                    names += item.Name + ', ';
                }, this);
                names = names.substring(0, names.length - 2);
            }
            if (!rt.isNullOrWhiteSpace(names) && names.length > 15) {
                names = names.substring(0, 15) + "...";
            }
            return names;
        }

        _getAllBuid();

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
            }, function (error) {
                $scope.vm.buidList = [];
            });
        }

        //获取上游商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            $scope.vm.bigDepSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.businessUnitSelected = null;
            $scope.vm.businessUnitList = [];
            $scope.vm.view.search(1);
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) return;

            rt.queryData("TblBusinessUnit.ChildBusinessUnitId", {
                '@queryValue': '',
                '@ParentBusinessUnitId': $scope.vm.buidSelected.id
            }, function (resp) {
                $scope.vm.bigDepList = resp.DataList;
            }, function (error) {
                $scope.vm.bigDepList = [];
            });
        });
        //获取上游省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            $scope.vm.businessUnitSelected = null;
            $scope.vm.businessUnitList = [];
            $scope.vm.view.search(1);
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) return;

            rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", {
                '@queryValue': '',
                '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id
            }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    data.forEach(function (e) {
                        $scope.vm.businessUnitList.push({ Name: e.name, Id: e.id });
                    });
                }
            }, function (error) {
                $scope.vm.businessUnitList = [];
            });
        });
    }]).controller('leadsEditController', ['$injector', '$compile', '$rootScope', '$scope', '$q', 'salesagreementService', 'leadsService', function ($injector, $compile, $rootScope, $scope, $q, salesagreementService, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.approverList = [];
        $scope.vm.form.data.ApprovedBy = {};
        $scope.vm.form.approvalStatus;
        $scope.vm.form.canSubmit = false;
        $scope.vm.form.canEdit = false;

        $scope.vm.sum = function (num1, num2, num3) {
            return parseFloat(num1) + parseFloat(num2) + parseFloat(num3);
        };

        _loadSalesAgreementData();

        function _loadSalesAgreementData() {
            var url = 'api/SalesAgreement/GetLeadsSalesAgreement?accountId=' + $scope.vm.form.id;
            return rt.get(url).then(function (resp) {
                if (!rt.isNull(resp.data)) {
                    $scope.vm.salesAgreement = resp.data;
                } else {
                    $scope.vm.salesAgreement = {};
                    $scope.vm.salesAgreement.Id = rt.newGuid();
                }
                if (rt.isNull($scope.vm.salesAgreement.salesAgreementTargetList) || $scope.vm.salesAgreement.salesAgreementTargetList.length == 0) {
                    $scope.vm.target = [{
                        "target_quarter": 1,
                        "target_month": 1,
                        "target_amount": 0
                    }, {
                        "target_quarter": 1,
                        "target_month": 2,
                        "target_amount": 0
                    }, {
                        "target_quarter": 1,
                        "target_month": 3,
                        "target_amount": 0
                    }, {
                        "target_quarter": 2,
                        "target_month": 4,
                        "target_amount": 0
                    }, {
                        "target_quarter": 2,
                        "target_month": 5,
                        "target_amount": 0
                    }, {
                        "target_quarter": 2,
                        "target_month": 6,
                        "target_amount": 0
                    }, {
                        "target_quarter": 3,
                        "target_month": 7,
                        "target_amount": 0
                    }, {
                        "target_quarter": 3,
                        "target_month": 8,
                        "target_amount": 0
                    }, {
                        "target_quarter": 3,
                        "target_month": 9,
                        "target_amount": 0
                    }, {
                        "target_quarter": 4,
                        "target_month": 10,
                        "target_amount": 0
                    }, {
                        "target_quarter": 4,
                        "target_month": 11,
                        "target_amount": 0
                    }, {
                        "target_quarter": 4,
                        "target_month": 12,
                        "target_amount": 0
                    }];
                } else {
                    $scope.vm.target = $scope.vm.salesAgreement.salesAgreementTargetList;
                }
            });
        }

        if (!rt.isNull($scope.vm.form.id) && $scope.vm.form.id != '') {
            myService.getApprovalStatus($scope.vm.form.id).then(function (resp) {
                if (!rt.isNull(resp)) {
                    $scope.vm.form.approvalStatus = resp.data.ApprovalStatus;
                    $scope.vm.form.approverList = resp.data.ApproverList;
                }

                $scope.vm.form.isFlowApprover = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.ApprovingBy) && rt.isSameGuid($scope.vm.form.approvalStatus.ApprovingBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;

                $scope.vm.form.isFlowSubmitter = !rt.isNull($scope.vm.form.approvalStatus) && !rt.isNull($scope.vm.form.approvalStatus.SubmittedBy) && rt.isSameGuid($scope.vm.form.approvalStatus.SubmittedBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value == 2;
            }).catch(function (resp) {
                rt.showErrorToast(resp.data);
            });
        }

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.$watch("vm.form.data.cityid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.vm.form.preLoad = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=room_type";
            rt.get(url).then(function (resp) {
                $scope.vm.picklist.room_type = resp.data;
            });
            rt.get("api/SystemParam/GetSystemParamByCode?code=product_focus_on").then(function (resp) {
                $scope.vm.picklist.product_focus_on = resp.data;
            });
        };

        $scope.vm.form.loadComplete = function () {
            //只有状态是未审核，且当前用户是提交用户的才允许重新提交
            if (rt.isNull($scope.vm.form.approvalStatus)) {
                $scope.vm.form.canSubmit = true;
            } else {
                if (rt.isSameGuid($scope.vm.form.approvalStatus.SubmittedBy.Id, rt.getUserId()) && $scope.vm.form.approvalStatus.approval_status.Value != 3) {
                    $scope.vm.form.canSubmit = true;
                }
                if ($scope.vm.form.approvalStatus.approval_status.Value != 1) {
                    $scope.vm.form.canEdit = true;
                }
            }
            if (rt.isNull($scope.vm.form.data.OwnerId) || rt.isNullOrWhiteSpace($scope.vm.form.data.OwnerId.Id)) {
                myService.GetBusinessUnitDetailByOwnerId("").then(function (resp) {
                    var data = resp.data[0];
                    if (data) {
                        $scope.vm.form.data.OwnerId = { Id: data.TblSystemUserId, Name: data.UserName };
                        $scope.vm.form.data.buid = { Id: data.buid, Name: data.buidName };
                        $scope.vm.form.data.bigdeptid = { Id: data.bigdeptid, Name: data.bigdeptidName };
                        $scope.vm.form.data.BusinessUnitId = { Id: data.BusinessUnitId, Name: data.BusinessUnitIdName };
                    }
                });
            }
        };

        $scope.vm.form.preSave = function () {
            if (!rt.isNullOrWhiteSpace($scope.vm.form.data.telephone) && !rt.isPhoneNumberString($scope.vm.form.data.telephone)) {
                rt.errorMessage("联系电话：请输入有效的联系电话！");
                return "联系电话：请输入有效的联系电话！";
            }
            $scope.vm.form.data.DepartmentList = _.map($scope.vm.form.data.DepartmentList, function (item) {
                var model = {};
                model.Name = item.Name;
                model.Value = item.Value;
                return model;
            });
            $scope.vm.form.data.department_good_at = JSON.stringify($scope.vm.form.data.DepartmentList);
        };

        $scope.vm.form.addApprover = function () {
            var html = '<div rt-include rt-template="OA/ApproveU/approveUListView.html" rt-controller="ApproveUController" rt-include-params=' + "" + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
        $scope.$on('to-parent', function (event, data) {
            if (rt.isNull($scope.vm.form.approverList) || $scope.vm.form.approverList === '') {
                $scope.vm.form.approverList = data;
            } else {
                $scope.vm.approverLists = $scope.vm.form.approverList;
                for (var i = 0; i < data.length; i++) {
                    var approverExit = true;
                    for (var j = 0; j < $scope.vm.approverLists.length; j++) {
                        if (data[i].OwnerId.Id === $scope.vm.approverLists[j].OwnerId.Id) {
                            approverExit = false;
                        }
                    }
                    if (approverExit) {
                        $scope.vm.form.approverList.push(data[i]);
                    }
                }
            }
        });

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };
        $scope.vm.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.vm.form.delApprover = function (index) {
            if ($scope.vm.form.isFlowSubmitter == false && $scope.vm.form.type !== 'Create') {
                return;
            }

            if ($scope.vm.form.type === 'Create') {
                $scope.vm.form.approverList.splice(index, 1);
            } else if ($scope.vm.form.data.StateCode.Value == 1 || $scope.vm.form.type === 'Edit') {
                $scope.vm.form.approverList.splice(index, 1);
            }
        };

        //提交
        $scope.vm.form.submit = function () {
            var reqData = {
                ObjectId: $scope.vm.form.id,
                ObjectName: $scope.vm.form.data.name,
                ObjectTypeName: myService.approvalTypeName,
                ApproverList: $scope.vm.form.approverList
            };
            var salesagreementtoaccount = $rootScope.salesdata;
            var savedata = true;
            //四个季度之和
            var sum_salesagreementtoaccount = 0;
            var sum_target_quarter1 = $scope.vm.sum($scope.vm.target[0].target_amount, $scope.vm.target[1].target_amount, $scope.vm.target[2].target_amount);
            var sum_target_quarter2 = $scope.vm.sum($scope.vm.target[3].target_amount, $scope.vm.target[4].target_amount, $scope.vm.target[5].target_amount);
            var sum_target_quarter3 = $scope.vm.sum($scope.vm.target[6].target_amount, $scope.vm.target[7].target_amount, $scope.vm.target[8].target_amount);
            var sum_target_quarter4 = $scope.vm.sum($scope.vm.target[9].target_amount, $scope.vm.target[10].target_amount, $scope.vm.target[11].target_amount);
            $scope.vm.sumtarget_amount = sum_target_quarter1 + sum_target_quarter2 + sum_target_quarter3 + sum_target_quarter4;
            for (var i = 0; i < salesagreementtoaccount.length; i++) {
                sum_salesagreementtoaccount += salesagreementtoaccount[i].year_target;
                // salesagreementtoaccount[i].Id = $scope.vm.salesAgreement.Id + "auxiliary";
            }

            if (sum_salesagreementtoaccount == 0 && $scope.vm.sumtarget_amount == 0) {
                savedata = true;
            } else if (sum_salesagreementtoaccount >= $scope.vm.sumtarget_amount) {
                rt.errorMessage("年度任务合计应小于年度销售指标约定四个季度之和！");
                savedata = false;
            } else {
                savedata = true;
            }

            if (savedata) {
                var url = 'api/FlowApproval/FlowSubmit';
                return rt.post(url, reqData).then(function (resp) {

                    rt.post('api/Leads/CreatedPDFFile?salesAgreementId=' + $scope.vm.salesAgreement.Id + '&agent_typeValue=' + $scope.vm.form.data.agent_type.Value, salesagreementtoaccount).then(function (resp) {
                        var returnData = resp.data;
                        $scope.vm.form.hide();
                    });
                });
            }
        };

        //撤销
        $scope.vm.form.flowRecall = function () {
            var retValue = prompt("请输入撤销理由(非必输)", "");
            if (retValue != null) {
                $scope.vm.form.approvalStatus.remark = retValue;
                rt.successMessage("正在处理...");
                myService.flowRecall($scope.vm.form.approvalStatus).then(function (resp) {
                    $scope.vm.form.hide();
                });
            } else {
                return;
            }
        };

        //同意
        $scope.vm.form.flowApprove = function () {
            var retValue = prompt("请输入同意理由(非必输)", "");
            if (retValue != null) {
                $scope.vm.form.approvalStatus.remark = retValue;
                rt.successMessage("正在处理...");
                myService.flowApprove($scope.vm.form.approvalStatus).then(function (resp) {
                    $scope.vm.form.hide();
                }, function (resp) {
                    rt.errorMessage(resp.data);
                });
            } else {
                return;
            }
        };

        //拒绝
        $scope.vm.form.flowReject = function () {
            var retValue = prompt("请输入拒绝理由(非必输)", "");
            if (retValue != null) {
                $scope.vm.form.approvalStatus.remark = retValue;
                rt.successMessage("正在处理...");
                myService.flowReject($scope.vm.form.approvalStatus).then(function (resp) {
                    $scope.vm.form.hide();
                }, function (resp) {
                    rt.errorMessage(resp.data);
                });
            } else {
                return;
            }
        };

        //转发
        $scope.vm.form.flowTransmit = function () {
            var retValue = prompt("请输入转发理由(非必输)", "");
            if (retValue != null) {
                $scope.vm.form.approvalStatus.remark = retValue;
                $scope.vm.form.showTransmitForm();
            } else {
                return;
            }
        };

        $scope.vm.form.showTransmitForm = function () {
            var html = '<div rt-include rt-template="OA/FlowApprovalU/flowApprovalUListView.html" rt-controller="flowApprovalUController" rt-include-params=' + JSON.stringify($scope.vm.form.approvalStatus) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        $scope.$watch("vm.salesAgreement.productid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                //带出药品规格
                myService.getProductSize($scope.vm.salesAgreement.productid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.salesAgreement.product_size = resp.data.productsize;
                    } else {
                        $scope.vm.salesAgreement.product_size = '';
                    }
                });
                return;
            }
        });

        $scope.vm.form.newsave = function (isCreate) {
            var waiting = rt.showWaiting();
            $scope.vm.salesAgreement.accountId = { "Id": $scope.vm.form.data.Id, "Name": $scope.vm.form.data.name };
            $scope.vm.form.save(isCreate).then(function () {
                if ($scope.vm.form.type === 'Edit' && !rt.isNullOrEmptyString($scope.vm.salesAgreement.agr_no) && !rt.isNullOrEmptyString($scope.vm.salesAgreement.first_party_name)) {
                    $q.all([myService.createOrUpdateSalesAgreement($scope.vm.salesAgreement), myService.bulkCreateOrUpdteSalesAgreementTarget($scope.vm.salesAgreement.Id, $scope.vm.target)]).then(function (resp) {
                        waiting.close();
                    }).finally(function () {
                        waiting.close();
                    });
                } else if ($scope.vm.form.type === 'Edit' && $scope.vm.salesAgreement.agr_no == '' && $scope.vm.salesAgreement.first_party_name == '') {
                    myService.deleteSalesAgreement($scope.vm.salesAgreement.Id);
                }
            }).finally(function () {
                waiting.close();
            });
        };
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2015-04-15
说明     : 会员等级
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('memberLevelService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'memberLevel';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('memberLevelListController', ['$scope', 'memberLevelService', entityListController]).controller('memberLevelEditController', ['$scope', 'memberLevelService', entityEditController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2017-01-09
 说明     : 用户积分规则
 *********************************************************/

(function () {
            'use strict';

            angular.module('xrmApp').service('memberRankRuleService', ['entityService', function (entityService) {

                        angular.extend(this, entityService);

                        // @@设置WebAPI的控制器名称
                        this.controllerName = 'MemberRankRule';

                        // @@ 选项集
                        this.picklists = ['StateCode'];
            }]).controller('memberRankRuleListController', ['$scope', 'memberRankRuleService', entityListController]).controller('memberRankRuleEditController', ['$scope', 'memberRankRuleService', entityEditController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2018-1-4
 说明     : 使用手册
 *********************************************************/

(function () {
	'use strict';

	angular.module('xrmApp').service('mineUseManualService', ['entityService', function (entityService) {

		angular.extend(this, entityService);
		var rt = entityService.rt;

		// @@设置WebAPI的控制器名称
		this.controllerName = 'MineUseManual';

		// @@ 选项集
		this.picklists = ['StateCode'];
	}]).controller('mineUseManualListController', ['$scope', '$injector', 'mineUseManualService', function ($scope, $injector, myService) {

		var rt = myService.rt;

		$injector.invoke(entityListController, this, {
			$scope: $scope,
			myService: myService
		});

		$scope.vm.actions.deleteManuals = function () {
			var selectedIdLength = $scope.vm.view.selectedIds.length;
			if (selectedIdLength === 0) {
				rt.warningMessage('请至少选择一项进行删除操作。');
				return;
			}

			var confirmMessage = '您一共选择了' + selectedIdLength + '条记录，确认要删除这些记录？';
			rt.confirm(confirmMessage, function (ok) {
				if (ok) {
					var waiting = rt.showWaiting();
					rt.deleteFile("manual", $scope.vm.view.selectedIds).success(function (data) {
						rt.successMessage("删除成功。");
					}).error(function (data) {
						rt.errorMessage(data);
					}).finally(function () {
						waiting.close();
					});
				}
			});
		};
	}]).controller('mineUseManualEditController', ['$injector', '$scope', '$timeout', 'mineUseManualService', function ($injector, $scope, $timeout, myService) {
		var rt = myService.rt;
		var $q = myService.$q;

		$injector.invoke(entityEditController, this, {
			$scope: $scope,
			myService: myService
		});

		$scope.vm.fjs = [];
		$scope.vm.flagBTN = 0;

		function _getfile() {
			if ($scope.vm.form.id !== "") {
				rt.GetFilesByObjectId($scope.vm.form.data.moduletype, $scope.vm.form.id).success(function (data) {
					var fileData = data.DataList;
					if (fileData !== null) {
						$scope.vm.fjs = [];
						for (var i = 0; i < fileData.length; i++) {
							$scope.vm.fjs.push({ Id: fileData[i].Id, FileName: fileData[i].FileName, DownFile: true });
						}
					}
				}).error(function (error) {
					rt.errorMessage(error);
				});
			}
		}

		$scope.vm.form.downloadfile = function (fileId) {
			rt.downloadFile($scope.vm.form.data.moduletype, fileId);
		};

		$scope.vm.form.deletedfile = function () {
			if ($scope.vm.view.selectedIds.length === 0) {
				return;
			}
			var mmm = rt.deleteFile($scope.vm.form.data.moduletype, $scope.vm.view.selectedIds).success(function (data) {
				$scope.vm.selectedFileName = null;
				for (var j = 0; j < $scope.vm.view.selectedIds.length; j++) {
					for (var k = 0; k < $scope.vm.fjs.length; k++) {
						if ($scope.vm.fjs[k].Id === $scope.vm.view.selectedIds[j]) {
							if ($scope.vm.selectedFiles !== null) {
								for (var i = 0; i < $scope.vm.selectedFiles.length; i++) {
									if ($scope.vm.selectedFiles[i].name === $scope.vm.fjs[k].FileName) {
										$scope.vm.selectedFiles.splice(i, 1);
										$scope.vm.fjs.splice(k, 1);
									}
								}
							}
						}
					}
				}
				$scope.vm.view.selectedIds = [];
				rt.successMessage("删除成功。");
				_getfile();
			}).error(function (message) {
				rt.errorMessage(message);
			});
		};

		$scope.vm.form.filesave = function () {
			if (!rt.isEmptyArray($scope.vm.selectedFiles)) {
				var waiting = rt.showWaiting();
				return rt.uploadFiles($scope.vm.selectedFiles, $scope.vm.form.data.moduletype, $scope.vm.form.data.Id, false, function (data) {
					$scope.vm.selectedFiles = null;
					$scope.vm.selectedFilesArr = [];
					$scope.vm.flagBTN = 0;
					waiting.close();
				});
			} else {
				var deferred = $q.defer();
				deferred.reject("没有添加附件");
				return deferred.promise;
			}
		};

		$scope.vm.selectedFiles = null;
		$scope.vm.selectedFilesArr = [];
		$scope.vm.selectedFileName = null;
		$scope.vm.form.fileselect = function (files) {
			if (files && files.length && files.length > 0) {
				for (var i = 0; i < files.length; i++) {
					$scope.vm.selectedFilesArr.push(files[i]);
				}
				$scope.vm.selectedFiles = $scope.vm.selectedFilesArr;
				for (var j = 0; j < files.length; j++) {
					$scope.vm.fjs.push({ Id: rt.newGuid(), FileName: files[j].name, DownFile: false });
				}
			}
		};

		$scope.vm.form.loadComplete = function () {
			if ($scope.vm.form.type === 'Edit') {
				_getfile();
			}
		};

		//保存并新建
		$scope.vm.truesave = function () {
			$scope.vm.form.save(true).then(function () {
				$scope.vm.form.filesave().then(function () {
					$scope.vm.fjs = []; //清空附件
				});
			});
		};

		$scope.vm.form.newsave = function () {
			$scope.vm.flagBTN = 1;
			$scope.vm.form.save(false).then(function () {
				$scope.vm.form.filesave().then(function () {
					_getfile();
				});
			});
		};
	}]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-02-15
 说明     : 任务指标
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('missiontargetService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'missiontarget';
        // @@ 选项集
        this.picklists = ['StateCode', 'tasklevel', 'type', 'year', 'month'];
    }]).controller('missiontargetListController', ['$injector', '$scope', 'missiontargetService', function ($injector, $scope, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.showForm = _showForm;
        function _showForm() {
            var html = '<div rt-include rt-template="Module/MissionTarget/missiontargetExcelImportView.html" rt-controller="missiontargetExcelImportController" ></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '<span style="color:#09f"><i class="fa fa-download fa-2x"></i>　导出任务指标数据</span>',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_NORMAL,
                onshow: function onshow(dialog) {
                    //dialog.getModalHeader().hide();
                    //dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }
    }]).controller('missiontargetEditController', ['$injector', '$scope', 'missiontargetService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : SummerXu
 创建时间 : 2016-06-24
 说明     : 样板区县指标
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('modelcountytargetService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'modelcountytarget';
        // @@ 选项集
        this.picklists = ['StateCode', 'type', 'year', 'month'];
        //            this.getTerminalCode = function (id) {
        //                var url = "api/Account/GetDataById?id=" + id;
        //                return rt.get(url);
        //            }
    }]).controller('modelcountytargetListController', ['$injector', '$scope', '$timeout', 'modelcountytargetService', function ($injector, $scope, $timeout, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;

        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            var accids = "";
            var staskLevel = 0;
            var category = "";
            var tabSelectId = $scope.vm.view.selectedView.Id;
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    rt.errorMessage("只可查询同一年的数据");
                    return false;
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    rt.errorMessage("开始日期必须小于结束日期");
                    return false;
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if (!rt.isNull($scope.vm.productSelected) && $scope.vm.productSelected.length > 0) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                that.searchList.push({ Type: 2, Key: "productid", Value: pmap });
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }

            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            var accids = "";
            var staskLevel = 0;
            var category = "";
            var tabSelectId = $scope.vm.view.selectedView.Id;
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    rt.errorMessage("只可查询同一年的数据");
                    return false;
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    rt.errorMessage("开始日期必须小于结束日期");
                    return false;
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if (!rt.isNull($scope.vm.productSelected) && $scope.vm.productSelected.length > 0) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                that.searchList.push({ Type: 2, Key: "productid", Value: pmap });
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }

            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.showForm = _showForm;
        function _showForm() {
            var html = '<div rt-include rt-template="Module/MissionTarget/missiontargetExcelImportView.html" rt-controller="missiontargetExcelImportController" ></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '<span style="color:#09f"><i class="fa fa-download fa-2x"></i>　导出任务指标数据</span>',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_NORMAL,
                onshow: function onshow(dialog) {
                    //dialog.getModalHeader().hide();
                    //dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }

        //-新增多条件查询-CreateTime：2016-05-20-//

        $scope.vm.searchFormHide = true;
        $scope.vm.buidList = [];
        $scope.vm.buidSelected = null;
        $scope.vm.bigDepList = [];
        $scope.vm.bigDepSelected = null;
        $scope.vm.businessUnitList = [];
        $scope.vm.businessUnitSelected = [];
        $scope.vm.depType = 0;
        $scope.vm.OwnerName = "";
        //            $scope.vm.ClientName = "";

        _getAllBuid();
        _getAllProduct();

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }
        //-新增结束--//

        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }

        $scope.overHeightTable = function () {
            overHeightTable();
        };
        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }

        //--获取所有药品--//
        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = [];
            });
        }

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });

        //-新增结束--//
    }]).controller('modelcountytargetEditController', ['$injector', '$scope', 'modelcountytargetService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.$watch('vm.form.data.buid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.bigdept = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.bigdept.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.BusinessUnitId = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-03-01
 说明     : 月报
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('monthlyService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'monthlyreport';

        // @@ 选项集
        this.picklists = ['StateCode'];

        this.filesave = function (files) {
            if (files && files.length && files.length > 0) {
                $scope.selectedFiles = files;
                $scope.selectedFileName = files[0].name;
            }
        };
    }]).controller('monthlyListController', ['$scope', 'monthlyService', entityListController]).controller('monthlyEditController', ['$scope', 'monthlyService', entityEditController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016-06-28
 说明     : 新开发医院任务指标
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('newlyHospitalTaskService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'NewlyHospitalTask';
        // @@ 选项集
        this.picklists = ['StateCode', 'year', 'month'];
    }]).controller('newlyHospitalTaskListController', ['$injector', '$scope', '$timeout', 'newlyHospitalTaskService', function ($injector, $scope, $timeout, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;
        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    return "只可查询同一年的数据";
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    return "开始日期必须小于结束日期";
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join("','");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.staskLevel)) {
                that.searchList.push({ Type: 1, Key: "tasklevel", Value: $scope.vm.staskLevel.Value });
            }
            if (!rt.isNull($scope.vm.custom_category)) {
                that.searchList.push({ Type: 1, Key: "custom_category", Value: $scope.vm.custom_category.Id });
            }
            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    return "只可查询同一年的数据";
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    return "开始日期必须小于结束日期";
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join("','");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.showForm = _showForm;
        function _showForm() {
            var html = '<div rt-include rt-template="Module/MissionTarget/missiontargetExcelImportView.html" rt-controller="missiontargetExcelImportController" ></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '<span style="color:#09f"><i class="fa fa-download fa-2x"></i>　导出任务指标数据</span>',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_NORMAL,
                onshow: function onshow(dialog) {
                    //dialog.getModalHeader().hide();
                    //dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }
        //-新增多条件查询-CreateTime：2016-05-20-//

        $scope.vm.searchFormHide = true;
        $scope.vm.buidList = [];
        $scope.vm.buidSelected = null;
        $scope.vm.bigDepList = [];
        $scope.vm.bigDepSelected = null;
        $scope.vm.businessUnitList = [];
        $scope.vm.businessUnitSelected = [];
        $scope.vm.depType = 0;
        $scope.vm.OwnerName = "";
        $scope.vm.clickForm = function () {};
        _getAllBuid();

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }
        //-新增结束--//

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        $scope.overHeightTable = function () {
            overHeightTable();
        };
        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //-新增结束--//
    }]).controller('newlyHospitalTaskEditController', ['$injector', '$scope', 'newlyHospitalTaskService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        // $scope.vm.form.newsave = function () {
        //     if (!rt.isNull($scope.vm.form.data.qty) || !rt.isNull($scope.vm.form.data.amount)) {
        //         $scope.vm.form.save(false);
        //     }
        //     else {
        //         $scope.vm.form.save(false);
        //     }
        // }
        $scope.$watch('vm.form.data.buid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.bigdept = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.bigdept.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.BusinessUnitId = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-08-04
 说明     : odp医生
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odpDoctorService', ['entityService', '$timeout', '$http', function (entityService, $timeout, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'DoctorOdp';

        this.odp_url = localStorage.getItem("odp_url");
        this.token_type = localStorage.getItem("token_type");
        this.access_token = localStorage.getItem("access_token");

        //获取Odp的AccessToken
        this.GetAccessToken = function () {
            return rt.get("api/CourseOdp/GetAccessToken");
        };

        this.getOrganization = function () {
            var url = "api/Role/GetCurrentUserOrganization";
            return rt.get(url).error(function (msg) {
                rtAlert.errorMessage(msg);
            });
        };
    }]).controller('odpDoctorListController', ['$timeout', '$compile', '$scope', 'odpDoctorService', function ($timeout, $compile, $scope, myService) {
        var rt = myService.rt;

        function init() {
            $scope.vm = {};
            $scope.vm.getDataList = _getDataList; //查询按钮
            $scope.vm.data = []; //表格数据
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.hospitalGradeList = []; //医院等级（一级）
            $scope.vm.hospitalSecondGradeList = []; //医院等级（二级）
            $scope.vm.departmentFirstList = [];
            $scope.vm.departmentSecondList = [];
            $scope.vm.gradeSelected = null; //医院等级（一级）选择

            if (!rt.isNullOrWhiteSpace(myService.odp_url)) {
                _getAllGrade();
                _getFirstDepartment();
                _getDataList();
            } else {
                myService.GetAccessToken().then(function (resp) {
                    $scope.accessTokenModel = resp.data;
                    localStorage.setItem("odp_url", $scope.accessTokenModel.odp_url);
                    localStorage.setItem("token_type", $scope.accessTokenModel.token_type);
                    localStorage.setItem("access_token", $scope.accessTokenModel.access_token);
                    myService.odp_url = $scope.accessTokenModel.odp_url;
                    myService.token_type = $scope.accessTokenModel.token_type;
                    myService.access_token = $scope.accessTokenModel.access_token;
                    _getAllGrade();
                    _getFirstDepartment();
                    _getDataList();
                });
            }
        }

        init();

        $scope.vm.showRemarks = function (title, remarks) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/remarksPreviewView.html" rt-controller="remarksPreviewController" rt-include-params="{title:\'' + title + '\',remarks:\'' + remarks + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        $scope.$watch("vm.provinceSelected.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                $scope.vm.citySelected = null;
                $scope.vm.countySelected = null;
                return;
            }
        });

        $scope.$watch("vm.citySelected.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                $scope.vm.countySelected = null;
                return;
            }
        });

        $scope.$watch("vm.gradeSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                _getSecondGrade($scope.vm.gradeSelected.id);
            }
        });

        $scope.$watch("vm.firstDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                _getSecondDepartment($scope.vm.firstDepSelected.id);
            }
        });

        //获取所有医院
        function _getAllGrade() {
            rt.get3(myService.odp_url + "/api/Hospital/GetOdpHospitalGrade", myService.token_type, myService.access_token, true).then(function (resp) {
                $scope.vm.hospitalGradeList = resp.data;
                $scope.vm.hospitalGradeList.unshift({ name: '全部等级', id: '' });
                $scope.vm.gradeSelected = $scope.vm.hospitalGradeList[0];
            });
        }

        function _getSecondGrade(id) {
            rt.get3(myService.odp_url + "/api/Hospital/GetOdpHospitalSecondGrade?id=" + id, myService.token_type, myService.access_token, true).then(function (resp) {
                $scope.vm.hospitalSecondGradeList = resp.data;
            });
        }

        function _getFirstDepartment() {
            rt.get3(myService.odp_url + "/api/Hospital/GetFirstDepartment", myService.token_type, myService.access_token, true).then(function (resp) {
                $scope.vm.departmentFirstList = resp.data;
                $scope.vm.departmentFirstList.unshift({ name: '全部科室', id: '' });
                $scope.vm.firstDepSelected = $scope.vm.departmentFirstList[0];
            });
        }

        function _getSecondDepartment(id) {
            rt.get3(myService.odp_url + "/api/Hospital/GetSecondDepartment?id=" + id, myService.token_type, myService.access_token, true).then(function (resp) {
                $scope.vm.departmentSecondList = resp.data;
            });
        }

        function _getDataList() {
            var provinceid = !rt.isNull($scope.vm.provinceSelected) && !rt.isNullOrWhiteSpace($scope.vm.provinceSelected.Id) ? $scope.vm.provinceSelected.Id : "";
            var cityid = !rt.isNull($scope.vm.citySelected) && !rt.isNullOrWhiteSpace($scope.vm.citySelected.Id) ? $scope.vm.citySelected.Id : "";
            var countyid = !rt.isNull($scope.vm.countySelected) && !rt.isNullOrWhiteSpace($scope.vm.countySelected.Id) ? $scope.vm.countySelected.Id : "";
            var hospital = !rt.isNullOrWhiteSpace($scope.vm.hospital) ? $scope.vm.hospital : "";
            var department = !rt.isNull($scope.vm.firstDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.firstDepSelected.id) ? $scope.vm.firstDepSelected.id : "";
            var department2 = '';
            if (!rt.isNull($scope.vm.SecondDepSelected)) {
                var provincemap = $scope.vm.SecondDepSelected.map(function (item) {
                    return item.id;
                });
                department2 = provincemap.join(",");
            }
            var goodat = !rt.isNullOrWhiteSpace($scope.vm.goodat) ? $scope.vm.goodat : "";
            var grade = !rt.isNull($scope.vm.gradeSelected) && !rt.isNullOrWhiteSpace($scope.vm.gradeSelected.id) ? $scope.vm.gradeSelected.id : "";
            var grade2 = '';
            if (!rt.isNull($scope.vm.gradeSecondSelected)) {
                var provincemap = $scope.vm.gradeSecondSelected.map(function (item) {
                    return item.id;
                });
                grade2 = provincemap.join(",");
            }
            var isUndevelop = $scope.vm.isUndevelop ? $scope.vm.isUndevelop : false;
            myService.getOrganization().success(function (resp) {
                $scope.vm.code = resp.OrganizationCode;
            }).error(function (error) {
                rt.errorMessage(error);
            });

            var waiting = rt.showLoading2();
            rt.get3(myService.odp_url + "/api/DoctorOdp/GetDataList?hospitalid=" + "&provinceid=" + provinceid + "&cityid=" + cityid + "&countyid=" + countyid + "&hospital=" + hospital + "&department=" + department + "&secondDepartment=" + department2 + "&grade=" + grade + "&secondGrade=" + grade2 + "&goodat=" + goodat + "&isUndevelop=" + isUndevelop + "&organizationCode=" + $scope.vm.code + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + rt.getPaginationSize() + "&viewType=pc", myService.token_type, myService.access_token, true).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
            }).finally(function () {
                waiting.close();
            });
        }

        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }
    }]);
})();
'use strict';

// /********************************************************
//  Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//  创建人   : Tonny Huang
//  创建时间 : 2018-01-25
//  说明     : 专家大数据
//  *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odpDoctorKolService', ['entityService', '$timeout', '$http', function (entityService, $timeout, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'DoctorOdpKol';

        this.odp_url = localStorage.getItem("odp_url");
        this.token_type = localStorage.getItem("token_type");
        this.access_token = localStorage.getItem("access_token");

        //获取Odp的AccessToken
        this.GetAccessToken = function () {
            return rt.get("api/CourseOdp/GetAccessToken");
        };

        this.getOrganization = function () {
            var url = "api/Role/GetCurrentUserOrganization";
            return rt.get(url).error(function (msg) {
                rtAlert.errorMessage(msg);
            });
        };
    }]).service('odpDoctorKolArticalService', ['entityService', '$timeout', '$http', function (entityService, $timeout, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'DoctorOdpKol';

        this.odp_url = localStorage.getItem("odp_url");
        this.token_type = localStorage.getItem("token_type");
        this.access_token = localStorage.getItem("access_token");

        //获取Odp的AccessToken
        this.GetAccessToken = function () {
            return rt.get("api/CourseOdp/GetAccessToken");
        };

        this.getOrganization = function () {
            var url = "api/Role/GetCurrentUserOrganization";
            return rt.get(url).error(function (msg) {
                rtAlert.errorMessage(msg);
            });
        };
    }]).controller('odpDoctorKolListController', ['$injector', '$timeout', '$compile', '$scope', 'odpDoctorKolService', function ($injector, $timeout, $compile, $scope, myService) {
        var rt = myService.rt;

        function init() {
            $scope.vm = {};
            $scope.vm.getDataList = _getDataList; //查询按钮
            $scope.vm.data = []; //表格数据
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;

            if (!rt.isNullOrWhiteSpace(myService.odp_url)) {

                _getDataList();
            } else {
                myService.GetAccessToken().then(function (resp) {
                    $scope.accessTokenModel = resp.data;
                    localStorage.setItem("odp_url", $scope.accessTokenModel.odp_url);
                    localStorage.setItem("token_type", $scope.accessTokenModel.token_type);
                    localStorage.setItem("access_token", $scope.accessTokenModel.access_token);
                    myService.odp_url = $scope.accessTokenModel.odp_url;
                    myService.token_type = $scope.accessTokenModel.token_type;
                    myService.access_token = $scope.accessTokenModel.access_token;

                    _getDataList();
                });
            }
        }

        init();

        $scope.vm.hideForm = function () {
            $scope.vm.dialog.close();
        };

        // //只读
        $scope.vm.showForm = function (row, templateUrl, controllerName) {
            var data = JSON.stringify(row);
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=\'' + data + '\'></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        $scope.vm.showRemarks = function (title, remarks) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/remarksPreviewView.html" rt-controller="remarksPreviewController" rt-include-params="{title:\'' + title + '\',remarks:\'' + remarks + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        function _getDataList() {
            var name = !rt.isNullOrWhiteSpace($scope.vm.name) ? $scope.vm.name : "";

            myService.getOrganization().success(function (resp) {
                $scope.vm.code = resp.OrganizationCode;
            }).error(function (error) {
                rt.errorMessage(error);
            });

            var waiting = rt.showLoading2();
            rt.get3(myService.odp_url + "/api/DoctorKolOdp/GetDataList?strsearch=" + name + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + rt.getPaginationSize() + "&viewType=pc", myService.token_type, myService.access_token, true).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
            }).finally(function () {
                waiting.close();
            });
        }

        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }
    }]).controller('odpdoctorkolEditController', ['$injector', '$timeout', '$compile', '$scope', 'odpDoctorKolService', function ($injector, $timeout, $compile, $scope, myService) {
        var rt = myService.rt;
        var $compile = myService.$compile;
        var $stateParams = myService.$stateParams;
        var id = $stateParams.id; //获取实体id


        $scope.vm = {};
        $scope.vm.pageIndex = 1;
        $scope.vm.doctor = []; //表格数据

        $scope.vm.article = [];
        // $scope.vm.data = $scope.rtIncludeParams;
        function init() {
            $scope.vm.getDataList = _getDataList;
            $scope.vm.article = [];
            $scope.vm.doctor = [];
            $scope.vm.hide = _hide;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;

            if (!rt.isNullOrWhiteSpace(myService.odp_url)) {

                _getDataList();
            } else {
                myService.GetAccessToken().then(function (resp) {
                    $scope.accessTokenModel = resp.data;
                    localStorage.setItem("odp_url", $scope.accessTokenModel.odp_url);
                    localStorage.setItem("token_type", $scope.accessTokenModel.token_type);
                    localStorage.setItem("access_token", $scope.accessTokenModel.access_token);
                    myService.odp_url = $scope.accessTokenModel.odp_url;
                    myService.token_type = $scope.accessTokenModel.token_type;
                    myService.access_token = $scope.accessTokenModel.access_token;

                    _getDataList();
                });
            }
        }

        init();

        function _getDataList() {

            myService.getOrganization().success(function (resp) {
                $scope.vm.code = resp.OrganizationCode;
            }).error(function (error) {
                rt.errorMessage(error);
            });

            var waiting = rt.showLoading2();

            rt.get3(myService.odp_url + "/api/DoctorKolOdp/GetDoctorData?id=" + id + "&pageIndex=1" + "&pageSize=1" + "&viewType=pc", myService.token_type, myService.access_token, true).then(function (resp) {
                $scope.vm.doctor = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
            }).finally(function () {
                waiting.close();
            });

            rt.get3(myService.odp_url + "/api/DoctorKolOdp/GetArticleDataList?id=" + id + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + rt.getPaginationSize() + "&viewType=pc", myService.token_type, myService.access_token, true).then(function (resp) {
                $scope.vm.article = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
            }).finally(function () {
                waiting.close();
            });
        }
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        $scope.vm.showForm = function (row, templateUrl, controllerName) {
            var data = JSON.stringify(row);
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=\'' + data + '\'></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        $scope.delSelected = [];

        function _hide() {
            $(".sidebar-right").sidebar('hide');
        }
    }]).controller('odpdoctorkolarticalReadonlyController', ['$timeout', '$compile', '$scope', 'odpDoctorKolService', function ($timeout, $compile, $scope, myService) {
        var rt = myService.rt;

        $scope.vm = {};
        $scope.vm.data = [];
        $scope.vm.data = $scope.rtIncludeParams;
    }]).controller('odpdoctorkolarticalListController', ['$injector', '$timeout', '$compile', '$scope', 'odpDoctorKolArticalService', function ($injector, $timeout, $compile, $scope, myService) {
        var rt = myService.rt;
        var $compile = myService.$compile;
        var $stateParams = myService.$stateParams;
        var id = $stateParams.id; //获取实体id


        $scope.vm = {};
        $scope.vm.pageIndex = 1;

        $scope.vm.article = [];

        function init() {
            $scope.vm.getDataList = _getDataList;
            $scope.vm.article = [];
            $scope.vm.recordCount = 0;

            if (!rt.isNullOrWhiteSpace(myService.odp_url)) {

                _getDataList();
            } else {
                myService.GetAccessToken().then(function (resp) {
                    $scope.accessTokenModel = resp.data;
                    localStorage.setItem("odp_url", $scope.accessTokenModel.odp_url);
                    localStorage.setItem("token_type", $scope.accessTokenModel.token_type);
                    localStorage.setItem("access_token", $scope.accessTokenModel.access_token);
                    myService.odp_url = $scope.accessTokenModel.odp_url;
                    myService.token_type = $scope.accessTokenModel.token_type;
                    myService.access_token = $scope.accessTokenModel.access_token;

                    _getDataList();
                });
            }
        }

        init();

        function _getDataList() {

            myService.getOrganization().success(function (resp) {
                $scope.vm.code = resp.OrganizationCode;
            }).error(function (error) {
                rt.errorMessage(error);
            });

            var waiting = rt.showLoading2();
            rt.get3(myService.odp_url + "/api/DoctorKolOdp/GetArticleDataList?id=" + id + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + rt.getPaginationSize() + "&viewType=pc", myService.token_type, myService.access_token, true).then(function (resp) {
                $scope.vm.article = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
            }).finally(function () {
                waiting.close();
            });
        }
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        $scope.vm.showForm = function (row, templateUrl, controllerName) {
            var data = JSON.stringify(row);
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=\'' + data + '\'></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        $scope.delSelected = [];
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-08-01
 说明     : odp医院
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odpHospitalService', ['entityService', '$timeout', '$http', function (entityService, $timeout, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'DoctorOdp';

        this.odp_url = localStorage.getItem("odp_url");
        this.token_type = localStorage.getItem("token_type");
        this.access_token = localStorage.getItem("access_token");

        //获取Odp的AccessToken
        this.GetAccessToken = function () {
            return rt.get("api/CourseOdp/GetAccessToken");
        };

        this.getOrganization = function () {
            var url = "api/Role/GetCurrentUserOrganization";
            return rt.get(url).error(function (msg) {
                rtAlert.errorMessage(msg);
            });
        };
    }]).controller('odpHospitalListController', ['$timeout', '$compile', '$scope', 'odpHospitalService', function ($timeout, $compile, $scope, myService) {
        var rt = myService.rt;

        function init() {
            $scope.vm = {};
            $scope.vm.getDataList = _getDataList; //查询按钮
            $scope.vm.data = []; //表格数据
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.hospitalGradeList = []; //医院等级（一级）
            $scope.vm.hospitalSecondGradeList = []; //医院等级（二级）
            $scope.vm.gradeSelected = null; //医院等级（一级）选择

            if (!rt.isNullOrWhiteSpace(myService.odp_url)) {
                _getAllGrade();
                _getDataList();
            } else {
                myService.GetAccessToken().then(function (resp) {
                    $scope.accessTokenModel = resp.data;
                    localStorage.setItem("odp_url", $scope.accessTokenModel.odp_url);
                    localStorage.setItem("token_type", $scope.accessTokenModel.token_type);
                    localStorage.setItem("access_token", $scope.accessTokenModel.access_token);
                    myService.odp_url = $scope.accessTokenModel.odp_url;
                    myService.token_type = $scope.accessTokenModel.token_type;
                    myService.access_token = $scope.accessTokenModel.access_token;
                    _getAllGrade();
                    _getDataList();
                });
            }
        }

        init();

        $scope.vm.showRemarks = function (title, remarks) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/remarksPreviewView.html" rt-controller="remarksPreviewController" rt-include-params="{title:\'' + title + '\',remarks:\'' + remarks + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        $scope.$watch("vm.gradeSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                _getSecondGrade($scope.vm.gradeSelected.id);
            }
        });

        $scope.$watch("vm.provinceSelected.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                $scope.vm.citySelected = null;
                $scope.vm.countySelected = null;
                return;
            }
        });

        $scope.$watch("vm.citySelected.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                $scope.vm.countySelected = null;
                return;
            }
        });

        //获取所有医院
        function _getAllGrade() {
            rt.get3(myService.odp_url + "/api/Hospital/GetOdpHospitalGrade", myService.token_type, myService.access_token, true).then(function (resp) {
                $scope.vm.hospitalGradeList = resp.data;
                $scope.vm.hospitalGradeList.unshift({ name: '全部等级', id: '' });
                $scope.vm.gradeSelected = $scope.vm.hospitalGradeList[0];
            });
        }

        function _getSecondGrade(id) {
            rt.get3(myService.odp_url + "/api/Hospital/GetOdpHospitalSecondGrade?id=" + id, myService.token_type, myService.access_token, true).then(function (resp) {
                $scope.vm.hospitalSecondGradeList = resp.data;
            });
        }

        function _getDataList() {
            var provinceid = !rt.isNull($scope.vm.provinceSelected) && !rt.isNullOrWhiteSpace($scope.vm.provinceSelected.Id) ? $scope.vm.provinceSelected.Id : "";
            var cityid = !rt.isNull($scope.vm.citySelected) && !rt.isNullOrWhiteSpace($scope.vm.citySelected.Id) ? $scope.vm.citySelected.Id : "";
            var countyid = !rt.isNull($scope.vm.countySelected) && !rt.isNullOrWhiteSpace($scope.vm.countySelected.Id) ? $scope.vm.countySelected.Id : "";
            var hospital = !rt.isNullOrWhiteSpace($scope.vm.hospital) ? $scope.vm.hospital : "";
            var department = !rt.isNullOrWhiteSpace($scope.vm.department) ? $scope.vm.department : "";
            var grade = !rt.isNull($scope.vm.gradeSelected) && !rt.isNullOrWhiteSpace($scope.vm.gradeSelected.id) ? $scope.vm.gradeSelected.id : "";
            var grade2 = '';
            if (!rt.isNull($scope.vm.gradeSecondSelected)) {
                var provincemap = $scope.vm.gradeSecondSelected.map(function (item) {
                    return item.id;
                });
                grade2 = provincemap.join(",");
            }
            var isUndevelop = $scope.vm.isUndevelop ? $scope.vm.isUndevelop : false;
            myService.getOrganization().success(function (resp) {
                $scope.vm.code = resp.OrganizationCode;
            }).error(function (error) {
                rt.errorMessage(error);
            });

            var waiting = rt.showLoading2();
            rt.get3(myService.odp_url + "/api/Hospital/GetDataList?provinceid=" + provinceid + "&cityid=" + cityid + "&countyid=" + countyid + "&hospital=" + hospital + "&department=" + department + "&grade=" + grade + "&secondGrade=" + grade2 + "&isUndevelop=" + isUndevelop + "&organizationCode=" + $scope.vm.code + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + rt.getPaginationSize() + "&viewType=pc", myService.token_type, myService.access_token, true).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
            }).finally(function () {
                waiting.close();
            });
        }

        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-08-04
 说明     : odp医生
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odpDrugStoreService', ['entityService', '$timeout', '$http', function (entityService, $timeout, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'DrugStoreOdp';

        this.odp_url = localStorage.getItem("odp_url");
        this.token_type = localStorage.getItem("token_type");
        this.access_token = localStorage.getItem("access_token");

        //获取Odp的AccessToken
        this.GetAccessToken = function () {
            return rt.get("api/CourseOdp/GetAccessToken");
        };

        this.getOrganization = function () {
            var url = "api/Role/GetCurrentUserOrganization";
            return rt.get(url).error(function (msg) {
                rtAlert.errorMessage(msg);
            });
        };
    }]).controller('odpDrugStoreListController', ['$timeout', '$compile', '$scope', 'odpDrugStoreService', function ($timeout, $compile, $scope, myService) {
        var rt = myService.rt;

        function init() {
            $scope.vm = {};
            $scope.vm.getDataList = _getDataList; //查询按钮
            $scope.vm.data = []; //表格数据
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;

            if (!rt.isNullOrWhiteSpace(myService.odp_url)) {
                _getDataList();
            } else {
                myService.GetAccessToken().then(function (resp) {
                    $scope.accessTokenModel = resp.data;
                    localStorage.setItem("odp_url", $scope.accessTokenModel.odp_url);
                    localStorage.setItem("token_type", $scope.accessTokenModel.token_type);
                    localStorage.setItem("access_token", $scope.accessTokenModel.access_token);
                    myService.odp_url = $scope.accessTokenModel.odp_url;
                    myService.token_type = $scope.accessTokenModel.token_type;
                    myService.access_token = $scope.accessTokenModel.access_token;
                    _getDataList();
                });
            }
        }

        init();

        $scope.$watch("vm.provinceSelected.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                $scope.vm.citySelected = null;
                $scope.vm.countySelected = null;
                return;
            }
        });

        $scope.$watch("vm.citySelected.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                $scope.vm.countySelected = null;
                return;
            }
        });

        function _getDataList() {
            var provinceid = !rt.isNull($scope.vm.provinceSelected) && !rt.isNullOrWhiteSpace($scope.vm.provinceSelected.Id) ? $scope.vm.provinceSelected.Id : "";
            var cityid = !rt.isNull($scope.vm.citySelected) && !rt.isNullOrWhiteSpace($scope.vm.citySelected.Id) ? $scope.vm.citySelected.Id : "";
            var countyid = !rt.isNull($scope.vm.countySelected) && !rt.isNullOrWhiteSpace($scope.vm.countySelected.Id) ? $scope.vm.countySelected.Id : "";
            var drugstore = !rt.isNullOrWhiteSpace($scope.vm.drugstore) ? $scope.vm.drugstore : "";
            var isUndevelop = $scope.vm.isUndevelop ? $scope.vm.isUndevelop : false;
            myService.getOrganization().success(function (resp) {
                $scope.vm.code = resp.OrganizationCode;
            }).error(function (error) {
                rt.errorMessage(error);
            });

            var waiting = rt.showLoading2();
            rt.get3(myService.odp_url + "/api/DrugStoreOdp/GetDataList?provinceid=" + provinceid + "&cityid=" + cityid + "&countyid=" + countyid + "&drugstore=" + drugstore + "&isUndevelop=" + isUndevelop + "&organizationCode=" + $scope.vm.code + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + rt.getPaginationSize(), myService.token_type, myService.access_token, true).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
            }).finally(function () {
                waiting.close();
            });
        }

        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Sakina Wu
 创建时间 : 2015-01-05
 说明     : 意向信息
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('opportunityService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'opportunity';

        // @@ 选项集
        this.picklists = ['StateCode', 'salesstage', 'lostreason', 'budget_unitprice'];
    }]).controller('opportunityListController', ['$scope', 'opportunityService', entityListController]).controller('opportunityEditController', ['$injector', '$scope', 'opportunityService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $compile = myService.$compile;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.Order = _Order;
        $scope.Maintain = _Maintain;
        $scope.HideForm = _hideForm;
        $scope.ReFresh = _refresh;

        //生成订单点击事件
        function _Order(data, id) {
            //查询是否有意向明细
            var url = 'api/Opportunity/IsOpportunityProduct?opportunityid=' + id;
            rt.get(url).then(function (resp) {
                $scope.vm.hasproduct = false;
                $scope.vm.hasproduct = resp.data;
            });
            if ($scope.vm.hasproduct == false) {
                rt.errorMessage("未选样"); //应控制在意向刚生成的时候-需修改
            }
            if ($scope.vm.hasproduct == true) {
                //生成订单和订单明细
                var waiting = rt.showWaiting();
                var url = 'api/Opportunity/CreateSalesOrder?opportunityid=' + id;
                rt.post(url, data);
                waiting.close();
            }
        }

        //意向阶段维护点击事件
        function _Maintain(id) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/Opportunity/opportunityMaintain.html" rt-controller="opportunityMaintainController" rt-include-params="{opportunityid:\'' + id + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }

        //关闭对话框
        function _hideForm() {
            $scope.vm.dialog.close();
            _refresh();
        }

        //刷新
        function _refresh() {
            $scope.$emit('rt-reload');
            $scope.$broadcast('rt-reload');
        }
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Sakina Wu
 创建时间 : 2015-01-05
 说明     : 意向明细
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('opportunityProductService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'opportunityProduct';

        // @@ 选项集
        this.picklists = ['StateCode'];

        // @@查询意向状态
        this.getCode = function (opportunityid) {
            var url = 'api/Opportunity/OpportunityState?opportunityid=' + opportunityid;
            return rt.get(url);
        };

        //根据选择的产品名称查找对应的产品编码
        this.getBarCode = function (productid) {
            var url = "api/Product/GetBarCode?productid=" + productid;
            return rt.get(url);
        };
    }]).controller('opportunityProductListController', ['$injector', '$scope', 'opportunityProductService', 'rt', function ($injector, $scope, myService, rt) {
        //  var $compile = myService.$compile;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        //获取意向状态-销售阶段
        $scope.$on('rt-reload', _refreshstate);
        function _refreshstate() {
            var url = 'api/Opportunity/OpportunityState?opportunityid=' + $scope.$parent.vm.form.id;
            rt.get(url).then(function (resp) {
                $scope.vm.opportunity = resp.data;
            });
        }

        //获取意向状态-销售阶段
        var url = 'api/Opportunity/OpportunityState?opportunityid=' + $scope.$parent.vm.form.id;
        rt.get(url).then(function (resp) {
            $scope.vm.opportunity = resp.data;
        });
    }]).controller('opportunityProductEditController', ['$injector', '$scope', 'opportunityProductService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        // 根据意向明细id查找意向状态
        $scope.$watch('vm.form.data.opportunityid', function () {
            if (!rt.isNull($scope.vm.form.data.opportunityid)) {
                var id = $scope.vm.form.data.opportunityid.Id;
                myService.getCode(id).then(function (data) {
                    $scope.vm.form.data.opportunity = data.data;
                });
            }
        });

        //根据选择的产品名称查找对应的产品编码
        $scope.$watch('vm.form.data.productid.Id', function () {
            if (!rt.isNull($scope.vm.form.data.productid)) {
                var productid = $scope.vm.form.data.productid.Id;
                myService.getBarCode(productid).then(function (data) {
                    $scope.vm.form.data.barcode = data.data;
                });
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-10-11
 说明     : 组织信息
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('OrganizationInfoService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'OrganizationInfo';

        // @@ 选项集
        this.picklists = ['Action_status'];
    }]).controller('organizationinfoListController', ['$injector', '$scope', 'OrganizationInfoService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.orginfodata = {};

        function _isPhoneNumber(str) {
            /// <summary>
            ///检查是否是手机号码或者电话号码
            ///</summary>

            var p1 = /^\(?0\d{2,3}\)?[- ]?\d{7,8}(-\d{3,4})?$/;
            var p2 = /^1\d{10}$/;
            if (p1.test(str) || p2.test(str)) return true;else return false;
        }

        getInfo();
        function getInfo() {
            rt.get("api/OrganizationInfo/GetInfo").then(function (resp) {
                $scope.orginfodata = resp.data;
            });
        };

        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.orginfodata.name)) {
                return "请填写名称。";
            } else {
                if (!rt.isNullOrWhiteSpace($scope.orginfodata.telphone)) {
                    if (!_isPhoneNumber($scope.orginfodata.telphone)) {
                        return "请填写正确的电话。";
                    } else {
                        return "";
                    }
                }
            }
        };

        //保存和保存并新建按钮
        $scope.rsave = function (datainfo) {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            } else {
                var waiting = rt.showWaiting();
                rt.post("api/OrganizationInfo/SaveInfo", datainfo).then(function () {
                    // 刷新数据
                    $scope.$emit('rt-reload');
                    $scope.$broadcast('rt-reload');
                    rt.successMessage("保存成功！");
                }).finally(function () {
                    waiting.close();
                });
            }
        };
    }]).controller('organizationinfoEditController', ['$scope', 'OrganizationInfoService', entityEditController]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2015-04-15
说明     : 积分调整
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('pointsAdjustmentService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'pointsAdjustment';

        // @@ 选项集
        this.picklists = ['StateCode', 'pointsadjustmenttype', 'points_adjustment_state'];

        this.confirm = function (id) {
            var url = "api/pointsAdjustment/Confirm?id=" + id;
            return rt.post(url);
        };
    }]).controller('pointsAdjustmentListController', ['$scope', 'pointsAdjustmentService', entityListController]).controller('pointsAdjustmentEditController', ['$injector', '$scope', 'pointsAdjustmentService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.confirm = function () {
            var waiting = rt.showWaiting();
            myService.confirm($scope.vm.form.id).then(function () {
                // 刷新数据
                $scope.$emit('rt-reload');

                waiting.close();
                rt.successMessage("确认成功。");
            });
        };

        // 保存之前，进行验证             
        $scope.vm.form.validateSave = function (obj) {
            //规则失效时间与规则生效时间的大小
            if (rt.isNull($scope.vm.form.data.adjustmentdate) === false && $scope.vm.form.data.adjustmentdate !== "" && rt.isNull($scope.vm.form.data.expirydate) === false && $scope.vm.form.data.expirydate !== "") {
                var dts = stringTrim($scope.vm.form.data.adjustmentdate);
                var dte = stringTrim($scope.vm.form.data.expirydate);
                if (moment(dte).isBefore(dts)) {
                    rt.errorMessage("积分失效日期必须大于积分生效日期。");
                    return;
                }
            }

            //保存
            $scope.vm.form.save(obj);
        };

        //string 去除空格
        function stringTrim(str) {
            return str.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
        }
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2015-04-15
说明     : 积分兑换申请
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('pointsExchangeService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'pointsExchange';

        // @@ 选项集
        this.picklists = ['StateCode', 'exchangestype', 'points_exchange_state'];

        // 确认操作，修改会员积分中的已消费积分和可用积分
        this.confirm = function (id) {
            var url = "api/pointsExchange/Confirm?pointsExchangeId=" + id;
            return rt.post(url);
        };
    }]).controller('pointsExchangeListController', ['$scope', 'pointsExchangeService', entityListController]).controller('pointsExchangeEditController', ['$injector', '$scope', 'pointsExchangeService', 'pointsExchangeRuleService', function ($injector, $scope, myService, pointsExchangeRuleService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //根据应用兑换规则带出兑换类型、使用积分
        $scope.$watch('vm.form.data.points_exchange_ruleid.Id', function (newValue, oldValue, scope) {
            if ($scope.vm.form.data.points_exchange_ruleid != undefined) {
                //判断当前的会员是否有选择了,或是新建
                if (rt.isNull(oldValue) === false || $scope.vm.form.type === 'Create') {
                    var waiting1 = rt.showLoading2();
                    pointsExchangeRuleService.getData($scope.vm.form.data.points_exchange_ruleid.Id).then(function (resp) {
                        //兑换类型
                        $scope.vm.form.data.exchangestype = resp.data.exchangestype;
                        //礼品
                        $scope.vm.form.data.productid = resp.data.productid;
                        //消费券
                        $scope.vm.form.data.vouchersid = resp.data.vouchersid;
                        //使用积分
                        $scope.vm.form.data.ammount = resp.data.consumption;
                        waiting1.close();
                    });
                }
            }
        });

        // 确认操作，修改会员积分中的已消费积分和可用积分
        $scope.vm.form.confirm = function () {
            var waiting2 = rt.showWaiting();
            myService.confirm($scope.vm.form.id).then(function () {
                // 刷新数据
                $scope.$emit('rt-reload');

                waiting2.close();
                rt.successMessage("确认成功。");
            });
        };

        //保存之前进行验证
        $scope.vm.form.validateSave = function (obj) {
            var sDate = moment(stringTrim($scope.vm.form.data.exchangedate));
            var nowDate = moment();
            if (sDate.isValid()) {
                if (sDate > nowDate) {
                    rt.errorMessage("兑换日期不能大于当前时间。");
                    return;
                }
            } else {
                $scope.vm.form.data.exchangedate = null;
            }
            //保存
            $scope.vm.form.save(obj);
        };

        //string 去除空格
        function stringTrim(str) {
            if (!rt.isNull(str)) {
                return str.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
            } else {
                return null;
            }
        }

        //计算总积分
        $scope.$watch('vm.form.data.quantity', function (newValue, oldValue, scope) {
            if ($scope.vm.form.data.quantity != "" && rt.isNull($scope.vm.form.data.quantity) === false && $scope.vm.form.data.ammount != "" && rt.isNull($scope.vm.form.data.ammount) === false) {
                $scope.vm.form.data.totalpoints = $scope.vm.form.data.quantity * $scope.vm.form.data.ammount;
            } else {
                $scope.vm.form.data.totalpoints = 0;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Chad Chen
 创建时间 : 2015-04-15
 说明     : 积分兑换规则
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('pointsExchangeRuleService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'pointsExchangeRule';

        // @@ 选项集
        this.picklists = ['StateCode', 'exchangestype', 'points_rule_state'];

        // 发布积分规则
        this.publish = function (id) {
            var url = "api/pointsExchangeRule/Publish?id=" + id;
            return rt.post(url);
        };

        // @@ 多选字段
        this.mutipleSelects = ['Tiers'];
    }]).controller('pointsExchangeRuleListController', ['$scope', 'pointsExchangeRuleService', entityListController]).controller('pointsExchangeRuleEditController', ['$injector', '$scope', 'pointsExchangeRuleService', 'memberLevelService', function ($injector, $scope, myService, memberLevelService) {
        var rt = myService.rt;
        var $q = myService.$q;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        // 加载会员等级列表
        //var waiting = rt.showWaiting();
        //$q.all([
        //    memberLevelService.GetAllTierList()
        //]).then(function (responses) {
        //    $scope.vm.form.tiers = responses[0].data;

        //    waiting.close();
        //});

        // 保存之前，比较时间大小            
        $scope.vm.form.validateSave = function (obj) {
            if (rt.isNull($scope.vm.form.data.exchangesstarton) === false && $scope.vm.form.data.exchangesstarton !== "" && rt.isNull($scope.vm.form.data.exchangesendon) === false && $scope.vm.form.data.exchangesendon !== "") {
                var dts = stringTrim($scope.vm.form.data.exchangesstarton);
                var dte = stringTrim($scope.vm.form.data.exchangesendon);
                if (moment(dte).isBefore(dts)) {
                    rt.errorMessage("兑换截至时间必须大于兑换开始时间。");
                    return;
                }
            }

            //判断所需积分是否为负数
            if (isNumeric($scope.vm.form.data.consumption)) {
                if ($scope.vm.form.data.consumption < 0) {
                    rt.errorMessage("所需积分不能为负数。");
                    return;
                }
            }

            //判断兑换数量限制是否勾选
            if (rt.isNull($scope.vm.form.data.exchange_requirements)) {
                $('#strategy').tooltip({ trigger: 'manual', placement: 'right', title: "请选择兑换数量限制。" });
                $('#strategy').tooltip('show');
                return;
            } else {
                $('#strategy').tooltip('hide');
            }

            //保存
            $scope.vm.form.save(obj);
        };

        //string 去除空格
        function stringTrim(str) {
            return str.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
        }

        // 发布积分兑换规则
        $scope.vm.form.publish = function () {
            var waiting = rt.showWaiting();
            myService.publish($scope.vm.form.id).then(function () {
                // 刷新数据
                $scope.$emit('rt-reload');

                waiting.close();
                rt.successMessage("发布成功。");
            });
        };

        // 检查是否为数字（实数）
        function isNumeric(strNumber) {
            var newPar = /^(-|\+)?\d+(\.\d+)?$/;
            if (newPar.test(strNumber)) return true;else return false;
        }
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2015-04-15
说明     : 积分交易记录
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('pointsHistoryService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'pointsHistory';

        // @@ 选项集
        this.picklists = ['StateCode', 'pointstransactiontype'];
    }]).controller('pointsHistoryListController', ['$scope', 'pointsHistoryService', entityListController]).controller('pointsHistoryEditController', ['$scope', 'pointsHistoryService', entityEditController]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2016-08-16
说明     : DC
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('prescriptionService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'prescription';

        //获取明细列表
        this.getDetails = function (prescriptionid) {
            var apiUrl = "api/Prescription/GetDetails?prescriptionid=" + prescriptionid;
            return rt.get(apiUrl);
        };
    }]).controller('prescriptionListController', ['$scope', 'prescriptionService', entityListController]).controller('prescriptionEditController', ['$injector', '$scope', 'prescriptionService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        this.loadComplete = function () {
            myService.getDetails($scope.vm.form.data.Id).then(function (resp) {
                $scope.vm.form.data.DetailList = resp.data;
            });

            // 默认为当前用户
            if (rt.isNull($scope.vm.form.data.OwnerId)) {
                $scope.vm.form.data.OwnerId = {
                    Id: rt.getUserId(),
                    Name: rt.getUserName()
                };
            }

            // 默认带出年月
            if (!rt.isNull($scope.vm.form.data.year_month)) {
                var mObj = moment($scope.vm.form.data.year_month, 'YYYYMM', true);
                $scope.vm.ym = mObj.format("YYYY-MM");
            }
        };

        this.preSave = function () {
            // 根据选择的年月给实体字段赋值
            if (!rt.isNull($scope.vm.ym)) {
                var mObj = moment($scope.vm.ym, 'YYYY-MM', true);
                $scope.vm.form.data.year = mObj.year();
                $scope.vm.form.data.month = mObj.month() + 1;
            }
        };

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Mona Xia
创建时间 : 2016-08-17
说明     : DC明细
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('prescriptionDetailService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'prescriptionDetail';

        this.updateQTY = function (id, qty, prescriptionid) {
            var url = "api/prescription/UpdateQTY?detailId=" + id + "&qty=" + qty + "&prescriptionid=" + prescriptionid;
            return rt.post(url);
        };
    }]).controller('prescriptionDetailListController', ['$scope', 'prescriptionDetailService', entityListController]).controller('prescriptionDetailEditController', ['$injector', '$scope', 'prescriptionDetailService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ ������̩��Ϣ�������޹�˾ All rights reserved.
 ������   : Sakina Wu
 ����ʱ�� : 2016-01-15
 ˵��     : �۸�
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('priceService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@����WebAPI�Ŀ���������
        this.controllerName = 'price';

        // @@ ѡ�
        this.picklists = ['StateCode', 'pricetype'];

        //ѡ���Ʒ���Ʋ��Ҷ�Ӧ�Ĳ�Ʒ����
        this.getBarCode = function (productid) {
            var url = "api/Product/GetBarCode?productid=" + productid;
            return rt.get(url);
        };
    }]).controller('priceListController', ['$scope', 'priceService', entityListController]).controller('priceEditController', ['$injector', '$scope', 'customcategorydetailService', 'priceService', function ($injector, $scope, customcategorydetailService, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.vm.isRegularPrice = false;
        //加载完成
        $scope.vm.form.loadComplete = function () {
            if ($scope.vm.form.data.pricetype.Value === 10) {
                $scope.vm.isRegularPrice = true;
            }
        };
        //价格类型
        $scope.$watch('vm.form.data.pricetype.Value', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (newValue === 10) {
                    //标准价
                    $scope.vm.isRegularPrice = true;
                } else {
                    //活动价
                    $scope.vm.isRegularPrice = false;
                }
            }
        });
        //带出药品规格
        $scope.$watch("vm.form.data.productid.Id", function (newValue, oldValue) {
            if (!rt.isNull($scope.vm.form.data.productid)) {
                myService.getBarCode($scope.vm.form.data.productid.Id).then(function (data) {
                    $scope.vm.form.data.barcode = data.data;
                });
            };
            if (oldValue != newValue) {
                //带出药品规格
                customcategorydetailService.getProductSize($scope.vm.form.data.productid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.form.data.product_size = resp.data.productsize;
                    } else {
                        $scope.vm.form.data.product_size = '';
                    }
                });
                return;
            }
        });
        //保存前
        $scope.vm.form.preSave = function () {
            if ($scope.vm.form.data.begindate && $scope.vm.form.data.enddate) {
                var st = $scope.vm.form.data.begindate.replace(/-/g, "/");
                var et = $scope.vm.form.data.enddate.replace(/-/g, "/");
                var starttime = new Date(st);
                var endtime = new Date(et);
                if (starttime.getTime() > endtime.getTime()) {
                    rt.warningMessage("价格结束时间不能小于开始时间");
                    return "价格结束时间不能小于开始时间";
                }
            }
        };
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Berry Ding
创建时间 : 2016-01-29
说明     : 药品
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('productService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'product';

        // @@ 选项集
        this.picklists = ['prepn_type', 'StateCode'];
    }]).controller('productListController', ['$scope', 'productService', entityListController]).controller('productEditController', ['$scope', 'productService', entityEditController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2017/05/12
 说明     : 流向数据-产品别名 Service
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('productaliasService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'ProductAlias';
        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getProductSizeById = function (id) {
            var url = 'api/Product/GetProductById?id=' + id;
            return rt.get(url);
        };
    }]).controller('productaliasListController', ['$injector', '$scope', 'productaliasService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('productaliasEditController', ['$injector', '$scope', 'productaliasService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.product_alias_radio", function (newValue, oldValue) {
            if (rt.isNull(newValue)) {
                $scope.vm.form.data.product_alias_radio = 1;
                return;
            }
            if (newValue != oldValue) {
                $scope.vm.form.data.product_alias_radio = newValue;
            }
        });

        //选择药品后自动带出药品规格
        $scope.$watch("vm.form.data.productid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                myService.getProductSizeById($scope.vm.form.data.productid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.form.data.productsize = resp.data.productsize;
                    } else {
                        $scope.vm.form.data.productsize = '';
                    }
                });
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
创建人   : Berry Ding
创建时间 : 2018/1/4
说明     : 产品箱毛利
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('productBoxProfitService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        this.controllerName = 'ProductBoxProfit';
    }]).controller('productBoxProfitListController', ['$scope', 'productBoxProfitService', entityListController]).controller('productBoxProfitEditController', ['$injector', '$scope', 'customcategorydetailService', 'productBoxProfitService', function ($injector, $scope, customcategorydetailService, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //带出药品规格
        $scope.$watch("vm.form.data.productid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (rt.isNull($scope.vm.form.data.productid)) {
                    $scope.vm.form.data.productsize = '';
                } else {
                    //带出药品规格
                    customcategorydetailService.getProductSize($scope.vm.form.data.productid.Id).then(function (resp) {
                        if (!rt.isNull(resp.data)) $scope.vm.form.data.productsize = resp.data.productsize;
                    });
                }
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-01-29
 说明     : 药品类别
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('productCategoryService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'productCategory';

        // @@ 选项集
        this.picklists = ['StateCode'];

        // 获取最小类别的药品类别列表
        this.getSmallestDataList = function () {
            var apiUrl = 'api/ProductCategory/GetSmallestDataList';
            return rt.get(apiUrl);
        };

        this.getTreeList = function (stateCode) {
            return rt.get("api/ProductCategory/GetProductCategoryTree?stateCode=" + stateCode);
        };

        this.getProductViewData = function (productCategoryId, pageIndex, searchText) {
            if (productCategoryId === '9185EB0B-3E4A-4065-98D8-B9B8199D45E0' || productCategoryId === undefined) productCategoryId = '';
            return rt.get("api/Product/GetProductinCategoryData?productCategoryId=" + productCategoryId + "&searchText=" + searchText + "&pageSize=" + rt.getPaginationSize() + "&pageIndex=" + pageIndex);
        };

        this.delCategoryById = function (ids) {
            return rt.post("api/ProductCategory/DeleteData", JSON.stringify(ids));
        };

        this.delProductsByIds = function (ids) {
            return rt.post("api/Product/DeleteData", JSON.stringify(ids));
        };
    }]).controller('productCategoryListController', ['$scope', '$state', '$injector', 'productCategoryService', function ($scope, $state, $injector, myService) {
        var rt = myService.rt;

        this.reload = function () {
            myService.getProductViewData($scope.mytree.currentNode === undefined ? '' : $scope.mytree.currentNode.Id, $scope.vm.page.index, rt.isNullOrEmptyString($scope.vm.view.searchText) ? '' : $scope.vm.view.searchText).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.page.recordCount = resp.data.TotalRecords;
                $scope.$broadcast('rt-off-datagrid-all-row-checked'); //操作完成刷新多选框未复原问题
                // 修正页面的高度
                $.AdminLTE.layout.fix();
            }).then($scope.vm.actions.loadComplete());
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.vm.reloadTree = true;

        $scope.selectedViewClick = function () {
            $scope.vm.reloadTree = true;
        };

        $scope.vm.categoryeditclick = function () {
            $scope.vm.reloadTree = true;
        };

        $scope.vm.actions.loadComplete = function () {
            var stateCode = '';
            switch ($scope.vm.view.selectedView.Id) {
                case "9185EB0B-3E4A-4065-98D8-B9B8199D45E0":
                    stateCode = "0"; //可用
                    break;
                case "83033557-6807-429E-B0CE-A01419AC0D1F":
                    stateCode = "1"; //停用
                    break;
                case "FA01377A-DDA4-4258-963C-3C3DC04382D3":
                    stateCode = ''; //全部
                    break;
                default:
                    StateCode = "0";
                    break;
            }
            if ($scope.vm.reloadTree) getTreeList(stateCode);
        };

        function getTreeList(stateCode) {
            $scope.mytree.currentNode = {};
            $scope.vm.hasChildren = true;
            $scope.roleList = [];
            $scope.vm.reloadTree = false;
            myService.getTreeList(stateCode).then(function (resp) {
                if (rt.isNull(resp.data)) return;
                $scope.roleList = resp.data;
            });
        }

        /**
         * 删除产品
         */
        $scope.vm.delProductsByIds = function () {
            var selectedIdLength = $scope.vm.view.selectedIds.length;
            if (selectedIdLength === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + selectedIdLength + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    // 隐藏已打开的表单
                    $scope.vm.actions.hideForm();

                    myService.delProductsByIds($scope.vm.view.selectedIds).then(function (resp) {
                        rt.successMessage(rt.isNull(resp.data) || resp.data.length === 0 ? '成功删除记录。' : resp.data);

                        // 刷新数据
                        $scope.$emit('rt-reload');
                    });
                }
            });
        };

        /**
         * 删除品类
         */
        $scope.vm.delCategory = function (currentNode) {

            if (rt.isNullOrEmptyString(currentNode.Id)) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您已选择了 ' + currentNode.Name + ' 品种记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {

                    if ($scope.vm.hasChildren) {
                        rt.errorMessage('当前品种有下级品种，不允许删除');
                        return;
                    }

                    var selectedIds = [];
                    selectedIds.push(currentNode.Id);

                    // 隐藏已打开的表单
                    $scope.vm.actions.hideForm();

                    myService.delCategoryById(selectedIds).then(function (resp) {
                        rt.successMessage(rt.isNull(resp.data) || resp.data.length === 0 ? '成功删除记录。' : resp.data);

                        $scope.vm.reloadTree = true;
                        // 刷新数据
                        $scope.$emit('rt-reload');
                    });
                }
            });
        };

        $scope.$watch("mytree.currentNode.Id", function (newValue, oldValue) {
            if (newValue == oldValue) return;
            $scope.vm.page.index = 1;

            if (newValue !== undefined) $scope.vm.hasChildren = $scope.mytree.currentNode.Children !== undefined && $scope.mytree.currentNode.Children.length > 0;

            getProductData(newValue, $scope.vm.page.index, "");
        });

        function getProductData(productCategoryId, pageIndex, searchText) {
            if (productCategoryId === undefined) productCategoryId = '';
            myService.getProductViewData(productCategoryId, pageIndex, searchText).then(function (resp) {
                if (rt.isNull(resp.data)) return;
                $scope.vm.data = resp.data.DataList;
                $scope.vm.page.recordCount = resp.data.TotalRecords;
            });
        }

        $scope.vm.searchClick = function () {
            getProductData('', $scope.vm.page.index, rt.isNullOrEmptyString($scope.vm.view.searchText) ? '' : $scope.vm.view.searchText);
        };

        $scope.vm.mytreedbclick = function () {
            $state.go("main.productCategory.editcategory", { id: $scope.mytree.currentNode.Id, hasChildren: $scope.vm.hasChildren });
        };
    }]).controller('productCategoryEditController', ['$injector', '$scope', 'productCategoryService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.hasChildren = myService.$stateParams.hasChildren === "true";

        $scope.vm.bigImg = { id: '', fileName: '', imageSrc: '', base64Content: '', file: null };
        $scope.vm.smallImg = { id: '', fileName: '', imageSrc: '', base64Content: '', file: null };

        $scope.vm.delCategory = function () {
            rt.confirm("确认删除？", function (ok) {
                if (ok) {
                    if ($scope.vm.hasChildren) {
                        rt.errorMessage('当前品种有下级品种，不允许删除');
                        return;
                    }

                    var waiting = rt.showWaiting();
                    myService.delData([$scope.vm.form.id]).then(function (resp) {
                        rt.successMessage(rt.isNull(resp.data) || resp.data.length === 0 ? '成功删除记录。' : resp.data);

                        $scope.$emit('rt-on-dialog-close-click');
                    }).finally(function () {
                        waiting.close();
                    });
                }
            });
        };

        $scope.vm.deactivateCategory = function () {
            rt.confirm("确认停用选定的记录？", function (ok) {
                if (ok) {

                    if ($scope.vm.hasChildren) {
                        rt.errorMessage('当前品种有下级品种，不允许停用');
                        return;
                    }

                    var waiting = rt.showWaiting();
                    myService.deactivateData([$scope.vm.form.id]).then(function (resp) {
                        rt.successMessage(rt.isNull(resp.data) || resp.data.length === 0 ? '成功停用记录。' : resp.data);

                        // 刷新数据
                        $scope.$emit('rt-reload');
                    }).finally(function () {
                        waiting.close();
                    });
                }
            });
        };

        //选择图片
        $scope.vm.form.fileSelect = function (files, type) {
            if (!rt.isEmptyArray(files)) {
                if (files.length > 1) {
                    rt.errorMessage("图片不能超过1张");
                    return;
                }

                if (files[0].size > 102400) {
                    //单位是字节，此处不允许超过100k
                    rt.errorMessage("图片不能超过100k");
                    return;
                }

                var fileType = files[0].name.substring(files[0].name.lastIndexOf(".") + 1, files[0].name.length).toLowerCase();

                if (fileType != 'jpg' && fileType != 'png' && fileType != 'jpeg') {
                    rt.errorMessage("图片格式只支持:JPG,PNG,JPEG");
                    return;
                }

                readAsDataURL(files[0], $scope).then(function (result) {
                    if (type == 'small') {
                        $scope.vm.smallImg = {
                            id: rt.isNullOrWhiteSpace($scope.vm.jsonimageId.smallid.objectid) ? rt.newGuid() : $scope.vm.jsonimageId.smallid.objectid,
                            fileName: files[0].name,
                            imageSrc: result,
                            file: files[0]
                        };
                        $scope.vm.jsonimageId.smallid.objectid = $scope.vm.smallImg.id;
                    }
                    if (type == 'big') {
                        $scope.vm.bigImg = {
                            id: rt.isNullOrWhiteSpace($scope.vm.jsonimageId.bigid.objectid) ? rt.newGuid() : $scope.vm.jsonimageId.bigid.objectid,
                            fileName: files[0].name,
                            imageSrc: result,
                            file: files[0]
                        };
                        $scope.vm.jsonimageId.bigid.objectid = $scope.vm.bigImg.id;
                    }
                    $scope.vm.form.data.avatar = JSON.stringify($scope.vm.jsonimageId);
                });
            }
        };

        //删除附件
        $scope.vm.form.deleteFile = function (type) {
            if (type == 'small' && !rt.isNullOrWhiteSpace($scope.vm.smallImg.id)) {
                var waiting = rt.showWaiting();
                rt.deleteSingleFile("course", $scope.vm.smallImg.id).success(function () {
                    $scope.vm.smallImg = { id: '', fileName: '', imageSrc: '', base64Content: '', file: null };;
                    $scope.vm.jsonimageId.smallid.objectid = null;
                    $scope.vm.jsonimageId.smallid.fileid = null;
                    rt.successMessage("删除成功。");
                    waiting.close();
                }).error(function (message) {
                    rt.errorMessage(message);
                    waiting.close();
                });
            }

            if (type == 'big' && !rt.isNullOrWhiteSpace($scope.vm.bigImg.id)) {
                var waiting = rt.showWaiting();
                rt.deleteSingleFile("course", $scope.vm.bigImg.id).success(function () {
                    $scope.vm.bigImg = { id: '', fileName: '', imageSrc: '', base64Content: '', file: null };;
                    $scope.vm.jsonimageId.bigid.objectid = null;
                    $scope.vm.jsonimageId.bigid.fileid = null;
                    rt.successMessage("删除成功。");
                    waiting.close();
                }).error(function (message) {
                    rt.errorMessage(message);
                    waiting.close();
                });
            }
            $scope.vm.form.data.avatar = JSON.stringify($scope.vm.jsonimageId);
        };

        //获取附件
        function _getFile() {

            var _baseApiUrl = "/";
            if (!rt.isNullOrWhiteSpace(localStorage.XrmBaseUrl)) {
                _baseApiUrl = localStorage.XrmBaseUrl;
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.jsonimageId.smallid.objectid)) {
                myService.getAttachmentList($scope.vm.jsonimageId.smallid.objectid).success(function (data) {
                    if (!rt.isEmptyArray(data)) {
                        $scope.vm.smallImg = {
                            id: data[0].Id,
                            fileName: data[0].FileName,
                            base64Content: _baseApiUrl + "FileDownloadHandler.ashx?fileid=" + data[0].Id + "&moduletype=attachment"
                        };
                    }
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.jsonimageId.bigid.objectid)) {
                myService.getAttachmentList($scope.vm.jsonimageId.bigid.objectid).success(function (data) {
                    if (!rt.isEmptyArray(data)) {
                        $scope.vm.bigImg = {
                            id: data[0].Id,
                            fileName: data[0].FileName,
                            base64Content: _baseApiUrl + "FileDownloadHandler.ashx?fileid=" + data[0].Id + "&moduletype=attachment"
                        };
                    }
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }
        }

        /*start 读取图片相关*/
        var onLoad = function onLoad(reader, deferred, scope) {
            return function () {
                scope.$apply(function () {
                    deferred.resolve(reader.result);
                });
            };
        };

        var onError = function onError(reader, deferred, scope) {
            return function () {
                scope.$apply(function () {
                    deferred.reject(reader.result);
                });
            };
        };

        var getReader = function getReader(deferred, scope) {
            var reader = new FileReader();
            reader.onload = onLoad(reader, deferred, scope);
            reader.onerror = onError(reader, deferred, scope);
            return reader;
        };

        var readAsDataURL = function readAsDataURL(file, scope) {
            var deferred = $q.defer();
            var reader = getReader(deferred, scope);
            reader.readAsDataURL(file);
            return deferred.promise;
        };
        /*end 读取图片相关*/

        $scope.vm.form.loadComplete = function () {
            $scope.vm.jsonimageId = { smallid: { fileid: null, objectid: null }, bigid: { fileid: null, objectid: null } };
            if ($scope.vm.form.type === 'Edit') {
                $scope.vm.jsonimageId = rt.isNullOrWhiteSpace($scope.vm.form.data.avatar) ? $scope.vm.jsonimageId : JSON.parse($scope.vm.form.data.avatar);
                _getFile();
            }
        };
    }]);
})();
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/4/26
 *说明：药品编码映射
 *************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('productErpMapService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'ProductErpMap';
        // @@ 选项集
        this.picklists = [];
        this.getProductSize = function (id) {
            var url = 'api/Product/GetProductById?id=' + id;
            return rt.get(url);
        };
    }]).controller('productErpMapListController', ['$scope', 'productErpMapService', entityListController]).controller('productErpMapEditController', ['$injector', '$scope', 'productErpMapService', function ($injector, $scope, myService) {
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        var rt = myService.rt;
        $scope.$watch("vm.form.data.productid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                //带出药品规格
                myService.getProductSize($scope.vm.form.data.productid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.form.data.product_size = resp.data.productsize;
                    } else {
                        $scope.vm.form.data.product_size = '';
                    }
                });
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2016/8/22
 说明     : 产品进目录情况Service
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('productIntoDirectoryService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'ProductIntoDirectory';
        // @@ 选项集
        this.picklists = ['StateCode', 'directory_type'];
    }]).controller('productIntoDirectoryListController', ['$injector', '$scope', 'productIntoDirectoryService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var that = this;
        this.searchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
        };
        this.preExport = function () {
            that.searchList.length = 0;
            that.searchList.push({ Type: 1, Key: "viewId", Value: $scope.vm.view.selectedView.Id });
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('productIntoDirectoryEditController', ['$injector', '$scope', 'productIntoDirectoryService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.product_categoryId.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.productId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Mona Xia
创建时间 : 2016-09-07
说明     : 药品推广信息
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('productPromoteInformationService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'productPromoteInformation';
    }]).controller('productPromoteInformationListController', ['$injector', '$scope', 'productPromoteInformationService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('productPromoteInformationEditController', ['$injector', '$scope', 'productPromoteInformationService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Gale Ge
创建时间 : 2017-01-04
说明     : 促销活动 Service
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('promotionCampaignService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // 服务端控制器名称
        this.controllerName = 'PromotionCampagin';

        this.picklists = ['StateCode', 'promotion_campaign_status'];
    }]).controller('promotionCampaignListController', ['$injector', '$scope', 'promotionCampaignService', function ($injector, $scope, myService) {
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('promotionCampaignEditController', ['$injector', '$scope', 'promotionCampaignService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.startCampaign = function () {
            if ($scope.vm.form.data.action_status.Value == 1) {
                $scope.vm.form.data.action_status = { Value: 2, Name: "执行中" };
                $scope.vm.form.save(false);
            }
        };

        $scope.vm.form.endCampaign = function () {
            if ($scope.vm.form.data.action_status.Value == 2) {
                $scope.vm.form.data.action_status = { Value: 3, Name: "已结束" };
                $scope.vm.form.save(false);
            }
        };

        $scope.vm.form.preSave = function () {
            if ($scope.vm.form.data.campaign_starttime >= $scope.vm.form.data.campaign_endtime) {
                rt.errorMessage("结束时间须大于开始时间");
                return "请输入正确的结束时间";
            }
        };
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Gale Ge
创建时间 : 2017-01-04
说明     : 促销活动-目标门店
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('promotionCampaignAccountService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // 服务端控制器名称
        this.controllerName = 'promotionCampaignAccount';

        this.picklists = ['StateCode'];
    }])
    // .controller('promotionCampaignAccountListController', ['$scope', 'promotionCampaignAccountService', entityListController])
    .controller('promotionCampaignAccountListController', ['$injector', '$scope', 'promotionCampaignAccountService', function ($injector, $scope, myService) {
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.vm.actions.loadComplete = function () {
            $scope.vm.actionStatus = $scope.$parent.vm.form.data.action_status.Value; //促销活动的状态 1规划中 2执行中 3已结束
            $scope.vm.stateCode = $scope.$parent.vm.form.data.StateCode.Value; //促销活动的禁用状态 0启用 1禁用
        };
    }]).controller('promotionCampaignAccountEditController', ['$injector', '$scope', 'promotionCampaignAccountService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.vm.form.loadComplete = function () {
            $scope.vm.actionStatus = $scope.$parent.vm.actionStatus; //促销活动的状态 1规划中 2执行中 3已结束
            $scope.vm.stateCode = $scope.$parent.vm.stateCode; //促销活动的禁用状态 0启用 1禁用
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/2/27
 说明     : 省份-基础数据
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('ProvinceBasicDataService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'ProvinceBasicData';
    }]).controller('ProvinceBasicDataListController', ['$injector', '$scope', 'ProvinceBasicDataService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('ProvinceBasicDataEditController', ['$injector', '$scope', 'ProvinceBasicDataService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : JeoLi
 创建时间 : 2018-02-26
 说明     :省中标价格
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('ProvinceBiddingPriceService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'ProvinceBiddingPrice';

        // @@ 选项集
        this.picklists = ['StateCode'];

        this.getBarCode = function (productid) {
            var url = "api/Product/GetBarCode?productid=" + productid;
            return rt.get(url);
        };

        this.getProductSize = function (id) {
            var url = 'api/Product/GetProductById?id=' + id;
            return rt.get(url);
        };
    }]).controller('ProvinceBiddingPriceListController', ['$injector', '$scope', 'ProvinceBiddingPriceService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        this.searchList = [];
        this.bodySearchList = [];
        var that = this;

        this.preExport = function () {
            that.searchList.length = 0;

            if (!rt.isNull($scope.vm.stateSelected)) {
                that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.Value });
            }

            if (!rt.isNull($scope.vm.provinceSelected)) {
                var idArray = [];
                $scope.vm.provinceSelected.map(function (item) {
                    idArray.push(item.Id);
                });
                that.searchList.push({ Type: 2, Key: "ProvinceId", Value: idArray });
            }

            if (!rt.isNull($scope.vm.productSelected)) {
                var idArray = [];
                $scope.vm.productSelected.map(function (item) {
                    idArray.push(item.Id);
                });
                that.searchList.push({ Type: 2, Key: "ProductId", Value: idArray });
            }
        };

        this.preSearch = function (params) {
            that.searchList.length = 0;
            that.bodySearchList.length = 0;

            if (!rt.isNull($scope.vm.stateSelected)) {
                that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.Value });
            }

            if (!rt.isNull($scope.vm.provinceSelected)) {
                var idArray = [];
                $scope.vm.provinceSelected.map(function (item) {
                    idArray.push(item.Id);
                });
                that.searchList.push({ Type: 2, Key: "ProvinceId", Value: idArray });
            }

            if (!rt.isNull($scope.vm.productSelected)) {
                var idArray = [];
                $scope.vm.productSelected.map(function (item) {
                    idArray.push(item.Id);
                });
                that.searchList.push({ Type: 2, Key: "ProductId", Value: idArray });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('ProvinceBiddingPriceEditController', ['$injector', '$scope', 'ProvinceBiddingPriceService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.productid", function (newValue, oldValue) {
            if (!rt.isNull($scope.vm.form.data.productid)) {
                myService.getBarCode($scope.vm.form.data.productid).then(function (data) {
                    $scope.vm.form.data.barcode = data.data;
                });
            };
            if (oldValue != newValue) {
                //带出药品规格
                myService.getProductSize($scope.vm.form.data.productid.Id).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.form.data.product_size = resp.data.productsize;
                    } else {
                        $scope.vm.form.data.product_size = '';
                    }
                });
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/2/27
 说明     : 省份-发病数据
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('ProvinceDiseaseDataService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'ProvinceDiseaseData';
    }]).controller('ProvinceDiseaseDataListController', ['$injector', '$scope', 'ProvinceDiseaseDataService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('ProvinceDiseaseDataEditController', ['$injector', '$scope', 'ProvinceDiseaseDataService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orangehong
 创建时间 : 2017-02-24
 说明     : 省份-医院终端-数量
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('ProvincehospitalqtyService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'ProvinceHospitalQty';

        // @@ 选项集
        this.picklists = ['account_grade'];
    }]).controller('provincehospitalqtyListController', ['$scope', 'ProvincehospitalqtyService', entityListController]).controller('provincehospitalqtyEditController', ['$injector', '$scope', 'ProvincehospitalqtyService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/2/27
 说明     : 省份-市场容量
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('ProvinceMarketCapacityService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'ProvinceMarketCapacity';
    }]).controller('ProvinceMarketCapacityListController', ['$injector', '$scope', 'ProvinceMarketCapacityService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.calculate = function () {
            var waiting = rt.showWaiting();
            var url = 'api/ProvinceMarketCapacity/CalculateMarketCapacity';
            return rt.post(url).then(function () {
                $scope.vm.view.search();
                waiting.close();
            });
        };
    }]).controller('ProvinceMarketCapacityEditController', ['$injector', '$scope', 'ProvinceMarketCapacityService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-01-16
 说明     : 题库管理
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('QuestionService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'Question';

        // @@ 选项集
        this.picklists = ['Action_Status', 'StateCode'];
    }]).controller('questionListController', ['$scope', 'QuestionService', entityListController]).controller('questionEditController', ['$injector', '$scope', 'QuestionService', '$timeout', function ($injector, $scope, myService, $timeout) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.vm.form.data.DetailList = {};
        var zmtable = ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"];

        $scope.addDetail = function () {
            $scope.vm.form.data.DetailList.push({
                Id: rt.newGuid(),
                Code: zmtable[$scope.vm.form.data.DetailList.length],
                name: "",
                Is_right_answer: ""
            });
        };

        //删除按钮
        $scope.del = function () {
            var idlist = _.map($scope.vm.form.data.DetailList, 'Id');
            var count = 0;

            $scope.vm.form.data.DetailList = _.remove($scope.vm.form.data.DetailList, function (item) {
                if ($scope.vm.view.selectedIds.indexOf(item.Id) < 0) {
                    return item;
                }
            });
            $scope.vm.form.data.Right_Answer = "";
            for (var i = 0; i < $scope.vm.form.data.DetailList.length; i++) {
                $scope.vm.form.data.DetailList[i].Code = zmtable[i];

                if ($scope.vm.form.data.Right_Answer === "" && $scope.vm.form.data.DetailList[i].Is_right_answer === true) {
                    $scope.vm.form.data.Right_Answer = $scope.vm.form.data.DetailList[i].Code;
                } else if ($scope.vm.form.data.Right_Answer != "" && $scope.vm.form.data.DetailList[i].Is_right_answer === true) {
                    $scope.vm.form.data.Right_Answer += "," + $scope.vm.form.data.DetailList[i].Code;
                }
                if ($scope.vm.form.data.DetailList[i].Is_right_answer === true) {
                    count++;
                }
            }
            if (count == 0) {
                $scope.vm.form.data.Right_Answer = "";
            }
            //$scope.vm.form.save(false);
        };

        //是否是正确答案
        $scope.istrue = function () {
            $scope.vm.form.data.Right_Answer = "";
            for (var i = 0; i < $scope.vm.form.data.DetailList.length; i++) {
                if ($scope.vm.form.data.Right_Answer === "" && $scope.vm.form.data.DetailList[i].Is_right_answer === true) {
                    $scope.vm.form.data.Right_Answer = $scope.vm.form.data.DetailList[i].Code;
                } else if ($scope.vm.form.data.Right_Answer != "" && $scope.vm.form.data.DetailList[i].Is_right_answer === true) {
                    $scope.vm.form.data.Right_Answer += "," + $scope.vm.form.data.DetailList[i].Code;
                }
            }
        };

        //保存
        $scope.save = function () {
            if ($scope.vm.form.data.Right_Answer === "" || $scope.vm.form.data.Right_Answer === null) {
                rt.errorMessage("请至少选择一个正确答案！");
            } else {
                $scope.vm.form.data.Remark = $scope.vm.editor.html();
                $scope.vm.form.save(false);
            }
        };

        //保存并新建
        $scope.truesave = function () {
            var js = 0;
            if ($scope.vm.form.data.Right_Answer === "" || $scope.vm.form.data.Right_Answer === null) {
                rt.errorMessage("请至少选择一个正确答案！");
            } else {
                $scope.vm.form.data.Remark = $scope.vm.editor.html();
                $scope.vm.form.save(true).then(function () {
                    js = KindEditor.instances.length - 1;
                    KindEditor.instances[js].html("");
                });
            }
        };

        //富文本框
        function kedit(kedit) {
            $scope.vm.editor = KindEditor.create(kedit, {
                themeType: "simple",
                uploadJson: 'FileUpload2Handler.ashx',
                extraFileUploadParams: {
                    ObjectId: rt.newGuid(), ModuleType: 'question'
                },
                resizeType: 2, //2时可以拖动改变宽度和高度，1时只能改变高度，0时不能拖动
                pasteType: 2, //设置粘贴类型，0:禁止粘贴, 1:纯文本粘贴, 2:HTML粘贴
                syncType: "form", //同步数据的方式，可设置”“、”form”，值为form时提交form时自动同步，空时不会自动同步
                filterMode: true,
                allowPreviewEmoticons: false,
                items: ['source', 'undo', 'redo', 'clearhtml', 'quickformat', 'selectall', 'fullscreen', 'fontname', 'fontsize', '|', 'forecolor', 'hilitecolor', 'bold', 'underline', 'hr', 'removeformat', '|', 'justifyleft', 'justifycenter', 'justifyright', '|', 'link', 'image', 'unlink'],
                afterCreate: function afterCreate() {
                    this.sync();
                    var self = this;
                    KindEditor.ctrl(document, 13, function () {
                        self.sync();
                    });
                    KindEditor.ctrl(self.edit.doc, 13, function () {
                        self.sync();
                    });
                },
                afterBlur: function afterBlur() {
                    //编辑器失去焦点(blur)时执行的回调函数
                    this.sync();
                },
                allowFileManager: false,
                allowFlashUpload: false,
                allowMediaUpload: false,
                allowFileUpload: false
            });
        }
        $(function () {
            $timeout(function () {
                kedit('#editor_question');
            }, 1000);
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-01-16
 说明     : 考试题目选项
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('QuestionOptionService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'QuestionOption';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('questionoptionListController', ['$injector', '$scope', 'QuestionOptionService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : SummerXu
 创建时间 : 2016-06-22
 说明     : 人员招聘达成
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('recruitcompletionService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'recruitcompletion';
        // @@ 选项集
        this.picklists = ['StateCode', 'year', 'month'];
    }]).controller('recruitcompletionListController', ['$injector', '$scope', '$timeout', 'recruitcompletionService', function ($injector, $scope, $timeout, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;

        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    return "只可查询同一年的数据";
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    return "开始日期必须小于结束日期";
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join("','");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.staskLevel)) {
                that.searchList.push({ Type: 1, Key: "tasklevel", Value: $scope.vm.staskLevel.Value });
            }
            if (!rt.isNull($scope.vm.custom_category)) {
                that.searchList.push({ Type: 1, Key: "custom_category", Value: $scope.vm.custom_category.Id });
            }
            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    return "只可查询同一年的数据";
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    return "开始日期必须小于结束日期";
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join("','");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.staskLevel)) {
                that.searchList.push({ Type: 1, Key: "tasklevel", Value: $scope.vm.staskLevel.Value });
            }
            if (!rt.isNull($scope.vm.custom_category)) {
                that.searchList.push({ Type: 1, Key: "custom_category", Value: $scope.vm.custom_category.Id });
            }
            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        //-新增多条件查询-CreateTime：2016-05-20-//

        $scope.vm.searchFormHide = true;
        $scope.vm.buidList = [];
        $scope.vm.buidSelected = null;
        $scope.vm.bigDepList = [];
        $scope.vm.bigDepSelected = null;
        $scope.vm.businessUnitList = [];
        $scope.vm.businessUnitSelected = [];
        $scope.vm.depType = 0;
        $scope.vm.OwnerName = "";
        $scope.vm.clickForm = function () {};
        _getAllBuid();

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }
        //-新增结束--//
        $scope.overHeightTable = function () {
            overHeightTable();
        };
        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });

        //-新增结束--//
    }]).controller('recruitcompletionEditController', ['$injector', '$scope', 'recruitcompletionService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.preSave = function () {
            if (rt.isNull($scope.vm.form.data.OwnerId)) {
                $scope.vm.form.data.OwnerId = {
                    Id: "",
                    Name: ""
                };
            }
        };

        $scope.$watch('vm.form.data.buid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.bigdept = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.bigdept.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.BusinessUnitId = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (!rt.isNull($scope.vm.form.data.OwnerId) && !rt.isNullOrWhiteSpace($scope.vm.form.data.OwnerId.Id)) {
                return;
            }
            if (!rt.isNull($scope.vm.form.data.BusinessUnitId)) {
                var id = $scope.vm.form.data.BusinessUnitId.Id;
                var waiting = rt.showLoading2();
                var url = 'api/RecruitTarget/GetOwnerIdByBusinessUnitId?id=' + id;
                rt.get(url).then(function (resp) {
                    if (!rt.isNullOrWhiteSpace(resp.data.Id)) {
                        $scope.vm.form.data.OwnerId = {
                            Id: resp.data.Id,
                            Name: resp.data.Name
                        };
                    }
                }).catch(function (msg) {
                    rt.errorMessage(msg);
                }).finally(function () {
                    waiting.close();
                });
            }
        });
        $scope.$watch('vm.OwnerId', function () {
            if (rt.isNullOrWhiteSpace($scope.vm.form.data.OwnerId)) {
                $scope.vm.form.data.OwnerId = $scope.vm.OwnerId;
            }
        });
        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });

        function _isPhoneNumber(str) {
            /// <summary>
            ///检查是否是手机号码或者电话号码
            ///</summary>

            var p1 = /^\d{3,4}-\d{7,8}(-\d{3,4})?$/;
            var p2 = /^1\d{10}$/;
            if (p1.test(str) || p2.test(str)) return true;else return false;
        }
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : SummerXu
 创建时间 : 2016-06-22
 说明     : 人员招聘指标
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('recruittargetService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'recruittarget';
        // @@ 选项集
        this.picklists = ['StateCode', 'year', 'month'];
    }]).controller('recruittargetListController', ['$injector', '$scope', '$timeout', 'recruittargetService', function ($injector, $scope, $timeout, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;

        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    return "只可查询同一年的数据";
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    return "开始日期必须小于结束日期";
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join("','");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.staskLevel)) {
                that.searchList.push({ Type: 1, Key: "tasklevel", Value: $scope.vm.staskLevel.Value });
            }
            if (!rt.isNull($scope.vm.custom_category)) {
                that.searchList.push({ Type: 1, Key: "custom_category", Value: $scope.vm.custom_category.Id });
            }
            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    return "只可查询同一年的数据";
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    return "开始日期必须小于结束日期";
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join("','");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.staskLevel)) {
                that.searchList.push({ Type: 1, Key: "tasklevel", Value: $scope.vm.staskLevel.Value });
            }
            if (!rt.isNull($scope.vm.custom_category)) {
                that.searchList.push({ Type: 1, Key: "custom_category", Value: $scope.vm.custom_category.Id });
            }
            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        //-新增多条件查询-CreateTime：2016-05-20-//

        $scope.vm.searchFormHide = true;
        $scope.vm.buidList = [];
        $scope.vm.buidSelected = null;
        $scope.vm.bigDepList = [];
        $scope.vm.bigDepSelected = null;
        $scope.vm.businessUnitList = [];
        $scope.vm.businessUnitSelected = [];
        $scope.vm.depType = 0;
        $scope.vm.OwnerName = "";
        $scope.vm.clickForm = function () {};
        _getAllBuid();

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        //-新增结束--//
        $scope.overHeightTable = function () {
            overHeightTable();
        };
        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });

        //-新增结束--//
    }]).controller('recruittargetEditController', ['$injector', '$scope', 'recruittargetService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.preSave = function () {
            if ($scope.vm.form.data.target < 1 || isNaN($scope.vm.form.data.target) || $scope.vm.form.data.target % 1 != 0) {
                rt.errorMessage("招聘人员必须是大于0的整数");
                return "招聘人员必须是大于0的整数";
            }
            $scope.vm.form.data.target = parseInt($scope.vm.form.data.target);
        };

        $scope.$watch('vm.form.data.buid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.bigdept = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.bigdept.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.BusinessUnitId = null;
                return;
            }
        });
        $scope.$watch('vm.OwnerId', function () {
            if (rt.isNullOrWhiteSpace($scope.vm.form.data.OwnerId)) {
                $scope.vm.form.data.OwnerId = $scope.vm.OwnerId;
            }
        });
        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (!rt.isNull($scope.vm.form.data.BusinessUnitId)) {
                var id = $scope.vm.form.data.BusinessUnitId.Id;
                var waiting = rt.showLoading2();
                var url = 'api/RecruitTarget/GetOwnerIdByBusinessUnitId?id=' + id;
                rt.get(url).then(function (resp) {
                    if (!rt.isNullOrWhiteSpace(resp.data.Id)) {
                        $scope.vm.form.data.OwnerId = {
                            Id: resp.data.Id,
                            Name: resp.data.Name
                        };
                    }
                }).catch(function (msg) {
                    rt.errorMessage(msg);
                }).finally(function () {
                    waiting.close();
                });
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : oscar
 创建时间 : 2017-07-18
 说明     : 红包查询
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('redpackstatisticsService', ['entityService', function (entityService) {

        angular.extend(this, entityService);

        var rt = entityService.rt;

        // @@设置WebAPI的控制器名称
        this.controllerName = 'WeixinRedpack';
        // @@ 选项集
        this.picklists = [];

        //按部门月度汇总显示    
        this.GetRedPackByBusinessData = function (sDate, eDate, pageSize, pageIndex) {
            var apiurl = 'api/WeixinRedpack/GetRedPackByBusinessData?sDate=' + sDate + '&eDate=' + eDate + '&pageSize=' + pageSize + '&pageIndex=' + pageIndex;
            return rt.get(apiurl);
        };

        //按代表月度汇总显示    
        this.GetRedPackByOwnerData = function (sDate, eDate, pageSize, pageIndex) {
            var apiurl = 'api/WeixinRedpack/GetRedPackByOwnerData?sDate=' + sDate + '&eDate=' + eDate + '&pageSize=' + pageSize + '&pageIndex=' + pageIndex;
            return rt.get(apiurl);
        };

        //红包发放明细    
        this.GetRedPackByDetailData = function (sDate, eDate, pageSize, pageIndex) {
            var apiurl = 'api/WeixinRedpack/GetRedPackByDetailData?sDate=' + sDate + '&eDate=' + eDate + '&pageSize=' + pageSize + '&pageIndex=' + pageIndex;
            return rt.get(apiurl);
        };
    }]).controller('redpackstatisticsListController', ['$injector', '$scope', 'redpackstatisticsService', function ($injector, $scope, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                rt.errorMessage("请选择开始年月");
                return false;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                rt.errorMessage("请选择结束年月");
                return false;
            }

            if ($scope.vm.sYm > $scope.vm.eYm) {
                rt.errorMessage("开始年月不能大于结束年月");
                return false;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        var rt = myService.rt;

        function _init() {
            $scope.tabindex = 'tab1';
            $scope.vm.sYm = moment().format('YYYY-MM-01');
            $scope.vm.eYm = moment().format('YYYY-MM-01');
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.pageIndex = 1;
            $scope.selectTab = selectTab;
            $scope.vm.search = _search;
        }

        //选择tab
        function selectTab(tabindex) {
            $scope.tabindex = tabindex;
            _search();
        }

        function _search() {
            var waiting = rt.showLoading2();
            if ($scope.tabindex == 'tab1') {
                myService.GetRedPackByBusinessData($scope.vm.sYm, $scope.vm.eYm, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                    if (resp.data) {
                        $scope.vm.data1 = resp.data.DataList;
                        $scope.vm.totalRecord1 = resp.data.TotalRecords;
                    }
                    _complateTableheight();
                }).finally(function () {
                    waiting.close();
                });
            } else if ($scope.tabindex == 'tab2') {
                myService.GetRedPackByOwnerData($scope.vm.sYm, $scope.vm.eYm, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                    if (resp.data) {
                        $scope.vm.data2 = resp.data.DataList;
                        $scope.vm.totalRecord2 = resp.data.TotalRecords;
                    }
                    _complateTableheight();
                }).finally(function () {
                    waiting.close();
                });
            } else {
                myService.GetRedPackByDetailData($scope.vm.sYm, $scope.vm.eYm, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                    if (resp.data) {
                        $scope.vm.data3 = resp.data.DataList;
                        $scope.vm.totalRecord3 = resp.data.TotalRecords;
                    }
                    _complateTableheight();
                }).finally(function () {
                    waiting.close();
                });
            }
        }

        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 90);
        }

        _init();
    }]);
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
//* 创建人   :oscargao
//* 创建时间 :2016-01-13
//* 说明     :流通效率
//******************************************************************
// #endregion

(function () {
	'use strict';

	function circulationEfficiencyController($scope, $q, rt) {
		function init() {
			$scope.vm = {};
			$scope.vm.reportData = [];

			$scope.vm.showReport = function () {
				_getReportData().then(_show, function (message) {
					rt.errorMessage(message);
				});
			};

			_getLastYears();
			_getPeriodYears();
			_getAllProvince();
			_getAllProduct();
		}

		//获取最近三年的年份
		function _getLastYears() {
			var myDate = new Date();
			var currYear = myDate.getFullYear();
			$scope.vm.years = [currYear, currYear - 1, currYear - 2];
			$scope.vm.yearsSelected = null;
		}
		//获取年度阶段
		function _getPeriodYears() {
			$scope.vm.period = [{ Name: '全年', Value: 1 }, { Name: '上半年', Value: 2 }, { Name: '下半年', Value: 3 }];
			$scope.vm.periodSelected = null;
		}

		function _getAllProvince() {
			var url = 'api/AlijkProvince/GetAllProvince';
			return rt.get(url).then(function (resp) {
				$scope.vm.provinceList = resp.data;
				$scope.vm.provinceSelected = null;
			});
		}

		function _getAllProduct() {
			var url = 'api/AlijkProduct/GetAllProduct';
			return rt.get(url).then(function (resp) {
				$scope.vm.productList = resp.data;
				$scope.vm.productSelected = null;
			});
		}

		function _getReportData() {
			if (rt.isNull($scope.vm.yearsSelected)) {
				var deferred = $q.defer();
				deferred.reject("查询的年份不能为空。");
				return deferred.promise;
			}
			if (rt.isNull($scope.vm.periodSelected)) {
				var deferred = $q.defer();
				deferred.reject("查询的年度阶段不能为空。");
				return deferred.promise;
			}
			if (rt.isNull($scope.vm.productSelected)) {
				var deferred = $q.defer();
				deferred.reject("查询的药品名称不能为空。");
				return deferred.promise;
			}
			if (rt.isNull($scope.vm.provinceSelected)) {
				var deferred = $q.defer();
				deferred.reject("查询的省份不能为空。");
				return deferred.promise;
			}

			var waiting = rt.showLoading2();
			var url = 'api/AlijkCirculationEfficiency/GetProvCeAnalysis?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&year=' + $scope.vm.yearsSelected + '&periodName=' + encodeURIComponent($scope.vm.periodSelected.Value) + '&toprovCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE);
			return rt.get(url).then(function (resp) {
				$scope.vm.reportData = resp.data;
				waiting.close();
			}, function () {
				waiting.close();
			});
		}

		function _show() {

			var myChart = echarts.init(document.getElementById("report"), "shine");

			var echartsDataNames = [];
			var echartsDataValues = [];
			var getData = $scope.vm.reportData;
			for (var i = 0; i < getData.length; i++) {
				echartsDataNames.push(getData[i].circ_days_name);
				echartsDataValues.push(getData[i].terminal_per.toFixed(2));
			}
			var option = {
				title: {
					text: '省级流通效率分析',
					subtext: ''
				},
				tooltip: {
					trigger: 'axis'
				},
				legend: {
					data: ['流通效率']
				},
				xAxis: [{
					type: 'value',
					boundaryGap: [0, 0.01]
				}],
				yAxis: [{
					type: 'category',
					data: echartsDataNames
				}],
				series: [{
					name: '流通效率',
					type: 'bar',
					data: echartsDataValues,
					itemStyle: {
						normal: {
							label: {
								show: true,
								position: 'right',
								formatter: "{c}%"
							},
							labelLine: { show: true }
						}
					}
				}]
			};
			myChart.setOption(option);
		}

		init();
	}

	angular.module('xrmApp').controller("circulationEfficiencyController", ['$scope', '$q', 'rt', circulationEfficiencyController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-8
 说明     :PC端门店协访
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('RetailAssistanceService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'RetailAssistance';
        // @@ 选项集
        this.picklists = ['StateCode'];
        //检查账号是否是医院
    }]).controller('retailAssistanceListController', ['$scope', 'RetailAssistanceService', entityListController]).controller('retailAssistanceEditController', ['$injector', '$scope', 'RetailAssistanceService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.loadComplete = function () {
            if ($scope.vm.form.data.assistanceList == null) {
                $scope.vm.form.data.assistanceList = [{
                    visit_recordId: '',
                    OwnerId: { Id: '', Name: '' },
                    visit_assistanceId: ''
                }];
            }
        };

        $scope.vm.form.preSave = function () {
            if ($scope.vm.form.data.is_assist) {
                for (var i = 0; i < $scope.vm.form.data.assistanceList.length; i++) {
                    if ($scope.vm.form.data.assistanceList[i].visit_assistanceId == null || $scope.vm.form.data.assistanceList[i].visit_assistanceId == '') {
                        $scope.vm.form.data.assistanceList[i].visit_assistanceId = rt.newGuid();
                    }
                    $scope.vm.form.data.assistanceList[i].visit_recordId = { Id: $scope.vm.form.data.Id };
                }
            }
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-4-6
 说明     :PC端门店拜访
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('RetailVisitService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'RetailVisit';
        // @@ 选项集
        this.picklists = ['StateCode'];
        this.getAttachmentList = function (id) {
            var url = 'api/' + this.controllerName + '/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
        //获取门店的拜访目的
        this.getRetailVisitPurpose = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=retail_visit_purpose";
            return rt.get(url);
        };
    }]).controller('retailvisitListController', ['$scope', 'RetailVisitService', entityListController]).controller('retailvisitEditController', ['$injector', '$scope', 'RetailVisitService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        var waiting = rt.showLoading2();
        $q.all([myService.getRetailVisitPurpose()]).then(function (resp) {
            $scope._visitpurpose = resp[0].data;
        }).catch(function (err) {
            rt.errorMessage(err);
        }).finally(function () {
            waiting.close();
        });
        function _getAllOwner() {
            rt.queryData("UserInfo.GetAllUser", { '@queryValue': '' }, function (resp) {
                $scope.OwnerList = [];
                var data = resp.DataList;
                for (var i = 0; i < data.length; i++) {
                    $scope.OwnerList.push({ Id: data[i].id, Name: data[i].name });
                }
            }, function (error) {});
        }
        $scope.vm.form.preLoad = function (data) {
            //获取所有代表
            _getAllOwner();
            if ($scope.vm.form.type === 'Edit') {
                myService.getAttachmentList($scope.vm.form.id).success(function (data) {
                    $scope.vm.form.attachmentList = data;
                }).error(function (error) {
                    rt.errorMessage(error);
                });
            }
        };

        $scope.vm.form.loadComplete = function () {
            var newassList = [];
            if ($scope.vm.form.data.assistanceList != null) {
                angular.forEach($scope.vm.form.data.assistanceList, function (entity) {
                    newassList.push({ Id: entity.OwnerId.Id, Name: entity.OwnerIdName });
                });
                $scope.vm.form.data.assistanceList = newassList;
            }
        };

        $scope.vm.form.preSave = function () {
            $scope.vm.form.data.visitpurposes = JSON.stringify($scope.vm.form.data.VisitPurpose);
            var assistanceList = $scope.vm.form.data.assistanceList;
            if ($scope.vm.form.data.is_assist) {
                for (var i = 0; i < assistanceList.length; i++) {
                    if (assistanceList.visit_assistanceId == null || assistanceList.visit_assistanceId == '') {
                        $scope.vm.form.data.assistanceList[i].visit_assistanceId = rt.newGuid();
                        $scope.vm.form.data.assistanceList[i].OwnerId = {
                            Id: assistanceList[i].Id,
                            Name: assistanceList[i].Name
                        };
                        $scope.vm.form.data.assistanceList[i].Id = assistanceList[i].visit_assistanceId;
                    }
                    $scope.vm.form.data.assistanceList[i].visit_recordId = { Id: $scope.vm.form.data.Id };
                }
            }
        };
        $scope.vm.form.downloadFile = function (fileId) {
            rt.downloadFile("retail_visit", fileId);
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : oscar
 创建时间 : 2017/05/19
 说明     : 门店协访维护
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('RetailVisitAssistPlanService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'RetailVisitAssistPlan';

        // @@ 选项集
        this.picklists = ['StateCode'];

        this.savePlan = function (visit_recordId, accountId, accountName, visitPurpose, planTime, visiterId) {
            var url = "api/RetailVisitAssistPlan/savePlan?visit_recordId=" + encodeURIComponent(visit_recordId) + "&accountId=" + encodeURIComponent(accountId) + "&accountName=" + encodeURIComponent(accountName) + "&visitPurpose=" + encodeURIComponent(visitPurpose) + "&planTime=" + encodeURIComponent(planTime) + "&visiterId=" + encodeURIComponent(visiterId);
            return rt.post(url);
        };

        this.deletePlan = function (visit_recordId, newplanId) {
            var url = "api/RetailVisitAssistPlan/deletePlan?visit_recordId=" + visit_recordId;
            return rt.get(url);
        };

        //获取门店的等级
        this.getRetailLevel = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=account_level";
            return rt.get(url);
        };

        this.getDbDateTime = function () {
            var apiUrl = "api/VisitRecord/GetDbDateTime";
            return rt.get(apiUrl);
        };
    }]).controller('retailVisitAssistPlanListController', ['$injector', '$scope', '$timeout', 'RetailVisitAssistPlanService', function ($injector, $scope, $timeout, myService) {
        var rt = myService.rt;
        var $q = myService.$q;
        //定义百度地图的地图对象
        var _map;
        //百度地图的缩放级别，大多数情况下使用14
        var _mapScale = 14;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        // 百度地图API功能
        function _getMap() {
            _map = new BMap.Map("addressMap");
            _map.centerAndZoom(new BMap.Point(120.551717, 31.284201), _mapScale);
            var zoomControl = new BMap.ZoomControl();
            _map.addControl(zoomControl); //添加缩放控件
            var scaleControl = new BMap.ScaleControl();
            _map.addControl(scaleControl); //添加比例尺控件
        }

        $scope.vm.visitStatusPickList = [{ Value: 0, Name: '不根据实际拜访情况过滤' }, { Value: 1, Name: '上周未拜访的门店' }, { Value: 2, Name: '本周未拜访的门店' }, { Value: 3, Name: '本月未拜访的的门店' }, { Value: 4, Name: '上月未拜访的门店' }, { Value: 5, Name: '自定义时间段' }];
        $scope.vm.visitStatus = $scope.vm.visitStatusPickList[0];
        $scope.vm.startTime = '';
        $scope.vm.endTime = '';
        _getRetailLevel();
        $scope.vm.planData = [];
        $scope.vm.showData = [];

        $scope.vm.PlanTime = [];
        $scope.vm.recordCount = 0;
        $scope.vm.isShow = false;
        $scope.vm.isShowOption = true;
        $scope.vm.windowWh = document.body.scrollWidth;
        $scope.vm.showTimeFilterInput = false;

        //初始化门店
        function _getRetailList() {
            var url = 'api/RetailVisitAssistPlan/GetRetailList?accountGrade=' + $scope.vm.account_grade_level.Value + "&visitStatus=" + $scope.vm.visitStatus.Value + "&startTime=" + $scope.vm.startTime + "&endTime=" + $scope.vm.endTime + "&visiterId=" + ($scope.vm.visiterId ? $scope.vm.visiterId.Id : '');
            return rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data;
            });
        }

        //获取门店分级
        function _getRetailLevel() {
            $q.all([myService.getRetailLevel(), myService.getDbDateTime()]).then(function (resp) {
                $scope.vm.account_grade_levelPickList = resp[0].data;
                $scope.vm.account_grade_levelPickList.unshift({ Value: 0, Name: "所有" }); //在数组开头增加所有级别医院
                if ($scope.vm.account_grade_levelPickList.length > 0) {
                    $scope.vm.account_grade_level = $scope.vm.account_grade_levelPickList[0];
                    _getRetailList();
                }
                $scope.vm.tomorrow = moment(resp[1].data, 'YYYY-MM-DD').add('days', 1).toDate();
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }

        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 160);
            }, 0);
        }

        $scope.vm.actions.isAllowFilter = function () {
            if ($scope.vm.visitStatus.Value !== 5) {
                $scope.vm.actions.filterRetailList();
            } else {
                $scope.vm.showTimeFilterInput = true;
            }
        };

        //切换tab
        $scope.selectTab = function (id) {
            switch (id) {
                case 'tab1':
                    $scope.vm.isShowTab = 1;
                    break;
                case 'tab2':
                    $scope.vm.isShowTab = 2;
                    _getMap();
                    break;
            }
        };

        $scope.vm.actions.filterRetailList = function () {
            if ($scope.vm.visitStatus.Value == 5 && rt.isNullOrWhiteSpace($scope.vm.startTime)) {
                rt.errorMessage("请输入开始时间");
                return;
            }

            if ($scope.vm.visitStatus.Value == 5 && rt.isNullOrWhiteSpace($scope.vm.endTime)) {
                rt.errorMessage("请输入结束时间");
                return;
            }

            if ($scope.vm.startTime > $scope.vm.endTime) {
                rt.errorMessage("开始时间必须小于结束时间");
                return;
            }

            var waiting = rt.showLoading2();
            var url = 'api/RetailVisitAssistPlan/GetRetailList?accountGrade=' + $scope.vm.account_grade_level.Value + "&visitStatus=" + $scope.vm.visitStatus.Value + "&startTime=" + moment($scope.vm.startTime).format('YYYY-MM-DD') + "&endTime=" + moment($scope.vm.endTime).add('days', 1).format('YYYY-MM-DD') + "&visiterId=" + ($scope.vm.visiterId ? $scope.vm.visiterId.Id : '');
            return rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data;
                waiting.close();
            });
        };

        $scope.vm.actions.savePlan = function () {
            $scope.vm.planData = [];
            //门店为空
            if ($scope.vm.data.length == 0) {
                return;
            }
            $scope.vm.windowWh = document.body.scrollWidth;
            angular.forEach($scope.vm.data, function (data) {
                if (rt.isNull(data.VisitPurpose)) {
                    data.VisitPurpose = [];
                }
            });
            var msg = '';
            var haveFullData = false;
            angular.forEach($scope.vm.data, function (data) {
                if (!rt.isNullOrWhiteSpace(data.planTime) && data.VisitPurpose.length > 0 && !(rt.isNull(data.visiter) || rt.isNullOrWhiteSpace(data.visiter.Id))) {
                    if (moment(data.planTime).toDate() < $scope.vm.tomorrow) {
                        msg += data.name + "的计划时间必须大于今日    ";
                    } else {
                        haveFullData = true;
                    }
                } else if (rt.isNullOrWhiteSpace(data.planTime) && data.VisitPurpose.length == 0 && (rt.isNull(data.visiter) || rt.isNullOrWhiteSpace(data.visiter.Id))) {} else {
                    if (rt.isNullOrWhiteSpace(data.planTime)) {
                        msg += data.name + "的计划时间不能为空     ";
                    }
                    if (rt.isNull(data.VisitPurpose) || data.VisitPurpose.length == 0) {
                        msg += data.name + "的拜访目的不能为空    ";
                    }
                    if (rt.isNull(data.visiter) || rt.isNullOrWhiteSpace(data.visiter.Id)) {
                        msg += data.name + "的销售代表不能为空    ";
                    }
                }
            });
            if (!haveFullData) {
                if (!rt.isNullOrWhiteSpace(msg) || msg != '') {
                    return rt.errorMessage(msg);
                }
            }

            for (var i = 0; i < $scope.vm.data.length; i++) {
                if (!rt.isNullOrWhiteSpace($scope.vm.data[i].planTime) && $scope.vm.data[i].VisitPurpose.length > 0 && !(rt.isNull($scope.vm.data[i].visiter) || rt.isNullOrWhiteSpace($scope.vm.data[i].visiter.Id))) {
                    $scope.vm.planData.push($scope.vm.data[i]);
                    $scope.vm.showData.push($scope.vm.data[i]);
                    $scope.vm.data.splice(i, 1);
                    i = i - 1;
                }
            }
            if ($scope.vm.planData.length == 0) {
                rt.errorMessage("计划全部为空，不能生成计划");
                return;
            }

            for (var i = 0; i < $scope.vm.planData.length; i++) {
                $scope.vm.planData[i].newVisit_recordId = rt.newGuid();
                myService.savePlan($scope.vm.planData[i].newVisit_recordId, $scope.vm.planData[i].accountId, $scope.vm.planData[i].name, JSON.stringify($scope.vm.planData[i].VisitPurpose), $scope.vm.planData[i].planTime, JSON.stringify($scope.vm.planData[i].visiter)).then(function () {});
            }
            $scope.vm.isShowTab = 1;
            $scope.vm.isShow = true;
            rt.successMessage("生成成功");
        };

        $scope.vm.actions.deletePlan = function (row, index) {
            myService.deletePlan(row.newVisit_recordId);
            $scope.vm.data.unshift(row);
            $scope.vm.showData.splice(index, 1);
        };
    }]).controller('retailVisitAssistPlanEditController', ['$injector', '$scope', '$timeout', 'RetailVisitAssistPlanService', function ($injector, $scope, $timeout, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : SummerXu
 创建时间 : 2016-04-26
 说明     : 回款任务指标
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('returnmoneytaskService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'returnmoneytask';
        // @@ 选项集
        this.picklists = ['StateCode', 'tasklevel', 'type', 'year', 'month', 'targettype'];
    }]).controller('returnmoneytaskListController', ['$injector', '$scope', '$timeout', 'returnmoneytaskService', function ($injector, $scope, $timeout, myService) {
        var $compile = myService.$compile;
        var rt = myService.rt;

        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    return "只可查询同一年的数据";
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    return "开始日期必须小于结束日期";
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join("','");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.staskLevel)) {
                that.searchList.push({ Type: 1, Key: "tasklevel", Value: $scope.vm.staskLevel.Value });
            }
            if (!rt.isNull($scope.vm.custom_category)) {
                that.searchList.push({ Type: 1, Key: "custom_category", Value: $scope.vm.custom_category.Id });
            }
            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };
        this.preSearch = function (params) {
            that.searchList.length = 0;
            var accids = "";
            var pids = "";
            if (!rt.isNullOrWhiteSpace($scope.vm.sYm) && !rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                    return "只可查询同一年的数据";
                }
                if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                    return "开始日期必须小于结束日期";
                }
                var sArr = $scope.vm.sYm.split("-");
                var eArr = $scope.vm.eYm.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }

            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join("','");
                $scope.vm.depType = 0;
            } else if (!rt.isNull($scope.vm.bigDepSelected)) {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }

            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            }
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdept", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }
            if (!rt.isNull($scope.vm.staskLevel)) {
                that.searchList.push({ Type: 1, Key: "tasklevel", Value: $scope.vm.staskLevel.Value });
            }
            if (!rt.isNull($scope.vm.custom_category)) {
                that.searchList.push({ Type: 1, Key: "custom_category", Value: $scope.vm.custom_category.Id });
            }
            if (!rt.isNull($scope.vm.OwnerName) && $scope.vm.OwnerName != "") {
                that.searchList.push({ Type: 0, Key: "OwnerIdName", Value: $scope.vm.OwnerName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.showForm = _showForm;
        function _showForm() {
            var html = '<div rt-include rt-template="Module/MissionTarget/missiontargetExcelImportView.html" rt-controller="missiontargetExcelImportController" ></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '<span style="color:#09f"><i class="fa fa-download fa-2x"></i>　导出任务指标数据</span>',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_NORMAL,
                onshow: function onshow(dialog) {
                    //dialog.getModalHeader().hide();
                    //dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }
        //-新增多条件查询-CreateTime：2016-05-20-//

        $scope.vm.searchFormHide = true;
        $scope.vm.buidList = [];
        $scope.vm.buidSelected = null;
        $scope.vm.bigDepList = [];
        $scope.vm.bigDepSelected = null;
        $scope.vm.businessUnitList = [];
        $scope.vm.businessUnitSelected = [];
        $scope.vm.depType = 0;
        $scope.vm.OwnerName = "";
        $scope.vm.clickForm = function () {};
        _getAllBuid();

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }
        //-新增结束--//
        $scope.overHeightTable = function () {
            overHeightTable();
        };
        function overHeightTable() {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        }

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                }
            }, function (error) {});
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.view.search(1);
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitList = [];
                $scope.vm.view.search(1);
                return;
            }
            if (oldValue != newValue && newValue != null) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    $scope.vm.view.search(1);
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                    $scope.vm.view.search(1);
                });
            }
        });

        //-新增结束--//
    }]).controller('returnmoneytaskEditController', ['$injector', '$scope', 'returnmoneytaskService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch('vm.form.data.buid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.bigdept = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.bigdept.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.BusinessUnitId = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/8/2
 说明     : 门店拜访计划维护
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('RetailVisitPlanService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'RetailVisitPlan';

        // @@ 选项集
        this.picklists = ['StateCode'];

        this.savePlan = function (visit_plan_batchId, visit_recordId, accountId, accountName, visitPurpose, planTime, assisterId) {
            var url = "api/RetailVisitPlan/savePlan?visit_recordId=" + encodeURIComponent(visit_recordId) + "&visit_plan_batchId=" + encodeURIComponent(visit_plan_batchId) + "&accountId=" + encodeURIComponent(accountId) + "&accountName=" + encodeURIComponent(accountName) + "&visitPurpose=" + encodeURIComponent(visitPurpose) + "&planTime=" + encodeURIComponent(planTime) + "&assisterId=" + encodeURIComponent(assisterId);
            return rt.post(url);
        };
        this.SendPlan = function (visit_plan_batchId) {
            var url = "api/RetailVisitPlan/SendPlan?visit_plan_batchId=" + visit_plan_batchId;
            return rt.post(url);
        };
        this.deletePlan = function (visit_recordId, newplanId) {
            var url = "api/RetailVisitPlan/deletePlan?visit_recordId=" + visit_recordId + "&visit_plan_batchId=" + newplanId;
            return rt.get(url);
        };
        //获取门店的等级
        this.getRetailLevel = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=account_level";
            return rt.get(url);
        };

        //获取发送人
        this.getManager = function () {
            var url = "api/RetailVisitPlan/GetManager";
            return rt.get(url);
        };

        this.getDbDateTime = function () {
            var apiUrl = "api/VisitRecord/GetDbDateTime";
            return rt.get(apiUrl);
        };
    }]).controller('retailVisitPlanListController', ['$injector', '$scope', '$timeout', 'RetailVisitPlanService', function ($injector, $scope, $timeout, myService) {
        var rt = myService.rt;
        var $q = myService.$q;
        //定义百度地图的地图对象
        var _map;
        //百度地图的缩放级别，大多数情况下使用14
        var _mapScale = 14;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        // 百度地图API功能
        function _getMap() {
            _map = new BMap.Map("addressMap");
            _map.centerAndZoom(new BMap.Point(120.551717, 31.284201), _mapScale);
            var zoomControl = new BMap.ZoomControl();
            _map.addControl(zoomControl); //添加缩放控件
            var scaleControl = new BMap.ScaleControl();
            _map.addControl(scaleControl); //添加比例尺控件
        }

        $scope.vm.visitStatusPickList = [{ Value: 0, Name: '不根据实际拜访情况过滤' }, { Value: 1, Name: '上周未拜访的门店' }, { Value: 2, Name: '本周未拜访的门店' }, { Value: 3, Name: '本月未拜访的的门店' }, { Value: 4, Name: '上月未拜访的门店' }, { Value: 5, Name: '自定义时间段' }];
        $scope.vm.visitStatus = $scope.vm.visitStatusPickList[0];
        $scope.vm.startTime = '';
        $scope.vm.endTime = '';
        _getRetailLevel();
        $scope.vm.planData = [];
        $scope.vm.showData = [];

        $scope.vm.PlanTime = [];
        $scope.vm.pageIndex = 1;
        $scope.vm.recordCount = 0;
        $scope.vm.pageSize = rt.getPaginationSize();
        $scope.vm.isShow = false;
        $scope.vm.isShowOption = true;
        $scope.vm.windowWh = document.body.scrollWidth;
        $scope.vm.showTimeFilterInput = false;

        //获取发送人
        _getManager();
        function _getManager() {
            $scope.vm.readerList = [];
            myService.getManager().success(function (resp) {
                $scope.vm.managerName = resp[0].managerName;
                $scope.vm.readerList = [{ OwnerId: { Id: resp[0].manager, Name: resp[0].managerName } }];
            }).error(function (error) {
                rt.showErrorToast(error);
            });
        }
        //初始化门店
        function _getRetailList() {
            // var waiting = rt.showWaiting();
            var url = 'api/RetailVisitPlan/GetRetailList?accountGrade=' + $scope.vm.account_grade_level.Value + "&visitStatus=" + $scope.vm.visitStatus.Value + "&startTime=" + $scope.vm.startTime + "&endTime=" + $scope.vm.endTime;
            return rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
            });
        }

        var waiting = rt.showLoading2();

        //获取门店分级
        function _getRetailLevel() {
            $q.all([myService.getRetailLevel(), myService.getDbDateTime()]).then(function (resp) {
                $scope.vm.account_grade_levelPickList = resp[0].data;
                $scope.vm.account_grade_levelPickList.unshift({ Value: 0, Name: "所有" }); //在数组开头增加所有级别医院
                if ($scope.vm.account_grade_levelPickList.length > 0) {
                    $scope.vm.account_grade_level = $scope.vm.account_grade_levelPickList[0];
                    _getRetailList();
                }
                $scope.vm.tomorrow = moment(resp[1].data, 'YYYY-MM-DD').add('days', 1).toDate();
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }

        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 160);
            }, 0);
        }

        //获取所有代表
        //_getAllOwner();
        function _getAllOwner() {
            rt.queryData("UserInfo.GetAllUser", { '@queryValue': '' }, function (resp) {
                $scope.OwnerList = [];
                var data = resp.DataList;
                for (var i = 0; i < data.length; i++) {
                    $scope.OwnerList.push({ Id: data[i].id, Name: data[i].name });
                }
            }, function (error) {});
        }

        $scope.vm.actions.isAllowFilter = function () {
            if ($scope.vm.visitStatus.Value !== 5) {
                $scope.vm.actions.filterRetailList();
            } else {
                $scope.vm.showTimeFilterInput = true;
            }
        };

        //切换tab
        $scope.selectTab = function (id) {
            switch (id) {
                case 'tab1':
                    $scope.vm.isShowTab = 1;
                    break;
                case 'tab2':
                    $scope.vm.isShowTab = 2;
                    _getMap();
                    break;
            }
        };

        $scope.vm.actions.filterRetailList = function () {
            if ($scope.vm.visitStatus.Value == 5 && rt.isNullOrWhiteSpace($scope.vm.startTime)) {
                rt.errorMessage("请输入开始时间");
                return "请输入开始时间";
            }

            if ($scope.vm.visitStatus.Value == 5 && rt.isNullOrWhiteSpace($scope.vm.endTime)) {
                rt.errorMessage("请输入结束时间");
                return "请输入结束时间";
            }

            if ($scope.vm.startTime > $scope.vm.endTime) {
                rt.errorMessage("开始时间必须小于结束时间");
                return "开始时间必须小于结束时间";
            }

            var waiting = rt.showLoading2();
            var url = 'api/RetailVisitPlan/GetRetailList?accountGrade=' + $scope.vm.account_grade_level.Value + "&visitStatus=" + $scope.vm.visitStatus.Value + "&startTime=" + moment($scope.vm.startTime).format('YYYY-MM-DD') + "&endTime=" + moment($scope.vm.endTime).add('days', 1).format('YYYY-MM-DD');
            return rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data;
                // _getRetailPurpose();
                waiting.close();
                // _complateTableheight();
            });
        };

        $scope.vm.actions.savePlan = function () {
            $scope.vm.isShowTab = 1;
            $scope.vm.windowWh = document.body.scrollWidth;
            angular.forEach($scope.vm.data, function (data) {
                if (rt.isNull(data.VisitPurpose)) {
                    data.VisitPurpose = [];
                }
            });

            // $scope.vm.planData = [];
            //门店为空
            if ($scope.vm.data.length == 0) {
                return;
            }
            var msg = '';
            var haveFullData = false;
            angular.forEach($scope.vm.data, function (data) {
                if (!rt.isNullOrWhiteSpace(data.planTime) && data.VisitPurpose.length > 0) {
                    if (moment(data.planTime).toDate() < $scope.vm.tomorrow) {
                        msg += data.name + "的计划时间必须大于今日    ";
                    } else {
                        haveFullData = true;
                    }
                } else if (rt.isNullOrWhiteSpace(data.planTime) && data.VisitPurpose.length == 0) {} else {
                    if (rt.isNullOrWhiteSpace(data.planTime)) {
                        msg += data.name + "的计划时间不能为空     ";
                    }
                    if (rt.isNull(data.VisitPurpose) || data.VisitPurpose.length == 0) {
                        msg += data.name + "的拜访目的不能为空    ";
                    }
                }
            });
            if (!haveFullData) {
                if (!rt.isNullOrWhiteSpace(msg) || msg != '') {
                    return rt.errorMessage(msg);
                }
            }

            for (var i = 0; i < $scope.vm.data.length; i++) {
                if (!rt.isNullOrWhiteSpace($scope.vm.data[i].planTime) && $scope.vm.data[i].VisitPurpose.length > 0) {
                    $scope.vm.planData.push($scope.vm.data[i]);
                    // $scope.vm.data[i].planTime=moment($scope.vm.data[i].planTime).format('YYYY-MM-DD');
                    $scope.vm.showData.push($scope.vm.data[i]);
                    $scope.vm.PlanTime.push({
                        accountid: [$scope.vm.data[i].accountId],
                        time: moment($scope.vm.data[i].planTime).format('YYYY-MM-DD')
                    });
                    //$scope.vm.PlanTime.push($scope.vm.data[i].accountId);
                    $scope.vm.data.splice(i, 1);
                    i = i - 1;
                }
                // $scope.vm.showData.push($scope.vm.planData);
            }
            //计划时间全为空
            if ($scope.vm.planData.length == 0) {
                return rt.errorMessage("计划时间全部为空，不能生成计划");
            }
            var waiting = rt.showLoading2();
            /* for (var j = 0, len2 = $scope.vm.planData.length; j < len2; j++) {
             $scope.vm.showData.push($scope.vm.planData[j]);
             }*/
            waiting.close();
            $scope.vm.isShow = true;
        };

        //点击发送
        $scope.send = function () {
            var httpCount = 0;
            $scope.vm.isShowOption = false;
            for (var m = 0, len3 = $scope.vm.showData.length; m < len3; m++) {
                $scope.vm.showData[m].isShow = false;
            }
            if ($scope.vm.planData.length > 0) {
                $scope.vm.account = [];
                $scope.vm.newplanId = rt.newGuid();
                var waiting = rt.showWaiting();
                httpCount = $scope.vm.planData.length;
                for (var j = 0, len2 = $scope.vm.planData.length; j < len2; j++) {
                    $scope.vm.planData[j].newVisit_recordId = rt.newGuid();
                    var assister = $scope.vm.planData[j].assister;
                    myService.savePlan($scope.vm.planData[j].newVisit_recordId, $scope.vm.newplanId, $scope.vm.planData[j].accountId, $scope.vm.planData[j].name, $scope.vm.planData[j].visitpurposes = JSON.stringify($scope.vm.planData[j].VisitPurpose), $scope.vm.planData[j].planTime, rt.isNull(assister) || assister.length == 0 ? "" : JSON.stringify($scope.vm.planData[j].assister)).then(function (resp) {
                        httpCount--;
                        if (httpCount == 0) {
                            myService.SendPlan($scope.vm.newplanId).then(function (resp) {

                                var reqData = {
                                    ObjectId: $scope.vm.newplanId,
                                    ObjectTypeName: "visit_plan_batch",
                                    ReaderList: $scope.vm.readerList
                                };
                                var url = 'api/WorkReportRead/ReaderSubmit';
                                return rt.post(url, reqData);
                            });
                        }
                    });
                }

                //$timeout(function () {    //发送给当前
                // myService.SendPlan($scope.vm.newplanId)
                // .then(function (resp) {
                // var reqData = {
                // ObjectId: $scope.vm.newplanId,
                // ObjectTypeName: "visit_plan_batch",
                // ReaderList: $scope.vm.readerList
                // };
                // var url = 'api/WorkReportRead/ReaderSubmit';
                // return rt.post(url, reqData);
                // });
                // }, 2000);
                $scope.vm.planData = [];
                rt.successMessage("生成成功");
                waiting.close();
            } else {
                return rt.errorMessage("没有计划草稿！");
            }
        };

        $scope.vm.actions.deletePlan = function (row, index) {
            $scope.vm.planData = [];
            myService.deletePlan(row.newVisit_recordId, $scope.vm.newplanId);
            //row.planTime=new Date(row.planTime);
            $scope.vm.data.unshift(row);
            $scope.vm.showData.splice(index, 1);
        };
    }]).controller('retailVisitPlanEditController', ['$injector', '$scope', '$timeout', 'RetailVisitPlanService', function ($injector, $scope, $timeout, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Oscar Gao
创建时间 : 2016-01-05
说明     : 销售活动
*********************************************************/

(function () {
        'use strict';

        angular.module('xrmApp').service('salesactivityService', ['entityService', function (entityService) {
                angular.extend(this, entityService);

                // @@设置WebAPI的控制器名称
                this.controllerName = 'salesactivity';

                // @@ 选项集
                this.picklists = ['StateCode', 'salesactivitytype', 'salesstage', 'followuptype'];
        }]).controller('salesactivityListController', ['$scope', 'salesactivityService', entityListController]).controller('salesactivityEditController', ['$scope', 'salesactivityService', entityEditController]);
})();
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/2/25
 *描述：销售协议产品
 *************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('salesagreementproductService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'salesagreementproduct';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('salesagreementproductListController', ['$scope', 'salesagreementproductService', entityListController]).controller('salesagreementproductEditController', ['$injector', '$scope', 'salesagreementproductService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.$watch("vm.form.data.product_id.Id", function () {
            if (rt.isNull($scope.vm.form.data.product_id)) return;
            var url = 'api/Product/GetProductById?id=' + $scope.vm.form.data.product_id.Id;
            return rt.get(url).then(function (resp) {
                var objProduct = resp.data;
                $scope.vm.form.data.product_code = objProduct.code;
                $scope.vm.form.data.product_size = objProduct.productsize;
            });
        });
    }]);
})();
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/2/18
 *描述：销售协议
 *************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('salesagreementService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'salesagreement';
        // @@ 选项集
        this.picklists = ['StateCode', 'agr_type'];
        this.getAccById = function (id) {
            var apiurl = "api/Account/GetDataById?id=" + encodeURIComponent(id);
            return rt.get(apiurl);
        };
    }]).controller('salesagreementListController', ['$scope', '$injector', 'salesagreementService', function ($scope, $injector, myService) {
        var rt = myService.rt;
        var that = this;
        this.preExport = function () {
            $scope.vm.view.searchList.push({ Type: 1, Key: "viewId", Value: $scope.vm.view.selectedView.Id });
        };

        this.preSearch = function () {
            $scope.vm.view.searchList = [];
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('salesagreementEditController', ['$injector', '$scope', 'salesagreementService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        //保存前
        $scope.vm.form.preSave = function () {
            var arrS = $scope.vm.form.data.startdate.split("-");
            var arrE = $scope.vm.form.data.enddate.split("-");
            var starttime = new Date(arrS[0], arrS[1], arrS[2].substring(0, 2));
            var endtime = new Date(arrE[0], arrE[1], arrE[2].substring(0, 2));
            if (starttime.getTime() > endtime.getTime()) {
                rt.warningMessage("协议结束日期不能小于开始日期");
                return "协议结束日期不能小于开始日期";
            }
        };
        //切换客户时触发
        $scope.$watch("vm.form.data.accountId.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                myService.getAccById($scope.vm.form.data.accountId.Id).then(function (resp) {
                    var data = resp.data;
                    if (!rt.isNull(data)) {
                        $scope.vm.form.data.accountnumber = data.accountnumber;
                    }
                });
                return;
            }
        });
        $scope.$watch('vm.form.data.buid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.bigdept = null;
                $scope.vm.form.data.BusinessUnitId = null;
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.bigdept.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.BusinessUnitId = null;
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });

        $scope.vm.form.loadComplete = function () {
            if (!rt.isNull($scope.rtIncludeParams)) {
                $scope.vm.form.data.accountId = { Id: $scope.rtIncludeParams.formAttrValue, Name: $scope.rtIncludeParams.formAttrName };
            }
        };
    }]);
})();
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/2/25
 *描述：目标终端
 *************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('salesagreementtoaccountService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;

        // @@设置WebAPI的控制器名称
        this.controllerName = 'salesagreementtoaccount';
        // @@ 选项集
        this.picklists = ['StateCode'];

        //获取代理商目标终端数量
        this.GetSalesAgreementToaccountCount = function (id) {
            return rt.get("api/agent/GetSalesAgreementToaccountCount?id=" + id);
        };
    }]).controller('salesagreementtoaccountListController', ['$scope', '$injector', 'salesagreementtoaccountService', function ($scope, $injector, myService) {
        var rt = myService.rt;
        var that = this;

        $scope.viewTag = "ForAgreement";
        this.viewTag = "ForAgreement";
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('salesagreementtoaccountEditController', ['$scope', '$injector', 'salesagreementtoaccountService', function ($scope, $injector, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.loadComplete = function () {
            if (!rt.isNull($scope.vm.form.data.toaccountid)) {
                myService.GetSalesAgreementToaccountCount($scope.vm.form.data.toaccountid.Id) //获取代理商目标终端数量
                .then(function (resp) {
                    $scope.vm.form.data.sales_agreementid = { Id: resp.data.sales_agreementid };
                }).catch(function (error) {
                    rt.errorMessage(error);
                });
            }
        };
    }]);
})();
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/2/25
 *描述：目标终端
 *************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('salesagreementtoaccountForAgentService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;

        // @@设置WebAPI的控制器名称
        this.controllerName = 'salesagreementtoaccount';
        // @@ 选项集
        this.picklists = ['StateCode'];

        //获取代理商是否存在协议
        this.GetAgentIsHaveSalesAgreement = function (id) {
            return rt.get("api/agent/GetAgentIsHaveSalesAgreement?id=" + id);
        };
    }]).controller('salesagreementtoaccountForAgentListController', ['$scope', '$injector', 'salesagreementtoaccountForAgentService', function ($scope, $injector, myService) {
        var rt = myService.rt;
        var that = this;
        $scope.viewTag = "ForAgent";
        this.viewTag = "ForAgent";
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.loadComplete = function () {
            myService.GetAgentIsHaveSalesAgreement($scope.$parent.vm.form.id).then(function (resp) {
                $scope.isShow = resp.data;
            }).catch(function (error) {
                rt.errorMessage(error);
            });
        };
    }]);
})();
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/2/25
 *描述：目标终端
 *************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('salesagreementtoaccountForLeadsService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;

        // @@设置WebAPI的控制器名称
        this.controllerName = 'salesagreementtoaccount';
        // @@ 选项集
        this.picklists = ['StateCode', 'account_grade'];

        this.GetAccountData = function (id) {
            return rt.get("api/Account/GetDataById?id=" + id);
        };
    }]).controller('salesagreementtoaccountForLeadsListController', ['$rootScope', '$scope', '$injector', 'salesagreementtoaccountForLeadsService', function ($rootScope, $scope, $injector, myService) {
        var rt = myService.rt;
        var that = this;
        $rootScope.salesdata = [];
        $scope.viewTag = "ForLeads";
        this.viewTag = "ForLeads";
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.$watch("vm.data", function (newValue, oldValue) {
            if (rt.isNull(newValue)) {
                return;
            }
            if (newValue != oldValue) {
                $rootScope.salesdata = $scope.vm.data;
            }
        });
    }]).controller('salesagreementtoaccountEditController', ['$scope', '$injector', 'salesagreementtoaccountForLeadsService', function ($scope, $injector, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //获取商业编码
        $scope.$watch("vm.form.data.accountid.Id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            if (!rt.isNullOrWhiteSpace(newValue)) {
                myService.GetAccountData($scope.vm.form.data.accountid.Id).then(function (resp) {
                    $scope.vm.form.data.account_grade = resp.data.account_grade;
                    $scope.vm.form.data.account_gradeName = resp.data.account_gradeName;
                });
            } else {
                $scope.vm.form.data.account_grade = null;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2016-09-27
 说明     : 连锁总部
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('salesorderService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'SalesOrder';
        this.approvalTypeName = 'sales_order';
        // @@ 选项集
        this.picklists = ['StateCode', 'transport_type', 'transport_cost_borneby', 'payment_type', 'sales_order_status'];

        this.approve = function (id) {
            return rt.get("api/SalesOrder/Approve?salesorderId=" + id);
        };

        this.reject = function (id) {
            return rt.get("api/SalesOrder/Reject?salesorderId=" + id);
        };

        this.getUserId = function () {
            var apiUrl = "api/Expense/GetCurrentUserId";
            return rt.get(apiUrl);
        };

        this.flowApprove = function (reqData) {
            var url = 'api/FlowApproval/FlowApprove';
            return rt.post(url, reqData);
        };

        this.flowReject = function (reqData) {
            var url = 'api/FlowApproval/FlowReject';
            return rt.post(url, reqData);
        };

        this.flowRecall = function (reqData) {
            var url = 'api/FlowApproval/FlowRecall';
            return rt.post(url, reqData);
        };

        this.flowTransmit = function (reqData, userid) {
            var url = 'api/FlowApproval/FlowTransmit?userId=' + userid;
            return rt.post(url, reqData);
        };

        //推送订单信息到ERP
        this.write2erp = function (model) {
            var url = 'api/Dock2Erp/WriteOrder2ERP';
            return rt.post(url, model);
        };
    }]).controller('salesorderListController', ['$injector', '$compile', '$scope', 'salesorderService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        $scope.viewTag = "Web";
        this.viewTag = "Web";

        var that = this;
        this.searchList = [];
        this.preExport = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }

            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdeptId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.Id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }

            if (!rt.isNull($scope.vm.sYm) && !rt.isNull($scope.vm.eYm)) {
                that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sYm });
                that.searchList.push({ Type: 1, Key: "eDate", Value: moment($scope.vm.eYm).add('days', 1) });
            }

            if (!rt.isNull($scope.vm.accountid) && !rt.isNullOrWhiteSpace($scope.vm.accountid.Id)) {
                that.searchList.push({ Type: 1, Key: "accountid", Value: $scope.vm.accountid.Id });
            }

            that.searchList.push({ Type: 1, Key: "viewId", Value: $scope.vm.view.selectedView.Id });
        };

        this.preSearch = function (params) {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            }

            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                that.searchList.push({ Type: 1, Key: "bigdeptId", Value: $scope.vm.bigDepSelected.id });
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var ids = _.map($scope.vm.businessUnitSelected, function (bu) {
                    return bu.Id;
                });
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: ids });
            }

            if (!rt.isNull($scope.vm.sYm) && !rt.isNull($scope.vm.eYm)) {
                that.searchList.push({ Type: 3, Key: "orderon", Value: [$scope.vm.sYm, moment($scope.vm.eYm).add('days', 1)] });
            } else {
                that.searchList.push({ Type: 3, Key: "orderon", Value: [moment().format("YYYY-MM-01"), moment().add('days', 1).format("YYYY-MM-DD")] });
            }

            if (!rt.isNull($scope.vm.accountid) && !rt.isNullOrWhiteSpace($scope.vm.accountid.Id)) {
                that.searchList.push({ Type: 1, Key: "accountid", Value: $scope.vm.accountid.Id });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        _getAllBuid();

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
            }, function (error) {
                $scope.vm.buidList = [];
            });
        }

        //获取大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            $scope.vm.bigDepSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.businessUnitSelected = null;
            $scope.vm.businessUnitList = [];
            $scope.vm.view.search(1);
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) return;

            rt.queryData("TblBusinessUnit.ChildBusinessUnitId", {
                '@queryValue': '',
                '@ParentBusinessUnitId': $scope.vm.buidSelected.id
            }, function (resp) {
                $scope.vm.bigDepList = resp.DataList;
            }, function (error) {
                $scope.vm.bigDepList = [];
            });
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            $scope.vm.businessUnitSelected = null;
            $scope.vm.businessUnitList = [];
            $scope.vm.view.search(1);
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) return;

            rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitId", {
                '@queryValue': '',
                '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id
            }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    data.forEach(function (e) {
                        $scope.vm.businessUnitList.push({ Name: e.name, Id: e.id });
                    });
                }
            }, function (error) {
                $scope.vm.businessUnitList = [];
            });
        });

        //图片浏览
        $scope.vm.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        $scope.vm.actions.loadComplete = function () {
            for (var i = 0; i < $scope.vm.data.length; i++) {
                if (!rt.isNull($scope.vm.data[i].SalesOrderLineList) && $scope.vm.data[i].SalesOrderLineList.length > 0) {
                    var tempAmount = 0;
                    _.map($scope.vm.data[i].SalesOrderLineList, function (item) {
                        tempAmount += item.amount;
                    });
                    $scope.vm.data[i].sumPrice = tempAmount;
                }
            }
        };
    }]).controller('salesorderEditController', ['$compile', '$injector', '$scope', '$stateParams', 'salesorderService', function ($compile, $injector, $scope, $stateParams, myService) {
        var rt = myService.rt;
        var $stateParams = myService.$stateParams;
        var id = $stateParams.id; //获取实体id

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        $scope.vm.form.approverList = [];
        $scope.vm.form.data.ApprovedBy = {};
        $scope.vm.hideForm = _hideForm;

        function _hideForm() {
            $scope.vm.dialog.close();
        }
        $scope.vm.form.approvalStatus;
        if (!rt.isNull($scope.vm.form.id) && $scope.vm.form.id !== '') {
            _getApprovalStatus($scope.vm.form.id).then(function (resp) {
                if (!rt.isNull(resp)) {
                    $scope.vm.form.approvalStatus = resp.data;
                }
            }).catch(function (resp) {
                rt.errorMessage(resp.data);
            });
        }
        function _getApprovalStatus(id) {
            var url = 'api/FlowApproval/GetFormApprovalStatus?objectId=' + id;
            return rt.get(url);
        }
        _getEditApprovalList($scope.vm.form.id, myService.approvalTypeName).then(function (resp) {
            if (!rt.isNull(resp)) {
                $scope.vm.form.approverList = resp.data;
            }
        }).catch(function (resp) {
            rt.errorMessage(resp.data);
        });

        function _getEditApprovalList(id, typename) {
            var url = 'api/FlowApproval/GetEditApprovalList?objectId=' + id + '&typename=' + typename;
            return rt.get(url);
        }

        $scope.addApprover = function () {
            var html = '<div rt-include rt-template="OA/ApproveU/approveUListView.html" rt-controller="ApproveUController" rt-include-params=' + "" + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
        $scope.$on('to-parent', function (event, data) {
            if (rt.isNull($scope.vm.form.approverList) || $scope.vm.form.approverList === '') {
                $scope.vm.form.approverList = data;
            } else {
                $scope.vm.approverLists = $scope.vm.form.approverList;
                for (var i = 0; i < data.length; i++) {
                    var approverExit = true;
                    for (var j = 0; j < $scope.vm.approverLists.length; j++) {
                        if (data[i].OwnerId.Id === $scope.vm.approverLists[j].OwnerId.Id) {
                            approverExit = false;
                        }
                    }
                    if (approverExit) {
                        $scope.vm.form.approverList.push(data[i]);
                    }
                }
            }
        });
        $scope.deleteApprover = function ($index) {
            if ($scope.vm.form.isFlowSubmitter == false && $scope.vm.form.type !== 'Create') {
                return;
            }
            if ($scope.vm.form.type === 'Create' || $scope.vm.form.approvalStatus.ApprovalStatus.approval_result.Value === 1) {
                $scope.vm.form.approverList.splice($index, 1);
            }
        };

        $scope.vm.form.preLoad = function () {
            myService.getUserId().success(function (data) {
                $scope.vm.userId = data;
            }).error(function (error) {
                rt.errorMessage(error);
            });
        };

        $scope.vm.form.loadComplete = function () {
            if (!rt.isNull($scope.vm.form.data.demandon)) $scope.vm.form.data.demandon = moment($scope.vm.form.data.demandon).format('YYYY-MM-DD');
            if (!rt.isNull($scope.vm.form.data.paymenton)) $scope.vm.form.data.paymenton = moment($scope.vm.form.data.paymenton).format('YYYY-MM-DD');
            if (!rt.isNull($scope.vm.form.data.SalesOrderLineList) && $scope.vm.form.data.SalesOrderLineList.length > 0) {
                var tempAmount = 0;
                _.map($scope.vm.form.data.SalesOrderLineList, function (item) {
                    tempAmount += item.amount;
                });
                $scope.vm.form.data.sumPrice = tempAmount;
            }
            _getFile();

            $scope.vm.form.isUnApproved = true;
            if ($scope.vm.form.type == 'Edit') {
                for (var i = 0; i < $scope.vm.form.approverList.length; i++) {
                    if ($scope.vm.form.approverList[i].approval_result.Value !== 1) {
                        $scope.vm.form.isUnApproved = false;
                        break;
                    }
                }
            }

            $scope.vm.form.isMoreActionsShow = true;
            if ($scope.vm.form.type == 'Edit') {
                if ($scope.vm.form.approvalStatus.ApprovalStatus.approval_status.Value != 2 && $scope.vm.form.approvalStatus.ApprovalStatus.approval_status.Value != 1) {
                    $scope.vm.form.isMoreActionsShow = false;
                }
                if ($scope.vm.form.approvalStatus.ApprovalStatus.SubmittedBy.Id != $scope.vm.userId) {
                    $scope.vm.form.isMoreActionsShow = false;
                }
                //if($scope.vm.form.approvalStatus.ApprovalStatus.approval_result.Value==5){
                //    $scope.vm.form.isMoreActionsShow = false;
                //}
            }

            $scope.vm.form.isFlowSubmitter = false;
            if ($scope.vm.form.type == 'Edit') {
                if ($scope.vm.form.approvalStatus.ApprovalStatus.SubmittedBy.Id == $scope.vm.userId && $scope.vm.form.approvalStatus.ApprovalStatus.approval_status.Value == 2) {
                    $scope.vm.form.isFlowSubmitter = true;
                }
            }

            $scope.vm.form.isFlowApprover = false;
            if ($scope.vm.form.type == 'Edit') {
                if ($scope.vm.form.approvalStatus.ApprovalStatus.ApprovingBy != null) {
                    if ($scope.vm.form.approvalStatus.ApprovalStatus.ApprovingBy != "" && $scope.vm.form.approvalStatus.ApprovalStatus.ApprovingBy.Id == $scope.vm.userId && $scope.vm.form.approvalStatus.ApprovalStatus.approval_status.Value == 2 && $scope.vm.form.approvalStatus.ApprovalStatus.SubmittedBy.Id != $scope.vm.userId) {
                        $scope.vm.form.isFlowApprover = true;
                    }
                }
            }
        };

        $scope.vm.newflowRecall = function () {
            var retValue = prompt("请输入撤销理由(非必输)", "");
            if (retValue != null) {
                $scope.vm.form.approvalStatus.ApprovalStatus.remark = retValue;
                rt.successMessage("正在处理...");
                rt.get('api/SalesOrder/CancelAudit?salesorderId=' + id).then(function () {
                    myService.flowRecall($scope.vm.form.approvalStatus.ApprovalStatus).then(function (resp) {
                        $scope.vm.form.hide();
                    }, function (resp) {
                        rt.errorMessage(resp.data);
                    });
                });
            } else {
                return;
            }
        };

        $scope.vm.newflowApprove = function () {
            var retValue = prompt("请输入同意理由(非必输)", "");
            if (retValue != null) {
                $scope.vm.form.approvalStatus.ApprovalStatus.remark = retValue;
                rt.successMessage("正在处理...");
                myService.flowApprove($scope.vm.form.approvalStatus.ApprovalStatus).then(function (resp) {
                    $scope.vm.form.hide();
                }, function (resp) {
                    rt.errorMessage(resp.data);
                });
            } else {
                return;
            }
        };

        $scope.vm.newflowReject = function () {
            var retValue = prompt("请输入拒绝理由(非必输)", "");
            if (retValue != null) {
                $scope.vm.form.approvalStatus.ApprovalStatus.remark = retValue;
                rt.successMessage("正在处理...");
                myService.flowReject($scope.vm.form.approvalStatus.ApprovalStatus).then(function (resp) {
                    $scope.vm.form.hide();
                }, function (resp) {
                    rt.errorMessage(resp.data);
                });
            } else {
                return;
            }
        };

        $scope.vm.form.flowTransmit = function () {
            var retValue = prompt("请输入转发理由(非必输)", "");
            if (retValue != null) {
                $scope.vm.form.approvalStatus.ApprovalStatus.remark = retValue;
                $scope.vm.form.showTransmitForm();
            } else {
                return;
            }
        };

        // $scope.vm.form.newsave = function () {
        //     $scope.vm.form.flowsave().then(function(){
        //         rt.get('api/SalesOrder/SubmitAudit?salesorderId=' + $scope.vm.form.data.Id).then(function(){
        //             // 刷新数据
        //             $scope.$emit('rt-reload');
        //             $scope.$broadcast('rt-reload');
        //         });
        //     });
        // }
        // $scope.vm.form.flowsave = function () {
        //     console.log($scope.vm.form);
        //     console.log($scope.vm.form.data);
        //     var reqData = {
        //         ObjectId: $scope.vm.form.id,
        //         ObjectName: $scope.vm.form.data.name,
        //         ObjectTypeName: myService.approvalTypeName,
        //         ApproverList: $scope.vm.form.approverList
        //     };
        //     var url = 'api/FlowApproval/FlowSubmit';
        //     return rt.post(url, reqData);
        // }

        $scope.vm.form.showTransmitForm = function () {
            var html = '<div rt-include rt-template="OA/FlowApprovalU/flowApprovalUListView.html" rt-controller="flowApprovalUController" rt-include-params=' + JSON.stringify($scope.vm.form.approvalStatus.ApprovalStatus) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.vm.form.approve = function () {
            var waiting = rt.showWaiting();
            myService.approve($scope.vm.form.id).catch(function (msg) {
                rt.errorMessage(msg);
            }).finally(function () {
                waiting.close();
                // 刷新数据
                $scope.$emit('rt-reload');
                $scope.$broadcast('rt-reload');
            });
        };

        $scope.vm.form.reject = function () {
            var waiting = rt.showWaiting();
            myService.reject($scope.vm.form.id).catch(function (msg) {
                rt.errorMessage(msg);
            }).finally(function () {
                waiting.close();
                // 刷新数据
                $scope.$emit('rt-reload');
                $scope.$broadcast('rt-reload');
            });
        };

        /* start 附件相关*/
        function _getFile() {
            if ($scope.vm.form.id != "") {
                return rt.GetFilesByObjectId("unknown", $scope.vm.form.id).error(function (message) {
                    rt.errorMessage(message);
                }).success(function (data) {
                    if (data != null) {
                        var data1 = data.DataList;
                        $scope.attchmentcount = data1.length;
                        $scope.fjs = [];
                        for (var i = 0; i < data1.length; i++) {
                            //排除pdf附件
                            if (data1[i].FileName.toLowerCase().indexOf(".pdf") <= 0) {
                                $scope.fjs.push({
                                    Id: data1[i].Id,
                                    FileName: data1[i].FileName,
                                    DownFile: true
                                });
                            }
                        }
                    } else {
                        $scope.attchmentcount = 0;
                    }
                });
            }
        }

        $scope.vm.form.downloadfile = function (fileId) {
            rt.downloadFile("unknown", fileId);
        };
        /* end 附件相关*/

        //推送信息到erp
        $scope.vm.write2erp = function () {
            rt.successMessage("正在处理...");
            myService.write2erp($scope.vm.form.data).then(function (resp) {
                if (resp && resp.data) {
                    var result = resp.data;
                    if (result.Result_Code == "2000") {
                        // 刷新数据
                        $scope.vm.form.hide();
                    } else {
                        rt.errorMessage(result.Result_Message);
                    }
                }
            }).catch(function (msg) {
                console.log('推送订单失败:' + msg);
                rt.errorMessage("订单推送失败。");
                return;
            });
        };
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2015-04-15
说明     : 消费记录明细
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('salesOrderDetailService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'salesOrderDetail';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('salesOrderDetailListController', ['$scope', 'salesOrderDetailService', entityListController]).controller('salesOrderDetailEditController', ['$injector', '$scope', 'salesOrderDetailService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        // 监控金额发生变化
        $scope.$watch('vm.form.data.quantity', _calculateAmount);
        $scope.$watch('vm.form.data.unit_price', _calculateAmount);

        // 计算金额
        function _calculateAmount() {
            var data = $scope.vm.form.data;
            if (rt.isNull(data.quantity) || rt.isNull(data.unit_price)) {
                data.amount = null;
            } else {
                data.amount = data.quantity * data.unit_price;
            }
        }
    }]);
})();
'use strict';

/********************************************************
 Copyright @ ������̩��Ϣ�������޹�˾ All rights reserved.
 ������   : Sakina Wu
 ����ʱ�� : 2016-01-27
 ˵��     : �ŵ궩��
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('salesOrderLineStoreService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@����WebAPI�Ŀ���������
        this.controllerName = 'salesOrderLineStore';

        // @@ ѡ�
        this.picklists = ['StateCode', 'needtoproduce'];
    }]).controller('salesOrderLineStoreListController', ['$scope', 'salesOrderLineStoreService', entityListController]).controller('salesOrderLineStoreEditController', ['$injector', '$scope', 'salesOrderLineStoreService', function ($injector, $scope, myService) {}]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2015-04-15
说明     : 消费记录
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('salesRecordsService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'salesRecords';

        // @@ 选项集
        this.picklists = ['StateCode', 'account_tiers'];

        // 计算积分
        this.calculatePoints = function (id) {
            var url = "api/SalesRecords/CalculatePoints?salesRecordsId=" + id;
            return rt.post(url);
        };
    }]).controller('salesRecordsListController', ['$scope', 'salesRecordsService', entityListController]).controller('salesRecordsEditController', ['$injector', '$scope', 'salesRecordsService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        // 计算积分
        $scope.vm.form.calculatePoints = function () {
            var waiting = rt.showWaiting();
            myService.calculatePoints($scope.vm.form.id).then(function () {
                waiting.close();

                rt.successMessage("计算完成。");
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ ������̩��Ϣ�������޹�˾ All rights reserved.
 ������   : Sakina Wu
 ����ʱ�� : 2016-01-27
 ˵��     : �ŵ궩��
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('salesOrderStoreService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@����WebAPI�Ŀ���������
        this.controllerName = 'salesOrderStore';

        // @@ ѡ�
        this.picklists = ['StateCode', 'sales_ordertype', 'is_freelater', 'sales_orderstate', 'logistics_company'];
    }]).controller('salesOrderStoreListController', ['$scope', 'salesOrderStoreService', entityListController]).controller('salesOrderStoreEditController', ['$injector', '$scope', 'salesOrderStoreService', function ($injector, $scope, myService) {
        /*        var rt=myService.rt;
              // var $compile=myService.$compile;
                  $injector.invoke(entityEditController,this,{
                    $scope:$scope,
                    myService:myService
                });*/

    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-02-04
 说明     : 销售区域
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('salesregionService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'salesregion';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('salesregionListController', ['$injector', '$scope', 'salesregionService', function ($injector, $scope, myService) {
        var that = this;
        this.isPost = true;
        this.searchList = [];
        this.bodySearchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
            that.bodySearchList.length = 0;

            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            if (!rt.isNullOrEmptyString(unitids)) {
                var idArray = unitids.split(",");
                that.bodySearchList.push({ Type: 2, Key: "BusinessUnitId", Value: idArray });
            }

            if (!rt.isNull($scope.vm.stateSelected)) that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.Value });
        };

        this.preExport = function () {
            that.searchList.length = 0;
            that.bodySearchList.length = 0;

            if (!rt.isNull($scope.vm.stateSelected)) that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.Value });

            if (!rt.isNull($scope.vm.nodeSelected) && !rt.isNull($scope.vm.nodeSelected.ids)) {
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: $scope.vm.nodeSelected.ids });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        var rt = myService.rt;
    }]).controller('salesregionEditController', ['$injector', '$scope', 'salesregionService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        // $scope.$watch('vm.form.data.buid.Id', function (newValue, oldValue) {
        //     if (oldValue != newValue && !rt.isNull(oldValue)) {
        //         $scope.vm.form.data.bigdepartid = null;
        //         $scope.vm.form.data.BusinessUnitId = null;
        //         $scope.vm.form.data.OwnerId = null;
        //         $scope.vm.unitSelected = null;
        //         $scope.vm.unitList = [];
        //         return;
        //     }
        // });
        // $scope.$watch('vm.form.data.bigdepartid.Id', function (newValue, oldValue) {
        //     if (oldValue != newValue && !rt.isNull(oldValue)) {
        //         $scope.vm.form.data.BusinessUnitId = null;
        //         $scope.vm.form.data.OwnerId = null;
        //         $scope.vm.unitList = [];
        //         return;
        //     }
        // });

        $scope.$watch('vm.form.data.BusinessUnitId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]).service('salesregionaccountService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'salesregionaccount';
        // @@ 选项集
        this.picklists = ['StateCode'];
        this.getAccById = function (id) {
            var apiurl = "api/Account/GetDataById?id=" + encodeURIComponent(id);
            return rt.get(apiurl);
        };
    }]).controller('salesregionaccountListController', ['$injector', '$scope', 'salesregionaccountService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $compile = myService.$compile;
        var that = this;
        this.searchList = [];

        this.preSearch = function (params) {
            that.searchList.length = 0;
        };
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('salesregionaccountEditController', ['$scope', '$injector', 'salesregionaccountService', function ($scope, $injector, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        //切换客户时触发
        $scope.$watch("vm.form.data.accountId.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                myService.getAccById($scope.vm.form.data.accountId.Id).then(function (resp) {
                    var data = resp.data;
                    if (!rt.isNull(data)) {
                        $scope.vm.form.data.accountnumber = data.accountnumber;
                    }
                });
                return;
            }
        });
    }]).service('salesregionareaService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'salesregionarea'; // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('salesregionareaListController', ['$scope', 'salesregionareaService', entityListController]).controller('salesregionareaEditController', ['$injector', '$scope', 'salesregionareaService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch('vm.form.data.provinceId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityId = null;
                $scope.vm.form.data.countyId = null;
                return;
            }
        });

        $scope.$watch('vm.form.data.cityId.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.countyId = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2015-04-15
说明     : 消费记录明细
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('salesOrderDetailService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'salesOrderDetail';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('salesOrderDetailListController', ['$scope', 'salesOrderDetailService', entityListController]).controller('salesOrderDetailEditController', ['$injector', '$scope', 'salesOrderDetailService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        // 监控金额发生变化
        $scope.$watch('vm.form.data.quantity', _calculateAmount);
        $scope.$watch('vm.form.data.unit_price', _calculateAmount);

        // 计算金额
        function _calculateAmount() {
            var data = $scope.vm.form.data;
            if (rt.isNull(data.quantity) || rt.isNull(data.unit_price)) {
                data.amount = null;
            } else {
                data.amount = data.quantity * data.unit_price;
            }
        }
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-02-07
 说明     : 代表结算价格表
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('salesreppricelistService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        var rt = entityService.rt;

        // @@设置WebAPI的控制器名称
        this.controllerName = 'SalesRepPricelist';

        // @@ 选项集
        this.picklists = ['StateCode'];

        // this.GetProductData = function (id) {
        //     return rt.get("api/Product/GetProductById?id=" + id);
        // }
    }]).controller('salesreppricelistListController', ['$injector', '$scope', 'salesreppricelistService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('salesreppricelistEditController', ['$injector', '$scope', 'salesreppricelistService', 'bizaccountpricelistService', function ($injector, $scope, myService, bizaccountpricelistService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //获取产品编码
        $scope.$watch("vm.form.data.productid.Id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            if (!rt.isNullOrWhiteSpace(newValue)) {
                bizaccountpricelistService.GetProductData($scope.vm.form.data.productid.Id).then(function (resp) {
                    $scope.vm.form.data.productnumber = resp.data.code;
                });
            } else {
                $scope.vm.form.data.productnumber = null;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/11
 说明     : 运营设置 - 短信验证码
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('SmsVerificationCodeLogService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'SmsVerificationCodeLog';
    }]).controller('SmsVerificationCodeLogListController', ['$injector', '$scope', 'SmsVerificationCodeLogService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-01-05
 说明     : 门店零售目标额
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('storeretailtargetService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'storeretailtarget';

        // @@ 选项集
        this.picklists = ['month', 'StateCode'];

        // @@查询门店编码
        this.getCode = function (storeid) {
            var url = "api/StoreRetailTarget/GetCode?storeid=" + storeid;
            return rt.get(url);
        };
    }]).controller('storeretailtargetListController', ['$scope', 'storeretailtargetService', entityListController]).controller('storeretailtargetEditController', ['$injector', '$scope', 'storeretailtargetService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        // 根据门店名称查询门店编码
        $scope.$watch('vm.form.data.storeid', function () {
            if (!rt.isNull($scope.vm.form.data.storeid)) {
                var id = $scope.vm.form.data.storeid.Id;
                myService.getCode(id).then(function (data) {
                    $scope.vm.form.data.code = data.data;
                });
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016-02-01
 说明     : 医生档案
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('systemUserContactService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'systemusercontact';

        // @@ 选项集
        this.picklists = ['StateCode', 'contact_level'];
    }]).controller('systemUserContactListController', ['$injector', '$compile', '$scope', 'systemUserContactService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        var that = this;
        this.searchList = [];
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('systemUserContactEditController', ['$injector', '$scope', 'systemUserContactService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.accountid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.deparmentid = null;
                $scope.vm.form.data.contactid = null;
                return;
            }
        });

        $scope.$watch("vm.form.data.deparmentid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.contactid = null;
                return;
            }
        });
    }]);
})();
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/2/25
 *描述：进货渠道
 *************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('supplychannelService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'supplychannel';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('supplychannelListController', ['$scope', 'supplychannelService', entityListController]).controller('supplychannelEditController', ['$scope', 'supplychannelService', entityEditController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016-02-03
 说明     : 零售终端档案
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('terminalaccountService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        var rt = entityService.rt;

        // @@设置WebAPI的控制器名称
        this.controllerName = 'terminalaccount';

        // @@ 选项集
        this.picklists = ['StateCode', 'yaotype', 'st_type', 'st_level', 'account_grade_level'];

        //获取归属信息
        this.GetSalesRegionInfo = function (accountId) {
            return rt.get("api/Account/GetSalesRegionInfo?accountId=" + accountId);
        };

        //保存归属信息
        this.SaveSalesRegionInfo = function (accountId, dataList) {
            return rt.post("api/SalesRegionAccount/SaveSalesRegionInfo?accountId=" + accountId, dataList);
        };

        //根据销售区域Id获取部门和用户信息
        this.GetBusinessAndOwnerInfoById = function (sales_regionId) {
            return rt.get("api/SalesRegion/GetBusinessAndOwnerInfoById?sales_regionId=" + sales_regionId);
        };
    }]).controller('terminalaccountListController', ['$injector', '$compile', '$scope', 'terminalaccountService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        $scope.viewTag = "Web";
        this.viewTag = "Web";

        var that = this;
        this.isPost = true;
        this.searchList = [];
        this.bodySearchList = [];
        this.preSearch = function (params) {
            that.searchList.length = 0;
            that.bodySearchList.length = 0;

            if (!rt.isNull($scope.vm.acclevelSelected) && $scope.vm.acclevelSelected.code != 0) {
                that.searchList.push({ Type: 1, Key: "account_grade_level", Value: $scope.vm.acclevelSelected.code });
            }

            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            if (!rt.isNullOrEmptyString(unitids)) {
                var idArray = unitids.split(",");
                that.bodySearchList.push({ Type: 2, Key: "BusinessUnitId", Value: idArray });
            }

            if (!rt.isNull($scope.vm.stateSelected)) that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.Value });

            if (!rt.isNull($scope.vm.gradeSelected)) that.searchList.push({ Type: 1, Key: "account_grade_level", Value: $scope.vm.gradeSelected.Value });

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.province) && !rt.isNullOrEmptyString($scope.vm.areaSelected.province.Id)) {
                that.searchList.push({ Type: 1, Key: "provinceid", Value: $scope.vm.areaSelected.province.Id });
            }

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.city) && !rt.isNullOrEmptyString($scope.vm.areaSelected.city.Id)) {
                that.searchList.push({ Type: 1, Key: "cityid", Value: $scope.vm.areaSelected.city.Id });
            }

            if (!rt.isNull($scope.vm.areaSelected) && !rt.isNull($scope.vm.areaSelected.county) && !rt.isNullOrEmptyString($scope.vm.areaSelected.county.Id)) {
                that.searchList.push({ Type: 1, Key: "countyid", Value: $scope.vm.areaSelected.county.Id });
            }

            if (!rt.isNullOrEmptyString($scope.vm.tagSelected)) {
                if ($scope.vm.tagSelected.indexOf('：') < 0 && $scope.vm.tagSelected.indexOf(':') < 0) {
                    return "请按照正确格式输入：标签名称：内容1，内容2；";
                }
                that.searchList.push({ Type: 5, Key: "account_tag", Value: $scope.vm.tagSelected });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        _getAllAcclevel();

        //获取所有客户分级
        function _getAllAcclevel() {
            rt.queryData("Account.AccountGradeLevel", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;

                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.acclevelList = data;
                    $scope.vm.acclevelList.unshift({ name: '全部终端分级', code: 0 });
                    $scope.vm.acclevelSelected = $scope.vm.acclevelList[0];
                }
            });
        }

        $scope.vm.actions.loadComplete = function () {
            if (!rt.isNull($scope.vm.data)) {
                for (var i = 0; i < $scope.vm.data.length; i++) {
                    if (!rt.isNull($scope.vm.data[i].account_tag)) {
                        var tagstring = "";
                        for (var o in $scope.vm.data[i].account_tag) {
                            tagstring += o + "：" + $scope.vm.data[i].account_tag[o] + "；";
                        }
                        $scope.vm.data[i].tagstring = tagstring;
                    }
                }
            }
        };
    }]).controller('terminalaccountEditController', ['$injector', '$compile', '$scope', 'terminalaccountService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.$watch("vm.form.data.cityid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.delSelected = [];
        //加载归属信息
        $scope.vm.form.loadComplete = function () {
            $scope.vm.getSalesRegionInfo();
            $scope.isCheckAll = false;
            $scope.vm.form.tagList = [];
            if (!rt.isNull($scope.vm.form.data.account_tag)) {
                var tagstring = "";
                for (var o in $scope.vm.form.data.account_tag) {
                    tagstring = o + "：" + $scope.vm.form.data.account_tag[o];
                    $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
                }
            }
        };

        $scope.vm.addTag = function () {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="module/BusinessAccount/addTagView.html" rt-controller="addTagController" rt-include-params="{id:\'' + $scope.vm.form.data.Id + '\'' + relatedHtml + '}"></div>';

            $scope.vm.dialog = BootstrapDialog.show({
                title: '增加标签',
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().css('background-color', '#08c');
                    dialog.getModalHeader().css('color', '#fff');
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                },
                onshown: function onshown(dialog) {
                    $("#" + this.id).find("#btnClose").bind("click", function () {
                        dialog.close();
                    });
                }
            });
        };

        $scope.vm.form.hideForm = function () {
            $scope.vm.dialog.close();
        };

        $scope.$on('to-parent', function (event, data) {
            var valueList = data.Value.split(/[,，]/);
            var list = [];
            for (var i = 0; i < valueList.length; i++) {
                if (!rt.isNullOrWhiteSpace(valueList[i])) {
                    list.push(valueList[i]);
                }
            }
            if (rt.isNull($scope.vm.form.data.account_tag)) {
                $scope.vm.form.data.account_tag = {};
            }
            $scope.vm.form.data.account_tag[data.Name] = list;
            $scope.vm.form.tagList = [];
            var tagstring = "";
            for (var o in $scope.vm.form.data.account_tag) {
                tagstring = o + "：" + $scope.vm.form.data.account_tag[o];
                $scope.vm.form.tagList.push({ "value": tagstring, "checked": false });
            }
        });

        $scope.vm.delTag = function () {
            var tag = {};
            var delTagList = _.where($scope.vm.form.tagList, { 'checked': true });
            if (rt.isNull(delTagList) || delTagList.length == 0) {
                rt.errorMessage("至少选择一个标签。");
                return "至少选择一个标签。";
            }
            $scope.vm.form.tagList = _.where($scope.vm.form.tagList, { 'checked': false });
            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.account_tag = tag;
        };

        //保存之前
        $scope.vm.form.preSave = function (data) {
            if ($scope.salesRegionInfoList.length == 0) {
                rt.errorMessage("至少选择一条门店归属信息。");
                return "至少选择一条门店归属信息。";
            }
            var tag = {};
            for (var i = 0; i < $scope.vm.form.tagList.length; i++) {
                var tagNameValueList = $scope.vm.form.tagList[i].value.split(/[:：]/);
                if (tagNameValueList.length > 1) {
                    if (tagNameValueList[1].indexOf(',') > 0 || tagNameValueList[1].indexOf('，') > 0) {
                        var valueList = tagNameValueList[1].split(/[,，]/);
                        tag[tagNameValueList[0]] = valueList;
                    } else {
                        tag[tagNameValueList[0]] = [tagNameValueList[1]];
                    }
                }
            };
            $scope.vm.form.data.account_tag = tag;
        };

        //保存之后
        $scope.vm.form.postSave = function () {
            //保存归属信息
            $scope.vm.saveSalesRegionInfo();
        };

        $scope.vm.getSalesRegionInfo = function () {
            //打开客户编辑页面时获取归属信息，!rt.isNull($scope.rtIncludeParams.formAttr)关联页
            if (rt.isNull($scope.rtIncludeParams) || !rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId) || !rt.isNull($scope.rtIncludeParams.formAttr)) {
                myService.GetSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id).then(function (resp) {
                    $scope.salesRegionInfoList = resp.data;
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            }
        };

        //保存归属信息
        $scope.vm.saveSalesRegionInfo = function () {
            myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {}).catch(function (error) {
                rt.showErrorToast(error);
            });
        };

        //删除记录
        $scope.vm.del = function () {
            if ($scope.delSelected.length === 0) {
                rt.warningMessage('请至少选择一项进行删除操作。');
                return;
            }

            var confirmMessage = '您一共选择了' + $scope.delSelected.length + '条记录，确认要删除这些记录？';
            rt.confirm(confirmMessage, function (ok) {
                if (ok) {
                    _.map($scope.delSelected, function (idx) {
                        $scope.salesRegionInfoList.splice(idx, 1, null);
                    });
                    $scope.salesRegionInfoList = _.remove($scope.salesRegionInfoList, function (item) {
                        return !rt.isNull(item);
                    });

                    //编辑客户时，删除归属信息才和后台数据库交互
                    if (!rt.isNullOrEmptyString($scope.vm.form.data.Id)) {
                        $scope.vm.saveSalesRegionInfo();
                    }

                    $scope.delSelected = [];
                    document.getElementById("checkboxAll").checked = false; //取消全选
                    $scope.isCheckAll = false;
                    rt.successMessage('成功删除记录。');
                    $scope.$apply();
                }
            });
        };

        var updateSelected = function updateSelected(action, index) {
            if (action == 'add') $scope.delSelected.push(index);
            if (action == 'remove') {
                var idx = $scope.delSelected.indexOf(index);
                $scope.delSelected.splice(idx, 1);
            }
        };

        //复选框点击事件
        $scope.updateSelection = function ($event, index) {
            var checkbox = $event.target;
            var action = checkbox.checked ? 'add' : 'remove';
            updateSelected(action, index);
        };

        //全选事件
        $scope.vm.selectAll = function () {
            var inputs = document.getElementById("salesRegion").getElementsByTagName("input");
            for (var i = 0; i < inputs.length; i++) {
                if (inputs[i].type == 'checkbox') {
                    inputs[i].checked = $scope.isCheckAll ? false : true;
                }
            }
            $scope.isCheckAll = !$scope.isCheckAll;
            $scope.delSelected = [];
            if ($scope.isCheckAll) {
                for (var i = 0; i < $scope.salesRegionInfoList.length; i++) {
                    $scope.delSelected.push(i);
                }
            }
        };

        //编辑客户-归属信息
        $scope.vm.showForm = function (row, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params="{rtIncludeId:\'' + row + '\'' + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //新建客户-归属信息
        $scope.vm.showForm2 = function (list, templateUrl, controllerName) {
            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params=' + JSON.stringify(list) + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //根据小区信息带出部门和用户信息
        $scope.$watch('vm.form.data.salesRegion', function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNull($scope.vm.form.data.salesRegion) && !rt.isNullOrEmptyString($scope.vm.form.data.salesRegion.Id)) {
                    myService.GetBusinessAndOwnerInfoById($scope.vm.form.data.salesRegion.Id).then(function (resp) {
                        if (resp.data) {
                            $scope.vm.form.data.salesRegionBusinessunitidName = (rt.isNullOrEmptyString(resp.data.buidName) ? '' : resp.data.buidName) + (rt.isNullOrEmptyString(resp.data.bigdepartidName) ? '' : resp.data.bigdepartidName) + (rt.isNullOrEmptyString(resp.data.BusinessUnitIdName) ? '' : resp.data.BusinessUnitIdName);
                            $scope.vm.form.data.salesRegionOwnerid = resp.data.OwnerId;
                            $scope.vm.form.data.salesRegionOwneridName = resp.data.OwnerIdName;
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                }
            }
        });

        // 保存归属信息
        $scope.vm.addSalesRegionInfo = function () {
            //必填项检查
            if (rt.isNull($scope.vm.form.data.salesRegion)) {
                rt.errorMessage("必须提供用户/小区。");
                return "必须提供用户/小区。";
            }

            if (rt.isNull($scope.vm.form.data.salesRegionProductCategory) || $scope.vm.form.data.salesRegionProductCategory.length == 0) {
                rt.errorMessage("必须提供品种。");
                return "必须提供品种。";
            }

            if (!rt.isNull($scope.rtIncludeParams.formAttr) || rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                $scope.salesRegionInfoList = $scope.rtIncludeParams;
            }

            for (var i = 0; i < $scope.vm.form.data.salesRegionProductCategory.length; i++) {
                if ($scope.vm.form.data.salesRegionProductCategory[i].Id == '11111111-1111-1111-1111-111111111111' && $scope.vm.form.data.salesRegionProductCategory.length > 1) {
                    rt.errorMessage("已选择了全品种，不能再添加其他品种。");
                    return "已选择了全品种，不能再添加其他品种。";
                }

                //重复性检查
                var existsIndex = _.findIndex($scope.salesRegionInfoList, function (a) {
                    return a.sales_regionid == $scope.vm.form.data.salesRegion.Id && a.product_categoryid == $scope.vm.form.data.salesRegionProductCategory[i].Id;
                });

                if (existsIndex >= 0) {
                    rt.errorMessage("已选择了相同的归属，不能重复添加。");
                    return "已选择了相同的归属，不能重复添加。";
                }

                //不存在就插入   
                $scope.salesRegionInfoList.push({
                    sales_regionid: $scope.vm.form.data.salesRegion.Id,
                    sales_regionidname: $scope.vm.form.data.salesRegion.Name,
                    businessunitidname: $scope.vm.form.data.salesRegionBusinessunitidName,
                    ownerid: $scope.vm.form.data.salesRegionOwnerid.Id,
                    owneridname: $scope.vm.form.data.salesRegionOwneridName,
                    product_categoryid: $scope.vm.form.data.salesRegionProductCategory[i].Id,
                    product_categoryidname: $scope.vm.form.data.salesRegionProductCategory[i].Name
                });
            };
            // 编辑客户时，直接保存到数据库，并刷新数据
            if (!rt.isNullOrEmptyString($scope.rtIncludeParams.rtIncludeId)) {
                myService.SaveSalesRegionInfo(rt.isNullOrEmptyString($scope.vm.form.data.Id) ? $scope.vm.form.id : $scope.vm.form.data.Id, $scope.salesRegionInfoList).then(function (resp) {
                    $scope.$emit('rt-on-dialog-close-click');
                }).catch(function (error) {
                    rt.showErrorToast(error);
                });
            } else
                // 新建客户时，广播到编辑页面
                $scope.$emit('rt-on-dialog-close-click-sales-region', $scope.salesRegionInfoList);
        };

        // 新建客户-编辑归属信息页面关闭事件
        $scope.$on('rt-on-dialog-close-click-sales-region', function (event, list) {
            // 不捕获自己的关闭事件
            if (event.targetScope.$id == $scope.$id) return;
            event.stopPropagation();

            // 隐藏窗口
            if ($scope.vm.dialog) {
                $scope.vm.dialog.close();
                delete $scope.vm.dialog;
            }
            $scope.salesRegionInfoList = list;
        });

        $scope.vm.form.newHide = function () {
            $scope.$parent.vm.dialog.close();
        };
    }]).service('terminalcontactService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'terminalcontact';

        // @@ 选项集
        this.picklists = ['StateCode', 'preferredcontactmethod', 'gendercode', 'familystatuscode', 'bachelor'];
    }]).controller('terminalcontactListController', ['$scope', 'terminalcontactService', entityListController]).controller('terminalcontactEditController', ['$injector', '$scope', 'terminalcontactService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch('vm.form.data.accountid', function (newValue, oldValue) {
            if (oldValue != newValue && $scope.vm.form.type === 'Create') {
                if (!rt.isNull($scope.vm.form.data.accountid)) {
                    var id = $scope.vm.form.data.accountid.Id;
                    var waiting = rt.showLoading2();
                    var url = 'api/AccountContact/GetContactBusinessUnit?id=' + id;
                    rt.get(url).then(function (resp) {
                        var data = resp.data[0];
                        if (data) {
                            $scope.vm.form.data.BusinessUnitId = {
                                Id: data.BusinessUnitId,
                                Name: data.BusinessUnitIdName
                            };
                            $scope.vm.form.data.OwnerId = {
                                Id: data.OwnerId,
                                Name: data.OwnerIdName
                            };
                        }
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                    var url2 = 'api/Department/GetCodeById?id=' + id;
                    rt.get(url2).then(function (resp) {
                        $scope.vm.form.data.accountnumber = resp.data;
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                    var url3 = 'api/accountcontact/GetContactProvince?id=' + id;
                    rt.get(url3).then(function (resp) {
                        $scope.vm.form.data.provinceid = {
                            Id: resp.data.Id,
                            Name: resp.data.Name
                        };
                    }).catch(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        vm.isLoading = false;
                    });
                }
            }
        });

        $scope.$watch('vm.form.data.buid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.bigdepartid = null;
                $scope.vm.unitSelected = null;
                $scope.vm.unitList = [];
                return;
            }
        });
        $scope.$watch('vm.form.data.bigdepartid.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.BusinessUnitId = null;
                $scope.vm.unitList = [];
                return;
            }
        });

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        //修改业务部门 业务负责人清空
        $scope.$watch("vm.form.data.BusinessUnitId.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });
    }]);
})();
'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Chad Chen
 创建时间 : 2017-11-20
 说明     : 辖区服务和控制器 
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('territoryService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;

        this.getBusinessTree = function (stateCode) {
            return rt.get('api/territory/getBusinessTree?stateCode=' + stateCode);
        };
    }]).controller('territoryListController', ['$injector', '$scope', 'businessUnitService', 'territoryService', function ($injector, $scope, businessUnitService, myService) {
        var _loadPrivilege = function () {
            var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                var resp;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                _context.next = 2;
                                return businessUnitService.getPrivilege();

                            case 2:
                                resp = _context.sent;

                                if (resp) {
                                    _vm.privilege = resp.data;
                                    $scope.$apply();
                                }
                                return _context.abrupt('return', resp);

                            case 5:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this);
            }));

            return function _loadPrivilege() {
                return _ref.apply(this, arguments);
            };
        }();

        var $q = myService.$q;
        var rt = myService.rt;

        var $timeout = myService.$timeout;

        var _vm = $scope.vm = {};
        (function () {
            //var viewType = !rt.isNull($scope.rtIncludeParams) ? "grid" : "default";
            _vm.view = {};
            //_vm.view.autoHeight=(viewType == 'grid' ? -1 : myService.getDefaultAutoHeight());
            _vm.view.list = [{ "Id": "0e2d26ab-d13e-4921-85f0-6bf5f7aff5a0", "ViewName": "所有业务部门" }, { "Id": "1775ee46-c425-4165-ba47-7438efa89383", "ViewName": "可用的业务部门" }, { "Id": "1d5de1f5-94b4-4ad5-b7d0-15cfd2ba083b", "ViewName": "停用的业务部门" }];
            _vm.view.selectedView = _vm.view.list[0];
            _vm.view.select = function (view) {
                _vm.view.selectedView = view;
            };

            _vm.actions = {};
            _vm.actions.new = _newData;
            _vm.actions.edit = _editData;
            _vm.actions.hideForm = __hideChildForm;
            _vm.actions.showForm = _showForm;

            $timeout(function () {
                var h = $(window).height() - ($(".navbar-static-bottom").outerHeight() + $(".rt-subnavbar").outerHeight() + $("nav.navbar-static-top").outerHeight() + 16);
                _vm.view.autoHeight = h;
            }, 0);

            // 编辑页面关闭事件
            $scope.$on('rt-on-dialog-close-click', function (event) {
                // 不捕获自己的关闭事件
                if (event.targetScope.$id == $scope.$id) return;

                event.stopPropagation();

                // 隐藏窗口
                _vm.actions.hideForm();

                // 刷新数据
                // $scope.$emit('rt-reload');
            });

            // // 捕获刷新事件
            // $scope.$on('rt-reload', _load);

            $scope.$watch('vm.view.selectedView', function (newValue, oldValue) {
                if (newValue == oldValue) return;

                _load();
            });

            $scope.$watch("mytree.currentNode.Id", function (newValue, oldValue) {
                if (newValue == oldValue) return;

                // 打开子视图
                if ($scope.mytree.currentNode.BusinessUnitDepthMask) {
                    myService.$state.go('main.territory.businessunit', { id: $scope.mytree.currentNode.Id });
                } else {
                    myService.$state.go('main.territory.region', { id: $scope.mytree.currentNode.Id });
                }
            });

            // 加载数据
            _loadPrivilege().then(_load);
        })();

        function _load() {
            var stateCode = "";
            switch (_vm.view.selectedView.Id) {
                case "1775ee46-c425-4165-ba47-7438efa89383":
                    stateCode = "0";
                    break;
                case "1d5de1f5-94b4-4ad5-b7d0-15cfd2ba083b":
                    stateCode = "1";
                    break;
            }

            myService.getBusinessTree(stateCode).then(function (resp) {
                if (rt.isNull(resp.data)) return;
                $scope.roleList = resp.data;

                // 默认展开第一级别
                $scope.roleList[0].expanded = true;
                $scope.roleList[0].Children2 = $scope.roleList[0].Children;

                myService.$state.go('main.territory.businessunit', { id: $scope.roleList[0].Id });
            });
        }

        function _newData(templateUrl, controllerName) {
            return _showForm('', templateUrl, controllerName);
        }

        // 删除数据
        function _editData(id, templateUrl, controllerName) {
            if (rt.isNull(id)) {
                rt.warningMessage('请至少选择一项进行编辑操作。');
                return;
            }

            // 隐藏已打开的表单
            _vm.actions.hideForm();

            return _showForm(id, templateUrl, controllerName);
        }

        // 显示表单
        function _showForm(id, templateUrl, controllerName) {
            var relatedHtml = '';
            if (_vm.view.type == 'grid') {
                var relatedAttr = $scope.rtIncludeParams.relatedAttr;
                var relatedAttrValue = $scope.$parent.vm.form.id;
                var relatedAttrName = $scope.$parent.vm.form.data.name;
                relatedHtml = ', formAttr:\'' + relatedAttr + '\', formAttrValue:\'' + relatedAttrValue + '\', formAttrName:\'' + relatedAttrName + '\'';
            }

            // 修改以支持自定义的打开窗口
            if (rt.isNull(templateUrl) || rt.isNull(controllerName)) {
                var stateName = $scope.stateName || myService.stateName || myService.controllerName;
                templateUrl = '"Module/' + stateName + '/' + stateName + 'EditView.html"';
                controllerName = '"' + stateName + 'EditController"';
            }

            var html = '<div rt-include rt-template=' + templateUrl + ' rt-controller=' + controllerName + ' rt-include-params="{rtIncludeId:\'' + id + '\'' + relatedHtml + '}"></div>';
            _vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    myService.$compile(obj)($scope);
                }
            });
        }

        // 隐藏表单
        function __hideChildForm() {
            if (_vm.dialog) {
                _vm.dialog.close();
                delete _vm.dialog;
                return;
            }
        }
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-11-20
 说明     : 辖区管理-小区
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('territorybusinessmanageService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'businessUnit';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('territorybusinessmanageEditController', ['$injector', '$scope', 'territorybusinessmanageService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.form.loadComplete = function () {
            $scope.vm.form.data.name = $scope.vm.form.data.BusinessUnitName;
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Jeoli
 创建时间 : 2018/03/16
 说明     : 月度历史版本
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('territoryBusinessVersionService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'TerritoryBusinessVersion';

        // @@ 选项集
        this.picklists = ['StateCode'];

        //月度历史版本
        this.GetVersionReport = function (sYm, eYm, bool_selected, id) {
            return rt.post("api/TerritoryBusinessVersion/GetBusinessVersion?sDate=" + sYm + "&eDate=" + eYm + "&same=" + bool_selected + "&unitid=" + id);
        };
    }]).controller('territoryBusinessVersionEditController', ['$injector', '$scope', '$stateParams', 'territoryBusinessVersionService', function ($injector, $scope, $stateParams, myService) {
        var rt = myService.rt;
        this.searchList = [];
        var that = this;
        var id = $stateParams.id;

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.sameModel = [{ Value: 0, Name: "否" }, { Value: 1, Name: "是" }];

        $scope.flag0 = "block";
        $scope.flag1 = "block";
        $scope.flag2 = "block";
        $scope.flag3 = "block";
        $scope.flag4 = "block";
        $scope.flag5 = "block";
        $scope.flag6 = "block";
        $scope.flag7 = "block";
        $scope.flag8 = "block";

        init();

        function init() {
            //时间筛选，默认这个月和上个月
            $scope.vm.sYm = moment().add(-1, 'months').format('YYYY-MM');
            $scope.vm.eYm = moment().format('YYYY-MM');
            $scope.vm.hideall = _hideThisForm;
            $scope.vm.sameSelected = localStorage.getItem("sameSelected") ? JSON.parse(localStorage.getItem("sameSelected")) : $scope.vm.sameModel[0];
            //$scope.vm.getReportData = _getData; //获取报表数据
        }

        // 隐藏表单
        function _hide() {
            $(".sidebar-right").sidebar('hide');
        }

        $scope.vm.hideForm = function () {
            $scope.vm.dialog.close();
        };
        // ignoreCheckFormDirty: 忽略表单检查,默认不忽略

        function _hideThisForm(ignoreCheckFormData) {
            //var form = _getForm();
            $scope.$emit('rt-on-dialog-close-click');
        }

        function _getForm() {
            // 获取表单
            var form = $scope[_vm.form.name];
            if ($scope[_vm.form.name] === undefined) {
                form = $scope.$$childTail[_vm.form.name] || $scope.$$childHead[_vm.form.name];
            }

            return form;
        }

        //查询数据
        $scope.vm.getReportData = function () {
            var msg = _checkOption();
            if (!rt.isNull(msg) && msg.length > 0) {
                rt.errorMessage(msg);
                return;
            }

            var bool_selected = $scope.vm.sameSelected.Value;

            var waiting = rt.showLoading2();

            $scope.isQtyShow = false;

            //动销，流向铺货率列表
            myService.GetVersionReport($scope.vm.sYm, $scope.vm.eYm, bool_selected, id).then(function (resp) {

                if (bool_selected == 1) {
                    $scope.flag0 = "none";
                    $scope.flag1 = "none";
                    $scope.flag2 = "none";
                    $scope.flag3 = "none";
                    $scope.flag4 = "none";
                    $scope.flag5 = "none";
                    $scope.flag6 = "none";
                    $scope.flag7 = "none";
                    $scope.flag8 = "none";
                    for (var i = 0; i < resp.data.length - 1; i++) {
                        for (var j = i + 1; j < resp.data.length; j++) {
                            if (resp.data[i].name != resp.data[j].name) {
                                $scope.flag0 = "block";
                            }
                            if (resp.data[i].parentBusinessUnitId != resp.data[j].parentBusinessUnitId) {
                                $scope.flag1 = "block";
                            }
                            if (resp.data[i].businessUnitOwnerId != resp.data[j].businessUnitOwnerId) {
                                $scope.flag2 = "block";
                            }
                            if (resp.data[i].regionCount != resp.data[j].regionCount) {
                                $scope.flag3 = "block";
                            }
                            if (resp.data[i].regionList != resp.data[j].regionList) {
                                $scope.flag4 = "block";
                            }
                            if (resp.data[i].accountCount != resp.data[j].accountCount) {
                                $scope.flag5 = "block";
                            }
                            if (resp.data[i].contactCount != resp.data[j].contactCount) {
                                $scope.flag6 = "block";
                            }
                            if (resp.data[i].personCount != resp.data[j].personCount) {
                                $scope.flag7 = "block";
                            }
                            if (resp.data[i].personList != resp.data[j].personList) {
                                $scope.flag8 = "block";
                            }
                        }
                    }
                } else {
                    $scope.flag0 = "block";
                    $scope.flag1 = "block";
                    $scope.flag2 = "block";
                    $scope.flag3 = "block";
                    $scope.flag4 = "block";
                    $scope.flag5 = "block";
                    $scope.flag6 = "block";
                    $scope.flag7 = "block";
                    $scope.flag8 = "block";
                }

                $scope.vm.reportData = resp.data;
                $scope.com = $scope.vm.reportData.length;
                //$scope.vm.recordCount = resp.data.TotalRecords;
                // _complateTableheight();
                waiting.close();
                //刷新
                $scope.$emit('rt-reload');
                $scope.$broadcast('rt-reload');
            });
        };

        //计算表格应有宽度
        function _complateTableweight() {
            $scope.tableMaxWeight = $(window).width() + "px";
        }

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            return "";
        }
    }]).filter('textLengthSet', function () {
        return function (value, wordwise, max, tail) {
            if (!value) return '';

            max = parseInt(max, 10);
            if (!max) return value;
            if (value.length <= max) return value;

            value = value.substr(0, max);
            if (wordwise) {
                var lastspace = value.lastIndexOf(' ');
                if (lastspace != -1) {
                    value = value.substr(0, lastspace);
                }
            }

            return value + (tail || ' …');
        };
    });
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : orange
 创建时间 : 2017-03-27
 说明     : 培训活动
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('TrainingcampaignService', ['entityService', function (entityService) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'TrainingCampaign';

        // @@ 选项集
        this.picklists = ['question_choose_type', 'training_campaign_reward_type', 'campaign_type'];
        this.getAttachmentList = function (id) {
            // 如果请求的Id为空，则直接返回承诺，不需要再请求服务器
            if (rt.isNull(id) || id.length === 0) {
                var deferred = $q.defer();
                deferred.resolve({ data: null });
                return deferred.promise;
            }

            var url = 'api/TrainingCampaignRewardRule/GetAttachmentList?id=' + id;
            return rt.get(url);
        };
    }]).controller('trainingcampaignListController', ['$scope', 'TrainingcampaignService', entityListController]).controller('trainingcampaignEditController', ['$injector', '$scope', 'TrainingcampaignService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $q = myService.$q;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.traincrList = [{
            Value: 10,
            Name: "微信红包"
        }, {
            Value: 20,
            Name: "实物奖励"
        }];

        $scope.vm.form.data.DetailList = [];
        $scope.vm.form.data.DetailList.length = 0;
        $scope.disabled = [];
        $scope.disabledstart = false;
        $scope.disabledend = false;
        $scope.addDetail = function () {
            $scope.vm.form.data.DetailList.push({
                Id: rt.newGuid(),
                // training_campaign_reward_type: "",
                reward_content: "",
                reward_fee: "",
                winning_rate: ""
            });
        };

        //奖励规则删除按钮
        $scope.del = function () {
            var idlist = _.map($scope.vm.form.data.DetailList, 'Id');

            $scope.vm.form.data.DetailList = _.remove($scope.vm.form.data.DetailList, function (item) {
                if ($scope.vm.view.selectedIds.indexOf(item.Id) < 0) {
                    return item;
                }
            });
        };

        //开始活动按钮
        $scope.startcampaign = function (traincampaignmodel) {
            if (traincampaignmodel.campaign_starttime > traincampaignmodel.campaign_endtime) {
                rt.errorMessage("开始日期不能在结束日期之后，请重新设置！");
            } else {
                if ($scope.vm.form.data.DetailList.length != 0) {
                    var count = 0;
                    for (var i = 0; i < $scope.vm.form.data.DetailList.length; i++) {
                        count += Number($scope.vm.form.data.DetailList[i].winning_rate);
                    }
                    if (count > 100) {
                        rt.errorMessage("中奖机率总和超出" + (count - 100) + "%，请合理分配中奖机率或重新设置中奖机率！");
                    } else if (count < 100) {
                        rt.errorMessage("中奖机率总和还差" + (100 - count) + "%，请合理分配中奖机率或重新设置中奖机率！");
                    } else if (100 == count) {
                        $scope.disabledstart = true;
                        $scope.vm.form.save(false).then(function () {
                            var waiting = rt.showWaiting();
                            rt.post("api/TrainingCampaign/StartCampaign", traincampaignmodel).then(function () {
                                $scope.$emit('rt-reload');
                                $scope.$broadcast('rt-reload');
                                rt.successMessage("活动已开始！");
                                $scope.vm.form.attachmentList = [];
                                _getFile();
                            }).finally(function () {
                                waiting.close();
                            });
                        });
                    }
                } else {
                    rt.errorMessage("还未设置考试奖励规则，活动不能开始！");
                }
            }
        };

        //保存按钮
        $scope.save = function () {
            $scope.vm.form.save(false);
        };

        //保存并新建按钮
        $scope.truesave = function () {
            if ($scope.vm.form.data.DetailList != undefined) {
                $scope.vm.form.save(true);
            } else {
                $scope.vm.form.save(true);
            }
        };

        //活动结束按钮
        $scope.endcampaign = function (traincampaignmodel) {
            $scope.disabledend = true;
            var waiting = rt.showWaiting();
            rt.post("api/TrainingCampaign/EndCampaign", traincampaignmodel).then(function () {
                $scope.$emit('rt-reload');
                $scope.$broadcast('rt-reload');
                rt.successMessage("活动结束！");
                $scope.vm.form.attachmentList = [];
                _getFile();
            }).finally(function () {
                waiting.close();
            });
        };

        /* start 附件相关*/
        $scope.vm.form.attachmentList = [];
        $scope.imageSrc = [];
        $scope.flag = false;

        $scope.vm.form.loadComplete = function (data) {
            if ($scope.vm.form.type === 'Edit') {
                $scope.vm.form.attachmentList = [];
                _getFile();
            }
        };

        function _getFile() {
            $scope.vm.form.attachmentList = [];
            $scope.imageSrc = [];
            if ($scope.vm.form.data.DetailList != undefined) {
                for (var j = 0; j < $scope.vm.form.data.DetailList.length; j++) {
                    myService.getAttachmentList($scope.vm.form.data.DetailList[j].Id).success(function (data) {
                        if (!rt.isEmptyArray(data)) {
                            $scope.vm.form.attachmentList.push(data[0]);
                            //$scope.imageSrc.push("data:" + data[0].MimeType + ";base64," + data[0].FileBase64Content);
                        }
                    }).error(function (error) {
                        rt.errorMessage(error);
                    });
                }
            } else {
                $scope.vm.form.attachmentList = [];
            }
        }

        $scope.selectedFiles = null;
        $scope.selectedFilesArr = [];
        $scope.selectedFileName = null;

        var onLoad = function onLoad(reader, deferred, scope) {
            return function () {
                scope.$apply(function () {
                    deferred.resolve(reader.result);
                });
            };
        };

        var onError = function onError(reader, deferred, scope) {
            return function () {
                scope.$apply(function () {
                    deferred.reject(reader.result);
                });
            };
        };

        var getReader = function getReader(deferred, scope) {
            var reader = new FileReader();
            reader.onload = onLoad(reader, deferred, scope);
            reader.onerror = onError(reader, deferred, scope);
            return reader;
        };

        var readAsDataURL = function readAsDataURL(file, scope) {
            var deferred = $q.defer();
            var reader = getReader(deferred, scope);
            reader.readAsDataURL(file);
            return deferred.promise;
        };

        $scope.vm.form.fileSelect = function (files, rowindex) {
            $scope.disabled[rowindex] = false;
            var attachmentListid = _.pluck(_.where($scope.vm.form.attachmentList, { 'ObjectId': $scope.vm.form.data.DetailList[rowindex].Id }), 'Id');
            if (attachmentListid != [] && _.includes(_.map($scope.vm.form.attachmentList, 'ObjectId'), $scope.vm.form.data.DetailList[rowindex].Id)) {
                rt.deleteFile("traincampaign", attachmentListid);
                $scope.vm.form.attachmentList = [];
            }

            if (!rt.isEmptyArray(files)) {
                var fileIn = files[0];
                var img = new Image();
                var fileType = fileIn.name.substring(fileIn.name.lastIndexOf(".") + 1, fileIn.name.length);
                // if (fileIn.size > 102400) {//单位是字节，此处不允许超过100k
                //     rt.errorMessage("图片不能超过100k");
                //     return;
                // }
                if (fileType == 'JPG' || fileType == 'PNG' || fileType == 'JPEG ' || fileType == 'jpg' || fileType == 'png' || fileType == 'jpeg') {
                    readAsDataURL(fileIn, $scope).then(function (result) {
                        $scope.imageSrc = result;
                    });
                } else {
                    rt.errorMessage("图片格式只支持:JPG,PNG,JPEG");
                    return;
                }
            }

            if (files && files.length && files.length > 0) {
                $scope.selectedFiles = null;
                $scope.selectedFilesArr = [];

                $scope.selectedFilesArr.push(files[0]);
                $scope.selectedFiles = $scope.selectedFilesArr;
                rt.uploadFiles($scope.selectedFiles, "traincampaign", $scope.vm.form.data.DetailList[rowindex].Id, false, function (data) {
                    $scope.disabled[rowindex] = true;
                    _getFile();
                });
            }

            files = [];
        };

        //获取对应的照片名称/照片
        $scope.vm.getRightPhotoName = function (v) {
            $scope.imageSrc = '/FileDownloadHandler.ashx?fileid=' + _.pluck(_.where($scope.vm.form.attachmentList, { 'ObjectId': $scope.vm.form.data.DetailList[v].Id }), 'Id')[0] + '&moduletype=traincampaign';
            return $scope.imageSrc;
        };

        /* end 附件相关*/
    }]).service('TrainingCampaignRewardQuotaService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'TrainingCampaignRewardQuota';

        //获取活动的状态
        this.GetCampaignStatus = function (training_campaignId) {
            return rt.get("api/TrainingCampaignRewardQuota/GetCampaignStatus?training_campaignId=" + training_campaignId);
        };
    }]).controller('TrainingCampaignRewardQuotaListController', ['$injector', '$scope', 'TrainingCampaignRewardQuotaService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        var $compile = myService.$compile;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.loadComplete = function () {
            if (!rt.isNullOrEmptyString($scope.$parent.vm.form.id)) {
                myService.GetCampaignStatus($scope.$parent.vm.form.id).then(function (resp) {
                    $scope.campaignStatus = resp.data;
                });
            }
        };
    }]).controller('TrainingCampaignRewardQuotaEditController', ['$scope', '$injector', 'TrainingCampaignRewardQuotaService', function ($scope, $injector, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-11-20
 说明     : 辖区管理-小区
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('territoryregionmanageService', ['entityService', function (entityService) {
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'salesregion';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('territoryregionmanageEditController', ['$injector', '$scope', 'territoryregionmanageService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/*********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/12/14
 说明     : 动销激励审查
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('TrainingCampaignTicketUploadService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'TrainingCampaignTicketUpload';

        // @@ 选项集
        this.picklists = [];
    }]).controller('TrainingCampaignTicketUploadListController', ['$injector', '$compile', '$scope', 'TrainingCampaignTicketUploadService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        var that = this;
        this.isPost = true;
        this.searchList = [];
        this.bodySearchList = [];

        this.preExport = function (params) {
            that.searchList.length = 0;

            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            if (!rt.isNullOrEmptyString(unitids)) {
                var idArray = unitids.split(",");
                that.searchList.push({ Type: 2, Key: "BusinessUnitId", Value: idArray });
            }

            if (!rt.isNull($scope.vm.ownerSelected)) {
                var idArray = [];
                $scope.vm.ownerSelected.map(function (item) {
                    idArray.push(item.Id);
                });
                that.searchList.push({ Type: 2, Key: "OwnerId", Value: idArray });
            }

            if (!rt.isNull($scope.vm.sYm) && !rt.isNull($scope.vm.eYm)) {
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [$scope.vm.sYm, moment($scope.vm.eYm).add(1, 'months').format('YYYY-MM')] });
            }
        };

        this.preSearch = function (params) {
            that.searchList.length = 0;
            that.bodySearchList.length = 0;

            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            if (!rt.isNullOrEmptyString(unitids)) {
                var idArray = unitids.split(",");
                that.bodySearchList.push({ Type: 2, Key: "BusinessUnitId", Value: idArray });
            }

            if (!rt.isNull($scope.vm.ownerSelected)) {
                var idArray = [];
                $scope.vm.ownerSelected.map(function (item) {
                    idArray.push(item.Id);
                });
                that.bodySearchList.push({ Type: 2, Key: "OwnerId", Value: idArray });
            }

            if (!rt.isNull($scope.vm.sYm) && !rt.isNull($scope.vm.eYm)) {
                that.searchList.push({ Type: 3, Key: "CreatedOn", Value: [$scope.vm.sYm, moment($scope.vm.eYm).add(1, 'months').format('YYYY-MM')] });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        //日期筛选：默认本月
        $scope.vm.sYm = moment().format('YYYY-MM');
        $scope.vm.eYm = moment().format('YYYY-MM');

        $scope.vm.actions.qualified = function (row) {
            var waiting = rt.showWaiting();
            row.result = { Value: '20', Name: '合格' };
            myService.updateData(row).then(function () {
                // 刷新数据
                $scope.$emit('rt-reload');
                $scope.$broadcast('rt-reload');
            }).finally(function () {
                waiting.close();
            });
        };

        $scope.vm.actions.unqualified = function (row) {
            var waiting = rt.showWaiting();
            row.result = { Value: '30', Name: '不合格' };
            myService.updateData(row).then(function () {
                // 刷新数据
                $scope.$emit('rt-reload');
            }).finally(function () {
                waiting.close();
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : JeoLi
 创建时间 : 2018-02-26
 说明     :代表投入费用
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('UserExpenseService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'UserExpense';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('UserExpenseListController', ['$injector', '$scope', 'UserExpenseService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        this.searchList = [];
        var that = this;

        this.preExport = function () {
            that.searchList.length = 0;

            if (!rt.isNull($scope.vm.stateSelected)) {
                that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.Value });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.sDate) && !rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                if ($scope.vm.sDate.substr(0, 4) !== $scope.vm.eDate.substr(0, 4)) {
                    rt.errorMessage("只可查询同一年的数据");
                    return false;
                }
                if (_CalculateDays($scope.vm.sDate, $scope.vm.eDate) < 0) {
                    rt.errorMessage("开始日期必须小于结束日期");
                    return false;
                }
                var sArr = $scope.vm.sDate.split("-");
                var eArr = $scope.vm.eDate.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }
        };

        this.preSearch = function (params) {
            that.searchList.length = 0;

            if (!rt.isNull($scope.vm.stateSelected)) {
                that.searchList.push({ Type: 1, Key: "StateCode", Value: $scope.vm.stateSelected.Value });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.sDate) && !rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                if ($scope.vm.sDate.substr(0, 4) !== $scope.vm.eDate.substr(0, 4)) {
                    rt.errorMessage("只可查询同一年的数据");
                    return false;
                }
                if (_CalculateDays($scope.vm.sDate, $scope.vm.eDate) < 0) {
                    rt.errorMessage("开始日期必须小于结束日期");
                    return false;
                }
                var sArr = $scope.vm.sDate.split("-");
                var eArr = $scope.vm.eDate.split("-");
                that.searchList.push({ Type: 1, Key: "year", Value: sArr[0] });
                that.searchList.push({ Type: 3, Key: "month", Value: [parseInt(sArr[1]), parseInt(eArr[1]) + 1] });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sDate = d.getFullYear() + "-" + '01';
            $scope.vm.eDate = moment().format('YYYY-MM');
        }

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
    }]).controller('UserExpenseEditController', ['$injector', '$scope', 'UserExpenseService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-05-19
 说明     : 客户协访
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('visitAssistanceService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitAssistance';
        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('visitAssistanceListController', ['$injector', '$scope', '$state', '$compile', 'visitAssistanceService', function ($injector, $scope, $state, $compile, myService) {
        var rt = myService.rt;
        var that = this;
        this.searchList = [];

        this.reload = function _loadData(pageIndex) {
            if (pageIndex && typeof pageIndex === 'number') $scope.vm.page.index = pageIndex;

            var preSearchMessage = $scope.vm.actions.preSearch();
            if (!rt.isNull(preSearchMessage) && preSearchMessage.length > 0) {
                rt.errorMessage(preSearchMessage);
                return;
            }

            var url = "api/VisitAssistance/GetVisitAssistanceListData?sYm=" + moment($scope.vm.sYm).format('YYYY-MM-DD') + "&eYm=" + moment($scope.vm.eYm).format('YYYY-MM-DD') + "&isDone=" + $scope.vm.doneType.value + "&filterType=" + $scope.vm.filterType.value + "&querySearchValue=" + $scope.vm.view.searchText + "&pageSize=" + rt.getPaginationSize() + "&pageIndex=" + $scope.vm.page.index;
            return rt.get(url).then(function (resp) {
                var data = resp.data.DataList;
                data.forEach(function (element) {
                    element.VisitPurpose = JSON.parse(element.visitpurposes);
                }, this);
                $scope.vm.data = data;
                $scope.vm.page.recordCount = resp.data.TotalRecords;
            }).then($scope.vm.actions.loadComplete);
        };

        this.preExport = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.sYm)) {
                that.searchList.push({ Type: 1, Key: "start_time", Value: moment($scope.vm.sYm).format('YYYY-MM-DD') });
            }
            if (!rt.isNull($scope.vm.eYm)) {
                that.searchList.push({ Type: 1, Key: "end_time", Value: moment($scope.vm.eYm).add('days', 1).format('YYYY-MM-DD') });
            }
            if (!rt.isNull($scope.vm.doneType)) {
                that.searchList.push({ Type: 1, Key: "isDone", Value: $scope.vm.doneType.value });
            }
            if (!rt.isNull($scope.vm.filterType)) {
                that.searchList.push({ Type: 1, Key: "filterType", Value: $scope.vm.filterType.value });
            }
            if (!rt.isNullOrWhiteSpace($scope.vm.view.searchText)) {
                that.searchList.push({ Type: 1, Key: "querySearchValue", Value: $scope.vm.view.searchText });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.sYm = localStorage.getItem("assisYm") ? localStorage.getItem("assisYm") : moment(moment().format('YYYY-MM') + '-01').toDate();
        $scope.vm.eYm = localStorage.getItem("assieYm") ? localStorage.getItem("assieYm") : moment(moment().format("YYYY-MM-DD")).toDate();
        $scope.vm.filterModel = [{ value: true, name: '我的协访' }, { value: false, name: '所有协访' }];
        $scope.vm.filterType = localStorage.getItem("filterType") ? JSON.parse(localStorage.getItem("filterType")) : $scope.vm.filterModel[0];
        $scope.vm.doneModel = [{ value: 1, name: '待评价' }, { value: 2, name: '已评价' }];
        $scope.vm.doneType = localStorage.getItem("doneType") ? JSON.parse(localStorage.getItem("doneType")) : $scope.vm.doneModel[0];

        $scope.vm.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        $scope.vm.actions.showEditView = function (id) {
            localStorage.setItem("filterType", JSON.stringify($scope.vm.filterType));
            localStorage.setItem("doneType", JSON.stringify($scope.vm.doneType));
            localStorage.setItem("assisYm", $scope.vm.sYm);
            localStorage.setItem("assieYm", $scope.vm.eYm);
            $state.go("main.visitassistanceedit", { "id": id }, { location: true });
        };
    }]).controller('visitAssistanceEditController', ['$injector', '$scope', '$state', 'visitAssistanceService', function ($injector, $scope, $state, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.canAssist = false;

        $scope.vm.form.loadComplete = function () {
            if (!rt.isNullOrWhiteSpace($scope.vm.form.data.visit_recordId.Id)) {
                var apiUrl = "api/AccountVisit/GetData?id=" + $scope.vm.form.data.visit_recordId.Id;
                rt.get(apiUrl).then(function (resp) {
                    $scope.vm.visitData = resp.data;
                    if (!rt.isNullOrWhiteSpace($scope.vm.visitData.start_time)) {
                        $scope.vm.visitData.start_time = moment($scope.vm.visitData.start_time).format("YYYY-MM-DD HH:mm");
                    }
                    if (!rt.isNullOrWhiteSpace($scope.vm.form.data.done_time)) {
                        $scope.vm.form.data.done_time = moment($scope.vm.form.data.done_time).format("YYYY-MM-DD HH:mm");
                    }
                    var newassList = [];
                    if ($scope.vm.visitData.assistanceList != null) {
                        angular.forEach($scope.vm.visitData.assistanceList, function (entity) {
                            newassList.push({ Id: entity.OwnerId.Id, Name: entity.OwnerIdName });
                        });
                        $scope.vm.visitData.assistanceList = newassList;
                    }
                    _getVisitAssistanceItemList($scope.vm.form.data.visit_recordId.Id);
                });
            }
            _getScore($scope.vm.form.data.avg_score);
            if ($scope.vm.form.data.OwnerId.Id == rt.getUserId()) {
                $scope.vm.canAssist = true;
            }
        };

        function _getVisitAssistanceItemList(visit_recordId) {
            rt.get("api/VisitAssistanceItem/GetItemListByVisitRecordId?visitRecordId=" + visit_recordId + "&visitAssistanceId=" + $scope.vm.form.id).then(function (resp) {
                if (!rt.isNull(resp.data) && resp.data.length > 0) {
                    $scope.vm.itemList = resp.data;
                } else {
                    rt.get("api/VisitAssistanceItemSetting/GetSettingListByVisitType?visitType=" + $scope.vm.visitData.visit_type.Value).then(function (resp) {
                        $scope.vm.settingList = resp.data;
                        $scope.vm.itemList = [];
                        $scope.vm.settingList.forEach(function (setting) {
                            $scope.vm.itemList.push({
                                Id: rt.newGuid(),
                                visit_recordId: $scope.vm.form.data.visit_recordId,
                                visit_assistanceId: { Id: $scope.vm.form.id, Name: "oscar" },
                                visit_assistanceIdName: "oscar",
                                visit_assistance_item_settingid: { Id: setting.Id, Name: setting.name },
                                visit_assistance_item_settingidName: setting.name,
                                visit_type: setting.visit_type,
                                visit_typeName: setting.visit_typeName,
                                name: setting.name,
                                score_0_remark: setting.score_0_remark,
                                score_1_remark: setting.score_1_remark,
                                score_2_remark: setting.score_2_remark,
                                score_3_remark: setting.score_3_remark,
                                item_score: 0
                            });
                        }, this);
                    });
                }
            });
        }

        $scope.vm.form.saveAssistance = function () {
            var waiting = rt.showWaiting();
            var model = { itemList: $scope.vm.itemList, visitAssistance: $scope.vm.form.data };
            var url = "api/VisitAssistance/UpdateVisitAssistAndAssistItemList";
            return rt.post(url, model).then(function () {
                // 刷新数据
                $scope.$emit('rt-reload');
                $scope.$broadcast('rt-reload');
            }).finally(function () {
                waiting.close();
            });
        };

        $scope.vm.form.goback = function () {
            var form = _getForm();
            if (form.$dirty) rt.confirm("当前页面有未保存的数据，确认要关闭？", function (ok) {
                ok && $state.go("main.visitassistance", {}, { location: true });
            });else {
                $state.go("main.visitassistance", {}, { location: true });
            }
        };

        function _getForm() {
            // 获取表单
            var form = $scope[$scope.vm.form.name];
            if ($scope[$scope.vm.form.name] === undefined) {
                form = $scope.$$childTail[$scope.vm.form.name] || $scope.$$childHead[$scope.vm.form.name];
            }

            return form;
        }

        $scope.vm.score = function (itemid, score) {
            var sumScore = 0;
            $scope.vm.itemList.forEach(function (item) {
                if (item.Id == itemid) {
                    item.item_score = score;
                }
                sumScore += item.item_score;
            }, this);
            $scope.vm.form.data.avg_score = sumScore / $scope.vm.itemList.length;
            _getScore($scope.vm.form.data.avg_score);
        };

        function _getScore(score) {
            if (!rt.isNull(score) && score >= 2.5) {
                $scope.vm.summary = "卓越";
            } else if (score >= 2.0 && score < 2.5) {
                $scope.vm.summary = "优秀";
            } else if (score >= 1.5 && score < 2.0) {
                $scope.vm.summary = "好";
            } else if (score >= 1.0 && score < 1.5) {
                $scope.vm.summary = "中";
            } else if (score < 1.0) {
                $scope.vm.summary = "差";
            }
        }
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2017-05-18
 说明     :协访-项目设定
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('visitAssistanceItemSettingService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitAssistanceItemSetting';

        // @@ 选项集
        this.picklists = ['StateCode', 'visit_type'];
    }]).controller('visitAssistanceItemSettingListController', ['$injector', '$compile', '$scope', 'visitAssistanceItemSettingService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('visitAssistanceItemSettingEditController', ['$injector', '$scope', 'visitAssistanceItemSettingService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/10/24
 说明     : 拜访-流程设置 Service
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('visitFlowService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitFlow';
        // @@ 选项集
        this.picklists = ['StateCode', 'visit_type'];
    }]).controller('visitFlowListController', ['$injector', '$scope', 'visitFlowService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('visitFlowEditController', ['$injector', '$scope', 'visitFlowService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //全部项目
        $scope.vm.projectList = [{
            code: "visit_PSI", //项目代码
            name: "进销存采集", //名称
            required: false //是否必须执行
        }, {
            code: "visit_product_display", //项目代码
            name: "陈列检查", //名称
            required: false //是否必须执行
        }, {
            code: "visit_vivid_check", //项目代码
            name: "生动化检查", //名称
            required: false //是否必须执行
        }, {
            code: "visit_sale_policy", //项目代码
            name: "促销政策", //名称
            required: false //是否必须执行
        }, {
            code: "visit_competing_product", //项目代码
            name: "竞品采集", //名称
            required: false //是否必须执行
        }, {
            code: "visit_expired_product", //项目代码
            name: "临逾期上报", //名称
            required: false //是否必须执行
        }, {
            code: "visit_stockout_product", //项目代码
            name: "缺货上报", //名称
            required: false //是否必须执行
        }, {
            code: "visit_defect_product", //项目代码
            name: "缺损上报", //名称
            required: false //是否必须执行
        }, {
            code: "visit_promotion_action", //项目代码
            name: "促销执行", //名称
            required: false //是否必须执行
        }, {
            code: "training_campaign_invitation", //项目代码
            name: "店员培训考试", //名称
            required: false //是否必须执行
        }, {
            code: "training_campaign_ticket_upload", //项目代码
            name: "动销激励", //名称
            required: false //是否必须执行
        }, {
            code: "visit_barcode", //项目代码
            name: "条码扫描", //名称
            required: false //是否必须执行
        }];

        $scope.vm.form.loadComplete = function () {
            if ($scope.vm.form.type === 'Create' || $scope.vm.form.type === 'Edit' && $scope.vm.form.data.itemList.length == 0) {
                //新建记录或者编辑记录时，没有拜访项目
                $scope.vm.unSelectedProjectList = $scope.vm.projectList.concat(); //待选择拜访项目
                $scope.vm.form.data.itemList = []; //已选拜访项目

                //保存并新建，清空radio
                $("input[name=unSelectedProjectList]").removeAttr("checked");
            } else {
                //编辑记录，有拜访项目
                $scope.vm.unSelectedProjectList = $scope.vm.projectList.concat(); //待选择拜访项目

                //已选拜访项目
                _.map($scope.vm.form.data.itemList, function (item) {
                    //在待选择拜访项目中去除
                    var index = _.findIndex($scope.vm.unSelectedProjectList, function (p) {
                        return p.code == item.code;
                    });
                    if (index != -1) $scope.vm.unSelectedProjectList.splice(index, 1);
                });
            }
        };

        //添加
        $scope.vm.add = function () {
            if ($scope.vm.unSelectedProjectList.length == 0) {
                rt.warningMessage("待选择拜访项目为空");
                return;
            }

            var index = parseInt($("input[name='unSelectedProjectList']:checked").val());
            if (!rt.isNumericString(index)) {
                rt.warningMessage("请从左侧【待选择拜访项目】中选择需要添加的项目");
                return;
            }
            $scope.vm.form.data.itemList.push($scope.vm.unSelectedProjectList[index]);
            $scope.vm.unSelectedProjectList.splice(index, 1);
            $scope.vm.dataChanged = true;
        };

        //移除
        $scope.vm.delete = function () {
            if ($scope.vm.form.data.itemList.length == 0) {
                rt.warningMessage("已选拜访项目为空");
                return;
            }

            var index = parseInt($("input[name='selectedProjectList']:checked").val());
            if (!rt.isNumericString(index)) {
                rt.warningMessage("请从右侧【已选拜访项目为空】中选择需要移除的项目");
                return;
            }
            $scope.vm.form.data.itemList[index].required = false;
            $scope.vm.unSelectedProjectList.push($scope.vm.form.data.itemList[index]);
            $scope.vm.form.data.itemList.splice(index, 1);
            $scope.vm.dataChanged = true;
        };

        // 交换数组元素
        function swapItems(arr, index1, index2) {
            arr[index1] = arr.splice(index2, 1, arr[index1])[0];
            return arr;
        };

        //上移
        $scope.vm.moveUp = function () {
            if ($scope.vm.form.data.itemList.length == 0) {
                rt.warningMessage("已选拜访项目为空");
                return;
            }

            var index = parseInt($("input[name='selectedProjectList']:checked").val());
            if (!rt.isNumericString(index)) {
                rt.warningMessage("请从右侧【已选拜访项目】中选择需要上移的项目");
                return;
            }

            if (index == 0) {
                rt.warningMessage("已移到最顶端啦");
                return;
            }
            swapItems($scope.vm.form.data.itemList, index, index - 1);
            $scope.vm.dataChanged = true;
        };

        //下移
        $scope.vm.moveDown = function () {
            if ($scope.vm.form.data.itemList.length == 0) {
                rt.warningMessage("已选拜访项目为空");
                return;
            }

            var index = parseInt($("input[name='selectedProjectList']:checked").val());
            if (!rt.isNumericString(index)) {
                rt.warningMessage("请从右侧【已选拜访项目】中选择需要下移的项目");
                return;
            }

            if (index == $scope.vm.form.data.itemList.length - 1) {
                rt.warningMessage("已移到最底端啦");
                return;
            }
            swapItems($scope.vm.form.data.itemList, index, index + 1);
            $scope.vm.dataChanged = true;
        };

        //必须执行checkbox点击事件
        $scope.vm.updateList = function (index) {
            $scope.vm.form.data.itemList[index].required = !$scope.vm.form.data.itemList[index].required;
        };

        //重写窗口关闭方法
        $scope.vm.form.newHide = function () {
            if ($scope.vm.dataChanged) {
                rt.confirm("当前页面有未保存的数据，确认要关闭？", function (ok) {
                    if (ok) $scope.vm.form.hide();
                });
            } else $scope.vm.form.hide();
        };
    }]);
})();
'use strict';

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/3/9
 *描述：拜访计划
 *************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('visitplanService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessVisit';
        // @@ 选项集
        this.picklists = ['StateCode'];
        //检查账号是否是医院
        this.CheckAccountIsHos = function (id) {
            return rt.get("api/Account/CheckAccountIsHospital?accountId=" + id);
        };
    }]).controller('visitplanListController', ['$scope', 'visitplanService', entityListController]).controller('visitplanEditController', ['$injector', '$scope', 'visitplanService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });
        //根据客户判断是否医院
        $scope.$watch("vm.form.data.accountid.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                myService.CheckAccountIsHos($scope.vm.form.data.accountid.Id).then(function (resp) {
                    var isH = resp.data;
                    if (isH === "1") {
                        $scope.vm.form.data.is_hospital = true;
                    } else {
                        $scope.vm.form.data.is_hospital = false;
                    }
                });
            }
        });
        //$scope.$watch("vm.form.data.provinceid.Id",function(newValue,oldValue){
        //    if(oldValue!=newValue&&!rt.isNull(oldValue)) {
        //        $scope.vm.form.data.cityid=null;
        //        $scope.vm.form.data.countyid=null;
        //        return;
        //    }
        //});
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : CherryXu
 创建时间 : 2017-11-24
 说明     : PC端拜访线路
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('visitrouteService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitRoute';

        // @@ 选项集
        this.picklists = ['StateCode'];

        //根据负责人带出业务部门
        this.GetBusinessUnitDetailByOwnerId = function (ownerId) {
            return rt.get("api/Account/GetBusinessUnitDetailByOwnerId?ownerId=" + ownerId);
        };
    }]).controller('visitrouteListController', ['$injector', '$compile', '$scope', 'visitrouteService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('visitrouteEditController', ['$injector', '$scope', 'visitrouteService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.BusinessUnitId.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrEmptyString(oldValue) && !$scope.vm.form.IsFromOwner) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });

        //watch负责人id变量值 反写业务部门 并且是从负责人选起
        $scope.$watch("vm.form.data.OwnerId.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNullOrWhiteSpace(newValue)) {
                    myService.GetBusinessUnitDetailByOwnerId(newValue).then(function (resp) {
                        var data = resp.data[0];
                        if (data) {
                            $scope.vm.form.data.BusinessUnitId = { Id: data.BusinessUnitId, Name: data.BusinessUnitIdName };
                        }
                    });
                }
            }
        });

        $scope.vm.form.loadComplete = function () {
            if (rt.isNull($scope.vm.form.data.OwnerId) || rt.isNullOrWhiteSpace($scope.vm.form.data.OwnerId.Id)) {
                myService.GetBusinessUnitDetailByOwnerId("").then(function (resp) {
                    var data = resp.data[0];
                    if (data) {
                        $scope.vm.form.data.OwnerId = { Id: data.TblSystemUserId, Name: data.UserName };
                        $scope.vm.form.data.buid = { Id: data.buid, Name: data.buidName };
                        $scope.vm.form.data.bigdeptid = { Id: data.bigdeptid, Name: data.bigdeptidName };
                        $scope.vm.form.data.BusinessUnitId = { Id: data.BusinessUnitId, Name: data.BusinessUnitIdName };
                    }
                });
            }
            if (!rt.isNull($scope.vm.form.data.DetailList)) {
                for (var i = 0; i < $scope.vm.form.data.DetailList.length; i++) {
                    $scope.vm.form.data.DetailList[i].CreatedOn = moment($scope.vm.form.data.DetailList[i].CreatedOn).format('YYYY-MM-DD HH:mm');
                }
            }
        };

        //检查条件
        function checkOption() {
            if (!rt.isNull($scope.vm.form.data.DetailList)) {
                for (var i = $scope.vm.form.data.DetailList.length - 1; i >= 0; i--) {
                    var targetNode = $scope.vm.form.data.DetailList[i];
                    for (var j = 0; j < i; j++) {
                        if (!rt.isNull(targetNode.accountId) && !rt.isNull($scope.vm.form.data.DetailList[j].accountId) && targetNode.accountId.Id == $scope.vm.form.data.DetailList[j].accountId.Id) {
                            // $scope.vm.form.data.DetailList.splice(i, 1);
                            return "拜访客户[" + targetNode.accountId.Name + "]相同，请确保唯一";
                        }
                    }
                }
            }
        }

        $scope.vm.form.preSave = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return msg;
            } else {
                if (!rt.isNull($scope.vm.form.data.DetailList)) {
                    for (var i = 0; i < $scope.vm.form.data.DetailList.length; i++) {
                        // if (rt.isNull($scope.vm.form.data.DetailList[i].accountId)) {
                        //     $scope.vm.form.data.DetailList.splice(i, 1);
                        //     $scope.vm.form.data.accountnumber = $scope.vm.form.data.DetailList.length;
                        //     return;
                        // }
                        if (rt.isNullOrEmptyString($scope.vm.form.data.DetailList[i].visit_route_detailId)) {
                            $scope.vm.form.data.DetailList[i].visit_route_detailId = rt.newGuid();
                        }
                        $scope.vm.form.data.DetailList[i] = {
                            visit_routeId: { Id: $scope.vm.form.id, Name: $scope.vm.form.data.name },
                            visit_route_detailId: $scope.vm.form.data.DetailList[i].visit_route_detailId,
                            accountId: {
                                Id: $scope.vm.form.data.DetailList[i].accountId ? $scope.vm.form.data.DetailList[i].accountId.Id : '',
                                Name: $scope.vm.form.data.DetailList[i].accountId ? $scope.vm.form.data.DetailList[i].accountId.Name : ''
                            },
                            address: $scope.vm.form.data.DetailList[i].address,
                            visit_order: i + 1
                        };
                    }

                    $scope.vm.form.data.accountnumber = $scope.vm.form.data.DetailList.length;
                } else {
                    $scope.vm.form.data.accountnumber = 0;
                }
            }
        };

        //添加客户
        $scope.addDetailAccount = function () {
            $scope.vm.form.data.DetailList.push({
                Id: rt.newGuid(),
                nameid: ""
            });
        };

        //删除客户
        $scope.delAccount = function () {
            var idlist = _.map($scope.vm.form.data.DetailList, 'Id');
            var j = 0;
            rt.post("api/VisitRoute/DeleteList", $scope.vm.view.selectedIdsSystemuser).then(function (resp) {
                $scope.vm.form.data.DetailList = _.remove($scope.vm.form.data.DetailList, function (item) {
                    if ($scope.vm.view.selectedIdsSystemuser[j] != item.Id) {
                        return item;
                    }
                    j++;
                });
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-06-05
 说明     : 客户档案（租户）
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odpAccountService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'OdpAccount';

        this.getAccountList = function (src, queryValue, accountType, pageSize, pageIndex) {
            var url = 'api/OdpAccount/GetAccountList?src=' + src;
            url += '&queryValue=' + queryValue;
            url += '&accountType=' + accountType;
            url += '&pageSize=' + pageSize;
            url += '&pageIndex=' + pageIndex;
            return rt.get(url);
        };

        this.getClientList = function () {
            var url = 'api/OdpAccount/GetClientList';
            return rt.get(url);
        };

        this.getAccountTypeList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=accountclassificationcode";
            return rt.get(url);
        };

        this.getDataById = function (accountId) {
            var url = 'api/OdpAccount/GetDataById?accountId=' + accountId;
            return rt.get(url);
        };
    }]).controller('odpAccountListController', ['$injector', '$compile', '$scope', 'odpAccountService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        _getClientList();
        $scope.vm.getAccountList = _getAccountList;
        $scope.vm.queryValue = '';

        //获取租户列表
        function _getClientList() {
            var waiting = rt.showLoading2();
            myService.getClientList().then(function (resp) {
                $scope.vm.clientList = resp.data;
                $scope.vm.clientList.unshift({ name: '全部租户', id: '' });
                $scope.vm.srcSelected = $scope.vm.clientList[0];
                _getAccountTypeList();
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }

        //获取客户类型列表
        function _getAccountTypeList() {
            var waiting = rt.showLoading2();
            myService.getAccountTypeList().then(function (resp) {
                $scope.vm.accountTypeList = resp.data;
                $scope.vm.accountTypeList.unshift({ Name: '全部类型', Value: '' });
                $scope.vm.accountTypeSelected = $scope.vm.accountTypeList[0];
                _getAccountList();
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }

        //获取客户列表
        function _getAccountList() {
            var waiting = rt.showLoading2();
            myService.getAccountList($scope.vm.srcSelected.name, $scope.vm.queryValue, $scope.vm.accountTypeSelected.Value, $scope.vm.page.size, $scope.vm.page.index).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }
    }]).controller('odpAccountEditController', ['$injector', '$scope', 'odpAccountService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        this.reload = function _loadData() {
            _getDataById();
        };

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //获取客户详情
        function _getDataById() {
            var waiting = rt.showLoading2();
            myService.getDataById($scope.vm.form.id).then(function (resp) {
                $scope.vm.form.data = resp.data;
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2017-07-28
 说明     : 客户别名库
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odpaccountaliasService', ['entityService', function (myService) {
        var rt = myService.rt;
        angular.extend(this, myService);
        this.controllerName = 'OdpAccountAlias';
        this.picklists = ['StateCode'];
    }]).controller('odpaccountaliasListController', ['$scope', '$injector', 'odpaccountaliasService', function ($scope, $injector, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.preSearch = function () {
            $scope.vm.view.searchList = [];
            if (!rt.isNullOrEmptyString($scope.vm.provinceidname)) {
                $scope.vm.view.searchList.push({ Type: 0, Key: "provinceidname", Value: $scope.vm.provinceidname });
            }
            if (!rt.isNullOrEmptyString($scope.vm.cityidname)) {
                $scope.vm.view.searchList.push({ Type: 0, Key: "cityidname", Value: $scope.vm.cityidname });
            }
            if (!rt.isNullOrEmptyString($scope.vm.hosname)) {
                $scope.vm.view.searchList.push({ Type: 0, Key: "account_alias_name,account_std_name", Value: $scope.vm.hosname });
            }
            if ($scope.vm.isUndevelop) {
                $scope.vm.view.searchList.push({ Type: 4, Key: "account_std_name" });
            }
        };
    }]).controller('odpaccountaliasEditController', ['$scope', 'odpaccountaliasService', entityEditController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-08-22
 说明     : 城市别名
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odpcityaliasService', ['entityService', function (myService) {
        var rt = myService.rt;
        angular.extend(this, myService);
        this.controllerName = 'OdpCityAlias';
        this.picklists = ['StateCode'];
    }]).controller('odpcityaliasListController', ['$scope', '$injector', 'odpcityaliasService', function ($scope, $injector, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }])
    // .controller('odpcityaliasEditController', ['$scope', 'odpcityaliasService', entityEditController]);
    .controller('odpcityaliasEditController', ['$injector', '$scope', 'odpcityaliasService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-08-22
 说明     : 区县别名
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odpcountyaliasService', ['entityService', function (myService) {
        var rt = myService.rt;
        angular.extend(this, myService);
        this.controllerName = 'OdpCountyAlias';
        this.picklists = ['StateCode'];
    }]).controller('odpcountyaliasListController', ['$scope', '$injector', 'odpcountyaliasService', function ($scope, $injector, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }])
    // .controller('odpcountyaliasEditController', ['$scope', 'odpcountyaliasService', entityEditController]);
    .controller('odpcountyaliasEditController', ['$injector', '$scope', 'odpcountyaliasService', function ($injector, $scope, myService) {
        var rt = myService.rt;
        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.provinceid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.cityid = null;
                $scope.vm.form.data.countyid = null;
                return;
            }
        });

        $scope.$watch("vm.form.data.cityid.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.form.data.countyid = null;
                return;
            }
        });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2017-07-28
 说明     : 科室别名库
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odpdepartmentaliasService', ['entityService', function (myService) {
        var rt = myService.rt;
        angular.extend(this, myService);
        this.controllerName = 'OdpDepartmentAlias';
        this.picklists = ['StateCode'];
    }]).controller('odpdepartmentaliasListController', ['$scope', '$injector', 'odpdepartmentaliasService', function ($scope, $injector, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.actions.preSearch = function () {
            $scope.vm.view.searchList = [];
            if ($scope.vm.isUndevelop) {
                $scope.vm.view.searchList.push({ Type: 4, Key: "first_typeid,second_typeid" });
            }
        };
    }]).controller('odpdepartmentaliasEditController', ['$scope', 'odpdepartmentaliasService', entityEditController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-06-06
 说明     : 联系人档案（租户）
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odpContactService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'OdpContact';

        this.getContactList = function (src, queryValue, contactType, pageSize, pageIndex) {
            var url = 'api/OdpContact/GetContactList?src=' + src;
            url += '&queryValue=' + queryValue;
            url += '&contactType=' + contactType;
            url += '&pageSize=' + pageSize;
            url += '&pageIndex=' + pageIndex;
            return rt.get(url);
        };

        this.getClientList = function () {
            var url = 'api/OdpContact/GetClientList';
            return rt.get(url);
        };

        this.getContactTypeList = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=contact_type";
            return rt.get(url);
        };

        this.getDataById = function (contactId) {
            var url = 'api/OdpContact/GetDataById?contactId=' + contactId;
            return rt.get(url);
        };

        //检查账号是否是医院
        this.CheckAccountIsHos = function (id) {
            return rt.get("api/Account/CheckAccountIsHospital?accountId=" + id);
        };
        //检查账号是否是商业
        this.CheckAccountIsBus = function (id) {
            return rt.get("api/Account/CheckAccountIsBusiness?accountId=" + id);
        };
    }]).controller('odpContactListController', ['$injector', '$compile', '$scope', 'odpContactService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        _getClientList();
        $scope.vm.getContactList = _getContactList;
        $scope.vm.queryValue = '';

        //获取租户列表
        function _getClientList() {
            var waiting = rt.showLoading2();
            myService.getClientList().then(function (resp) {
                $scope.vm.clientList = resp.data;
                $scope.vm.clientList.unshift({ name: '全部租户', id: '' });
                $scope.vm.srcSelected = $scope.vm.clientList[0];
                _getContactTypeList();
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }

        //获取客户类型列表
        function _getContactTypeList() {
            var waiting = rt.showLoading2();
            myService.getContactTypeList().then(function (resp) {
                $scope.vm.contactTypeList = resp.data;
                $scope.vm.contactTypeList.unshift({ Name: '全部类型', Value: '' });
                $scope.vm.contactTypeSelected = $scope.vm.contactTypeList[0];
                _getContactList();
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }

        //获取客户列表
        function _getContactList() {
            var waiting = rt.showLoading2();
            myService.getContactList($scope.vm.srcSelected.name, $scope.vm.queryValue, $scope.vm.contactTypeSelected.Value, $scope.vm.page.size, $scope.vm.page.index).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }
    }]).controller('odpContactEditController', ['$injector', '$scope', 'odpContactService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        this.reload = function _loadData() {
            _getDataById();
        };

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //获取联系人详情
        function _getDataById() {
            var waiting = rt.showLoading2();
            myService.getDataById($scope.vm.form.id).then(function (resp) {
                $scope.vm.form.data = resp.data;
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        };

        // $scope.$watch('vm.form.data.accountid', function (newValue, oldValue) {
        //     if (oldValue != newValue) {
        //         myService.CheckAccountIsHos($scope.vm.form.data.accountid.Id)
        //             .then(function (resp) {
        //                 var isH = resp.data;
        //                 if (isH === "1") {
        //                     $scope.vm.form.data.is_hospital = true;
        //                 }
        //                 else {
        //                     $scope.vm.form.data.is_hospital = false;
        //                 }
        //             });

        //         myService.CheckAccountIsBus($scope.vm.form.data.accountid.Id)
        //             .then(function (resp) {
        //                 var isH = resp.data;
        //                 if (isH === "1") {
        //                     $scope.vm.is_business = true;
        //                 }
        //                 else {
        //                     $scope.vm.is_business = false;
        //                 }
        //             });

        //         if (!rt.isNull($scope.vm.form.data.accountid) && $scope.vm.form.type === 'Create') {
        //             var id = $scope.vm.form.data.accountid.Id;
        //             var waiting = rt.showWaiting();
        //             var url2 = 'api/Department/GetCodeById?id=' + id;
        //             rt.get(url2)
        //                 .then(function (resp) {
        //                     $scope.vm.form.data.accountnumber = resp.data;
        //                 })
        //                 .catch(function (msg) {
        //                     rt.errorMessage(msg);
        //                 })
        //                 .finally(function () {
        //                     waiting.close();
        //                 })

        //             var url3 = 'api/accountcontact/GetContactProvince?id=' + id;
        //             rt.get(url3)
        //                 .then(function (resp) {
        //                     $scope.vm.form.data.provinceid = {
        //                         Id: resp.data.Id,
        //                         Name: resp.data.Name
        //                     };
        //                 })
        //                 .catch(function (msg) {
        //                     rt.errorMessage(msg);
        //                 })
        //                 .finally(function () {
        //                     vm.isLoading = false;
        //                 });
        //         }
        //     }
        // });
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2017-07-28
 说明     : 科室(爬虫)数据列表 以及 爬虫科室的同步页 
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odpdepartmentcrawlerService', ['entityService', function (myService) {
        var rt = myService.rt;
        angular.extend(this, myService);

        this.controllerName = 'OdpDepartmentCrawler';
        this.picklists = ['StateCode', 'odp_crawler_source'];
        //同步数据
        this.SyncDepartmentCrawlerDataFromCsv = function (paramStr) {
            return rt.get("api/OdpDepartmentCrawler/SyncDepartmentCrawlerDataFromCsv?paramStr=" + paramStr);
        };

        //获取同步数据结果
        this.GetSyncResult = function (paramStr) {
            return rt.get("api/OdpDepartmentCrawler/GetSyncResult?paramStr=" + paramStr);
        };

        //获取爬虫医院分页数据
        this.GetOdpDepartmentCrawlerByPage = function (hosName, depName, fromSite, pageIndex, pageSize) {
            return rt.get("api/OdpDepartmentCrawler/GetOdpDepartmentCrawlerByPage?hosName=" + hosName + "&depName=" + depName + "&fromSite=" + fromSite + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex);
        };
    }]).controller('odpdepartmentcrawlerListController', ['$scope', '$state', '$injector', 'odpdepartmentcrawlerService', function ($scope, $state, $injector, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        function _init() {
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.search = _searchData;
            $scope.vm.gotoSyncPage = _gotoSyncData;
        }
        //搜索
        function _searchData() {
            var hosname = rt.isNullOrEmptyString($scope.vm.hosname) ? "" : $scope.vm.hosname;
            var depname = rt.isNullOrEmptyString($scope.vm.depname) ? "" : $scope.vm.depname;
            var fromWebSite = rt.isNull($scope.vm.fromWebSite) ? "" : $scope.vm.fromWebSite.Value;
            myService.GetOdpDepartmentCrawlerByPage(hosname, depname, fromWebSite, $scope.vm.pageIndex, $scope.vm.pageSize).then(function (resp) {
                var data = resp.data;
                if (data) {
                    $scope.vm.data = data.DataList;
                    $scope.vm.recordCount = data.TotalRecords;
                }
            });
        };

        //跳转到同步页
        function _gotoSyncData() {
            $state.go('main.syncdepartmentcrawler', {}, { location: true });
        }

        _init();
    }]).controller('syncdepartmentcrawlerListController', ['$scope', '$state', 'odpdepartmentcrawlerService', function ($scope, $state, myService) {
        var rt = myService.rt;
        function _init() {
            $scope.vm.paramStr = '';
            $scope.vm.syncResult = "";
            $scope.vm.enable = true;
            $scope.vm.WebSites = [{ name: '好大夫在线', value: 'hdf' }, { name: '丁香园', value: 'dxy' }, { name: '微医（挂号网）', value: 'wy' }, { name: '99医生点评', value: 'yyk99' }];
            $scope.vm.startSync = _startSync;
            $scope.vm.goBack = _goBack;
            $scope.vm.refreshSyncResult = _GetSyncResult;
        }

        //开始同步
        function _startSync() {
            _prepairParam();
            if (rt.isNullOrEmptyString($scope.vm.paramStr)) {
                rt.showErrorToast("请至少选择一项进行同步");
                return;
            } else {
                //请求接口
                myService.SyncDepartmentCrawlerDataFromCsv($scope.vm.paramStr);
            }
        }

        //获取同步结果
        function _GetSyncResult() {
            _prepairParam();
            if (rt.isNullOrEmptyString($scope.vm.paramStr)) {
                rt.showErrorToast("请先至少选择一项进行同步");
                return;
            } else {
                //请求接口
                $scope.vm.syncResult = "";
                myService.GetSyncResult($scope.vm.paramStr).then(function (resp) {
                    if (resp.data) {
                        var data = resp.data;
                        if (data != null && data.length > 0) {
                            _.forEach(data, function (item) {
                                $scope.vm.syncResult += item.SiteName + "同步结果：\n";
                                $scope.vm.syncResult += "一共" + item.TotalQty + "条记录，成功同步" + item.SyncQty + "条\n";
                            });
                        }
                    }
                });
            }
        }

        function _prepairParam() {
            $scope.vm.paramStr = '';
            _.forEach($scope.vm.WebSites, function (item) {
                if (item.checked) {
                    $scope.vm.paramStr += item.value + ',';
                }
            });
        }

        //返回上一页
        function _goBack() {
            $state.go("main.odpdepartmentcrawler", {}, { location: true });
        }

        _init();
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2017-07-28
 说明     : 医生(爬虫)数据列表 以及 爬虫医生的同步页 
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odpdoctorcrawlerService', ['entityService', function (myService) {
        var rt = myService.rt;
        angular.extend(this, myService);

        this.controllerName = 'OdpDoctorCrawler';
        this.picklists = ['StateCode', 'odp_crawler_source'];
        //同步数据
        this.SyncDoctorCrawlerDataFromCsv = function (paramStr) {
            return rt.get("api/OdpDoctorCrawler/SyncDoctorCrawlerDataFromCsv?paramStr=" + paramStr);
        };

        //获取同步数据结果
        this.GetSyncResult = function (paramStr) {
            return rt.get("api/OdpDoctorCrawler/GetSyncResult?paramStr=" + paramStr);
        };

        //获取爬虫医院分页数据
        this.GetOdpDoctorCrawlerByPage = function (hosName, depName, docName, fromSite, pageIndex, pageSize) {
            return rt.get("api/OdpDoctorCrawler/GetOdpDoctorCrawlerByPage?hosName=" + hosName + "&depName=" + depName + "&docName=" + docName + "&fromSite=" + fromSite + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex);
        };
    }]).controller('odpdoctorcrawlerListController', ['$scope', '$state', '$injector', 'odpdoctorcrawlerService', function ($scope, $state, $injector, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        function _init() {
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.search = _searchData;
            $scope.vm.gotoSyncPage = _gotoSyncData;
        }
        //搜索
        function _searchData() {
            var hosname = rt.isNullOrEmptyString($scope.vm.hosname) ? "" : $scope.vm.hosname;
            var depname = rt.isNullOrEmptyString($scope.vm.depname) ? "" : $scope.vm.depname;
            var docname = rt.isNullOrEmptyString($scope.vm.docname) ? "" : $scope.vm.docname;
            var fromWebSite = rt.isNull($scope.vm.fromWebSite) ? "" : $scope.vm.fromWebSite.Value;
            myService.GetOdpDoctorCrawlerByPage(hosname, depname, docname, fromWebSite, $scope.vm.pageIndex, $scope.vm.pageSize).then(function (resp) {
                var data = resp.data;
                if (data) {
                    $scope.vm.data = data.DataList;
                    $scope.vm.recordCount = data.TotalRecords;
                }
            });
        };

        //跳转到同步页
        function _gotoSyncData() {
            $state.go('main.syncdoctorcrawler', {}, { location: true });
        }

        _init();
    }]).controller('syncdoctorcrawlerListController', ['$scope', '$state', 'odpdoctorcrawlerService', function ($scope, $state, myService) {
        var rt = myService.rt;
        function _init() {
            $scope.vm.paramStr = '';
            $scope.vm.syncResult = "";
            $scope.vm.enable = true;
            $scope.vm.WebSites = [{ name: '好大夫在线', value: 'hdf' }, { name: '丁香园', value: 'dxy' }, { name: '微医（挂号网）', value: 'wy' }, { name: '99医生点评', value: 'yyk99' }];
            $scope.vm.startSync = _startSync;
            $scope.vm.goBack = _goBack;
            $scope.vm.refreshSyncResult = _GetSyncResult;
        }

        //开始同步
        function _startSync() {
            _prepairParam();
            if (rt.isNullOrEmptyString($scope.vm.paramStr)) {
                rt.showErrorToast("请至少选择一项进行同步");
                return;
            } else {
                $scope.vm.enable = false;
                //请求接口
                myService.SyncDoctorCrawlerDataFromCsv($scope.vm.paramStr);
            }
        }

        //获取同步结果
        function _GetSyncResult() {
            _prepairParam();
            if (rt.isNullOrEmptyString($scope.vm.paramStr)) {
                rt.showErrorToast("请先至少选择一项进行同步");
                return;
            } else {
                //请求接口
                $scope.vm.syncResult = "";
                myService.GetSyncResult($scope.vm.paramStr).then(function (resp) {
                    if (resp.data) {
                        var data = resp.data;
                        if (data != null && data.length > 0) {
                            _.forEach(data, function (item) {
                                $scope.vm.syncResult += item.SiteName + "同步结果：\n";
                                $scope.vm.syncResult += "一共" + item.TotalQty + "条记录，成功同步" + item.SyncQty + "条\n";
                            });
                        }
                    }
                });
            }
        }

        function _prepairParam() {
            $scope.vm.paramStr = '';
            _.forEach($scope.vm.WebSites, function (item) {
                if (item.checked) {
                    $scope.vm.paramStr += item.value + ',';
                }
            });
        }

        //返回上一页
        function _goBack() {
            $state.go("main.odpdoctorcrawler", {}, { location: true });
        }

        _init();
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2017-07-28
 说明     : 门店(爬虫)数据列表 以及 爬虫门店的同步页 
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odpdrugstorecrawlerService', ['entityService', function (myService) {
        var rt = myService.rt;
        angular.extend(this, myService);

        this.controllerName = 'OdpDrugStoreCrawler';
        this.picklists = ['StateCode', 'odp_drugstore_crawler_source'];
        //同步数据
        this.SyncdrugstoreCrawlerDataFromCsv = function (paramStr) {
            return rt.get("api/OdpDrugStoreCrawler/SyncDrugStoreCrawlerDataFromCsv?paramStr=" + paramStr);
        };

        //获取同步数据结果
        this.GetSyncResult = function (paramStr) {
            return rt.get("api/OdpDrugStoreCrawler/GetSyncResult?paramStr=" + paramStr);
        };

        //获取爬虫门店分页数据
        this.GetOdpDrugStoreCrawlerByPage = function (drugstorename, gspcode, fromSite, pageIndex, pageSize) {
            return rt.get("api/OdpDrugStoreCrawler/GetOdpDrugStoreCrawlerByPage?drugstorename=" + drugstorename + "&gspcode=" + gspcode + "&fromSite=" + fromSite + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex);
        };
    }]).controller('odpdrugstorecrawlerListController', ['$scope', '$state', '$injector', 'odpdrugstorecrawlerService', function ($scope, $state, $injector, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        function _init() {
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.search = _searchData;
            $scope.vm.gotoSyncPage = _gotoSyncData;
        }
        //搜索
        function _searchData() {
            var drugstorename = rt.isNullOrEmptyString($scope.vm.drugstorename) ? "" : $scope.vm.drugstorename;
            var gspcode = rt.isNullOrEmptyString($scope.vm.gspcode) ? "" : $scope.vm.gspcode;
            var fromWebSite = rt.isNull($scope.vm.fromWebSite) ? "" : $scope.vm.fromWebSite.Value;
            myService.GetOdpDrugStoreCrawlerByPage(drugstorename, gspcode, fromWebSite, $scope.vm.pageIndex, $scope.vm.pageSize).then(function (resp) {
                var data = resp.data;
                if (data) {
                    $scope.vm.data = data.DataList;
                    $scope.vm.recordCount = data.TotalRecords;
                }
            });
        };

        //跳转到同步页
        function _gotoSyncData() {
            $state.go('main.syncdrugstorecrawler', {}, { location: true });
        }

        _init();
    }]).controller('syncdrugstorecrawlerListController', ['$scope', '$state', 'odpdrugstorecrawlerService', function ($scope, $state, myService) {
        var rt = myService.rt;
        function _init() {
            $scope.vm.paramStr = '';
            $scope.vm.syncResult = "";
            $scope.vm.enable = true;
            $scope.vm.WebSites = [{ name: '药监局', value: 'cfda' }];
            $scope.vm.startSync = _startSync;
            $scope.vm.goBack = _goBack;
            $scope.vm.refreshSyncResult = _GetSyncResult;
        }

        //开始同步
        function _startSync() {
            _prepairParam();
            if (rt.isNullOrEmptyString($scope.vm.paramStr)) {
                rt.showErrorToast("请至少选择一项进行同步");
                return;
            } else {
                $scope.vm.enable = false;
                //请求接口
                myService.SyncdrugstoreCrawlerDataFromCsv($scope.vm.paramStr);
            }
        }

        //获取同步结果
        function _GetSyncResult() {
            _prepairParam();
            if (rt.isNullOrEmptyString($scope.vm.paramStr)) {
                rt.showErrorToast("请先至少选择一项进行同步");
                return;
            } else {
                //请求接口
                $scope.vm.syncResult = "";
                myService.GetSyncResult($scope.vm.paramStr).then(function (resp) {
                    if (resp.data) {
                        var data = resp.data;
                        if (data != null && data.length > 0) {
                            _.forEach(data, function (item) {
                                $scope.vm.syncResult += item.SiteName + "同步结果：\n";
                                $scope.vm.syncResult += "一共" + item.TotalQty + "条记录，成功同步" + item.SyncQty + "条\n";
                            });
                        }
                    }
                });
            }
        }

        function _prepairParam() {
            $scope.vm.paramStr = '';
            _.forEach($scope.vm.WebSites, function (item) {
                if (item.checked) {
                    $scope.vm.paramStr += item.value + ',';
                }
            });
        }

        //返回上一页
        function _goBack() {
            $state.go("main.odpdrugstorecrawler", {}, { location: true });
        }

        _init();
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2017-07-28
 说明     : 医院(爬虫)数据列表 以及 爬虫医院的同步页 
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('odphospitalcrawlerService', ['entityService', function (myService) {
        var rt = myService.rt;
        angular.extend(this, myService);

        this.controllerName = 'OdpHospitalCrawler';
        this.picklists = ['StateCode', 'odp_crawler_source'];
        //同步数据
        this.SyncHospitalCrawlerDataFromCsv = function (paramStr) {
            return rt.get("api/OdpHospitalCrawler/SyncHospitalCrawlerDataFromCsv?paramStr=" + paramStr);
        };

        //获取同步数据结果
        this.GetSyncResult = function (paramStr) {
            return rt.get("api/OdpHospitalCrawler/GetSyncResult?paramStr=" + paramStr);
        };

        //获取爬虫医院分页数据
        this.GetOdpHospitalCrawlerByPage = function (hosName, fromSite, pageIndex, pageSize) {
            return rt.get("api/OdpHospitalCrawler/GetOdpHospitalCrawlerByPage?hosName=" + hosName + "&fromSite=" + fromSite + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex);
        };
    }]).controller('odphospitalcrawlerListController', ['$scope', '$state', '$injector', 'odphospitalcrawlerService', function ($scope, $state, $injector, myService) {
        var rt = myService.rt;
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
        function _init() {
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.search = _searchData;
            $scope.vm.gotoSyncPage = _gotoSyncData;
        }
        //搜索
        function _searchData() {
            var hosname = rt.isNullOrEmptyString($scope.vm.hosname) ? "" : $scope.vm.hosname;
            var fromWebSite = rt.isNull($scope.vm.fromWebSite) ? "" : $scope.vm.fromWebSite.Value;
            myService.GetOdpHospitalCrawlerByPage(hosname, fromWebSite, $scope.vm.pageIndex, $scope.vm.pageSize).then(function (resp) {
                var data = resp.data;
                if (data) {
                    $scope.vm.data = data.DataList;
                    $scope.vm.recordCount = data.TotalRecords;
                }
            });
        };

        //跳转到同步页
        function _gotoSyncData() {
            $state.go('main.synchospitalcrawler', {}, { location: true });
        }

        _init();
    }]).controller('synchospitalcrawlerListController', ['$scope', '$state', 'odphospitalcrawlerService', function ($scope, $state, myService) {
        var rt = myService.rt;
        function _init() {
            $scope.vm.paramStr = '';
            $scope.vm.syncResult = "";
            $scope.vm.enable = true;
            $scope.vm.WebSites = [{ name: '好大夫在线', value: 'hdf' }, { name: '丁香园', value: 'dxy' }, { name: '微医（挂号网）', value: 'wy' }, { name: '99医生点评', value: 'yyk99' }];
            $scope.vm.startSync = _startSync;
            $scope.vm.goBack = _goBack;
            $scope.vm.refreshSyncResult = _GetSyncResult;
        }

        //开始同步
        function _startSync() {
            _prepairParam();
            if (rt.isNullOrEmptyString($scope.vm.paramStr)) {
                rt.showErrorToast("请至少选择一项进行同步");
                return;
            } else {
                $scope.vm.enable = false;
                window.localStorage.setItem('WebSitesStatus', JSON.stringify($scope.vm.WebSites));
                //请求接口
                myService.SyncHospitalCrawlerDataFromCsv($scope.vm.paramStr);
            }
        }

        //获取同步结果
        function _GetSyncResult() {
            _prepairParam();
            if (rt.isNullOrEmptyString($scope.vm.paramStr)) {
                rt.showErrorToast("请先至少选择一项进行同步");
                return;
            } else {
                //请求接口
                $scope.vm.syncResult = "";
                myService.GetSyncResult($scope.vm.paramStr).then(function (resp) {
                    if (resp.data) {
                        var data = resp.data;
                        if (data != null && data.length > 0) {
                            _.forEach(data, function (item) {
                                $scope.vm.syncResult += item.SiteName + "同步结果：\n";
                                $scope.vm.syncResult += "一共" + item.TotalQty + "条记录，成功同步" + item.SyncQty + "条\n";
                            });
                        }
                    }
                });
            }
        }

        function _prepairParam() {
            $scope.vm.paramStr = '';
            _.forEach($scope.vm.WebSites, function (item) {
                if (item.checked) {
                    $scope.vm.paramStr += item.value + ',';
                }
            });
        }

        //返回上一页
        function _goBack() {
            $state.go("main.odphospitalcrawler", {}, { location: true });
        }

        _init();
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : CherryXu
 创建时间 : 2017-11-24
 说明     : PC端拜访线路
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('visitrouteweeklyService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;

        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitRouteWeekly';

        // @@ 选项集
        this.picklists = ['StateCode'];

        //根据负责人带出业务部门
        this.GetBusinessUnitDetailByOwnerId = function (ownerId) {
            return rt.get("api/Account/GetBusinessUnitDetailByOwnerId?ownerId=" + ownerId);
        };
    }]).controller('visitrouteweeklyListController', ['$injector', '$compile', '$scope', 'visitrouteweeklyService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('visitrouteweeklyEditController', ['$injector', '$scope', 'visitrouteweeklyService', function ($injector, $scope, myService) {
        var rt = myService.rt;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.$watch("vm.form.data.BusinessUnitId.Id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrEmptyString(oldValue)) {
                $scope.vm.form.data.OwnerId = null;
                return;
            }
        });

        //watch负责人id变量值 反写业务部门 并且是从负责人选起
        $scope.$watch("vm.form.data.OwnerId.Id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                if (!rt.isNullOrEmptyString(oldValue)) {
                    $scope.vm.form.data.monday_visit_routeid = null;
                    $scope.vm.form.data.tuesday_visit_routeid = null;
                    $scope.vm.form.data.wednesday_visit_routeid = null;
                    $scope.vm.form.data.thurday_visit_routeid = null;
                    $scope.vm.form.data.friday_visit_routeid = null;
                    $scope.vm.form.data.saturday_visit_routeid = null;
                    $scope.vm.form.data.sunday_visit_routeid = null;
                }
                if (!rt.isNullOrWhiteSpace(newValue)) {
                    myService.GetBusinessUnitDetailByOwnerId(newValue).then(function (resp) {
                        var data = resp.data[0];
                        if (data) {
                            $scope.vm.form.data.BusinessUnitId = { Id: data.BusinessUnitId, Name: data.BusinessUnitIdName };
                        }
                    });
                }
            }
        });

        $scope.vm.form.loadComplete = function () {
            if (rt.isNull($scope.vm.form.data.OwnerId) || rt.isNullOrWhiteSpace($scope.vm.form.data.OwnerId.Id)) {
                myService.GetBusinessUnitDetailByOwnerId("").then(function (resp) {
                    var data = resp.data[0];
                    if (data) {
                        $scope.vm.form.data.OwnerId = { Id: data.TblSystemUserId, Name: data.UserName };
                        $scope.vm.form.data.buid = { Id: data.buid, Name: data.buidName };
                        $scope.vm.form.data.bigdeptid = { Id: data.bigdeptid, Name: data.bigdeptidName };
                        $scope.vm.form.data.BusinessUnitId = { Id: data.BusinessUnitId, Name: data.BusinessUnitIdName };
                    }
                });
            }
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-08-21
 说明     : 科室类型 Service
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('departmentTypeService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'DepartmentType';
    }]).controller('departmentTypeListController', ['$scope', 'departmentTypeService', entityListController]).controller('departmentTypeEditController', ['$scope', 'departmentTypeService', entityEditController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-09-13
 说明     : 门店数据清洗 Service
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('DrugStoreDataCleanService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'DrugStore';

        //获取数据源
        this.GetDataSource = function () {
            return rt.get("api/DrugStore/GetDataSource");
        };

        //合并爬虫和租户的门店数据
        this.CollectData = function (srcName) {
            return rt.get("api/DrugStore/CollectData?srcName=" + srcName);
        };

        //调用百度接口，获取经纬度、省市信息及电话
        this.GetProvinceCityCounty = function (srcName) {
            return rt.get("api/DrugStore/GetProvinceCityCounty?srcName=" + srcName);
        };

        //调用百度接口，获取省市信息
        this.GetProvinceCityCounty2 = function (srcName) {
            return rt.get("api/DrugStore/GetProvinceCityCounty2?srcName=" + srcName);
        };

        //处理门店名称，加上市\县信息（百度地图）
        this.HandleBaiDuDrugStoreName = function (srcName) {
            return rt.get("api/DrugStore/HandleBaiDuDrugStoreName?srcName=" + srcName);
        };

        //处理别名（省份）
        this.HandleProvinceAliasName = function (srcName) {
            return rt.get("api/DrugStore/HandleProvinceAliasName?srcName=" + srcName);
        };

        //处理别名（城市）
        this.HandleCityAliasName = function (srcName) {
            return rt.get("api/DrugStore/HandleCityAliasName?srcName=" + srcName);
        };

        //处理别名（区县）
        this.HandleCountyAliasName = function (srcName) {
            return rt.get("api/DrugStore/HandleCountyAliasName?srcName=" + srcName);
        };

        //处理别名（门店别名）
        this.HandleDrugStoreAliasName = function (srcName) {
            return rt.get("api/DrugStore/HandleDrugStoreAliasName?srcName=" + srcName);
        };

        //合并重名
        this.MergeDrugStoreSameName = function () {
            return rt.get("api/DrugStore/MergeSameName");
        };
    }]).controller('DrugStoreDataCleanListController', ['$injector', '$scope', '$state', 'DrugStoreDataCleanService', function ($injector, $scope, $state, myService) {
        var rt = myService.rt;
        var that = this;

        this.searchList = [];

        this.preSearch = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.provinceid) && !rt.isNullOrWhiteSpace($scope.vm.provinceid.Value)) {
                that.searchList.push({ Type: 1, Key: "std_provinceid", Value: $scope.vm.provinceid.Value });
            }

            if (!rt.isNull($scope.vm.cityid) && !rt.isNullOrWhiteSpace($scope.vm.cityid.Value)) {
                that.searchList.push({ Type: 1, Key: "std_cityid", Value: $scope.vm.cityid.Value });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.drugStoreName)) {
                that.searchList.push({ Type: 0, Key: "name", Value: $scope.vm.drugStoreName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        _getProvince();

        //获取省份
        function _getProvince() {
            $scope.vm.provinceList = [{ Name: '全部', Value: '' }];
            $scope.vm.provinceid = $scope.vm.provinceList[0];
            rt.queryData("Province.GetProvince", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    _.map(data, function (item) {
                        $scope.vm.provinceList.push({ Name: item.name, Value: item.id });
                    });
                }
            }, function (error) {});
        }

        //获取城市
        $scope.$watch("vm.provinceid.Value", function (newValue, oldValue) {
            $scope.vm.cityList = [{ Name: '全部', Value: '' }];
            $scope.vm.cityid = $scope.vm.cityList[0];
            if (oldValue != newValue) {
                rt.queryData("Province.GetCity", { '@queryValue': '', '@provinceid': $scope.vm.provinceid.Value }, function (resp) {
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        _.map(data, function (item) {
                            $scope.vm.cityList.push({ Name: item.name, Value: item.Id });
                        });
                    }
                }, function (error) {});
            }
        });

        $scope.vm.handle = function () {
            $state.go("main.drugstoredatadleanhandle", { location: true });
        };
    }]).controller('DrugStoreDataCleanHandleController', ['$injector', '$scope', '$state', 'DrugStoreDataCleanService', function ($injector, $scope, $state, myService) {
        var rt = myService.rt;
        var $q = myService.$q;

        _init();

        function _init() {
            $scope.srcList = [{ Name: '全部' }];
            $scope.srcSelected = $scope.srcList[0];
            $scope.vm = {};

            myService.GetDataSource().then(function (resp) {
                if (resp.data != null && resp.data.length > 0) {
                    _.map(resp.data, function (item) {
                        $scope.srcList.push({ Name: item });
                    });
                }
            }).catch(function (err) {
                rt.errorMessage(err.data);
            });
        }

        //步骤1：合并爬虫和租户数据
        $scope.vm.collect = function () {
            var waiting = rt.showWaiting();
            myService.CollectData($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                rt.successMessage('合并爬虫和租户的数据成功');
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤2：调用百度接口，根据名称获取经纬度、省市县信息（CFDA）
        $scope.vm.getProvinceCityCounty = function () {
            var waiting = rt.showWaiting();
            myService.GetProvinceCityCounty($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                rt.successMessage('调用百度接口获取省市县信息成功');
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤2：调用百度接口，根据经纬度获取省市县信息（百度地图）
        $scope.vm.getProvinceCityCounty2 = function () {
            var waiting = rt.showWaiting();
            myService.GetProvinceCityCounty2($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                rt.successMessage('调用百度接口获取省市县信息成功');
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤3：处理门店名称，加上市\县信息（百度、高德）
        $scope.vm.handleBaiDuDrugStoreName = function () {
            var waiting = rt.showWaiting();
            myService.HandleBaiDuDrugStoreName($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                rt.successMessage('处理门店名称，加上市\县信息成功');
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤3：处理别名（省份）
        $scope.vm.handleProvince = function () {
            var waiting = rt.showWaiting();
            myService.HandleProvinceAliasName($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                if (!rt.isNullOrWhiteSpace(resp.data)) {
                    rt.errorMessage(resp.data);
                } else {
                    rt.successMessage('处理别名（省份）成功');
                }
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤4：处理别名（城市）
        $scope.vm.handleCity = function () {
            var waiting = rt.showWaiting();
            myService.HandleCityAliasName($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                if (!rt.isNullOrWhiteSpace(resp.data)) {
                    rt.errorMessage(resp.data);
                } else {
                    rt.successMessage('处理别名（城市）成功');
                }
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤5：处理别名（区县）
        $scope.vm.handleCounty = function () {
            var waiting = rt.showWaiting();
            myService.HandleCountyAliasName($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                if (!rt.isNullOrWhiteSpace(resp.data)) {
                    rt.errorMessage(resp.data);
                } else {
                    rt.successMessage('处理别名（区县）成功');
                }
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤7：处理别名（门店别名）
        $scope.vm.handleDrugStoreAliasName = function () {
            var waiting = rt.showWaiting();
            myService.HandleDrugStoreAliasName($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                rt.successMessage('处理别名（门店别名）成功');
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤9：合并重名
        $scope.vm.merge = function () {
            var waiting = rt.showWaiting();
            myService.MergeDrugStoreSameName().then(function (resp) {
                rt.successMessage('合并重名成功');
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        };

        $scope.vm.goBack = function () {
            $state.go("main.drugstoredatadlean", { location: true });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2017-08-21
 说明     : 医院级别 Service
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('hospitalLevelService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'OdpHospitalLevel';
    }]).controller('hospitalLevelListController', ['$scope', 'hospitalLevelService', entityListController]).controller('hospitalLevelEditController', ['$scope', 'hospitalLevelService', entityEditController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-07-26
 说明     : 协议租户设置 Service
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('tenantService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'Tenant';
    }]).controller('tenantListController', ['$scope', 'tenantService', entityListController]).controller('tenantEditController', ['$scope', 'tenantService', entityEditController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-08-01
 说明     : 客户数据清洗 Service
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('tenantDataCleanService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'HospitalOdp';

        //获取数据源
        this.GetDataSource = function () {
            return rt.get("api/HospitalOdp/GetDataSource");
        };

        //合并爬虫和租户的医院数据
        this.CollectHospitalData = function (srcName) {
            return rt.get("api/HospitalOdp/CollectData?srcName=" + srcName);
        };

        //合并爬虫和租户的医生数据
        this.CollectDoctorData = function (srcName) {
            return rt.get("api/Doctor/CollectData?srcName=" + srcName);
        };

        //医院-调用百度接口，获取省市信息
        this.GetProvinceCityCounty = function (srcName) {
            return rt.get("api/HospitalOdp/GetProvinceCityCounty?srcName=" + srcName);
        };

        //医院-处理别名（省份）
        this.HandleHospitalProvinceAliasName = function (srcName) {
            return rt.get("api/HospitalOdp/HandleProvinceAliasName?srcName=" + srcName);
        };

        //医院-处理别名（城市）
        this.HandleHospitalCityAliasName = function (srcName) {
            return rt.get("api/HospitalOdp/HandleCityAliasName?srcName=" + srcName);
        };

        //医院-处理别名（区县）
        this.HandleHospitalCountyAliasName = function (srcName) {
            return rt.get("api/HospitalOdp/HandleCountyAliasName?srcName=" + srcName);
        };

        //医院-处理级别
        this.HandleHospitalGradeAliasName = function (srcName) {
            return rt.get("api/HospitalOdp/HandleHospitalGradeAliasName?srcName=" + srcName);
        };

        //医生-处理科室
        this.HandleDoctorDepartmentAliasName = function (srcName) {
            return rt.get("api/DoctorOdp/HandleDoctorDepartmentAliasName?srcName=" + srcName);
        };

        //医院-处理别名（医院别名）
        this.HandleHospitalAliasName1 = function (srcName) {
            return rt.get("api/HospitalOdp/HandleHospitalAliasName?srcName=" + srcName);
        };

        //医院-合并重名
        this.MergeHospitalSameName = function () {
            return rt.get("api/HospitalOdp/MergeSameName");
        };
    }]).controller('tenantDataCleanListController', ['$injector', '$scope', '$state', 'tenantDataCleanService', function ($injector, $scope, $state, myService) {
        var rt = myService.rt;
        var that = this;

        this.searchList = [];

        this.preSearch = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.provinceid) && !rt.isNullOrWhiteSpace($scope.vm.provinceid.Value)) {
                that.searchList.push({ Type: 1, Key: "provinceid", Value: $scope.vm.provinceid.Value });
            }

            if (!rt.isNull($scope.vm.cityid) && !rt.isNullOrWhiteSpace($scope.vm.cityid.Value)) {
                that.searchList.push({ Type: 1, Key: "cityid", Value: $scope.vm.cityid.Value });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.hospitalName)) {
                that.searchList.push({ Type: 0, Key: "name", Value: $scope.vm.hospitalName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.selectedTabName = 'HospitalOdp';
        _getProvince();

        //获取省份
        function _getProvince() {
            $scope.vm.provinceList = [{ Name: '全部', Value: '' }];
            $scope.vm.provinceid = $scope.vm.provinceList[0];
            rt.queryData("Province.GetProvince", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    _.map(data, function (item) {
                        $scope.vm.provinceList.push({ Name: item.name, Value: item.id });
                    });
                }
            }, function (error) {});
        }

        //获取城市
        $scope.$watch("vm.provinceid.Value", function (newValue, oldValue) {
            $scope.vm.cityList = [{ Name: '全部', Value: '' }];
            $scope.vm.cityid = $scope.vm.cityList[0];
            if (oldValue != newValue) {
                rt.queryData("Province.GetCity", { '@queryValue': '', '@provinceid': $scope.vm.provinceid.Value }, function (resp) {
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        _.map(data, function (item) {
                            $scope.vm.cityList.push({ Name: item.name, Value: item.Id });
                        });
                    }
                }, function (error) {});
            }
        });

        //切换tab
        $scope.vm.selectTab = function (tabName) {
            $scope.vm.selectedTabName = tabName;
            myService.controllerName = tabName;
            $scope.vm.view.search(1);
        };

        $scope.vm.handle = function () {
            $state.go("main.odptenantdatacleanhandle", { location: true });
        };
    }]).controller('tenantDataCleanHandleController', ['$injector', '$scope', '$state', 'tenantDataCleanService', function ($injector, $scope, $state, myService) {
        var rt = myService.rt;
        var $q = myService.$q;

        _init();

        function _init() {
            $scope.srcList = [{ Name: '全部' }];
            $scope.srcSelected = $scope.srcList[0];
            $scope.vm = {};

            myService.GetDataSource().then(function (resp) {
                if (resp.data != null && resp.data.length > 0) {
                    _.map(resp.data, function (item) {
                        $scope.srcList.push({ Name: item });
                    });
                }
            }).catch(function (err) {
                rt.errorMessage(err.data);
            });
        }

        //步骤1：合并爬虫和租户数据
        $scope.vm.collect = function () {
            var waiting = rt.showWaiting();
            $q.all([myService.CollectHospitalData($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name), myService.CollectDoctorData($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name)]).then(function (resp) {
                rt.successMessage('合并爬虫和租户的数据成功');
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤2：调用百度接口获取省市县信息
        $scope.vm.getProvinceCityCounty = function () {
            var waiting = rt.showLoading2();
            myService.GetProvinceCityCounty($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                rt.successMessage('调用百度接口获取省市县信息成功');
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤3：处理别名（省份）
        $scope.vm.handleProvince = function () {
            var waiting = rt.showWaiting();
            myService.HandleHospitalProvinceAliasName($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                if (!rt.isNullOrWhiteSpace(resp.data)) {
                    rt.errorMessage(resp.data);
                } else {
                    rt.successMessage('处理别名（省份）成功');
                }
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤4：处理别名（城市）
        $scope.vm.handleCity = function () {
            var waiting = rt.showWaiting();
            myService.HandleHospitalCityAliasName($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                if (!rt.isNullOrWhiteSpace(resp.data)) {
                    rt.errorMessage(resp.data);
                } else {
                    rt.successMessage('处理别名（城市）成功');
                }
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤5：处理别名（区县）
        $scope.vm.handleCounty = function () {
            var waiting = rt.showWaiting();
            myService.HandleHospitalCountyAliasName($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                if (!rt.isNullOrWhiteSpace(resp.data)) {
                    rt.errorMessage(resp.data);
                } else {
                    rt.successMessage('处理别名（区县）成功');
                }
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤6：处理别名（医院级别）
        $scope.vm.handleHospitalGrade1 = function () {
            var waiting = rt.showWaiting();
            myService.HandleHospitalGradeAliasName($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                rt.successMessage('处理别名（医院级别）成功');
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤7：处理别名（医院别名）
        $scope.vm.handleHospitalAliasName = function () {
            var waiting = rt.showWaiting();
            myService.HandleHospitalAliasName1($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                rt.successMessage('处理别名（医院别名）成功');
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤8：处理别名（科室类型）
        $scope.vm.handleDepartmentType1 = function () {
            var waiting = rt.showWaiting();
            myService.HandleDoctorDepartmentAliasName($scope.srcSelected.Name == '全部' ? '' : $scope.srcSelected.Name).then(function (resp) {
                if (!rt.isNullOrWhiteSpace(resp.data)) {
                    rt.errorMessage(resp.data);
                } else {
                    rt.successMessage('处理别名（科室类型）成功');
                }
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };

        //步骤9：合并重名
        $scope.vm.merge = function () {
            var waiting = rt.showWaiting();
            myService.MergeHospitalSameName().then(function (resp) {
                rt.successMessage('合并重名成功');
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        };

        $scope.vm.goBack = function () {
            $state.go("main.odptenantdataclean", { location: true });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-08-01
 说明     : 主数据-科室-租户 Service
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('tenantDepartmentService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'TenantDepartmentOdp';
    }]).controller('tenantDepartmentListController', ['$injector', '$timeout', '$scope', 'tenantDepartmentService', function ($injector, $timeout, $scope, myService) {
        var rt = myService.rt;
        var that = this;

        this.searchList = [];

        this.preSearch = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.srcSelected) && !rt.isNullOrWhiteSpace($scope.vm.srcSelected.Value)) {
                that.searchList.push({ Type: 1, Key: "odp_tenant_code", Value: $scope.vm.srcSelected.Value });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.hospitalName)) {
                that.searchList.push({ Type: 0, Key: "hospitalidName", Value: $scope.vm.hospitalName });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.departmentName)) {
                that.searchList.push({ Type: 0, Key: "name", Value: $scope.vm.departmentName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.srcList = [{ Name: '全部', Value: '' }];
        _getDataSrc();
        $scope.vm.srcSelected = $scope.vm.srcList[0];

        //获取数据来源
        function _getDataSrc() {
            rt.queryData("Tenant.GetAllDataSrc", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    _.map(data, function (item) {
                        $scope.vm.srcList.push({ Name: item.name, Value: item.value });
                    });
                }
            }, function (error) {});
        }

        $scope.overHeightTable = function () {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-08-01
 说明     : 主数据-医生-租户 Service
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('tenantDoctorService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'TenantDoctor';

        this.SyncData = function () {
            return rt.get("api/TenantDoctor/SyncTenantDoctor");
        };
    }]).controller('tenantDoctorListController', ['$injector', '$timeout', '$scope', 'tenantDoctorService', function ($injector, $timeout, $scope, myService) {
        var rt = myService.rt;
        var that = this;

        this.searchList = [];

        this.preSearch = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.srcSelected) && !rt.isNullOrWhiteSpace($scope.vm.srcSelected.Value)) {
                that.searchList.push({ Type: 1, Key: "odp_tenant_code", Value: $scope.vm.srcSelected.Value });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.hospitalName)) {
                that.searchList.push({ Type: 0, Key: "hospitalidName", Value: $scope.vm.hospitalName });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.departmentName)) {
                that.searchList.push({ Type: 0, Key: "departmentidName", Value: $scope.vm.departmentName });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.doctorName)) {
                that.searchList.push({ Type: 0, Key: "name", Value: $scope.vm.doctorName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.srcList = [{ Name: '全部', Value: '' }];
        _getDataSrc();
        $scope.vm.srcSelected = $scope.vm.srcList[0];

        //获取数据来源
        function _getDataSrc() {
            rt.queryData("Tenant.GetAllDataSrc", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    _.map(data, function (item) {
                        $scope.vm.srcList.push({ Name: item.name, Value: item.value });
                    });
                }
            }, function (error) {});
        }

        $scope.overHeightTable = function () {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        };

        $scope.vm.syncData = function () {
            var waiting = rt.showWaiting();
            myService.SyncData().then(function (resp) {
                rt.successMessage('数据同步成功');
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-09-12
 说明     : 主数据-门店-租户 Service
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('tenantDrugStoreService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'TenantDrugStoreOdp';

        this.SyncData = function () {
            return rt.get("api/TenantDrugStoreOdp/SyncTenantDrugStore");
        };
    }]).controller('tenantDrugStoreListController', ['$injector', '$timeout', '$scope', 'tenantDrugStoreService', function ($injector, $timeout, $scope, myService) {
        var rt = myService.rt;
        var that = this;

        this.searchList = [];

        this.preSearch = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.srcSelected) && !rt.isNullOrWhiteSpace($scope.vm.srcSelected.Value)) {
                that.searchList.push({ Type: 1, Key: "odp_tenant_code", Value: $scope.vm.srcSelected.Value });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.drugStoreName)) {
                that.searchList.push({ Type: 0, Key: "drugstoreidName", Value: $scope.vm.drugStoreName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.srcList = [{ Name: '全部', Value: '' }];
        _getDataSrc();
        $scope.vm.srcSelected = $scope.vm.srcList[0];

        //获取数据来源
        function _getDataSrc() {
            rt.queryData("Tenant.GetAllDataSrc", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    _.map(data, function (item) {
                        $scope.vm.srcList.push({ Name: item.name, Value: item.value });
                    });
                }
            }, function (error) {});
        }

        $scope.overHeightTable = function () {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        };

        $scope.vm.syncData = function () {
            var waiting = rt.showWaiting();
            myService.SyncData().then(function (resp) {
                rt.successMessage('数据同步成功');
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-07-31
 说明     : 主数据-医院-租户 Service
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('tenantHospitalService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'TenantHospital';

        this.SyncData = function () {
            return rt.get("api/TenantHospital/SyncTenantHospital");
        };
    }]).controller('tenantHospitalListController', ['$injector', '$timeout', '$scope', 'tenantHospitalService', function ($injector, $timeout, $scope, myService) {
        var rt = myService.rt;
        var that = this;

        this.searchList = [];

        this.preSearch = function () {
            that.searchList.length = 0;
            if (!rt.isNull($scope.vm.srcSelected) && !rt.isNullOrWhiteSpace($scope.vm.srcSelected.Value)) {
                that.searchList.push({ Type: 1, Key: "odp_tenant_code", Value: $scope.vm.srcSelected.Value });
            }

            if (!rt.isNullOrWhiteSpace($scope.vm.hospitalName)) {
                that.searchList.push({ Type: 0, Key: "name", Value: $scope.vm.hospitalName });
            }
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.srcList = [{ Name: '全部', Value: '' }];
        _getDataSrc();
        $scope.vm.srcSelected = $scope.vm.srcList[0];

        //获取数据来源
        function _getDataSrc() {
            rt.queryData("Tenant.GetAllDataSrc", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    _.map(data, function (item) {
                        $scope.vm.srcList.push({ Name: item.name, Value: item.value });
                    });
                }
            }, function (error) {});
        }

        $scope.overHeightTable = function () {
            if ($scope.vm.view.isShowSearchList) {
                $timeout(function () {
                    $scope.vm.view.autoHeight = $scope.vm.view.autoHeight - $(".form-horizontal").parent().outerHeight();
                }, 0);
            } else {
                $scope.vm.view.autoHeight = $scope.vm.view.autoHeight + $(".form-horizontal").parent().outerHeight();
            }
        };

        $scope.vm.syncData = function () {
            var waiting = rt.showWaiting();
            myService.SyncData().then(function (resp) {
                rt.successMessage('数据同步成功');
            }).catch(function (err) {
                rt.errorMessage(err.data);
            }).finally(function () {
                waiting.close();
            });
        };
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2016-10-13
 说明     : 瑞云客户资料
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('csmCustomerService', ['entityService', function (entityService) {
        angular.extend(this, entityService);
        var rt = entityService.rt;
        // @@设置WebAPI的控制器名称
        this.controllerName = 'csmcustomer';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller('csmCustomerListController', ['$injector', '$compile', '$scope', 'csmCustomerService', function ($injector, $compile, $scope, myService) {
        var rt = myService.rt;
        var that = this;
        this.searchList = [];
        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });
    }]).controller('csmCustomerEditController', ['$http', '$injector', '$scope', 'csmCustomerService', function ($http, $injector, $scope, myService) {
        var rt = myService.rt;
        $scope.isVerifyAddress = false;
        $scope.isVerifyLogin = false;

        $injector.invoke(entityEditController, this, {
            $scope: $scope,
            myService: myService
        });

        //保存前
        $scope.vm.form.preSave = function () {
            if (!$scope.isVerifyAddress || !$scope.isVerifyLogin) {
                rt.errorMessage("请先验证，再保存！");
                return "请先验证，再保存！";
            }

            if (!rt.isNullOrEmptyString($scope.vm.form.data.contactMail)) {
                var filter = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
                var contactMail = $scope.vm.form.data.contactMail.split(',');

                for (var i = 0; i < contactMail.length; i++) {
                    if (!filter.test(contactMail[i])) {
                        rt.errorMessage("邮箱格式错误");
                        return "邮箱格式错误";
                    }
                }
            } else {
                $scope.vm.form.data.contactMail = "";
            }
        };

        $scope.vm.form.verifyAddress = _verifyAddress;
        $scope.vm.form.verifyLogin = _verifyLogin;

        //验证客户环境是否正确
        function _verifyAddress() {
            if (rt.isNullOrEmptyString($scope.vm.form.data.service_address)) {
                return;
            }
            var s = $scope.vm.form.data.service_address + "/api/App/connect";
            $http.get(s).success(function (u) {
                rt.successMessage("正确");
                $scope.isVerifyAddress = true;
            }).error(function (msg) {
                rt.errorMessage("客户环境地址错误！");
                return false;
            });
        }

        /**
         * 账号登陆验证
         * @private
         */
        function _verifyLogin() {
            if (rt.isNullOrEmptyString($scope.vm.form.data.service_usercode) || rt.isNullOrEmptyString($scope.vm.form.data.service_password)) {
                return;
            }
            if ($scope.isVerifyAddress) {
                var s = $scope.vm.form.data.service_address + "/api/Authentication/login";
                $http.post(s, {
                    uid: $scope.vm.form.data.service_usercode,
                    pwd: $scope.vm.form.data.service_password
                }).success(function (u) {
                    rt.successMessage("正确");
                    $scope.isVerifyLogin = true;
                }).error(function (msg) {
                    if (msg == null) {
                        rt.errorMessage("客户环境地址错误！");
                    } else {
                        rt.errorMessage(msg);
                    }
                    return false;
                });
            } else {
                rt.errorMessage("先验证环境地址！");
            }
        }
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2018-01-25
 说明     : 仪表板-客户新增情况
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller("accountaddconditionController", ['$scope', 'rt', accountaddconditionController]);
    function accountaddconditionController($scope, rt) {

        init();

        function init() {

            //   $scope.vm.lastmonth = moment().add(-1, 'months').format('YYYY-MM');
            $scope.vm.accountaddpiereportData = [];
            $scope.vm.echartsPieData = [];
            $scope.vm.echartsMonth = [];
            $scope.vm.echartshosdata = []; //等级医院默认值
            $scope.vm.echartsbasdata = []; //基层医疗默认值
            $scope.vm.echartsterdata = []; //基层医疗默认值
            rt.get("api/VisitRecord/GetDbDateTime").then(function (d) {
                $scope.vm.lastmonth = moment(d.data, 'YYYY-MM').add(-1, 'months').toDate();
                //客户总体情况
                _showReport();
            });

            //配置项高度，位置
            $scope.$emit('get-parentheight', [$("#accountaddcondition").outerHeight(), $($("#accountaddcondition").parents()[1]).attr("id")]);
        }

        //获取echarts默认月份数据
        function _getechartsMonth() {
            $scope.vm.eMonth = moment($scope.vm.lastmonth).format('M');
            for (var i = 1; i <= $scope.vm.eMonth; i++) {
                $scope.vm.echartsMonth.push(i + '月');
                $scope.vm.echartshosdata.push(0);
                $scope.vm.echartsbasdata.push(0);
                $scope.vm.echartsterdata.push(0);
            }
        }

        function _showReport() {

            _getechartsMonth();

            //客户增加饼图
            _getAccountAddPieReport().then(_showAccountAddPieReport, function (message) {
                rt.errorMessage(message);
            });

            //客户增加折线图
            _getAccountAddLineReport().then(_showAccountAddLineReport, function (message) {
                rt.errorMessage(message);
            });
        }

        //获取客户新增（饼图）数据
        function _getAccountAddPieReport() {
            var url = 'api/Dashboard/GetDevelopedAccountPieData?Ym=';
            return rt.get(url).then(function (resp) {
                var getData = resp.data;
                for (var i = 0; i < getData.length; i++) {
                    $scope.vm.accountaddpiereportData.push(getData[i].toenttypename);
                    $scope.vm.echartsPieData.push({ name: getData[i].toenttypename, value: getData[i].accountcount });
                }
            });
        }

        //获取客户新增（折线图）数据
        function _getAccountAddLineReport() {
            var url = 'api/Dashboard/GetDevelopedAccountLineData?Ym=';
            return rt.get(url).then(function (resp) {
                var lineData = resp.data[0];
                if (lineData) {
                    $scope.vm.echartshosdevdata = lineData.Hos_Line_Data; //等级医院新增趋势
                    $scope.vm.echartsbasdevdata = lineData.Bas_Line_Data; //基层医疗新增额趋势
                    $scope.vm.echartsterdevdata = lineData.Ter_Line_Data; //零售门店新增趋势
                }
            });
        }

        //客户新增（饼图）
        function _showAccountAddPieReport() {
            var myChart = echarts.init(document.getElementById("accountaddpiereport"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];

            var option = {
                tooltip: {
                    trigger: 'item',
                    formatter: "{a} <br/>{b} : {c} ({d}%)"
                },
                legend: {
                    orient: 'vertical',
                    left: '60%',
                    top: '20%',
                    data: $scope.vm.accountaddpiereportData,
                    itemWidth: 10,
                    itemHeight: 10,
                    textStyle: { //图例文字的样式
                        color: '#fff'
                    }
                },
                series: [{
                    name: '客户新增',
                    type: 'pie',
                    radius: '60px',
                    center: ['25%', '50%'],
                    data: $scope.vm.echartsPieData,
                    itemStyle: {
                        normal: {
                            label: {
                                show: false
                            },
                            labelLine: {
                                show: false
                            }
                        }
                    }
                }],
                color: ['#ffeb76', '#1acbd1', '#fea772', '#e75e6e']
            };

            myChart.clear();
            myChart.setOption(option);
        }

        function _showAccountAddLineReport() {
            var myChart = echarts.init(document.getElementById("accountaddlinereport"));
            angular.element(window).on('resize', myChart.resize);
            var option = {
                title: {
                    text: '客户增加折线图',
                    textStyle: { //标题颜色  
                        color: '#1acbd1',
                        fontSize: '12px'
                    },
                    x: "center",
                    y: 5
                },
                legend: {
                    data: ['等级医院', '基层医疗', '零售门店'],
                    bottom: '0px',
                    textStyle: {
                        color: '#fff' // 图例文字颜色
                    }
                },
                tooltip: {
                    trigger: 'axis'
                },
                grid: {
                    y: 35,
                    y2: 45,
                    x: 30,
                    x2: 15
                },
                xAxis: {
                    type: 'category',
                    boundaryGap: false,
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        textStyle: {
                            color: "#fff",
                            fontSize: 12
                        }
                    },
                    data: $scope.vm.echartsMonth
                },
                yAxis: {
                    type: 'value',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        formatter: '{value}',
                        textStyle: {
                            color: "#fff", //坐标轴刻度文字的颜色
                            fontSize: 12
                        }
                    },
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: 'rgba(26, 203, 209, 0.1)'
                        }
                    }
                },

                series: [{
                    name: '等级医院',
                    type: 'line',
                    data: $scope.vm.echartshosdevdata,
                    areaStyle: { normal: {} },
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: 'rgba(26, 203, 209, 0.8)' }, { offset: 1, color: 'rgba(26, 203, 209, 0)' }])
                        }
                    }
                }, {
                    name: '基层医疗',
                    type: 'line',
                    data: $scope.vm.echartsbasdevdata,
                    areaStyle: { normal: {} },
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: 'rgba(254,167,114,0.8)' }, { offset: 1, color: 'rgba(254,167,114, 0)' }])
                        }
                    }

                }, {
                    name: '零售门店',
                    type: 'line',
                    // stack: '总量',
                    data: $scope.vm.echartsterdevdata,
                    areaStyle: { normal: {} },
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: 'rgba(255,235,118,0.8)' }, { offset: 1, color: 'rgba(255,235,118, 0)' }])
                        }
                    }

                }],
                color: ['#ffeb76', '#1acbd1', '#fea772', '#e75e6e']
            };
            myChart.clear();
            myChart.setOption(option);
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2018-01-25
 说明     : 仪表板-客户总体情况
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller("accountgeneralconditionController", ['$scope', 'rt', accountgeneralconditionController]);
    function accountgeneralconditionController($scope, rt) {
        init();

        function init() {
            $scope.vm.reportClientCount = {};
            $scope.vm.lastmonth = moment().add(-1, 'months').format('YYYY-MM');
            //客户总体情况
            _getClientData();
            //配置项高度，位置
            $scope.$emit('get-parentheight', [$("#accountgeneralcondition").outerHeight(), $($("#accountgeneralcondition").parents()[1]).attr("id")]);
        }

        //按企业类型 （矩形区域显示数据）
        function _getClientData() {
            $scope.vm.reportClientCount.BizCount = '正在计算中...';
            $scope.vm.reportClientCount.BizCapacity = '正在计算中...';
            $scope.vm.reportClientCount.HosCapacity = '正在计算中...';
            $scope.vm.reportClientCount.HosCount = '正在计算中...';
            $scope.vm.reportClientCount.OtcCapacity = '正在计算中...';
            $scope.vm.reportClientCount.OtcCount = '正在计算中...';
            $scope.vm.reportClientCount.ThrCapacity = '正在计算中...';
            $scope.vm.reportClientCount.ThrCount = '正在计算中...';
            var url = 'api/AlijkDashboard/GetClientsCount?Ym=';
            return rt.get(url).then(function (resp) {
                $scope.vm.reportClientCount = resp.data;
            }, function () {});
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2018-01-30
 说明     : 仪表板-客户流失情况
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller("accountlossconditionController", ['$scope', 'rt', accountlossconditionController]);
    function accountlossconditionController($scope, rt) {
        init();

        function init() {
            $scope.vm.lastmonth = moment().add(-1, 'months').format('YYYY-MM');
            $scope.vm.lossaccountnameData = [];
            $scope.vm.hoslossaccountData = [];
            $scope.vm.baslossaccountData = [];
            $scope.vm.terlossaccountData = [];

            _showReport();
            //配置项高度，位置
            $scope.$emit('get-parentheight', [$("#accountlosscondition").outerHeight(), $($("#accountlosscondition").parents()[1]).attr("id")]);
        }

        function _showReport() {

            //客户流失饼图
            _getLossAccountPieReport().then(_showAccountLossPieReport, function (message) {
                rt.errorMessage(message);
            });

            //各地域客户流失情况
            _getLossAccountBarReport().then(_showAccountLossBarReport, function (message) {
                rt.errorMessage(message);
            });
        }

        //获取客户流失（饼图）数据
        function _getLossAccountPieReport() {
            var url = 'api/Dashboard/GetLossAccountPieData?Ym=';
            return rt.get(url).then(function (resp) {
                if (resp.data != null && resp.data.length > 0) {
                    $scope.vm.totalcount = resp.data[0].totalcount;
                    $scope.vm.losscount = resp.data[0].losscount;
                    $scope.vm.lossdata = Math.round($scope.vm.losscount * 100 / $scope.vm.totalcount);
                } else {
                    $scope.vm.totalcount = 0;
                    $scope.vm.losscount = 0;
                    $scope.vm.lossdata = 0;
                }
            });
        }

        //获取各地域客户流失情况数据
        function _getLossAccountBarReport() {
            var url = 'api/Dashboard/GetLossAccountBarData?Ym=';
            return rt.get(url).then(function (resp) {
                var getData = resp.data;
                for (var i = 0; i < getData.length; i++) {
                    $scope.vm.lossaccountnameData.push(getData[i].toprovinceidname);
                    $scope.vm.hoslossaccountData.push(getData[i].hoslossCount);
                    $scope.vm.baslossaccountData.push(getData[i].baslossCount);
                    $scope.vm.terlossaccountData.push(getData[i].terlossCount);
                }
            });
        }

        function _showAccountLossPieReport() {
            //显示客户流失占比饼图
            var myChart = echarts.init(document.getElementById("accountlosspiereport"));
            angular.element(window).on('resize', myChart.resize);

            var option = {
                tooltip: {
                    show: true,
                    trigger: 'item',
                    formatter: function formatter(params, ticket, callback) {
                        var num = $scope.vm.lossdata + '%';
                        var str = '<div style="position: absolute; margin-left: -40px;width:72px" id="toolTipBox"><img style="position: absolute;left: -4px;top: -25px;" src="main/img/percentpie.png"><p style="font-size: 10px;margin: 0px;color: #fff;text-align: center;">流失客户占比</p><p style="font-size:18px;margin:0px;color:#e75e6e;font-weight:bold;text-align: center;">' + num + '</p></div>';
                        return str;
                    },
                    alwaysShowContent: true,
                    position: function position(point, params, dom, rect, size) {
                        //console.log(dom)可以看到，提示框是用position定位
                        var marginW = Math.ceil(size.contentSize[0] / 2);
                        var marginH = Math.ceil(size.contentSize[1] / 2);
                        return ['85px', '55px'];
                    },
                    backgroundColor: 'transparent',
                    textStyle: {
                        color: '#fff'
                    }
                },

                series: [{
                    type: 'pie',
                    radius: ['45px', '60px'],
                    center: ['85px', '75px'],
                    avoidLabelOverlap: false,
                    silent: true,
                    label: {
                        normal: {
                            show: false
                        }
                    },
                    data: [{
                        value: $scope.vm.lossdata,
                        name: '流失客户',
                        itemStyle: {
                            normal: {
                                color: '#1acbd1'
                            }
                        }
                    }, {
                        value: 100 - $scope.vm.lossdata,
                        name: '总客户',
                        itemStyle: {
                            normal: {
                                color: 'rgba(26, 203, 209, 0.3)',
                                label: {
                                    show: false
                                }
                            }
                        }
                    }]
                }]
            };
            myChart.clear();
            myChart.setOption(option);
            // 显示 tooltip
            myChart.dispatchAction({
                type: 'showTip',
                seriesIndex: 0,
                dataIndex: 0
            });
        }

        function _showAccountLossBarReport() {
            var myChart = echarts.init(document.getElementById("accountlossbarreport"));
            angular.element(window).on('resize', myChart.resize);
            var option = {
                title: {
                    text: '各地域客户流失情况',
                    textStyle: { //标题颜色  
                        color: '#1acbd1',
                        fontSize: '12px'
                    },
                    x: "center",
                    y: 5
                },
                tooltip: {
                    trigger: 'axis',
                    axisPointer: { // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    }
                },
                grid: {
                    y: 35,
                    y2: 45,
                    x: 50,
                    x2: 15
                },
                legend: {
                    data: ['等级医院', '基层医疗', '零售门店'],
                    x: 'center',
                    y: 'bottom',
                    itemWidth: 10,
                    itemHeight: 10,
                    textStyle: { //图例文字的样式
                        color: '#fff'
                    }
                },
                xAxis: {
                    type: 'value',
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: 'rgba(26, 203, 209, 0.1)'
                        }
                    },
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        formatter: '{value}',
                        textStyle: {
                            color: "#fff", //坐标轴刻度文字的颜色
                            fontSize: 12
                        }
                    }
                },
                yAxis: {
                    type: 'category',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        formatter: '{value}',
                        textStyle: {
                            color: "#fff", //坐标轴刻度文字的颜色
                            fontSize: 12
                        }
                    },
                    data: $scope.vm.lossaccountnameData
                },
                series: [{
                    name: '等级医院',
                    type: 'bar',
                    stack: '总量',
                    data: $scope.vm.hoslossaccountData
                }, {
                    name: '基层医疗',
                    type: 'bar',
                    stack: '总量',
                    data: $scope.vm.baslossaccountData
                }, {
                    name: '零售门店',
                    type: 'bar',
                    stack: '总量',
                    data: $scope.vm.terlossaccountData
                }],
                color: ['#ffeb76', '#1acbd1', '#fea772', '#e75e6e']
            };
            myChart.clear();
            myChart.setOption(option);
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2018-01-31
 说明     : 仪表板-市场活动分析
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller("campaignanalysisController", ['$scope', 'rt', campaignanalysisController]);
    function campaignanalysisController($scope, rt) {
        init();

        function init() {
            $scope.vm.lastmonth = moment().add(-1, 'months').format('YYYY-MM');
            $scope.vm.campaigntypenameData = [];
            $scope.vm.campaigncountData = [];
            $scope.vm.actionanysisnameData = [];
            $scope.vm.actionanysisData = [];
            _showReport();
            //配置项高度，位置
            $scope.$emit('get-parentheight', [$("#campaignanalysis").outerHeight(), $($("#campaignanalysis").parents()[1]).attr("id")]);
        }

        function _showReport() {

            //市场活动分析（饼图）
            _getActionAnysisPieReport().then(_showActionAnysisPieReport, function (message) {
                rt.errorMessage(message);
            });

            //市场活动地域排名（柱状图）
            _getActionAnysisBarReport().then(_showaAtionRankBarReport, function (message) {
                rt.errorMessage(message);
            });
        }

        //获取市场活动分析（饼图）数据
        function _getActionAnysisPieReport() {
            var url = 'api/Dashboard/GetActionAnysisPieData?Ym=';
            return rt.get(url).then(function (resp) {
                var getData = resp.data;
                for (var i = 0; i < getData.length; i++) {
                    $scope.vm.campaigntypenameData.push(getData[i].campaign_typename);
                    $scope.vm.campaigncountData.push({ name: getData[i].campaign_typename, value: getData[i].campaigncount });
                }
            });
        }

        //获取市场活动地域排名数据
        function _getActionAnysisBarReport() {
            var url = 'api/Dashboard/GetActionAnysisBarData?Ym=';
            return rt.get(url).then(function (resp) {
                var getData = resp.data;
                for (var i = 0; i < getData.length; i++) {
                    $scope.vm.actionanysisnameData.push(getData[i].businessunitidname);
                    $scope.vm.actionanysisData.push(getData[i].campaigncount);
                }
            });
        }

        function _showActionAnysisPieReport() {
            var myChart = echarts.init(document.getElementById("actionanysispiereport"), "shine");
            angular.element(window).on('resize', myChart.resize);

            var option = {
                tooltip: {
                    trigger: 'item',
                    formatter: "{a} <br/>{b} : {c} ({d}%)"
                },
                legend: {
                    type: 'scroll',
                    orient: 'vertical',
                    left: '60%',
                    top: '20%',
                    data: $scope.vm.campaigntypenameData,
                    itemWidth: 10,
                    itemHeight: 10,
                    pageTextStyle: {
                        color: '#fff'
                    },
                    pageIconSize: 10,
                    pageIconColor: 'rgba(26, 203, 209, 1)',
                    pageIconInactiveColor: 'rgba(26, 203, 209, 0.3)',
                    textStyle: { //图例文字的样式
                        color: '#fff'
                    }
                },
                series: [{
                    name: '市场活动',
                    type: 'pie',
                    radius: '60px',
                    center: ['25%', '50%'],
                    data: $scope.vm.campaigncountData,
                    itemStyle: {
                        normal: {
                            label: {
                                show: false
                            },
                            labelLine: {
                                show: false
                            }
                        }
                    }
                }],
                color: ['#ffeb76', '#1acbd1', '#fea772', '#e75e6e', "#4bd192"]
            };

            myChart.clear();
            myChart.setOption(option);
        }
        function _showaAtionRankBarReport() {
            var myChart = echarts.init(document.getElementById("actionrankbarreport"));
            angular.element(window).on('resize', myChart.resize);
            var option = {
                title: {
                    text: '市场活动地域排名',
                    textStyle: { //标题颜色  
                        color: '#1acbd1',
                        fontSize: '12px'
                    },
                    x: "center",
                    y: 10
                },
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'shadow'
                    }
                },
                grid: {
                    x: 40,
                    x2: 10,
                    y: 40,
                    y2: 50
                },
                xAxis: [{
                    type: 'category',
                    data: $scope.vm.actionanysisnameData,
                    axisLabel: {
                        textStyle: {
                            color: '#fff'
                        }
                    },
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    }
                }],
                yAxis: [{
                    type: 'value',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: 'rgba(26, 203, 209, 0.1)'
                        }
                    }

                }],
                series: [{
                    name: '市场活动',
                    type: 'bar',
                    barWidth: '20px',
                    data: $scope.vm.actionanysisData,
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: '#fea772' }, { offset: 1, color: '#1acbd1' }])
                        }
                    }
                }]
            };

            myChart.clear();
            myChart.setOption(option);
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2018-01-30
 说明     : 仪表板-达成额排名
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller("doneamountrankController", ['$scope', 'rt', doneamountrankController]);
    function doneamountrankController($scope, rt) {
        init();

        function init() {
            $scope.vm.lastmonth = moment().add(-1, 'months').format('YYYY-MM');
            $scope.vm.doneamountnameData = [];
            $scope.vm.doneamountData = [];
            _showReport();
            //配置项高度，位置
            $scope.$emit('get-parentheight', [$("#doneamountrank").outerHeight(), $($("#doneamountrank").parents()[1]).attr("id")]);
        }

        function _showReport() {

            //达成额排名（柱状图）
            _getDoneAmountBarReport().then(_showDoneAmontBarReport, function (message) {
                rt.errorMessage(message);
            });
        }

        //获取达成额排名数据
        function _getDoneAmountBarReport() {
            var url = 'api/Dashboard/GetDoneAmountBarData?Ym=';
            return rt.get(url).then(function (resp) {
                var getData = resp.data;
                for (var i = 0; i < getData.length; i++) {
                    $scope.vm.doneamountnameData.push(getData[i].businessunitidname);
                    $scope.vm.doneamountData.push((getData[i].salecount * 1.0 / 10000).toFixed(2));
                }
            });
        }

        function _showDoneAmontBarReport() {
            var myChart = echarts.init(document.getElementById("salesdonebarreport"));
            angular.element(window).on('resize', myChart.resize);
            var dataAxis = $scope.vm.doneamountnameData;
            var data = $scope.vm.doneamountData;

            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: "{b} <br/> 达成额：{c}万",
                    axisPointer: {
                        type: 'shadow'
                    }

                },
                grid: {
                    x: 40,
                    x2: 10,
                    y: 30,
                    y2: 30
                },
                xAxis: [{
                    type: 'category',
                    data: dataAxis,
                    axisLabel: {
                        textStyle: {
                            color: '#fff'
                        }
                    },
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    }
                }],
                yAxis: [{
                    type: 'value',
                    name: '达成额(万元)',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: 'rgba(26, 203, 209, 0.1)'
                        }
                    }

                }],
                series: [{
                    name: '达成额',
                    type: 'bar',
                    barWidth: '20px',
                    data: data,
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: '#fea772' }, { offset: 1, color: '#1acbd1' }])
                        }
                    }
                }]
            };

            myChart.clear();
            myChart.setOption(option);
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2018-01-30
 说明     : 仪表板-达成额趋势
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller("doneamounttrendController", ['$scope', 'rt', doneamounttrendController]);
    function doneamounttrendController($scope, rt) {
        init();

        function init() {
            rt.get("api/VisitRecord/GetDbDateTime").then(function (d) {
                $scope.vm.lastmonth = moment(d.data, 'YYYY-MM').add(-1, 'months').toDate();
                _showReport();
            });

            //配置项高度，位置
            $scope.$emit('get-parentheight', [$("#doneamounttrend").outerHeight(), $($("#doneamounttrend").parents()[1]).attr("id")]);
        }

        function _showReport() {

            //达成额趋势（折线图）
            _getDoneAmountLineReport().then(_showSalesDoneLineReport, function (message) {
                rt.errorMessage(message);
            });
        }

        //获取达成额趋势数据
        function _getDoneAmountLineReport() {
            var url = 'api/Dashboard/GetDoneAmountLineData?Ym=';
            return rt.get(url).then(function (resp) {
                var lineData = resp.data[0];
                if (lineData) {
                    $scope.vm.echartshosdonedata = _.map(lineData.HosDoneAmount_Line_Data, function (e) {
                        return (e / 10000).toFixed(2);
                    }); //等级医院达成额趋势
                    $scope.vm.echartsbasdonedata = _.map(lineData.BasDoneAmount_Line_Data, function (e) {
                        return (e / 10000).toFixed(2);
                    }); //基层医疗达成额趋势
                    $scope.vm.echartsterdonedata = _.map(lineData.TerDoneAmount_Line_Data, function (e) {
                        return (e / 10000).toFixed(2);
                    }); //零售门店达成额趋势
                }
            });
        }

        function _showSalesDoneLineReport() {
            var myChart = echarts.init(document.getElementById("salesdonelinereport"));
            angular.element(window).on('resize', myChart.resize);
            var option = {
                legend: {
                    data: ['等级医院', '基层医疗', '零售门店'],
                    bottom: '0px',
                    textStyle: {
                        color: '#fff' // 图例文字颜色
                    }
                },
                tooltip: {
                    trigger: 'axis'
                    // formatter: "{b}月：<br/> 等级医院达成额：{c0}万 <br/>基层医疗达成额：{c1}万<br/>零售门店达成额：{c2}万"
                },
                grid: {
                    x: 40,
                    x2: 10,
                    y: 30,
                    y2: 50
                },
                xAxis: {
                    type: 'category',
                    boundaryGap: false,
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        textStyle: {
                            color: "#fff",
                            fontSize: 12
                        }
                    },
                    name: '月',
                    data: $scope.vm.echartsMonth
                },
                yAxis: {
                    type: 'value',
                    name: '达成额(万元)',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        formatter: '{value}',
                        textStyle: {
                            color: "#fff", //坐标轴刻度文字的颜色
                            fontSize: 12
                        }
                    },
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: 'rgba(26, 203, 209, 0.1)'
                        }
                    }
                },

                series: [{
                    name: '等级医院',
                    type: 'line',
                    //stack: '总量',
                    data: $scope.vm.echartshosdonedata,
                    areaStyle: { normal: {} },
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: 'rgba(26, 203, 209, 0.8)' }, { offset: 1, color: 'rgba(26, 203, 209, 0)' }])
                        }
                    }
                }, {
                    name: '基层医疗',
                    type: 'line',
                    //stack: '总量',
                    data: $scope.vm.echartsbasdonedata,
                    areaStyle: { normal: {} },
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: 'rgba(254,167,114,0.8)' }, { offset: 1, color: 'rgba(254,167,114, 0)' }])
                        }
                    }

                }, {
                    name: '零售门店',
                    type: 'line',
                    // stack: '总量',
                    data: $scope.vm.echartsterdonedata,
                    areaStyle: { normal: {} },
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: 'rgba(255,235,118,0.8)' }, { offset: 1, color: 'rgba(255,235,118, 0)' }])
                        }
                    }

                }],
                color: ['#ffeb76', '#1acbd1', '#fea772', '#e75e6e']
            };
            myChart.clear();
            myChart.setOption(option);
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2018-01-30
 说明     : 仪表板-全国销售达成分布
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller("nationalsalesdoneconditionController", ['$scope', 'rt', nationalsalesdoneconditionController]);
    function nationalsalesdoneconditionController($scope, rt) {
        init();

        function init() {
            $scope.vm.lastmonth = moment().add(-1, 'months').format('YYYY-MM');

            _showReport();
            //配置项高度，位置
            $scope.$emit('get-parentheight', [$("#nationalsalesdonecondition").outerHeight(), $($("#nationalsalesdonecondition").parents()[1]).attr("id")]);
        }

        function _showReport() {

            //全国销售达成分布（纯销）
            _getReportData2().then(_show7, function (message) {
                rt.errorMessage(message);
            });
        }

        //按省份纯销排名 (地图）
        function _getReportData2() {
            var url = 'api/Dashboard/GetEntTermiSaleByProvMapData?Ym=';
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData2 = resp.data;
            });
        }

        //按省份纯销排名 展示数据
        function _show7() {

            var myChart = echarts.init(document.getElementById("salesdonemapreport"), "shine");
            var rptData2 = $scope.vm.reportData2.ChartData;
            var tabData2 = _.map(rptData2, function (o) {
                return { name: o.Name, value: o.Value };
            });
            var maxValue = _.max(_.map(tabData2, function (o) {
                return o.value;
            }));

            $.get('lib/echarts/map/json/china.json', function (chinaJson) {
                echarts.registerMap('china', chinaJson);
                var option = {
                    tooltip: {
                        trigger: 'item'
                    },
                    visualMap: {
                        min: 0,
                        max: maxValue,
                        left: 'left',
                        top: 'bottom',
                        itemWidth: 10,
                        itemHeight: 70,
                        text: ['高', '低'],
                        inRange: {
                            color: ['#ebceba', '#ff1832']
                        },
                        textStyle: {
                            color: '#ffffff'
                        },
                        calculable: true
                    },
                    series: [{
                        name: '按省纯销量',
                        type: 'map',
                        mapType: 'china',
                        selectedMode: 'single',
                        roam: false,
                        zoom: 1.2,
                        itemStyle: {
                            //正常时的样式  
                            normal: {
                                label: {
                                    show: true,
                                    color: "#640000",
                                    textStyle: {
                                        fontSize: 8
                                    }
                                }
                            },
                            //鼠标经过时的样式  
                            emphasis: {
                                label: {
                                    show: true,
                                    color: '#ffffff',
                                    textStyle: {
                                        fontSize: 12
                                    }
                                }
                            }
                        },
                        data: tabData2
                    }]
                };
                myChart.clear();
                myChart.setOption(option);
            });
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2018-01-30
 说明     : 仪表板-销售指标情况
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller("salestargeconditionController", ['$scope', 'rt', salestargeconditionController]);
    function salestargeconditionController($scope, rt) {
        init();

        function init() {
            $scope.vm.lastmonth = moment().add(-1, 'months').format('YYYY-MM');

            _showReport();
            //配置项高度，位置
            $scope.$emit('get-parentheight', [$("#salestargecondition").outerHeight(), $($("#salestargecondition").parents()[1]).attr("id")]);
        }

        function _showReport() {

            //销售指标总额/总量情况（饼图）
            _getPureVenditionPieReport().then(_showSalesAmountPieReport, function (message) {
                rt.errorMessage(message);
            }).then(_showSalesQtyPieReport, function (message) {
                rt.errorMessage(message);
            });
        }

        //获取销售指标总额/总量（饼图）数据
        function _getPureVenditionPieReport() {
            var url = 'api/Dashboard/GetPureVenditionPieData?Ym=';
            return rt.get(url).then(function (resp) {
                if (resp.data != null && resp.data.length > 0) {
                    $scope.vm.done_amount = (resp.data[0].done_amount * 1.0 / 10000).toFixed(2);
                    $scope.vm.target_amount = resp.data[0].target_amount;
                    $scope.vm.done_qty = resp.data[0].done_qty;
                    $scope.vm.target_qty = resp.data[0].target_qty;
                    if ($scope.vm.target_amount == 0) {
                        $scope.vm.doneamountdata = 100;
                    } else {
                        $scope.vm.doneamountdata = Math.round($scope.vm.done_amount * 100 / $scope.vm.target_amount);
                    }
                    if ($scope.vm.target_qty == 0) {
                        $scope.vm.doneqtydata = 100;
                    } else {
                        $scope.vm.doneqtydata = Math.round($scope.vm.done_qty * 100 / $scope.vm.target_qty);
                    }
                } else {
                    scope.vm.done_amount = 0;
                    scope.vm.target_amount = 0;
                    $scope.vm.done_qty = 0;
                    $scope.vm.target_qty = 0;
                    $scope.vm.lossdata = 0;
                    $scope.vm.doneamountdata = 0;
                    $scope.vm.doneqtydata = 0;
                }
            });
        }

        function _showSalesAmountPieReport() {
            var myChart = echarts.init(document.getElementById("salesamountpiereport"));
            angular.element(window).on('resize', myChart.resize);
            var doneamountdata = $scope.vm.doneamountdata > 100 ? 100 : $scope.vm.doneamountdata;
            var option = {
                tooltip: {
                    show: true,
                    trigger: 'item',
                    formatter: function formatter(params, ticket, callback) {
                        var num = $scope.vm.doneamountdata + '%';
                        var str = '<div style="position: absolute; margin-left: -40px;width:72px" id="pietoolTipBox"><img style="position: absolute;left: -4px;top: -25px;" src="main/img/percentpie.png"><p style="font-size:10px;margin:0px;color:#fff;text-align:center">达成占比</p><p style="font-size:18px;margin:0px;color:#e75e6e;font-weight:bold;text-align:center">' + num + '</p></div>';
                        return str;
                    },
                    position: function position(point, params, dom, rect, size) {
                        //console.log(dom)可以看到，提示框是用position定位
                        var marginW = Math.ceil(size.contentSize[0] / 2);
                        var marginH = Math.ceil(size.contentSize[1] / 2);
                        dom.style.zIndex = "2";
                        return ['50%', '55px'];
                    },
                    alwaysShowContent: true,
                    backgroundColor: 'transparent',
                    textStyle: {
                        color: '#fff'
                    }
                },
                series: [{
                    type: 'pie',
                    radius: ['45px', '60px'],
                    center: ['50%', '75px'],
                    avoidLabelOverlap: false,
                    silent: true,
                    label: {
                        normal: {
                            show: false
                        }
                    },
                    data: [{
                        value: doneamountdata,
                        name: '达成额',
                        itemStyle: {
                            normal: {
                                color: '#1acbd1'
                            }
                        }
                    }, {
                        value: 100 - doneamountdata,
                        name: '指标额',
                        itemStyle: {
                            normal: {
                                color: 'rgba(26, 203, 209, 0.3)',
                                label: {
                                    show: false
                                }
                            }
                        }
                    }]
                }]
            };
            myChart.clear();
            myChart.setOption(option);
            // 显示 tooltip
            myChart.dispatchAction({
                type: 'showTip',
                seriesIndex: 0,
                dataIndex: 0
            });
        }

        function _showSalesQtyPieReport() {
            var myChart = echarts.init(document.getElementById("salesqtypiereport"));
            angular.element(window).on('resize', myChart.resize);
            var doneqtydata = $scope.vm.doneqtydata > 100 ? 100 : $scope.vm.doneqtydata;
            var option = {
                tooltip: {
                    show: true,
                    trigger: 'item',
                    formatter: function formatter(params, ticket, callback) {
                        var num = $scope.vm.doneqtydata + '%';
                        var str = '<div style="position: absolute; margin-left: -40px;width:72px" id="pietoolTipBox2"><img style="position: absolute;left: -4px;top: -25px;" src="main/img/percentpie.png"><p style="font-size:10px;margin:0px;color:#fff;text-align:center">达成占比</p><p style="font-size:18px;margin:0px;color:#e75e6e;font-weight:bold;text-align:center">' + num + '</p></div>';
                        return str;
                    },
                    position: function position(point, params, dom, rect, size) {
                        //console.log(dom)可以看到，提示框是用position定位
                        var marginW = Math.ceil(size.contentSize[0] / 2);
                        var marginH = Math.ceil(size.contentSize[1] / 2);
                        dom.style.zIndex = "2";
                        return ['50%', '55px'];
                    },
                    alwaysShowContent: true,
                    backgroundColor: 'transparent',
                    textStyle: {
                        color: '#fff'
                    }
                },
                series: [{
                    type: 'pie',
                    radius: ['45px', '60px'],
                    center: ['50%', '75px'],
                    avoidLabelOverlap: false,
                    silent: true,
                    label: {
                        normal: {
                            show: false
                        }
                    },
                    data: [{
                        value: doneqtydata,
                        name: '达成量',
                        itemStyle: {
                            normal: {
                                color: '#1acbd1'
                            }
                        }
                    }, {
                        value: 100 - doneqtydata,
                        name: '指标量',
                        itemStyle: {
                            normal: {
                                color: 'rgba(26, 203, 209, 0.3)',
                                label: {
                                    show: false
                                }
                            }
                        }
                    }]
                }]
            };
            myChart.clear();
            myChart.setOption(option);
            // 显示 tooltip
            myChart.dispatchAction({
                type: 'showTip',
                seriesIndex: 0,
                dataIndex: 0
            });
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2018-01-31
 说明     : 仪表板-拜访分析
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller("visitanalysisController", ['$scope', 'rt', visitanalysisController]);
    function visitanalysisController($scope, rt) {
        init();

        function init() {
            $scope.vm.lastmonth = moment().add(-1, 'months').format('YYYY-MM');
            $scope.vm.visitnameData = [];
            $scope.vm.visitData = [];
            _showReport();
            //配置项高度，位置
            $scope.$emit('get-parentheight', [$("#visitanalysis").outerHeight(), $($("#visitanalysis").parents()[1]).attr("id")]);
        }

        function _showReport() {

            //拜访分析（饼图）
            _getVisitPieReport().then(_showVisitPieReport, function (message) {
                rt.errorMessage(message);
            });

            //拜访次数各地域排名(柱状图)
            _getVisitBarReport().then(_showVisitQtyBarReport, function (message) {
                rt.errorMessage(message);
            });
        }

        //获取拜访分析（饼图）数据
        function _getVisitPieReport() {
            var url = 'api/Dashboard/GetVisitPieData?Ym=';
            return rt.get(url).then(function (resp) {
                if (resp.data != null && resp.data.length > 0) {
                    $scope.vm.account_count = resp.data[0].account_count;
                    $scope.vm.visit_done_count = resp.data[0].visit_done_count;
                    $scope.vm.visit_done_times = resp.data[0].visit_done_times;
                    $scope.vm.ownercount = resp.data[0].ownercount;
                    if ($scope.vm.account_count == 0) {
                        $scope.vm.donevisitdata = 100;
                    } else {
                        $scope.vm.donevisitdata = Math.round($scope.vm.visit_done_count * 100 / $scope.vm.account_count);
                    }
                    if ($scope.vm.ownercount == 0) {
                        $scope.vm.averagevisit = 100;
                    } else {
                        $scope.vm.averagevisit = Math.round($scope.vm.visit_done_times / $scope.vm.ownercount);
                    }
                } else {
                    scope.vm.account_count = 0;
                    scope.vm.visit_done_count = 0;
                    $scope.vm.donevisitdata = 0;
                }
            });
        }

        //获取拜访次数地域排名数据
        function _getVisitBarReport() {
            var url = 'api/Dashboard/GetVistitBarData?Ym=';
            return rt.get(url).then(function (resp) {
                var getData = resp.data;
                for (var i = 0; i < getData.length; i++) {
                    $scope.vm.visitnameData.push(getData[i].businessunitidname);
                    $scope.vm.visitData.push(getData[i].visit_done_times);
                }
            });
        }
        function _showVisitPieReport() {
            //显示拜访分析占比
            var myChart = echarts.init(document.getElementById("visitpiereport"));
            angular.element(window).on('resize', myChart.resize);
            var donevisitdata = $scope.vm.donevisitdata > 100 ? 100 : $scope.vm.donevisitdata;
            var option = {
                tooltip: {
                    show: true,
                    trigger: 'item',
                    formatter: function formatter(params, ticket, callback) {
                        var num = $scope.vm.donevisitdata + '%';
                        var str = '<div style="position: absolute; margin-left: -40px;width:72px" id="toolTipBox"><img style="position: absolute;left: -4px;top: -25px;" src="main/img/percentpie.png"><p style="font-size: 10px;margin: 0px;color: #fff;text-align: center;">覆盖客户占比</p><p style="font-size: 18px;margin: 0px;color: #e75e6e;font-weight: bold; text-align: center;">' + num + '</p></div>';
                        return str;
                    },
                    position: function position(point, params, dom, rect, size) {
                        //console.log(dom)可以看到，提示框是用position定位
                        var marginW = Math.ceil(size.contentSize[0] / 2);
                        var marginH = Math.ceil(size.contentSize[1] / 2);
                        return ['50%', '55px'];
                    },
                    alwaysShowContent: true,
                    backgroundColor: 'transparent',
                    textStyle: {
                        color: '#fff'
                    }
                },
                series: [{
                    type: 'pie',
                    radius: ['45px', '60px'],
                    center: ['50%', '75px'],
                    avoidLabelOverlap: false,
                    silent: true,
                    label: {
                        normal: {
                            show: false
                        }
                    },
                    data: [{
                        value: donevisitdata,
                        name: '覆盖客户',
                        itemStyle: {
                            normal: {
                                color: '#1acbd1'
                            }
                        }
                    }, {
                        value: 100 - donevisitdata,
                        name: '总客户',
                        itemStyle: {
                            normal: {
                                color: 'rgba(26, 203, 209, 0.3)',
                                label: {
                                    show: false
                                }
                            }
                        }
                    }]
                }]
            };
            myChart.clear();
            myChart.setOption(option);
            // 显示 tooltip
            myChart.dispatchAction({
                type: 'showTip',
                seriesIndex: 0,
                dataIndex: 0
            });
        }

        function _showVisitQtyBarReport() {
            var myChart = echarts.init(document.getElementById("visitqtybarreport"));
            angular.element(window).on('resize', myChart.resize);
            var option = {
                title: {
                    text: '拜访次数地域排名',
                    textStyle: { //标题颜色  
                        color: '#1acbd1',
                        fontSize: '12px'
                    },
                    x: "center",
                    y: 10
                },
                grid: {
                    y: 40,
                    y2: 45,
                    x: 50,
                    x2: 15
                },
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'shadow'
                    }
                },
                legend: {
                    data: ['拜访次数'],
                    itemWidth: 10,
                    itemHeight: 10,
                    textStyle: { //图例文字的样式
                        color: '#fff'
                    },
                    top: 'bottom'
                },
                yAxis: {
                    type: 'value',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        formatter: '{value}',
                        textStyle: {
                            color: "#fff", //坐标轴刻度文字的颜色
                            fontSize: 12
                        }
                    },
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: 'rgba(26, 203, 209, 0.1)'
                        }
                    }
                },
                xAxis: {
                    type: 'category',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },

                    axisLabel: {

                        textStyle: {
                            color: "#fff", //坐标轴刻度文字的颜色
                            fontSize: 12
                        }
                    },
                    data: $scope.vm.visitnameData
                },
                series: [{
                    name: '拜访次数',
                    type: 'bar',
                    barWidth: '20px',
                    data: $scope.vm.visitData
                }],
                color: ['#1acbd1']

            };

            myChart.clear();
            myChart.setOption(option);
        }
    }
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/10/20
 说明     : 大区经理拜访统计表（OTC）（佐力）
 *********************************************************/

(function () {
    'use strict';

    function bigDepManageOTCVisitReportController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "Ym", Value: $scope.vm.Ym });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        function _init() {
            $scope.vm.search = _search;
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.recordCount = 0;
            _getAllBuid();
            _initYmSelected();
        }

        function _search() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return;
            }
            var waiting = rt.showLoading2();
            var url = 'api/BigDepManageOTCVisitReport/GetBigDepManageOTCVisitReportData?Ym=' + $scope.vm.Ym + "&buId=" + $scope.vm.buidSelected.id + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize;
            rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            }, function () {
                waiting.close();
            });
        };

        //计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 80);
            }, 0);
        }

        //条件检查
        function _checkOption() {
            //组合条件
            if (rt.isNullOrWhiteSpace($scope.vm.Ym)) {
                return "请填写年月";
            }
            return "";
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.map(function (e) {
                        if (e.name === '全部事业部' || e.name === 'OTC') {
                            return e;
                        }
                    });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        //给年月默认值
        function _initYmSelected() {
            $scope.vm.Ym = moment().format('YYYY-MM');
        }

        _init();
    }

    angular.module('xrmApp').service('bigDepManageOTCVisitReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BigDepManageOTCVisitReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("bigDepManageOTCVisitReportController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'bigDepManageOTCVisitReportService', bigDepManageOTCVisitReportController]);
})();
"use strict";

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/10/18
 *说明：大区经理拜访统计(按医生)(佐力)
 *************************************************/
(function () {
    'use strict';

    function bigDepManageVisitReportController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "Ym", Value: $scope.vm.Ym });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        //初始化
        function _init() {
            $scope.vm.search = _search; //搜索
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.recordCount = 0;
            _getAllBuid();
            _initYmSelected();
        }
        //搜索代表拜访统计(按医生)(佐力)数据
        function _search() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return;
            }
            var waiting = rt.showLoading2();
            var url = 'api/BigDepManageVisitReport/GetBigDepManageVisitReportData?Ym=' + $scope.vm.Ym + "&buId=" + $scope.vm.buidSelected.id + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize;
            rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            }, function () {
                waiting.close();
            });
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 80);
            }, 0);
        }

        //条件检查
        function _checkOption() {
            //组合条件
            if (rt.isNullOrWhiteSpace($scope.vm.Ym)) {
                return "请填写年月";
            }
            return "";
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.map(function (e) {
                        if (e.name === '全部事业部' || e.id === 'a8c2cb2c-e7c4-e511-838e-782bcb127b62' || e.id === 'fc5a6d82-e7c4-e511-838e-782bcb127b62') {
                            return e;
                        }
                    });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }
        //给年月默认值
        function _initYmSelected() {
            $scope.vm.Ym = moment().format('YYYY-MM');
        }
        _init();
    }
    angular.module('xrmApp').service('bigDepManageVisitReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BigDepManageVisitReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("bigDepManageVisitReportController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'bigDepManageVisitReportService', bigDepManageVisitReportController]);
})();
"use strict";

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/10/18
 *说明：代表拜访统计(按医生)(佐力)
 *************************************************/
(function () {
    'use strict';

    function delegateVisitReportController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "Ym", Value: $scope.vm.Ym });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "businessUnitId", Value: $scope.vm.unitids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        //初始化
        function _init() {
            $scope.vm.unitids = ""; //用','分割的多个省区地区
            $scope.vm.search = _search; //搜索
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.recordCount = 0;
            _getAllBuid();
            _initYmSelected();
        }
        //搜索代表拜访统计(按医生)(佐力)数据
        function _search() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return;
            }
            var waiting = rt.showLoading2();
            var url = 'api/DelegateVisitReport/GetDelegateVisitReportData?Ym=' + $scope.vm.Ym + "&buId=" + $scope.vm.buidSelected.id + "&bigDepId=" + $scope.vm.bigDepSelected.id + "&businessUnitId=" + $scope.vm.unitids + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize;
            rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            }, function () {
                waiting.close();
            });
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 80);
            }, 0);
        }

        //条件检查
        function _checkOption() {
            //组合条件
            if (rt.isNullOrWhiteSpace($scope.vm.Ym)) {
                return "请填写年月";
            }
            $scope.vm.unitids = _CaculateUnitIds();
            return "";
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.map(function (e) {
                        if (e.name === '全部事业部' || e.id === 'a8c2cb2c-e7c4-e511-838e-782bcb127b62' || e.id === 'fc5a6d82-e7c4-e511-838e-782bcb127b62') {
                            return e;
                        }
                    });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }
        //获取业务线大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });
        //获取省区地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    $scope.vm.businessUnitList = resp.DataList;
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });
        //给年月默认值
        function _initYmSelected() {
            $scope.vm.Ym = moment().format('YYYY-MM');
        }
        //计算省区/地区的id集合
        function _CaculateUnitIds() {
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                return unitmap.join(",");
            }
            return "";
        }
        _init();
    }
    angular.module('xrmApp').service('delegateVisitReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DelegateVisitReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("delegateVisitReportController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'delegateVisitReportService', delegateVisitReportController]);
})();
"use strict";

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/10/21
 *说明：OTC代表拜访统计(佐力)
 *************************************************/
(function () {
    'use strict';

    function OTCDelegateVisitReportController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "Ym", Value: $scope.vm.Ym });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "businessUnitId", Value: $scope.vm.unitids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        //初始化
        function _init() {
            $scope.vm.unitids = ""; //用','分割的多个省区地区
            $scope.vm.search = _search; //搜索
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.recordCount = 0;
            _getAllBuid();
            _initYmSelected();
        }
        //搜索代表拜访统计(按医生)(佐力)数据
        function _search() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return;
            }
            var waiting = rt.showLoading2();
            var url = 'api/OTCDelegateVisitReport/GetOTCDelegateVisitReportData?Ym=' + $scope.vm.Ym + "&buId=" + $scope.vm.buidSelected.id + "&bigDepId=" + $scope.vm.bigDepSelected.id + "&businessUnitId=" + $scope.vm.unitids + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize;
            rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            }, function () {
                waiting.close();
            });
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 80);
            }, 0);
        }

        //条件检查
        function _checkOption() {
            //组合条件
            if (rt.isNullOrWhiteSpace($scope.vm.Ym)) {
                return "请填写年月";
            }
            $scope.vm.unitids = _CaculateUnitIds();
            return "";
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.map(function (e) {
                        if (e.name === '全部事业部' || e.name === 'OTC') {
                            return e;
                        }
                    });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }
        //获取业务线大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });
        //获取省区地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    $scope.vm.businessUnitList = resp.DataList;
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });
        //给年月默认值
        function _initYmSelected() {
            $scope.vm.Ym = moment().format('YYYY-MM');
        }
        //计算省区/地区的id集合
        function _CaculateUnitIds() {
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                return unitmap.join(",");
            }
            return "";
        }
        _init();
    }
    angular.module('xrmApp').service('OTCDelegateVisitReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'OTCDelegateVisitReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("OTCDelegateVisitReportController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'OTCDelegateVisitReportService', OTCDelegateVisitReportController]);
})();
"use strict";

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Gale Ge
 *创建时间：2016/10/19
 *说明：OTC地区经理拜访统计(按医生)(佐力)
 *************************************************/
(function () {
    'use strict';

    function otcRegionManagerVisitReportController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "Ym", Value: $scope.vm.Ym });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        //初始化
        function _init() {
            $scope.vm.search = _search; //搜索
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.recordCount = 0;
            _getAllBuid();
            _initYmSelected();
        }
        //搜索代表拜访统计(按医生)(佐力)数据
        function _search() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return;
            }
            var waiting = rt.showLoading2();
            var url = 'api/OTCRegionManagerVisitReport/GetOTCRegionManagerVisitReportData?Ym=' + $scope.vm.Ym + "&buId=" + $scope.vm.buidSelected.id + "&bigDepId=" + $scope.vm.bigDepSelected.id + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize;
            rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            }, function () {
                waiting.close();
            });
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 80);
            }, 0);
        }
        //条件检查
        function _checkOption() {
            //组合条件
            if (rt.isNullOrWhiteSpace($scope.vm.Ym)) {
                return "请填写年月";
            }
            return "";
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.map(function (e) {
                        if (e.name === '全部事业部' || e.name === 'OTC') {
                            return e;
                        }
                    });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        //获取业务线大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });

        //给年月默认值
        function _initYmSelected() {
            $scope.vm.Ym = moment().format('YYYY-MM');
        }

        _init();
    }
    angular.module('xrmApp').service('otcRegionManagerVisitReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'OTCRegionManagerVisitReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("otcRegionManagerVisitReportController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'otcRegionManagerVisitReportService', otcRegionManagerVisitReportController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2016-10-20
 说明     : 拜访明细查询(OTC)(佐力)
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('OTCVisitDetailsReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'OTCVisitDetailsReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("OTCVisitDetailsReportController", ['$scope', '$q', 'rt', '$injector', 'OTCVisitDetailsReportService', OTCVisitDetailsReportController]);
    function OTCVisitDetailsReportController($scope, $q, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "Ym", Value: $scope.vm.Ym });
            _that.searchList.push({ Type: 1, Key: "buId", Value: buId });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: bigUnitId });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "position", Value: $scope.vm.positionSelected.name });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.Ym = moment().format('YYYY-MM');
            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };
            _getAllBuid();
            _getAllPosition();
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.map(function (e) {
                        if (e.name === '全部事业部' || e.name === 'OTC') {
                            return e;
                        }
                    });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        //获取职位
        function _getAllPosition() {
            rt.queryData("TblSystemUser.GetSystemUserPosition", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;

                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.position = data;
                    $scope.vm.position.unshift({ name: '全部职位' });
                    $scope.vm.positionSelected = $scope.vm.position[0];
                }
            });
        }

        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        //检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.Ym)) {
                return "请填写年月";
            }
            return "";
        }

        function _getReportData() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var waiting = rt.showLoading2();
            var url = "api/OTCVisitDetailsReport/GetOTCVisitDetails";
            url += "?Ym=" + encodeURIComponent($scope.vm.Ym);
            url += "&bigUnitId=" + encodeURIComponent(bigUnitId);
            url += "&unitIds=" + encodeURIComponent(unitids);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);
            url += "&buId=" + encodeURIComponent(buId);
            url += "&position=" + encodeURIComponent($scope.vm.positionSelected.name);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
    }
})();
"use strict";

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Gale Ge
 *创建时间：2016/10/19
 *说明：地区经理拜访统计(按医生)(佐力)
 *************************************************/
(function () {
    'use strict';

    function regionManagerVisitReportController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "Ym", Value: $scope.vm.Ym });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        //初始化
        function _init() {
            $scope.vm.search = _search; //搜索
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.recordCount = 0;
            _getAllBuid();
            _initYmSelected();
        }
        //搜索代表拜访统计(按医生)(佐力)数据
        function _search() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return;
            }
            var waiting = rt.showLoading2();
            var url = 'api/RegionManagerVisitReport/GetRegionManagerVisitReportData?Ym=' + $scope.vm.Ym + "&buId=" + $scope.vm.buidSelected.id + "&bigDepId=" + $scope.vm.bigDepSelected.id + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize;
            rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            }, function () {
                waiting.close();
            });
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 80);
            }, 0);
        }
        //条件检查
        function _checkOption() {
            //组合条件
            if (rt.isNullOrWhiteSpace($scope.vm.Ym)) {
                return "请填写年月";
            }
            return "";
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.map(function (e) {
                        if (e.name === '全部事业部' || e.id === 'a8c2cb2c-e7c4-e511-838e-782bcb127b62' || e.id === 'fc5a6d82-e7c4-e511-838e-782bcb127b62') {
                            return e;
                        }
                    });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        //获取业务线大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });

        //给年月默认值
        function _initYmSelected() {
            $scope.vm.Ym = moment().format('YYYY-MM');
        }

        _init();
    }
    angular.module('xrmApp').service('regionManagerVisitReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'RegionManagerVisitReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("regionManagerVisitReportController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'regionManagerVisitReportService', regionManagerVisitReportController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/11/16
 说明     : 代表负责客户 报表
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('RepresentativeOwnerAccountService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'RepresentativeOwnerAccount';
        // @@ 选项集
        this.picklists = [];
    }]).controller("RepresentativeOwnerAccountController", ['$scope', '$q', 'rt', '$injector', 'RepresentativeOwnerAccountService', RepresentativeOwnerAccountController]);
    function RepresentativeOwnerAccountController($scope, $q, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var ownerId = rt.isNull($scope.vm.ownerIdSelected) ? "" : $scope.vm.ownerIdSelected.Id;
            var isTop = rt.isNull($scope.vm.isTopSelected) ? "" : $scope.vm.isTopSelected.Id;
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "buId", Value: buId });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: bigUnitId });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "ownerId", Value: ownerId });
            _that.searchList.push({ Type: 1, Key: "isTop", Value: isTop });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.isTopList = [{ name: '全部', Id: 10 }, { name: '是', Id: 20 }, { name: '否', Id: 30 }];
            $scope.vm.isTopSelected = $scope.vm.isTopList[0];

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };
            _getAllBuid();
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
                $scope.vm.ownerIdSelected = null;
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
                $scope.vm.ownerIdSelected = null;
            }
        });

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.map(function (e) {
                        if (e.name === '全部事业部' || e.name === '南中国' || e.name === '北中国') {
                            return e;
                        }
                    });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        function _getReportData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var ownerId = rt.isNull($scope.vm.ownerIdSelected) ? "" : $scope.vm.ownerIdSelected.Id;
            var isTop = rt.isNull($scope.vm.isTopSelected) ? "" : $scope.vm.isTopSelected.Id;
            var waiting = rt.showLoading2();

            var url = "api/RepresentativeOwnerAccount/GetRepresentativeOwnerAccount";
            url += "?bigUnitId=" + encodeURIComponent(bigUnitId);
            url += "&unitIds=" + encodeURIComponent(unitids);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);
            url += "&buId=" + encodeURIComponent(buId);
            url += "&ownerId=" + encodeURIComponent(ownerId);
            url += "&isTop=" + encodeURIComponent(isTop);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2016-10-19
 说明     : 拜访明细查询(医生)(佐力)
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('VisitDetailsReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitDetailsReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("visitDetailsReportController", ['$scope', '$q', 'rt', '$injector', 'VisitDetailsReportService', visitDetailsReportController]);
    function visitDetailsReportController($scope, $q, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "Ym", Value: $scope.vm.Ym });
            _that.searchList.push({ Type: 1, Key: "buId", Value: buId });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: bigUnitId });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "position", Value: $scope.vm.positionSelected.name });
            _that.searchList.push({ Type: 1, Key: "statecode", Value: $scope.vm.statecodeSelected.Value });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.categoryInfo = [];
            $scope.vm.categoryCount = 0;
            $scope.vm.index = 1;
            $scope.vm.isShow = 'detail';
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.Ym = moment().format('YYYY-MM');
            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };
            _getAllBuid();
            _getAllPosition();
            _getStateCode();
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.map(function (e) {
                        if (e.name === '全部事业部' || e.id === 'a8c2cb2c-e7c4-e511-838e-782bcb127b62' || e.id === 'fc5a6d82-e7c4-e511-838e-782bcb127b62') {
                            return e;
                        }
                    });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        //获取职位
        function _getAllPosition() {
            rt.queryData("TblSystemUser.GetSystemUserPosition", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;

                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.position = data;
                    $scope.vm.position.unshift({ name: '全部职位' });
                    $scope.vm.positionSelected = $scope.vm.position[0];
                }
            });
        }

        function _getStateCode() {
            rt.get("api/SystemParam/GetSystemParamByCode?code=sys_statecode").then(function (resp) {
                $scope.vm.statecode = resp.data;
                $scope.vm.statecode.unshift({ Name: '全部', Value: 2 });
                $scope.vm.statecodeSelected = $scope.vm.statecode[0];
            });
        }

        //检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.Ym)) {
                return "请填写年月";
            }
            return "";
        }

        function _getReportData() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var waiting = rt.showWaiting();
            var url = $scope.vm.isShow === "detail" ? "api/VisitDetailsReport/GetVisitDetailsReport" : "api/VisitDetailsReport/GetVisitDetailsReportWithCategory";
            url += "?Ym=" + encodeURIComponent($scope.vm.Ym);
            url += "&bigUnitId=" + encodeURIComponent(bigUnitId);
            url += "&unitIds=" + encodeURIComponent(unitids);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);
            url += "&buId=" + encodeURIComponent(buId);
            url += "&position=" + encodeURIComponent($scope.vm.positionSelected.name);
            url += "&statecode=" + encodeURIComponent($scope.vm.statecodeSelected.Value);
            url += "&dataSelected=" + encodeURIComponent($scope.vm.isShow);

            return rt.get(url).then(function (resp) {
                if ($scope.vm.isShow === "detail") {
                    $scope.vm.reportData = resp.data.DataList;
                    $scope.vm.recordCount = resp.data.TotalRecords;
                } else {
                    $scope.vm.categoryInfo = resp.data.DataList;
                    $scope.vm.categoryCount = resp.data.TotalRecords;
                }

                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        //切换tab
        $scope.selectTab = function (id) {
            $scope.vm.index = 1;
            switch (id) {
                case 'tab1':
                    $scope.vm.isShow = 'detail';
                    break;
                case 'tab2':
                    $scope.vm.isShow = 'category';
                    break;
            }
        };
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016-04-18
 说明     : 通用申请
 *********************************************************/
(function () {
    'use strict';

    function ApproveUController($scope, rt) {
        function init() {
            $scope.vm = {};
            $scope.vm.page = {
                index: 1,
                size: 10,
                orderby: 'order by CreatedOn desc'
            };
            $scope.vm.view = {};
            $scope.vm.Data = [];
            $scope.vm.DataLeast = [];
            $scope.vm.approverList = [];
            $scope.vm.addApprover = _addApprover;
            $scope.vm.hide = _hide;
            $scope.vm.getData = _getData;
            var waiting = rt.showLoading2();
            _getData().then(_show(), function (message) {
                rt.errorMessage(message);
            });
            waiting.close();
        }
        function _getData() {
            var url = url = 'api/FlowApproval/GetVisibleActivedSystemUserList?queryString=' + (rt.isNull($scope.vm.searchText) ? "" : encodeURIComponent($scope.vm.searchText)) + '&pageIndex=' + $scope.vm.page.index + '&pageSize=' + $scope.vm.page.size + '&orderby=' + $scope.vm.page.orderby;

            return rt.get(url).then(function (resp) {
                $scope.vm.Data = resp.data.DataList;
                $scope.vm.page.recordCount = resp.data.TotalRecords;
            });
        }
        function _hide() {
            $scope.$parent.vm.hideForm();
        }
        function _addApprover() {
            for (var i = 0; i < $scope.vm.view.selectedIds.length; i++) {
                for (var j = 0; j < $scope.vm.Data.length; j++) {
                    if ($scope.vm.Data[j].SystemUserId === $scope.vm.view.selectedIds[i]) {
                        $scope.vm.approverList.push({
                            OwnerId: {
                                Id: $scope.vm.Data[j].SystemUserId,
                                Name: $scope.vm.Data[j].UserName
                            }
                        });
                    }
                }
            }
            $scope.$emit('to-parent', $scope.vm.approverList);
            $scope.$parent.vm.hideForm();
        }

        function _show() {}

        init();
    }

    angular.module("xrmApp").controller("ApproveUController", ['$scope', 'rt', ApproveUController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016-04-18
 说明     : 通用申请
 *********************************************************/
(function () {
    'use strict';

    function ApproveU2Controller($scope, rt) {
        function init() {
            $scope.vm = {};
            $scope.vm.page = {
                index: 1,
                size: 10,
                orderby: 'order by CreatedOn desc'
            };
            $scope.vm.view = {};
            $scope.vm.Data = [];
            $scope.vm.approverList = [];
            $scope.paramslist = {};
            $scope.moduleName = $scope.rtIncludeParams.moduleName;
            $scope.isFiltered = rt.isNull($scope.rtIncludeParams.filtered) ? true : $scope.rtIncludeParams.filtered;
            var wasSelected = localStorage.getItem($scope.moduleName + "WasSelected_25948a76-18d1-421f-b54d-3936eb0aea88");
            $scope.userWasSelected = !rt.isNull(wasSelected) ? JSON.parse(wasSelected) : [];
            $scope.vm.addApprover = _addApprover;
            $scope.vm.hide = _hide;
            $scope.vm.getData = _getData;
            _getData();
        }

        function _getData() {
            $scope.paramslist["@queryValue"] = rt.isNullOrWhiteSpace($scope.vm.searchText) ? '' : $scope.vm.searchText;
            if ($scope.isFiltered) {
                rt.filteredQueryPagingData('userinfo.GetAllUserInfo', $scope.paramslist, 'name asc', $scope.vm.page.index, function (data) {
                    $scope.vm.Data = data.DataList;
                    $scope.vm.page.recordCount = data.TotalRecords;
                }, function (msg) {
                    rt.showErrorToast(msg);
                });
            } else {
                rt.queryPagingData('userinfo.GetAllUserInfo', $scope.paramslist, 'name asc', $scope.vm.page.index, function (data) {
                    $scope.vm.Data = data.DataList;
                    $scope.vm.page.recordCount = data.TotalRecords;
                }, function (msg) {
                    rt.showErrorToast(msg);
                });
            }
        }

        function _hide() {
            $scope.$parent.vm.hideForm();
        }

        function _addApprover() {
            for (var i = 0; i < $scope.vm.view.selectedIds.length; i++) {
                for (var j = 0; j < $scope.vm.Data.length; j++) {
                    if ($scope.vm.Data[j].id === $scope.vm.view.selectedIds[i]) {
                        $scope.vm.approverList.push({
                            OwnerId: {
                                Id: $scope.vm.Data[j].id,
                                Name: $scope.vm.Data[j].name,
                                businessunitidname: $scope.vm.Data[j].tblbusinessunitidname
                            }
                        });
                    }
                }
            }

            for (var i = 0; i < $scope.vm.view.selectedIds2.length; i++) {
                for (var j = 0; j < $scope.userWasSelected.length; j++) {
                    if ($scope.userWasSelected[j].OwnerId.Id === $scope.vm.view.selectedIds2[i]) {
                        $scope.vm.approverList.push({
                            OwnerId: {
                                Id: $scope.userWasSelected[j].OwnerId.Id,
                                Name: $scope.userWasSelected[j].OwnerId.Name,
                                businessunitidname: $scope.userWasSelected[j].OwnerId.businessunitidname
                            }
                        });
                    }
                }
            }

            // 保存到常用选择人员列表：合并之前已缓存的数据，并取不重复的Top5
            $scope.vm.approverList.forEach(function (u) {
                $scope.userWasSelected = _.take(_.uniq([u].concat($scope.userWasSelected), function (n) {
                    return n.OwnerId.Id;
                }), 5);
            });
            var str = $scope.moduleName + "WasSelected_25948a76-18d1-421f-b54d-3936eb0aea88";
            localStorage.setItem(str, JSON.stringify($scope.userWasSelected));

            $scope.$emit('to-parent', $scope.vm.approverList);
            $scope.$parent.vm.hideForm();
        }

        init();
    }

    angular.module("xrmApp").controller("ApproveU2Controller", ['$scope', 'rt', ApproveU2Controller]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : oscar
 创建时间 : 2018-2-5
 说明     : 增加流程步骤
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller("addFlowStepController", ['$injector', '$stateParams', '$scope', '$compile', '$state', 'rt', addFlowStepController]);

    function addFlowStepController($injector, $stateParams, $scope, $compile, $state, rt) {
        function _init() {
            $scope.vm = {};
            $scope.vm.picklist = {};
            $scope.vm.selectedApproverType = {}; //选中的审批人类别
            $scope.vm.selectedStepApprovalMode = null;
            $scope.vm.approverList = []; //存放审核人
            $scope.vm.selectApproverType = _selectApproverType;
            $scope.vm.addApprover = _addApprover;
            $scope.vm.hideForm = _hideForm;
            $scope.vm.delApprover = _delApprover;
            $scope.vm.save = _save;
            _loadPickList();
            var data = $scope.rtIncludeParams;
            if (!rt.isNull(data)) {
                $scope.vm.data = data;
                _loadData();
            }
        }

        //加载数据
        function _loadData() {
            var data = $scope.vm.data;
            if (!rt.isNull(data)) {
                var step_approval_mode = data.step_approval_mode;
                var manager_level = data.manager_level;
                var approval_users = data.approval_users;
                var approval_roleid = data.approval_roleid;
                var approver_type = data.approver_type;
                if (!rt.isNull(approver_type) && !rt.isNullOrEmptyString(approver_type.Value)) {
                    $scope.vm.selectedApproverType = approver_type;
                }
                if (!rt.isNull(manager_level) && !rt.isNullOrEmptyString(manager_level.Value)) {
                    if (approver_type.Value == "10") {
                        $scope.vm.specifymanagerlevel = manager_level;
                    } else {
                        $scope.vm.tomanagerlevel = manager_level;
                    }
                }
                if (!rt.isNull(step_approval_mode) && !rt.isNullOrEmptyString(step_approval_mode.Value)) {
                    $scope.vm.selectedStepApprovalMode = step_approval_mode;
                }
                if (!rt.isNull(approval_users)) {
                    $scope.vm.approverList = approval_users;
                }
                if (!rt.isNull(approval_roleid) && !rt.isNullOrEmptyString(approval_roleid.Id)) {
                    $scope.vm.flowroleid = approval_roleid;
                }
                $scope.vm.step_seq = data.step_seq;
            }
        }

        //加载选项集
        function _loadPickList() {
            _loadManageLevelOption().then(function (resp) {
                if (resp && resp.data) {
                    $scope.vm.picklist = resp.data;
                    if (rt.isNull($scope.vm.data)) {
                        $scope.vm.selectedApproverType = $scope.vm.picklist.approver_type[0];
                    }
                    if (rt.isNull($scope.vm.specifymanagerlevel)) {
                        $scope.vm.specifymanagerlevel = $scope.vm.picklist.manager_level[0];
                    }
                    if (rt.isNull($scope.vm.tomanagerlevel)) {
                        $scope.vm.tomanagerlevel = $scope.vm.picklist.manager_level[0];
                    }
                }
            });
        }

        //加载主管级别选项集
        function _loadManageLevelOption() {
            var api = "api/FlowStep/GetPickListData?fieldCodes=manager_level,approver_type";
            return rt.get(api);
        }

        //选中的审批人类别
        function _selectApproverType(row) {
            $scope.vm.selectedApproverType = row;
        }

        function _addApprover() {
            var html = '<div rt-include rt-template="OA/ApproveU/approveUListView.html" rt-controller="ApproveUController" rt-include-params=' + "" + '></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '添加审核人',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }

        //关闭弹框
        function _hideForm() {
            $scope.vm.dialog.close();
        }

        //删除审核人
        function _delApprover(index) {
            $scope.vm.approverList.splice(index, 1);
        }

        //保存审批节点
        function _save() {
            var selectedApproverType = $scope.vm.selectedApproverType; //审批人类型
            var flowstep = {};
            if (!rt.isNull(selectedApproverType) && !rt.isNullOrEmptyString(selectedApproverType.Value)) {
                switch (selectedApproverType.Value) {
                    case "10":
                        //主管-指定一级
                        flowstep.manager_level = $scope.vm.specifymanagerlevel;
                        var step_approval_mode = $("input[name='step_approval_mode']:checked").val();
                        if (step_approval_mode == "10") {
                            flowstep.step_approval_mode = {
                                Name: '依次审批（本环节内审批人依次审批）',
                                Value: '10'
                            };
                        } else if (step_approval_mode == "20") {
                            flowstep.step_approval_mode = {
                                Name: '会签（须所有审批人同意）',
                                Value: '20'
                            };
                        } else {
                            flowstep.step_approval_mode = {
                                Name: '或签（一名审批人同意或拒绝即可）',
                                Value: '30'
                            };
                        }
                        break;
                    case "20":
                        //主管-连续多级
                        flowstep.manager_level = $scope.vm.tomanagerlevel;
                        flowstep.step_approval_mode = {
                            Name: '依次审批（每一级主管中的审批人依次审批）',
                            Value: '10'
                        };
                        break;
                    case "30":
                        //指定成员
                        flowstep.approval_users = $scope.vm.approverList;
                        var length = flowstep.approval_users.length;
                        if (length <= 0) {
                            rt.errorMessage("请添加至少一个审核人");
                            return "请添加至少一个审核人";
                        }
                        var step_approval_mode = $("input[name='step_approval_mode']:checked").val();
                        if (step_approval_mode == "20") {
                            flowstep.step_approval_mode = {
                                Name: '会签（须所有审批人同意）',
                                Value: '20'
                            };
                        } else {
                            flowstep.step_approval_mode = {
                                Name: '或签（一名审批人同意或拒绝即可）',
                                Value: '30'
                            };
                        }
                        break;
                    case "40":
                        //角色（一组固定成员）
                        flowstep.approval_roleid = $scope.vm.flowroleid;
                        var step_approval_mode = $("input[name='step_approval_mode']:checked").val();
                        if (step_approval_mode == "10") {
                            flowstep.step_approval_mode = {
                                Name: '发起人从角色成员中自选',
                                Value: '10'
                            };
                        } else if (step_approval_mode == "20") {
                            flowstep.step_approval_mode = {
                                Name: '会签（须所有审批人同意）',
                                Value: '20'
                            };
                        } else {
                            flowstep.step_approval_mode = {
                                Name: '或签（一名审批人同意或拒绝即可）',
                                Value: '30'
                            };
                        }
                        if (rt.isNull(flowstep.approval_roleid) || rt.isNullOrEmptyString(flowstep.approval_roleid.Id)) {
                            rt.errorMessage("请选择角色。");
                            return;
                        }
                        break;
                    case "50":
                        //发起人自己
                        break;
                }
                flowstep.approver_type = selectedApproverType;
                if (!rt.isNull($scope.vm.step_seq)) {
                    flowstep.step_seq = $scope.vm.step_seq;
                }
            }
            $scope.$emit('to-parent', flowstep);
            $scope.$parent.vm.hideForm();
        }

        $scope.$on('to-parent', function (event, data) {
            if (rt.isNull($scope.vm.approverList) || $scope.vm.approverList === '') {
                $scope.vm.approverList = _.map(data, function (item) {
                    return item.OwnerId;
                });
            } else {
                $scope.vm.approverLists = $scope.vm.approverList;
                var DataAdd = [];
                for (var i = 0; i < data.length; i++) {
                    var approverExit = true;
                    for (var j = 0; j < $scope.vm.approverLists.length; j++) {
                        if (data[i].OwnerId.Id === $scope.vm.approverLists[j].Id) {
                            approverExit = false;
                        }
                    }
                    if (approverExit) {
                        DataAdd.push(data[i].OwnerId);
                    }
                }
                if ($scope.vm.approverLists.length + DataAdd.length > 20) {
                    rt.errorMessage("单个节点审批人不要超过20人");
                    return "单个节点审批人不要超过20人";
                } else {
                    for (var k = 0; k < DataAdd.length; k++) {
                        $scope.vm.approverList.push(DataAdd[k]);
                    }
                }
            }
        });

        _init();
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/4/15
 说明     : 转发人lookup
 *********************************************************/

(function () {
    'use strict';

    function flowApprovalUController($scope, rt) {
        function init() {
            $scope.vm = {};
            $scope.vm.page = {
                index: 1,
                size: 10,
                orderby: 'order by CreatedOn desc'
            };
            $scope.vm.view = {};
            $scope.vm.Data = [];
            $scope.vm.DataLeast = [];
            $scope.vm.conQR = _conQR;
            $scope.vm.hide = _hide;
            $scope.vm.getData = _getData;
            var waiting = rt.showLoading2();
            _getData().then(_show(), function (message) {
                rt.errorMessage(message);
            });
            waiting.close();
        }

        function _getData() {
            var url = "";
            if (!rt.isNull($scope.vm.searchText)) {
                url = 'api/FlowApproval/GetVisibleActivedSystemUserList?queryString=' + encodeURIComponent($scope.vm.searchText) + '&pageIndex=' + $scope.vm.page.index + '&pageSize=' + $scope.vm.page.size + '&orderby=' + $scope.vm.page.orderby;
            } else {
                url = 'api/FlowApproval/GetVisibleActivedSystemUserList?queryString=' + '' + '&pageIndex=' + $scope.vm.page.index + '&pageSize=' + $scope.vm.page.size + '&orderby=' + $scope.vm.page.orderby;
            }

            return rt.get(url).then(function (resp) {
                $scope.vm.Data = resp.data.DataList;
                $scope.vm.page.recordCount = resp.data.TotalRecords;
            });
        }

        function _hide() {
            $scope.$parent.vm.form.hideForm();
        }

        function _conQR() {
            if ($scope.vm.view.selectedIds.length == 0) {
                rt.errorMessage("请选择转发人");
                return;
            }

            if ($scope.vm.view.selectedIds.length > 1) {
                rt.errorMessage("只能选择一个转发人");
                return;
            }

            rt.successMessage("正在处理...");
            var url = 'api/FlowApproval/FlowTransmit?userId=' + $scope.vm.view.selectedIds;
            rt.post(url, $scope.rtIncludeParams).then(function () {
                $scope.$emit('rt-reload');
                $scope.$parent.vm.form.hideForm();
                $scope.$parent.vm.form.hide();
            }, function () {});
        }

        function _show() {}

        init();
    }

    angular.module("xrmApp").controller("flowApprovalUController", ['$scope', 'rt', flowApprovalUController]);
})();
"use strict";

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/2/14
 *描述：商业库存导入脚本
 *************************************************/
(function () {
    'use strict';

    angular.module("xrmApp").controller("accountinvExcelImportController", ['$scope', 'rt', accountinvExcelImportController]);
    function accountinvExcelImportController($scope, rt) {
        init();

        function init() {
            $scope.importStatus = "";
            $scope.errorFileId = "";
            $scope.selectedFiles = null;
            $scope.selectedFileName = null;

            $scope.import = _import;
            $scope.downloadErrorFile = _downloadErrorFile;
            $scope.downloadTemplateFile = _downloadTemplateFile;
            $scope.selectFile = _selectFile;
        }

        function _selectFile(files) {
            if (files && files.length && files.length > 0) {
                $scope.selectedFiles = files;
                $scope.selectedFileName = files[0].name;
            }
        }
        function _importExcel(fileid) {
            var url = "api/DataService/ImportExcel";
            var data = $scope.$parent.importHeader;
            data.FileId = fileid;
            data.Extra = $scope.vm.importDate;
            return rt.post(url, data);
        }

        function _downloadTemplateFile() {
            var url = "api/DataService/CreateImportTemplate";
            var data = $scope.$parent.importHeader;
            rt.post(url, data).success(function (id) {
                rt.downloadFile("temp", id); //下载模板
            });
        }

        //下载导入错误日志文件
        function _downloadErrorFile() {
            rt.downloadFile("temp", encodeURIComponent($scope.errorFileId));
        }

        function _import() {
            if ($scope.vm === undefined) {
                $scope.importStatus = " 请选择年月。";
                return;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.importDate)) {
                $scope.importStatus = " 请选择年月。";
                return;
            } else {
                var importDateStr = $scope.vm.importDate;
                var importDateArray = importDateStr.split('-');
                var totalMonth = parseInt(importDateArray[0]) * 12 + parseInt(importDateArray[1]);
                var currentMonth = parseInt(new Date().getFullYear()) * 12 + new Date().getMonth() + 1;
                if (totalMonth > currentMonth) {
                    $scope.importStatus = " 选择年月不能大于当前年月。";
                    return;
                }
            }
            if (!$scope.selectedFiles || !$scope.selectedFiles.length || $scope.selectedFiles.length <= 0) {
                $scope.importStatus = " 请选择Excel文件。";
                return;
            }
            $scope.importStatus = "正在导入中...";
            $scope.errorFileId = "";
            var waiting = rt.showWaiting();
            rt.uploadFile($scope.selectedFiles, "temp", rt.newGuid(), false, function (data) {
                _importExcel(data).then(function (resp) {
                    if (rt.isNullOrWhiteSpace(resp.data) || resp.data == "") {
                        $scope.importStatus = " 成功。";
                        $scope.$emit('rt-reload');
                    } else {
                        $scope.importStatus = " 失败。";
                        $scope.errorFileId = resp.data;
                    }
                    waiting.close();
                }, function (resp) {
                    $scope.importStatus = resp.data;
                    waiting.close();
                });
            }, function (msg) {
                waiting.close();
            });

            //   if (rt.isNullOrWhiteSpace($scope.vm.importDate)) {
            //     rt.errorMessage("年月不能为空。");
            //     return;
            // }

            // var waiting = rt.showWaiting();
            // rt.uploadFile($scope.selectedFiles,"delivery",rt.newGuid(),false, function (data) {
            //     $scope.excelinsert(data).then(function(){
            //         rt.successMessage("导入成功。");
            //         $scope.$emit('rt-reload');
            //         waiting.close();
            //     }, function(){
            //         waiting.close();
            //     });
            // });
        }
    }
})();
"use strict";

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/2/14
 *描述：商业安全库存导入脚本
 *************************************************/
(function () {
    'use strict';

    angular.module("xrmApp").controller("accountsafeinvExcelImportController", ['$scope', 'rt', accountsafeinvExcelImportController]);
    function accountsafeinvExcelImportController($scope, rt) {
        init();

        function init() {
            $scope.importStatus = "";
            $scope.errorFileId = "";
            $scope.selectedFiles = null;
            $scope.selectedFileName = null;

            $scope.import = _import;
            $scope.downloadErrorFile = _downloadErrorFile;
            $scope.downloadTemplateFile = _downloadTemplateFile;
            $scope.selectFile = _selectFile;
        }

        function _selectFile(files) {
            if (files && files.length && files.length > 0) {
                $scope.selectedFiles = files;
                $scope.selectedFileName = files[0].name;
            }
        }
        function _importExcel(fileid) {
            var url = "api/DataService/ImportExcel";
            var data = $scope.$parent.importHeader;
            data.FileId = fileid;
            return rt.post(url, data);
        }

        function _downloadTemplateFile() {
            var url = "api/DataService/CreateImportTemplate";
            var data = $scope.$parent.importHeader;
            rt.post(url, data).success(function (id) {
                rt.downloadFile("account_safe_inv", id); //下载模板
            });
        }

        //下载导入错误日志文件
        function _downloadErrorFile() {
            rt.downloadFile("account_safe_inv", encodeURIComponent($scope.errorFileId));
        }

        function _import() {
            if (!$scope.selectedFiles || !$scope.selectedFiles.length || $scope.selectedFiles.length <= 0) {
                $scope.importStatus = " 请选择Excel文件。";
                return;
            }
            $scope.importStatus = "正在导入中...";
            $scope.errorFileId = "";
            var waiting = rt.showWaiting();
            rt.uploadFile($scope.selectedFiles, "account_safe_inv", rt.newGuid(), false, function (data) {
                _importExcel(data).then(function (resp) {
                    if (rt.isNullOrWhiteSpace(resp.data) || resp.data == "") {
                        $scope.importStatus = " 成功。";
                        $scope.$emit('rt-reload');
                    } else {
                        $scope.importStatus = " 失败。";
                        $scope.errorFileId = resp.data;
                    }
                    waiting.close();
                }, function (resp) {
                    $scope.importStatus = resp.data;
                    waiting.close();
                });
            }, function (msg) {
                waiting.close();
            });
        }
    }
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2017/6/12
 说明     : 代表签到查询
 *********************************************************/
(function () {
    'use strict';

    function attendancereportController($scope, $q, rt, $injector, $timeout, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            var ownerid = _CalculateAccids();
            _that.searchList.push({ Type: 1, Key: "ym", Value: $scope.vm.ym });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "ownerids", Value: ownerid });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.reportData = []; //表格数据
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.ym = moment().format('YYYY-MM');
            $scope.vm.TbHeCosNum = 4;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.paramUnitids = '';
            $scope.vm.getReportData = _getReportData; //查询按钮
            $scope.complateTableheight = _complateTableheight;
            _initYmSelected();
        }
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.ym)) {
                return "请选择查询年月";
            }
            return "";
        }
        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var ownerid = _CalculateAccids();
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showWaiting();
            var url = 'api/AddtenanceReport/GetOwnerAddtenance?date=' + encodeURIComponent($scope.vm.ym) + "&OwnerId=" + encodeURIComponent(ownerid) + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            rt.post(url, unitids).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
        //计算客户ids
        function _CalculateAccids() {
            var ownerid = "";
            if (!rt.isNull($scope.vm.ownerSelected)) {
                var accmap = $scope.vm.ownerSelected.map(function (item) {
                    return item.Id;
                });
                ownerid = accmap.join(",");
            }
            return ownerid;
        }
        init();
    }
    angular.module('xrmApp').service('attendancereportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessEntiretyReturnMoney';
        // @@ 选项集
        this.picklists = [];
    }]).controller("attendancereportController", ['$scope', '$q', 'rt', '$injector', '$timeout', 'attendancereportService', attendancereportController]);
})();
"use strict";

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/6/29
 *说明：基药线动销率报表
 *************************************************/
(function () {
    'use strict';

    function baseLineDynamicRateListController($scope, $q, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.startDate });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.endDate });
            _that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: $scope.vm.unitids });
            _that.searchList.push({ Type: 1, Key: "orderBy", Value: $scope.vm.sortSelected.Value });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.reportData = []; //表格数据
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = { Id: '' };
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { Id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = null;
            $scope.vm.pageIndex = 1;
            $scope.vm.TotalRecords = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.unitids = "";
            $scope.vm.showReport = _getReportData;
            _getSorts();
            _getAllBuid();
            _initYmSelected();
        }
        //检查条件
        function checkOption() {
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                $scope.vm.unitids = unitmap.join(",");
            }
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                return "开始年月不能为空。";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                return "结束年月不能为空。";
            }
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                return "请选择事业部";
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) < 0) {
                return "参数异常[开始日期必须小于等于结束日期.]";
            }
            if (_CalOneYear($scope.vm.startDate, $scope.vm.endDate) != 0) {
                return "参数异常[开始日期与结束日期必须在同一年.]";
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) >= 365) {
                return "参数异常[日期区间最大为12个月.]";
            }
            return "";
        }
        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.startDate = d.getFullYear() + "-" + '01';
            $scope.vm.endDate = moment().format('YYYY-MM');
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }
        function _getSorts() {
            $scope.vm.sortList = [{ Name: '动销率', Value: 1 }, { Name: '达成数', Value: 2 }];
            $scope.vm.sortSelected = $scope.vm.sortList[0];
        }
        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        function _CalOneYear(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var result = sArr[0] - eArr[0];
            return result;
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }
        //通过接口获取图表数据
        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var waiting = rt.showLoading2();
            //获取表格数据
            myService.getBaseLineDynamicRateData($scope.vm.startDate, $scope.vm.endDate, $scope.vm.buidSelected.id, $scope.vm.bigDepSelected.id, $scope.vm.unitids, $scope.vm.sortSelected.Value, $scope.vm.pageIndex, $scope.vm.pageSize).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.TotalRecords = resp.data.TotalRecords;
                _complateTableheight();
            }, function () {
                waiting.close();
            });
            waiting.close();
        }
        init();
    }
    angular.module('xrmApp').service('baseLineDynamicRateService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BaseLineDynamicRate';
        // @@ 选项集
        this.picklists = [];
        //获取表格数据
        this.getBaseLineDynamicRateData = function (sYm, eYm, buId, bigUnitId, businessUnitId, sortType, pageIndex, pageSize) {
            var url = 'api/BaseLineDynamicRate/GetBaseLineDynamicRateData?sYm=' + encodeURIComponent(sYm) + '&eYm=' + encodeURIComponent(eYm) + '&businessUnitId=' + encodeURIComponent(businessUnitId) + '&bigDepId=' + encodeURIComponent(bigUnitId) + '&orderBy=' + encodeURIComponent(sortType) + '&pageIndex=' + pageIndex + '&pageSize=' + pageSize + '&buId=' + encodeURIComponent(buId);
            return rt.get(url);
        };
    }]).controller("baseLineDynamicRateListController", ['$scope', '$q', '$timeout', 'rt', '$injector', 'baseLineDynamicRateService', baseLineDynamicRateListController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/02/28
 说明     : 报表 - 商业开票金额统计
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('BizAccountReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BizAccountReport';
    }]).controller("BizAccountReportController", ['$scope', 'rt', '$injector', 'BizAccountReportService', BizAccountReportController]);
    function BizAccountReportController($scope, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "Ym", Value: moment($scope.vm.yM).format('YYYY-MM') });
            _that.searchList.push({ Type: 1, Key: "buId", Value: buId });
            _that.searchList.push({ Type: 1, Key: "bigDepId", Value: bigUnitId });
            _that.searchList.push({ Type: 1, Key: "businessUnitId", Value: unitids });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();

        function init() {
            $scope.vm.buidList = [];
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.isShow = 'sum';
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.yM = moment().format('YYYY-MM');

            //查询
            $scope.vm.showReport = function () {
                if ($scope.vm.isShow == 'sum') {
                    _getReportSumData();
                }
                if ($scope.vm.isShow == 'detail') {
                    _getReportDetailData();
                }
            };

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                _getReportSumData();
                _getReportDetailData();
            };

            _getAllBuid();
        }

        //切换tab
        $scope.selectTab = function (id) {
            $scope.vm.index = 1;
            switch (id) {
                case 'tab1':
                    $scope.vm.isShow = 'sum';
                    break;
                case 'tab2':
                    $scope.vm.isShow = 'detail';
                    break;
            }
        };

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            });
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function () {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        function _getReportDetailData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var waiting = rt.showLoading2();
            var url = "api/BizAccountReport/GetBizAccountReportDetailData";
            url += "?Ym=" + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM'));
            url += "&buId=" + encodeURIComponent($scope.vm.buidSelected.id);
            url += "&bigDepId=" + encodeURIComponent(bigUnitId);
            url += "&businessUnitId=" + encodeURIComponent(unitids);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportDetailData = resp.data.DataList;
                $scope.vm.recordDetailCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        function _getReportSumData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var waiting = rt.showLoading2();
            var url = "api/BizAccountReport/GetBizAccountReportSumData";
            url += "?Ym=" + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM'));
            url += "&buId=" + encodeURIComponent($scope.vm.buidSelected.id);
            url += "&bigDepId=" + encodeURIComponent(bigUnitId);
            url += "&businessUnitId=" + encodeURIComponent(unitids);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportSumData = resp.data.DataList;
                $scope.vm.recordSumCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Mona
 创建时间 : 2017-12-21
 说明     : 增加标签页
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller("addTagController", ['$injector', '$stateParams', '$scope', '$compile', '$state', 'rt', addTagController]);
    function addTagController($injector, $stateParams, $scope, $compile, $state, rt) {

        _init();

        function _init() {
            $scope.vm = {};
            $scope.vm.data = {};

            $scope.vm.save = function () {
                $scope.vm.errorMessage = checkOption();
                if (!rt.isNullOrWhiteSpace($scope.vm.errorMessage)) {
                    return false;
                } else {
                    _save();
                }
            };
        }

        //检查条件
        function checkOption() {
            if (rt.isNull($scope.vm.data.tagName) || rt.isNullOrWhiteSpace($scope.vm.data.tagValue)) {
                return "请选择标签并输入内容";
            }
            if ($scope.vm.data.tagValue.indexOf(':') >= 0 || $scope.vm.data.tagValue.indexOf('：') >= 0 || $scope.vm.data.tagValue.indexOf(';') >= 0 || $scope.vm.data.tagValue.indexOf('；') >= 0) {
                return "内容不能有特殊字符";
            }
            return "";
        }

        function _save() {
            var tag = { Name: $scope.vm.data.tagName.Name, Value: $scope.vm.data.tagValue, Type: 'addTag' };
            $scope.$emit('to-parent', tag);
            $scope.$parent.vm.form.hideForm();
        }

        $scope.$watch('vm.data.tagName.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.data.tagValue = null;
                return;
            }
        });
    }
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016/7/4
 说明     : 商业回款统计
 *********************************************************/
(function () {
    'use strict';

    function businesscashbacksatisticsController($scope, $q, rt, $injector, $timeout, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            var accids = _CalculateAccids();
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "accountIds", Value: accids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.accList = []; //医院下拉
            $scope.vm.accSelected = null; //医院选择
            $scope.vm.reportData = []; //表格数据
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.imgData = []; //图标数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.MonDataName = []; //每个月份对应文本属性名
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TbHeCosNum = 4;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.paramUnitids = '';
            $scope.vm.getReportData = _getReportData; //查询按钮
            $scope.complateTableheight = _complateTableheight;
            _initYmSelected();
        }
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }
        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            $scope.vm.TbHeCosNum += (MCount + 1) * 2;
            var DeMessText = ["金额（万元）"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("金额（万元）");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("金额（万元）");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }
        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始年月不能大于结束年月";
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }
            return "";
        }
        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var accids = _CalculateAccids();
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showWaiting();
            var url = 'api/BusinessEntiretyReturnMoney/GetBusinessCashBackStatistics?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&accountids=" + encodeURIComponent(accids) + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            rt.post(url, unitids).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _MonDataList($scope.vm.sYm, $scope.vm.eYm);
                _complateTableheight();
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
        //计算客户ids
        function _CalculateAccids() {
            var accids = "";
            if (!rt.isNull($scope.vm.accSelected)) {
                var accmap = $scope.vm.accSelected.map(function (item) {
                    return item.Id;
                });
                accids = accmap.join(",");
            }
            return accids;
        }
        init();
    }
    angular.module('xrmApp').service('BusinessEntiretyReturnMoneyService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessEntiretyReturnMoney';
        // @@ 选项集
        this.picklists = [];
    }]).controller("businesscashbacksatisticsController", ['$scope', '$q', 'rt', '$injector', '$timeout', 'BusinessEntiretyReturnMoneyService', businesscashbacksatisticsController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016/6/17
 说明     : 商业发货统计
 *********************************************************/
(function () {
    'use strict';

    function businessDeliveryStatisticsController($scope, $q, rt, $injector, $timeout, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: $scope.vm.bigDepSelected.id });
            var accids = _CalculateAccids();
            var pids = _CalculatePids();
            var unitids = _CalculateUnitids();
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "accountIds", Value: accids });
            _that.searchList.push({ Type: 1, Key: "productIds", Value: pids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.buidList = []; //事业部下拉
            $scope.vm.buidSelected = { id: '' }; //事业部选择
            $scope.vm.bigDepList = [{ id: '', name: '全部业务线/大区' }]; //业务线/大区下拉
            $scope.vm.bigDepSelected = { id: '' }; //业务线/大区选择
            $scope.vm.businessUnitList = []; //省区/地区下拉
            $scope.vm.businessUnitSelected = null; //省区/地区选择         
            $scope.vm.accList = []; //医院下拉
            $scope.vm.accSelected = null; //医院选择
            $scope.vm.productList = []; //药品名称下拉
            $scope.vm.productSelected = null; //药品名称选择
            $scope.vm.reportData = []; //表格数据
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.imgData = []; //图标数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.MonDataName = []; //每个月份对应文本属性名
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TbHeCosNum = 4;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.paramUnitids = '';
            $scope.vm.getReportData = _getReportData; //查询按钮
            $scope.vm.ClickBusiness = _clickBusiness;
            $scope.complateTableheight = _complateTableheight;
            _initYmSelected();
            _getAllBuid(); //获取所有事业部
        }
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                }
                $scope.vm.buidList.unshift({ id: "", name: "全部事业部" });
                $scope.vm.buidSelected = $scope.vm.buidList[0];
            }, function (error) {});
        }
        //链接省区/地区id集合 不带''间隔的
        function _JoinUnitIds() {
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                return unitmap.join(",");
            }
            return "";
        }
        //业务大区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (newValue != oldValue) {
                $scope.vm.accList.length = 0;
                $scope.vm.paramUnitids = _JoinUnitIds();
            }
        });
        //计算省区的参数值
        function _clickBusiness() {
            $scope.vm.accList.length = 0;
            $scope.vm.paramUnitids = _JoinUnitIds();
        }

        //获取业务线/大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [{ id: '', name: '全部业务线/大区' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    var data = resp.DataList;
                    if (!rt.isNull(data) && data.length > 0) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(data);
                        $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                    }
                    $scope.vm.bigDepList.unshift({ id: '', name: '全部业务线/大区' });
                    $scope.vm.bigDepSelected = { id: '', name: '全部业务线/大区' };
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
                //获取事业部下的所有药品
                rt.queryData("Product.GetProductByBuild", {
                    '@queryValue': '',
                    '@buildId': $scope.vm.buidSelected.id
                }, function (resp) {
                    $scope.vm.productList = resp.DataList;
                    $scope.vm.productSelected = null;
                }, function (error) {
                    $scope.vm.productList = [];
                    $scope.vm.productSelected = null;
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                return;
            }
            if (oldValue != newValue) {
                getBusinessUnitList($scope.vm.buidSelected.id, $scope.vm.bigDepSelected.id);
            }
        });
        //根据事业部或业务线大区 获取省区地区
        function getBusinessUnitList(buId, bigDepId) {
            rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                '@queryValue': '',
                '@ParentBusinessUnitId': bigDepId,
                '@businesstype': 10
            }, function (resp) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.businessUnitList = data;
                }
            }, function (error) {
                $scope.vm.businessUnitList = [];
            });
        }
        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            $scope.vm.TbHeCosNum += (MCount + 1) * 2;
            var DeMessText = ["数量", "金额（万元）"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("数量", "金额（万元）");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("数量", "金额（万元）");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }
        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始年月不能大于结束年月";
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }
            return "";
        }
        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var accids = _CalculateAccids();
            var pids = _CalculatePids();
            var unitids = _CalculateUnitids();
            var waiting = rt.showLoading2();
            var url = 'api/BusinessDeliveryStatistics/GetBusinessDeliveryStatistics?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + encodeURIComponent($scope.vm.buidSelected.id) + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&saleRegion=" + encodeURIComponent(unitids) + "&accountIds=" + encodeURIComponent(accids) + "&productIds=" + encodeURIComponent(pids) + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _MonDataList($scope.vm.sYm, $scope.vm.eYm);
                _complateTableheight();
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
        //计算客户ids
        function _CalculateAccids() {
            var accids = "";
            if (!rt.isNull($scope.vm.accSelected)) {
                var accmap = $scope.vm.accSelected.map(function (item) {
                    return item.Id;
                });
                accids = accmap.join(",");
            }
            return accids;
        }
        //计算产品ids
        function _CalculatePids() {
            var pids = "";
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.id;
                });
                pids = pmap.join(",");
            }
            return pids;
        }
        //计算省区ids
        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            return unitids;
        }
        init();
    }
    angular.module('xrmApp').service('businessDeliveryStatisticsService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessDeliveryStatistics';
        // @@ 选项集
        this.picklists = [];
    }]).controller("businessDeliveryStatisticsController", ['$scope', '$q', 'rt', '$injector', '$timeout', 'businessDeliveryStatisticsService', businessDeliveryStatisticsController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016/6/17
 说明     : 商业分销统计
 *********************************************************/
(function () {
    'use strict';

    function businessDistributeVenditionController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: $scope.vm.bigDepSelected.id });
            var accids = _CalculateAccids();
            var pids = _CalculatePids();
            var unitids = _CalculateUnitids();
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "accountIds", Value: accids });
            _that.searchList.push({ Type: 1, Key: "productIds", Value: pids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm = {};
            $scope.vm.buidList = []; //事业部下拉
            $scope.vm.buidSelected = { id: '' }; //事业部选择
            $scope.vm.bigDepList = [{ id: '', name: '全部业务线/大区' }]; //业务线/大区下拉
            $scope.vm.bigDepSelected = { id: '' }; //业务线/大区选择
            $scope.vm.businessUnitList = []; //省区/地区下拉
            $scope.vm.businessUnitSelected = null; //省区/地区选择         
            $scope.vm.accList = []; //医院下拉
            $scope.vm.accSelected = null; //医院选择
            $scope.vm.productList = []; //药品名称下拉
            $scope.vm.productSelected = null; //药品名称选择
            $scope.vm.reportData = []; //表格数据
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.imgData = []; //图标数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.MonDataName = []; //每个月份对应文本属性名
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TbHeCosNum = 4;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.paramUnitids = '';
            $scope.vm.getReportData = _getReportData; //查询按钮
            $scope.vm.ClickBusiness = _clickBusiness;
            _initYmSelected();
            _getAllBuid(); //获取所有事业部
        }

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }
        //链接省区/地区id集合 不带''间隔的
        function _JoinUnitIds() {
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                return unitmap.join(",");
            }
            return "";
        }
        //业务大区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (newValue != oldValue) {
                $scope.vm.accList.length = 0;
                $scope.vm.paramUnitids = _JoinUnitIds();
            }
        });
        //计算省区的参数值
        function _clickBusiness() {
            $scope.vm.accList.length = 0;
            $scope.vm.paramUnitids = _JoinUnitIds();
        }

        //获取业务线/大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitId", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id }, function (resp) {
                    $scope.vm.bigDepList = [{ id: '', name: '全部业务线/大区' }];
                    $scope.vm.bigDepSelected = { id: '', name: '全部业务线/大区' };
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (!rt.isNull(data) && data.length > 0) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(data);
                        $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                    }
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
                //获取事业部下的所有药品
                rt.queryData("Product.GetProductByBuild", {
                    '@queryValue': '',
                    '@buildId': $scope.vm.buidSelected.id
                }, function (resp) {
                    $scope.vm.productList = resp.DataList;
                    $scope.vm.productSelected = null;
                }, function (error) {
                    $scope.vm.productList = [];
                    $scope.vm.productSelected = null;
                });
                getBusinessUnitList($scope.vm.buidSelected.id, $scope.vm.bigDepSelected.id);
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                getBusinessUnitList($scope.vm.buidSelected.id, $scope.vm.bigDepSelected.id);
            }
        });
        //根据事业部或业务线大区 获取省区地区
        function getBusinessUnitList(buId, bigDepId) {
            rt.filteredQueryData("TblBusinessUnit.GetBusinessUnitByBuidOrBigDep", {
                '@queryValue': '',
                '@bidDepId': bigDepId,
                '@buId': buId
            }, function (resp) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.businessUnitList = data;
                }
            }, function (error) {
                $scope.vm.businessUnitList = [];
            });
        }
        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            $scope.vm.TbHeCosNum += (MCount + 1) * 2;
            var DeMessText = ["数量", "金额（万元）"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("数量", "金额（万元）");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("数量", "金额（万元）");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 50);
        }
        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始年月不能大于结束年月";
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                return "请选择事业部";
            }
            return "";
        }
        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var accids = _CalculateAccids();
            var pids = _CalculatePids();
            var unitids = _CalculateUnitids();
            var waiting = rt.showLoading2();
            var url = 'api/BusinessDistributeVendition/GetBusinessDistributeVendition?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + encodeURIComponent($scope.vm.buidSelected.id) + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&saleRegion=" + encodeURIComponent(unitids) + "&accountIds=" + encodeURIComponent(accids) + "&productIds=" + encodeURIComponent(pids) + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _MonDataList($scope.vm.sYm, $scope.vm.eYm);
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
        //计算客户ids
        function _CalculateAccids() {
            var accids = "";
            if (!rt.isNull($scope.vm.accSelected)) {
                var accmap = $scope.vm.accSelected.map(function (item) {
                    return item.Id;
                });
                accids = accmap.join("','");
            }
            return accids;
        }
        //计算产品ids
        function _CalculatePids() {
            var pids = "";
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.id;
                });
                pids = pmap.join("','");
            }
            return pids;
        }
        //计算省区ids
        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join("','");
            }
            return unitids;
        }
        init();
    }
    angular.module('xrmApp').service('BusinessDistributeVenditionService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessDistributeVendition';
        // @@ 选项集
        this.picklists = [];
    }]).controller("businessDistributeVenditionController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'BusinessDistributeVenditionService', businessDistributeVenditionController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016/6/17
 说明     : 商业分销统计
 *********************************************************/
(function () {
    'use strict';

    function businessDistributeVenditionListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: $scope.vm.bigDepSelected.id });
            var accids = _CalculateAccids();
            var pids = _CalculatePids();
            var unitids = _CalculateUnitids();
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "accountIds", Value: accids });
            _that.searchList.push({ Type: 1, Key: "productIds", Value: pids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.buidList = []; //事业部下拉
            $scope.vm.buidSelected = { id: '' }; //事业部选择
            $scope.vm.bigDepList = [{ id: '' }]; //业务线/大区下拉
            $scope.vm.bigDepSelected = { id: '' }; //业务线/大区选择
            $scope.vm.businessUnitList = []; //省区/地区下拉
            $scope.vm.businessUnitSelected = null; //省区/地区选择         
            $scope.vm.accList = []; //医院下拉
            $scope.vm.accSelected = null; //医院选择
            $scope.vm.productList = []; //药品名称下拉
            $scope.vm.productSelected = null; //药品名称选择
            $scope.vm.reportData = []; //表格数据
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.imgData = []; //图标数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.MonDataName = []; //每个月份对应文本属性名
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TbHeCosNum = 4;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.paramUnitids = '';
            $scope.vm.getReportData = _getReportData; //查询按钮
            $scope.vm.ClickBusiness = _clickBusiness;
            _initYmSelected();
            _getAllBuid(); //获取所有事业部
        }

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                }
                $scope.vm.buidList.unshift({ id: "", name: "全部事业部" });
                $scope.vm.buidSelected = $scope.vm.buidList[0];
            }, function (error) {});
        }
        //链接省区/地区id集合 不带''间隔的
        function _JoinUnitIds() {
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                return unitmap.join(",");
            }
            return "";
        }
        //业务大区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (newValue != oldValue) {
                $scope.vm.accList.length = 0;
                $scope.vm.paramUnitids = _JoinUnitIds();
            }
        });
        //计算省区的参数值
        function _clickBusiness() {
            $scope.vm.accList.length = 0;
            $scope.vm.paramUnitids = _JoinUnitIds();
        }

        //获取业务线/大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [{ id: '', name: '全部业务线/大区' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    var data = resp.DataList;
                    if (!rt.isNull(data) && data.length > 0) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(data);
                        $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                    }
                    $scope.vm.bigDepList.unshift({ id: '', name: '全部业务线/大区' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
                //获取事业部下的所有药品
                rt.queryData("Product.GetProductByBuild", {
                    '@queryValue': '',
                    '@buildId': $scope.vm.buidSelected.id
                }, function (resp) {
                    $scope.vm.productList = resp.DataList;
                    $scope.vm.productSelected = null;
                }, function (error) {
                    $scope.vm.productList = [];
                    $scope.vm.productSelected = null;
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                return;
            }
            if (oldValue != newValue) {
                getBusinessUnitList($scope.vm.buidSelected.id, $scope.vm.bigDepSelected.id);
            }
        });
        //获取省区地区
        function getBusinessUnitList(buId, bigDepId) {
            rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                '@queryValue': '',
                '@ParentBusinessUnitId': bigDepId,
                '@businesstype': 10
            }, function (resp) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.businessUnitList = data;
                }
            }, function (error) {
                $scope.vm.businessUnitList = [];
            });
        }
        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            $scope.vm.TbHeCosNum += (MCount + 1) * 2;
            var DeMessText = ["数量", "金额（万元）"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("数量", "金额（万元）");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("数量", "金额（万元）");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }
        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始年月不能大于结束年月";
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }
            return "";
        }
        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var accids = _CalculateAccids();
            var pids = _CalculatePids();
            var unitids = _CalculateUnitids();
            var waiting = rt.showLoading2();
            var url = 'api/BusinessDistributeVendition/GetBusinessDistributeVendition?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + encodeURIComponent($scope.vm.buidSelected.id) + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&saleRegion=" + encodeURIComponent(unitids) + "&accountIds=" + encodeURIComponent(accids) + "&productIds=" + encodeURIComponent(pids) + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _MonDataList($scope.vm.sYm, $scope.vm.eYm);
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
        //计算客户ids
        function _CalculateAccids() {
            var accids = "";
            if (!rt.isNull($scope.vm.accSelected)) {
                var accmap = $scope.vm.accSelected.map(function (item) {
                    return item.Id;
                });
                accids = accmap.join(",");
            }
            return accids;
        }
        //计算产品ids
        function _CalculatePids() {
            var pids = "";
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.id;
                });
                pids = pmap.join(",");
            }
            return pids;
        }
        //计算省区ids
        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            return unitids;
        }
        init();
    }
    angular.module('xrmApp').service('BusinessDistributeVenditionService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessDistributeVendition';
        // @@ 选项集
        this.picklists = [];
    }]).controller("businessDistributeVenditionListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'BusinessDistributeVenditionService', businessDistributeVenditionListController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人    : Summer Xu
 修改人    : Ludwig Dong
 创建时间  : 2016/5/5
 说明      : 纯销指标达成
 *********************************************************/
(function () {
    'use strict';

    function BEBackSectionController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            //组合条件
            var accids = "";
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                rt.errorMessage("请选择开始年月");
                return false;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                rt.errorMessage("请选择结束年月");
                return false;
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                rt.errorMessage("只可查询同一年的数据");
                return false;
            }
            if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                rt.errorMessage("开始日期必须小于等于结束日期");
                return false;
            }
            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join(",");
                $scope.vm.depType = 0;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigdepart", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "saleregion", Value: accids });
            _that.searchList.push({ Type: 1, Key: "deType", Value: $scope.vm.depType });
            _that.searchList.push({ Type: 1, Key: "orderStr", Value: $scope.vm.orderCode.id });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.chartWidth = 1000;
            // $scope.vm.data = [];
            $scope.vm.dataTable = [];
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.RepoteData = []; //累计达成率图表数据
            $scope.vm.RepoteDataForCount = []; //实际达成额排名图表数据
            $scope.vm.accList = []; //省区地区数据
            $scope.vm.accSelected = null; //省区地区选择
            $scope.vm.productList = []; //药品数据
            $scope.vm.productSelected = null; //药品选择
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = null;
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = [];
            $scope.vm.depType = 0;
            $scope.vm.searchFormHide = true;
            $scope.vm.orderCode = 0;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.selectedTabId = "tab1";
            $scope.selectTab = _selectTab;
            $scope.tableMaxHeight = 0;
            $scope.vm.search = function () {
                _search().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getTops();
            _getAllBuid();
            _initYmSelected();
            _getOrderStr();
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }
        //切换tab
        function _selectTab(id) {
            switch (id) {
                case 'tab1':
                    _show();break;
                case 'tab2':
                    _showcount();break;
                case 'tab3':
                    break;
            }
        }

        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[0];
        }
        function _getOrderStr() {
            $scope.vm.OrderList = [{ id: 0, name: '达成率' }, { id: 1, name: '达成额' }];
            $scope.vm.orderCode = $scope.vm.OrderList[0];
        }
        //--月份与对应月份的文字--//
        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            var DeMessText = ["回款指标", "实际达成额", "月度达成率"];
            // $scope.vm.MonDataList[0] = sArr[1];
            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("回款指标", "实际达成额", "月度达成率");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("回款指标", "实际达成额", "月度达成率");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [{ name: '全部业务线/大区', id: '' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
                return;
            }
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
            $scope.vm.businessUnitList = [];
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
                $scope.vm.buidList.unshift({ id: "", name: "全部事业部" });
                $scope.vm.buidSelected = $scope.vm.buidList[0];
            }, function (error) {});
        }
        function _CalOneYear(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var result = sArr[0] - eArr[0];
            return result;
        } //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        function _ReportTbData(unitSelected) {
            //通过接口获取累计达成率图表数据

            var waiting = rt.showLoading2();
            var TabDataUrl = 'api/BusinessEntiretyReturnMoney/GetBusinessEntiretyRMChartData?sYm=' + encodeURIComponent($scope.vm.sYm) + '&eYm=' + encodeURIComponent($scope.vm.eYm) + "&buid=" + $scope.vm.buidSelected.id + '&businessunitId=' + encodeURIComponent(unitSelected) + '&depType=ToTal_AVG' + '&top=' + $scope.vm.topsSelected;
            return rt.get(TabDataUrl).then(function (resp) {
                $scope.vm.RepoteData = resp.data;
                waiting.close();
                _show();
            }, function () {
                waiting.close();
            });
        }
        function _ReportTbDataForCount(unitSelected) {
            //通过接口获取实际达成额排名图表数据
            var waiting = rt.showLoading2();
            var TabDataUrl = 'api/BusinessEntiretyReturnMoney/GetBusinessEntiretyRMChartData?sYm=' + encodeURIComponent($scope.vm.sYm) + '&eYm=' + encodeURIComponent($scope.vm.eYm) + "&buid=" + $scope.vm.buidSelected.id + '&businessunitId=' + encodeURIComponent(unitSelected) + '&depType=ToTal_All' + '&top=' + $scope.vm.topsSelected;
            return rt.get(TabDataUrl).then(function (resp) {
                $scope.vm.RepoteDataForCount = resp.data;
                waiting.close();
                _showcount();
            }, function () {
                waiting.close();
            });
        }

        function _search() {
            var unitSelected = "";
            var accids = "";
            var pids = "";
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                var deferred = $q.defer();
                deferred.reject("请选择开始年月.");
                return deferred.promise;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                var deferred = $q.defer();
                deferred.reject("请选择结束年月.");
                return deferred.promise;
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                var deferred = $q.defer();
                deferred.reject("只可查询同一年的数据.");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                var deferred = $q.defer();
                deferred.reject("开始日期必须小于等于结束日期.");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.topsSelected)) {
                var deferred = $q.defer();
                deferred.reject("请选择Top值.");
                return deferred.promise;
            }

            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join(",");
                $scope.vm.depType = 0;
            }
            _MonDataList($scope.vm.sYm, $scope.vm.eYm);
            _ReportTbData(accids);
            _ReportTbDataForCount(accids);
            var waiting = rt.showLoading2();
            var url = 'api/BusinessEntiretyReturnMoney/GetBusinessEntiretyRMData?sYm=' + $scope.vm.sYm + "&eYm=" + $scope.vm.eYm + "&saleregion=" + accids + "&buid=" + $scope.vm.buidSelected.id + "&bigdept=" + $scope.vm.bigDepSelected.id + "&orderStr=" + $scope.vm.orderCode.id + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize;
            return rt.get(url).then(function (resp) {
                $scope.vm.dataTable = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
        //展示图表数据
        //实际达成额排名图表
        function _showcount() {
            var myChart = echarts.init(document.getElementById("report2"), "shine");

            var echartYName = [];
            var echartsData = [];
            var getData = $scope.vm.RepoteDataForCount.DataList;
            if (getData != null && getData.length > 0) {
                for (var i = getData.length - 1; i >= 0; i--) {
                    getData[i].BusinessUnitIdName = getData[i].BusinessUnitIdName == null ? "" : getData[i].BusinessUnitIdName;
                    getData[i].OwnerIdName = getData[i].OwnerIdName == null ? "" : getData[i].OwnerIdName;
                    echartYName.push(getData[i].BusinessUnitIdName + "--" + getData[i].OwnerIdName);
                    echartsData.push(getData[i].ToTal_All == null ? 0 : rt.xrmRound(getData[i].ToTal_All, 2));
                }
            }

            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}万元'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartYName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '实际达成额',
                    type: 'bar',
                    data: echartsData,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}万元"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.setOption(option);
        }
        //累计达成率排名图表
        function _show() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            var echartYName = [];
            var echartsData = [];
            var getData = $scope.vm.RepoteData.DataList;
            if (getData != null && getData.length > 0) {
                for (var i = getData.length - 1; i >= 0; i--) {
                    getData[i].BusinessUnitIdName = getData[i].BusinessUnitIdName == null ? "" : getData[i].BusinessUnitIdName;
                    getData[i].OwnerIdName = getData[i].OwnerIdName == null ? "" : getData[i].OwnerIdName;
                    echartYName.push(getData[i].BusinessUnitIdName + "--" + getData[i].OwnerIdName);
                    echartsData.push(getData[i].ToTal_AVG == null ? 0 : rt.xrmRound(getData[i].ToTal_AVG, 2));
                }
            }
            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartYName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '累计达成率',
                    type: 'bar',
                    data: echartsData,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}%"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.setOption(option);
        }
        init();
    }
    angular.module('xrmApp').service('BackSectionService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessEntiretyReturnMoney';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("BEBackSectionController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'BackSectionService', BEBackSectionController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : BerryDing
 创建时间 : 2017/10/31
 说明     : 发货指标达成分析
 *********************************************************/
(function () {
    'use strict';

    function BusinessCirculateVarDeliverListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";

            _that.searchList.length = 0;
            _that.searchList.push({
                Type: 1,
                Key: "sYm",
                Value: $scope.vm.sYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "eYm",
                Value: $scope.vm.eYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "orderStr",
                Value: "percent"
            });
            _that.searchList.push({
                Type: 1,
                Key: "businessUnitIds",
                Value: unitids
            });
            if ($scope.typeSelect !== "noCustomCategory") {
                _that.searchList.push({
                    Type: 1,
                    Key: "diyCategoryId",
                    Value: $scope.vm.cuSelected.Id
                });
            }
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        function init() {
            //时间筛选，默认全年
            $scope.dateSelect = 'fullYear';
            $scope.vm.sYm = moment().format('YYYY-01');
            $scope.vm.eYm = moment().format('YYYY-12');

            //类型筛选，默认按大区
            $scope.filterSelect = 'byRegion';
            $scope.typeSelect = 'noCustomCategory';
            _getCustomCategory(); //获取指标类型

            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.dataTable = [];
            $scope.vm.recordCount = 0;
            $scope.vm.echartData1 = [];
            $scope.vm.echartData2 = [];
            $scope.vm.totalData = {
                totalTarget: 0,
                totalDone: 0,
                totalPercent: 0
            };
        }

        //获取指标类型
        function _getCustomCategory() {
            var url = 'api/CustomCategory/GetCustomCategoryByTaskType?taskType=4';
            return rt.get(url).then(function (resp) {
                $scope.vm.customCategoryList = resp.data;
                if ($scope.vm.customCategoryList.length > 0) {
                    $scope.vm.cuSelected = $scope.vm.customCategoryList[0];
                }
            });
        }

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }
            return "";
        }

        //达成率排名-echart图表
        function _showReportPercentEchart() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");

            var echartsDataValue = [];
            var echartsDataName = [];

            var getData = $scope.vm.echartData1.DataList;
            if (getData != null && getData.length > 0) {
                for (var i = getData.length - 1; i >= 0; i--) {
                    getData[i].BusinessUnitIdName = getData[i].BusinessUnitIdName == null ? "" : getData[i].BusinessUnitIdName;
                    getData[i].OwnerIdName = getData[i].OwnerIdName == null ? "" : getData[i].OwnerIdName;
                    echartsDataName.push(getData[i].BusinessUnitIdName + "--" + getData[i].OwnerIdName);
                    echartsDataValue.push(getData[i].ToTal_AVG == null ? 0 : getData[i].ToTal_AVG.toFixed2(2));
                }
            }
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: '{b}<br/>{a}:{c}%'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '累计达成率',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}%"
                            },
                            labelLine: {
                                show: true
                            }

                        }
                    }
                }]
            };

            myChart.setOption(option);
        }

        //达成量排名-echart图表
        function _showReportByQtyDoneEchart() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.echartData2.DataList;
            if (dataList) {
                dataList = _.sortBy(dataList, function (item) {
                    return item.ToTal_Qty;
                }); //数组翻转 因为echart会反向排序
                echartsDataValue = _.map(dataList, function (e) {
                    return e.ToTal_Qty.toFixed2(2);
                });
                echartsDataName = _.map(dataList, function (e) {
                    return e.BusinessUnitIdName + '--' + (e.OwnerIdName ? e.OwnerIdName : "");
                });
            }
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: '{b}<br/>{a}:{c}'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '累计达成量',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}"
                            },
                            labelLine: {
                                show: true
                            }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        //达成额排名-echart图表
        function _showReportDoneEchart() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");

            var echartsDataValue = [];
            var echartsDataName = [];

            var getData = $scope.vm.echartData2.DataList;
            if (getData != null && getData.length > 0) {
                for (var i = getData.length - 1; i >= 0; i--) {
                    getData[i].BusinessUnitIdName = getData[i].BusinessUnitIdName == null ? "" : getData[i].BusinessUnitIdName;
                    getData[i].OwnerIdName = getData[i].OwnerIdName == null ? "" : getData[i].OwnerIdName;
                    echartsDataName.push(getData[i].BusinessUnitIdName + "--" + getData[i].OwnerIdName);
                    echartsDataValue.push(getData[i].ToTal_All == null ? 0 : getData[i].ToTal_All.toFixed2(2));
                }
            }
            var option = {
                title: {
                    text: ''
                },
                tooltip: {
                    trigger: 'axis'
                },

                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} 万元'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '发货达成额',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}万元"
                            },
                            labelLine: {
                                show: true
                            }

                        }
                    }
                }]
            };

            myChart.setOption(option);
        }

        //处理列表数据表头
        function _setMonthData(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            var DeMessText = $scope.typeSelect == 'customCategoryByQty' ? ["发货指标", "实际达成量", "月度达成率"] : ["发货指标", "实际达成额", "月度达成率"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    if ($scope.typeSelect == 'customCategoryByQty') $scope.vm.TbMessText.push("发货指标", "实际达成量", "月度达成率");else $scope.vm.TbMessText.push("发货指标", "实际达成额", "月度达成率");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                if ($scope.typeSelect == 'customCategoryByQty') $scope.vm.TbMessText.push("发货指标", "实际达成量", "月度达成率");else $scope.vm.TbMessText.push("发货指标", "实际达成额", "月度达成率");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }

        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
        }

        //选择时间筛选
        $scope.vm.changeDate = function (dateType) {
            $scope.dateSelect = dateType;

            switch (dateType) {
                case "fullYear":
                    $scope.vm.sYm = moment().format('YYYY-01');
                    $scope.vm.eYm = moment().format('YYYY-12');
                    break;
                case "thisMonth":
                    $scope.vm.sYm = moment().format('YYYY-MM');
                    $scope.vm.eYm = moment().format('YYYY-MM');
                    break;
                case "lastMonth":
                    $scope.vm.sYm = moment().add(-1, 'months').format('YYYY-MM');
                    $scope.vm.eYm = moment().add(-1, 'months').format('YYYY-MM');
                    break;
                case "thisQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-10');
                            $scope.vm.eYm = moment().format('YYYY-12');
                            break;
                    }
                    break;
                case "lastQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().add(-1, 'years').format('YYYY-10');
                            $scope.vm.eYm = moment().add(-1, 'years').format('YYYY-12');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                    }
                    break;
            }
        };

        //查询Echart图表数据
        $scope.vm.getChartData = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();

            //按大区
            if ($scope.filterSelect == 'byRegion') {
                //不分指标类型
                if ($scope.typeSelect === 'noCustomCategory') {
                    //达成率排名                    
                    myService.GetRegionPercentEchart($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                        $scope.vm.echartData1 = resp.data;
                        _showReportPercentEchart();
                        waiting.close();
                    });
                    //达成额排名
                    myService.GetRegionDoneEchart($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                        $scope.vm.echartData2 = resp.data;
                        _showReportDoneEchart();
                        waiting.close();
                    });
                    //合计  
                    myService.GetRegionTotal($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                        $scope.vm.totalData = resp.data;
                        waiting.close();
                    });
                }
                //按金额
                if ($scope.typeSelect === 'customCategoryByAmount') {
                    //达成率排名                   
                    myService.GetRegionPercentEchartByAmount($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.echartData1 = resp.data;
                        _showReportPercentEchart();
                        waiting.close();
                    });
                    //达成额排名
                    myService.GetRegionDoneEchartByAmount($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.echartData2 = resp.data;
                        _showReportDoneEchart();
                        waiting.close();
                    });
                    //合计      
                    myService.GetRegionTotalByAmount($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.totalData = resp.data;
                        waiting.close();
                    });
                }
                //按数量
                if ($scope.typeSelect === 'customCategoryByQty') {
                    //达成率排名
                    myService.GetRegionPercentEchartByQty($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.echartData1 = resp.data;
                        _showReportPercentEchart();
                        waiting.close();
                    });

                    //达成额排名
                    myService.GetRegionDoneEchartByQty($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.echartData2 = resp.data;
                        _showReportByQtyDoneEchart();
                        waiting.close();
                    });

                    //合计
                    myService.GetRegionTotalByQty($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.totalData = resp.data;
                        waiting.close();
                    });
                }
            }

            //按省区/地区
            if ($scope.filterSelect == 'byBusinessunit') {
                //不分指标类型
                if ($scope.typeSelect === 'noCustomCategory') {
                    //达成率排名
                    myService.GetBusinessunitPercentEchart($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                        $scope.vm.echartData1 = resp.data;
                        _showReportPercentEchart();
                        waiting.close();
                    });

                    //达成额排名
                    myService.GetBusinessunitDoneEchart($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                        $scope.vm.echartData2 = resp.data;
                        _showReportDoneEchart();
                        waiting.close();
                    });

                    //合计
                    myService.GetBusinessunitTotal($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                        $scope.vm.totalData = resp.data;
                        waiting.close();
                    });
                }
                //按金额
                if ($scope.typeSelect === 'customCategoryByAmount') {
                    //达成率排名
                    myService.GetBusinessunitPercentEchartByAmount($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.echartData1 = resp.data;
                        _showReportPercentEchart();
                        waiting.close();
                    });

                    //达成额排名
                    myService.GetBusinessunitDoneEchartByAmount($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.echartData2 = resp.data;
                        _showReportDoneEchart();
                        waiting.close();
                    });

                    //合计
                    myService.GetBusinessunitTotalByAmount($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.totalData = resp.data;
                        waiting.close();
                    });
                }
                //按数量
                if ($scope.typeSelect === 'customCategoryByQty') {
                    //达成率排名
                    myService.GetBusinessunitPercentEchartByQty($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.echartData1 = resp.data;
                        _showReportPercentEchart();
                        waiting.close();
                    });

                    //达成额排名
                    myService.GetBusinessunitDoneEchartByQty($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.echartData2 = resp.data;
                        _showReportByQtyDoneEchart();
                        waiting.close();
                    });

                    //合计
                    myService.GetBusinessunitTotalByQty($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.totalData = resp.data;
                        waiting.close();
                    });
                }
            }

            //按代表
            if ($scope.filterSelect == 'byOwner') {
                //不分指标类型
                if ($scope.typeSelect === 'noCustomCategory') {
                    //达成率排名
                    myService.GetOwnerPercentEchart($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                        $scope.vm.echartData1 = resp.data;
                        _showReportPercentEchart();
                        waiting.close();
                    });

                    //达成额排名
                    myService.GetOwnerDoneEchart($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                        $scope.vm.echartData2 = resp.data;
                        _showReportDoneEchart();
                        waiting.close();
                    });

                    //合计
                    myService.GetOwnerTotal($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                        $scope.vm.totalData = resp.data;
                        waiting.close();
                    });
                }
                //按金额
                if ($scope.typeSelect === 'customCategoryByAmount') {
                    //达成率排名
                    myService.GetOwnerPercentEchartByAmount($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.echartData1 = resp.data;
                        _showReportPercentEchart();
                        waiting.close();
                    });

                    //达成额排名
                    myService.GetOwnerDoneEchartByAmount($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.echartData2 = resp.data;
                        _showReportDoneEchart();
                        waiting.close();
                    });

                    //合计
                    myService.GetOwnerTotalByAmount($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.totalData = resp.data;
                        waiting.close();
                    });
                }
                //按数量
                if ($scope.typeSelect === 'customCategoryByQty') {
                    //达成率排名
                    myService.GetOwnerPercentEchartByQty($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.echartData1 = resp.data;
                        _showReportPercentEchart();
                        waiting.close();
                    });

                    //达成额排名
                    myService.GetOwnerDoneEchartByQty($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.echartData2 = resp.data;
                        _showReportByQtyDoneEchart();
                        waiting.close();
                    });

                    //合计
                    myService.GetOwnerTotalByQty($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                        $scope.vm.totalData = resp.data;
                        waiting.close();
                    });
                }
            }
        };

        //查询报表数据
        $scope.vm.getReportData = function () {
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();

            //按大区
            if ($scope.filterSelect == 'byRegion') {
                $scope.isOwnerShow = false;
                $scope.region = true;
                //不分省区发货指标类型
                if ($scope.typeSelect === 'noCustomCategory') {
                    $scope.isQtyShow = false;
                    //达成列表
                    myService.GetRegionList($scope.vm.sYm, $scope.vm.eYm, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                        $scope.vm.dataTable = resp.data.DataList;
                        $scope.vm.recordCount = resp.data.TotalRecords;
                        _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                        _complateTableheight();
                        waiting.close();
                    });
                }
                //按金额
                if ($scope.typeSelect === 'customCategoryByAmount') {
                    $scope.isQtyShow = false;
                    //达成列表
                    myService.GetRegionListByAmount($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                        $scope.vm.dataTable = resp.data.DataList;
                        $scope.vm.recordCount = resp.data.TotalRecords;
                        _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                        _complateTableheight();
                        waiting.close();
                    });
                }

                //按数量
                if ($scope.typeSelect === 'customCategoryByQty') {
                    $scope.isQtyShow = true;

                    //达成列表                 
                    myService.GetRegionListByQty($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                        $scope.vm.dataTable = resp.data.DataList;
                        $scope.vm.recordCount = resp.data.TotalRecords;
                        _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                        _complateTableheight();
                        waiting.close();
                    });
                }
            }

            //按省区/地区
            if ($scope.filterSelect == 'byBusinessunit') {
                $scope.isOwnerShow = false;
                $scope.region = false;
                //达成列表
                //不分省区发货指标类型
                if ($scope.typeSelect === 'noCustomCategory') {
                    $scope.isQtyShow = false;
                    //达成列表
                    myService.GetBusinessunitList($scope.vm.sYm, $scope.vm.eYm, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                        $scope.vm.dataTable = resp.data.DataList;
                        $scope.vm.recordCount = resp.data.TotalRecords;
                        _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                        _complateTableheight();
                        waiting.close();
                    });
                }
                //按金额
                if ($scope.typeSelect === 'customCategoryByAmount') {
                    $scope.isQtyShow = false;
                    //达成列表
                    myService.GetBusinessunitListByAmount($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                        $scope.vm.dataTable = resp.data.DataList;
                        $scope.vm.recordCount = resp.data.TotalRecords;
                        _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                        _complateTableheight();
                        waiting.close();
                    });
                }

                //按数量
                if ($scope.typeSelect === 'customCategoryByQty') {
                    $scope.isQtyShow = true;

                    //达成列表
                    myService.GetBusinessunitListByQty($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                        $scope.vm.dataTable = resp.data.DataList;
                        $scope.vm.recordCount = resp.data.TotalRecords;
                        _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                        _complateTableheight();
                        waiting.close();
                    });
                }
            }

            //按代表
            if ($scope.filterSelect == 'byOwner') {
                $scope.isOwnerShow = true;
                $scope.region = false;
                //达成列表
                //不分省区发货指标类型
                if ($scope.typeSelect === 'noCustomCategory') {
                    $scope.isQtyShow = false;
                    //达成列表
                    myService.GetOwnerList($scope.vm.sYm, $scope.vm.eYm, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                        $scope.vm.dataTable = resp.data.DataList;
                        $scope.vm.recordCount = resp.data.TotalRecords;
                        _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                        _complateTableheight();
                        waiting.close();
                    });
                }

                //按金额
                if ($scope.typeSelect === 'customCategoryByAmount') {
                    $scope.isQtyShow = false;
                    //达成列表
                    myService.GetOwnerListByAmount($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                        $scope.vm.dataTable = resp.data.DataList;
                        $scope.vm.recordCount = resp.data.TotalRecords;
                        _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                        _complateTableheight();
                        waiting.close();
                    });
                }

                //按数量
                if ($scope.typeSelect === 'customCategoryByQty') {
                    $scope.isQtyShow = true;

                    //达成列表
                    myService.GetOwnerListByQty($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                        $scope.vm.dataTable = resp.data.DataList;
                        $scope.vm.recordCount = resp.data.TotalRecords;
                        _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                        _complateTableheight();
                        waiting.close();
                    });
                }
            }
        };

        init();
    }
    angular.module('xrmApp').service('DeliverService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessCirculateVarDeliver';

        //按大区不分指标-达成率排名
        this.GetRegionPercentEchart = function (sYm, eYm, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByRegionChartData?" + "sYm=" + sYm + "&eYm=" + eYm + "&depType=ToTal_AVG", unitids);
        };
        //按大区不分指标-达成额排名
        this.GetRegionDoneEchart = function (sYm, eYm, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByRegionChartData?" + "sYm=" + sYm + "&eYm=" + eYm + "&depType=ToTal_All", unitids);
        };
        //按大区不分指标-达成列表
        this.GetRegionList = function (sYm, eYm, pageIndex, pageSize, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByRegionDataForTable?" + "sYm=" + sYm + "&eYm=" + eYm + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&orderStr=percent", unitids);
        };
        //按大区不分指标-合计
        this.GetRegionTotal = function (sYm, eYm, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByRegionTotal?" + "sYm=" + sYm + "&eYm=" + eYm, unitids);
        };
        //按大区按金额-达成率排名
        this.GetRegionPercentEchartByAmount = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByRegionChartData?" + "sYm=" + sYm + "&eYm=" + eYm + "&depType=ToTal_AVG" + "&diyCategoryId=" + diyCategoryId, unitids);
        };
        //按大区按金额-达成额排名
        this.GetRegionDoneEchartByAmount = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByRegionChartData?" + "sYm=" + sYm + "&eYm=" + eYm + "&depType=ToTal_All" + "&diyCategoryId=" + diyCategoryId, unitids);
        };
        //按大区按金额-达成列表
        this.GetRegionListByAmount = function (sYm, eYm, diyCategoryId, pageIndex, pageSize, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByRegionDataForTable?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&orderStr=percent", unitids);
        };

        //按大区按金额-合计
        this.GetRegionTotalByAmount = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByRegionTotal?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId, unitids);
        };
        //按大区按数量-达成率排名
        this.GetRegionPercentEchartByQty = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByRegionDataForTableByQty?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId + "&pageIndex=1" + "&pageSize=10" + "&orderStr=percent", unitids);
        };
        //按大区按数量-达成额排名
        this.GetRegionDoneEchartByQty = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByRegionDataForTableByQty?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId + "&pageIndex=1" + "&pageSize=10" + "&orderStr=qty", unitids);
        };
        //按大区按数量-达成列表
        this.GetRegionListByQty = function (sYm, eYm, diyCategoryId, pageIndex, pageSize, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByRegionDataForTableByQty?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&orderStr=percent", unitids);
        };

        //按大区按数量-合计
        this.GetRegionTotalByQty = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByRegionTotalByQty?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId, unitids);
        };

        //按省区/地区不分指标-达成率排名
        this.GetBusinessunitPercentEchart = function (sYm, eYm, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverChartData?" + "sYm=" + sYm + "&eYm=" + eYm + "&depType=ToTal_AVG", unitids);
        };

        //按省区/地区不分指标-达成额排名
        this.GetBusinessunitDoneEchart = function (sYm, eYm, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverChartData?" + "sYm=" + sYm + "&eYm=" + eYm + "&depType=ToTal_All", unitids);
        };

        //按省区/地区不分指标-达成列表
        this.GetBusinessunitList = function (sYm, eYm, pageIndex, pageSize, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverDataForTable?" + "sYm=" + sYm + "&eYm=" + eYm + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&orderStr=percent", unitids);
        };

        //按省区/地区不分指标-合计
        this.GetBusinessunitTotal = function (sYm, eYm, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverTotal?" + "sYm=" + sYm + "&eYm=" + eYm, unitids);
        };

        //按省区/地区按金额-达成率排名
        this.GetBusinessunitPercentEchartByAmount = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverChartData?" + "sYm=" + sYm + "&eYm=" + eYm + "&depType=ToTal_AVG" + "&diyCategoryId=" + diyCategoryId, unitids);
        };

        //按省区/地区按金额-达成额排名
        this.GetBusinessunitDoneEchartByAmount = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverChartData?" + "sYm=" + sYm + "&eYm=" + eYm + "&depType=ToTal_All" + "&diyCategoryId=" + diyCategoryId, unitids);
        };

        //按省区/地区按金额-达成列表
        this.GetBusinessunitListByAmount = function (sYm, eYm, diyCategoryId, pageIndex, pageSize, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverDataForTable?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&orderStr=percent", unitids);
        };

        //按省区/地区按金额-合计
        this.GetBusinessunitTotalByAmount = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverTotal?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId, unitids);
        };

        //按省区/地区按数量-达成率排名
        this.GetBusinessunitPercentEchartByQty = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverDataForTableByQty?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId + "&pageIndex=1" + "&pageSize=10" + "&orderStr=percent", unitids);
        };

        //按省区/地区按数量-达成额排名
        this.GetBusinessunitDoneEchartByQty = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverDataForTableByQty?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId + "&pageIndex=1" + "&pageSize=10" + "&orderStr=qty", unitids);
        };

        //按省区/地区按数量-达成列表
        this.GetBusinessunitListByQty = function (sYm, eYm, diyCategoryId, pageIndex, pageSize, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverDataForTableByQty?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&orderStr=percent", unitids);
        };

        //按省区/地区按数量-合计
        this.GetBusinessunitTotalByQty = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverTotalByQty?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId, unitids);
        };

        //按代表不分指标-达成率排名
        this.GetOwnerPercentEchart = function (sYm, eYm, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByOwnerChartData?sYm=" + sYm + "&eYm=" + eYm + "&depType=ToTal_AVG", unitids);
        };

        //按代表不分指标-达成额排名
        this.GetOwnerDoneEchart = function (sYm, eYm, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByOwnerChartData?sYm=" + sYm + "&eYm=" + eYm + "&depType=ToTal_All", unitids);
        };

        //按代表不分指标-达成列表
        this.GetOwnerList = function (sYm, eYm, pageIndex, pageSize, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByOwnerDataForTable?sYm=" + sYm + "&eYm=" + eYm + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&orderStr=percent", unitids);
        };

        //按代表不分指标-合计
        this.GetOwnerTotal = function (sYm, eYm, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByOwnerTotal?sYm=" + sYm + "&eYm=" + eYm, unitids);
        };

        //按代表按金额-达成率排名
        this.GetOwnerPercentEchartByAmount = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByOwnerChartData?sYm=" + sYm + "&eYm=" + eYm + "&depType=ToTal_AVG" + "&diyCategoryId=" + diyCategoryId, unitids);
        };

        //按代表按金额-达成额排名
        this.GetOwnerDoneEchartByAmount = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByOwnerChartData?sYm=" + sYm + "&eYm=" + eYm + "&depType=ToTal_All" + "&diyCategoryId=" + diyCategoryId, unitids);
        };

        //按代表按金额-达成列表
        this.GetOwnerListByAmount = function (sYm, eYm, diyCategoryId, pageIndex, pageSize, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByOwnerDataForTable?sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&orderStr=percent", unitids);
        };

        //按代表按金额-合计
        this.GetOwnerTotalByAmount = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByOwnerTotal?sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId, unitids);
        };

        //按代表按数量-达成率排名
        this.GetOwnerPercentEchartByQty = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByOwnerDataForTableByQty?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId + "&pageIndex=1" + "&pageSize=10" + "&orderStr=percent", unitids);
        };

        //按代表按数量-达成额排名
        this.GetOwnerDoneEchartByQty = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByOwnerDataForTableByQty?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId + "&pageIndex=1" + "&pageSize=10" + "&orderStr=qty", unitids);
        };

        //按代表按数量-达成列表
        this.GetOwnerListByQty = function (sYm, eYm, diyCategoryId, pageIndex, pageSize, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByOwnerDataForTableByQty?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&orderStr=percent", unitids);
        };

        //按代表按数量-合计
        this.GetOwnerTotalByQty = function (sYm, eYm, diyCategoryId, unitids) {
            return rt.post("api/BusinessCirculateVarDeliver/GetBusinessCirculateVarDeliverByOwnerTotalByQty?" + "sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + diyCategoryId, unitids);
        };
    }]);
    angular.module('xrmApp').controller("BusinessCirculateVarDeliverListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'DeliverService', BusinessCirculateVarDeliverListController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016/5/5
 说明     : 纯销指标达成
 *********************************************************/
(function () {
    'use strict';

    function BusinessEntiretyReturnMoneyListController($scope, $q, rt) {
        function init() {
            $scope.vm = {};
            //            $scope.vm.productList =[];
            //            $scope.vm.productSelected = null;
            $scope.vm.data = [];
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.search = _search;
            _getTops();
        }
        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = 10;
        }
        function _search() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                rt.errorMessage("请选择开始年月");
                return false;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                rt.errorMessage("请选择结束年月");
                return false;
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                rt.errorMessage("只可查询同一年的数据");
                return false;
            }

            if (rt.isNull($scope.vm.topsSelected)) {
                rt.errorMessage("请选择查询的Top数");
                return false;
            }

            var waiting = rt.showLoading2();
            if (rt.isNull($scope.vm.unitSelected) || rt.isNullOrWhiteSpace($scope.vm.unitSelected.Id)) {
                var url = 'api/BusinessEntiretyReturnMoney/GetBusinessEntiretyReturnMoneyData?eYm=' + $scope.vm.eYm + "&sYm=" + $scope.vm.sYm + "&bigdept=" + "" + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize;
                rt.get(url).then(function (resp) {
                    $scope.vm.data = resp.data.DataList;
                    $scope.vm.recordCount = resp.data.TotalRecords;
                    _show();
                    waiting.close();
                }, function () {
                    waiting.close();
                });
            } else {
                var url = 'api/BusinessEntiretyReturnMoney/GetBusinessEntiretyReturnMoneyData?eYm=' + $scope.vm.eYm + "&sYm=" + $scope.vm.sYm + "&bigdept=" + $scope.vm.unitSelected.Name + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize;
                rt.get(url).then(function (resp) {
                    $scope.vm.data = resp.data.DataList;
                    $scope.vm.recordCount = resp.data.TotalRecords;
                    _show();
                    waiting.close();
                }, function () {
                    waiting.close();
                });
            }
        }
        //展示图表数据
        function _show() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");

            var echartsDataValue = [];
            var echartsDataName = [];
            if ($scope.vm.topsSelected < $scope.vm.data.length) {
                for (var i = 0; i < $scope.vm.topsSelected; i++) {
                    echartsDataValue.push($scope.vm.data[i].yearPercent);
                    echartsDataName.push($scope.vm.data[i].OwnerIdName);
                }
            } else {
                for (var i = 0; i < $scope.vm.data.length; i++) {
                    echartsDataValue.push($scope.vm.data[i].yearPercent);
                    echartsDataName.push($scope.vm.data[i].OwnerIdName);
                }
            }
            console.log(echartsDataValue);
            var length1 = echartsDataValue.length - 1;
            console.log(length1);
            for (var i = 0; i < echartsDataValue.length / 2; i++) {
                var temp = 0;
                temp = echartsDataValue[i];
                echartsDataValue[i] = echartsDataValue[length1 - i];
                echartsDataValue[length1 - i] = temp;
                temp = echartsDataName[i];
                echartsDataName[i] = echartsDataName[length1 - i];
                echartsDataName[length1 - i] = temp;
            }
            console.log(echartsDataValue);
            var option = {
                title: {
                    text: ''
                },
                tooltip: {
                    trigger: 'axis'
                },
                legend: {
                    data: ['累计达成率（%）']
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01]
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName
                }],
                series: [{
                    name: '累计达成率',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                formatter: "{c}%"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.setOption(option);
        }
        init();
    }
    angular.module('xrmApp').controller("BusinessEntiretyReturnMoneyListController", ['$scope', '$q', 'rt', BusinessEntiretyReturnMoneyListController]);
})();
"use strict";

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/5/3
 *说明：商业psi
 *************************************************/
(function () {
    'use strict';

    function PsiListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "prodIds", Value: $scope.vm.pids });
            _that.searchList.push({ Type: 1, Key: "accountIds", Value: $scope.vm.accids });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: $scope.vm.unitids });
            _that.searchList.push({ Type: 1, Key: "accLevel", Value: $scope.vm.accLevelSelected.value });
            _that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.accList = [];
            $scope.vm.accSelected = null;
            $scope.vm.productList = [];
            $scope.vm.productSelected = null;
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = { id: '' };
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = null;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.search = _search;
            $scope.vm.accids = "";
            $scope.vm.pids = "";
            $scope.vm.unitids = ""; //用','分割的
            $scope.vm.paramUnitids = ""; //用逗号分隔的
            $scope.vm.accLevelSelected = { Name: '', Value: '' };
            _getAllBuid();
            _initYmSelected();
            _loadPicklist();
        }
        function _initYmSelected() {
            $scope.vm.sYm = moment().format('YYYY-MM');
        }
        //条件检查
        function _checkOption() {
            //组合条件
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请填写年月";
            }
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                return "请选择事业部";
            }
            if (rt.isNull($scope.vm.accLevelSelected) || rt.isNull($scope.vm.accLevelSelected.Value)) {
                return "请选择商业级别";
            }
            $scope.vm.unitids = _CaculateUnitIds();
            $scope.vm.pids = _CaculatePids();
            $scope.vm.accids = _CaculateAccids();
            return "";
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {

            if (oldValue != newValue) {
                //获取业务线/大区
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    $scope.vm.bigDepList = resp.DataList;

                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
                //获取事业部下的所有药品
                rt.queryData("Product.GetProductByBuild", {
                    '@queryValue': '',
                    '@buildId': $scope.vm.buidSelected.id
                }, function (resp) {
                    $scope.vm.productList = resp.DataList;
                    $scope.vm.productSelected = null;
                }, function (error) {
                    $scope.vm.productList = [];
                    $scope.vm.productSelected = null;
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    $scope.vm.businessUnitList = resp.DataList;
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        //搜索psi数据
        function _search() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return;
            }
            var waiting = rt.showLoading2();
            var url = 'api/AccountPsi/GetAccountPsiData?sYm=' + $scope.vm.sYm + "&prodIds=" + $scope.vm.pids + "&accountIds=" + $scope.vm.accids + "&accLevel=" + $scope.vm.accLevelSelected.Value + "&bigUnitId=" + $scope.vm.bigDepSelected.id + "&unitIds=" + $scope.vm.unitids + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize + "&buid=" + $scope.vm.buidSelected.id;
            rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        };
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 80);
            }, 0);
        }
        //计算省区/地区的id集合
        function _CaculateUnitIds() {
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                return unitmap.join("','");
            }
            return "";
        }
        //链接省区/地区id集合 不带''间隔的
        function _JoinUnitIds() {
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                return unitmap.join(",");
            }
            return "";
        }
        //计算产品id集合
        function _CaculatePids() {
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.id;
                });
                return pmap.join("','");
            }
            return "";
        }
        //计算客户id集合
        function _CaculateAccids() {
            if (!rt.isNull($scope.vm.accSelected)) {
                var accmap = $scope.vm.accSelected.map(function (item) {
                    return item.Id;
                });
                return accmap.join("','");
            }
            return "";
        }
        //业务大区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            var unitids = _CaculateUnitIds();
            if (!rt.isNullOrWhiteSpace(unitids)) {
                return;
            }
            if (newValue != oldValue) {
                $scope.vm.accList.length = 0;
                $scope.vm.paramUnitids = _JoinUnitIds();
            }
        });
        //计算省区的参数值
        $scope.vm.ClickBusiness = function () {
            $scope.vm.accList.length = 0;
            $scope.vm.paramUnitids = _JoinUnitIds();
        };
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }
        //加载选项集
        function _loadPicklist() {
            myService.getPickList().then(function (resp) {
                $scope.vm.picklist = resp.data;
                if (!rt.isNull($scope.vm.picklist.acc_level) && $scope.vm.picklist.acc_level.length > 0) {
                    $scope.vm.accLevelSelected = $scope.vm.picklist.acc_level[0];
                }
            });
        }
        init();
    }
    angular.module('xrmApp').service('PsiService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'AccountPsi';
        // @@ 选项集
        this.picklists = ['acc_level'];
    }]).controller("PsiListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'PsiService', PsiListController]);
})();
"use strict";

/*************************************************
 * Copyright (c) 2016 苏州瑞泰信息技术有限公司 All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *创建人： Berry Ding
 *创建时间：2017/5/19
 *描述：公用的Excel导入组件 - 无模板文件下载
 *************************************************/

(function () {
    'use strict';

    angular.module("xrmApp").controller("CalDrugFlowAssignmentImportController", ['$scope', 'rt', CalDrugFlowAssignmentImportController]);
    function CalDrugFlowAssignmentImportController($scope, rt) {
        init();

        function init() {
            $scope.importStatus = "";
            $scope.errorFileId = "";
            $scope.selectedFiles = null;
            $scope.selectedFileName = null;

            $scope.import = _import;
            $scope.downloadErrorFile = _downloadErrorFile;
            $scope.selectFile = _selectFile;
        }

        function _selectFile(files) {
            if (files && files.length && files.length > 0) {
                $scope.selectedFiles = files;
                $scope.selectedFileName = files[0].name;
            }
        }
        function _importExcel(fileid) {
            var url = "api/DataService/ImportExcel";
            var data = $scope.$parent.vm.importHeader;
            data.FileId = fileid;
            return rt.post(url, data);
        }

        //下载导入错误日志文件
        function _downloadErrorFile() {
            rt.downloadFile("temp", encodeURIComponent($scope.errorFileId));
        }

        function _import() {
            $scope.importStatus = "正在导入中...";
            $scope.errorFileId = "";
            var waiting = rt.showWaiting();
            rt.uploadFile($scope.selectedFiles, "temp", rt.newGuid(), false, function (data) {
                _importExcel(data).then(function (resp) {
                    if (rt.isNullOrWhiteSpace(resp.data) || resp.data == "") {
                        $scope.importStatus = " 成功。";
                        $scope.$emit('rt-reload');
                    } else {
                        $scope.importStatus = " 失败。";
                        $scope.errorFileId = resp.data;
                    }
                }, function (resp) {
                    $scope.importStatus = resp.data;
                }).finally(function () {
                    waiting.close();
                });
            }, function (msg) {
                $scope.importStatus = " 失败。" + msg;
                rt.errorMessage(msg);
                waiting.close();
            });
        }
    }
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-12-13
 说明     : 市场活动出勤统计
 ********************************************************/
(function () {
    'use strict';

    function campaignjoinreportController($scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: $scope.vm.bigDepSelected.id });
            var unitids = _CalculateUnitids();
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "actionStatus", Value: $scope.vm.actionStatusSelected.Value });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.sYm = moment().format('YYYY-MM-01');
            $scope.vm.eYm = moment($scope.vm.eYm).format('YYYY-MM-DD');

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                var msg = _checkOption();
                if (!rt.isNullOrWhiteSpace(msg)) {
                    rt.errorMessage(msg);
                    return false;
                }
                var unitids = _CalculateUnitids();
                var bigUnitId = $scope.vm.bigDepSelected.id;
                var buId = $scope.vm.buidSelected.id;
                _getReportData(buId, bigUnitId, unitids);
            };

            _getAllBuid();
            _getActionStatus();
        }

        //条件检查
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "开始时间不能为空";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "结束时间不能为空";
            }
            if (moment($scope.vm.sYm) > moment($scope.vm.eYm)) {
                return "参数异常[开始日期必须小于等于结束日期.]";
            }
        }

        //获取业务线//大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            });
        }

        //获取市场活动状态
        function _getActionStatus() {
            var url = "api/SystemParam/GetSystemParamByCode?code=action_status";
            return rt.get(url).then(function (resp) {
                $scope.vm.actionStatus = resp.data;
                if (rt.isNull(resp.data) || resp.data.length > 4) {
                    $scope.vm.actionStatusSelected = resp.data[4]; //默认查询已经完成的活动
                }
            });
        }

        //获取市场活动出勤统计
        function _getReportData(buId, bigUnitId, unitids) {
            var waiting = rt.showLoading2();
            var url = 'api/CampaignJoinReport/GetCampaignJoinReport?sYm=' + encodeURIComponent($scope.vm.sYm) + '&eYm=' + encodeURIComponent($scope.vm.eYm) + '&actionStatus=' + encodeURIComponent($scope.vm.actionStatusSelected.Value) + '&buId=' + encodeURIComponent(buId) + '&bigDepId=' + encodeURIComponent(bigUnitId) + '&unitIds=' + encodeURIComponent(unitids) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join("','");
            }
            return unitids;
        }
    }

    angular.module('xrmApp').service('campaignjoinreportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'TerminalHeatReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("campaignjoinreportController", ['$scope', '$injector', 'rt', 'campaignjoinreportService', campaignjoinreportController]);
})();
"use strict";

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/3/2
 *描述：商业发货导入脚本
 *************************************************/
(function () {
    'use strict';

    function cashbackExcelImportController($scope, rt) {
        function init() {
            $scope.vm = {};
            $scope.vm.Data = [];
            $scope.vm.DataLeast = [];
            $scope.vm.import = _import;
        }
        $scope.selectedFiles = null;
        $scope.selectedFileName = null;
        $scope.fileselect = function (files) {
            if (files && files.length && files.length > 0) {
                $scope.selectedFiles = files;
                $scope.selectedFileName = files[0].name;
            }
        };
        $scope.excelinsert = function (fileId) {
            var url = "api/cashback/InsertFromExcel?fileId=" + fileId;
            url += "&importDate=" + $scope.vm.importDate;
            return rt.get(url);
        };
        $scope.downloadfile = function () {
            rt.downloadFile("cashback", "a6aece0f-0885-448b-a7ac-5ac04c5d9a1f"); //下载模板
        };
        function _import() {
            if (rt.isNullOrWhiteSpace($scope.vm.importDate)) {
                rt.errorMessage("年月不能为空。");
                return;
            }
            var waiting = rt.showWaiting();
            rt.uploadFile($scope.selectedFiles, "cashback", rt.newGuid(), false, function (data) {
                $scope.excelinsert(data).then(function () {
                    rt.successMessage("导入成功。");
                    $scope.$emit('rt-reload');
                    waiting.close();
                }, function () {
                    waiting.close();
                });
            });
        }
        init();
    }
    angular.module("xrmApp").controller("cashbackExcelImportController", ['$scope', 'rt', cashbackExcelImportController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : JerryWu
 创建时间 : 2018-03-14
 说明     : 增加标签页
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller("addTagController", ['$injector', '$stateParams', '$scope', '$compile', '$state', 'rt', addTagController]);

    function addTagController($injector, $stateParams, $scope, $compile, $state, rt) {

        _init();

        function _init() {
            $scope.vm = {};
            $scope.vm.data = {};

            $scope.vm.save = function () {
                $scope.vm.errorMessage = checkOption();
                if (!rt.isNullOrWhiteSpace($scope.vm.errorMessage)) {
                    return false;
                } else {
                    _save();
                }
            };
        }

        //检查条件
        function checkOption() {
            if (rt.isNull($scope.vm.data.tagName) || rt.isNullOrWhiteSpace($scope.vm.data.tagValue)) {
                return "请选择标签并输入内容";
            }
            if ($scope.vm.data.tagValue.indexOf(':') >= 0 || $scope.vm.data.tagValue.indexOf('：') >= 0 || $scope.vm.data.tagValue.indexOf(';') >= 0 || $scope.vm.data.tagValue.indexOf('；') >= 0) {
                return "内容不能有特殊字符";
            }
            return "";
        }

        function _save() {
            var tag = { Name: $scope.vm.data.tagName.Name, Value: $scope.vm.data.tagValue, Type: 'addTag' };
            $scope.$emit('to-parent', tag);
            $scope.$parent.vm.form.hideForm();
        }

        $scope.$watch('vm.data.tagName.Id', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                $scope.vm.data.tagValue = null;
                return;
            }
        });
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-10-18
 说明     : 运营情况报表
 ********************************************************/
(function () {
    'use strict';

    function csmReportLoginController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                var buid = '';
            } else {
                buid = $scope.vm.buidSelected.id;
            }
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                var bigDep = '';
            } else {
                bigDep = $scope.vm.bigDepSelected.id;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "clientid", Value: $scope.vm.client.csm_customerId });
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.startYM });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.endYM });
            _that.searchList.push({ Type: 1, Key: "buid", Value: buid });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: bigDep });
            var unitids = _CalculateUnitids();
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            var d = new Date();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.isShow = 'login';
            $scope.vm.isShow2 = 'login';
            $scope.vm.showcount = 1;
            $scope.vm.windowWh = document.body.scrollWidth;
            $scope.chartWidth = $scope.vm.windowWh / 2 - 50;
            $scope.vm.startYM = moment().add('days', -(d.getDay() === 0 ? 7 : d.getDay()) + 1).format('YYYY-MM-DD');
            $scope.vm.endYM = moment($scope.vm.endYM).format('YYYY-MM-DD');
            $scope.vm.totalPeopleQty = 0; //设置总人数初始值
            _getClient();
            $scope.vm.search = function () {
                if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    var buid = '';
                } else {
                    buid = $scope.vm.buidSelected.id;
                }

                if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                    var bigDep = '';
                } else {
                    bigDep = $scope.vm.bigDepSelected.id;
                }
                var unitids = '';
                if (!rt.isNull($scope.vm.businessUnitSelected)) {
                    var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                        return item.id;
                    });
                    unitids = unitmap.join("','");
                }
                if ($scope.vm.isShow == 'login' && $scope.vm.isShow2 == 'unlogin') {
                    _getUnLoginData(buid, bigDep, unitids).then(null, function (message) {
                        rt.errorMessage(message);
                    });
                }
                if ($scope.vm.isShow == 'login' && $scope.vm.isShow2 == 'login') {
                    _getReportData(buid, bigDep, unitids).then(null, function (message) {
                        rt.errorMessage(message);
                    });
                }
                if ($scope.vm.isShow == 'visit') {
                    _getReportVisitData(buid, bigDep, unitids).then(null, function (message) {
                        rt.errorMessage(message);
                    });
                }
            };

            //查询按钮
            $scope.vm.showReportButton = function () {
                if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    var buid = '';
                } else {
                    buid = $scope.vm.buidSelected.id;
                }

                if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                    var bigDep = '';
                } else {
                    bigDep = $scope.vm.bigDepSelected.id;
                }
                var unitids = '';
                if (!rt.isNull($scope.vm.businessUnitSelected)) {
                    var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                        return item.id;
                    });
                    unitids = unitmap.join("','");
                }
                _getUnLoginData(buid, bigDep, unitids).then(null, function (message) {
                    rt.errorMessage(message);
                });
                _getReportOperateRank(buid, bigDep, unitids).then(null, function (message) {
                    rt.errorMessage(message);
                });
                _getReportOperateData(buid, bigDep, unitids).then(null, function (message) {
                    rt.errorMessage(message);
                });

                _GetTotalPeopleQty(buid, bigDep, unitids).then(null, function (message) {
                    rt.errorMessage(message);
                });

                _ReportLoginCount(buid, bigDep, unitids).then(null, function (message) {
                    rt.errorMessage(message);
                });
                _getReportData(buid, bigDep, unitids).then(null, function (message) {
                    rt.errorMessage(message);
                });
                _ReportVisitCount(buid, bigDep, unitids).then(null, function (message) {
                    rt.errorMessage(message);
                });
                _getReportVisitData(buid, bigDep, unitids).then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
        }

        //条件检查
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.startYM)) {
                return "开始时间不能为空";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endYM)) {
                return "结束时间不能为空";
            }
            if (_CalculateDays($scope.vm.startYM, $scope.vm.endYM) < 0) {
                return "参数异常[开始日期必须小于等于结束日期.]";
            }
        }

        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 160);
            }, 0);
        }

        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = new Date(startDate);
            var eArr = new Date(endDate);
            var NMon = 0;
            var MCount = (eArr - sArr) / (24 * 3600 * 1000);
            $scope.vm.TbHeCosNum += (MCount + 1) * 2;
            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = moment(startDate).add('days', i).format('YYYY-MM-DD');
                    $scope.vm.MonDataList[i] = NMon;
                }
                $scope.vm.MonDataList[MCount] = moment(startDate).add('days', MCount).format('YYYY-MM-DD');
            } else {
                $scope.vm.MonDataList[0] = moment(startDate).format('YYYY-MM-DD');
            }
        }

        //切换tab
        $scope.selectTab = function (id) {
            $scope.vm.index = 1;
            switch (id) {
                case 'tab1':
                    $scope.vm.isShow = 'login';
                    break;
                case 'tab2':
                    $scope.vm.isShow = 'visit';
                    break;
                case 'tab3':
                    $scope.vm.isShow = 'operate';
                    break;
                case 'tab4':
                    $scope.vm.isShow2 = 'login';
                    break;
                case 'tab5':
                    $scope.vm.isShow2 = 'unlogin';
                    break;
            }
        };
        $scope.showDetail = function () {
            $scope.vm.isShow = true;
        };
        $scope.showChart = function () {
            $scope.vm.isShow = false;
        };

        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && newValue != null) {
                var waiting = rt.showLoading2();
                var url = 'api/CsmReportLogin/GetBigdepart?buid=' + $scope.vm.buidSelected.id;
                return rt.get(url).then(function (resp) {
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.bigDepList = resp.data;
                    waiting.close();
                }, function () {
                    waiting.close();
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && newValue != null) {
                var waiting = rt.showLoading2();
                var url = 'api/CsmReportLogin/GetBusinessUnit?bigdept=' + $scope.vm.bigDepSelected.id;
                return rt.get(url).then(function (resp) {
                    var data = resp.data;
                    $scope.vm.businessUnitList = [];
                    $scope.vm.businessUnitSelected = [];
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                    waiting.close();
                }, function () {
                    waiting.close();
                });
            }
        });
        //获取客户列表中数据
        function _getClient() {
            var waiting = rt.showLoading2();
            var url = 'api/CsmReportLogin/GetClient';
            return rt.get(url).then(function (resp) {
                $scope.vm.clientList = resp.data;
                $scope.vm.client = $scope.vm.clientList[0];
                _getAllBuid($scope.vm.client.csm_customerId);
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        $scope.$watch('vm.client.csm_customerId', function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNull(oldValue)) {
                _getAllBuid($scope.vm.client.csm_customerId);
                $scope.vm.bigDepSelected = null;
                $scope.vm.businessUnitSelected = null;
            }
        });
        //获取事业部
        function _getAllBuid(clientid) {
            var waiting = rt.showLoading2();
            var url = 'api/CsmReportLogin/GetBuid?csm_customerId=' + clientid;
            return rt.get(url).then(function (resp) {
                $scope.vm.buidSelected = null;
                $scope.vm.buidList = resp.data;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        //获取当前环境的总人数
        function _GetTotalPeopleQty(buid, bigDep, unitids) {
            var waiting = rt.showLoading2();
            var TabDataUrl = 'api/CsmReportLogin/GetTotalPeopleQty?buid=' + encodeURIComponent(buid) + '&bigdept=' + encodeURIComponent(bigDep) + '&businessunitid=' + encodeURIComponent(unitids) + '&csm_customerId=' + $scope.vm.client.csm_customerId;
            return rt.get(TabDataUrl).then(function (resp) {
                $scope.vm.totalPeopleQty = resp.data;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        function _ReportLoginCount(buid, bigDep, unitids) {
            //通过接口获取图数据
            var waiting = rt.showLoading2();
            var TabDataUrl = 'api/CsmReportLogin/GetLoginCount?sYm=' + encodeURIComponent($scope.vm.startYM) + '&eYm=' + encodeURIComponent($scope.vm.endYM) + "&buid=" + encodeURIComponent(buid) + '&bigdept=' + encodeURIComponent(bigDep) + '&businessunitid=' + encodeURIComponent(unitids) + '&csm_customerId=' + $scope.vm.client.csm_customerId;
            return rt.get(TabDataUrl).then(function (resp) {
                $scope.vm.LoginCountData = resp.data;
                //if ($scope.vm.LoginCountData.length > 0) {
                _show();
                _showqty();
                //}
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        function _getReportOperateRank(buid, bigDep, unitids) {
            var waiting = rt.showLoading2();
            var TabDataUrl = 'api/CsmReportOperateAnnal/GetOperateAnnalRank?sYm=' + encodeURIComponent($scope.vm.startYM) + '&eYm=' + encodeURIComponent($scope.vm.endYM) + "&buid=" + encodeURIComponent(buid) + '&bigdept=' + encodeURIComponent(bigDep) + '&businessunitid=' + encodeURIComponent(unitids) + '&csm_customerId=' + $scope.vm.client.csm_customerId;
            return rt.get(TabDataUrl).then(function (resp) {
                $scope.vm.operateRankData = resp.data;
                // if ($scope.vm.operateRankData.length > 0) {
                _showOperateDesc();
                _showOperateAsc();
                // }
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        function _getReportOperateData(buid, bigDep, unitids) {
            var waiting = rt.showLoading2();
            var TabDataUrl = 'api/CsmReportOperateAnnal/GetOperateAnnalGrid?sYm=' + encodeURIComponent($scope.vm.startYM) + '&eYm=' + encodeURIComponent($scope.vm.endYM) + "&buid=" + encodeURIComponent(buid) + '&bigdept=' + encodeURIComponent(bigDep) + '&businessunitid=' + encodeURIComponent(unitids) + '&csm_customerId=' + $scope.vm.client.csm_customerId;
            return rt.get(TabDataUrl).then(function (resp) {

                if (!rt.isNull(resp.data.DataList) && resp.data.DataList.length > 0) {
                    $scope.vm.RepoteData2 = resp.data.DataList;
                    $scope.vm.textXList = $scope.vm.RepoteData2[0].DateBody;
                    $scope.vm.TbMessText2 = $scope.vm.RepoteData2[0].textBody;
                } else {
                    $scope.vm.RepoteData2 = [];
                }
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        function _getReportData(buid, bigDep, unitids) {
            var waiting = rt.showLoading2();
            var url = 'api/CsmReportLogin/GetLoginDetail?sYm=' + $scope.vm.startYM + '&eYm=' + $scope.vm.endYM + "&buid=" + encodeURIComponent(buid) + '&bigdept=' + encodeURIComponent(bigDep) + '&businessunitid=' + encodeURIComponent(unitids) + '&csm_customerId=' + $scope.vm.client.csm_customerId + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportLoginData = resp.data.DataList;
                $scope.vm.recordLoginCount = resp.data.TotalRecords;
                _MonDataList($scope.vm.startYM, $scope.vm.endYM);
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }

        function _getUnLoginData(buid, bigDep, unitids) {
            var waiting = rt.showLoading2();
            var url = 'api/CsmReportUserinfo/GetUserUnLogin?sYm=' + $scope.vm.startYM + '&eYm=' + $scope.vm.endYM + "&buid=" + encodeURIComponent(buid) + '&bigdept=' + encodeURIComponent(bigDep) + '&businessunitid=' + encodeURIComponent(unitids) + '&csm_customerId=' + $scope.vm.client.csm_customerId + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportUnloginData = resp.data.DataList;
                $scope.vm.recordUnloginCount = resp.data.TotalRecords;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        function _ReportVisitCount(buid, bigDep, unitids) {
            //获取拜访人数，拜访次数图表
            var waiting = rt.showLoading2();
            var TabDataUrl = 'api/CsmReportLogin/GetVisitCount?sYm=' + encodeURIComponent($scope.vm.startYM) + '&eYm=' + encodeURIComponent($scope.vm.endYM) + "&buid=" + encodeURIComponent(buid) + '&bigdept=' + encodeURIComponent(bigDep) + '&businessunitid=' + encodeURIComponent(unitids) + '&csm_customerId=' + encodeURIComponent($scope.vm.client.csm_customerId);
            return rt.get(TabDataUrl).then(function (resp) {
                $scope.vm.VisitCountData = resp.data;
                //if ($scope.vm.VisitCountData.length > 0) {
                _showVisit1();
                _showVisit2();
                //}
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        function _getReportVisitData(buid, bigDep, unitids) {
            var waiting = rt.showLoading2();
            var url = 'api/CsmReportLogin/GetVisitDetail?sYm=' + $scope.vm.startYM + '&eYm=' + $scope.vm.endYM + "&buid=" + encodeURIComponent(buid) + '&bigdept=' + encodeURIComponent(bigDep) + '&businessunitid=' + encodeURIComponent(unitids) + '&csm_customerId=' + $scope.vm.client.csm_customerId + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportvisitData = resp.data.DataList;
                $scope.vm.recordVisitCount = resp.data.TotalRecords;
                _MonDataList($scope.vm.startYM, $scope.vm.endYM);
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }

        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join("','");
            }
            return unitids;
        }

        //登陆人数
        function _show() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");

            var echartYName = [];
            var echartsData = [];
            var getData = $scope.vm.LoginCountData;
            if (getData != null && getData.length > 0) {
                for (var i = 0; i < getData.length; i++) {
                    echartYName.push(getData[i].logincount);
                    echartsData.push(getData[i].logindate);
                }
            }

            var option = {
                title: {
                    text: '登录人数趋势（总人数：' + $scope.vm.totalPeopleQty + '）'
                },
                tooltip: {
                    trigger: 'axis'
                },
                toolbox: {
                    show: true,
                    feature: {
                        dataZoom: {
                            yAxisIndex: 'none'
                        },
                        dataView: { readOnly: false },
                        magicType: { type: ['line', 'bar'] },
                        restore: {},
                        saveAsImage: {}
                    }
                },
                xAxis: {
                    type: 'category',
                    boundaryGap: false,
                    data: echartsData
                },
                yAxis: {
                    type: 'value'
                },
                series: [{
                    name: '登录人数',
                    type: 'line',
                    data: echartYName,
                    markPoint: {
                        data: [{ type: 'max', name: '最大值' }, { type: 'min', name: '最小值' }]
                    },
                    markLine: {
                        data: [{ type: 'average', name: '平均值' }]
                    }
                }]
            };
            myChart.setOption(option);
        }

        function _showqty() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            var echartYName = [];
            var echartsData = [];
            var getData = $scope.vm.LoginCountData;
            if (getData != null && getData.length > 0) {
                for (var i = 0; i < getData.length; i++) {
                    echartYName.push(getData[i].loginqty);
                    echartsData.push(getData[i].logindate);
                }
            }

            var option = {
                title: {
                    text: '登录次数趋势'
                },
                tooltip: {
                    trigger: 'axis'
                },
                toolbox: {
                    show: true,
                    feature: {
                        dataZoom: {
                            yAxisIndex: 'none'
                        },
                        dataView: { readOnly: false },
                        magicType: { type: ['line', 'bar'] },
                        restore: {},
                        saveAsImage: {}
                    }
                },
                xAxis: {
                    type: 'category',
                    boundaryGap: false,
                    data: echartsData
                },
                yAxis: {
                    type: 'value'
                },
                series: [{
                    name: '登录次数',
                    type: 'line',
                    data: echartYName,
                    markPoint: {
                        data: [{ type: 'max', name: '最大值' }, { type: 'min', name: '最小值' }]
                    },
                    markLine: {
                        data: [{ type: 'average', name: '平均值' }]
                    }
                }]
            };
            myChart.setOption(option);
        }

        //拜访人数
        function _showVisit1() {

            var myChart = echarts.init(document.getElementById("reportVisitPeopleQty"), "shine");

            var echartYVisitPeopleQtyName = [];
            var echartsVisitPeopleQtyData = [];
            var getVisitPeopleQtyData = $scope.vm.VisitCountData;
            if (getVisitPeopleQtyData != null && getVisitPeopleQtyData.length > 0) {
                for (var i = 0; i < getVisitPeopleQtyData.length; i++) {
                    echartYVisitPeopleQtyName.push(getVisitPeopleQtyData[i].peopleQty);
                    echartsVisitPeopleQtyData.push(getVisitPeopleQtyData[i].visitdate);
                }
            }

            var option = {
                title: {
                    text: '拜访人数趋势（总人数：' + $scope.vm.totalPeopleQty + '）'
                },
                tooltip: {
                    trigger: 'axis'
                },
                toolbox: {
                    show: true,
                    feature: {
                        dataZoom: {
                            yAxisIndex: 'none'
                        },
                        dataView: { readOnly: false },
                        magicType: { type: ['line', 'bar'] },
                        restore: {},
                        saveAsImage: {}
                    }
                },
                xAxis: {
                    type: 'category',
                    boundaryGap: false,
                    data: echartsVisitPeopleQtyData
                },
                yAxis: {
                    type: 'value'
                },
                series: [{
                    name: '拜访人数',
                    type: 'line',
                    data: echartYVisitPeopleQtyName,
                    markPoint: {
                        data: [{ type: 'max', name: '最大值' }, { type: 'min', name: '最小值' }]
                    },
                    markLine: {
                        data: [{ type: 'average', name: '平均值' }]
                    }
                }]
            };
            myChart.setOption(option);
        }

        //拜访次数
        function _showVisit2() {

            var myChart = echarts.init(document.getElementById("reportVisitTimeQty"), "shine");
            var echartYVisitTimeQtyName = [];
            var echartsVisitTimeQtyData = [];
            var getVisitTimeQtyData = $scope.vm.VisitCountData;
            if (getVisitTimeQtyData != null && getVisitTimeQtyData.length > 0) {
                for (var i = 0; i < getVisitTimeQtyData.length; i++) {
                    echartYVisitTimeQtyName.push(getVisitTimeQtyData[i].visitQty);
                    echartsVisitTimeQtyData.push(getVisitTimeQtyData[i].visitdate);
                }
            }

            var option = {
                title: {
                    text: '拜访次数趋势'
                },
                tooltip: {
                    trigger: 'axis'
                },
                toolbox: {
                    show: true,
                    feature: {
                        dataZoom: {
                            yAxisIndex: 'none'
                        },
                        dataView: { readOnly: false },
                        magicType: { type: ['line', 'bar'] },
                        restore: {},
                        saveAsImage: {}
                    }
                },
                xAxis: {
                    type: 'category',
                    boundaryGap: false,
                    data: echartsVisitTimeQtyData
                },
                yAxis: {
                    type: 'value'
                },
                series: [{
                    name: '拜访次数',
                    type: 'line',
                    data: echartYVisitTimeQtyName,
                    markPoint: {
                        data: [{ type: 'max', name: '最大值' }, { type: 'min', name: '最小值' }]
                    },
                    markLine: {
                        data: [{ type: 'average', name: '平均值' }]
                    }
                }]
            };
            myChart.setOption(option);
        }

        function _showOperateDesc() {

            var myChart = echarts.init(document.getElementById("report3"), "shine");

            var echartYName = [];
            var echartsData = [];
            var getData = _.take($scope.vm.operateRankData, 10);
            if (getData != null && getData.length > 0) {
                for (var i = 0; i < getData.length; i++) {
                    echartYName.push(getData[i].operateCount);
                    echartsData.push(getData[i].TblMdlIdName);
                }
            }

            var option = {
                title: {
                    text: '功能使用最多的Top10'
                },
                color: ['#4194D5'],
                tooltip: {
                    trigger: 'axis'
                },
                grid: {
                    left: '3%',
                    right: '4%',
                    bottom: '3%',
                    containLabel: true
                },
                xAxis: [{
                    type: 'category',
                    data: echartsData,
                    splitLine: {
                        show: false
                    }
                }],
                yAxis: [{
                    type: 'value'
                }],
                series: [{
                    name: '使用次数',
                    type: 'bar',
                    data: echartYName
                }]
            };
            myChart.setOption(option);
        }

        function _showOperateAsc() {

            var myChart = echarts.init(document.getElementById("report4"), "shine");

            var echartYName = [];
            var echartsData = [];
            var getData = _.takeRight($scope.vm.operateRankData, 10).reverse();
            if (getData != null && getData.length > 0) {
                for (var i = 0; i < getData.length; i++) {
                    echartYName.push(getData[i].operateCount);
                    echartsData.push(getData[i].TblMdlIdName);
                }
            }

            var option = {
                title: {
                    text: '功能使用最少的Top10'
                },
                color: ['#4194D5'],
                tooltip: {
                    trigger: 'axis'
                },
                grid: {
                    left: '3%',
                    right: '4%',
                    bottom: '3%',
                    containLabel: true
                },
                xAxis: [{
                    type: 'category',
                    data: echartsData,
                    splitLine: {
                        show: false
                    }
                }],
                yAxis: [{
                    type: 'value'
                }],
                series: [{
                    name: '使用次数',
                    type: 'bar',
                    data: echartYName
                }]
            };
            myChart.setOption(option);
        }
    }

    angular.module('xrmApp').service('CsmReprtLoginService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'CsmReportLogin';
        // @@ 选项集
        this.picklists = [];
    }]).controller("csmReportLoginController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'CsmReprtLoginService', csmReportLoginController]);
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Joe Song
//* 创建时间 :2016-1-18
//* 说明     :Dashboard
//******************************************************************
// #endregion

(function () {
    'use strict';

    angular.module('xrmApp').controller("dashboardController", ['$scope', '$q', 'rt', '$compile', dashboardController]);

    function dashboardController($scope, $q, rt, $compile) {
        init();

        function init() {
            $scope.query = {};
            $scope.query.mapSelectedName = '北京';
            $scope.vm = {};
            $scope.vm.reportData1 = [];
            $scope.vm.reportData2 = [];
            $scope.vm.DataList = [];
            $scope.vm.DataLeast = [];
            $scope.vm.reportClientCount = {};
            $scope.vm.selectTimeTab = "MTD"; //当月tab
            $scope.selectTab = _selectTab;
            $scope.selectTimeTab = _selectTimeTab;
            $scope.showForm = _showForm;
            $scope.hideForm = _hideForm;
            $scope.refresh = _refresh;
            $scope.vm.lastmonth = moment().add(-1, 'months').format('YYYY-MM');
            _getTimes(); //当月当年时间类别
            _getAllProduct().then(_showReport);
            _getDataList(); //公告列表          
            _initSysConfig(); //生成默认的系统参数
            _loadDashboardData();
        }

        //获取echarts默认月份数据
        function _getechartsMonth() {
            $scope.vm.eMonth = moment($scope.vm.lastmonth).format('M');
            for (var i = 1; i <= $scope.vm.eMonth; i++) {
                $scope.vm.echartsMonth.push(i + '月');
                $scope.vm.echartshosdata.push(0);
                $scope.vm.echartsbasdata.push(0);
                $scope.vm.echartsterdata.push(0);
            }
        }
        function _showReport() {
            $scope.vm.accountaddpiereportData = [];
            $scope.vm.echartsPieData = [];
            $scope.vm.lossaccountnameData = [];
            $scope.vm.hoslossaccountData = [];
            $scope.vm.baslossaccountData = [];
            $scope.vm.terlossaccountData = [];
            $scope.vm.doneamountnameData = [];
            $scope.vm.doneamountData = [];
            $scope.vm.visitnameData = [];
            $scope.vm.visitData = [];
            $scope.vm.campaigntypenameData = [];
            $scope.vm.campaigncountData = [];
            $scope.vm.actionanysisnameData = [];
            $scope.vm.actionanysisData = [];
            $scope.vm.echartsMonth = [];
            $scope.vm.echartshosdata = []; //等级医院默认值
            $scope.vm.echartsbasdata = []; //基层医疗默认值
            $scope.vm.echartsterdata = []; //基层医疗默认值
            _getechartsMonth();

            //客户总体情况
            _getClientData();

            //全国销售达成分布（纯销）
            _getReportData2().then(_show7, function (message) {
                rt.errorMessage(message);
            });

            //客户增加饼图
            _getAccountAddPieReport().then(_showAccountAddPieReport, function (message) {
                rt.errorMessage(message);
            });

            //客户增加折线图
            _getAccountAddLineReport().then(_showAccountAddLineReport, function (message) {
                rt.errorMessage(message);
            });

            //客户流失饼图
            _getLossAccountPieReport().then(_showAccountLossPieReport, function (message) {
                rt.errorMessage(message);
            });

            //各地域客户流失情况
            _getLossAccountBarReport().then(_showAccountLossBarReport, function (message) {
                rt.errorMessage(message);
            });

            //销售指标总额/总量情况（饼图）
            _getPureVenditionPieReport().then(_showSalesAmountPieReport, function (message) {
                rt.errorMessage(message);
            }).then(_showSalesQtyPieReport, function (message) {
                rt.errorMessage(message);
            });

            //达成额排名（柱状图）
            _getDoneAmountBarReport().then(_showDoneAmontBarReport, function (message) {
                rt.errorMessage(message);
            });

            //达成额趋势（折线图）
            _getDoneAmountLineReport().then(_showSalesDoneLineReport, function (message) {
                rt.errorMessage(message);
            });

            //拜访分析（饼图）
            _getVisitPieReport().then(_showVisitPieReport, function (message) {
                rt.errorMessage(message);
            });

            //拜访次数各地域排名(柱状图)
            _getVisitBarReport().then(_showVisitQtyBarReport, function (message) {
                rt.errorMessage(message);
            });

            //市场活动分析（饼图）
            _getActionAnysisPieReport().then(_showActionAnysisPieReport, function (message) {
                rt.errorMessage(message);
            });

            //市场活动地域排名（柱状图）
            _getActionAnysisBarReport().then(_showaAtionRankBarReport, function (message) {
                rt.errorMessage(message);
            });
        };

        $(window).resize(function () {
            $scope.contentwidth = $(".content").width();
        });

        $scope.$watch("vm.lastmonth", function (newValue, oldValue) {
            if (oldValue != newValue) {
                _showReport();
            }
        });

        //按省份纯销排名 (地图）
        function _getReportData2() {
            var url = 'api/Dashboard/GetEntTermiSaleByProvMapData?Ym=' + $scope.vm.lastmonth;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData2 = resp.data;
            });
        }

        //获取客户新增（饼图）数据
        function _getAccountAddPieReport() {
            var url = 'api/Dashboard/GetDevelopedAccountPieData?Ym=' + $scope.vm.lastmonth;
            return rt.get(url).then(function (resp) {
                var getData = resp.data;
                for (var i = 0; i < getData.length; i++) {
                    $scope.vm.accountaddpiereportData.push(getData[i].toenttypename);
                    $scope.vm.echartsPieData.push({ name: getData[i].toenttypename, value: getData[i].accountcount });
                }
            });
        }

        //获取客户新增（折线图）数据
        function _getAccountAddLineReport() {
            var url = 'api/Dashboard/GetDevelopedAccountLineData?Ym=' + $scope.vm.lastmonth;
            return rt.get(url).then(function (resp) {
                var lineData = resp.data[0];
                if (lineData) {
                    $scope.vm.echartshosdevdata = lineData.Hos_Line_Data; //等级医院新增趋势
                    $scope.vm.echartsbasdevdata = lineData.Bas_Line_Data; //基层医疗新增额趋势
                    $scope.vm.echartsterdevdata = lineData.Ter_Line_Data; //零售门店新增趋势
                }
            });
        }

        //获取客户流失（饼图）数据
        function _getLossAccountPieReport() {
            var url = 'api/Dashboard/GetLossAccountPieData?Ym=' + $scope.vm.lastmonth;
            return rt.get(url).then(function (resp) {
                if (resp.data != null && resp.data.length > 0) {
                    $scope.vm.totalcount = resp.data[0].totalcount;
                    $scope.vm.losscount = resp.data[0].losscount;
                    $scope.vm.lossdata = Math.round($scope.vm.losscount * 100 / $scope.vm.totalcount);
                } else {
                    $scope.vm.totalcount = 0;
                    $scope.vm.losscount = 0;
                    $scope.vm.lossdata = 0;
                }
            });
        }

        //获取各地域客户流失情况数据
        function _getLossAccountBarReport() {
            var url = 'api/Dashboard/GetLossAccountBarData?Ym=' + $scope.vm.lastmonth;
            return rt.get(url).then(function (resp) {
                var getData = resp.data;
                for (var i = 0; i < getData.length; i++) {
                    $scope.vm.lossaccountnameData.push(getData[i].toprovinceidname);
                    $scope.vm.hoslossaccountData.push(getData[i].hoslossCount);
                    $scope.vm.baslossaccountData.push(getData[i].baslossCount);
                    $scope.vm.terlossaccountData.push(getData[i].terlossCount);
                }
            });
        }

        //获取销售指标总额/总量（饼图）数据
        function _getPureVenditionPieReport() {
            var url = 'api/Dashboard/GetPureVenditionPieData?Ym=' + $scope.vm.lastmonth;
            return rt.get(url).then(function (resp) {
                if (resp.data != null && resp.data.length > 0) {
                    $scope.vm.done_amount = (resp.data[0].done_amount * 1.0 / 10000).toFixed(2);
                    $scope.vm.target_amount = resp.data[0].target_amount;
                    $scope.vm.done_qty = resp.data[0].done_qty;
                    $scope.vm.target_qty = resp.data[0].target_qty;
                    if ($scope.vm.target_amount == 0) {
                        $scope.vm.doneamountdata = 100;
                    } else {
                        $scope.vm.doneamountdata = Math.round($scope.vm.done_amount * 100 / $scope.vm.target_amount);
                    }
                    if ($scope.vm.target_qty == 0) {
                        $scope.vm.doneqtydata = 100;
                    } else {
                        $scope.vm.doneqtydata = Math.round($scope.vm.done_qty * 100 / $scope.vm.target_qty);
                    }
                } else {
                    scope.vm.done_amount = 0;
                    scope.vm.target_amount = 0;
                    $scope.vm.done_qty = 0;
                    $scope.vm.target_qty = 0;
                    $scope.vm.lossdata = 0;
                    $scope.vm.doneamountdata = 0;
                    $scope.vm.doneqtydata = 0;
                }
            });
        }

        //获取达成额排名数据
        function _getDoneAmountBarReport() {
            var url = 'api/Dashboard/GetDoneAmountBarData?Ym=' + $scope.vm.lastmonth;
            return rt.get(url).then(function (resp) {
                var getData = resp.data;
                for (var i = 0; i < getData.length; i++) {
                    $scope.vm.doneamountnameData.push(getData[i].businessunitidname);
                    $scope.vm.doneamountData.push((getData[i].salecount * 1.0 / 10000).toFixed(2));
                }
            });
        }

        //获取达成额趋势数据
        function _getDoneAmountLineReport() {
            var url = 'api/Dashboard/GetDoneAmountLineData?Ym=' + $scope.vm.lastmonth;
            return rt.get(url).then(function (resp) {
                var lineData = resp.data[0];
                if (lineData) {
                    $scope.vm.echartshosdonedata = _.map(lineData.HosDoneAmount_Line_Data, function (e) {
                        return (e / 10000).toFixed(2);
                    }); //等级医院达成额趋势
                    $scope.vm.echartsbasdonedata = _.map(lineData.BasDoneAmount_Line_Data, function (e) {
                        return (e / 10000).toFixed(2);
                    }); //基层医疗达成额趋势
                    $scope.vm.echartsterdonedata = _.map(lineData.TerDoneAmount_Line_Data, function (e) {
                        return (e / 10000).toFixed(2);
                    }); //零售门店达成额趋势
                }
            });
        }

        //获取拜访分析（饼图）数据
        function _getVisitPieReport() {
            var url = 'api/Dashboard/GetVisitPieData?Ym=' + $scope.vm.lastmonth;
            return rt.get(url).then(function (resp) {
                if (resp.data != null && resp.data.length > 0) {
                    $scope.vm.account_count = resp.data[0].account_count;
                    $scope.vm.visit_done_count = resp.data[0].visit_done_count;
                    $scope.vm.visit_done_times = resp.data[0].visit_done_times;
                    $scope.vm.ownercount = resp.data[0].ownercount;
                    if ($scope.vm.account_count == 0) {
                        $scope.vm.donevisitdata = 100;
                    } else {
                        $scope.vm.donevisitdata = Math.round($scope.vm.visit_done_count * 100 / $scope.vm.account_count);
                    }
                    if ($scope.vm.ownercount == 0) {
                        $scope.vm.averagevisit = 100;
                    } else {
                        $scope.vm.averagevisit = Math.round($scope.vm.visit_done_times / $scope.vm.ownercount);
                    }
                } else {
                    scope.vm.account_count = 0;
                    scope.vm.visit_done_count = 0;
                    $scope.vm.donevisitdata = 0;
                }
            });
        }

        //获取拜访次数地域排名数据
        function _getVisitBarReport() {
            var url = 'api/Dashboard/GetVistitBarData?Ym=' + $scope.vm.lastmonth;
            return rt.get(url).then(function (resp) {
                var getData = resp.data;
                for (var i = 0; i < getData.length; i++) {
                    $scope.vm.visitnameData.push(getData[i].businessunitidname);
                    $scope.vm.visitData.push(getData[i].visit_done_times);
                }
            });
        }

        //获取市场活动分析（饼图）数据
        function _getActionAnysisPieReport() {
            var url = 'api/Dashboard/GetActionAnysisPieData?Ym=' + $scope.vm.lastmonth;
            return rt.get(url).then(function (resp) {
                var getData = resp.data;
                for (var i = 0; i < getData.length; i++) {
                    $scope.vm.campaigntypenameData.push(getData[i].campaign_typename);
                    $scope.vm.campaigncountData.push({ name: getData[i].campaign_typename, value: getData[i].campaigncount });
                }
            });
        }

        //获取市场活动地域排名数据
        function _getActionAnysisBarReport() {
            var url = 'api/Dashboard/GetActionAnysisBarData?Ym=' + $scope.vm.lastmonth;
            return rt.get(url).then(function (resp) {
                var getData = resp.data;
                for (var i = 0; i < getData.length; i++) {
                    $scope.vm.actionanysisnameData.push(getData[i].businessunitidname);
                    $scope.vm.actionanysisData.push(getData[i].campaigncount);
                }
            });
        }

        //客户新增（饼图）
        function _showAccountAddPieReport() {
            var myChart = echarts.init(document.getElementById("accountaddpiereport"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];

            var option = {
                tooltip: {
                    trigger: 'item',
                    formatter: "{a} <br/>{b} : {c} ({d}%)"
                },
                legend: {
                    orient: 'vertical',
                    left: '60%',
                    top: '20%',
                    data: $scope.vm.accountaddpiereportData,
                    itemWidth: 10,
                    itemHeight: 10,
                    textStyle: { //图例文字的样式
                        color: '#fff'
                    }
                },
                series: [{
                    name: '客户新增',
                    type: 'pie',
                    radius: '60px',
                    center: ['25%', '50%'],
                    data: $scope.vm.echartsPieData,
                    itemStyle: {
                        normal: {
                            label: {
                                show: false
                            },
                            labelLine: {
                                show: false
                            }
                        }
                    }
                }],
                color: ['#ffeb76', '#1acbd1', '#fea772', '#e75e6e']
            };

            myChart.clear();
            myChart.setOption(option);
        }

        function _showAccountAddLineReport() {
            var myChart = echarts.init(document.getElementById("accountaddlinereport"));
            angular.element(window).on('resize', myChart.resize);
            var option = {
                title: {
                    text: '客户增加折线图',
                    textStyle: { //标题颜色  
                        color: '#1acbd1',
                        fontSize: '12px'
                    },
                    x: "center",
                    y: 5
                },
                legend: {
                    data: ['等级医院', '基层医疗', '零售门店'],
                    bottom: '0px',
                    textStyle: {
                        color: '#fff' // 图例文字颜色
                    }
                },
                tooltip: {
                    trigger: 'axis'
                },
                grid: {
                    y: 35,
                    y2: 45,
                    x: 30,
                    x2: 15
                },
                xAxis: {
                    type: 'category',
                    boundaryGap: false,
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        textStyle: {
                            color: "#fff",
                            fontSize: 12
                        }
                    },
                    data: $scope.vm.echartsMonth
                },
                yAxis: {
                    type: 'value',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        formatter: '{value}',
                        textStyle: {
                            color: "#fff", //坐标轴刻度文字的颜色
                            fontSize: 12
                        }
                    },
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: 'rgba(26, 203, 209, 0.1)'
                        }
                    }
                },

                series: [{
                    name: '等级医院',
                    type: 'line',
                    data: $scope.vm.echartshosdevdata,
                    areaStyle: { normal: {} },
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: 'rgba(26, 203, 209, 0.8)' }, { offset: 1, color: 'rgba(26, 203, 209, 0)' }])
                        }
                    }
                }, {
                    name: '基层医疗',
                    type: 'line',
                    data: $scope.vm.echartsbasdevdata,
                    areaStyle: { normal: {} },
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: 'rgba(254,167,114,0.8)' }, { offset: 1, color: 'rgba(254,167,114, 0)' }])
                        }
                    }

                }, {
                    name: '零售门店',
                    type: 'line',
                    // stack: '总量',
                    data: $scope.vm.echartsterdevdata,
                    areaStyle: { normal: {} },
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: 'rgba(255,235,118,0.8)' }, { offset: 1, color: 'rgba(255,235,118, 0)' }])
                        }
                    }

                }],
                color: ['#ffeb76', '#1acbd1', '#fea772', '#e75e6e']
            };
            myChart.clear();
            myChart.setOption(option);
        }

        function _showAccountLossPieReport() {
            //显示客户流失占比饼图
            var myChart = echarts.init(document.getElementById("accountlosspiereport"));
            angular.element(window).on('resize', myChart.resize);

            var option = {
                tooltip: {
                    show: true,
                    trigger: 'item',
                    formatter: function formatter(params, ticket, callback) {
                        var num = $scope.vm.lossdata + '%';
                        var str = '<div style="position: absolute; margin-left: -40px;width:72px" id="toolTipBox"><img style="position: absolute;left: -4px;top: -25px;" src="main/img/percentpie.png"><p style="font-size: 10px;margin: 0px;color: #fff;text-align: center;">流失客户占比</p><p style="font-size:18px;margin:0px;color:#e75e6e;font-weight:bold;text-align: center;">' + num + '</p></div>';
                        return str;
                    },
                    alwaysShowContent: true,
                    position: function position(point, params, dom, rect, size) {
                        //console.log(dom)可以看到，提示框是用position定位
                        var marginW = Math.ceil(size.contentSize[0] / 2);
                        var marginH = Math.ceil(size.contentSize[1] / 2);
                        return ['85px', '55px'];
                    },
                    backgroundColor: 'transparent',
                    textStyle: {
                        color: '#fff'
                    }
                },

                series: [{
                    type: 'pie',
                    radius: ['45px', '60px'],
                    center: ['85px', '75px'],
                    avoidLabelOverlap: false,
                    silent: true,
                    label: {
                        normal: {
                            show: false
                        }
                    },
                    data: [{
                        value: $scope.vm.lossdata,
                        name: '流失客户',
                        itemStyle: {
                            normal: {
                                color: '#1acbd1'
                            }
                        }
                    }, {
                        value: 100 - $scope.vm.lossdata,
                        name: '总客户',
                        itemStyle: {
                            normal: {
                                color: 'rgba(26, 203, 209, 0.3)',
                                label: {
                                    show: false
                                }
                            }
                        }
                    }]
                }]
            };
            myChart.clear();
            myChart.setOption(option);
            // 显示 tooltip
            myChart.dispatchAction({
                type: 'showTip',
                seriesIndex: 0,
                dataIndex: 0
            });
        }

        function _showAccountLossBarReport() {
            var myChart = echarts.init(document.getElementById("accountlossbarreport"));
            angular.element(window).on('resize', myChart.resize);
            var option = {
                title: {
                    text: '各地域客户流失情况',
                    textStyle: { //标题颜色  
                        color: '#1acbd1',
                        fontSize: '12px'
                    },
                    x: "center",
                    y: 5
                },
                tooltip: {
                    trigger: 'axis',
                    axisPointer: { // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    }
                },
                grid: {
                    y: 35,
                    y2: 45,
                    x: 50,
                    x2: 15
                },
                legend: {
                    data: ['等级医院', '基层医疗', '零售门店'],
                    x: 'center',
                    y: 'bottom',
                    itemWidth: 10,
                    itemHeight: 10,
                    textStyle: { //图例文字的样式
                        color: '#fff'
                    }
                },
                xAxis: {
                    type: 'value',
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: 'rgba(26, 203, 209, 0.1)'
                        }
                    },
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        formatter: '{value}',
                        textStyle: {
                            color: "#fff", //坐标轴刻度文字的颜色
                            fontSize: 12
                        }
                    }
                },
                yAxis: {
                    type: 'category',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        formatter: '{value}',
                        textStyle: {
                            color: "#fff", //坐标轴刻度文字的颜色
                            fontSize: 12
                        }
                    },
                    data: $scope.vm.lossaccountnameData
                },
                series: [{
                    name: '等级医院',
                    type: 'bar',
                    stack: '总量',
                    data: $scope.vm.hoslossaccountData
                }, {
                    name: '基层医疗',
                    type: 'bar',
                    stack: '总量',
                    data: $scope.vm.baslossaccountData
                }, {
                    name: '零售门店',
                    type: 'bar',
                    stack: '总量',
                    data: $scope.vm.terlossaccountData
                }],
                color: ['#ffeb76', '#1acbd1', '#fea772', '#e75e6e']
            };
            myChart.clear();
            myChart.setOption(option);
        }

        function _showSalesAmountPieReport() {
            var myChart = echarts.init(document.getElementById("salesamountpiereport"));
            angular.element(window).on('resize', myChart.resize);
            var doneamountdata = $scope.vm.doneamountdata > 100 ? 100 : $scope.vm.doneamountdata;
            var option = {
                tooltip: {
                    show: true,
                    trigger: 'item',
                    formatter: function formatter(params, ticket, callback) {
                        var num = $scope.vm.doneamountdata + '%';
                        var str = '<div style="position: absolute; margin-left: -40px;width:72px" id="pietoolTipBox"><img style="position: absolute;left: -4px;top: -25px;" src="main/img/percentpie.png"><p style="font-size:10px;margin:0px;color:#fff;text-align:center">达成占比</p><p style="font-size:18px;margin:0px;color:#e75e6e;font-weight:bold;text-align:center">' + num + '</p></div>';
                        return str;
                    },
                    position: function position(point, params, dom, rect, size) {
                        //console.log(dom)可以看到，提示框是用position定位
                        var marginW = Math.ceil(size.contentSize[0] / 2);
                        var marginH = Math.ceil(size.contentSize[1] / 2);
                        dom.style.zIndex = "2";
                        return ['50%', '55px'];
                    },
                    alwaysShowContent: true,
                    backgroundColor: 'transparent',
                    textStyle: {
                        color: '#fff'
                    }
                },
                series: [{
                    type: 'pie',
                    radius: ['45px', '60px'],
                    center: ['50%', '75px'],
                    avoidLabelOverlap: false,
                    silent: true,
                    label: {
                        normal: {
                            show: false
                        }
                    },
                    data: [{
                        value: doneamountdata,
                        name: '达成额',
                        itemStyle: {
                            normal: {
                                color: '#1acbd1'
                            }
                        }
                    }, {
                        value: 100 - doneamountdata,
                        name: '指标额',
                        itemStyle: {
                            normal: {
                                color: 'rgba(26, 203, 209, 0.3)',
                                label: {
                                    show: false
                                }
                            }
                        }
                    }]
                }]
            };
            myChart.clear();
            myChart.setOption(option);
            // 显示 tooltip
            myChart.dispatchAction({
                type: 'showTip',
                seriesIndex: 0,
                dataIndex: 0
            });
        }

        function _showSalesQtyPieReport() {
            var myChart = echarts.init(document.getElementById("salesqtypiereport"));
            angular.element(window).on('resize', myChart.resize);
            var doneqtydata = $scope.vm.doneqtydata > 100 ? 100 : $scope.vm.doneqtydata;
            var option = {
                tooltip: {
                    show: true,
                    trigger: 'item',
                    formatter: function formatter(params, ticket, callback) {
                        var num = $scope.vm.doneqtydata + '%';
                        var str = '<div style="position: absolute; margin-left: -40px;width:72px" id="pietoolTipBox2"><img style="position: absolute;left: -4px;top: -25px;" src="main/img/percentpie.png"><p style="font-size:10px;margin:0px;color:#fff;text-align:center">达成占比</p><p style="font-size:18px;margin:0px;color:#e75e6e;font-weight:bold;text-align:center">' + num + '</p></div>';
                        return str;
                    },
                    position: function position(point, params, dom, rect, size) {
                        //console.log(dom)可以看到，提示框是用position定位
                        var marginW = Math.ceil(size.contentSize[0] / 2);
                        var marginH = Math.ceil(size.contentSize[1] / 2);
                        dom.style.zIndex = "2";
                        return ['50%', '55px'];
                    },
                    alwaysShowContent: true,
                    backgroundColor: 'transparent',
                    textStyle: {
                        color: '#fff'
                    }
                },
                series: [{
                    type: 'pie',
                    radius: ['45px', '60px'],
                    center: ['50%', '75px'],
                    avoidLabelOverlap: false,
                    silent: true,
                    label: {
                        normal: {
                            show: false
                        }
                    },
                    data: [{
                        value: doneqtydata,
                        name: '达成量',
                        itemStyle: {
                            normal: {
                                color: '#1acbd1'
                            }
                        }
                    }, {
                        value: 100 - doneqtydata,
                        name: '指标量',
                        itemStyle: {
                            normal: {
                                color: 'rgba(26, 203, 209, 0.3)',
                                label: {
                                    show: false
                                }
                            }
                        }
                    }]
                }]
            };
            myChart.clear();
            myChart.setOption(option);
            // 显示 tooltip
            myChart.dispatchAction({
                type: 'showTip',
                seriesIndex: 0,
                dataIndex: 0
            });
            //$('#pietoolTipBox2').parent()[0].style.zIndex = "2";
        }

        function _showDoneAmontBarReport() {
            var myChart = echarts.init(document.getElementById("salesdonebarreport"));
            angular.element(window).on('resize', myChart.resize);
            var dataAxis = $scope.vm.doneamountnameData;
            var data = $scope.vm.doneamountData;

            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: "{b} <br/> 达成额：{c}万",
                    axisPointer: {
                        type: 'shadow'
                    }

                },
                grid: {
                    x: 40,
                    x2: 10,
                    y: 30,
                    y2: 30
                },
                xAxis: [{
                    type: 'category',
                    data: dataAxis,
                    axisLabel: {
                        textStyle: {
                            color: '#fff'
                        }
                    },
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    }
                }],
                yAxis: [{
                    type: 'value',
                    name: '达成额(万元)',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: 'rgba(26, 203, 209, 0.1)'
                        }
                    }

                }],
                series: [{
                    name: '达成额',
                    type: 'bar',
                    barWidth: '20px',
                    data: data,
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: '#fea772' }, { offset: 1, color: '#1acbd1' }])
                        }
                    }
                }]
            };

            myChart.clear();
            myChart.setOption(option);
        }

        function _showSalesDoneLineReport() {
            var myChart = echarts.init(document.getElementById("salesdonelinereport"));
            angular.element(window).on('resize', myChart.resize);
            var option = {
                legend: {
                    data: ['等级医院', '基层医疗', '零售门店'],
                    bottom: '0px',
                    textStyle: {
                        color: '#fff' // 图例文字颜色
                    }
                },
                tooltip: {
                    trigger: 'axis'
                    // formatter: "{b}月：<br/> 等级医院达成额：{c0}万 <br/>基层医疗达成额：{c1}万<br/>零售门店达成额：{c2}万"
                },
                grid: {
                    x: 40,
                    x2: 10,
                    y: 30,
                    y2: 50
                },
                xAxis: {
                    type: 'category',
                    boundaryGap: false,
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        textStyle: {
                            color: "#fff",
                            fontSize: 12
                        }
                    },
                    name: '月',
                    data: $scope.vm.echartsMonth
                },
                yAxis: {
                    type: 'value',
                    name: '达成额(万元)',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        formatter: '{value}',
                        textStyle: {
                            color: "#fff", //坐标轴刻度文字的颜色
                            fontSize: 12
                        }
                    },
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: 'rgba(26, 203, 209, 0.1)'
                        }
                    }
                },

                series: [{
                    name: '等级医院',
                    type: 'line',
                    //stack: '总量',
                    data: $scope.vm.echartshosdonedata,
                    areaStyle: { normal: {} },
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: 'rgba(26, 203, 209, 0.8)' }, { offset: 1, color: 'rgba(26, 203, 209, 0)' }])
                        }
                    }
                }, {
                    name: '基层医疗',
                    type: 'line',
                    //stack: '总量',
                    data: $scope.vm.echartsbasdonedata,
                    areaStyle: { normal: {} },
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: 'rgba(254,167,114,0.8)' }, { offset: 1, color: 'rgba(254,167,114, 0)' }])
                        }
                    }

                }, {
                    name: '零售门店',
                    type: 'line',
                    // stack: '总量',
                    data: $scope.vm.echartsterdonedata,
                    areaStyle: { normal: {} },
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: 'rgba(255,235,118,0.8)' }, { offset: 1, color: 'rgba(255,235,118, 0)' }])
                        }
                    }

                }],
                color: ['#ffeb76', '#1acbd1', '#fea772', '#e75e6e']
            };
            myChart.clear();
            myChart.setOption(option);
        }

        function _showVisitPieReport() {
            //显示拜访分析占比
            var myChart = echarts.init(document.getElementById("visitpiereport"));
            angular.element(window).on('resize', myChart.resize);
            var donevisitdata = $scope.vm.donevisitdata > 100 ? 100 : $scope.vm.donevisitdata;
            var option = {
                tooltip: {
                    show: true,
                    trigger: 'item',
                    formatter: function formatter(params, ticket, callback) {
                        var num = $scope.vm.donevisitdata + '%';
                        var str = '<div style="position: absolute; margin-left: -40px;width:72px" id="toolTipBox"><img style="position: absolute;left: -4px;top: -25px;" src="main/img/percentpie.png"><p style="font-size: 10px;margin: 0px;color: #fff;text-align: center;">覆盖客户占比</p><p style="font-size: 18px;margin: 0px;color: #e75e6e;font-weight: bold; text-align: center;">' + num + '</p></div>';
                        return str;
                    },
                    position: function position(point, params, dom, rect, size) {
                        //console.log(dom)可以看到，提示框是用position定位
                        var marginW = Math.ceil(size.contentSize[0] / 2);
                        var marginH = Math.ceil(size.contentSize[1] / 2);
                        return ['50%', '55px'];
                    },
                    alwaysShowContent: true,
                    backgroundColor: 'transparent',
                    textStyle: {
                        color: '#fff'
                    }
                },
                series: [{
                    type: 'pie',
                    radius: ['45px', '60px'],
                    center: ['50%', '75px'],
                    avoidLabelOverlap: false,
                    silent: true,
                    label: {
                        normal: {
                            show: false
                        }
                    },
                    data: [{
                        value: donevisitdata,
                        name: '覆盖客户',
                        itemStyle: {
                            normal: {
                                color: '#1acbd1'
                            }
                        }
                    }, {
                        value: 100 - donevisitdata,
                        name: '总客户',
                        itemStyle: {
                            normal: {
                                color: 'rgba(26, 203, 209, 0.3)',
                                label: {
                                    show: false
                                }
                            }
                        }
                    }]
                }]
            };
            myChart.clear();
            myChart.setOption(option);
            // 显示 tooltip
            myChart.dispatchAction({
                type: 'showTip',
                seriesIndex: 0,
                dataIndex: 0
            });
        }

        function _showaAtionRankBarReport() {
            var myChart = echarts.init(document.getElementById("actionrankbarreport"));
            angular.element(window).on('resize', myChart.resize);
            var option = {
                title: {
                    text: '市场活动地域排名',
                    textStyle: { //标题颜色  
                        color: '#1acbd1',
                        fontSize: '12px'
                    },
                    x: "center",
                    y: 10
                },
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'shadow'
                    }
                },
                grid: {
                    x: 40,
                    x2: 10,
                    y: 40,
                    y2: 50
                },
                xAxis: [{
                    type: 'category',
                    data: $scope.vm.actionanysisnameData,
                    axisLabel: {
                        textStyle: {
                            color: '#fff'
                        }
                    },
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    }
                }],
                yAxis: [{
                    type: 'value',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: 'rgba(26, 203, 209, 0.1)'
                        }
                    }

                }],
                series: [{
                    name: '市场活动',
                    type: 'bar',
                    barWidth: '20px',
                    data: $scope.vm.actionanysisData,
                    itemStyle: {
                        normal: {
                            color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{ offset: 0, color: '#fea772' }, { offset: 1, color: '#1acbd1' }])
                        }
                    }
                }]
            };

            myChart.clear();
            myChart.setOption(option);
        }

        function _showActionAnysisPieReport() {
            var myChart = echarts.init(document.getElementById("actionanysispiereport"), "shine");
            angular.element(window).on('resize', myChart.resize);

            var option = {
                tooltip: {
                    trigger: 'item',
                    formatter: "{a} <br/>{b} : {c} ({d}%)"
                },
                legend: {
                    type: 'scroll',
                    orient: 'vertical',
                    left: '60%',
                    top: '20%',
                    data: $scope.vm.campaigntypenameData,
                    itemWidth: 10,
                    itemHeight: 10,
                    pageTextStyle: {
                        color: '#fff'
                    },
                    pageIconSize: 10,
                    pageIconColor: 'rgba(26, 203, 209, 1)',
                    pageIconInactiveColor: 'rgba(26, 203, 209, 0.3)',
                    textStyle: { //图例文字的样式
                        color: '#fff'
                    }
                },
                series: [{
                    name: '市场活动',
                    type: 'pie',
                    radius: '60px',
                    center: ['25%', '50%'],
                    data: $scope.vm.campaigncountData,
                    itemStyle: {
                        normal: {
                            label: {
                                show: false
                            },
                            labelLine: {
                                show: false
                            }
                        }
                    }
                }],
                color: ['#ffeb76', '#1acbd1', '#fea772', '#e75e6e', "#4bd192"]
            };

            myChart.clear();
            myChart.setOption(option);
        }

        function _showVisitQtyBarReport() {
            var myChart = echarts.init(document.getElementById("visitqtybarreport"));
            angular.element(window).on('resize', myChart.resize);
            var option = {
                title: {
                    text: '拜访次数地域排名',
                    textStyle: { //标题颜色  
                        color: '#1acbd1',
                        fontSize: '12px'
                    },
                    x: "center",
                    y: 10
                },
                grid: {
                    y: 40,
                    y2: 45,
                    x: 50,
                    x2: 15
                },
                tooltip: {
                    trigger: 'axis',
                    axisPointer: {
                        type: 'shadow'
                    }
                },
                legend: {
                    data: ['拜访次数'],
                    itemWidth: 10,
                    itemHeight: 10,
                    textStyle: { //图例文字的样式
                        color: '#fff'
                    },
                    top: 'bottom'
                },
                yAxis: {
                    type: 'value',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },
                    axisLabel: {
                        formatter: '{value}',
                        textStyle: {
                            color: "#fff", //坐标轴刻度文字的颜色
                            fontSize: 12
                        }
                    },
                    splitLine: {
                        show: true,
                        lineStyle: {
                            color: 'rgba(26, 203, 209, 0.1)'
                        }
                    }
                },
                xAxis: {
                    type: 'category',
                    axisLine: { //坐标轴线条相关设置(颜色等)
                        lineStyle: {
                            color: '#fff'
                        }
                    },

                    axisLabel: {

                        textStyle: {
                            color: "#fff", //坐标轴刻度文字的颜色
                            fontSize: 12
                        }
                    },
                    data: $scope.vm.visitnameData
                },
                series: [{
                    name: '拜访次数',
                    type: 'bar',
                    barWidth: '20px',
                    data: $scope.vm.visitData
                }],
                color: ['#1acbd1']

            };

            myChart.clear();
            myChart.setOption(option);
        }

        function _selectTab(id) {
            $scope.selectedTabId = id;
            if (id === "tab1") {
                _show1();
            } else if (id === "tab2") {
                _show2();
            }
        }
        //选择时间tab 当月 当年切换
        function _selectTimeTab(timetype) {
            $scope.vm.selectTimeTab = timetype;
            if (timetype === "MTD") {
                //当月
                _showReport();
            } else {
                //当年
                _showReport();
            }
        }
        //获取列表
        function _getDataList() {
            var url = 'api/NoticeRead/GetNoticeList';
            return rt.get(url).then(function (resp) {
                $scope.vm.DataList = resp.data;
            });
        }

        //获取所有的药品(筛选条件)
        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = $scope.vm.productList[0];
            });
        }
        //时间类别(筛选条件)
        function _getTimes() {
            $scope.vm.timeList = [{ value: 'MTD', name: '当月(MTD)' }, { value: 'YTD', name: '当年(YTD)' }];
            $scope.vm.timeSelected = $scope.vm.timeList[0];
        }
        //按企业类型 （矩形区域显示数据）
        function _getClientData() {
            $scope.vm.reportClientCount.BizCount = '正在计算中...';
            $scope.vm.reportClientCount.BizCapacity = '正在计算中...';
            $scope.vm.reportClientCount.HosCapacity = '正在计算中...';
            $scope.vm.reportClientCount.HosCount = '正在计算中...';
            $scope.vm.reportClientCount.OtcCapacity = '正在计算中...';
            $scope.vm.reportClientCount.OtcCount = '正在计算中...';
            $scope.vm.reportClientCount.ThrCapacity = '正在计算中...';
            $scope.vm.reportClientCount.ThrCount = '正在计算中...';
            var url = 'api/AlijkDashboard/GetClientsCount?Ym=' + $scope.vm.lastmonth;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportClientCount = resp.data;
            }, function () {});
        }
        //按省份发货排名 （地图）
        function _getReportData1() {
            var waiting = rt.showLoading2();
            var url = 'api/AlijkDashboard/GetEntSaleByProv?timeType=' + $scope.vm.selectTimeTab;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData1 = resp.data;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
        //按省份发货排名 展示数据
        function _show1() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            var rptData1 = $scope.vm.reportData1.ChartData;
            var tabData1 = _.map(rptData1, function (o) {
                return { name: o.Name, value: o.Value };
            });
            var maxValue = _.max(_.map(tabData1, function (o) {
                return o.value;
            }));

            $.get('lib/echarts/map/json/china.json', function (chinaJson) {
                echarts.registerMap('china', chinaJson);
                var option = {
                    tooltip: {
                        trigger: 'item'
                    },
                    visualMap: {
                        min: 0,
                        max: maxValue,
                        left: 'left',
                        top: 'bottom',
                        text: ['高', '低'], // 文本，默认为数值文本
                        inRange: {
                            color: ['#e0ffff', '#006edd']
                        },
                        calculable: true
                    },
                    series: [{
                        name: '按省发货量',
                        type: 'map',
                        mapType: 'china',
                        selectedMode: 'single',
                        roam: false,
                        zoom: 1.2,
                        label: {
                            normal: { show: true },
                            emphasis: { show: true }
                        },
                        data: tabData1
                    }]
                };
                // var ecConfig = require('echarts/config');
                // myChart.on(ecConfig.EVENT.MAP_SELECTED, function(param){//地图点击事件
                //     console.log(param);
                //     //$scope.query.mapSelectedName = param.target;
                //     //_getCityData();
                // });
                myChart.setOption(option);
            });
        }

        //按省份纯销排名 展示数据
        function _show7() {

            var myChart = echarts.init(document.getElementById("salesdonemapreport"), "shine");
            var rptData2 = $scope.vm.reportData2.ChartData;
            var tabData2 = _.map(rptData2, function (o) {
                return { name: o.Name, value: o.Value };
            });
            var maxValue = _.max(_.map(tabData2, function (o) {
                return o.value;
            }));

            $.get('lib/echarts/map/json/china.json', function (chinaJson) {
                echarts.registerMap('china', chinaJson);
                var option = {
                    tooltip: {
                        trigger: 'item'
                    },
                    visualMap: {
                        min: 0,
                        max: maxValue,
                        left: 'left',
                        top: 'bottom',
                        itemWidth: 10,
                        itemHeight: 70,
                        text: ['高', '低'],
                        inRange: {
                            color: ['#ebceba', '#ff1832']
                        },
                        textStyle: {
                            color: '#fff'
                        },
                        calculable: true
                    },
                    series: [{
                        name: '按省纯销量',
                        type: 'map',
                        mapType: 'china',
                        selectedMode: 'single',
                        roam: false,
                        zoom: 1.2,
                        // label: {
                        //     normal: { show: true },
                        //     emphasis: { show: true }
                        // },
                        itemStyle: {
                            //正常时的样式  
                            normal: {
                                label: {
                                    show: true,
                                    color: '#640000',
                                    textStyle: {
                                        fontSize: 8
                                    }
                                }
                            },
                            //鼠标经过时的样式  
                            emphasis: {
                                label: {
                                    show: true,
                                    color: '#fff',
                                    fontSize: 12
                                }
                            }
                        },
                        data: tabData2
                    }]
                };

                // var ecConfig = require('echarts/config');
                // myChart.on(ecConfig.EVENT.MAP_SELECTED, function(param){
                //     //$scope.query.mapSelectedName = param.target;
                //     //_getCityData();
                // });
                myChart.setOption(option);
            });
        }

        //显示窗口
        function _showForm(id) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="cmm/notice/noticeInformEditView.html" rt-controller="noticeInformEditController" rt-include-params="{noticeid:\'' + id + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        }

        function _hideForm() {
            $scope.vm.dialog.close();
            _getDataList().then(_show, function (message) {
                rt.errorMessage(message);
            });
            _refresh();
        }

        function _show() {}

        function _refresh() {
            $scope.$emit('rt-reload');
        }

        //生成默认的系统参数
        function _initSysConfig() {
            rt.get("api/AlijkDashboard/InitSysConfig");
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-12-22
 说明     :仪表板Controller
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').controller("dashboardhomeController", ['$scope', '$state', '$stateParams', 'rt', dashboardhomeController]);
    function dashboardhomeController($scope, $state, $stateParams, rt) {

        init();
        function init() {
            $scope.vm = {};
            $scope.vm.leftmenuDashboard = [];
            $scope.vm.middlemenuDashboard = [];
            $scope.vm.rightmenuDashboard = [];
            var leftheight = 0;
            var middleheight = 0;
            var rightheight = 0;
            // $scope.vm.dashboardheight = 0;

            $scope.$on('get-parentheight', function (d, data) {
                if (data[1] == "leftdashboard") {
                    leftheight += data[0] + 40;
                } else if (data[1] == "middledashboard") {
                    middleheight += data[0] + 40;
                } else if (data[1] == "rightdashboard") {
                    rightheight += data[0] + 40;
                };

                //根据最高的一列 设置背景图片高度
                $scope.vm.dashboardheight = {
                    'height': Math.max(leftheight, middleheight, rightheight) + 90 + 'px',
                    'min-height': $(".content-wrapper").height()
                };
            });
            _loadDashboardData();
        }

        //获取仪表板菜单
        function _loadDashboardData() {
            var apiUrl = "api/SystemMenu/GetSystemMenusForWebDashboard";
            rt.get(apiUrl).then(function (resp) {
                var menuData = resp.data;
                for (var i = 0; i < menuData.length; i++) {
                    if (menuData[i].MenuCode == "dashboard-left") {
                        $scope.vm.hasleftDashboard = true;
                        $scope.vm.leftmenuDashboard = menuData[i].Children;
                    } else if (menuData[i].MenuCode == "dashboard-middle") {
                        $scope.vm.hasmiddleDashboard = true;
                        $scope.vm.middlemenuDashboard = menuData[i].Children;
                    } else if (menuData[i].MenuCode == "dashboard-right") {
                        $scope.vm.hasrightDashboard = true;
                        $scope.vm.rightmenuDashboard = menuData[i].Children;
                    } else {
                        $scope.vm.hasleftDashboard = false;
                        $scope.vm.hasmiddleDashboard = false;
                        $scope.vm.hasrightDashboard = false;
                        // $scope.vm.dashboardheight = {
                        //     'min-height': '900px'
                        // };
                    }
                }
            });
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2017-05-16
 说明     : 流向数据处理-主页面
 *********************************************************/
(function () {
    'use strict';

    angular.module("xrmApp").service('ddmManageService', ['entityService', '$http', function (entityService, $http) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'DDMCleanData';

        // @@ 选项集
        this.picklists = ['StateCode'];
    }]).controller("ddmManageController", ['$scope', '$state', '$injector', 'ddmManageService', function ($scope, $state, $injector, myService) {
        var rt = myService.rt;
        var that = this;

        this.preSearch = function (params) {
            if (rt.isNull($scope.vm.importDate)) {
                return "请选择年月";
            }
        };

        this.reload = function _loadData(pageIndex) {
            if (pageIndex && typeof pageIndex === 'number') $scope.vm.page.index = pageIndex;

            var preSearchMessage = $scope.vm.actions.preSearch();
            if (!rt.isNull(preSearchMessage) && preSearchMessage.length > 0) {
                rt.errorMessage(preSearchMessage);
                return;
            }

            var url = "api/DDMCleanData/GetDDMCleanDataList?yearMonth=" + $scope.vm.importDate + "&fromBuid=" + (!rt.isNull($scope.vm.fromBuSelected) && !rt.isNullOrWhiteSpace($scope.vm.fromBuSelected.Id) ? $scope.vm.fromBuSelected.Id : "") + "&fromAccid=" + (!rt.isNull($scope.vm.fromAccSelected) && !rt.isNullOrWhiteSpace($scope.vm.fromAccSelected.Id) ? $scope.vm.fromAccSelected.Id : "") + "&fromOwnerid=" + (!rt.isNull($scope.vm.fromOwnerSelected) && !rt.isNullOrWhiteSpace($scope.vm.fromOwnerSelected.Id) ? $scope.vm.fromOwnerSelected.Id : "") + "&toBuid=" + (!rt.isNull($scope.vm.toBuSelected) && !rt.isNullOrWhiteSpace($scope.vm.toBuSelected.Id) ? $scope.vm.toBuSelected.Id : "") + "&toAccid=" + (!rt.isNull($scope.vm.toAccSelected) && !rt.isNullOrWhiteSpace($scope.vm.toAccSelected.Id) ? $scope.vm.toAccSelected.Id : "") + "&toOwnerid=" + (!rt.isNull($scope.vm.toOwnerSelected) && !rt.isNullOrWhiteSpace($scope.vm.toOwnerSelected.Id) ? $scope.vm.toOwnerSelected.Id : "") + "&pageIndex=" + $scope.vm.page.index + "&pageSize=" + $scope.vm.page.size;
            return rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.page.recordCount = resp.data.TotalRecords;
            }).then($scope.vm.actions.loadComplete);
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        function init() {
            $scope.vm.goNext = _goNext;
            $scope.vm.importDate = localStorage.getItem("importDate") ? localStorage.getItem("importDate") : moment().add(-1, 'months').format('YYYY-MM');
            $scope.vm.fromBuSelected = localStorage.getItem("fromBuSelected") ? JSON.parse(localStorage.getItem("fromBuSelected")) : {};
            $scope.vm.fromAccSelected = localStorage.getItem("fromAccSelected") ? JSON.parse(localStorage.getItem("fromAccSelected")) : {};
            $scope.vm.fromOwnerSelected = localStorage.getItem("fromOwnerSelected") ? JSON.parse(localStorage.getItem("fromOwnerSelected")) : {};
            $scope.vm.toBuSelected = localStorage.getItem("toBuSelected") ? JSON.parse(localStorage.getItem("toBuSelected")) : {};
            $scope.vm.toAccSelected = localStorage.getItem("toAccSelected") ? JSON.parse(localStorage.getItem("toAccSelected")) : {};
            $scope.vm.toOwnerSelected = localStorage.getItem("toOwnerSelected") ? JSON.parse(localStorage.getItem("toOwnerSelected")) : {};
        }

        init();

        function _goNext(value) {
            localStorage.setItem("importDate", $scope.vm.importDate);
            localStorage.setItem("fromBuSelected", JSON.stringify($scope.vm.fromBuSelected));
            localStorage.setItem("fromAccSelected", JSON.stringify($scope.vm.fromAccSelected));
            localStorage.setItem("fromOwnerSelected", JSON.stringify($scope.vm.fromOwnerSelected));
            localStorage.setItem("toBuSelected", JSON.stringify($scope.vm.toBuSelected));
            localStorage.setItem("toAccSelected", JSON.stringify($scope.vm.toAccSelected));
            localStorage.setItem("toOwnerSelected", JSON.stringify($scope.vm.toOwnerSelected));
            switch (value) {
                case "ddmrawdataexcel":
                    $state.go("main.ddmrawdataexcel", {
                        "ym": moment($scope.vm.importDate).format('YYYY-MM'),
                        "frombuid": JSON.stringify($scope.vm.fromBuSelected)
                    }, { location: true });
                    break;
                case "ddmcleandataproduct":
                    $state.go("main.ddmcleandataproduct", {
                        "ym": moment($scope.vm.importDate).format('YYYY-MM'),
                        "frombuid": JSON.stringify($scope.vm.fromBuSelected),
                        "fromaccid": JSON.stringify($scope.vm.fromAccSelected)
                    }, {
                        location: true
                    });
                    break;
                case "caldrugflowassignment":
                    $state.go("main.caldrugflowassignment", {
                        "ym": moment($scope.vm.importDate).format('YYYY-MM'),
                        "frombuid": JSON.stringify($scope.vm.fromBuSelected),
                        "fromaccid": JSON.stringify($scope.vm.fromAccSelected)
                    }, {
                        location: true
                    });
                    break;
            }
        }
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-05-16
 说明     : B2B流向数据
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('Ddmrawdatab2bService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DdmRawDatab2b';
        // @@ 选项集
        this.picklists = [];
    }]).controller("ddmrawdatab2bController", ['$scope', 'rt', '$injector', 'Ddmrawdatab2bService', ddmrawdatab2bController]);
    function ddmrawdatab2bController($scope, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var fromBu = rt.isNull($scope.vm.fromBuSelected) ? "" : $scope.vm.fromBuSelected.Id;
            var fromAcc = rt.isNull($scope.vm.fromAccSelected) ? "" : $scope.vm.fromAccSelected.Id;
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "yM", Value: moment($scope.vm.yM).format('YYYY-MM') });
            _that.searchList.push({ Type: 1, Key: "fromBu", Value: fromBu });
            _that.searchList.push({ Type: 1, Key: "fromAcc", Value: fromAcc });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.yM = moment().format('YYYY-MM');

            //查询按钮
            $scope.vm.showReportButton = function () {
                var msg = checkOption();
                if (!rt.isNullOrWhiteSpace(msg)) {
                    rt.errorMessage(msg);
                    return false;
                } else {
                    $scope.vm.index = 1;
                    $scope.vm.showReport();
                }
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };
        }

        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.yM)) {
                return "请选择查询年月";
            } else {
                return "";
            }
        }

        //获取B2B流向数据
        function _getReportData() {
            var fromBu = rt.isNull($scope.vm.fromBuSelected) ? "" : $scope.vm.fromBuSelected.Id;
            var fromAcc = rt.isNull($scope.vm.fromAccSelected) ? "" : $scope.vm.fromAccSelected.Id;
            var waiting = rt.showLoading2();
            var url = "api/DdmRawDatab2b/GetDdmRawDatab2bData";
            url += "?yM=" + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM'));
            url += "&fromBu=" + encodeURIComponent(fromBu);
            url += "&fromAcc=" + encodeURIComponent(fromAcc);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }
    }
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2017-05-12
 说明     : 流向原始数据导入
 *********************************************************/
(function () {
    'use strict';

    angular.module("xrmApp").controller("ddmRawDataExcelController", ['$scope', '$state', '$stateParams', 'rt', ddmRawDataExcelController]);
    function ddmRawDataExcelController($scope, $state, $stateParams, rt) {
        function init() {
            $scope.importStatus = "";
            $scope.errorFileId = "";
            $scope.importSuccess = false;
            $scope.selectedFiles = null;
            $scope.selectedFileName = null;
            $scope.import = _import;
            $scope.downloadErrorFile = _downloadErrorFile;
            $scope.downloadTemplateFile = _downloadTemplateFile;
            $scope.selectFile = _selectFile;
            $scope.goNext = _goNext;
            $scope.goBack = _goBack;
            $scope.getDataList = _getDataList;
            $scope.vm = {};
            $scope.vm.isShowBack = !rt.isNullOrWhiteSpace($stateParams.ym);
            $scope.vm.importDate = $scope.vm.isShowBack ? $stateParams.ym : moment().add(-1, 'months').format('YYYY-MM');
            $scope.vm.unitSelected = rt.isNullOrWhiteSpace($stateParams.frombuid) ? {} : JSON.parse($stateParams.frombuid);

            //筛选模式
            $scope.vm.modeList = [{ Name: '年月+部门', Value: 1 }, { Name: '年月+商业', Value: 2 }];

            $scope.vm.selectedMode = $scope.vm.modeList[0];
            $scope.vm.importHeader = _getImportHeader();
            $scope.vm.page = {
                index: 1,
                size: rt.getPaginationSize(),
                recordCount: 0
            };
            $scope.vm.totalQty = 0; //合计数量
        }

        init();

        function _goBack() {
            $state.go("main.ddmmanage", {}, { location: true });
        }

        function _getImportHeader() {
            if ($scope.vm.selectedMode.Value === 1) {
                return {
                    Title: "流向数据",
                    ModuleName: "DDMRawDataImport",
                    EntityName: "ddm_raw_data_excel",
                    Columns: [{ ColumnName: "from_accountidName", DisplayName: "上游企业名称*", IsRequired: true, IsKey: true }, { ColumnName: "to_account_alias_name", DisplayName: "下游企业名称*", IsRequired: true, IsKey: false }, { ColumnName: "product_alias_name", DisplayName: "药品名称*", IsRequired: true, IsKey: false }, { ColumnName: "product_alias_size", DisplayName: "药品规格*", IsRequired: true, IsKey: false }, { ColumnName: "product_lotno", DisplayName: "药品批号", IsRequired: false, IsKey: false }, { ColumnName: "saleto_date", DisplayName: "销售日期*", IsRequired: true, IsKey: false }, { ColumnName: "saleto_price", DisplayName: "销售价格", IsRequired: false, IsKey: false }, { ColumnName: "saleto_qty", DisplayName: "销售数量*", IsRequired: true, IsKey: false }]
                };
            } else {
                return {
                    Title: "流向数据",
                    ModuleName: "DDMRawDataImport",
                    EntityName: "ddm_raw_data_excel",
                    Columns: [{ ColumnName: "from_accountidName", DisplayName: "上游企业名称", IsRequired: false, IsKey: true }, { ColumnName: "to_account_alias_name", DisplayName: "下游企业名称*", IsRequired: true, IsKey: false }, { ColumnName: "product_alias_name", DisplayName: "药品名称*", IsRequired: true, IsKey: false }, { ColumnName: "product_alias_size", DisplayName: "药品规格*", IsRequired: true, IsKey: false }, { ColumnName: "product_lotno", DisplayName: "药品批号", IsRequired: false, IsKey: false }, { ColumnName: "saleto_date", DisplayName: "销售日期*", IsRequired: true, IsKey: false }, { ColumnName: "saleto_price", DisplayName: "销售价格", IsRequired: false, IsKey: false }, { ColumnName: "saleto_qty", DisplayName: "销售数量*", IsRequired: true, IsKey: false }]
                };
            }
        }

        $scope.$watch("vm.selectedMode.Value", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            $scope.vm.importHeader = _getImportHeader();
        });

        function _selectFile(files) {
            if (files && files.length && files.length > 0) {
                $scope.selectedFiles = files;
                $scope.selectedFileName = files[0].name;
            }
        }

        function _importExcel(fileid) {
            var url = "api/DataService/ImportExcel";
            var data = $scope.vm.importHeader;
            data.FileId = fileid;
            var paramid = "";
            if ($scope.vm.selectedMode.Value === 2) {
                data.Extra = $scope.vm.selectedMode.Value + '|' + $scope.vm.importDate + '|' + $scope.vm.unitSelected.Id + '|' + $scope.vm.busiSelected.Id;
            } else {
                data.Extra = $scope.vm.selectedMode.Value + '|' + $scope.vm.importDate + '|' + $scope.vm.unitSelected.Id;
            }
            return rt.post(url, data);
        }

        function _downloadTemplateFile() {
            var url = "api/DataService/CreateImportTemplate";
            var data = $scope.vm.importHeader;
            rt.post(url, data).success(function (id) {
                rt.downloadFile("temp", id); //下载模板
            });
        }

        //下载导入错误日志文件
        function _downloadErrorFile() {
            rt.downloadFile("temp", encodeURIComponent($scope.errorFileId));
        }

        function _import() {
            if ($scope.vm === undefined) {
                $scope.importStatus = " 请选择年月。";
                return;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.importDate)) {
                $scope.importStatus = " 请选择年月。";
                return;
            } else {
                var importDateStr = $scope.vm.importDate;
                var importDateArray = importDateStr.split('-');
                var totalMonth = parseInt(importDateArray[0]) * 12 + parseInt(importDateArray[1]);
                var currentMonth = parseInt(new Date().getFullYear()) * 12 + new Date().getMonth() + 1;
                if (totalMonth > currentMonth) {
                    $scope.importStatus = " 选择年月不能大于当前年月。";
                    return;
                }
            }
            if (rt.isNull($scope.vm.unitSelected) || rt.isNullOrWhiteSpace($scope.vm.unitSelected.Id)) {
                $scope.importStatus = " 请选择省区/地区";
                return;
            }
            if ($scope.vm.selectedMode.Value === 2) {
                if (rt.isNull($scope.vm.busiSelected) || rt.isNullOrWhiteSpace($scope.vm.busiSelected.Id)) {
                    $scope.importStatus = " 请选择商业。";
                    return;
                }
            }
            if (!$scope.selectedFiles || !$scope.selectedFiles.length || $scope.selectedFiles.length <= 0) {
                $scope.importStatus = " 请选择Excel文件。";
                return;
            }
            $scope.importStatus = "正在导入中...";
            $scope.errorFileId = "";
            $scope.importSuccess = false;
            var waiting = rt.showWaiting();
            rt.uploadFile($scope.selectedFiles, "temp", rt.newGuid(), false, function (data) {
                _importExcel(data).then(function (resp) {
                    if (rt.isNullOrWhiteSpace(resp.data) || resp.data == "") {
                        $scope.importSuccess = true;
                        // 查询数据
                        $scope.getDataList($scope.vm.page.index).then(function () {
                            $scope.importStatus = " 流向数据导入成功，一共导入" + $scope.vm.page.recordCount + "笔：";
                        });
                    } else {
                        var arr = resp.data.split("#");
                        $scope.importStatus = " 流向数据导入失败，一共" + arr[1] + "笔流向，其中" + arr[2] + "笔存在错误：";
                        $scope.errorFileId = resp.data;
                    }
                    waiting.close();
                }, function (resp) {
                    $scope.importStatus = resp.data;
                    waiting.close();
                });
            }, function (msg) {
                waiting.close();
            });
        }

        function _getDataList(pageIndex) {
            if (pageIndex && typeof pageIndex === 'number') $scope.vm.page.index = pageIndex;

            if (rt.isNull($scope.vm.importDate)) {
                rt.errorMessage("请选择年月。");
                return;
            }
            var current = moment().format('YYYY-MM');
            if ($scope.vm.importDate > current) {
                rt.errorMessage("选择年月不能大于当前年月。");
                return;
            }
            if (rt.isNull($scope.vm.unitSelected) || rt.isNullOrWhiteSpace($scope.vm.unitSelected.Id)) {
                rt.errorMessage(" 请选择省区/地区");
                return;
            }
            if ($scope.vm.selectedMode.Value === 2) {
                if (rt.isNull($scope.vm.busiSelected) || rt.isNullOrWhiteSpace($scope.vm.busiSelected.Id)) {
                    rt.errorMessage(" 请选择商业。");
                    return;
                }
            }
            var url = "api/DDMRawDataExcel/GetDDMRawData?yearMonth=" + $scope.vm.importDate + "&buid=" + ($scope.vm.unitSelected ? $scope.vm.unitSelected.Id : "") + "&accountid=" + ($scope.vm.busiSelected ? $scope.vm.busiSelected.Id : "") + "&pageIndex=" + $scope.vm.page.index + "&pageSize=" + $scope.vm.page.size;
            return rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.page.recordCount = resp.data.TotalRecords;
                $scope.vm.totalQty = resp.data.TotalQty;
            });
        }

        function _goNext() {
            $state.go("main.ddmcleandataproduct", {
                "ym": moment($scope.vm.importDate).format('YYYY-MM'),
                "frombuid": JSON.stringify($scope.vm.unitSelected),
                "fromaccid": JSON.stringify($scope.vm.busiSelected)
            }, {
                location: true
            });
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : BerryDing
 创建时间 : 2017-01-12
 说明     : 代表拜访分析
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('DelegateVistRankService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DelegateVistRank';
        // @@ 选项集
        this.picklists = [];
    }]).controller("delegatevisitrankController", ['$scope', '$q', 'rt', '$injector', 'DelegateVistRankService', delegatevisitrankController]);
    function delegatevisitrankController($scope, $q, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            var bigUnitId = $scope.vm.bigDepSelected.id;
            var buId = $scope.vm.buidSelected.id;
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "yM", Value: moment($scope.vm.yM).format('YYYY-MM') });
            _that.searchList.push({ Type: 1, Key: "buId", Value: buId });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: bigUnitId });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.yM = moment().format('YYYY-MM');

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };
            _getAllBuid();
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            });
        }

        //获取客户数量 覆盖数 覆盖率
        function _GetSumCoverageData(bigUnitId, unitIds) {
            var url = "api/AccountVisitedAnalysis/GetAccountVisitSumData";
            url += "?yM=" + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM'));
            url += "&buId=" + encodeURIComponent($scope.vm.buidSelected.id);
            url += "&bigDeptId=" + encodeURIComponent(bigUnitId);
            url += "&businessUnitId=" + unitIds;
            return rt.get(url).then(function (resp) {
                $scope.cusqty = resp.data[0].shouldVisit;
                $scope.coverqty = resp.data[0].hasVisit;
                $scope.coverper = resp.data[0].coverage.toFixed(1) + '%';
            });
        }

        function _getReportData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            var bigUnitId = $scope.vm.bigDepSelected.id;
            var waiting = rt.showLoading2();
            _GetSumCoverageData(bigUnitId, unitids);
            var url = "api/AccountVisitedAnalysis/GetAccountVisitGrid";
            url += "?yM=" + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM'));
            url += "&buId=" + encodeURIComponent($scope.vm.buidSelected.id);
            url += "&bigDeptId=" + encodeURIComponent(bigUnitId);
            url += "&businessUnitId=" + encodeURIComponent(unitids);
            url += "&account_Level=";
            url += "&pageIndex=" + $scope.vm.index;
            url += "&pageSize=" + $scope.vm.pageSize;

            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Kevin Zhou
 创建时间 : 2016-04-14
 说明     : 代表排名柱状图
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').controller("delegatevisitScoreController", ['$scope', '$q', 'rt', delegatevisitScoreController]);
    function delegatevisitScoreController($scope, $q, rt) {
        function _show() {

            var myChart = echarts.init(document.getElementById("scoreCharts"), "shine");
            var echartYName = [];
            var echartsData = [];
            var getData = $scope.vm.reportData;
            for (var i = 0; i < getData.length; i++) {
                echartYName.push(getData[i].EntInfoName);
                echartsData.push(getData[i].SaleCount);
            }
            var scoreOption = {
                title: {
                    text: '拜访评分'
                },
                tooltip: {
                    trigger: 'axis'
                },
                calculable: true,
                xAxis: [{
                    type: 'category',
                    data: ['100-80', '79-60', '59-40', '39-20', '19-0'],
                    name: '分值',
                    axisTick: {
                        show: false
                    },
                    axisLabel: {
                        interval: 0
                    },
                    splitLine: {
                        show: false
                    }
                }],
                yAxis: [{
                    type: 'value',
                    name: '比例',
                    nameLocation: 'end',
                    axisTick: {
                        show: false
                    },
                    axisLabel: {
                        formatter: '{value}%'
                    },
                    splitLine: {
                        show: false
                    }
                }],
                series: [{
                    name: '比例',
                    type: 'bar',
                    data: $scope.visitScore,
                    itemStyle: {
                        normal: {
                            color: '#80BD46',
                            label: {
                                show: true,
                                position: 'top',
                                formatter: '{c}%',
                                textStyle: {
                                    color: '#3B3B3B'
                                }
                            }
                        }
                    }
                }]
            };
            scoreCharts.setOption(scoreOption);
        }
    }
})();
"use strict";

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/3/2
 *描述：商业发货导入脚本
 *************************************************/
// (function(){
//     'use strict';
//     function deliveryExcelImportController($scope,rt){
//         function init(){
//             $scope.vm={};
//             $scope.vm.Data=[];
//             $scope.vm.DataLeast=[];
//             $scope.vm.import=_import;
//         }
//         $scope.selectedFiles = null;
//         $scope.selectedFileName = null;
//         $scope.fileselect = function (files) {
//             if (files && files.length && files.length > 0) {
//                 $scope.selectedFiles = files;
//                 $scope.selectedFileName = files[0].name;
//             }
//         }
//         $scope.excelinsert = function (fileId) {
//             var url = "api/delivery/InsertFromExcel?fileId=" + fileId;
//             url+="&importDate="+$scope.vm.importDate;
//             return rt.get(url);
//         }
//         $scope.downloadfile = function () {
//             rt.downloadFile("delivery","a6aece0f-0885-448b-a7ac-5ac04c5d9a1f");//下载模板
//         }
//         function  _import(){
//             if (rt.isNullOrWhiteSpace($scope.vm.importDate)) {
//                 rt.errorMessage("年月不能为空。");
//                 return;
//             }

//             var waiting = rt.showWaiting();
//             rt.uploadFile($scope.selectedFiles,"delivery",rt.newGuid(),false, function (data) {
//                 $scope.excelinsert(data).then(function(){
//                     rt.successMessage("导入成功。");
//                     $scope.$emit('rt-reload');
//                     waiting.close();
//                 }, function(){
//                     waiting.close();
//                 });
//             });
//         }
//         init();
//     }
//     angular.module("xrmApp").controller("deliveryExcelImportController",['$scope','rt',deliveryExcelImportController]);
// })();


(function () {
    'use strict';

    angular.module("xrmApp").controller("deliveryExcelImportController", ['$scope', 'rt', deliveryExcelImportController]);
    function deliveryExcelImportController($scope, rt) {
        function init() {
            $scope.importStatus = "";
            $scope.errorFileId = "";
            $scope.selectedFiles = null;
            $scope.selectedFileName = null;
            $scope.import = _import;
            $scope.downloadErrorFile = _downloadErrorFile;
            $scope.downloadTemplateFile = _downloadTemplateFile;
            $scope.selectFile = _selectFile;
            $scope.vm = {};
            $scope.vm.modeType = $scope.$parent.importType; //导入模式
        }
        init();
        function _selectFile(files) {
            if (files && files.length && files.length > 0) {
                $scope.selectedFiles = files;
                $scope.selectedFileName = files[0].name;
            }
        }
        function _importExcel(fileid) {
            var url = "api/DataService/ImportExcel";
            var data = $scope.$parent.importHeader;
            data.FileId = fileid;
            data.Extra = $scope.vm.modeType;
            return rt.post(url, data);
        }

        function _downloadTemplateFile() {
            var url = "api/DataService/CreateImportTemplate";
            var data = $scope.$parent.importHeader;
            rt.post(url, data).success(function (id) {
                rt.downloadFile("temp", id); //下载模板
            });
        }

        //下载导入错误日志文件
        function _downloadErrorFile() {
            rt.downloadFile("temp", encodeURIComponent($scope.errorFileId));
        }

        function _import() {
            if (!$scope.selectedFiles || !$scope.selectedFiles.length || $scope.selectedFiles.length <= 0) {
                $scope.importStatus = " 请选择Excel文件。";
                return;
            }
            $scope.importStatus = "正在导入中...";
            $scope.errorFileId = "";
            var waiting = rt.showWaiting();
            rt.uploadFile($scope.selectedFiles, "temp", rt.newGuid(), false, function (data) {
                _importExcel(data).then(function (resp) {
                    if (rt.isNullOrWhiteSpace(resp.data) || resp.data == "") {
                        $scope.importStatus = " 成功。";
                        $scope.$emit('rt-reload');
                    } else {
                        $scope.importStatus = " 失败。";
                        $scope.errorFileId = resp.data;
                    }
                    waiting.close();
                }, function (resp) {
                    $scope.importStatus = resp.data;
                    waiting.close();
                });
            }, function (msg) {
                waiting.close();
            });
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-02-07
 说明     : 医院开发跟进明细
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('ActivityService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DevelopHospitalActivityH';
        // @@ 选项集
        this.picklists = [];
    }]).controller("activityController", ['$scope', 'rt', '$injector', 'ActivityService', activityController]);
    function activityController($scope, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var unitids = rt.isNull($scope.vm.businessUnitSelected) ? "" : $scope.vm.businessUnitSelected.id;
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "yM", Value: moment($scope.vm.yM).format('YYYY-MM') });
            _that.searchList.push({ Type: 1, Key: "buId", Value: buId });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: bigUnitId });
            var unitids = _CalculateUnitids();
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.yM = moment().format('YYYY-MM');

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };
            _getAllBuid();
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                }
                $scope.vm.buidList.unshift({ id: "", name: "全部事业部" });
                $scope.vm.buidSelected = $scope.vm.buidList[0];
            }, function (error) {});
        }

        //获取业务线/大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [{ id: '', name: '全部业务线/大区' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    var data = resp.DataList;
                    if (!rt.isNull(data) && data.length > 0) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(data);
                        $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                    }
                    $scope.vm.bigDepList.unshift({ id: '', name: '全部业务线/大区' });
                    $scope.vm.bigDepSelected = { id: '', name: '全部业务线/大区' };
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                return;
            }
            if (oldValue != newValue) {
                getBusinessUnitList($scope.vm.buidSelected.id, $scope.vm.bigDepSelected.id);
            }
        });
        //获取省区地区
        function getBusinessUnitList(buId, bigDepId) {
            rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                '@queryValue': '',
                '@ParentBusinessUnitId': bigDepId,
                '@businesstype': 10
            }, function (resp) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.businessUnitList = data;
                }
            }, function (error) {
                $scope.vm.businessUnitList = [];
            });
        }

        //获取医院开发跟进明细
        function _getReportData() {
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var unitids = _CalculateUnitids();
            var waiting = rt.showLoading2();
            var url = "api/DevelopHospitalActivityH/GetDevelopHospitalActivityData";
            url += "?yM=" + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM'));
            url += "&buId=" + encodeURIComponent($scope.vm.buidSelected.id);
            url += "&bigDeptId=" + encodeURIComponent(bigUnitId);
            url += "&businessUnitId=" + encodeURIComponent(unitids);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;

                if ($scope.vm.reportData.length > 0) {
                    //防止取不到数据时，获取权限报错
                    //导出权限
                    var stprivilege = $scope.vm.reportData[0].develop_hospitalId;
                    return myService.getPrivilege(stprivilege).then(function (resp) {
                        $scope.vm.privilege = resp.data;
                    });
                }
            }).finally(function () {
                waiting.close();
            });
        }

        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            return unitids;
        }
    }
})();
"use strict";

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Ludwig Dong
 *创建时间：2016/5/4
 *说明：分销分析
 *************************************************/
(function () {
    'use strict';

    function DrListController($scope, $q, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.startDate });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.endDate });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "diyCategoryId", Value: $scope.vm.CuSelected.Id });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: $scope.vm.unitids });
            _that.searchList.push({ Type: 1, Key: "sortType", Value: $scope.vm.sortSelected.Value });
            _that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.chartWidth = 1000;
            $scope.vm.reportData = []; //表格数据
            $scope.vm.reportTbData = []; //图表数据
            $scope.vm.reportTbData2 = []; //图表数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = { Id: '' };
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { Id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = null;
            $scope.vm.pageIndex = 1;
            $scope.vm.TotalRecords = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.unitids = "";
            $scope.selectedTabId = "tab1";
            $scope.selectTab = _selectTab;
            $scope.vm.showReport = _getReportData;
            _getTops();
            _getSorts();
            _getCustomcategory();
            _getAllBuid();
            _initYmSelected();
        }
        //检查条件
        function checkOption() {
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                $scope.vm.unitids = unitmap.join(",");
            }
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                return "开始年月不能为空。";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                return "结束年月不能为空。";
            }
            if (rt.isNull($scope.vm.CuSelected) || rt.isNullOrWhiteSpace($scope.vm.CuSelected.Id)) {
                return "指标类型不能为空。";
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) < 0) {
                return "参数异常[开始日期必须小于等于结束日期.]";
            }
            if (_CalOneYear($scope.vm.startDate, $scope.vm.endDate) != 0) {
                return "参数异常[开始日期与结束日期必须在同一年.]";
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) >= 365) {
                return "参数异常[日期区间最大为12个月.]";
            }
            return "";
        }
        //切换tab
        function _selectTab(id) {
            $scope.selectedTabId = id;
            _showData();
        }
        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.startDate = d.getFullYear() + "-" + '01';
            $scope.vm.endDate = moment().format('YYYY-MM');
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [{ name: '全部业务线/大区', id: '' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
                return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
                $scope.vm.buidList.unshift({ id: "", name: "全部事业部" });
                $scope.vm.buidSelected = $scope.vm.buidList[0];
            }, function (error) {});
        }
        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[0];
        }
        function _getSorts() {
            $scope.vm.sortList = [{ Name: '达成率', Value: 1 }, { Name: '达成额', Value: 2 }];
            $scope.vm.sortSelected = $scope.vm.sortList[0];
        }
        function _getCustomcategory() {
            var url = 'api/CustomCategory/GetCustomCategoryByTaskType?taskType=2';
            return rt.get(url).then(function (resp) {
                $scope.vm.customcategoryList = resp.data;
                $scope.vm.CuSelected = $scope.vm.customcategoryList[0];
            });
        }

        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        function _CalOneYear(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var result = sArr[0] - eArr[0];
            return result;
        }
        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            var DeMessText = ["分销指标", "实际达成额", "月度达成率"];
            // $scope.vm.MonDataList[0] = sArr[1];
            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("分销指标", "实际达成额", "月度达成率");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("分销指标", "实际达成额", "月度达成率");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        //通过接口获取图表数据
        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var waiting = rt.showLoading2();
            var TabDataUrl = 'api/DistributeAnalysis/GetDistributeDoneChartData?sYm=' + encodeURIComponent($scope.vm.startDate) + '&eYm=' + encodeURIComponent($scope.vm.endDate) + '&buId=' + encodeURIComponent($scope.vm.buidSelected.id) + '&bigUnitId=' + encodeURIComponent($scope.vm.bigDepSelected.id) + '&businessUnitId=' + encodeURIComponent($scope.vm.unitids) + '&diyCategoryId=' + encodeURIComponent($scope.vm.CuSelected.Id) + '&depType=ToTal_AVG' + '&top=' + $scope.vm.topsSelected;
            rt.get(TabDataUrl).then(function (resp) {
                $scope.vm.reportTbData = resp.data;
                _showData();
                waiting.close();
            }, function () {
                waiting.close();
            });
            var TabDataUrl2 = 'api/DistributeAnalysis/GetDistributeDoneChartData?sYm=' + encodeURIComponent($scope.vm.startDate) + '&eYm=' + encodeURIComponent($scope.vm.endDate) + '&buId=' + encodeURIComponent($scope.vm.buidSelected.id) + '&bigUnitId=' + encodeURIComponent($scope.vm.bigDepSelected.id) + '&businessUnitId=' + encodeURIComponent($scope.vm.unitids) + '&diyCategoryId=' + encodeURIComponent($scope.vm.CuSelected.Id) + '&depType=ToTal_All' + '&top=' + $scope.vm.topsSelected;
            rt.get(TabDataUrl2).then(function (resp) {
                $scope.vm.reportTbData2 = resp.data;
                _showData();
                waiting.close();
            }, function () {
                waiting.close();
            });
            var url = 'api/DistributeAnalysis/GetDistributeAnalysis?sYm=' + encodeURIComponent($scope.vm.startDate) + '&eYm=' + encodeURIComponent($scope.vm.endDate) + '&buId=' + encodeURIComponent($scope.vm.buidSelected.id) + '&bigUnitId=' + encodeURIComponent($scope.vm.bigDepSelected.id) + '&businessUnitId=' + encodeURIComponent($scope.vm.unitids) + '&diyCategoryId=' + encodeURIComponent($scope.vm.CuSelected.Id) + '&sortType=' + encodeURIComponent($scope.vm.sortSelected.Value) + '&pageIndex=' + $scope.vm.pageIndex + '&pageSize=' + $scope.vm.pageSize;
            rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.TotalRecords = resp.data.TotalRecords;
                _MonDataList($scope.vm.startDate, $scope.vm.endDate);
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
        function _showData() {
            var t = $scope.selectedTabId;
            if (t == 'tab1') {
                _show();
            } else if (t == 'tab3') {
                _show2();
            } else if (t == 'tab2') {}
        }
        //达成率图表显示
        function _show() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            var echartsDataName = [];
            var echartsDataValue = [];
            var getData = $scope.vm.reportTbData.DataList;
            if (getData != null && getData.length > 0) {
                for (var i = getData.length - 1; i >= 0; i--) {
                    getData[i].BusinessUnitIdName = getData[i].BusinessUnitIdName == null ? "" : getData[i].BusinessUnitIdName;
                    getData[i].OwnerIdName = getData[i].OwnerIdName == null ? "" : getData[i].OwnerIdName;
                    echartsDataName.push(getData[i].BusinessUnitIdName + "--" + getData[i].OwnerIdName);
                    echartsDataValue.push(getData[i].ToTal_AVG == null ? 0 : rt.xrmRound(getData[i].ToTal_AVG, 2));
                }
            }
            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }

                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '达成率',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}%"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.setOption(option);
        }
        //达成额排名
        function _show2() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            var echartYName = [];
            var echartsData = [];
            var getData = $scope.vm.reportTbData2.DataList;
            if (getData != null && getData.length > 0) {
                for (var i = getData.length - 1; i >= 0; i--) {
                    getData[i].BusinessUnitIdName = getData[i].BusinessUnitIdName == null ? "" : getData[i].BusinessUnitIdName;
                    getData[i].OwnerIdName = getData[i].OwnerIdName == null ? "" : getData[i].OwnerIdName;
                    echartYName.push(getData[i].BusinessUnitIdName + "--" + getData[i].OwnerIdName);
                    echartsData.push(getData[i].ToTal_All == null ? 0 : rt.xrmRound(getData[i].ToTal_All, 2));
                }
            }
            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} 万'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartYName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }

                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '达成额',
                    type: 'bar',
                    data: echartsData,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}万"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.setOption(option);
        }
        init();
    }
    angular.module('xrmApp').service('DrService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DistributeAnalysis';
        // @@ 选项集
        this.picklists = [];
    }]).controller("DrListController", ['$scope', '$q', '$timeout', 'rt', '$injector', 'DrService', DrListController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/5/9
 说明     : 医生DC量统计
 *********************************************************/
(function () {
    'use strict';

    function DoctorDCReportController($scope, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: moment($scope.vm.sYm).format('YYYY-MM') });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: moment($scope.vm.eYm).format('YYYY-MM') });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        function init() {
            $scope.vm.reportData = []; //表格数据
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.sYm = moment().format('YYYY-MM');
            $scope.vm.eYm = moment().format('YYYY-MM');
            $scope.vm.showReportData = _showReportData; //查询按钮
            $scope.vm.getReportData = _getReportData; //分页
        }

        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }

            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始年月不能大于结束年月";
            }

            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }

            return "";
        }

        $scope.complateTableheight = function () {
            _complateTableheight();
        };

        //计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _showReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return;
            }

            $scope.vm.pageIndex = 1;
            _getReportData();
        }

        function _getReportData() {
            var waiting = rt.showLoading2();
            var apiUrl = "api/DoctorDCReport/GetTableData";
            apiUrl += "?sYm=" + encodeURIComponent(moment($scope.vm.sYm).format('YYYY-MM'));
            apiUrl += "&eYm=" + encodeURIComponent(moment($scope.vm.eYm).format('YYYY-MM'));
            apiUrl += "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex);
            apiUrl += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            rt.get(apiUrl).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }

        init();
    }

    angular.module('xrmApp').service('DoctorDCReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'DoctorDCReport';
    }]);
    angular.module('xrmApp').controller("DoctorDCReportController", ['$scope', '$timeout', 'rt', '$injector', 'DoctorDCReportService', DoctorDCReportController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-10-9
 说明     : 客户热度（按医生）
 ********************************************************/
(function () {
    'use strict';

    function doctorheatreportController($scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            var unitids = _CalculateUnitids();
            _that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigdepart", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            _getAllBuid();
            var units = null;
            $scope.vm.sYm = moment().format('YYYY-MM' + '-01');
            $scope.vm.eYm = moment($scope.vm.endYM).format('YYYY-MM-DD');
        }

        //查询
        $scope.vm.showReport = function () {
            var msg = _checkOption();

            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var bigdepart = "";
            var unitids = _CalculateUnitids();

            if (!rt.isNull($scope.vm.buidSelected)) {
                bigdepart = $scope.vm.bigDepSelected.id;
            }

            var buid = $scope.vm.buidSelected.id;
            _getAverage(buid, bigdepart, unitids).then(null, function (message) {
                rt.errorMessage(message);
            });
            _getReportData(buid, bigdepart, unitids).then(null, function (message) {
                rt.errorMessage(message);
            });
        };

        //条件检查
        function _checkOption() {

            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "开始时间不能为空";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "结束时间不能为空";
            }

            if (moment($scope.vm.sYm) > moment($scope.vm.eYm)) {
                return "参数异常[开始日期必须小于等于结束日期.]";
            }
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        function _getReportData(buid, bigdepart, unitids) {
            var waiting = rt.showLoading2();
            var url = 'api/DoctorHeatReport/GetDoctorHeatReport?sYm=' + encodeURIComponent($scope.vm.sYm) + '&eYm=' + encodeURIComponent($scope.vm.eYm) + '&buId=' + encodeURIComponent(buid) + "&bigDepId=" + encodeURIComponent(bigdepart) + '&unitIds=' + encodeURIComponent(unitids) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        //获取均值
        function _getAverage(buid, bigdepart, unitids) {
            var url = 'api/DoctorHeatReport/GetDoctorHeatAvgData?sYm=' + encodeURIComponent($scope.vm.sYm) + '&eYm=' + encodeURIComponent($scope.vm.eYm) + '&buId=' + encodeURIComponent(buid) + "&bigDepId=" + encodeURIComponent(bigdepart) + '&unitIds=' + encodeURIComponent(unitids);
            return rt.get(url).then(function (resp) {
                $scope.avgNum = resp.data[0].avgNum;
                $scope.avgDayCount = resp.data[0].avgDayCount;
                $scope.sumNum = resp.data[0].sumNum;
            });
        }

        function _CalculateUnitids() {
            var unitids = "";

            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            return unitids;
        }
    }

    angular.module('xrmApp').service('DoctorHeatReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DoctorHeatReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("doctorheatreportController", ['$scope', '$injector', 'rt', 'DoctorHeatReportService', doctorheatreportController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2016-10-08
 说明     : 代表拜访分析(医生)
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('DoctorVisitedAnalysisService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DoctorVisitedAnalysis';
        // @@ 选项集
        this.picklists = [];
    }]).controller("doctorvisitedanalysisController", ['$scope', '$q', 'rt', '$injector', 'DoctorVisitedAnalysisService', doctorvisitedanalysisController]);
    function doctorvisitedanalysisController($scope, $q, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.startYM });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.startYM = moment(moment().format('YYYY-MM') + '-01').format('YYYY-MM-DD');
            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };
            _getAllBuid();
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            });
        }

        //检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.startYM)) {
                return "开始时间不能为空。";
            }
            return "";
        }

        function _getReportData() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            var waiting = rt.showLoading2();
            var url = "api/DoctorVisitedAnalysis/GetDoctorVisitGrid";
            url += "?sYm=" + encodeURIComponent($scope.vm.startYM);
            url += "&accountRank=";
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);
            url += "&businessIds=" + encodeURIComponent(unitids);
            url += "&buId=" + encodeURIComponent($scope.vm.buidSelected.id);
            url += "&bigUnitId=" + encodeURIComponent($scope.vm.bigDepSelected.id);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }
    }
})();
"use strict";

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/2/15
 *描述：导出药品流向数据
 *************************************************/
(function () {
    'use strict';

    function drugflowExcelExportController($scope, rt) {
        function init() {
            $scope.vm = {};
            $scope.vm.Data = [];
            $scope.vm.DataLeast = [];
            $scope.vm.export = _export;
        }
        $scope.getExcelData = function () {
            var url = "api/drugflow/ExportExcelData?exportDate=" + $scope.vm.exportDate;
            return rt.get(url);
        };
        $scope.downloadfile = function (fileId) {
            rt.downloadFile("temp", fileId); //下载导出的excel表
        };
        function _export() {
            if (rt.isNullOrWhiteSpace($scope.vm.exportDate)) {
                rt.errorMessage("年月不能为空。");
                return;
            }
            var waiting = rt.showLoading2();
            $scope.getExcelData().then(function (data) {
                waiting.close();
                var fileId = data.data; //文件唯一标识guid
                $scope.downloadfile(fileId);
            }, function () {
                waiting.close();
            });
        }
        init();
    }

    angular.module("xrmApp").controller("drugflowExcelExportController", ['$scope', 'rt', drugflowExcelExportController]);
})();
"use strict";

/*************************************************
 * Copyright (c) 2016 Microsoft All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *版本号：  V1.0.0.0
 *创建人： OscarGao
 *电子邮箱：oscargao@reltect.com.cn
 *创建时间：2016/2/14
 *描述：药品流向导入脚本
 *************************************************/
(function () {
    'use strict';

    angular.module("xrmApp").controller("drugflowExcelImportController", ['$scope', 'rt', drugflowExcelImportController]);
    function drugflowExcelImportController($scope, rt) {
        function init() {
            $scope.importStatus = "";
            $scope.errorFileId = "";
            $scope.selectedFiles = null;
            $scope.selectedFileName = null;
            $scope.import = _import;
            $scope.downloadErrorFile = _downloadErrorFile;
            $scope.downloadTemplateFile = _downloadTemplateFile;
            $scope.selectFile = _selectFile;
            $scope.vm = {};
            $scope.vm.busiSelected = { Id: '' };
            $scope.vm.unitSelected = { Id: '' };
            $scope.vm.modeType = $scope.$parent.importType; //导入模式
        }
        init();
        function _selectFile(files) {
            if (files && files.length && files.length > 0) {
                $scope.selectedFiles = files;
                $scope.selectedFileName = files[0].name;
            }
        }
        function _importExcel(fileid) {
            var url = "api/DataService/ImportExcel";
            var data = $scope.$parent.importHeader;
            data.FileId = fileid;
            var paramid = "";
            if ($scope.vm.modeType === 2) {
                data.Extra = $scope.vm.modeType + '|' + $scope.vm.importDate + '|' + $scope.vm.unitSelected.Id;
            } else if ($scope.vm.modeType === 3) {
                data.Extra = $scope.vm.modeType + '|' + $scope.vm.importDate + '|' + $scope.vm.unitSelected.Id + '|' + $scope.vm.busiSelected.Id;
            } else {
                data.Extra = $scope.vm.modeType + '|' + $scope.vm.importDate + '|';
            }
            return rt.post(url, data);
        }

        function _downloadTemplateFile() {
            var url = "api/DataService/CreateImportTemplate";
            var data = $scope.$parent.importHeader;
            rt.post(url, data).success(function (id) {
                rt.downloadFile("temp", id); //下载模板
            });
        }

        //下载导入错误日志文件
        function _downloadErrorFile() {
            rt.downloadFile("temp", encodeURIComponent($scope.errorFileId));
        }

        function _import() {
            if ($scope.vm === undefined) {
                $scope.importStatus = " 请选择年月。";
                return;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.importDate)) {
                $scope.importStatus = " 请选择年月。";
                return;
            } else {
                var importDateStr = $scope.vm.importDate;
                var importDateArray = importDateStr.split('-');
                var totalMonth = parseInt(importDateArray[0]) * 12 + parseInt(importDateArray[1]);
                var currentMonth = parseInt(new Date().getFullYear()) * 12 + new Date().getMonth() + 1;
                if (totalMonth > currentMonth) {
                    $scope.importStatus = " 选择年月不能大于当前年月。";
                    return;
                }
            }
            if ($scope.vm.modeType !== 1) {
                if (rt.isNull($scope.vm.unitSelected) || rt.isNullOrWhiteSpace($scope.vm.unitSelected.Id)) {
                    $scope.importStatus = " 请选择省区/地区";
                    return;
                }
            }
            if ($scope.vm.modeType === 3) {
                if (rt.isNull($scope.vm.busiSelected) || rt.isNullOrWhiteSpace($scope.vm.busiSelected.Id)) {
                    $scope.importStatus = " 请选择商业。";
                    return;
                }
            }
            if (!$scope.selectedFiles || !$scope.selectedFiles.length || $scope.selectedFiles.length <= 0) {
                $scope.importStatus = " 请选择Excel文件。";
                return;
            }
            var ym = moment($scope.vm.importDate).year() * 100 + moment($scope.vm.importDate).month() + 1;
            var url = "api/DrugFlowImportLock/IsLockImport?type=" + $scope.vm.modeType + "&ym=" + ym + "&buid=" + ($scope.vm.modeType !== 1 && (rt.isNull($scope.vm.unitSelected) || rt.isNullOrWhiteSpace($scope.vm.unitSelected.Id)) ? "" : $scope.vm.unitSelected.Id) + "&accountid=" + ($scope.vm.modeType === 3 && (rt.isNull($scope.vm.busiSelected) || rt.isNullOrWhiteSpace($scope.vm.busiSelected.Id)) ? "" : $scope.vm.busiSelected.Id);
            rt.get(url).then(function (resp) {
                if (resp.data) {
                    $scope.importStatus = "该条件下流向导入已被锁定。";
                } else {
                    $scope.importStatus = "正在导入中...";
                    $scope.errorFileId = "";
                    var waiting = rt.showWaiting();
                    rt.uploadFile($scope.selectedFiles, "temp", rt.newGuid(), false, function (data) {
                        _importExcel(data).then(function (resp) {
                            if (rt.isNullOrWhiteSpace(resp.data) || resp.data == "") {
                                $scope.importStatus = " 成功。";
                                $scope.$emit('rt-reload');
                            } else {
                                $scope.importStatus = " 失败。";
                                $scope.errorFileId = resp.data;
                            }
                            waiting.close();
                        }, function (resp) {
                            $scope.importStatus = resp.data;
                            waiting.close();
                        });
                    }, function (msg) {
                        waiting.close();
                    });
                }
            });
        }
    }
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017-06-28
 说明     : 流向计算
 ********************************************************/
(function () {
    function DrugFlowSettleController($scope, $injector, rt, myService) {
        var rt = myService.rt;
        var that = this;
        this.searchList = [];

        this.preExport = function () {
            that.searchList.length = 0;

            if (rt.isNullOrEmptyString($scope.vm.yM)) {
                return "请选择计算年月";
            } else {
                that.searchList.push({ Type: 1, Key: "yM", Value: moment($scope.vm.yM).format('YYYY-MM') });
            }

            that.searchList.push({ Type: 1, Key: "tabIndex", Value: $scope.vm.tabIndex });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        $scope.vm.tabIndex = 'line';

        $scope.vm.chooseTab = function (index) {
            $scope.vm.tabIndex = index;
            $scope.vm.pageIndex = 1;
            $scope.vm.query();
        };

        $scope.vm.query = function () {
            if (rt.isNullOrEmptyString($scope.vm.yM)) {
                rt.errorMessage("请选择计算年月");
                return false;
            }

            var waiting = rt.showLoading2();
            switch ($scope.vm.tabIndex) {
                case 'line':
                    myService.GetLineDataList($scope.vm.yM, $scope.vm.pageIndex).success(function (resp) {
                        $scope.vm.lineData = resp.DataList;
                        $scope.vm.lineRecordCount = resp.TotalRecords;
                    }).error(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                    break;
                case 'sum':
                    myService.GetSumDataList($scope.vm.yM, $scope.vm.pageIndex).success(function (resp) {
                        $scope.vm.sumData = resp.DataList;
                        $scope.vm.sumRecordCount = resp.TotalRecords;
                    }).error(function (msg) {
                        rt.errorMessage(msg);
                    }).finally(function () {
                        waiting.close();
                    });
                    break;
                case 'busline':
                    $scope.vm.buslineData = [{
                        bigdepartidName: '临床线',
                        businessunitidName: '安徽-临床线',
                        owneridName: '虚竹',
                        from_accountidName: '浙江医药股份有限公司',
                        billdate: '2017-08-01',
                        saleto_count: 1500.00,
                        settle_amount: 45.00,
                        settle_cal_rule_desc: '1500.00*3.00%'
                    }, {
                        bigdepartidName: '临床线',
                        businessunitidName: '安徽-临床线',
                        owneridName: '虚竹',
                        from_accountidName: '浙江医药股份有限公司',
                        billdate: '2017-08-08',
                        saleto_count: 31504.00,
                        settle_amount: 945.12,
                        settle_cal_rule_desc: '31504.00*3.00%'
                    }, {
                        bigdepartidName: '临床线',
                        businessunitidName: '浙江-临床线',
                        owneridName: '周瑜',
                        from_accountidName: '浙江医药股份有限公司',
                        billdate: '2017-08-07',
                        saleto_count: 1800.00,
                        settle_amount: 54.00,
                        settle_cal_rule_desc: '1800.00*3.00%'
                    }, {
                        bigdepartidName: '商务线',
                        businessunitidName: '安徽-商务线',
                        owneridName: '韦小宝',
                        from_accountidName: '安徽恒通医药有限公司',
                        billdate: '2017-08-04',
                        saleto_count: 15504.00,
                        settle_amount: 620.16,
                        settle_cal_rule_desc: '15504.00*(3.00%+1.00%)'
                    }, {
                        bigdepartidName: 'OTC线',
                        businessunitidName: '海南-OTC线',
                        owneridName: '张学友',
                        from_accountidName: '海南国瑞堂制药有限公司',
                        billdate: '2017-08-04',
                        saleto_count: 14300.00,
                        settle_amount: 429.00,
                        settle_cal_rule_desc: '14300.00*(2.50%+0.50%)'
                    }, {
                        bigdepartidName: 'OTC线',
                        businessunitidName: '海南-OTC线',
                        owneridName: '黎明',
                        from_accountidName: '海南国瑞堂制药有限公司',
                        billdate: '2017-08-05',
                        saleto_count: 13500.00,
                        settle_amount: 405.00,
                        settle_cal_rule_desc: '13500.00*(2.50%+0.50%)'
                    }, {
                        bigdepartidName: '基药线',
                        businessunitidName: '安徽-基药线',
                        owneridName: '翟利州',
                        from_accountidName: '安徽省华硕医药有限公司',
                        billdate: '2017-08-06',
                        saleto_count: 15040.00,
                        settle_amount: 376.00,
                        settle_cal_rule_desc: '15040.00*2.50%'
                    }, {
                        bigdepartidName: '临床线',
                        businessunitidName: '湖北-临床线',
                        owneridName: '本因',
                        from_accountidName: '湖北民生医药有限公司',
                        billdate: '2017-08-07',
                        saleto_count: 8462.00,
                        settle_amount: 253.86,
                        settle_cal_rule_desc: '8462.00*3.00%'
                    }, {
                        bigdepartidName: '基药线',
                        businessunitidName: '广东-基药线',
                        owneridName: '赵琪',
                        from_accountidName: '国泰医药有限公司',
                        billdate: '2017-08-08',
                        saleto_count: 19452.00,
                        settle_amount: 583.56,
                        settle_cal_rule_desc: '19452.00*(2.50%+0.50%)'
                    }, {
                        bigdepartidName: 'OTC线',
                        businessunitidName: '湘赣-OTC线',
                        owneridName: '张飞',
                        from_accountidName: '常德洞庭医药有限公司',
                        billdate: '2017-08-03',
                        saleto_count: 12050.00,
                        settle_amount: 361.50,
                        settle_cal_rule_desc: '12050.00*3.00%'
                    }];
                    $scope.vm.buslineRecordCount = $scope.vm.buslineData.length;
                    waiting.close();

                    break;
                case 'bussum':
                    $scope.vm.bussumData = [{
                        bigdepartidName: '临床线',
                        businessunitidName: '安徽-临床线',
                        owneridName: '虚竹',
                        settle_amount: 990.12
                    }, {
                        bigdepartidName: '临床线',
                        businessunitidName: '浙江-临床线',
                        owneridName: '周瑜',
                        settle_amount: 54.00
                    }, {
                        bigdepartidName: '商务线',
                        businessunitidName: '安徽-商务线',
                        owneridName: '韦小宝',
                        settle_amount: 620.16
                    }, {
                        bigdepartidName: 'OTC线',
                        businessunitidName: '海南-OTC线',
                        owneridName: '张学友',
                        settle_amount: 429.00
                    }, {
                        bigdepartidName: 'OTC线',
                        businessunitidName: '海南-OTC线',
                        owneridName: '黎明',
                        settle_amount: 405.00
                    }, {
                        bigdepartidName: '基药线',
                        businessunitidName: '安徽-基药线',
                        owneridName: '翟利州',
                        settle_amount: 376.00
                    }, {
                        bigdepartidName: '临床线',
                        businessunitidName: '湖北-临床线',
                        owneridName: '本因',
                        settle_amount: 253.86
                    }, {
                        bigdepartidName: '基药线',
                        businessunitidName: '广东-基药线',
                        owneridName: '赵琪',
                        settle_amount: 583.56
                    }, {
                        bigdepartidName: 'OTC线',
                        businessunitidName: '湘赣-OTC线',
                        owneridName: '张飞',
                        settle_amount: 361.50
                    }];
                    $scope.vm.bussumRecordCount = $scope.vm.bussumData.length;
                    waiting.close();

                    break;
                case 'agentsline':
                    $scope.vm.agentslineData = [{
                        bigdepartidName: '临床线',
                        businessunitidName: '安徽-临床线',
                        owneridName: '虚竹',
                        productidName: '罗红霉素',
                        productsize: '75mg×12粒',
                        from_accountidName: '安徽省华硕医药有限公司',
                        to_accountidName: '包河社区服务中心',
                        billdate: '2017-08-01',
                        saleto_count: 15.00,
                        settle_amount: 15.00 * 0.8547,
                        settle_cal_rule_desc: '15.00*85.47%'
                    }, {
                        bigdepartidName: '临床线',
                        businessunitidName: '广东-临床线',
                        owneridName: '王熙凤',
                        productidName: '止咳糖浆',
                        productsize: '120ml',
                        from_accountidName: '国泰医药有限公司',
                        to_accountidName: '深圳市南山区人民医院',
                        billdate: '2017-08-07',
                        saleto_count: 6.00,
                        settle_amount: 6.00 * 0.8547,
                        settle_cal_rule_desc: '6.00*85.47%'
                    }, {
                        bigdepartidName: 'OTC线',
                        businessunitidName: '上海-OTC线',
                        owneridName: '撒贝宁',
                        productidName: '罗红霉素',
                        productsize: '75mg×12粒',
                        from_accountidName: '浙江医药股份有限公司',
                        to_accountidName: '三叶大药房',
                        billdate: '2017-08-12',
                        saleto_count: 4.00,
                        settle_amount: 4.00 * 0.8547,
                        settle_cal_rule_desc: '4.00*85.47%'
                    }, {
                        bigdepartidName: '临床线',
                        businessunitidName: '安徽-临床线',
                        owneridName: '虚竹',
                        productidName: '健胃消食片',
                        productsize: '0.25g×30片',
                        from_accountidName: '安徽省华硕医药有限公司',
                        to_accountidName: '合肥市曙光医院',
                        billdate: '2017-08-14',
                        saleto_count: 13.00,
                        settle_amount: 13.00 * 0.8547,
                        settle_cal_rule_desc: '13.00*85.47%'
                    }, {
                        bigdepartidName: '临床线',
                        businessunitidName: '安徽-临床线',
                        owneridName: '虚竹',
                        productidName: 'a环丙沙星',
                        productsize: '0.25g*10',
                        from_accountidName: '安徽省华硕医药有限公司',
                        to_accountidName: '合肥中医院',
                        billdate: '2017-08-18',
                        saleto_count: 7.00,
                        settle_amount: 7.00 * 0.8547,
                        settle_cal_rule_desc: '7.00*85.47%'
                    }, {
                        bigdepartidName: 'OTC线',
                        businessunitidName: '上海-OTC线',
                        owneridName: '撒贝宁',
                        productidName: '健胃消食片',
                        productsize: '0.25g×30片',
                        from_accountidName: '浙江医药股份有限公司',
                        to_accountidName: '三叶大药房',
                        billdate: '2017-08-18',
                        saleto_count: 16.00,
                        settle_amount: 16.00 * 0.8547,
                        settle_cal_rule_desc: '16.00*85.47%'
                    }, {
                        bigdepartidName: 'OTC线',
                        businessunitidName: '上海-OTC线',
                        owneridName: '撒贝宁',
                        productidName: 'a环丙沙星',
                        productsize: '0.25g*10',
                        from_accountidName: '浙江医药股份有限公司',
                        to_accountidName: '三叶大药房',
                        billdate: '2017-08-20',
                        saleto_count: 11.00,
                        settle_amount: 11.00 * 0.8547,
                        settle_cal_rule_desc: '11.00*85.47%'
                    }, {
                        bigdepartidName: '临床线',
                        businessunitidName: '安徽-临床线',
                        owneridName: '虚竹',
                        productidName: '止咳糖浆',
                        productsize: '120ml',
                        from_accountidName: '安徽省华硕医药有限公司',
                        to_accountidName: '安庆市第二人民医院',
                        billdate: '2017-08-20',
                        saleto_count: 5.00,
                        settle_amount: 5.00 * 0.8547,
                        settle_cal_rule_desc: '5.00*85.47%'
                    }, {
                        bigdepartidName: '临床线',
                        businessunitidName: '安徽-临床线',
                        owneridName: '虚竹',
                        productidName: '止咳糖浆',
                        productsize: '120ml',
                        from_accountidName: '安徽省华硕医药有限公司',
                        to_accountidName: '淮南市人民医院',
                        billdate: '2017-08-25',
                        saleto_count: 18.00,
                        settle_amount: 18.00 * 0.8547,
                        settle_cal_rule_desc: '18.00*85.47%'
                    }, {
                        bigdepartidName: 'OTC线',
                        businessunitidName: '上海-OTC线',
                        owneridName: '撒贝宁',
                        productidName: '止咳糖浆',
                        productsize: '120ml',
                        from_accountidName: '浙江医药股份有限公司',
                        to_accountidName: '三叶大药房',
                        billdate: '2017-08-25',
                        saleto_count: 8.00,
                        settle_amount: 8.00 * 0.8547,
                        settle_cal_rule_desc: '8.00*85.47%'
                    }];
                    $scope.vm.agentslineRecordCount = $scope.vm.agentslineData.length;
                    waiting.close();

                    break;
                case 'agentssum':
                    $scope.vm.agentssumData = [{
                        bigdepartidName: '临床线',
                        businessunitidName: '安徽-临床线',
                        owneridName: '虚竹',
                        settle_amount: 49.56
                    }, {
                        bigdepartidName: '临床线',
                        businessunitidName: '广东-临床线',
                        owneridName: '王熙凤',
                        settle_amount: 5.13
                    }, {
                        bigdepartidName: 'OTC线',
                        businessunitidName: '上海-OTC线',
                        owneridName: '撒贝宁',
                        settle_amount: 33.34
                    }];
                    $scope.vm.agentssumRecordCount = $scope.vm.agentssumData.length;
                    waiting.close();

                    break;
            }
        };

        $scope.vm.calculate = function () {
            if (rt.isNullOrEmptyString($scope.vm.yM)) {
                rt.errorMessage("请选择计算年月");
                return false;
            }

            var waiting = rt.showWaiting();
            myService.CalculateDrugFlowSettle($scope.vm.yM).success(function () {
                rt.successMessage("计算成功");
                $scope.vm.pageIndex = 1;
                $scope.vm.query();
            }).error(function (msg) {
                rt.errorMessage(msg);
            }).finally(function () {
                waiting.close();
            });
        };
    }
    angular.module('xrmApp').service('DrugFlowSettleService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'DrugFlowSettle';

        //流向结算明细
        this.GetLineDataList = function (yM, pageIndex) {
            var api = "api/DrugFlowSettle/GetLineDataList?yM=" + encodeURIComponent(yM) + "&pageIndex=" + encodeURIComponent(pageIndex) + "&pageSize=" + rt.getPaginationSize();
            return rt.get(api);
        };

        //按推广人汇总
        this.GetSumDataList = function (yM, pageIndex) {
            var api = "api/DrugFlowSettle/GetSumDataList?yM=" + encodeURIComponent(yM) + "&pageIndex=" + encodeURIComponent(pageIndex) + "&pageSize=" + rt.getPaginationSize();
            return rt.get(api);
        };

        //计算
        this.CalculateDrugFlowSettle = function (yM) {
            var api = "api/DrugFlowSettle/CalculateDrugFlowSettle?yM=" + encodeURIComponent(yM);
            return rt.get(api);
        };
    }]).controller("DrugFlowSettleController", ['$scope', '$injector', 'rt', 'DrugFlowSettleService', DrugFlowSettleController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2017/12/7
 说明     : 按部门流向统计
 *********************************************************/
(function () {
    'use strict';

    function DistributionFlowListController($scope, $q, $compile, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            // var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            var accountLevel_selected = "";
            var pids = "";
            if (!rt.isNull($scope.vm.accountLevel_selected) && !rt.isNull($scope.vm.accountLevel_selected.Value)) {
                accountLevel_selected = $scope.vm.accountLevel_selected.Value;
            }
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join(",");
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "productIds", Value: pids });
            _that.searchList.push({ Type: 1, Key: "accountLevel", Value: accountLevel_selected });
            _that.searchList.push({ Type: 1, Key: "businessunits", Value: unitids });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        function init() {
            //时间筛选，默认全年
            $scope.dateSelect = 'fullYear';
            $scope.vm.sYm = moment().format('YYYY-01');
            $scope.vm.eYm = moment().format('YYYY-12');

            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.accountLevel = [''];
            $scope.vm.accountLevel_selected = '';
            _getAllProduct();
            _getAccountLevel();
        }
        function _getAccountLevel() {
            var url = 'api/businessaccount/GetPickListData?fieldCodes=account_grade_level';
            rt.get(url).then(function (resp) {
                if (!rt.isNull(resp.data) && !rt.isNull(resp.data.account_grade_level)) {
                    $scope.vm.accountLevel = resp.data.account_grade_level;
                }
            });
        }
        //获取产品
        function _getAllProduct() {
            var url = 'api/ProductCategory/GetSmallestDataList';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }

        $scope.typeSelecttClick = function (selected) {
            $scope.typeSelect = selected;
        };

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            return "";
        }

        // function _getHeader(date) {

        //     myService.GetHandelProduct(date)
        //         .then(function (resp) {
        //             $scope.vm.productlist.push(resp.data.length);
        //             for (var j = 0; j < resp.data.length; j++) {
        //                 var ss = resp.data[j].productidname;
        //                 $scope.vm.aa = resp.data.length;
        //                 $scope.vm.TbMessText.push(ss);
        //                 //$scope.vm.ll = resp.data.length;                                                                           
        //             }
        //         });
        // }

        //计算报表应有宽度
        function _complateTableweight() {
            $scope.tableMaxWeight = $(window).width() + "px";
        }

        //选择时间筛选
        $scope.vm.changeDate = function (dateType) {
            $scope.dateSelect = dateType;

            switch (dateType) {
                case "fullYear":
                    $scope.vm.sYm = moment().format('YYYY-01');
                    $scope.vm.eYm = moment().format('YYYY-12');
                    break;
                case "thisMonth":
                    $scope.vm.sYm = moment().format('YYYY-MM');
                    $scope.vm.eYm = moment().format('YYYY-MM');
                    break;
                case "lastMonth":
                    $scope.vm.sYm = moment().add(-1, 'months').format('YYYY-MM');
                    $scope.vm.eYm = moment().add(-1, 'months').format('YYYY-MM');
                    break;
                case "thisQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-10');
                            $scope.vm.eYm = moment().format('YYYY-12');
                            break;
                    }
                    break;
                case "lastQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().add(-1, 'years').format('YYYY-10');
                            $scope.vm.eYm = moment().add(-1, 'years').format('YYYY-12');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;pivotUtilities;
                    }
                    break;
            }
        };

        function _getreport(data) {
            var utils = $.pivotUtilities;
            var sam = utils.aggregators["Sum"];
            var sortAs = utils.sortAs;
            $("#rt-report").pivot(data, {
                rows: ["BusinessUnitIdName", "businessunitowneridname", "accountnum"], //区域，负责人，门店数
                cols: ["Product_CategoryIdName", "type"], //品种，铺货数，铺货率
                sorters: { BusinessUnitIdName: function BusinessUnitIdName(a, b) {
                        return a.localeCompare(b, 'zh-Hans-CN', { sensitivity: 'accent' });
                    } }, //排序
                aggregator: function aggregator(data, rowKey, colKey) {
                    return {
                        s1: '',
                        sum: 0,
                        push: function push(record) {
                            if (record["type"] == "铺货数") {
                                this.s1 = "铺货数";
                                if (!isNaN(parseInt(record["result"]))) {
                                    return this.sum += parseInt(record["result"]);
                                }
                            } else {
                                this.s1 = "铺货率";
                                if (!isNaN(parseFloat(record["result"]))) {
                                    return this.sum += record["result"];
                                }
                            }
                        },
                        value: function value() {
                            return this.sum;
                        },
                        format: function format(x) {
                            if (this.s1 == "铺货数") {
                                return x;
                            } else {
                                return (x * 100).toFixed(2) + '%';
                            }
                        }
                    };
                }
            });

            $('th.pvtAxisLabel').map(function (i) {
                if ($('th.pvtAxisLabel')[i].innerText == "BusinessUnitIdName") $('th.pvtAxisLabel')[i].innerText = "区域";
                if ($('th.pvtAxisLabel')[i].innerText == "businessunitowneridname") $('th.pvtAxisLabel')[i].innerText = "负责人";
                if ($('th.pvtAxisLabel')[i].innerText == "accountnum") $('th.pvtAxisLabel')[i].innerText = "门店数";
                if ($('th.pvtAxisLabel')[i].innerText == "Product_CategoryIdName") $('th.pvtAxisLabel')[i].innerText = "品种";
                if ($('th.pvtAxisLabel')[i].innerText == "type") $('th.pvtAxisLabel')[i].innerText = "数据";
            });
            $('th.pvtTotalLabel').map(function (i) {
                $(".pvtTotalLabel").remove();
                $(".pvtTotal").remove();
                $(".pvtGrandTotal").remove();
            });
        }

        //查询报表数据
        $scope.vm.getReportData = function () {
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var accountLevel_selected = "";
            var pids = "";
            if (!rt.isNull($scope.vm.accountLevel_selected) && !rt.isNull($scope.vm.accountLevel_selected.Value)) {
                accountLevel_selected = $scope.vm.accountLevel_selected.Value;
            }
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join(",");
            }
            var waiting = rt.showLoading2();

            $scope.isQtyShow = false;
            //动销，流向铺货率列表
            myService.GetDrugflowReport($scope.vm.sYm, $scope.vm.eYm, pids, accountLevel_selected, unitids).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _getreport($scope.vm.reportData.DataList);
                _complateTableweight();
                waiting.close();
            });
        };
        init();
    }
    angular.module('xrmApp').service('DistributionFlowService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DrugFlow';
        this.picklists = ['StateCode', 'accountLevel'];

        //动销，流向铺货率列表
        this.GetDrugflowReport = function (sYm, eYm, productIds, accountLevel, unitids) {
            return rt.post("api/DrugFlow/GetDrugFlowReport?sYm=" + sYm + "&eYm=" + eYm + "&productIds=" + productIds + "&accountLevel=" + accountLevel, unitids);
        };
    }]);
    angular.module('xrmApp').controller("DistributionFlowListController", ['$scope', '$q', '$compile', 'rt', '$injector', 'DistributionFlowService', DistributionFlowListController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/5/6
 说明     : 代表指标达成
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('PureOwnerTargetService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'PureOwnerTarget';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("HospitalOwnerTargetListController", ['$scope', '$injector', '$timeout', 'rt', 'PureOwnerTargetService', function ($scope, $injector, $timeout, rt, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigDeptId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "businessUnitId", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "customCategoryId", Value: $scope.vm.CuSelected.Id });
            _that.searchList.push({ Type: 1, Key: "orderByType", Value: $scope.vm.orderbyTypeCode.value });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();
        function init() {
            var cw = document.documentElement.clientWidth || document.body.clientWidth;
            $scope.chartWidth = 1000;
            $scope.vm.buidList = []; //事业部下拉
            $scope.vm.buidSelected = { id: '' }; //事业部选择
            $scope.vm.bigDepList = []; //业务线/大区下拉
            $scope.vm.bigDepSelected = { id: '' }; //业务线/大区选择
            $scope.vm.businessUnitList = []; //省区/地区下拉
            $scope.vm.businessUnitSelected = null; //省区/地区选择
            $scope.vm.reportData = []; //表格数据
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.imgData = []; //图标数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.MonDataName = []; //每个月份对应文本属性名
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TbHeCosNum = 4;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();

            $scope.vm.getReportData = _getReportData; //查询按钮
            $scope.vm.getDataList = _getDataList; //点击列表分页的查询
            $scope.selectedTabId = "tab1";
            $scope.selectTab = _selectTab;

            _initYmSelected();
            _getTops();
            _getOrderbyTypes();
            _getAllBuid(); //获取所有事业部
            _getCustomcategory();
        }

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[0];
        }

        function _getOrderbyTypes() {
            $scope.vm.orderbyTypeList = [{ value: 'Sum_Percent_Rank', name: '达成率' }, {
                value: 'Sum_Done_Rank',
                name: '达成额'
            }];
            $scope.vm.orderbyTypeCode = $scope.vm.orderbyTypeList[0];
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ id: '', name: '全部事业部' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            });
        }

        //获取大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [{ name: '全部业务线/大区', id: '' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
                return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            $scope.vm.TbHeCosNum += (MCount + 1) * 3;
            var DeMessText = ["指标", "达成额", "达成率"];
            var DeMessName = ["{{vm.reportData[0].target" + parseInt(sArr[1]) + "}}", "{{vm.reportData.DataList[0].row.done" + parseInt(sArr[1]) + "}}", "{{vm.reportData.DataList[0].row.donepercent" + parseInt(sArr[1]) + "}}"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("指标", "达成额", "达成率");
                    $scope.vm.MonDataName.push("row.target" + NMon, "row.done" + NMon, "row.donepercent" + NMon);
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("指标", "达成额", "达成率");
                $scope.vm.MonDataName.push("row.target" + (parseInt(sArr[1]) + MCount), "row.done" + (parseInt(sArr[1]) + MCount), "row.donepercent" + (parseInt(sArr[1]) + MCount));
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
                $scope.vm.MonDataName = DeMessName;
            }
        }

        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }

            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始年月不能大于结束年月";
            }

            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }

            if (rt.isNull($scope.vm.CuSelected) || rt.isNullOrWhiteSpace($scope.vm.CuSelected.Id)) {
                return "指标类型不能为空";
            }
            return "";
        }

        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var waiting = rt.showLoading2();
            //获取图表数据(达成率排名)
            var urlPercent = 'api/PureOwnerTarget/GetTsSrTargetDoneByownerRank?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigDeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitId=" + encodeURIComponent(unitids) + "&customCategoryId=" + $scope.vm.CuSelected.Id + "&orderByType=Done_Percent" + "&top= TOP " + $scope.vm.topsSelected + "&pageIndex=1" + "&pageSize=50";
            rt.get(urlPercent).then(function (resp) {
                $scope.vm.percentData = resp.data;
                _show();
            }, function (message) {
                rt.errorMessage(message);
            }).finally(function () {
                waiting.close();
            });

            //获取图表数据(达成额排名)
            var urlAmount = 'api/PureOwnerTarget/GetTsSrTargetDoneByownerRank?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigDeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitId=" + encodeURIComponent(unitids) + "&customCategoryId=" + $scope.vm.CuSelected.Id + "&orderByType=Sum_Done_Amount" + "&top= TOP " + $scope.vm.topsSelected + "&pageIndex=1" + "&pageSize=50";
            rt.get(urlAmount).then(function (resp) {
                $scope.vm.amountData = resp.data;
                _show();
            }, function (message) {
                rt.errorMessage(message);
            }).finally(function () {
                waiting.close();
            });

            _getDataList();
        }

        function _getDataList() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var waiting = rt.showLoading2();
            //获取达成列表数据
            var url = 'api/PureOwnerTarget/GetTsSrTargetDoneByownerList?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigDeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitId=" + encodeURIComponent(unitids) + "&customCategoryId=" + $scope.vm.CuSelected.Id + "&orderByType=" + $scope.vm.orderbyTypeCode.value + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize);
            rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _MonDataList($scope.vm.sYm, $scope.vm.eYm);
                _complateTableheight();
            }, function (message) {
                rt.errorMessage(message);
            }).finally(function () {
                waiting.close();
            });
        }

        $scope.selectedTabId = 'tab1';
        function _selectTab(id) {
            $scope.selectedTabId = id;
            _show();
        }

        function _show() {
            var t = $scope.selectedTabId;
            if (t == "tab1") {
                _showReport1();
            } else if (t == "tab2") {
                _showReport2();
            }
        }

        function _showReport1() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.percentData.DataList;
            for (var i = dataList.length - 1; i >= 0; i--) {
                echartsDataValue.push(dataList[i].Done_Percent.toFixed(2));
                echartsDataName.push(dataList[i].BusinessUnitIdName + '--' + dataList[i].OwnerIdName);
            }
            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '累计达成率',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}%"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        function _showReport2() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.amountData.DataList;
            for (var i = dataList.length - 1; i >= 0; i--) {
                echartsDataValue.push(dataList[i].Sum_Done_Amount.toFixed(2));
                echartsDataName.push(dataList[i].BusinessUnitIdName + '--' + dataList[i].OwnerIdName);
            }

            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}万元'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '累计达成额',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}万元"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        //--通过接口获取所有自定义分类（代表层级）--//
        function _getCustomcategory() {
            var url = 'api/CustomCategory/GetCustomCategoryByTaskType?taskType=3&taskLevel=2';
            return rt.get(url).then(function (resp) {
                $scope.vm.customcategoryList = resp.data;
                if ($scope.vm.customcategoryList.length > 0) {
                    $scope.vm.CuSelected = $scope.vm.customcategoryList[0];
                } else {
                    $scope.vm.CuSelected = null;
                }
            });
        }

        init();
    }]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/5/09
 说明     : 医院纯销统计
 *********************************************************/
(function () {
    'use strict';

    function HospitalPureVenditionController($scope, $injector, $q, $timeout, $stateParams, rt, myService) {
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var accountids = "";
            if (!rt.isNull($scope.vm.accSelected)) {
                var accountsmap = _.map($scope.vm.accSelected, 'Id');
                accountids = accountsmap.join(",");
            }

            var productids = "";
            if (!rt.isNull($scope.vm.productSelected)) {
                var productsmap = _.map($scope.vm.productSelected, 'Id');
                productids = productsmap.join(",");
            }

            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitsmap = _.map($scope.vm.businessUnitSelected, 'id');
                unitids = unitsmap.join(",");
            }

            $scope.vm.view.searchList = [];
            $scope.vm.view.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            $scope.vm.view.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            $scope.vm.view.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            $scope.vm.view.searchList.push({ Type: 1, Key: "bigdeptId", Value: $scope.vm.bigDepSelected.id });
            $scope.vm.view.searchList.push({ Type: 1, Key: "businessunits", Value: unitids });
            $scope.vm.view.searchList.push({ Type: 1, Key: "accountIds", Value: accountids });
            $scope.vm.view.searchList.push({ Type: 1, Key: "productIds", Value: productids });
            $scope.vm.view.searchList.push({ Type: 1, Key: "entType", Value: $scope.vm.entType });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        function init() {
            $scope.vm.buidList = []; //事业部下拉
            $scope.vm.buidSelected = { Id: '' }; //事业部选择
            $scope.vm.bigDepList = []; //业务线/大区下拉
            $scope.vm.bigDepSelected = { Id: '' }; //业务线/大区选择
            $scope.vm.businessUnitList = []; //省区/地区下拉
            $scope.vm.businessUnitSelected = null; //省区/地区选择         
            $scope.vm.accList = []; //医院下拉
            $scope.vm.accSelected = null; //医院选择
            $scope.vm.productList = []; //药品名称下拉
            $scope.vm.productSelected = null; //药品名称选择
            $scope.vm.reportData = []; //表格数据
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.imgData = []; //图标数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.MonDataName = []; //每个月份对应文本属性名
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TbHeCosNum = 4;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.paramUnitids = '';
            $scope.vm.getReportData = _getReportData; //查询按钮
            $scope.vm.ClickBusiness = _clickBusiness;
            _initYmSelected();
            _getAllBuid(); //获取所有事业部
        }
        init();

        $scope.vm.entType = $stateParams.entType ? $stateParams.entType : 2; //模块终端类型
        $scope.vm.moduleName = _getModuleName($scope.vm.entType); //模块名称
        $scope.vm.exportFileName = '按' + $scope.vm.moduleName + '纯销统计';
        //根据模块参数获取模块名称
        function _getModuleName(entType) {
            var str = '医院';
            entType = rt.isNullOrWhiteSpace(entType) ? 2 : parseInt(entType);
            switch (entType) {
                case 1:
                    str = '商业';break;
                case 2:
                    str = '医院';break;
                case 3:
                    str = '门店';break;
                case 4:
                    str = '基层医疗机构';break;
            }
            return str;
        }
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = [{ id: '', name: '全部事业部' }];
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.concat(data);
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            });
        }

        //链接省区/地区id集合 不带''间隔的
        function _JoinUnitIds() {
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                return unitmap.join(",");
            }
            return "";
        }

        //业务大区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (newValue != oldValue) {
                $scope.vm.accList.length = 0;
                $scope.vm.paramUnitids = _JoinUnitIds();
            }
        });
        //计算省区的参数值
        function _clickBusiness() {
            $scope.vm.accList.length = 0;
            $scope.vm.paramUnitids = _JoinUnitIds();
        }

        //获取业务线/大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.bigDepList = [{ name: '全部业务线/大区', id: '' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { Id: '' };
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                        $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            $scope.vm.TbHeCosNum += (MCount + 1) * 2;
            var DeMessText = ["数量", "金额（万元）"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("数量", "金额（万元）");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("数量", "金额（万元）");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }

        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 50);
            }, 0);
        }
        // 检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }

            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始年月不能大于结束年月";
            }

            if (moment($scope.vm.sYm).format("YYYY") !== moment($scope.vm.eYm).format("YYYY")) {
                return "只可查询同一年的数据";
            }

            return "";
        }
        function _getReportData() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var accountids = "";
            if (!rt.isNull($scope.vm.accSelected)) {
                var accountsmap = _.map($scope.vm.accSelected, 'Id');
                accountids = accountsmap.join(",");
            }

            var productids = "";
            if (!rt.isNull($scope.vm.productSelected)) {
                var productsmap = _.map($scope.vm.productSelected, 'Id');
                productids = productsmap.join(",");
            }

            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitsmap = _.map($scope.vm.businessUnitSelected, 'id');
                unitids = unitsmap.join(",");
            }

            var waiting = rt.showLoading2();
            var url = 'api/HospitalPureVendition/GetHospitalPureVendition?sYm=' + $scope.vm.sYm + "&eYm=" + $scope.vm.eYm + "&buid=" + $scope.vm.buidSelected.id + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessunits=" + encodeURIComponent(unitids) + "&accountIds=" + encodeURIComponent(accountids) + "&productIds=" + encodeURIComponent(productids) + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize) + "&entType=" + encodeURIComponent($scope.vm.entType);

            rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _MonDataList($scope.vm.sYm, $scope.vm.eYm);
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
    }
    angular.module('xrmApp').service('HospitalPureVenditionService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'HospitalPureVendition';
        // @@ 选项集
        this.picklists = [];
    }]).controller("HospitalPureVenditionController", ['$scope', '$injector', '$q', '$timeout', '$stateParams', 'rt', 'HospitalPureVenditionService', HospitalPureVenditionController]);
})();
"use strict";

/*************************************************
 * Copyright (c) 2016 苏州瑞泰信息技术有限公司 All Rights Reserved.
 *公司名称：苏州瑞泰信息技术有限公司
 *创建人： osCar Gao
 *创建时间：2016/7/14
 *描述：纯销代表指标导入
 *************************************************/
(function () {
    'use strict';

    angular.module("xrmApp").controller("OwnerExcelImportController", ['$scope', 'rt', OwnerExcelImportController]);
    function OwnerExcelImportController($scope, rt) {
        init();

        function init() {
            $scope.importStatus = "";
            $scope.errorFileId = "";
            $scope.selectedFiles = null;
            $scope.selectedFileName = null;

            $scope.import = _import;
            $scope.downloadErrorFile = _downloadErrorFile;
            $scope.downloadTemplateFile = _downloadTemplateFile;
            $scope.selectFile = _selectFile;
        }

        function _selectFile(files) {
            if (files && files.length && files.length > 0) {
                $scope.selectedFiles = files;
                $scope.selectedFileName = files[0].name;
            }
        }
        function _importExcel(fileid) {
            var url = "api/DataService/ImportExcel";
            var data = $scope.$parent.vm.importHeader;
            data.FileId = fileid;
            data.Extra = ""; //额外参数
            return rt.post(url, data);
        }

        function _downloadTemplateFile() {
            var url = "api/DataService/CreateImportTemplate";
            var data = $scope.$parent.vm.importHeader;
            rt.post(url, data).success(function (id) {
                rt.downloadFile("account", id); //下载模板
            });
        }

        //下载导入错误日志文件
        function _downloadErrorFile() {
            rt.downloadFile("temp", encodeURIComponent($scope.errorFileId));
        }

        function _import() {
            $scope.importStatus = "正在导入中...";
            $scope.errorFileId = "";
            var waiting = rt.showWaiting();
            rt.uploadFile($scope.selectedFiles, "temp", rt.newGuid(), false, function (data) {
                _importExcel(data).then(function (resp) {
                    if (rt.isNullOrWhiteSpace(resp.data) || resp.data == "") {
                        $scope.importStatus = " 成功。";
                        $scope.$emit('rt-reload');
                    } else {
                        $scope.importStatus = " 失败。";
                        $scope.errorFileId = resp.data;
                    }
                }, function (resp) {
                    $scope.importStatus = resp.data;
                }).finally(function () {
                    waiting.close();
                });
            }, function (msg) {
                $scope.importStatus = " 失败。" + msg;
                rt.errorMessage(msg);
                waiting.close();
            });
        }
    }
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2016-07-15
 说明     : 同步代表指标到部门指标
 *********************************************************/
(function () {
    'use strict';

    angular.module("xrmApp").controller("syncTaskController", ['$scope', 'rt', syncTaskController]);
    function syncTaskController($scope, rt) {
        function init() {
            $scope.syncMissionTask = _syncMissionTask;
        }
        init();
        function _syncMissionTask() {
            if (rt.isNullOrWhiteSpace($scope.importDate)) {
                rt.errorMessage("请输入所属年月。");
                return;
            }
            var waiting = rt.showWaiting();
            $scope.importStatus = "正在同步中...";
            _syncData($scope.importDate).then(function (resp) {
                if (rt.isNullOrWhiteSpace(resp.data)) {
                    $scope.importStatus = " 成功。";
                    $scope.$emit('rt-reload');
                } else {
                    $scope.importStatus = resp.data;
                }
                waiting.close();
            }, function (msg) {
                $scope.importStatus = ' 失败。';
                waiting.close();
            });
        }
        //同步数据
        function _syncData(importDate) {
            var api = "api/HospitalSaleTask/SyncDelegateMissionTaskToDep?importDate=" + importDate;
            return rt.get(api);
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/5/11
 说明     : 重点医院指标达成
 *********************************************************/

(function () {
    'use strict';

    function ImportantHospitalTargetListController($scope, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }

            var _diyCategoryId = $scope.vm.cuSelected.Id;
            if ($scope.vm.typeSelect == 'noCustomCategory') {
                _diyCategoryId = '';
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "businessunitid", Value: $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "" });
            _that.searchList.push({ Type: 1, Key: "orderbyType", Value: $scope.vm.orderbyTypeCode.id });
            _that.searchList.push({ Type: 1, Key: "isShowOwner", Value: $scope.vm.isShowOwner });
            _that.searchList.push({ Type: 1, Key: "typeSelect", Value: $scope.vm.typeSelect });
            _that.searchList.push({ Type: 1, Key: "diyCategoryId", Value: _diyCategoryId });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.imgData = []; //图标数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.MonDataName = []; //每个月份对应文本属性名
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TbHeCosNum = 6;
            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            //类型筛选，默认不显示代表,不分指标类型
            $scope.vm.isShowOwner = false;
            $scope.vm.typeSelect = 'noCustomCategory';

            $scope.vm.getReportData = _getReportData; //查询按钮
            _initYmSelected(); //初始化年月筛选
            _getOrderbyTypes();
            _getCustomcategory(); //获取指标类型
        }

        //查询、导出前检查条件
        function _checkOption() {
            //组合条件
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }

            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始年月不能大于结束年月";
            }

            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }

            if (rt.isNull($scope.vm.cuSelected) || rt.isNullOrWhiteSpace($scope.vm.cuSelected.Id)) {
                return "指标类型不能为空";
            }

            return "";
        }

        //选择时间筛选
        $scope.vm.changeDate = function (dateType) {
            $scope.dateSelect = dateType;

            switch (dateType) {
                case "fullYear":
                    $scope.vm.sYm = moment().format('YYYY-01');
                    $scope.vm.eYm = moment().format('YYYY-12');
                    break;
                case "thisMonth":
                    $scope.vm.sYm = moment().format('YYYY-MM');
                    $scope.vm.eYm = moment().format('YYYY-MM');
                    break;
                case "lastMonth":
                    $scope.vm.sYm = moment().add(-1, 'months').format('YYYY-MM');
                    $scope.vm.eYm = moment().add(-1, 'months').format('YYYY-MM');
                    break;
                case "thisQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-10');
                            $scope.vm.eYm = moment().format('YYYY-12');
                            break;
                    }
                    break;
                case "lastQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().add(-1, 'years').format('YYYY-10');
                            $scope.vm.eYm = moment().add(-1, 'years').format('YYYY-12');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                    }
                    break;
            }
        };

        function _initYmSelected() {
            //时间筛选，默认全年
            $scope.dateSelect = 'fullYear';
            $scope.vm.sYm = moment().format('YYYY-01');
            $scope.vm.eYm = moment().format('YYYY-12');
        }

        function _getOrderbyTypes() {
            $scope.vm.orderbyTypeList = [{ id: 'percent', name: '达成率' }, { id: 'amount', name: '达成额' }];
            $scope.vm.orderbyTypeCode = $scope.vm.orderbyTypeList[0];
        }

        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            $scope.vm.TbHeCosNum += (MCount + 1) * 3;
            var DeMessText = ["纯销指标", "达成额", "达成率"];

            if ($scope.vm.typeSelect == 'customCategoryByQty') {
                DeMessText = ["纯销指标", "达成量", "达成率"];
            }

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    if ($scope.vm.typeSelect == 'customCategoryByQty') {
                        $scope.vm.TbMessText.push("纯销指标", "达成量", "达成率");
                    } else {
                        $scope.vm.TbMessText.push("纯销指标", "达成额", "达成率");
                    }
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                if ($scope.vm.typeSelect == 'customCategoryByQty') {
                    $scope.vm.TbMessText.push("纯销指标", "达成量", "达成率");
                } else {
                    $scope.vm.TbMessText.push("纯销指标", "达成额", "达成率");
                }
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }

        $scope.complateTableheight = function () {
            _complateTableheight();
        };

        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 40);
            }, 0);
        }

        function _getReportData() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return msg;
            }
            var waiting = rt.showLoading2();

            //查询前处理数据(表格头部显示)
            $scope.vm.isShowOwnerHeader = $scope.vm.isShowOwner;
            $scope.vm.typeSelectHeader = $scope.vm.typeSelect;
            var _diyCategoryId = $scope.vm.cuSelected.Id;
            if ($scope.vm.typeSelect == 'noCustomCategory') {
                _diyCategoryId = '';
            }
            //获取表格分页数据
            var url = 'api/ImportantHospitalTarget/GetImportantHospitalTarget?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&orderbyType=" + $scope.vm.orderbyTypeCode.id + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize) + "&isShowOwner=" + encodeURIComponent($scope.vm.isShowOwner) + "&typeSelect=" + encodeURIComponent($scope.vm.typeSelect) + "&diyCategoryId=" + encodeURIComponent(_diyCategoryId);
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? JSON.stringify($scope.vm.nodeSelected.ids) : "";

            rt.post(url, unitids).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _MonDataList($scope.vm.sYm, $scope.vm.eYm);
                _complateTableheight();
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        //--通过接口获取所有自定义分类(客户层级)--//
        function _getCustomcategory() {
            var url = 'api/CustomCategory/GetCustomCategoryByTaskType?taskType=3&taskLevel=3';
            return rt.get(url).then(function (resp) {
                $scope.vm.customCategoryList = resp.data;
                if ($scope.vm.customCategoryList.length > 0) {
                    $scope.vm.cuSelected = $scope.vm.customCategoryList[0];
                } else {
                    $scope.vm.cuSelected = null;
                }
            });
        }
        init();
    }
    angular.module('xrmApp').service('importantHospitalService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'ImportantHospitalTarget';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("ImportantHospitalTargetListController", ['$scope', '$timeout', 'rt', '$injector', 'importantHospitalService', ImportantHospitalTargetListController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : julie zhu
 创建时间 : 2018/2/6
 说明     : 机构签到
 *********************************************************/
(function () {
    'use strict';

    function InstitutionSignListController($scope, $q, $compile, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preSearch = function (params) {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }

            var unitids = !rt.isNull($scope.vm.nodeSelected) ? JSON.stringify($scope.vm.nodeSelected.ids) : "";

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "SDate", Value: $scope.vm.SDate });
            _that.searchList.push({ Type: 1, Key: "EDate", Value: $scope.vm.EDate });
            _that.searchList.push({ Type: 1, Key: "businessunits", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "pageIndex", Value: $scope.vm.pageIndex });
            _that.searchList.push({ Type: 1, Key: "pageSize", Value: $scope.vm.pageSize });
        };

        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "SDate", Value: $scope.vm.SDate });
            _that.searchList.push({ Type: 1, Key: "EDate", Value: $scope.vm.EDate });
            _that.searchList.push({ Type: 1, Key: "unitids", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "pageIndex", Value: $scope.vm.pageIndex });
            _that.searchList.push({ Type: 1, Key: "pageSize", Value: $scope.vm.pageSize });
        };

        $injector.invoke(entityListController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        function init() {
            //时间筛选，默认本月
            $scope.vm.SDate = moment().format('YYYY-MM-01');
            $scope.vm.EDate = moment().endOf('month').format("YYYY-MM-DD");
            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
        };

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.SDate)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.EDate)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.SDate > $scope.vm.EDate) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            return "";
        };

        //查询报表数据
        $scope.vm.getReportData = function () {
            var msg = _checkOption();
            if (!rt.isNull(msg) && msg.length > 0) {
                rt.errorMessage(msg);
                return;
            }
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();
            $scope.isQtyShow = false;
            //机构签到列表
            myService.getReportData($scope.vm.SDate, $scope.vm.EDate, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            });
        };
        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
        }
        init();
    }
    angular.module('xrmApp').service('InstitutionSignService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'InstitutionSignIn';
        this.picklists = ['StateCode'];

        //机构签到列表
        this.getReportData = function (SDate, EDate, pageIndex, pageSize, unitids) {
            return rt.post("api/InstitutionSignIn/InstitutionSignReport?SDate=" + SDate + "&EDate=" + EDate + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize, unitids);
        };
    }]);
    angular.module('xrmApp').controller("InstitutionSignListController", ['$scope', '$q', '$compile', 'rt', '$injector', 'InstitutionSignService', InstitutionSignListController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-02-08
 说明     : 潜在代理商创建明细
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('LeadsReprtService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'LeadsReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("leadsreportController", ['$scope', 'rt', '$injector', 'LeadsReprtService', leadsreportController]);
    function leadsreportController($scope, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var unitids = rt.isNull($scope.vm.businessUnitSelected) ? "" : $scope.vm.businessUnitSelected.id;
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "yM", Value: moment($scope.vm.yM).format('YYYY-MM') });
            _that.searchList.push({ Type: 1, Key: "buId", Value: buId });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: bigUnitId });
            var unitids = _CalculateUnitids();
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.yM = moment().format('YYYY-MM');

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };
            _getAllBuid();
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                }
                $scope.vm.buidList.unshift({ id: "", name: "全部事业部" });
                $scope.vm.buidSelected = $scope.vm.buidList[0];
            }, function (error) {});
        }

        //获取业务线/大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [{ id: '', name: '全部业务线/大区' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    var data = resp.DataList;
                    if (!rt.isNull(data) && data.length > 0) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(data);
                        $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                    }
                    $scope.vm.bigDepList.unshift({ id: '', name: '全部业务线/大区' });
                    $scope.vm.bigDepSelected = { id: '', name: '全部业务线/大区' };
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                return;
            }
            if (oldValue != newValue) {
                getBusinessUnitList($scope.vm.buidSelected.id, $scope.vm.bigDepSelected.id);
            }
        });
        //获取省区地区
        function getBusinessUnitList(buId, bigDepId) {
            rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                '@queryValue': '',
                '@ParentBusinessUnitId': bigDepId,
                '@businesstype': 10
            }, function (resp) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.businessUnitList = data;
                }
            }, function (error) {
                $scope.vm.businessUnitList = [];
            });
        }

        //潜在代理商创建明细
        function _getReportData() {
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var unitids = _CalculateUnitids();
            var waiting = rt.showLoading2();
            var url = "api/LeadsReport/GetLeadsReportData";
            url += "?yM=" + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM'));
            url += "&buId=" + encodeURIComponent($scope.vm.buidSelected.id);
            url += "&bigDeptId=" + encodeURIComponent(bigUnitId);
            url += "&businessUnitId=" + encodeURIComponent(unitids);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;

                if ($scope.vm.reportData.length > 0) {
                    //防止取不到数据时，获取权限报错
                    //导出权限
                    var stprivilege = $scope.vm.reportData[0].leadsId;
                    return myService.getPrivilege(stprivilege).then(function (resp) {
                        $scope.vm.privilege = resp.data;
                    });
                }
            }).finally(function () {
                waiting.close();
            });
        }

        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            return unitids;
        }
    }
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-09-29
 说明     : 按部门拜访分析
 ********************************************************/
(function () {
	'use strict';

	function ManagervisitAssAnalysisController($scope, $q, $compile, $timeout, rt, $injector, myService) {
		var _that = this;
		_that.searchList = [];
		this.preExport = function () {
			var msg = _checkOption();
			if (!rt.isNullOrWhiteSpace(msg)) {
				return msg;
			}

			var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";

			_that.searchList.length = 0;
			_that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
			_that.searchList.push({ Type: 1, Key: "businessUnitIds", Value: unitids });
			_that.searchList.push({ Type: 1, Key: "ordertype", Value: $scope.vm.ordertype.value });
		};

		$injector.invoke(reportListController, this, {
			$scope: $scope,
			myService: myService
		});

		init();
		function init() {
			$scope.vm.reportData = [];
			$scope.vm.recordCount = 0;
			$scope.vm.index = 1;
			$scope.vm.pageSize = rt.getPaginationSize();
			$scope.vm.sYm = moment().format('YYYY-MM');
			_chooseordertype();
			//查询按钮
			$scope.vm.showReportButton = function () {
				$scope.vm.index = 1;
				$scope.vm.showReport();
			};
			_getReportData().then(null, function (message) {
				rt.errorMessage(message);
			});
		}

		//查询
		$scope.vm.showReport = function () {
			var msg = _checkOption();
			if (!rt.isNullOrWhiteSpace(msg)) {
				rt.errorMessage(msg);
				return false;
			}
			_getReportData().then(null, function (message) {
				rt.errorMessage(message);
			});
		};
		//排序筛选
		function _chooseordertype() {
			$scope.vm.ordertypeList = [{
				value: 'BusinessUnitIdName',
				name: '按省区/地区排序'
			}, {
				value: 'Coach_Done_Count',
				name: '按协访数排序'
			}, {
				value: 'Visited_Avg',
				name: '按人均拜访数排序'
			}, {
				value: 'Visited_Done_Avg',
				name: '按覆盖率排序'
			}];
			$scope.vm.ordertype = $scope.vm.ordertypeList[0];
		}

		//条件检查
		function _checkOption() {
			if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
				return "开始时间不能为空";
			}
		}

		function _getReportData() {
			var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";

			var waiting = rt.showLoading2();
			var url = 'api/ManagervisitAssAnalysis/GetManagervisitAssAnalysis?sYm=' + encodeURIComponent(moment($scope.vm.sYm).format('YYYY-MM-DD')) + '&ordertype=' + encodeURIComponent($scope.vm.ordertype.value) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
			return rt.post(url, unitids).then(function (resp) {
				$scope.vm.reportData = resp.data.DataList;
				$scope.vm.recordCount = resp.data.TotalRecords;
				waiting.close();
			}, function () {
				waiting.close();
			});
		}
	}

	angular.module('xrmApp').service('ManagervisitAssAnalysisService', ['entityService', function (entityService) {
		var rt = entityService.rt;
		angular.extend(this, entityService);
		// @@设置WebAPI的控制器名称
		this.controllerName = 'ManagervisitAssAnalysis';
		// @@ 选项集
		this.picklists = [];
	}]).controller("ManagervisitAssAnalysisController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'ManagervisitAssAnalysisService', ManagervisitAssAnalysisController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : MonaXia
 创建时间 : 2016-09-28
 说明     : 部门拜访分析(医生)
 ********************************************************/
(function () {
	'use strict';

	function managerVisitContactAnalysisListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
		var _that = this;
		_that.searchList = [];
		this.preExport = function () {
			var msg = _checkOption();
			if (!rt.isNullOrWhiteSpace(msg)) {
				return msg;
			}
			_that.searchList.length = 0;
			_that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.startYM });
			_that.searchList.push({ Type: 1, Key: "bigUnitId", Value: $scope.vm.bigDepSelected.id });
			_that.searchList.push({ Type: 1, Key: "ordertype", Value: $scope.vm.selectedOrderType.value });
			_that.searchList.push({ Type: 1, Key: "departtype", Value: $scope.vm.departtype });
		};
		$injector.invoke(reportListController, this, {
			$scope: $scope,
			myService: myService
		});
		init();
		function init() {
			$scope.vm.reportData = [];
			$scope.vm.recordCount = 0;
			$scope.vm.index = 1;
			$scope.vm.pageSize = rt.getPaginationSize();
			$scope.vm.departtype = 1; //1则根据权限查询，2根据大区查询
			$scope.vm.buidSelected = { id: '' };
			$scope.vm.startYM = moment(new Date().getFullYear() + "-" + '01' + '-01').format('YYYY-MM-DD');
			//排序方式
			$scope.vm.orderList = [{
				value: 'BusinessUnitIdName',
				name: '按省区/地区排序'
			}, {
				value: 'Coach_Done_Count',
				name: '按协访数排序'
			}, {
				value: 'Visited_Avg',
				name: '按人均拜访数排序'
			}, {
				value: 'Visited_Done_Avg',
				name: '按覆盖率排序'
			}];
			$scope.vm.selectedOrderType = $scope.vm.orderList[0]; //默认按姓名排序
			_getAllBuid();
			$scope.vm.buidSelected = { id: '' };
			$scope.vm.bigDepSelected = { id: '' };
			//查询按钮
			$scope.vm.showReportButton = function () {
				$scope.vm.index = 1;
				$scope.vm.showReport();
			};
			//查询
			$scope.vm.showReport = function () {
				var msg = _checkOption();
				if (!rt.isNullOrWhiteSpace(msg)) {
					rt.errorMessage(msg);
					return false;
				}

				_getReportData().then(null, function (message) {
					rt.errorMessage(message);
				});
			};
			_getReportData().then(null, function (message) {
				rt.errorMessage(message);
			});
		}

		//条件检查
		function _checkOption() {
			if (rt.isNull($scope.vm.startYM)) {
				return "开始时间不能为空";
			}
		}

		//获取商业大区
		$scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
			if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
				$scope.vm.bigDepList = [{ name: '全部业务线/大区', id: '' }];
				$scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
				return;
			}
			if (oldValue != newValue) {
				$scope.vm.departtype = 2;
				rt.queryData("TblBusinessUnit.ChildBusinessUnitId", {
					'@queryValue': '',
					'@ParentBusinessUnitId': $scope.vm.buidSelected.id
				}, function (resp) {
					$scope.vm.bigDepList = [];
					$scope.vm.bigDepSelected = { id: '' };
					var data = resp.DataList;
					if (data != null && data.length > 0) {
						$scope.vm.bigDepList = data;
						if (!rt.isNull($scope.vm.bigDepList) && $scope.vm.bigDepList.length > 0) {
							$scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
							$scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
						}
					}
				}, function (error) {
					$scope.vm.bigDepList = [];
				});
			}
		});
		//获取省区/地区
		$scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
			if (oldValue != newValue) {
				$scope.vm.departtype = 2;
			}
		});
		//获取所有事业部
		function _getAllBuid() {
			rt.queryData("TblBusinessUnit.BuidBusinessUnitId", { '@queryValue': '' }, function (resp) {
				var data = resp.DataList;
				if (!rt.isNull(data) && data.length > 0) {
					$scope.vm.buidList = data;
				}
				$scope.vm.buidList.unshift({ id: "", name: "全部事业部" });
				$scope.vm.buidSelected = $scope.vm.buidList[0];
			}, function (error) {});
		}

		function _getReportData() {
			var waiting = rt.showLoading2();
			var url = 'api/ManagervisitAssAnalysis/GetManagerVisitContactAnalysis?sYm=' + encodeURIComponent(moment($scope.vm.startYM).format('YYYY-MM-DD')) + "&departtype=" + $scope.vm.departtype + "&ordertype=" + encodeURIComponent($scope.vm.selectedOrderType.value) + "&bigdepart=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&pageIndex=" + encodeURIComponent($scope.vm.index) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize) + "&buid=" + $scope.vm.buidSelected.id;
			return rt.get(url).then(function (resp) {
				$scope.vm.reportData = resp.data.DataList;
				$scope.vm.recordCount = resp.data.TotalRecords;
				waiting.close();
			}, function () {
				waiting.close();
			});
		}
	}
	angular.module('xrmApp').service('ManagerVisitContactAnalysisService', ['entityService', function (entityService) {
		var rt = entityService.rt;
		angular.extend(this, entityService);
		// @@设置WebAPI的控制器名称
		this.controllerName = 'ManagervisitAssAnalysis';
		// @@ 选项集
		this.picklists = [];
	}]).controller("managerVisitContactAnalysisListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'ManagerVisitContactAnalysisService', managerVisitContactAnalysisListController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Summer Xu
 创建时间 : 2016/6/27
 说明     : 样板区县指标达成
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('ModelCountyReachService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'modelcountyreach';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("modelcountyreachListController", ['$scope', '$injector', '$timeout', 'rt', 'ModelCountyReachService', function ($scope, $injector, $timeout, rt, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join("','");
            }
            var productids = "";
            if ($scope.vm.productSelected.length > 0) {
                var productids = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                productids = productids.join("','");
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 2, Key: "productid", Value: productids });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigdeptid", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 2, Key: "saleRegion", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "orderbyType", Value: $scope.vm.orderbyTypeCode.id });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();
        function init() {
            var cw = document.documentElement.clientWidth || document.body.clientWidth;
            $scope.chartWidth = 1000;
            $scope.vm.buidList = []; //事业部下拉
            $scope.vm.buidSelected = { id: '' }; //事业部选择
            $scope.vm.bigDepList = []; //业务线/大区下拉
            $scope.vm.bigDepSelected = { id: '' }; //业务线/大区选择
            $scope.vm.businessUnitList = []; //省区/地区下拉
            $scope.vm.businessUnitSelected = null; //省区/地区选择
            $scope.vm.reportData = []; //表格数据
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.imgData = []; //图标数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.MonDataName = []; //每个月份对应文本属性名
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TbHeCosNum = 4;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();

            $scope.vm.getReportData = _getReportData; //查询按钮

            $scope.selectedTabId = "tab1";
            $scope.selectTab = _selectTab;
            _getAllProduct();
            _initYmSelected();
            _getTops();
            _getOrderbyTypes();
            _getAllBuid(); //获取所有事业部
        }

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[0];
        }

        function _getOrderbyTypes() {
            $scope.vm.orderbyTypeList = [{ id: 'percent', name: '达成率' }, { id: 'amount', name: '达成量' }];
            $scope.vm.orderbyTypeCode = $scope.vm.orderbyTypeList[0];
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        //获取业务线/大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                    '@businesstype': 20
                }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                        $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            $scope.vm.TbHeCosNum += (MCount + 1) * 3;
            var DeMessText = ["指标", "达成量", "达成率"];
            var DeMessName = ["{{vm.reportData.DataList[0].target" + parseInt(sArr[1]) + "}}", "{{vm.reportData.DataList[0].row.done" + parseInt(sArr[1]) + "}}", "{{vm.reportData.DataList[0].row.donepercent" + parseInt(sArr[1]) + "}}"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("指标", "达成量", "达成率");
                    $scope.vm.MonDataName.push("row.target" + NMon, "row.done" + NMon, "row.donepercent" + NMon);
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("指标", "达成量", "达成率");
                $scope.vm.MonDataName.push("row.target" + (parseInt(sArr[1]) + MCount), "row.done" + (parseInt(sArr[1]) + MCount), "row.donepercent" + (parseInt(sArr[1]) + MCount));
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
                $scope.vm.MonDataName = DeMessName;
            }
        }

        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }

            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始年月不能大于结束年月";
            }

            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }

            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                return "请选择事业部";
            }

            return "";
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }
        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var waiting = rt.showLoading2();

            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join("','");
            }
            var productids = "";
            if ($scope.vm.productSelected.length > 0) {
                var productids = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                productids = productids.join("','");
            }

            //获取图表数据(达成率)
            var url2 = 'api/ModelCountyReach/GetOwnerTargetChart?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&productid=" + productids + "&buid=" + $scope.vm.buidSelected.id + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&saleRegion=" + encodeURIComponent(unitids) + "&orderbyType=percent" + "&top=" + $scope.vm.topsSelected;
            rt.get(url2).then(function (resp) {
                $scope.vm.reportData2 = resp.data;
                _show();
            }, function () {});

            //获取图表数据(达成量)
            var url3 = 'api/ModelCountyReach/GetOwnerTargetChart?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&productid=" + productids + "&buid=" + $scope.vm.buidSelected.id + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&saleRegion=" + encodeURIComponent(unitids) + "&orderbyType=amount" + "&top=" + $scope.vm.topsSelected;
            rt.get(url3).then(function (resp) {
                $scope.vm.reportData3 = resp.data;
                _show();
            }, function () {});

            //获取表格分页数据
            var url = 'api/ModelCountyReach/GetOwnerTargetList?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&productid=" + productids + "&buId=" + encodeURIComponent($scope.vm.buidSelected.id) + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&saleRegion=" + encodeURIComponent(unitids) + "&orderbyType=" + $scope.vm.orderbyTypeCode.id + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize);
            rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _MonDataList($scope.vm.sYm, $scope.vm.eYm);
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }

        $scope.selectedTabId = 'tab1';
        function _selectTab(id) {
            $scope.selectedTabId = id;
            _show();
        }
        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = [];
            });
        }
        function _show() {
            var t = $scope.selectedTabId;
            if (t == "tab1") {
                _showReport1();
            } else if (t == "tab2") {
                _showReport2();
            }
        }

        function _showReport1() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.reportData2.DataList;
            for (var i = dataList.length - 1; i >= 0; i--) {
                echartsDataValue.push(dataList[i].year_percent);
                echartsDataName.push(dataList[i].businessunitidname + '--' + dataList[i].owneridname);
            }
            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '累计达成率',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}%"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        function _showReport2() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.reportData3.DataList;
            for (var i = dataList.length - 1; i >= 0; i--) {
                echartsDataValue.push(dataList[i].act_amount);
                echartsDataName.push(dataList[i].businessunitidname + '--' + dataList[i].owneridname);
            }

            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}个'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '累计达成量',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}个"
                            },
                            labelLine: { show: true }
                        }
                    }

                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        init();
    }]);
})();
"use strict";

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/6/29
 *说明：新开发医院达成分析
 *************************************************/
(function () {
    'use strict';

    function newlyHospitalTaskAnalysisListController($scope, $q, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.startDate });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.endDate });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: $scope.vm.unitids });
            _that.searchList.push({ Type: 1, Key: "sortType", Value: $scope.vm.sortSelected.Value });
            _that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            //var cw = (document.documentElement.clientWidth || document.body.clientWidth);
            $scope.chartWidth = 1000;
            $scope.vm.reportData = []; //表格数据
            $scope.vm.reportTbData = []; //图表数据
            $scope.vm.reportTbData2 = []; //图表数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = { Id: '' };
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { Id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = null;
            $scope.vm.pageIndex = 1;
            $scope.vm.TotalRecords = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.unitids = "";
            $scope.selectedTabId = "tab1";
            $scope.selectTab = _selectTab;
            $scope.vm.showReport = _getReportData;
            _getTops();
            _getSorts();
            _getCustomcategory();
            _getAllBuid();
            _initYmSelected();
        }
        //检查条件
        function checkOption() {
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                $scope.vm.unitids = unitmap.join("','");
            }
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                return "开始年月不能为空。";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                return "结束年月不能为空。";
            }
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                return "请选择事业部";
            }
            // if (rt.isNull($scope.vm.CuSelected) || rt.isNullOrWhiteSpace($scope.vm.CuSelected.Id)) {
            //     return "指标类型不能为空。";
            // }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) < 0) {
                return "参数异常[开始日期必须小于等于结束日期.]";
            }
            if (_CalOneYear($scope.vm.startDate, $scope.vm.endDate) != 0) {
                return "参数异常[开始日期与结束日期必须在同一年.]";
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) >= 365) {
                return "参数异常[日期区间最大为12个月.]";
            }
            return "";
        }
        //切换tab
        function _selectTab(id) {
            $scope.selectedTabId = id;
            _showData();
        }
        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.startDate = d.getFullYear() + "-" + '01';
            $scope.vm.endDate = moment().format('YYYY-MM');
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }
        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[0];
        }
        function _getSorts() {
            $scope.vm.sortList = [{ Name: '达成率', Value: 1 }, { Name: '达成数', Value: 2 }];
            $scope.vm.sortSelected = $scope.vm.sortList[0];
        }
        function _getCustomcategory() {
            var url = 'api/CustomCategory/GetCustomCategoryByTaskType?taskType=2';
            return rt.get(url).then(function (resp) {
                $scope.vm.customcategoryList = resp.data;
                $scope.vm.CuSelected = $scope.vm.customcategoryList[0];
            });
        }

        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        function _CalOneYear(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var result = sArr[0] - eArr[0];
            return result;
        }
        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            var DeMessText = ["新开医院指标", "实际达成数", "月度达成率"];
            // $scope.vm.MonDataList[0] = sArr[1];
            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("新开医院指标", "实际达成数", "月度达成率");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("新开医院指标", "实际达成数", "月度达成率");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }
        //通过接口获取图表数据
        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var waiting = rt.showLoading2();
            //获取达成率数据
            myService.getNewlyHospitalTargetChartData($scope.vm.startDate, $scope.vm.endDate, $scope.vm.buidSelected.id, $scope.vm.bigDepSelected.id, $scope.vm.unitids, 1, $scope.vm.topsSelected).then(function (resp) {
                $scope.vm.reportPerData = resp.data;
                _showData();
            }, function () {
                waiting.close();
            });
            //获取达成数的数据
            myService.getNewlyHospitalTargetChartData($scope.vm.startDate, $scope.vm.endDate, $scope.vm.buidSelected.id, $scope.vm.bigDepSelected.id, $scope.vm.unitids, 2, $scope.vm.topsSelected).then(function (resp) {
                $scope.vm.reportNumData = resp.data;
                _showData();
            }, function () {
                waiting.close();
            });
            //获取表格数据
            myService.getNewlyHospitalTargetData($scope.vm.startDate, $scope.vm.endDate, $scope.vm.buidSelected.id, $scope.vm.bigDepSelected.id, $scope.vm.unitids, $scope.vm.sortSelected.Value, $scope.vm.pageIndex, $scope.vm.pageSize).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.TotalRecords = resp.data.TotalRecords;
                _MonDataList($scope.vm.startDate, $scope.vm.endDate);
                _complateTableheight();
            }, function () {
                waiting.close();
            });
            waiting.close();
        }
        function _showData() {
            var t = $scope.selectedTabId;
            if (t == 'tab1') {
                _show();
            } else if (t == 'tab3') {
                _show2();
            } else if (t == 'tab2') {}
        }
        //达成率图表显示
        function _show() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            var echartYName = [];
            var echartsData = [];
            var getData = $scope.vm.reportPerData;
            if (getData != null && getData.length > 0) {
                for (var i = getData.length - 1; i >= 0; i--) {
                    echartYName.push(getData[i].BusinessUnitIdName + "--" + getData[i].OwnerIdName);
                    if (rt.isNull(getData[i].totalPercent)) {
                        echartsData.push(0);
                    } else {
                        echartsData.push(getData[i].totalPercent);
                    }
                }
            }
            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartYName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }

                }],
                series: [{
                    name: '达成率',
                    type: 'bar',
                    data: echartsData,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}%"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.setOption(option);
        }
        //达成数排名
        function _show2() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            var echartYName = [];
            var echartsData = [];
            var getData = $scope.vm.reportNumData;
            if (getData != null && getData.length > 0) {
                for (var i = getData.length - 1; i >= 0; i--) {
                    echartYName.push(getData[i].BusinessUnitIdName + "--" + getData[i].OwnerIdName);
                    if (rt.isNull(getData[i].totalNum)) {
                        echartsData.push(0);
                    } else {
                        echartsData.push(getData[i].totalNum);
                    }
                }
            }
            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}个'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartYName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }

                }],
                series: [{
                    name: '达成数',
                    type: 'bar',
                    data: echartsData,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}个"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.setOption(option);
        }
        init();
    }
    angular.module('xrmApp').service('newlyHospitalTaskAnalysisService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'NewlyHospitalTarget';
        // @@ 选项集
        this.picklists = [];
        //获取表格数据
        this.getNewlyHospitalTargetData = function (sYm, eYm, buId, bigUnitId, businessUnitId, sortType, pageIndex, pageSize) {
            var url = 'api/NewlyHospitalTarget/GetNewlyHospitalTargetData?sYm=' + encodeURIComponent(sYm) + '&eYm=' + encodeURIComponent(eYm) + '&businessUnitId=' + encodeURIComponent(businessUnitId) + '&bigUnitId=' + encodeURIComponent(bigUnitId) + '&sortType=' + encodeURIComponent(sortType) + '&pageIndex=' + pageIndex + '&pageSize=' + pageSize + '&buId=' + encodeURIComponent(buId);
            return rt.get(url);
        };
        //获取图标数据
        this.getNewlyHospitalTargetChartData = function (sYm, eYm, buId, bigUnitId, businessUnitId, sortType, top) {
            var url = 'api/NewlyHospitalTarget/GetNewlyHospitalTargetChartData?sYm=' + encodeURIComponent(sYm) + '&eYm=' + encodeURIComponent(eYm) + '&businessUnitId=' + encodeURIComponent(businessUnitId) + '&bigUnitId=' + encodeURIComponent(bigUnitId) + '&sortType=' + encodeURIComponent(sortType) + '&top=' + top + '&buId=' + encodeURIComponent(buId);
            return rt.get(url);
        };
    }]).controller("newlyHospitalTaskAnalysisListController", ['$scope', '$q', '$timeout', 'rt', '$injector', 'newlyHospitalTaskAnalysisService', newlyHospitalTaskAnalysisListController]);
})();
'use strict';

(function () {
    'use strict';

    function opportunityMaintainController($scope, rt) {

        $scope.vm = {};
        $scope.vm.form = {};
        $scope.vm.form.data = {};
        $scope.vm.picklist = {};
        $scope.vm.picklist.lostreason = [];
        $scope.vm.picklist.salesstage = [];
        $scope.CloseDialog = _CloseDialog;
        $scope.Edit = _Edit;
        $scope.Save = _Save;
        $scope.List = _getPickList;
        $scope.MaintainForm = _maintainform;
        _maintainform();
        _Edit();
        _getPickList();

        //获取picklist数据
        function _getPickList() {
            var url = 'api/opportunity/GetPickListData?fieldCodes=' + encodeURIComponent(['salesstage', 'lostreason']);
            return rt.get(url).then(function (resp) {
                $scope.vm.picklist.salesstage = resp.data.salesstage;
                $scope.vm.picklist.lostreason = resp.data.lostreason;
            });
        };

        function _maintainform() {
            $scope.vm.form = {
                name: rt.newGuid(), // 动态生成表单的名称
                // includeId，作为明细视图的弹出编辑页面处理时记录的标识
                // $stateParams.id，作为默认视图的弹出编辑页面处理时记录的标识
                id: rt.isNull($scope.rtIncludeParams) || rt.isNull($scope.rtIncludeParams.opportunityid) ? $stateParams.id.split(',')[0] : $scope.rtIncludeParams.opportunityid,
                // 表格自动高度
                autoHeight: rt.isNull($scope.rtIncludeParams) || rt.isNull($scope.rtIncludeParams.opportunityid) ? myService.getDefaultFormAutoHeight() : -1
            };
        }

        //显示编辑页面
        function _Edit() {
            // console.log($scope.vm.form.data.salesstage );
            if (!rt.isNullOrWhiteSpace($scope.rtIncludeParams.opportunityid)) {
                var waiting = rt.showLoading2();
                var url = 'api/Opportunity/GetOpportunity?opportunityid=' + $scope.rtIncludeParams.opportunityid;
                return rt.get(url).then(function (resp) {
                    $scope.vm.form.data = resp.data;
                    $scope.vm.form.data.salesstage = $scope.vm.form.data.salesstage.Value / 10 - 1;
                    waiting.close();
                });
            }
        }

        //保存
        function _Save() {
            // 验证表单合法性
            if ((rt.isNull($scope.vm.form.data.lostreason) || $scope.vm.form.data.lostreason.Value < 0) && $scope.vm.form.data.salesstage == 5) {
                rt.errorMessage("必须提供丢单原因。");
                return;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.form.data.remarks) && $scope.vm.form.data.salesstage == 5) {
                rt.errorMessage("必须提供丢单描述。");
                return;
            }
            if (rt.isNullOrWhiteSpace($scope.rtIncludeParams.opportunityid)) {}
            if (!rt.isNullOrWhiteSpace($scope.rtIncludeParams.opportunityid)) {
                $scope.vm.form.data.salesstage = $scope.vm.picklist.salesstage[$scope.vm.form.data.salesstage];
                var waiting = rt.showWaiting();
                var url = 'api/Opportunity/UpdateOpportunity?opportunityid=' + $scope.rtIncludeParams.opportunityid;
                return rt.post(url, $scope.vm.form.data).then(function () {
                    _CloseDialog();
                    waiting.close();
                });
            }
        }

        //关闭
        function _CloseDialog() {
            $scope.$emit('rt-reload');
            $scope.$broadcast('rt-reload');
            $scope.$parent.HideForm();
        }
    }

    angular.module("xrmApp").controller("opportunityMaintainController", ['$scope', 'rt', opportunityMaintainController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/5/12
 说明     : 代表纯销统计
 *********************************************************/
(function () {
    'use strict';

    function OwnerPureVenditionController($scope, $injector, $q, rt, $timeout, myService) {
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var productids = "";
            if (!rt.isNull($scope.vm.productSelected)) {
                var productsmap = _.map($scope.vm.productSelected, 'Id');
                productids = productsmap.join("','");
            }

            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitsmap = _.map($scope.vm.businessUnitSelected, 'id');
                unitids = unitsmap.join("','");
            }

            $scope.vm.view.searchList = [];
            $scope.vm.view.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            $scope.vm.view.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            $scope.vm.view.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            $scope.vm.view.searchList.push({ Type: 1, Key: "bigdeptId", Value: $scope.vm.bigDepSelected.id });
            $scope.vm.view.searchList.push({ Type: 1, Key: "businessunits", Value: unitids });
            $scope.vm.view.searchList.push({ Type: 1, Key: "productIds", Value: productids });
            $scope.vm.view.searchList.push({ Type: 1, Key: "entType", Value: $scope.vm.entType });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        function init() {
            $scope.vm.buidList = []; //事业部下拉
            $scope.vm.buidSelected = { Id: '' }; //事业部选择
            $scope.vm.bigDepList = []; //业务线/大区下拉
            $scope.vm.bigDepSelected = { Id: '' }; //业务线/大区选择
            $scope.vm.businessUnitList = []; //省区/地区下拉
            $scope.vm.businessUnitSelected = null; //省区/地区选择         
            $scope.vm.productList = []; //药品名称下拉
            $scope.vm.productSelected = null; //药品名称选择
            $scope.vm.reportData = []; //表格数据
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.imgData = []; //图标数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.MonDataName = []; //每个月份对应文本属性名
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TbHeCosNum = 4;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.getReportData = _getReportData; //查询按钮
            _initYmSelected();
            _getAllBuid(); //获取所有事业部
        }

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        //获取业务线/大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { Id: '' };
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                        $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            $scope.vm.TbHeCosNum += (MCount + 1) * 2;
            var DeMessText = ["数量", "金额（万元）"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("数量", "金额（万元）");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("数量", "金额（万元）");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 40);
            }, 0);
        }
        // 检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }

            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始年月不能大于结束年月";
            }

            if (moment($scope.vm.sYm).format("YYYY") !== moment($scope.vm.eYm).format("YYYY")) {
                return "只可查询同一年的数据";
            }

            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                return "请选择事业部";
            }
            return "";
        }
        function _getReportData() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var productids = "";
            if (!rt.isNull($scope.vm.productSelected)) {
                var productsmap = _.map($scope.vm.productSelected, 'Id');
                productids = productsmap.join("','");
            }

            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitsmap = _.map($scope.vm.businessUnitSelected, 'id');
                unitids = unitsmap.join("','");
            }

            var waiting = rt.showLoading2();
            var url = 'api/OwnerPureVendition/GetOwnerPureVendition?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buid=" + $scope.vm.buidSelected.id + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&saleRegion=" + encodeURIComponent(unitids) + "&productIds=" + encodeURIComponent(productids) + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _MonDataList($scope.vm.sYm, $scope.vm.eYm);
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }

        init();
    }
    angular.module('xrmApp').service('OwnerPureVenditionService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'OwnerPureVendition';
        // @@ 选项集
        this.picklists = [];
    }]).controller("OwnerPureVenditionController", ['$scope', '$injector', '$q', 'rt', '$timeout', 'OwnerPureVenditionService', OwnerPureVenditionController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/2/28
 说明     : 区域市场占有率分析
 *********************************************************/

(function () {
    'use strict';

    function ProvinceMarketOccupancyController($scope, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            if (rt.isNullOrWhiteSpace($scope.vm.data_year)) {
                rt.errorMessage("请选择年份");
                return false;
            }

            var provinceids = "";
            if (!rt.isNull($scope.vm.provinceIdSelected)) {
                var provincemap = $scope.vm.provinceIdSelected.map(function (item) {
                    return item.id;
                });
                provinceids = provincemap.join(",");
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "data_year", Value: $scope.vm.data_year });
            _that.searchList.push({ Type: 1, Key: "provinceId", Value: provinceids });
            _that.searchList.push({ Type: 1, Key: "product_categoryid", Value: $scope.vm.product_categoryIdSelected.id });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        function init() {
            $scope.chartWidth = 1000;
            $scope.vm.product_categoryIdList = []; //药品品类下拉
            $scope.vm.product_categoryIdSelected = { Id: '' }; //药品品类选择
            $scope.vm.provinceIdList = []; //省份下拉
            $scope.vm.provinceIdSelected = null; //省份选择
            $scope.vm.reportData = []; //表格数据
            $scope.vm.chartData = []; //图表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.getReportData = _getReportData; //查询按钮

            _initYearSelected(); //默认选择今年
            _getAllProductCategoryId(); //获取所有药品品类
            _getAllProvince(); //获取所有省份

            var cw = document.documentElement.clientWidth || document.body.clientWidth;
            $scope.chartWidth = cw * 0.7;
        }

        function _initYearSelected() {
            var d = new Date();
            $scope.vm.data_year = d.getFullYear().toString();
        }

        //获取所有药品品类
        function _getAllProductCategoryId() {
            rt.queryData("Product.GetProductCategory", { '@queryValue': '' }, function (resp) {
                $scope.vm.product_categoryIdList = [{ name: '全部药品', id: '' }];
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.product_categoryIdList = $scope.vm.product_categoryIdList.concat(data);
                }
                $scope.vm.product_categoryIdSelected = $scope.vm.product_categoryIdList[0];
            });
        }

        //获取所有省份
        function _getAllProvince() {
            rt.queryData("Province.GetProvince", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.provinceIdList = data;
                }
            });
        }

        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 90);
        }

        function _getReportData() {
            if (rt.isNullOrWhiteSpace($scope.vm.data_year)) {
                rt.errorMessage("请选择年份");
                return false;
            }

            var provinceids = "";
            if (!rt.isNull($scope.vm.provinceIdSelected)) {
                var provincemap = $scope.vm.provinceIdSelected.map(function (item) {
                    return item.id;
                });
                provinceids = provincemap.join(",");
            }

            //获取图表数据
            var waiting1 = rt.showLoading2();
            var url = 'api/ProvinceMarketOccupancy/GetProvinceMarketOccupancyChart?data_year=' + encodeURIComponent($scope.vm.data_year) + "&provinceId=" + encodeURIComponent(provinceids) + "&product_categoryid=" + encodeURIComponent($scope.vm.product_categoryIdSelected.id);
            rt.get(url).then(function (resp) {
                $scope.vm.chartData = resp.data;
                _show();
                waiting1.close();
            }, function (message) {
                rt.errorMessage(message);
            }).finally(function () {
                waiting1.close();
            });

            //获取表格数据
            var waiting2 = rt.showLoading2();
            var url = 'api/ProvinceMarketOccupancy/GetProvinceMarketOccupancy?data_year=' + encodeURIComponent($scope.vm.data_year) + "&provinceId=" + encodeURIComponent(provinceids) + "&product_categoryid=" + encodeURIComponent($scope.vm.product_categoryIdSelected.id) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize) + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex);
            rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting2.close();
                _complateTableheight();
            }, function (message) {
                rt.errorMessage(message);
            }).finally(function () {
                waiting2.close();
            });
        }

        function _show() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            var echartsX = [];
            var echartsCapacityAmount = [];
            var echartsYearActAmount = [];
            var echartsOccupancy = [];
            for (var i = 0; i < $scope.vm.chartData.length; i++) {
                echartsX.push($scope.vm.chartData[i].provinceIdName);
                echartsCapacityAmount.push($scope.vm.chartData[i].capacity_amount);
                echartsYearActAmount.push(parseFloat($scope.vm.chartData[i].year_act_amount.toFixed(2)));
                echartsOccupancy.push($scope.vm.chartData[i].occupancy.toFixed(2));
            }

            var option = {
                title: {
                    text: '产品容量及产品占有率分析',
                    x: 'center'
                },
                tooltip: {
                    trigger: 'axis',
                    formatter: "{b}<br/>{a0}：{c0}<br/>{a1}：{c1}<br/>{a2}：{c2}%"
                },
                calculable: true,
                legend: {
                    data: ['潜力预估金额（万元）', '本年度销售额（万元）', '占有率'],
                    y: 'bottom'
                },
                xAxis: [{
                    type: 'category',
                    data: echartsX
                }],
                yAxis: [{
                    type: 'value',
                    name: '金额',
                    axisLabel: {
                        formatter: '{value}万元 '
                    },
                    splitLine: {
                        show: false
                    }
                }, {
                    type: 'value',
                    name: '占有率',
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                series: [{
                    name: '潜力预估金额（万元）',
                    type: 'bar',
                    data: echartsCapacityAmount
                }, {
                    name: '本年度销售额（万元）',
                    type: 'bar',
                    data: echartsYearActAmount
                }, {
                    name: '占有率',
                    type: 'line',
                    yAxisIndex: 1,
                    data: echartsOccupancy
                }]
            };
            myChart.setOption(option);
        }

        init();
    }

    angular.module('xrmApp').service('ProvinceMarketOccupancyService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'ProvinceMarketOccupancy';
    }]);
    angular.module('xrmApp').controller("ProvinceMarketOccupancyController", ['$scope', 'rt', '$injector', 'ProvinceMarketOccupancyService', ProvinceMarketOccupancyController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/7
 说明     : 代表纯销指标达成（金额）
 *********************************************************/

(function () {
    'use strict';

    function PureOwnerTargetByAmountListController($scope, $injector, $timeout, rt, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigDeptId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "businessUnitId", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "orderByType", Value: $scope.vm.orderbyTypeCode.value });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        function init() {
            var cw = document.documentElement.clientWidth || document.body.clientWidth;
            $scope.chartWidth = 1000;
            $scope.vm.buidList = [{ name: '全部事业部', id: '' }];
            $scope.vm.buidSelected = $scope.vm.buidList[0]; //事业部选择
            $scope.vm.bigDepList = []; //业务线/大区下拉
            $scope.vm.bigDepSelected = { id: '' }; //业务线/大区选择
            $scope.vm.businessUnitList = []; //省区/地区下拉
            $scope.vm.businessUnitSelected = null; //省区/地区选择
            $scope.vm.reportData = []; //表格数据
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.imgData = []; //图标数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.MonDataName = []; //每个月份对应文本属性名
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TbHeCosNum = 4;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.getReportData = _getReportData; //查询按钮
            $scope.selectedTabId = "tab1";
            $scope.selectTab = _selectTab;

            _initYmSelected();
            _getTops();
            _getOrderbyTypes();
            _getAllBuid(); //获取所有事业部
        }

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[0];
        }

        function _getOrderbyTypes() {
            $scope.vm.orderbyTypeList = [{ value: 'Sum_Percent_Rank', name: '达成率' }, {
                value: 'Sum_Done_Rank',
                name: '达成额'
            }];
            $scope.vm.orderbyTypeCode = $scope.vm.orderbyTypeList[0];
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.concat(data);
                }
            });
        }

        //获取大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [{ name: '全部业务线/大区', id: '' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                    '@businesstype': 20
                }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
                return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            $scope.vm.TbHeCosNum += (MCount + 1) * 3;
            var DeMessText = ["指标", "达成额", "达成率"];
            var DeMessName = ["{{vm.reportData[0].target" + parseInt(sArr[1]) + "}}", "{{vm.reportData.DataList[0].row.done" + parseInt(sArr[1]) + "}}", "{{vm.reportData.DataList[0].row.donepercent" + parseInt(sArr[1]) + "}}"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("指标", "达成额", "达成率");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("指标", "达成额", "达成率");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }

        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }

            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始年月不能大于结束年月";
            }

            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }
            return "";
        }

        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var waiting = rt.showLoading2();
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            //获取达成列表数据
            var url = 'api/PureOwnerTarget/GetTsSrTargetDoneByownerList?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigDeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitId=" + encodeURIComponent(unitids) + "&orderByType=" + $scope.vm.orderbyTypeCode.value + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            //获取图表数据(达成率排名)
            var urlPercent = 'api/PureOwnerTarget/GetTsSrTargetDoneByownerRank?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigDeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitId=" + encodeURIComponent(unitids) + "&orderByType=Done_Percent" + "&top=" + "&pageIndex=1" + "&pageSize=" + $scope.vm.topsSelected;

            //获取图表数据(达成额排名)
            var urlAmount = 'api/PureOwnerTarget/GetTsSrTargetDoneByownerRank?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigDeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitId=" + encodeURIComponent(unitids) + "&orderByType=Sum_Done_Amount" + "&top=" + "&pageIndex=1" + "&pageSize=" + $scope.vm.topsSelected;

            rt.get(urlPercent).then(function (resp) {
                $scope.vm.percentData = resp.data;

                rt.get(urlAmount).then(function (resp) {
                    $scope.vm.amountData = resp.data;

                    rt.get(url).then(function (resp) {
                        $scope.vm.reportData = resp.data;
                        $scope.vm.recordCount = resp.data.TotalRecords;
                        _MonDataList($scope.vm.sYm, $scope.vm.eYm);
                        _complateTableheight();
                        _show();
                    }).finally(function () {
                        waiting.close();
                    });
                });
            });
        }

        function _selectTab(id) {
            $scope.selectedTabId = id;
            _show();
        }

        function _show() {
            var t = $scope.selectedTabId;
            if (t == "tab1") {
                _showReport1();
            } else if (t == "tab2") {
                _showReport2();
            }
        }

        function _showReport1() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.percentData.DataList;
            for (var i = dataList.length - 1; i >= 0; i--) {
                echartsDataValue.push(dataList[i].Done_Percent.toFixed(2));
                echartsDataName.push(dataList[i].BusinessUnitIdName + '--' + dataList[i].OwnerIdName);
            }
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: '{b}<br/>{a}:{c}%'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '累计达成率',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}%"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        function _showReport2() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.amountData.DataList;
            for (var i = dataList.length - 1; i >= 0; i--) {
                echartsDataValue.push(dataList[i].Sum_Done_Amount.toFixed(2));
                echartsDataName.push(dataList[i].BusinessUnitIdName + '--' + dataList[i].OwnerIdName);
            }

            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: '{b}<br/>{a}:{c}万元'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}万元'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '累计达成额',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}万元"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        init();
    }

    angular.module('xrmApp').service('PureOwnerTargetByAmountService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'PureOwnerTarget';
    }]);
    angular.module('xrmApp').controller("PureOwnerTargetByAmountListController", ['$scope', '$injector', '$timeout', 'rt', 'PureOwnerTargetByAmountService', PureOwnerTargetByAmountListController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/7
 说明     : 代表纯销指标达成（数量）
 *********************************************************/

(function () {
    'use strict';

    function PureOwnerTargetByQtyListController($scope, $injector, $timeout, rt, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigDeptId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "businessUnitId", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "orderByType", Value: $scope.vm.orderbyTypeCode.value });
            _that.searchList.push({ Type: 1, Key: "diyCategoryId", Value: $scope.vm.CuSelected.Id });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        function init() {
            var cw = document.documentElement.clientWidth || document.body.clientWidth;
            $scope.chartWidth = 1000;
            $scope.vm.buidList = [{ name: '全部事业部', id: '' }];
            $scope.vm.buidSelected = $scope.vm.buidList[0]; //事业部选择
            $scope.vm.bigDepList = []; //业务线/大区下拉
            $scope.vm.bigDepSelected = { id: '' }; //业务线/大区选择
            $scope.vm.businessUnitList = []; //省区/地区下拉
            $scope.vm.businessUnitSelected = null; //省区/地区选择
            $scope.vm.reportData = []; //表格数据
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.imgData = []; //图标数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.MonDataName = []; //每个月份对应文本属性名
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TbHeCosNum = 4;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.getReportData = _getReportData; //查询按钮
            $scope.selectedTabId = "tab1";
            $scope.selectTab = _selectTab;

            _initYmSelected();
            _getTops();
            _getOrderbyTypes();
            _getAllBuid(); //获取所有事业部
            _getCustomcategory();
        }

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[0];
        }

        function _getOrderbyTypes() {
            $scope.vm.orderbyTypeList = [{ value: 'Sum_Percent_Rank', name: '达成率' }, {
                value: 'Sum_Done_Rank',
                name: '达成量'
            }];
            $scope.vm.orderbyTypeCode = $scope.vm.orderbyTypeList[0];
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.concat(data);
                }
            });
        }

        //获取大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [{ name: '全部业务线/大区', id: '' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                    '@businesstype': 20
                }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
                return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        function _getCustomcategory() {
            var url = 'api/CustomCategory/GetCustomCategoryByTaskType?taskType=3&taskLevel=1';
            return rt.get(url).then(function (resp) {
                $scope.vm.customcategoryList = resp.data;
                if ($scope.vm.customcategoryList.length > 0) {
                    $scope.vm.CuSelected = $scope.vm.customcategoryList[0];
                } else {
                    $scope.vm.CuSelected = null;
                }
            });
        }

        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            $scope.vm.TbHeCosNum += (MCount + 1) * 3;
            var DeMessText = ["指标", "达成量", "达成率"];
            var DeMessName = ["{{vm.reportData[0].target" + parseInt(sArr[1]) + "}}", "{{vm.reportData.DataList[0].row.done" + parseInt(sArr[1]) + "}}", "{{vm.reportData.DataList[0].row.donepercent" + parseInt(sArr[1]) + "}}"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("指标", "达成量", "达成率");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("指标", "达成量", "达成率");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }

        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }

            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始年月不能大于结束年月";
            }

            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }

            if (rt.isNull($scope.vm.CuSelected) || rt.isNullOrWhiteSpace($scope.vm.CuSelected.Id)) {
                return "指标类型不能为空";
            }
            return "";
        }

        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var waiting = rt.showLoading2();
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            //获取达成列表数据
            var url = 'api/PureOwnerTarget/GetTsSrTargetDoneByOwnerByQtyList?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigDeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitId=" + encodeURIComponent(unitids) + "&orderByType=" + $scope.vm.orderbyTypeCode.value + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize) + "&diyCategoryId=" + $scope.vm.CuSelected.Id;

            //获取图表数据(达成率排名)
            var urlPercent = 'api/PureOwnerTarget/GetTsSrTargetDoneByownerByQtyRank?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigDeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitId=" + encodeURIComponent(unitids) + "&orderByType=Done_Percent" + "&pageIndex=1" + "&pageSize=" + $scope.vm.topsSelected + "&customCategoryId=" + $scope.vm.CuSelected.Id;

            //获取图表数据(达成量排名)
            var urlQty = 'api/PureOwnerTarget/GetTsSrTargetDoneByownerByQtyRank?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigDeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitId=" + encodeURIComponent(unitids) + "&orderByType=Sum_Done_Qty" + "&pageIndex=1" + "&pageSize=" + $scope.vm.topsSelected + "&customCategoryId=" + $scope.vm.CuSelected.Id;

            rt.get(urlPercent).then(function (resp) {
                $scope.vm.percentData = resp.data;

                rt.get(urlQty).then(function (resp) {
                    $scope.vm.qtyData = resp.data;

                    rt.get(url).then(function (resp) {
                        $scope.vm.reportData = resp.data;
                        $scope.vm.recordCount = resp.data.TotalRecords;
                        _MonDataList($scope.vm.sYm, $scope.vm.eYm);
                        _complateTableheight();
                        _show();
                    }).finally(function () {
                        waiting.close();
                    });
                });
            });
        }

        function _selectTab(id) {
            $scope.selectedTabId = id;
            _show();
        }

        function _show() {
            var t = $scope.selectedTabId;
            if (t == "tab1") {
                _showReport1();
            } else if (t == "tab2") {
                _showReport2();
            }
        }

        function _showReport1() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.percentData.DataList;
            for (var i = dataList.length - 1; i >= 0; i--) {
                echartsDataValue.push(dataList[i].Done_Percent.toFixed(2));
                echartsDataName.push(dataList[i].BusinessUnitIdName + '--' + dataList[i].OwnerIdName);
            }
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: '{b}<br/>{a}:{c}%'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '累计达成率',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}%"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        function _showReport2() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.qtyData.DataList;
            for (var i = dataList.length - 1; i >= 0; i--) {
                echartsDataValue.push(dataList[i].Sum_Done_Qty.toFixed(2));
                echartsDataName.push(dataList[i].BusinessUnitIdName + '--' + dataList[i].OwnerIdName);
            }

            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: '{b}<br/>{a}:{c}'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '累计达成量',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        init();
    }

    angular.module('xrmApp').service('PureOwnerTargetByQtyService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'PureOwnerTarget';
    }]);
    angular.module('xrmApp').controller("PureOwnerTargetByQtyListController", ['$scope', '$injector', '$timeout', 'rt', 'PureOwnerTargetByQtyService', PureOwnerTargetByQtyListController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2018/1/5
 说明     : 纯销毛利统计
 *********************************************************/
(function () {
    'use strict';

    function PureVenditionProfitListController($scope, $q, $compile, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "businessUnitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "filterType", Value: $scope.filterSelect });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        function init() {
            //时间筛选，默认全年
            $scope.dateSelect = 'fullYear';
            $scope.vm.sYm = moment().format('YYYY-01');
            $scope.vm.eYm = moment().format('YYYY-MM');

            //统计纬度，默认按客户
            $scope.filterSelect = 'byAccount';
            $scope.isAccountShow = true;

            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.totalData = { totalDoneQty: 0, totalDoneAmount: 0 };
        }

        $scope.filterSelectClick = function (selected) {
            $scope.filterSelect = selected;
        };

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            return "";
        }

        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 90);
        }

        //选择时间筛选
        $scope.vm.changeDate = function (dateType) {
            $scope.dateSelect = dateType;

            switch (dateType) {
                case "fullYear":
                    $scope.vm.sYm = moment().format('YYYY-01');
                    $scope.vm.eYm = moment().format('YYYY-MM');
                    break;
                case "thisMonth":
                    $scope.vm.sYm = moment().format('YYYY-MM');
                    $scope.vm.eYm = moment().format('YYYY-MM');
                    break;
                case "lastMonth":
                    $scope.vm.sYm = moment().add(-1, 'months').format('YYYY-MM');
                    $scope.vm.eYm = moment().add(-1, 'months').format('YYYY-MM');
                    break;
                case "thisQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-10');
                            $scope.vm.eYm = moment().format('YYYY-12');
                            break;
                    }
                    break;
                case "lastQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().add(-1, 'years').format('YYYY-10');
                            $scope.vm.eYm = moment().add(-1, 'years').format('YYYY-12');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                    }
                    break;
            }
        };

        //查询报表数据
        $scope.vm.getReportData = function () {
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();

            $scope.isAccountShow = $scope.filterSelect === 'byAccount';

            //列表
            myService.GetPureVenditionProfitList($scope.vm.sYm, $scope.vm.eYm, $scope.filterSelect, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            });

            //合计
            myService.GetPureVenditionProfitTotal($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                $scope.vm.totalData = resp.data;
                waiting.close();
            });
        };

        init();
    }
    angular.module('xrmApp').service('PureVenditionProfitService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'PureVenditionProfit';

        //列表
        this.GetPureVenditionProfitList = function (sYm, eYm, filterType, pageIndex, pageSize, unitids) {
            return rt.post("api/PureVenditionProfit/GetPureVenditionProfitList?sYm=" + sYm + "&eYm=" + eYm + "&filterType=" + filterType + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize, unitids);
        };

        //合计
        this.GetPureVenditionProfitTotal = function (sYm, eYm, unitids) {
            return rt.post("api/PureVenditionProfit/GetPureVenditionProfitTotal?sYm=" + sYm + "&eYm=" + eYm, unitids);
        };
    }]);
    angular.module('xrmApp').controller("PureVenditionProfitListController", ['$scope', '$q', '$compile', 'rt', '$injector', 'PureVenditionProfitService', PureVenditionProfitListController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/5/5
 说明     : 省区纯销指标达成
 *********************************************************/
(function () {
    'use strict';

    function PureVenditionTargetListController($scope, $q, $compile, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "businessUnitIds", Value: unitids });
            if ($scope.typeSelect === 'customCategoryByAmount' || $scope.typeSelect === 'customCategoryByQty' || $scope.typeSelect === 'tsSrTargetDoneByQty') _that.searchList.push({ Type: 1, Key: "diyCategoryId", Value: $scope.vm.cuSelected.Id });
            if ($scope.typeSelect === 'tsSrTargetDoneByAmount') //不分代表纯销指标类型||按代表纯销指标类型（金额）
                _that.searchList.push({ Type: 1, Key: "customCategoryId", Value: $scope.vm.cuSelected.Id });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        function init() {
            //时间筛选，默认全年
            $scope.dateSelect = 'fullYear';
            $scope.vm.sYm = moment().format('YYYY-01');
            $scope.vm.eYm = moment().format('YYYY-MM');

            //类型筛选，默认不分指标类型
            $scope.typeSelect = 'noCustomCategory';
            $scope.filterSelect = 'byBusinessUnit';
            $scope.vm.getCustomCategory(3, 1); //获取指标类型
            _getTops();

            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.echartData1 = [];
            $scope.vm.echartData2 = [];
            $scope.vm.totalData = { totalTarget: 0, totalDone: 0, totalPercent: 0 };
        }

        $scope.filterSelectClick = function (selected) {
            $scope.filterSelect = selected;
            if (selected === 'byBusinessUnit') $scope.typeSelect = 'noCustomCategory';else $scope.typeSelect = 'tsSrTargetDone';
        };

        $scope.typeSelecttClick = function (selected) {
            $scope.typeSelect = selected;
        };

        //获取Top
        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[0];
        }

        //获取指标类型
        $scope.vm.getCustomCategory = function (taskType, taskLevel) {
            var url = 'api/CustomCategory/GetCustomCategoryByTaskType?taskType=' + taskType + '&taskLevel=' + taskLevel;
            return rt.get(url).then(function (resp) {
                $scope.vm.customCategoryList = resp.data;
                if ($scope.vm.customCategoryList.length > 0) {
                    $scope.vm.cuSelected = $scope.vm.customCategoryList[0];
                }
            });
        };

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            return "";
        }

        //不分省区纯销指标类型&按省区纯销指标类型（金额）&按省区纯销指标类型（数量）&不分代表纯销指标类型-达成率排名-echart图表
        function _showReportPercentEchart() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.echartData1.DataList;
            if (dataList) {
                dataList = _.sortBy(dataList, function (item) {
                    return item.Sum_Percent;
                });
                echartsDataValue = _.map(dataList, function (e) {
                    return e.Sum_Percent.toFixed(2);
                });
                echartsDataName = _.map(dataList, function (e) {
                    return e.BusinessUnitIdName + '--' + (e.OwnerIdName ? e.OwnerIdName : "");
                });
            }
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: '{b}<br/>{a}:{c}%'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '累计达成率',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}%"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        //按省区纯销指标类型（金额）&不分指标类型 &不分代表纯销指标类型-达成额排名-echart图表
        function _showReportByAmountDoneEchart() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.echartData2.DataList;
            if (dataList) {
                dataList = _.sortBy(dataList, function (item) {
                    return item.Sum_Amount;
                }); //数组翻转 因为echart会反向排序
                echartsDataValue = _.map(dataList, function (e) {
                    return (e.Sum_Amount / 10000).toFixed(2);
                });
                echartsDataName = _.map(dataList, function (e) {
                    return e.BusinessUnitIdName + '--' + (e.OwnerIdName ? e.OwnerIdName : "");
                });
            }
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: '{b}<br/>{a}:{c}万元'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}万元'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '累计达成额',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}万元"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        //按省区纯销指标类型（数量）-达成量排名-echart图表
        function _showReportByQtyDoneEchart() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.echartData2.DataList;
            if (dataList) {
                dataList = _.sortBy(dataList, function (item) {
                    return item.Sum_Qty;
                }); //数组翻转 因为echart会反向排序
                echartsDataValue = _.map(dataList, function (e) {
                    return e.Sum_Qty.toFixed(2);
                });
                echartsDataName = _.map(dataList, function (e) {
                    return e.BusinessUnitIdName + '--' + (e.OwnerIdName ? e.OwnerIdName : "");
                });
            }
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: '{b}<br/>{a}:{c}'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '累计达成量',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        //处理列表数据表头
        function _setMonthData(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            var DeMessText = $scope.typeSelect === 'customCategoryByQty' || $scope.typeSelect === 'tsSrTargetDoneByQty' ? ["纯销指标", "实际达成量", "月度达成率"] : ["纯销指标", "实际达成额", "月度达成率"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    if ($scope.typeSelect === 'customCategoryByQty' || $scope.typeSelect === 'tsSrTargetDoneByQty') $scope.vm.TbMessText.push("纯销指标", "实际达成量", "月度达成率");else $scope.vm.TbMessText.push("纯销指标", "实际达成额", "月度达成率");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                if ($scope.typeSelect === 'customCategoryByQty' || $scope.typeSelect === 'tsSrTargetDoneByQty') $scope.vm.TbMessText.push("纯销指标", "实际达成量", "月度达成率");else $scope.vm.TbMessText.push("纯销指标", "实际达成额", "月度达成率");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }

        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 90);
        }

        //选择时间筛选
        $scope.vm.changeDate = function (dateType) {
            $scope.dateSelect = dateType;

            switch (dateType) {
                case "fullYear":
                    $scope.vm.sYm = moment().format('YYYY-01');
                    $scope.vm.eYm = moment().format('YYYY-MM');
                    break;
                case "thisMonth":
                    $scope.vm.sYm = moment().format('YYYY-MM');
                    $scope.vm.eYm = moment().format('YYYY-MM');
                    break;
                case "lastMonth":
                    $scope.vm.sYm = moment().add(-1, 'months').format('YYYY-MM');
                    $scope.vm.eYm = moment().add(-1, 'months').format('YYYY-MM');
                    break;
                case "thisQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-10');
                            $scope.vm.eYm = moment().format('YYYY-12');
                            break;
                    }
                    break;
                case "lastQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().add(-1, 'years').format('YYYY-10');
                            $scope.vm.eYm = moment().add(-1, 'years').format('YYYY-12');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                    }
                    break;
            }
        };

        //查询Echart图表数据
        $scope.vm.getChartData = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();

            //不分指标类型
            if ($scope.typeSelect === 'noCustomCategory') {
                $scope.isQtyShow = false;
                //达成率排名
                myService.GetNoCustomCategoryPercentEchart($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                    $scope.vm.echartData1 = resp.data;
                    _showReportPercentEchart();
                    waiting.close();
                });

                //达成额排名
                myService.GetNoCustomCategoryDoneEchart($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                    $scope.vm.echartData2 = resp.data;
                    _showReportByAmountDoneEchart();
                    waiting.close();
                });

                //合计
                myService.GetNoCustomCategoryTotal($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                    $scope.vm.totalData = resp.data;
                    waiting.close();
                });
            }

            //按省区纯销指标类型（金额）
            if ($scope.typeSelect === 'customCategoryByAmount') {
                $scope.isQtyShow = false;
                //达成率排名
                myService.GetCustomCategoryByAmountPercentEchart($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                    $scope.vm.echartData1 = resp.data;
                    _showReportPercentEchart();
                    waiting.close();
                });

                //达成额排名
                myService.GetCustomCategoryByAmountDoneEchart($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                    $scope.vm.echartData2 = resp.data;
                    _showReportByAmountDoneEchart();
                    waiting.close();
                });

                //合计
                myService.GetCustomCategoryByAmountTotal($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                    $scope.vm.totalData = resp.data;
                    waiting.close();
                });
            }

            //按省区纯销指标类型（数量）
            if ($scope.typeSelect === 'customCategoryByQty') {
                $scope.isQtyShow = true;
                //达成率排名
                myService.GetCustomCategoryByQtyPercentEchart($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                    $scope.vm.echartData1 = resp.data;
                    _showReportPercentEchart();
                    waiting.close();
                });

                //达成量排名
                myService.GetCustomCategoryByQtyDoneEchart($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                    $scope.vm.echartData2 = resp.data;
                    _showReportByQtyDoneEchart();
                    waiting.close();
                });

                //合计
                myService.GetCustomCategoryByQtyTotal($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                    $scope.vm.totalData = resp.data;
                    waiting.close();
                });
            }

            //#region 代表纯销指标

            //不分代表纯销指标类型
            if ($scope.typeSelect === 'tsSrTargetDone') {
                $scope.isQtyShow = false;
                //达成率排名
                myService.GetTsSrTargetDoneByownerPercentByAmountEchart($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                    $scope.vm.echartData1 = resp.data;
                    _showReportPercentEchart();
                    waiting.close();
                });

                //达成额排名
                myService.GetTsSrTargetDoneByownerDoneByAmountEchart($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                    $scope.vm.echartData2 = resp.data;
                    _showReportByAmountDoneEchart();
                    waiting.close();
                });

                //合计
                myService.GetTsSrTargetDoneByownerByAmountTotal($scope.vm.sYm, $scope.vm.eYm, unitids).then(function (resp) {
                    $scope.vm.totalData = resp.data;
                    waiting.close();
                });
            }

            //按代表纯销指标类型（金额）
            if ($scope.typeSelect === 'tsSrTargetDoneByAmount') {
                $scope.isQtyShow = false;
                //达成率排名
                myService.GetTsSrTargetDoneByownerPercentEchart($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                    $scope.vm.echartData1 = resp.data;
                    _showReportPercentEchart();
                    waiting.close();
                });

                //达成额排名
                myService.GetTsSrTargetDoneByownerDoneEchart($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                    $scope.vm.echartData2 = resp.data;
                    _showReportByAmountDoneEchart();
                    waiting.close();
                });

                //合计
                myService.GetTsSrTargetDoneByownerTotal($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                    $scope.vm.totalData = resp.data;
                    waiting.close();
                });
            }

            //按代表纯销指标类型（数量）
            if ($scope.typeSelect === 'tsSrTargetDoneByQty') {
                $scope.isQtyShow = true;
                //达成率排名
                myService.GetTsSrTargetDoneByownerByQtyPercentEchart($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                    $scope.vm.echartData1 = resp.data;
                    _showReportPercentEchart();
                    waiting.close();
                });

                //达成量排名
                myService.GetTsSrTargetDoneByownerByQtyDoneEchart($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                    $scope.vm.echartData2 = resp.data;
                    _showReportByQtyDoneEchart();
                    waiting.close();
                });

                //合计
                myService.GetTsSrTargetDoneByownerByQtyTotal($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, unitids).then(function (resp) {
                    $scope.vm.totalData = resp.data;
                    waiting.close();
                });
            }

            //#endregion
        };

        //查询报表数据
        $scope.vm.getReportData = function () {
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();

            $scope.isOwnerShow = $scope.typeSelect === 'tsSrTargetDone' || $scope.typeSelect === 'tsSrTargetDoneByAmount' || $scope.typeSelect === 'tsSrTargetDoneByQty';

            //不分省区纯销指标类型
            if ($scope.typeSelect === 'noCustomCategory') {
                $scope.isQtyShow = false;
                //达成列表
                myService.GetNoCustomCategoryList($scope.vm.sYm, $scope.vm.eYm, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                    $scope.vm.reportData = resp.data;
                    $scope.vm.recordCount = resp.data.TotalRecords;
                    _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                    _complateTableheight();
                    waiting.close();
                });
            }

            //按省区纯销指标类型（金额）
            if ($scope.typeSelect === 'customCategoryByAmount') {
                $scope.isQtyShow = false;
                //达成列表
                myService.GetCustomCategoryByAmountList($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                    $scope.vm.reportData = resp.data;
                    $scope.vm.recordCount = resp.data.TotalRecords;
                    _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                    _complateTableheight();
                    waiting.close();
                });
            }

            //按省区纯销指标类型（数量）
            if ($scope.typeSelect === 'customCategoryByQty') {
                $scope.isQtyShow = true;
                //达成列表
                myService.GetCustomCategoryByQtyList($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                    $scope.vm.reportData = resp.data;
                    $scope.vm.recordCount = resp.data.TotalRecords;
                    _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                    _complateTableheight();
                    waiting.close();
                });
            }

            //#region 代表纯销指标

            //不分代表纯销指标类型
            if ($scope.typeSelect === 'tsSrTargetDone') {
                $scope.isQtyShow = false;
                //达成列表
                myService.GetTsSrTargetDoneByownerByAmountList($scope.vm.sYm, $scope.vm.eYm, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                    $scope.vm.reportData = resp.data;
                    $scope.vm.recordCount = resp.data.TotalRecords;
                    _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                    _complateTableheight();
                    waiting.close();
                });
            }

            //按代表纯销指标类型（金额）
            if ($scope.typeSelect === 'tsSrTargetDoneByAmount') {
                $scope.isQtyShow = false;
                //达成列表
                myService.GetTsSrTargetDoneByownerList($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                    $scope.vm.reportData = resp.data;
                    $scope.vm.recordCount = resp.data.TotalRecords;
                    _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                    _complateTableheight();
                    waiting.close();
                });
            }

            //按代表纯销指标类型（数量）
            if ($scope.typeSelect === 'tsSrTargetDoneByQty') {
                $scope.isQtyShow = true;
                //达成列表
                myService.GetTsSrTargetDoneByownerByQtyList($scope.vm.sYm, $scope.vm.eYm, $scope.vm.cuSelected.Id, $scope.vm.pageIndex, $scope.vm.pageSize, unitids).then(function (resp) {
                    $scope.vm.reportData = resp.data;
                    $scope.vm.recordCount = resp.data.TotalRecords;
                    _setMonthData($scope.vm.sYm, $scope.vm.eYm);
                    _complateTableheight();
                    waiting.close();
                });
            }

            //#endregion
        };

        init();
    }
    angular.module('xrmApp').service('PrueVenditionService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'PureVenditionTarget';

        //不分省区纯销指标类型-达成率排名
        this.GetNoCustomCategoryPercentEchart = function (sYm, eYm, unitids) {
            return rt.post("api/PureVenditionTarget/GetPureVenditionTarget?sYm=" + sYm + "&eYm=" + eYm + "&pageIndex=1" + "&pageSize=10" + "&orderByType=percent", unitids);
        };

        //不分省区纯销指标类型-达成额排名
        this.GetNoCustomCategoryDoneEchart = function (sYm, eYm, unitids) {
            return rt.post("api/PureVenditionTarget/GetPureVenditionTarget?sYm=" + sYm + "&eYm=" + eYm + "&pageIndex=1" + "&pageSize=10" + "&orderByType=amount", unitids);
        };

        //不分省区纯销指标类型-达成列表
        this.GetNoCustomCategoryList = function (sYm, eYm, pageIndex, pageSize, unitids) {
            return rt.post("api/PureVenditionTarget/GetPureVenditionTarget?sYm=" + sYm + "&eYm=" + eYm + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&orderByType=percent", unitids);
        };

        //不分省区纯销指标类型-合计
        this.GetNoCustomCategoryTotal = function (sYm, eYm, unitids) {
            return rt.post("api/PureVenditionTarget/GetPureVenditionByAmountTotal?sYm=" + sYm + "&eYm=" + eYm, unitids);
        };

        //按省区纯销指标类型（金额）-达成率排名
        this.GetCustomCategoryByAmountPercentEchart = function (sYm, eYm, customCategoryId, unitids) {
            return rt.post("api/PureVenditionTarget/GetPureVenditionChart?sYm=" + sYm + "&eYm=" + eYm + "&orderByType=percent" + "&diyCategoryId=" + customCategoryId, unitids);
        };

        //按省区纯销指标类型（金额）-达成额排名
        this.GetCustomCategoryByAmountDoneEchart = function (sYm, eYm, customCategoryId, unitids) {
            return rt.post("api/PureVenditionTarget/GetPureVenditionChart?sYm=" + sYm + "&eYm=" + eYm + "&orderByType=amount" + "&diyCategoryId=" + customCategoryId, unitids);
        };

        //按省区纯销指标类型（金额）-达成列表
        this.GetCustomCategoryByAmountList = function (sYm, eYm, customCategoryId, pageIndex, pageSize, unitids) {
            return rt.post("api/PureVenditionTarget/GetPureVenditionTarget?sYm=" + sYm + "&eYm=" + eYm + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&diyCategoryId=" + customCategoryId + "&orderByType=percent", unitids);
        };

        //按省区纯销指标类型（金额）-合计
        this.GetCustomCategoryByAmountTotal = function (sYm, eYm, customCategoryId, unitids) {
            return rt.post("api/PureVenditionTarget/GetPureVenditionByAmountTotal?sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + customCategoryId, unitids);
        };

        //按省区纯销指标类型（数量）-达成率排名
        this.GetCustomCategoryByQtyPercentEchart = function (sYm, eYm, customCategoryId, unitids) {
            return rt.post("api/PureVenditionTarget/GetPureVenditionTargetByQty?sYm=" + sYm + "&eYm=" + eYm + "&orderByType=percent" + "&pageIndex=1" + "&pageSize=10" + "&diyCategoryId=" + customCategoryId, unitids);
        };

        //按省区纯销指标类型（数量）-达成额排名
        this.GetCustomCategoryByQtyDoneEchart = function (sYm, eYm, customCategoryId, unitids) {
            return rt.post("api/PureVenditionTarget/GetPureVenditionTargetByQty?sYm=" + sYm + "&eYm=" + eYm + "&orderByType=qty" + "&pageIndex=1" + "&pageSize=10" + "&diyCategoryId=" + customCategoryId, unitids);
        };

        //按省区纯销指标类型（数量）-达成列表
        this.GetCustomCategoryByQtyList = function (sYm, eYm, customCategoryId, pageIndex, pageSize, unitids) {
            return rt.post("api/PureVenditionTarget/GetPureVenditionTargetByQty?sYm=" + sYm + "&eYm=" + eYm + "&orderByType=percent" + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&diyCategoryId=" + customCategoryId, unitids);
        };

        //按省区纯销指标类型（数量）-合计
        this.GetCustomCategoryByQtyTotal = function (sYm, eYm, customCategoryId, unitids) {
            return rt.post("api/PureVenditionTarget/GetPureVenditionByQtyTotal?sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + customCategoryId, unitids);
        };

        //#region 代表纯销指标类型
        //按代表纯销指标类型（金额）-达成率排名
        this.GetTsSrTargetDoneByownerPercentEchart = function (sYm, eYm, customCategoryId, unitids) {
            return rt.post("api/PureOwnerTarget/GetTsSrTargetDoneByownerChart?sYm=" + sYm + "&eYm=" + eYm + "&customCategoryId=" + customCategoryId + "&orderByType=percent", unitids);
        };

        //按代表纯销指标类型（金额）-达成额排名
        this.GetTsSrTargetDoneByownerDoneEchart = function (sYm, eYm, customCategoryId, unitids) {
            return rt.post("api/PureOwnerTarget/GetTsSrTargetDoneByownerChart?sYm=" + sYm + "&eYm=" + eYm + "&customCategoryId=" + customCategoryId + "&orderByType=amount", unitids);
        };

        //按代表纯销指标类型（金额）-达成列表
        this.GetTsSrTargetDoneByownerList = function (sYm, eYm, customCategoryId, pageIndex, pageSize, unitids) {
            return rt.post("api/PureOwnerTarget/GetTsSrTargetDoneByownerList?sYm=" + sYm + "&eYm=" + eYm + "&customCategoryId=" + customCategoryId + "&orderByType=percent" + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize, unitids);
        };

        //按代表纯销指标类型（金额）-合计
        this.GetTsSrTargetDoneByownerTotal = function (sYm, eYm, customCategoryId, unitids) {
            return rt.post("api/PureOwnerTarget/GetTsSrTargetDoneByownerTotal?sYm=" + sYm + "&eYm=" + eYm + "&customCategoryId=" + customCategoryId, unitids);
        };

        //不分代表纯销指标类型-达成率排名
        this.GetTsSrTargetDoneByownerPercentByAmountEchart = function (sYm, eYm, unitids) {
            return rt.post("api/PureOwnerTarget/GetTsSrTargetDoneByownerChart?sYm=" + sYm + "&eYm=" + eYm + "&orderByType=percent", unitids);
        };

        //不分代表纯销指标类型-达成额排名
        this.GetTsSrTargetDoneByownerDoneByAmountEchart = function (sYm, eYm, unitids) {
            return rt.post("api/PureOwnerTarget/GetTsSrTargetDoneByownerChart?sYm=" + sYm + "&eYm=" + eYm + "&orderByType=amount", unitids);
        };

        //不分代表纯销指标类型-达成列表
        this.GetTsSrTargetDoneByownerByAmountList = function (sYm, eYm, pageIndex, pageSize, unitids) {
            return rt.post("api/PureOwnerTarget/GetTsSrTargetDoneByownerList?sYm=" + sYm + "&eYm=" + eYm + "&orderByType=percent" + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize, unitids);
        };

        //不分代表纯销指标类型-合计
        this.GetTsSrTargetDoneByownerByAmountTotal = function (sYm, eYm, unitids) {
            return rt.post("api/PureOwnerTarget/GetTsSrTargetDoneByownerTotal?sYm=" + sYm + "&eYm=" + eYm, unitids);
        };

        //按省区纯销指标类型（数量）-达成率排名
        this.GetTsSrTargetDoneByownerByQtyPercentEchart = function (sYm, eYm, customCategoryId, unitids) {
            return rt.post("api/PureOwnerTarget/GetTsSrTargetDoneByOwnerByQtyList?sYm=" + sYm + "&eYm=" + eYm + "&orderByType=percent" + "&pageIndex=1" + "&pageSize=10" + "&diyCategoryId=" + customCategoryId, unitids);
        };

        //按省区纯销指标类型（数量）-达成额排名
        this.GetTsSrTargetDoneByownerByQtyDoneEchart = function (sYm, eYm, customCategoryId, unitids) {
            return rt.post("api/PureOwnerTarget/GetTsSrTargetDoneByOwnerByQtyList?sYm=" + sYm + "&eYm=" + eYm + "&orderByType=qty" + "&pageIndex=1" + "&pageSize=10" + "&diyCategoryId=" + customCategoryId, unitids);
        };

        //按省区纯销指标类型（数量）-达成列表
        this.GetTsSrTargetDoneByownerByQtyList = function (sYm, eYm, customCategoryId, pageIndex, pageSize, unitids) {
            return rt.post("api/PureOwnerTarget/GetTsSrTargetDoneByOwnerByQtyList?sYm=" + sYm + "&eYm=" + eYm + "&orderByType=percent" + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&diyCategoryId=" + customCategoryId, unitids);
        };

        //按省区纯销指标类型（数量）-合计
        this.GetTsSrTargetDoneByownerByQtyTotal = function (sYm, eYm, customCategoryId, unitids) {
            return rt.post("api/PureOwnerTarget/GetTsSrTargetDoneByOwnerByQtyTotal?sYm=" + sYm + "&eYm=" + eYm + "&diyCategoryId=" + customCategoryId, unitids);
        };

        //#endregion
    }]);
    angular.module('xrmApp').controller("PureVenditionTargetListController", ['$scope', '$q', '$compile', 'rt', '$injector', 'PrueVenditionService', PureVenditionTargetListController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/6
 说明     : 省区纯销指标达成（金额）
 *********************************************************/

(function () {
    'use strict';

    function PureVenditionTargetByAmountListController($scope, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                rt.errorMessage("请选择开始年月");
                return false;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                rt.errorMessage("请选择结束年月");
                return false;
            }

            if ($scope.vm.sYm > $scope.vm.eYm) {
                rt.errorMessage("开始年月不能大于结束年月");
                return false;
            }

            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                rt.errorMessage("只可查询同一年的数据");
                return false;
            }

            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "businessUnitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "bigdeptId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "orderbyType", Value: $scope.vm.orderbyTypeCode.id });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        function init() {
            $scope.chartWidth = 1000;

            $scope.vm.buidList = [{ name: '全部事业部', id: '' }];
            $scope.vm.buidSelected = $scope.vm.buidList[0]; //事业部选择
            $scope.vm.bigDepList = []; //业务线/大区下拉
            $scope.vm.bigDepSelected = { id: '' }; //业务线/大区选择
            $scope.vm.businessUnitList = []; //省区/地区下拉
            $scope.vm.businessUnitSelected = null; //省区/地区选择
            $scope.vm.reportData2 = [];
            $scope.vm.reportData3 = [];
            $scope.vm.reportData = []; //表格数据
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.imgData = []; //图标数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.MonDataName = []; //每个月份对应文本属性名
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TbHeCosNum = 3;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.getReportData = _getReportData; //查询按钮
            $scope.selectedTabId = "tab1";
            $scope.selectTab = _selectTab;

            _initYmSelected();
            _getTops();
            _getAllBuid(); //获取所有事业部
            _getOrderbyTypes();
        }

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[0];
        }

        function _getOrderbyTypes() {
            $scope.vm.orderbyTypeList = [{ id: 'percent', name: '达成率' }, { id: 'amount', name: '达成额' }];
            $scope.vm.orderbyTypeCode = $scope.vm.orderbyTypeList[0];
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.concat(data);
                }
            });
        }

        //获取业务线/大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.bigDepList = [{ name: '全部业务线/大区', id: '' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                    '@businesstype': 20
                }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { Id: '' };
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    $scope.vm.bigDepList = [{ name: '全部业务线/大区', id: '' }];
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(data);
                    }
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];
                return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            $scope.vm.TbHeCosNum += (MCount + 1) * 3;
            var DeMessText = ["纯销指标", "实际达成额", "月度达成率"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("纯销指标", "实际达成额", "月度达成率");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("纯销指标", "实际达成额", "月度达成率");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }

        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 90);
        }

        function _getReportData() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                rt.errorMessage("请选择开始年月");
                return false;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                rt.errorMessage("请选择结束年月");
                return false;
            }

            if ($scope.vm.sYm > $scope.vm.eYm) {
                rt.errorMessage("开始年月不能大于结束年月");
                return false;
            }

            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                rt.errorMessage("只可查询同一年的数据");
                return false;
            }

            var waiting = rt.showLoading2();
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            //获取表格分页数据
            var url = 'api/PureVenditionTarget/GetPureVenditionTarget?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitIds=" + encodeURIComponent(unitids) + "&orderbyType=" + $scope.vm.orderbyTypeCode.id + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            //获取图表数据(达成率)
            var url2 = 'api/PureVenditionTarget/GetPureVenditionTarget?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitIds=" + encodeURIComponent(unitids) + "&orderbyType=percent" + "&pageIndex=1" + "&pageSize=" + $scope.vm.topsSelected;

            //获取图表数据(达成额)
            var url3 = 'api/PureVenditionTarget/GetPureVenditionTarget?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitIds=" + encodeURIComponent(unitids) + "&orderbyType=amount" + "&pageIndex=1" + "&pageSize=" + $scope.vm.topsSelected;

            rt.get(url2).then(function (resp) {
                $scope.vm.reportData2 = resp.data;

                rt.get(url3).then(function (resp) {
                    $scope.vm.reportData3 = resp.data;

                    rt.get(url).then(function (resp) {
                        $scope.vm.reportData = resp.data;
                        $scope.vm.recordCount = resp.data.TotalRecords;
                        _MonDataList($scope.vm.sYm, $scope.vm.eYm);
                        _complateTableheight();
                        _show();
                    }).finally(function () {
                        waiting.close();
                    });
                });
            });
        }

        function _selectTab(id) {
            $scope.selectedTabId = id;
            _show();
        }

        function _show() {
            var t = $scope.selectedTabId;
            if (t == "tab1") {
                _showReport1();
            } else if (t == "tab2") {
                _showReport2();
            }
        }

        function _showReport1() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.reportData2.DataList;
            if (dataList) {
                dataList = _.sortBy(dataList, function (item) {
                    return item.Sum_Percent;
                });
                echartsDataValue = _.map(dataList, function (e) {
                    return e.Sum_Percent.toFixed(2);
                });
                echartsDataName = _.map(dataList, function (e) {
                    return e.BusinessUnitIdName + '--' + (e.OwnerIdName ? e.OwnerIdName : "");
                });
            }
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: '{b}<br/>{a}:{c}%'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '累计达成率',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}%"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        //实际达成额排名图表
        function _showReport2() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.reportData3.DataList;
            if (dataList) {
                dataList = _.sortBy(dataList, function (item) {
                    return item.Sum_Amount;
                }); //数组翻转 因为echart会反向排序
                echartsDataValue = _.map(dataList, function (e) {
                    return (e.Sum_Amount / 10000).toFixed(2);
                });
                echartsDataName = _.map(dataList, function (e) {
                    return e.BusinessUnitIdName + '--' + (e.OwnerIdName ? e.OwnerIdName : "");
                });
            }
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: '{b}<br/>{a}:{c}万元'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01]
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '累计达成额',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}万元"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        init();
    }

    angular.module('xrmApp').service('PrueVenditionByAmountService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'PureVenditionTarget';
    }]);
    angular.module('xrmApp').controller("PureVenditionTargetByAmountListController", ['$scope', 'rt', '$injector', 'PrueVenditionByAmountService', PureVenditionTargetByAmountListController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/4/7
 说明     : 省区纯销指标达成（数量）
 *********************************************************/

(function () {
    'use strict';

    function PureVenditionTargetByQtyListController($scope, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                rt.errorMessage("请选择开始年月");
                return false;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                rt.errorMessage("请选择结束年月");
                return false;
            }

            if ($scope.vm.sYm > $scope.vm.eYm) {
                rt.errorMessage("开始年月不能大于结束年月");
                return false;
            }

            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                rt.errorMessage("只可查询同一年的数据");
                return false;
            }

            if (rt.isNull($scope.vm.CuSelected) || rt.isNullOrWhiteSpace($scope.vm.CuSelected.Id)) {
                return "指标类型不能为空";
            }

            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "businessUnitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "bigdeptId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "orderbyType", Value: $scope.vm.orderbyTypeCode.id });
            _that.searchList.push({ Type: 1, Key: "diyCategoryId", Value: $scope.vm.CuSelected.Id });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        function init() {
            $scope.chartWidth = 1000;

            $scope.vm.buidList = [{ name: '全部事业部', id: '' }];
            $scope.vm.buidSelected = $scope.vm.buidList[0]; //事业部选择
            $scope.vm.bigDepList = []; //业务线/大区下拉
            $scope.vm.bigDepSelected = { id: '' }; //业务线/大区选择
            $scope.vm.businessUnitList = []; //省区/地区下拉
            $scope.vm.businessUnitSelected = null; //省区/地区选择
            $scope.vm.reportData2 = [];
            $scope.vm.reportData3 = [];
            $scope.vm.reportData = []; //表格数据
            $scope.vm.data = []; //自定义分类数据
            $scope.vm.imgData = []; //图标数据
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.MonDataName = []; //每个月份对应文本属性名
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TbHeCosNum = 3;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.getReportData = _getReportData; //查询按钮
            $scope.selectedTabId = "tab1";
            $scope.selectTab = _selectTab;

            _initYmSelected();
            _getTops();
            _getAllBuid(); //获取所有事业部
            _getOrderbyTypes();
            _getCustomcategory();
        }

        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[0];
        }

        function _getOrderbyTypes() {
            $scope.vm.orderbyTypeList = [{ id: 'percent', name: '达成率' }, { id: 'qty', name: '达成量' }];
            $scope.vm.orderbyTypeCode = $scope.vm.orderbyTypeList[0];
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = $scope.vm.buidList.concat(data);
                }
            });
        }

        //获取业务线/大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.bigDepList = [{ name: '全部业务线/大区', id: '' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                    '@businesstype': 20
                }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { Id: '' };
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    $scope.vm.bigDepList = [{ name: '全部业务线/大区', id: '' }];
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(data);
                    }
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];
                return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        function _getCustomcategory() {
            var url = 'api/CustomCategory/GetCustomCategoryByTaskType?taskType=3&taskLevel=1';
            return rt.get(url).then(function (resp) {
                $scope.vm.customcategoryList = resp.data;
                if ($scope.vm.customcategoryList.length > 0) {
                    $scope.vm.CuSelected = $scope.vm.customcategoryList[0];
                } else {
                    $scope.vm.CuSelected = null;
                }
            });
        }

        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            $scope.vm.MonDataName = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            $scope.vm.TbHeCosNum += (MCount + 1) * 3;
            var DeMessText = ["纯销指标", "实际达成额", "月度达成率"];

            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("纯销指标", "实际达成额", "月度达成率");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("纯销指标", "实际达成额", "月度达成率");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }

        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 90);
        }

        function _getReportData() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                rt.errorMessage("请选择开始年月");
                return false;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                rt.errorMessage("请选择结束年月");
                return false;
            }

            if ($scope.vm.sYm > $scope.vm.eYm) {
                rt.errorMessage("开始年月不能大于结束年月");
                return false;
            }

            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                rt.errorMessage("只可查询同一年的数据");
                return false;
            }

            var waiting = rt.showLoading2();
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            //获取表格分页数据
            var url = 'api/PureVenditionTarget/GetPureVenditionTargetByQty?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitIds=" + encodeURIComponent(unitids) + "&orderbyType=" + $scope.vm.orderbyTypeCode.id + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize) + "&diyCategoryId=" + $scope.vm.CuSelected.Id;

            //获取图表数据(达成率)
            var url2 = 'api/PureVenditionTarget/GetPureVenditionTargetByQty?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitIds=" + encodeURIComponent(unitids) + "&orderbyType=percent" + "&pageIndex=1" + "&pageSize=" + $scope.vm.topsSelected + "&diyCategoryId=" + $scope.vm.CuSelected.Id;

            //获取图表数据(达成额)
            var url3 = 'api/PureVenditionTarget/GetPureVenditionTargetByQty?sYm=' + encodeURIComponent($scope.vm.sYm) + "&eYm=" + encodeURIComponent($scope.vm.eYm) + "&buId=" + $scope.vm.buidSelected.id + "&bigdeptId=" + encodeURIComponent($scope.vm.bigDepSelected.id) + "&businessUnitIds=" + encodeURIComponent(unitids) + "&orderbyType=qty" + "&pageIndex=1" + "&pageSize=" + $scope.vm.topsSelected + "&diyCategoryId=" + $scope.vm.CuSelected.Id;

            rt.get(url2).then(function (resp) {
                $scope.vm.reportData2 = resp.data;

                rt.get(url3).then(function (resp) {
                    $scope.vm.reportData3 = resp.data;

                    rt.get(url).then(function (resp) {
                        $scope.vm.reportData = resp.data;
                        $scope.vm.recordCount = resp.data.TotalRecords;
                        _MonDataList($scope.vm.sYm, $scope.vm.eYm);
                        _complateTableheight();
                        _show();
                    }).finally(function () {
                        waiting.close();
                    });
                });
            });
        }

        function _selectTab(id) {
            $scope.selectedTabId = id;
            _show();
        }

        function _show() {
            var t = $scope.selectedTabId;
            if (t == "tab1") {
                _showReport1();
            } else if (t == "tab2") {
                _showReport2();
            }
        }

        function _showReport1() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.reportData2.DataList;
            if (dataList) {
                dataList = _.sortBy(dataList, function (item) {
                    return item.Sum_Percent;
                });
                echartsDataValue = _.map(dataList, function (e) {
                    return e.Sum_Percent.toFixed(2);
                });
                echartsDataName = _.map(dataList, function (e) {
                    return e.BusinessUnitIdName + '--' + (e.OwnerIdName ? e.OwnerIdName : "");
                });
            }
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: '{b}<br/>{a}:{c}%'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '累计达成率',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}%"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        //实际达成量排名图表
        function _showReport2() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue = [];
            var echartsDataName = [];
            var dataList = $scope.vm.reportData3.DataList;
            if (dataList) {
                dataList = _.sortBy(dataList, function (item) {
                    return item.Sum_Qty;
                }); //数组翻转 因为echart会反向排序
                echartsDataValue = _.map(dataList, function (e) {
                    return e.Sum_Qty.toFixed(2);
                });
                echartsDataName = _.map(dataList, function (e) {
                    return e.BusinessUnitIdName + '--' + (e.OwnerIdName ? e.OwnerIdName : "");
                });
            }
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: '{b}<br/>{a}:{c}'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01]
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '累计达成量',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        init();
    }

    angular.module('xrmApp').service('PureVenditionTargetByQtyService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'PureVenditionTarget';
    }]);
    angular.module('xrmApp').controller("PureVenditionTargetByQtyListController", ['$scope', 'rt', '$injector', 'PureVenditionTargetByQtyService', PureVenditionTargetByQtyListController]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2015-04-25
说明     : 城市表单视图 控制器
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller('ratinglogEditController', ['$scope', '$state', '$stateParams', 'rt', ratinglogEditController]);
    function ratinglogEditController($scope, $state, $stateParams, rt) {
        var _vm = $scope.vm = {};
        _init();

        function _init() {
            /****************** 定义数据对象 ******************/
            _vm.form = {};
            _vm.form.id = $stateParams.id;
            _vm.form.type = $stateParams.id === "" ? "Create" : "Edit";
            _vm.form.data = {};
            _vm.picklist = {};
            _vm.privilege = {};
            _vm.privilege.IsCreate = true;
            _vm.privilege.IsDelete = true;
            _vm.privilege.IsWrite = true;

            /****************** 加载数据 ******************/

            // 加载表单
            _loadForm();

            /****************** 绑定事件 ******************/

            // 删除事件
            _vm.form.del = _del;

            // 保存事件
            _vm.form.save = _saveForm;
        }

        function _loadForm() {
            /// <summary>加载城市表单</summary>


        }

        function _saveForm(createNext) {
            /// <summary>保存表单数据</summary>
            /// <param name="createNext">是否创建下一条记录</param>
            var trigerButtonId = createNext ? "btnSaveAndNew" : "btnSave";
        }

        function _del() {
            /// <summary>删除事件</summary>

        }

        function _reloadForm(id) {
            /// <summary>重新加载表单</summary>

            // 刷新视图页面
        }
    }
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2015-04-15
说明     : 城市列表视图 控制器
*********************************************************/

(function () {
            'use strict';

            angular.module('xrmApp').controller('ratinglogListController', ['$scope', '$state', 'rt', ratinglogListController]);
            function ratinglogListController($scope, $state, rt) {
                        var _vm = $scope.vm = {};
                        _init();

                        function _init() {
                                    /****************** 定义数据对象 ******************/
                                    _vm.view = {};
                                    _vm.view.list = [];
                                    _vm.view.selectedView = {};
                                    _vm.view.searchText = '';
                                    _vm.view.sortField = 'name asc';
                                    _vm.data = {};
                                    _vm.view.selectedIds = [];
                                    _vm.row = {};
                                    _vm.page = {};
                                    _vm.page.index = 1;
                                    _vm.page.size = rt.getPaginationSize();
                                    _vm.page.recordCount = 2;
                                    _vm.privilege = {};
                                    _vm.privilege.IsCreate = true;
                                    _vm.privilege.IsDelete = true;

                                    /****************** 加载数据 ******************/

                                    // 检查实体权限
                                    _loadPrivilege();

                                    // 加载视图和数据
                                    _loadView();

                                    /****************** 数据监控 ******************/

                                    // 选中视图后加载数据
                                    $scope.$watch('vm.view.selectedView', _loadData);

                                    /****************** 绑定事件 ******************/

                                    // 选择视图事件
                                    _vm.view.select = function (view) {
                                                _vm.view.selectedView = view;
                                    };

                                    // 搜索事件
                                    _vm.view.search = _loadData;

                                    // 删除事件
                                    _vm.row.del = function () {};
                        }

                        function _loadPrivilege() {
                                    /// <summary>检查实体的相关操作权限</summary>

                        }

                        function _loadView() {
                                    /// <summary>加载视图列表</summary>


                        }

                        function _loadData() {
                                    /// <summary>加载视图数据</summary>


                        }
            }
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人    : Summer Xu
 创建时间  : 2016/6/23
 说明      : 招聘指标达成
 *********************************************************/
(function () {
    'use strict';

    function recruitreachController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            //组合条件
            var accids = "";
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                rt.errorMessage("请选择开始年月");
                return false;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                rt.errorMessage("请选择结束年月");
                return false;
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                rt.errorMessage("只可查询同一年的数据");
                return false;
            }
            if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                rt.errorMessage("开始日期必须小于等于结束日期");
                return false;
            }
            if (rt.isNull($scope.vm.buidSelected)) {
                rt.errorMessage("请选择事业部");
                return false;
            }
            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join(",");
                $scope.vm.depType = 0;
            } else {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigdepart", Value: accids });
            _that.searchList.push({ Type: 1, Key: "deType", Value: $scope.vm.depType });
            _that.searchList.push({ Type: 1, Key: "orderStr", Value: $scope.vm.orderCode.id });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.chartWidth = 1000;
            // $scope.vm.data = [];
            $scope.vm.dataTable = [];
            $scope.vm.MonDataList = []; //月份数据
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.RepoteData = []; //累计达成率图表数据
            $scope.vm.RepoteDataForCount = []; //实际达成额排名图表数据
            $scope.vm.accList = []; //省区地区数据
            $scope.vm.accSelected = null; //省区地区选择
            //            $scope.vm.productList = [];//药品数据
            //            $scope.vm.productSelected = null;//药品选择
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = null;
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = [];
            $scope.vm.depType = 0;
            $scope.vm.searchFormHide = true;
            $scope.vm.orderCode = 0;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.selectedTabId = "tab1";
            $scope.selectTab = _selectTab;
            $scope.tableMaxHeight = 0;
            $scope.vm.search = function () {
                _search().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getTops();
            _getAllBuid();
            _initYmSelected();
            _getOrderStr();
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }
        //切换tab
        function _selectTab(id) {
            switch (id) {
                case 'tab1':
                    _show();break;
                case 'tab2':
                    _showcount();break;
                case 'tab3':
                    break;
            }
        }

        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[0];
        }
        function _getOrderStr() {
            $scope.vm.OrderList = [{ id: 0, name: '达成率' }, { id: 1, name: '达成数' }];
            $scope.vm.orderCode = $scope.vm.OrderList[0];
        }
        //--月份与对应月份的文字--//
        function _MonDataList(startDate, endDate) {
            $scope.vm.MonDataList = [];
            $scope.vm.TbMessText = [];
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var NMon = 0;
            var MCount = eArr[1] - sArr[1];
            var DeMessText = ["招聘指标", "实际达成数", "月度达成率"];
            // $scope.vm.MonDataList[0] = sArr[1];
            if (MCount > 0) {
                for (var i = 0; i < MCount; i++) {
                    NMon = parseInt(sArr[1]) + i;
                    $scope.vm.MonDataList[i] = NMon;
                    $scope.vm.TbMessText.push("招聘指标", "实际达成数", "月度达成率");
                }
                $scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
                $scope.vm.TbMessText.push("招聘指标", "实际达成数", "月度达成率");
            } else {
                $scope.vm.MonDataList[0] = parseInt(sArr[1]);
                $scope.vm.TbMessText = DeMessText;
            }
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                        //                        $scope.vm.bigDepList = $scope.vm.bigDepList[0];//kengdie
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
            $scope.vm.businessUnitList = [];
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }
        function _CalOneYear(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var result = sArr[0] - eArr[0];
            return result;
        } //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        function _ReportTbData(unitSelected) {
            //通过接口获取累计达成率图表数据

            var waiting = rt.showLoading2();
            var TabDataUrl = 'api/RecruitReachReport/GetRecruitReachRMChartData?sYm=' + encodeURIComponent($scope.vm.sYm) + '&eYm=' + encodeURIComponent($scope.vm.eYm) + "&buid=" + $scope.vm.buidSelected.id + '&bigdept=' + encodeURIComponent(unitSelected) + '&depType=' + $scope.vm.depType + '&top=' + $scope.vm.topsSelected;
            return rt.get(TabDataUrl).then(function (resp) {
                $scope.vm.RepoteData = resp.data;
                waiting.close();
                _show();
            }, function () {
                waiting.close();
            });
        }
        function _ReportTbDataForCount(unitSelected) {
            //通过接口获取实际达成额排名图表数据
            var waiting = rt.showLoading2();
            var TabDataUrl = 'api/RecruitReachReport/GetRecruitReachRMCChartDataForCount?sYm=' + encodeURIComponent($scope.vm.sYm) + '&eYm=' + encodeURIComponent($scope.vm.eYm) + "&buid=" + $scope.vm.buidSelected.id + '&bigdept=' + encodeURIComponent(unitSelected) + '&depType=' + $scope.vm.depType + '&top=' + $scope.vm.topsSelected;
            return rt.get(TabDataUrl).then(function (resp) {
                $scope.vm.RepoteDataForCount = resp.data;
                waiting.close();
                _showcount();
            }, function () {
                waiting.close();
            });
        }

        function _search() {
            var unitSelected = "";
            var accids = "";
            var pids = "";
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                var deferred = $q.defer();
                deferred.reject("请选择开始年月.");
                return deferred.promise;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                var deferred = $q.defer();
                deferred.reject("请选择结束年月.");
                return deferred.promise;
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                var deferred = $q.defer();
                deferred.reject("只可查询同一年的数据.");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.sYm, $scope.vm.eYm) < 0) {
                var deferred = $q.defer();
                deferred.reject("开始日期必须小于等于结束日期.");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.buidSelected)) {
                var deferred = $q.defer();
                deferred.reject("请选择事业部.");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.topsSelected)) {
                var deferred = $q.defer();
                deferred.reject("请选择Top值.");
                return deferred.promise;
            }

            if ($scope.vm.businessUnitSelected.length > 0) {
                var accmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                accids = accmap.join(",");
                $scope.vm.depType = 0;
            } else {
                accids = $scope.vm.bigDepSelected.id;
                $scope.vm.depType = 1;
            }
            _MonDataList($scope.vm.sYm, $scope.vm.eYm);
            _ReportTbData(accids);
            _ReportTbDataForCount(accids);
            var waiting = rt.showLoading2();
            var url = 'api/RecruitReachReport/GetRecruitReachRMData?sYm=' + $scope.vm.sYm + "&eYm=" + $scope.vm.eYm + "&buid=" + $scope.vm.buidSelected.id + "&bigdept=" + accids + "&depType=" + $scope.vm.depType + "&orderStr=" + $scope.vm.orderCode.id + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize;
            return rt.get(url).then(function (resp) {
                $scope.vm.dataTable = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
        //展示图表数据
        //实际达成额排名图表
        function _showcount() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");

            var echartYName = [];
            var echartsData = [];
            var getData = $scope.vm.RepoteDataForCount.DataList;
            if (getData != null && getData.length > 0) {
                for (var i = 0; i < getData.length; i++) {
                    echartYName.push(getData[i].BusinessUnitName + "--" + getData[i].UserName);
                    echartsData.push(getData[i].doneRank);
                }
            }

            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}人'
                    }

                }],
                yAxis: [{
                    type: 'category',
                    data: echartYName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '实际达成数',
                    type: 'bar',
                    data: echartsData,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}人"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.setOption(option);
        }
        //累计达成率排名图表
        function _show() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");

            var echartYName = [];
            var echartsData = [];
            var getData = $scope.vm.RepoteData.DataList;
            if (getData != null && getData.length > 0) {
                for (var i = 0; i < getData.length; i++) {
                    echartYName.push(getData[i].BusinessUnitName + "--" + getData[i].UserName);
                    echartsData.push(getData[i].totalPercent);
                }
            }
            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartYName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '累计达成率',
                    type: 'bar',
                    data: echartsData,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}%"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.setOption(option);
        }
        init();
    }
    angular.module('xrmApp').service('RecruitReachReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'RecruitReachReport';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("recruitreachController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'RecruitReachReportService', recruitreachController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-5-5
 说明     :异常终端报表
 *********************************************************/
(function () {
    'use strict';

    function abnormalterListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var pids = "";
            var eYm = $scope.vm.eYm;
            var max = $scope.vm.max;
            var min = $scope.vm.min;
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                eYm = "";
                rt.errorMessage("请选择开始年月");
                return false;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.max)) {
                max = 4;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.min)) {
                min = 0.6;
            }
            if ($scope.vm.min > 1 || $scope.vm.min < 0) {
                rt.errorMessage("减少率：请填写0-1之间的数");
                return false;
            }
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join("','");
            }
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "eYm", Value: eYm });
            _that.searchList.push({ Type: 1, Key: "saleregion", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "saletodrugId", Value: pids });
            _that.searchList.push({ Type: 1, Key: "max", Value: max });
            _that.searchList.push({ Type: 1, Key: "min", Value: min });
            _that.searchList.push({ Type: 1, Key: "entType", Value: $scope.vm.entType });
            _that.searchList.push({ Type: 1, Key: "exportType", Value: $scope.selectedTab });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        var $stateParams = myService.$stateParams;
        $scope.vm.entType = $stateParams.entType ? $stateParams.entType : 2; //模块终端类型
        $scope.vm.moduleName = _getModuleName($scope.vm.entType); //模块名称
        function init() {
            $scope.vm.productList = [];
            $scope.vm.productSelected = null;
            $scope.vm.data = [];
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.search = _search;
            $scope.vm.eYm = moment().add('months', -1).format('YYYY-MM');
            $scope.selectedTab = 'detail';
        }

        //根据模块参数获取模块名称
        function _getModuleName(entType) {
            var str = '医院';
            entType = rt.isNullOrWhiteSpace(entType) ? 2 : parseInt(entType);
            switch (entType) {
                case 1:
                    str = '商业';
                    break;
                case 2:
                    str = '医院';
                    break;
                case 3:
                    str = '门店';
                    break;
                case 4:
                    str = '基层医疗机构';
                    break;
            }
            return str;
        }

        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 80);
            }, 0);
        }

        //搜索hos数据
        function _search() {
            var pids = "";
            var eYm = $scope.vm.eYm;
            var max = $scope.vm.max;
            var min = $scope.vm.min;

            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                eYm = "";
                rt.errorMessage("请选择开始年月");
                return false;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.max)) {
                max = 4;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.min)) {
                min = 0.6;
            }
            if ($scope.vm.min > 1 || $scope.vm.min < 0) {
                rt.errorMessage("减少率：请填写0-1之间的数");
                return false;
            }
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join("','");
            }

            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";

            var waiting = rt.showLoading2();
            var url = "";

            switch ($scope.selectedTab) {
                case 'detail':
                    url = "api/Abnormalterminal/GetAbnormalterData";
                    break;
                case 'count':
                    url = "api/Abnormalterminal/GetAbnormalterCount";
                    break;
            }

            url += "?eYm=" + eYm;
            url += "&saletodrugId=" + pids;
            url += "&max=" + max;
            url += "&min=" + min;
            url += "&pageIndex=" + $scope.vm.pageIndex;
            url += "&pageSize=" + $scope.vm.pageSize;
            url += "&entType=" + $scope.vm.entType;

            rt.post(url, unitids).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }

        //切换tab
        $scope.selectTab = function (type) {
            $scope.selectedTab = type;
            $scope.vm.pageIndex = 1;
            _search();
        };

        init();
    }

    angular.module('xrmApp').service('AbnormalterService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'Abnormalterminal';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("abnormalterListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'AbnormalterService', abnormalterListController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-5-4
 说明     :新开发医院Controller
 *********************************************************/
(function () {
    'use strict';

    function newlyhosListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            //组合条件
            var pids = "";
            if (rt.isNull($scope.vm.eYm)) {
                rt.errorMessage("请选择年月");
                return false;
            }
            if (rt.isNull($scope.vm.purchasingMonth) || $scope.vm.purchasingMonth === "") {
                rt.errorMessage("请填写最近N个月未进货");
                return false;
            }
            if (!rt.isUnsignedIntegerString(parseInt($scope.vm.purchasingMonth))) {
                rt.errorMessage("最近N个月未进货应为正整数");
                return false;
            }

            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join(",");
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "purchasingMonth", Value: $scope.vm.purchasingMonth });
            _that.searchList.push({ Type: 1, Key: "saletodrugId", Value: pids });
            _that.searchList.push({ Type: 1, Key: "entType", Value: $scope.vm.entType });
            _that.searchList.push({ Type: 1, Key: "businessUnitIds", Value: rt.isNull($scope.vm.nodeSelected) ? "" : $scope.vm.nodeSelected.ids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        var $stateParams = myService.$stateParams;
        $scope.vm.entType = $stateParams.entType ? $stateParams.entType : 2; //模块终端类型
        $scope.vm.moduleName = _getModuleName($scope.vm.entType); //模块名称
        function init() {
            $scope.vm.productList = [];
            $scope.vm.productSelected = null;
            $scope.vm.data = [];
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.purchasingMonth = 6;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.search = _search;
            $scope.vm.eYm = moment().add('months', -1).format('YYYY-MM');
            _getAllProduct(); //获取所有事业部
        }

        //根据模块参数获取模块名称
        function _getModuleName(entType) {
            var str = '医院';
            entType = rt.isNullOrWhiteSpace(entType) ? 2 : parseInt(entType);
            switch (entType) {
                case 1:
                    str = '商业';
                    break;
                case 2:
                    str = '医院';
                    break;
                case 3:
                    str = '门店';
                    break;
                case 4:
                    str = '基层医疗机构';
                    break;
            }
            return str;
        }

        //（暂时）计算报表应有高度
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 80);
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 80);
            }, 0);
        }

        //搜索hos数据
        function _search() {

            var pids = "";

            if (rt.isNull($scope.vm.eYm)) {
                rt.errorMessage("请选择年月");
                return false;
            }
            if (rt.isNull($scope.vm.purchasingMonth) || $scope.vm.purchasingMonth === "") {
                rt.errorMessage("请填写最近N个月未进货");
                return false;
            }
            if (!rt.isUnsignedIntegerString(parseInt($scope.vm.purchasingMonth))) {
                rt.errorMessage("最近N个月未进货应为正整数");
                return false;
            }

            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join(",");
            }

            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";

            var waiting = rt.showLoading2();
            var url = 'api/Newlydevelopedhos/GetNewlydevelopedhosData?eYm=' + encodeURIComponent($scope.vm.eYm) + "&saletodrugId=" + encodeURIComponent(pids) + "&parentBusinessUnitId=" + '' + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize) + "&entType=" + encodeURIComponent($scope.vm.entType) + "&buId=" + '' + "&purchasingMonth=" + encodeURIComponent($scope.vm.purchasingMonth);

            rt.post(url, unitids).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }).finally(function () {
                waiting.close();
            });
        }

        //获取所有产品
        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            rt.get(url).then(function (resp) {
                if (resp.data.length > 0) {
                    $scope.vm.productList = resp.data;
                } else {
                    $scope.vm.productList = [];
                    return;
                }
            }).catch(function (error) {
                rt.showErrorToast(error);
            });
        }
        init();
    }

    angular.module('xrmApp').service('NewlyHosService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'Newlydevelopedhos';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("newlyhosListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'NewlyHosService', newlyhosListController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-5-5
 说明     :僵尸医院
 *********************************************************/
(function () {
    'use strict';

    function zombiehosListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var pids = "";
            var eYm = $scope.vm.eYm;
            var salecount = $scope.vm.salecount;
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                eYm = "";
                rt.errorMessage("请选择开始年月");
                return false;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.salecount)) {
                salecount = 20;
            }

            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join("','");
            }
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "eYm", Value: eYm });
            _that.searchList.push({ Type: 1, Key: "saleregion", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "salecount", Value: salecount });
            _that.searchList.push({ Type: 1, Key: "productIds", Value: pids });
            _that.searchList.push({ Type: 1, Key: "monthAgo", Value: $scope.vm.monthAgoSelected.value });
            _that.searchList.push({ Type: 1, Key: "entType", Value: $scope.vm.entType });
            _that.searchList.push({ Type: 1, Key: "exportType", Value: $scope.selectedTab });
            _that.searchList.push({ Type: 1, Key: "typeSelected", Value: $scope.typeSelect });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        var $stateParams = myService.$stateParams;
        $scope.vm.entType = $stateParams.entType ? $stateParams.entType : 2; //模块终端类型
        $scope.vm.moduleName = _getModuleName($scope.vm.entType); //模块名称
        function init() {
            $scope.vm.productList = [];
            $scope.vm.productSelected = null;
            $scope.vm.monthAgoList = [{ name: "前1个月", value: 1 }, { name: "前3个月", value: 3 }, { name: "前6个月", value: 6 }];
            $scope.vm.monthAgoSelected = $scope.vm.monthAgoList[1]; //默认为前三个月
            $scope.vm.data = [];
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            //类型筛选，默认不分指标类型
            $scope.typeSelect = 'noProduct';
            $scope.filterSelect = 'Product';
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.search = _search;
            $scope.vm.eYm = moment().add('months', -1).format('YYYY-MM');
            $scope.selectedTab = 'detail';
        }

        $scope.typeSelecttClick = function (selected) {
            $scope.typeSelect = selected;
        };

        //根据模块参数获取模块名称
        function _getModuleName(entType) {
            var str = '医院';
            entType = rt.isNullOrWhiteSpace(entType) ? 2 : parseInt(entType);
            switch (entType) {
                case 1:
                    str = '商业';break;
                case 2:
                    str = '医院';break;
                case 3:
                    str = '门店';break;
                case 4:
                    str = '基层医疗机构';break;
            }
            return str;
        }

        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 80);
            }, 0);
        }

        //搜索hos数据
        function _search() {
            var pids = "";
            var eYm = $scope.vm.eYm;
            var salecount = $scope.vm.salecount;
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                eYm = "";
                rt.errorMessage("请选择开始年月");
                return false;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.salecount)) {
                salecount = 20;
            }

            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join("','");
            }
            if ($scope.typeSelect === 'Product') {
                $scope.vm.showType = "showProduct";
            } else {
                $scope.vm.showType = "showNoProduct";
            }
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";

            var waiting = rt.showLoading2();
            var url = "";

            switch ($scope.selectedTab) {
                case 'detail':
                    url = "api/Zombiehos/GetZombiehosData";
                    break;
                case 'count':
                    url = "api/Zombiehos/GetZombiehosCount";
                    break;
            }

            url += "?eYm=" + eYm;
            url += "&saletodrugId=" + pids;
            url += "&salecount=" + salecount;
            url += "&productIds=" + encodeURIComponent(pids);
            url += "&monthAgo=" + $scope.vm.monthAgoSelected.value;
            url += "&typeSelected=" + $scope.typeSelect;
            url += "&pageIndex=" + $scope.vm.pageIndex;
            url += "&pageSize=" + $scope.vm.pageSize;
            url += "&entType=" + $scope.vm.entType;

            rt.post(url, unitids).then(function (resp) {

                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }

        //切换tab
        $scope.selectTab = function (type) {
            $scope.selectedTab = type;
            $scope.vm.pageIndex = 1;
            _search();
        };

        init();
    }
    angular.module('xrmApp').service('ZombieHosService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'Zombiehos';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("zombiehosListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'ZombieHosService', zombiehosListController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Jerry Wu
 创建时间 : 2018-3-5
 说明     :商业返利占比分析 
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('accountRebateAnalyzeService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'accountRebateAnalyze';

        //查询区域生动化分析数据
        this.GetaccountRebateAnalyze = function (sYm, eYm, unitids, accountids, toprovId, prodIds, pageSize, pageIndex) {
            return rt.post("api/accountRebateAnalyze/GetaccountRebateAnalyze?sYm=" + sYm + "&eYm=" + eYm + "&accountIds=" + encodeURIComponent(accountids) + '&toprovId=' + encodeURIComponent(toprovId) + '&prodIds=' + encodeURIComponent(prodIds) + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex, unitids);
        };
    }]).controller('accountRebateAnalyzeController', ['$scope', '$injector', 'rt', 'accountRebateAnalyzeService', accountRebateAnalyzeListController]);

    function accountRebateAnalyzeListController($scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            //检查导出条件
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            //区域(业务部门)Id
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";
            var accountids = "";
            if (!rt.isNull($scope.vm.accSelected)) {
                accountids = $scope.vm.accSelected.Id;
            }

            var toprovId = "";
            if (!rt.isNull($scope.vm.provinceSelected)) {
                toprovId = $scope.vm.provinceSelected.Id;
            }
            var prodIds = "";
            if (!rt.isNull($scope.vm.productSelected)) {
                var productsmap = _.map($scope.vm.productSelected, 'Id');
                prodIds = productsmap.join(",");
            }
            //添加搜索条件
            _that.searchList.length = 0;
            _that.searchList.push({
                Type: 1,
                Key: "sYm",
                Value: $scope.vm.sYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "eYm",
                Value: $scope.vm.eYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "unitids",
                Value: unitids
            });
            _that.searchList.push({
                Type: 1,
                Key: "toprovId",
                Value: toprovId
            });
            _that.searchList.push({
                Type: 1,
                Key: "prodIds",
                Value: prodIds
            });
            _that.searchList.push({
                Type: 1,
                Key: "accountids",
                Value: accountids
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageSize",
                Value: $scope.vm.pageSize
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageIndex",
                Value: $scope.vm.pageIndex
            });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();
        //初始化
        function init() {
            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.accList = []; //医院下拉
            $scope.vm.accSelected = null; //医院选择
            $scope.vm.recordCount = 0;
            $scope.vm.getReportData = _getData; //获取报表数据
            $scope.vm.productSelected = null;
        }

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }

            return "";
        }
        // //获取查询数据
        function _getData() {
            var msg = _checkOption();
            if (!rt.isNull(msg) && msg.length > 0) {
                rt.errorMessage(msg);
                return;
            }
            var accountids = "";
            if (!rt.isNull($scope.vm.accSelected)) {
                accountids = $scope.vm.accSelected.Id;
            }
            var prodIds = "";
            if (!rt.isNull($scope.vm.productSelected)) {
                var productsmap = _.map($scope.vm.productSelected, 'Id');
                prodIds = productsmap.join(",");
            }
            var toprovId = "";
            if (!rt.isNull($scope.vm.provinceSelected)) {
                toprovId = $scope.vm.provinceSelected.Id;
            }
            //获取区域Id
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();
            myService.GetaccountRebateAnalyze($scope.vm.sYm, $scope.vm.eYm, unitids, accountids, toprovId, prodIds, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            });
        }

        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
        }
    }
})();
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/4/14
 *说明：代理商销量排名
 *************************************************/
(function () {
    'use strict';

    function AgentBusiSaleRankController($scope, $q, rt) {
        function init() {
            $scope.vm = {};
            $scope.vm.reportData = [];
            $scope.vm.showReport = function () {
                _getReportData().then(_show, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllProduct();
            _getAllProvince();
            _getTops();
        }
        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }

        //获取省份
        function _getAllProvince() {
            var url = 'api/AlijkProvince/GetAllProvince';
            return rt.get(url).then(function (resp) {
                $scope.vm.provinceList = resp.data;
                $scope.vm.provinceSelected = null;
            });
        }
        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[1];
        }

        function _getReportData() {
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                var deferred = $q.defer();
                deferred.reject("开始年月不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                var deferred = $q.defer();
                deferred.reject("结束年月不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.productSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.provinceSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的省份不能为空。");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) < 0) {
                var deferred = $q.defer();
                deferred.reject("参数异常[开始日期必须小于等于结束日期.]");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) >= 365) {
                var deferred = $q.defer();
                deferred.reject("参数异常[日期区间最大为12个月.]");
                return deferred.promise;
            }
            var waiting = rt.showLoading2();
            var url = 'api/AgentBusiSaleRank/GetAgentBusiSaleRank?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&toprovCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE) + '&startYm=' + encodeURIComponent($scope.vm.startDate) + '&endYm=' + encodeURIComponent($scope.vm.endDate) + '&top=' + $scope.vm.topsSelected;

            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
        function _show() {

            var myChart = echarts.init(document.getElementById("report"), "shine");
            var echartYName = [];
            var echartsData = [];
            var getData = $scope.vm.reportData;
            for (var i = 0; i < getData.length; i++) {
                echartYName.push(getData[i].EntInfoName);
                echartsData.push(getData[i].SaleCount);
            }
            var option = {
                title: {
                    text: '代理商销量排名',
                    subtext: '',
                    x: 'left'
                },
                tooltip: {
                    trigger: 'axis'
                },
                legend: {
                    data: ['销量']
                },
                calculable: true,
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.1]
                }],
                yAxis: [{
                    type: 'category',
                    boundaryGap: [0, 0.1],
                    data: echartYName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '销量',
                    type: 'bar',
                    data: echartsData,
                    itemStyle: {
                        normal: {
                            barBorderRadius: 0,
                            label: {
                                show: true,
                                position: 'right'
                            }
                        }
                    }
                }]
            };
            myChart.setOption(option);
        }
        init();
    }
    angular.module('xrmApp').controller("AgentBusiSaleRankController", ['$scope', '$q', 'rt', AgentBusiSaleRankController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2017-02-10
 说明     : 招商经理拜访明细
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('AgentVisitDetailService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'RepresentativeVisitRank';
        // @@ 选项集
        this.picklists = [];
    }]).controller("AgentVisitDetailController", ['$scope', '$q', 'rt', '$injector', 'AgentVisitDetailService', AgentVisitDetailController]);
    function AgentVisitDetailController($scope, $q, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.startYM });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.endYM });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "visitTypeId", Value: $scope.vm.visitTypeSelected.id });
            var unitids = _CalculateUnitids();
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.startYM = moment(moment().format('YYYY-MM') + '-01').format('YYYY-MM-DD');
            $scope.vm.endYM = moment($scope.vm.endYM).format('YYYY-MM-DD');
            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };
            //查询
            $scope.vm.showReport = function () {
                var msg = _checkOption();
                if (!rt.isNullOrWhiteSpace(msg)) {
                    rt.errorMessage(msg);
                    return false;
                }
                var unitids = _CalculateUnitids();
                var bigUnitId = $scope.vm.bigDepSelected.id;
                var buId = $scope.vm.buidSelected.id;
                var visitTypeId = $scope.vm.visitTypeSelected.id;

                //获取终端热度总拜访数和均拜访数
                _getReportData(buId, bigUnitId, unitids, visitTypeId).then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllType();
            _getAllBuid();
        }

        //条件检查
        function _checkOption() {

            if (rt.isNullOrWhiteSpace($scope.vm.startYM)) {
                return "开始时间不能为空";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.endYM)) {
                return "结束时间不能为空";
            }

            if (_CalculateDays($scope.vm.startYM, $scope.vm.endYM) < 0) {
                return "参数异常[开始日期必须小于等于结束日期.]";
            }
        }

        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            if (startDate > endDate) {
                return -1;
            }
            return 0;
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];

            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }

            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {

            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;

                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            });
        }

        //获取拜访类型类型
        function _getAllType() {

            var data = [{ id: "willVisit", name: "意向代理商回访" }, { id: "nowVisit", name: "现有代理商拜访" }, { id: "assistVisit", name: "协助拜访医院" }];
            if (!rt.isNull(data) && data.length > 0) {
                $scope.vm.visitType = data;
                $scope.vm.visitType.unshift({ name: '全部类型', id: '' });
                $scope.vm.visitTypeSelected = $scope.vm.visitType[0];
            }
        }

        //获取终端热度总拜访数和均拜访数
        function _getReportData(buId, bigUnitId, unitids, visitTypeId) {
            var waiting = rt.showLoading2();
            var url = 'api/AgentVisitDetail/GetAgentVisitDetailList?sYm=' + encodeURIComponent($scope.vm.startYM) + '&eYm=' + encodeURIComponent($scope.vm.endYM) + '&buId=' + encodeURIComponent(buId) + '&bigDepId=' + encodeURIComponent(bigUnitId) + '&unitIds=' + encodeURIComponent(unitids) + '&visitTypeId=' + encodeURIComponent(visitTypeId) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;

                if ($scope.vm.reportData.length > 0) {
                    //防止取不到数据时，获取权限报错
                    //导出权限
                    var stprivilege = $scope.vm.reportData[0].visit_recordId;
                    return myService.getPrivilege(stprivilege).then(function (resp) {
                        $scope.vm.privilege = resp.data;
                    });
                }
            }).finally(function () {
                waiting.close();
            });
        }

        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            return unitids;
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lecrean Pan
 创建时间 : 2018-1-8
 说明     :区域生动化分析 
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('areaVividService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'AreaVivid';

        //查询区域生动化分析数据
        this.GetAreaVivid = function (sYm, eYm, unitids, accountLevel, pageSize, pageIndex) {
            return rt.post("api/AreaVivid/GetAreaVivid?sYm=" + sYm + "&eYm=" + eYm + "&accountLevel=" + accountLevel + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex, unitids);
        };
    }]).controller('areaVividListController', ['$scope', '$injector', 'rt', 'areaVividService', areaVividListController]);

    function areaVividListController($scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            //检查导出条件
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            //区域(业务部门)Id
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";
            var accountLevel_selectedValue = "";
            if (!rt.isNull($scope.vm.accountLevel_selected) && !rt.isNull($scope.vm.accountLevel_selected.Value)) {
                accountLevel_selectedValue = $scope.vm.accountLevel_selected.Value;
            }
            //添加搜索条件
            _that.searchList.length = 0;
            _that.searchList.push({
                Type: 1,
                Key: "sYm",
                Value: $scope.vm.sYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "eYm",
                Value: $scope.vm.eYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "unitids",
                Value: unitids
            });
            _that.searchList.push({
                Type: 1,
                Key: "accountLevel_selectedValue",
                Value: accountLevel_selectedValue
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageSize",
                Value: $scope.vm.pageSize
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageIndex",
                Value: $scope.vm.pageIndex
            });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();
        //初始化
        function init() {
            //时间筛选，默认全年，时间段范围为月份
            $scope.dateSelect = 'fullYear';
            $scope.vm.sYm = moment().format('YYYY-01');
            $scope.vm.eYm = moment().format('YYYY-12');
            //门店级别默认为空
            $scope.vm.accountLevel = [];
            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.changeDate = _changeDate; //改变日期
            $scope.vm.getReportData = _getData; //获取报表数据

            //获取门店级别
            _getAccountLevel();
        }

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            return "";
        }
        //选择时间筛选
        function _changeDate(dateType) {
            $scope.dateSelect = dateType;

            switch (dateType) {
                case "fullYear":
                    $scope.vm.sYm = moment().format('YYYY-01');
                    $scope.vm.eYm = moment().format('YYYY-12');
                    break;
                case "thisMonth":
                    $scope.vm.sYm = moment().format('YYYY-MM');
                    $scope.vm.eYm = moment().format('YYYY-MM');
                    break;
                case "lastMonth":
                    $scope.vm.sYm = moment().add(-1, 'months').format('YYYY-MM');
                    $scope.vm.eYm = moment().add(-1, 'months').format('YYYY-MM');
                    break;
                case "thisQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-10');
                            $scope.vm.eYm = moment().format('YYYY-12');
                            break;
                    }
                    break;
                case "lastQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().add(-1, 'years').format('YYYY-10');
                            $scope.vm.eYm = moment().add(-1, 'years').format('YYYY-12');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                    }
                    break;
            }
        }
        //获取门店级别(客户分级)
        function _getAccountLevel() {
            var url = "api/businessaccount/GetPickListData?fieldCodes=account_grade_level";
            rt.get(url).then(function (resp) {
                if (!rt.isNull(resp.data) && !rt.isNull(resp.data.account_grade_level)) {
                    $scope.vm.accountLevel = resp.data.account_grade_level;
                    $scope.vm.accountLevel_selected = "";
                }
            });
        }
        // //获取查询数据
        function _getData() {
            //选项检查及提示错误信息
            var msg = _checkOption();
            if (!rt.isNull(msg) && msg.length > 0) {
                rt.errorMessage(msg);
                return;
            }
            //获取区域Id
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            //初始化门店级别  
            var accountLevel_selectedValue = "";
            if (!rt.isNull($scope.vm.accountLevel_selected) && !rt.isNull($scope.vm.accountLevel_selected.Value)) {
                accountLevel_selectedValue = $scope.vm.accountLevel_selected.Value;
            }
            var waiting = rt.showLoading2();
            //获取区域生动化数据
            myService.GetAreaVivid($scope.vm.sYm, $scope.vm.eYm, unitids, accountLevel_selectedValue, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            });
        }
        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
        }
    }
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2017/12/7
 说明     : 按部门流向统计
 *********************************************************/
(function () {
    'use strict';

    function busidrugflowreportController($scope, $q, $compile, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "businessUnitIds", Value: unitids });
            if ($scope.typeSelect === 'customCategoryByAmount' || $scope.typeSelect === 'customCategoryByQty' || $scope.typeSelect === 'tsSrTargetDoneByQty') _that.searchList.push({ Type: 1, Key: "diyCategoryId", Value: $scope.vm.cuSelected.Id });
            if ($scope.typeSelect === 'tsSrTargetDoneByAmount') //不分代表纯销指标类型||按代表纯销指标类型（金额）
                _that.searchList.push({ Type: 1, Key: "customCategoryId", Value: $scope.vm.cuSelected.Id });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        function init() {
            //时间筛选，默认全年
            $scope.dateSelect = 'thisMonth';
            $scope.vm.sYm = moment().format('YYYY-MM');
            $scope.vm.eYm = moment().format('YYYY-MM');

            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            _getAllProduct();
        }
        //获取产品
        function _getAllProduct() {
            var url = 'api/ProductCategory/GetSmallestDataList';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }

        $scope.typeSelecttClick = function (selected) {
            $scope.typeSelect = selected;
        };

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            return "";
        }

        function _getHeader(date) {

            myService.GetHandelProduct(date).then(function (resp) {
                $scope.vm.productlist.push(resp.data.length);
                for (var j = 0; j < resp.data.length; j++) {
                    var ss = resp.data[j].productidname;
                    $scope.vm.aa = resp.data.length;
                    $scope.vm.TbMessText.push(ss);
                    //$scope.vm.ll = resp.data.length;                                                                           
                }
            });
        }

        //计算报表应有宽度
        function _complateTableweight() {
            $scope.tableMaxWeight = $(window).width() + "px";
        }

        //选择时间筛选
        $scope.vm.changeDate = function (dateType) {
            $scope.dateSelect = dateType;

            switch (dateType) {
                case "fullYear":
                    $scope.vm.sYm = moment().format('YYYY-01');
                    $scope.vm.eYm = moment().format('YYYY-MM');
                    break;
                case "thisMonth":
                    $scope.vm.sYm = moment().format('YYYY-MM');
                    $scope.vm.eYm = moment().format('YYYY-MM');
                    break;
                case "lastMonth":
                    $scope.vm.sYm = moment().add(-1, 'months').format('YYYY-MM');
                    $scope.vm.eYm = moment().add(-1, 'months').format('YYYY-MM');
                    break;
                case "thisQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-10');
                            $scope.vm.eYm = moment().format('YYYY-12');
                            break;
                    }
                    break;
                case "lastQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().add(-1, 'years').format('YYYY-10');
                            $scope.vm.eYm = moment().add(-1, 'years').format('YYYY-12');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                    }
                    break;
            }
        };

        function _getreport(data) {
            var utils = $.pivotUtilities;
            var Integersum = utils.aggregators["Integer Sum"];
            var sortAs = utils.sortAs;
            $("#rt-report").pivot(data, {
                rows: ["BusinessUnitIdName", "OwnerIdName"],
                cols: ["month", "productidname"],
                sorters: { BusinessUnitIdName: function BusinessUnitIdName(a, b) {
                        return a.localeCompare(b, 'zh-Hans-CN', { sensitivity: 'accent' });
                    } }, //排序
                aggregator: Integersum(["qty"])
            });

            $('th.pvtAxisLabel').map(function (i) {
                if ($('th.pvtAxisLabel')[i].innerText == "BusinessUnitIdName") $('th.pvtAxisLabel')[i].innerText = "部门";
                if ($('th.pvtAxisLabel')[i].innerText == "OwnerIdName") $('th.pvtAxisLabel')[i].innerText = "经理";
                if ($('th.pvtAxisLabel')[i].innerText == "month") $('th.pvtAxisLabel')[i].innerText = "月份";
                if ($('th.pvtAxisLabel')[i].innerText == "productidname") $('th.pvtAxisLabel')[i].innerText = "品种";
            });

            $('th.pvtTotalLabel').map(function (i) {
                $('th.pvtTotalLabel')[i].innerText = "合计";
            });
        }

        //查询报表数据
        $scope.vm.getReportData = function () {
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var pids = "";
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join(",");
            }
            var waiting = rt.showLoading2();

            $scope.isQtyShow = false;
            //达成列表
            myService.GetBusiDrugflowReport($scope.vm.sYm, $scope.vm.eYm, pids, unitids).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _getreport($scope.vm.reportData.DataList);
                _complateTableweight();
                waiting.close();
            });
        };
        init();
    }
    angular.module('xrmApp').service('busidrugflowreportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusiDrugflowReport';

        //不分代表纯销指标类型-达成列表
        this.GetBusiDrugflowReport = function (sYm, eYm, productIds, unitids) {
            return rt.post("api/BusiDrugflowReport/GetBusiDrugflowReport?sYm=" + sYm + "&eYm=" + eYm + "&productIds=" + productIds, unitids);
        };

        this.GetHandelProduct = function (Ym) {
            return rt.get("api/BusiDrugflowReport/GetHandelProduct?Ym=" + Ym);
        };
    }]);
    angular.module('xrmApp').controller("busidrugflowreportController", ['$scope', '$q', '$compile', 'rt', '$injector', 'busidrugflowreportService', busidrugflowreportController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-04-07
 说明     : 按事业部发货统计
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('BusinessDeliveryService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessDelivery';
        // @@ 选项集
        this.picklists = [];
    }]).controller("businessdeliveryController", ['$scope', 'rt', '$injector', '$timeout', 'BusinessDeliveryService', activityController]);
    function activityController($scope, rt, $injector, $timeout, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.reportDataSum = []; //合计数据
            $scope.vm.reportData.bulist = [];
            $scope.vm.reportDataSum.bulistsun = [];
            $scope.vm.busum = 0; //事业部个数
            $scope.vm.sumqty = 0; //数量总和
            $scope.vm.sumamount = 0; //金额总和
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.yM = moment().format('YYYY-MM');
            $scope.vm.buDataList = []; //事业部数据
            $scope.complateTableheight = _complateTableheight;

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };

            _initYmSelected();
            _getBuList();

            _complateTableheight();
        }

        //获取所有事业部,设置数量和金额列
        function _getBuList() {
            rt.get("api/BusinessDelivery/GetAllBuid").success(function (data) {
                $scope.vm.buDataList = data;
                $scope.vm.buDataList.forEach(function (e) {
                    e.BuIdName = e.BuIdName.replace("-", "");
                }, this);

                $scope.vm.busum = $scope.vm.buDataList.length * 2;
                $scope.vm.TbMessText = [];
                var MCount = $scope.vm.buDataList.length;
                var DeMessText = ["数量", "金额（元）"];

                if (MCount > 0) {
                    for (var i = 0; i < MCount; i++) {
                        $scope.vm.TbMessText.push("数量", "金额（元）");
                    }
                } else {
                    $scope.vm.TbMessText = DeMessText;
                }
            }).error(function (error) {
                rt.errorMessage(error);
            });
        }

        //获取合计数据
        function _getSumData() {
            var url2 = "api/BusinessDelivery/GetSumData";
            url2 += "?sYm=" + encodeURIComponent($scope.vm.sYm);
            url2 += "&eYm=" + encodeURIComponent($scope.vm.eYm);

            rt.get(url2).success(function (data) {
                $scope.vm.reportDataSum = data;
                var bulistsum = [];
                var syb2 = _.map($scope.vm.buDataList, 'BuIdName'); //事业部名称
                var Done_Qtysum = "Done_Qtysum";
                var Done_Amountsum = "Done_Amountsum";
                for (var i = 0; i < $scope.vm.reportDataSum.length; i++) {
                    for (var j = 0; j < syb2.length; j++) {
                        Done_Qtysum = syb2[j] + Done_Qtysum;
                        Done_Amountsum = syb2[j] + Done_Amountsum;
                        bulistsum.push(_.map($scope.vm.reportDataSum, Done_Qtysum)[i]);
                        bulistsum.push(_.map($scope.vm.reportDataSum, Done_Amountsum)[i]);
                        $scope.vm.reportDataSum.bulistsum = bulistsum;
                        Done_Qtysum = "Done_Qtysum";
                        Done_Amountsum = "Done_Amountsum";
                    }
                }
            }).error(function (error) {
                rt.errorMessage(error);
            });
        }

        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        //设置时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sYm = d.getFullYear() + "-" + '01';
            $scope.vm.eYm = moment().format('YYYY-MM');
        }

        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始年月";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束年月";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始年月不能大于结束年月";
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据";
            }
            return "";
        }

        //获取按事业部发货统计
        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            $scope.vm.sumqty = 0;
            $scope.vm.sumamount = 0;
            var waiting = rt.showLoading2();
            var url = "api/BusinessDelivery/GetBusinessDeliveryData";
            url += "?sYm=" + encodeURIComponent($scope.vm.sYm);
            url += "&eYm=" + encodeURIComponent($scope.vm.eYm);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                var bulist = [];
                var syb = _.map($scope.vm.buDataList, 'BuIdName'); //事业部名称
                var Done_Qty = "Done_Qty";
                var Done_Amount = "Done_Amount";
                for (var i = 0; i < $scope.vm.reportData.length; i++) {
                    $scope.vm.sumqty += _.map($scope.vm.reportData, 'Done_Qty')[i];
                    $scope.vm.sumamount += parseFloat(_.map($scope.vm.reportData, 'Done_Amount')[i].toFixed(2));
                    for (var j = 0; j < syb.length; j++) {
                        Done_Qty = syb[j] + Done_Qty;
                        Done_Amount = syb[j] + Done_Amount;
                        bulist.push(_.map($scope.vm.reportData, Done_Qty)[i]);
                        bulist.push(_.map($scope.vm.reportData, Done_Amount)[i]);
                        $scope.vm.reportData.bulist = bulist;
                        Done_Qty = "Done_Qty";
                        Done_Amount = "Done_Amount";
                    }
                }

                _getSumData();

                _complateTableheight();
                waiting.close();
            }).finally(function () {
                waiting.close();
            });
        }

        //获取对应的数量和金额
        $scope.vm.getCountMoney = function (v) {
            v = v * $scope.vm.busum;
            return _.slice($scope.vm.reportData.bulist, v, v + $scope.vm.busum);
        };
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Eric Zheng 
 创建时间 : 2018-3-2
 说明     : 部门费效比分析 
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('businessUnitCostEffectivenessService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'BusinessUnitCostEffectiveness';

        // @@ 选项集
        this.picklists = [];

        //查询部门费效比分析数据
        this.GetBusinessUnitCostEffectiveness = function (sYm, eYm, unitids, pageSize, pageIndex) {
            return rt.post("api/BusinessUnitCostEffectiveness/GetBusinessUnitCostEffectiveness?sYm=" + sYm + "&eYm=" + eYm + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex, unitids);
        };
    }]).controller('businessUnitCostEffectivenessController', ['$scope', '$injector', 'rt', 'businessUnitCostEffectivenessService', businessUnitCostEffectivenessListController]);

    function businessUnitCostEffectivenessListController($scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            //检查导出条件
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            //区域(业务部门)Id
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";
            //添加搜索条件
            _that.searchList.length = 0;
            _that.searchList.push({
                Type: 1,
                Key: "sYm",
                Value: $scope.vm.sYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "eYm",
                Value: $scope.vm.eYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "unitids",
                Value: unitids
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageSize",
                Value: $scope.vm.pageSize
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageIndex",
                Value: $scope.vm.pageIndex
            });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();
        //初始化
        function init() {
            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.getReportData = _getData; //获取报表数据
        }

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始时间不能大于结束时间.";
            }
            return "";
        }
        // //获取查询数据
        function _getData() {
            var msg = _checkOption();
            if (!rt.isNull(msg) && msg.length > 0) {
                rt.errorMessage(msg);
                return;
            }
            //获取区域Id
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();
            myService.GetBusinessUnitCostEffectiveness($scope.vm.sYm, $scope.vm.eYm, unitids, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            });
        }
        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
        }
    }
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Berry Ding
//* 创建时间 :2016-1-22
//* 说明     :基础-流向查询（按商业）
//******************************************************************
// #endregion

(function () {
    'use strict';

    angular.module('xrmApp').controller("busisaledetailbyentController", ['$scope', '$q', 'rt', busisaledetailbyentController]);
    function busisaledetailbyentController($scope, $q, rt) {
        init();

        function init() {
            $scope.vm = {};
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;

            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            $scope.vm.showReport = function () {
                _getReportData().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };

            _getAllProduct();
        }

        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }
        //计算间隔天数
        function DateDiff(sDate1, sDate2) {
            //sDate1和sDate2是2006-12-18格式
            var sArr = sDate1.split("-");
            var eArr = sDate2.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        //function _CalculateDays() {
        //    var sDate=$scope.vm.startYM;
        //    var eDate=$scope.vm.endYM;
        //    var sArr = sDate.split("-");
        //    var eArr = eDate.split("-");
        //    var m1 = parseInt(sArr[1].replace(/^0+/, "")) + parseInt(sArr[0]) * 12;
        //    var m2 = parseInt(eArr[1].replace(/^0+/, "")) + parseInt(eArr[0]) * 12;
        //    return m2-m1+1;
        //    //var sRDate = new Date(sArr[0], sArr[1], sArr[2]);
        //    //var eRDate = new Date(eArr[0], eArr[1], eArr[2]);
        //    //var result = (eRDate-sRDate)/(24*60*60*1000);
        //    //return result;
        //}

        function _getReportData() {
            if (rt.isNull($scope.vm.productSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.startYM)) {
                var deferred = $q.defer();
                deferred.reject("开始时间不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endYM)) {
                var deferred = $q.defer();
                deferred.reject("结束时间不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.fromEntInfoName) && rt.isNull($scope.vm.toEntInfoName)) {
                var deferred = $q.defer();
                deferred.reject("查询的发货企业或收货企业不能为空。");
                return deferred.promise;
            }
            if (DateDiff($scope.vm.startYM, $scope.vm.endYM) < 0) {
                var deferred = $q.defer();
                deferred.reject("参数异常[开始日期必须小于等于结束日期]");
                return deferred.promise;
            }
            if (DateDiff($scope.vm.startYM, $scope.vm.endYM) >= 365) {
                var deferred = $q.defer();
                deferred.reject("参数异常[日期区间最大为12个月]");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.fromEntInfoName)) {
                $scope.vm.fromEntInfoName = {};
                $scope.vm.fromEntInfoName.Name = "";
            }
            if (rt.isNull($scope.vm.toEntInfoName)) {
                $scope.vm.toEntInfoName = {};
                $scope.vm.toEntInfoName.Name = "";
            }

            var waiting = rt.showLoading2();
            var url = 'api/AlijkGetBusiInSalesOfOutDrugs/GetBusiInSalesOfDrugs?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&startDate=' + encodeURIComponent($scope.vm.startYM) + '&endDate=' + encodeURIComponent($scope.vm.endYM) + '&toEntInfoName=' + encodeURIComponent($scope.vm.toEntInfoName.Name) + '&fromEntInfoName=' + encodeURIComponent($scope.vm.fromEntInfoName.Name) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.GetBusiInSalesOfDrugsList;
                $scope.vm.recordCount = resp.data.TotalRecordCount;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
    }
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Berry Ding
//* 创建时间 :2016-1-22
//* 说明     :基础-流向查询（按终端）
//******************************************************************
// #endregion

(function () {
    'use strict';

    angular.module('xrmApp').controller("busisaledetailbyterminalController", ['$scope', '$q', 'rt', busisaledetailbyterminalController]);
    function busisaledetailbyterminalController($scope, $q, rt) {
        init();

        function init() {
            $scope.vm = {};
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;

            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            $scope.vm.showReport = function () {
                _getReportData().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };

            _getAllProduct();
            $scope.getEntInfoName = _getEntInfoName;
        }

        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }

        function _getEntInfoName(entInfoName) {
            var url = 'api/AlijkGetEntSaleByNameFromDtaily/GetEntTermiNameByWord?entInfoName=' + encodeURIComponent($scope.vm.toEntInfoName);
            return rt.get(url).then(function (resp) {
                $scope.vm.toEntInfoNameNoList = resp.data;
                $scope.vm.toEntInfoNameSelected = null;
            });
        }
        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        function _getReportData() {
            if (rt.isNullOrWhiteSpace($scope.vm.startYM)) {
                var deferred = $q.defer();
                deferred.reject("开始时间不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endYM)) {
                var deferred = $q.defer();
                deferred.reject("结束时间不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.toEntInfoName) || rt.isNullOrWhiteSpace($scope.vm.toEntInfoName.Name)) {
                var deferred = $q.defer();
                deferred.reject("查询的终端名称不能为空。");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startYM, $scope.vm.endYM) < 0) {
                var deferred = $q.defer();
                deferred.reject("参数异常[开始日期必须小于等于结束日期.]");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startYM, $scope.vm.endYM) >= 365) {
                var deferred = $q.defer();
                deferred.reject("参数异常[日期区间最大为12个月.]");
                return deferred.promise;
            }

            var waiting = rt.showLoading2();
            if (rt.isNull($scope.vm.productSelected)) {
                var url = 'api/AlijkGetEntSaleByNameFromDtaily/GetEntSaleByNameFromDtailyList?prodId=' + '' + '&startYm=' + encodeURIComponent($scope.vm.startYM) + '&endYm=' + encodeURIComponent($scope.vm.endYM) + '&toEntInfoName=' + encodeURIComponent($scope.vm.toEntInfoName.Name) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            } else {
                var url = 'api/AlijkGetEntSaleByNameFromDtaily/GetEntSaleByNameFromDtailyList?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&startYm=' + encodeURIComponent($scope.vm.startYM) + '&endYm=' + encodeURIComponent($scope.vm.endYM) + '&toEntInfoName=' + encodeURIComponent($scope.vm.toEntInfoName.Name) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            }
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.GetEntSaleByNameFromDtailyList;
                $scope.vm.recordCount = resp.data.TotalRecordCount;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
    }
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
//* 创建人   :oscargao
//* 创建时间 :2016-01-18
//* 说明     :商业流失分析
//******************************************************************
// #endregion

(function () {
	'use strict';

	function BusiSaleLostController($scope, $q, rt) {
		function init() {
			$scope.vm = {};
			$scope.vm.reportData = [];
			$scope.vm.showReport = function () {
				_getReportData().then(_show, function (message) {
					rt.errorMessage(message);
				});
			};
			_getAllProduct();
			_getAllProvince();
			_getLastBusiTime();
		}
		function _getAllProduct() {
			var url = 'api/AlijkProduct/GetAllProduct';
			return rt.get(url).then(function (resp) {
				$scope.vm.productList = resp.data;
				$scope.vm.productSelected = null;
			});
		}

		function _getAllProvince() {
			var url = 'api/AlijkProvince/GetAllProvince';
			return rt.get(url).then(function (resp) {
				$scope.vm.provinceList = resp.data;
				$scope.vm.provinceSelected = null;
			});
		}

		function _getLastBusiTime() {
			$scope.vm.lastBusiTimeList = [{ Name: '最近3个月', Value: '1' }, { Name: '最近6个月', Value: '2' }, { Name: '最近一年', Value: '3' }];
			$scope.vm.lastBusiTimeSelected = $scope.vm.lastBusiTimeList[1];
		}
		function _getReportData() {
			if (rt.isNull($scope.vm.productSelected)) {
				var deferred = $q.defer();
				deferred.reject("查询的药品名称不能为空。");
				return deferred.promise;
			}
			if (rt.isNull($scope.vm.provinceSelected)) {
				var deferred = $q.defer();
				deferred.reject("查询的省份不能为空。");
				return deferred.promise;
			}
			if (rt.isNull($scope.vm.lastBusiTimeSelected)) {
				var deferred = $q.defer();
				deferred.reject("最近时间段不能为空。");
				return deferred.promise;
			}
			var waiting = rt.showLoading2();
			var url = 'api/AlijkBusiSaleLost/GetBusiLostCountByProv?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&toprovCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE) + '&lastTimeType=' + $scope.vm.lastBusiTimeSelected.Value;
			return rt.get(url).then(function (resp) {
				$scope.vm.reportData = resp.data;
				waiting.close();
			}, function () {
				waiting.close();
			});
		}
		function _show() {

			var myChart = echarts.init(document.getElementById("report"), "shine");
			var echartTitle = [];
			var echartsData = [];
			var getData = $scope.vm.reportData.PieMod;
			for (var i = 0; i < getData.length; i++) {
				echartsData.push({
					value: getData[i].LostCount,
					name: getData[i].CityName
				});
				echartTitle.push(getData[i].CityName);
			}
			var option = {
				title: {
					text: '',
					subtext: '',
					x: 'center'
				},
				tooltip: {
					trigger: 'item',
					formatter: "{a} <br/>{b} : {c} ({d}%)"
				},
				calculable: true,
				series: [{
					name: '流失分析',
					type: 'pie',
					radius: '55%',
					center: ['50%', '60%'],
					data: echartsData,
					itemStyle: {
						normal: {
							label: {
								show: true,
								//position: 'top',
								formatter: "{b} : {c} ({d}%)"
							},
							labelLine: { show: true }
						}
					}
				}]
			};

			myChart.setOption(option);
		}

		init();
	}

	angular.module('xrmApp').controller("BusiSaleLostController", ['$scope', '$q', 'rt', BusiSaleLostController]);
})();
"use strict";

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
//* 创建人   :oscargao
//* 创建时间 :2016-01-20
//* 说明     :商业按省销量排名
//******************************************************************
// #endregion

(function () {
	'use strict';

	function BusiSaleRankController($scope, $q, $compile, $timeout, rt, $injector, myService) {
		var _that = this;
		_that.searchList = [];
		this.preExport = function () {
			var pids = "";
			var msg = _checkOption();
			if (!rt.isNullOrWhiteSpace(msg)) {
				return msg;
			}
			var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
			if (!rt.isNull($scope.vm.productSelected) && $scope.vm.productSelected.length > 0) {
				var pmap = $scope.vm.productSelected.map(function (item) {
					return item.Id;
				});
				pids = pmap.join(",");
			}

			_that.searchList.length = 0;
			_that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
			_that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
			_that.searchList.push({ Type: 1, Key: "accountType", Value: $scope.filterSelect });
			_that.searchList.push({ Type: 1, Key: "businessUnitIds", Value: unitids });
			_that.searchList.push({ Type: 1, Key: "categoryids", Value: pids });
		};
		$injector.invoke(reportListController, this, {
			$scope: $scope,
			myService: myService
		});
		function init() {
			//时间筛选，默认全年
			$scope.dateSelect = 'fullYear';
			$scope.vm.sYm = moment().format('YYYY-01');
			$scope.vm.eYm = moment().format('YYYY-12');
			//机构筛选，默认按部门
			$scope.filterSelect = 'byAll';

			$scope.vm.reportData = [];
			$scope.vm.echartData1 = [];
			$scope.vm.echartData2 = [];
			$scope.vm.productSelected = []; //药品选择
			$scope.vm.pageIndex = 1;
			$scope.vm.recordCount = 0;
			$scope.vm.pageSize = rt.getPaginationSize();
			_getAllProduct();
		}

		//获取产品
		function _getAllProduct() {
			var url = 'api/ProductCategory/GetSmallestDataList';
			return rt.get(url).then(function (resp) {
				$scope.vm.productList = resp.data;
				$scope.vm.productSelected = null;
			});
		}

		//查询、导出前检查条件
		function _checkOption() {
			if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
				return "请选择时间筛选中的开始时间.";
			}
			if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
				return "请选择时间筛选中的结束时间.";
			}
			if ($scope.vm.sYm > $scope.vm.eYm) {
				return "时间筛选中的开始时间不能大于结束时间.";
			}
			if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
				return "只可查询同一年的数据.";
			}
			return "";
		}

		//选择时间筛选
		$scope.vm.changeDate = function (dateType) {
			$scope.dateSelect = dateType;
			switch (dateType) {
				case "fullYear":
					$scope.vm.sYm = moment().format('YYYY-01');
					$scope.vm.eYm = moment().format('YYYY-12');
					break;
				case "thisMonth":
					$scope.vm.sYm = moment().format('YYYY-MM');
					$scope.vm.eYm = moment().format('YYYY-MM');
					break;
				case "lastMonth":
					$scope.vm.sYm = moment().add(-1, 'months').format('YYYY-MM');
					$scope.vm.eYm = moment().add(-1, 'months').format('YYYY-MM');
					break;
				case "thisQuarter":
					switch (moment().quarter()) {
						case 1:
							$scope.vm.sYm = moment().format('YYYY-01');
							$scope.vm.eYm = moment().format('YYYY-03');
							break;
						case 2:
							$scope.vm.sYm = moment().format('YYYY-04');
							$scope.vm.eYm = moment().format('YYYY-06');
							break;
						case 3:
							$scope.vm.sYm = moment().format('YYYY-07');
							$scope.vm.eYm = moment().format('YYYY-09');
							break;
						case 4:
							$scope.vm.sYm = moment().format('YYYY-10');
							$scope.vm.eYm = moment().format('YYYY-12');
							break;
					}
					break;
				case "lastQuarter":
					switch (moment().quarter()) {
						case 1:
							$scope.vm.sYm = moment().add(-1, 'years').format('YYYY-10');
							$scope.vm.eYm = moment().add(-1, 'years').format('YYYY-12');
							break;
						case 2:
							$scope.vm.sYm = moment().format('YYYY-01');
							$scope.vm.eYm = moment().format('YYYY-03');
							break;
						case 3:
							$scope.vm.sYm = moment().format('YYYY-04');
							$scope.vm.eYm = moment().format('YYYY-06');
							break;
						case 4:
							$scope.vm.sYm = moment().format('YYYY-07');
							$scope.vm.eYm = moment().format('YYYY-09');
							break;
					}
					break;
			}
		};

		function _MonDataList(startDate, endDate) {
			$scope.vm.MonDataList = [];
			$scope.vm.TbMessText = [];
			$scope.vm.MonDataName = [];
			var sArr = startDate.split("-");
			var eArr = endDate.split("-");
			var NMon = 0;
			var MCount = eArr[1] - sArr[1];
			var DeMessText = ["数量", "金额（万元）"];
			if (MCount > 0) {
				for (var i = 0; i < MCount; i++) {
					NMon = parseInt(sArr[1]) + i;
					$scope.vm.MonDataList[i] = NMon;
					$scope.vm.TbMessText.push("数量", "金额（万元）");
				}
				$scope.vm.MonDataList[MCount] = parseInt(sArr[1]) + MCount;
				$scope.vm.TbMessText.push("数量", "金额（万元）");
			} else {
				$scope.vm.MonDataList[0] = parseInt(sArr[1]);
				$scope.vm.TbMessText = DeMessText;
			}
		}

		$scope.complateTableheight = function () {
			_complateTableheight();
		};
		//（暂时）计算报表应有高度
		function _complateTableheight() {
			$timeout(function () {
				$scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
			}, 0);
		}

		$scope.vm.getChartData = function () {
			var msg = _checkOption();
			if (!rt.isNullOrWhiteSpace(msg)) {
				rt.errorMessage(msg);
				return false;
			}
			var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
			var pids = "";
			if (!rt.isNull($scope.vm.productSelected) && $scope.vm.productSelected.length > 0) {
				var pmap = $scope.vm.productSelected.map(function (item) {
					return item.Id;
				});
				pids = pmap.join(",");
			}
			var waiting = rt.showLoading2();
			//按金额排名
			var TabDataUrl = 'api/AlijkBusiSalesRank/GetSaleRankChartData?sYm=' + $scope.vm.sYm + '&eYm=' + $scope.vm.eYm + '&accountType=' + $scope.filterSelect + '&categoryids=' + pids + '&orderBy=total_amount';
			rt.post(TabDataUrl, unitids).then(function (resp) {
				$scope.vm.echartData1 = resp.data;
				waiting.close();
				_showChart1();
			});

			//按数量排名
			TabDataUrl = 'api/AlijkBusiSalesRank/GetSaleRankChartData?sYm=' + $scope.vm.sYm + '&eYm=' + $scope.vm.eYm + '&accountType=' + $scope.filterSelect + '&categoryids=' + pids + '&orderBy=total_qty';
			rt.post(TabDataUrl, unitids).then(function (resp) {
				$scope.vm.echartData2 = resp.data;
				waiting.close();
				_showChart2();
			});
		};

		$scope.vm.getReportData = function () {
			var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
			var pids = "";
			if (!rt.isNull($scope.vm.productSelected) && $scope.vm.productSelected.length > 0) {
				var pmap = $scope.vm.productSelected.map(function (item) {
					return item.Id;
				});
				pids = pmap.join(",");
			}
			_MonDataList($scope.vm.sYm, $scope.vm.eYm);
			var waiting = rt.showLoading2();
			var url = 'api/AlijkBusiSalesRank/GetSaleRankTable?sYm=' + $scope.vm.sYm + '&eYm=' + $scope.vm.eYm + '&accountType=' + $scope.filterSelect + '&categoryids=' + pids + '&pageIndex=' + $scope.vm.pageIndex + '&pageSize=' + $scope.vm.pageSize;
			return rt.post(url, unitids).then(function (resp) {
				$scope.vm.reportData = resp.data.DataList;
				$scope.vm.recordCount = resp.data.TotalRecords;
				waiting.close();
				_complateTableheight();
			}, function () {
				waiting.close();
			});
		};

		function _showChart1() {
			var myChart = echarts.init(document.getElementById("report1"), "shine");
			var echartsDataValue = [];
			var echartsDataName = [];

			var getData = $scope.vm.echartData1.DataList;
			if (getData != null && getData.length > 0) {
				for (var i = getData.length - 1; i >= 0; i--) {
					getData[i].businessunitidname = getData[i].businessunitidname == null ? "" : getData[i].businessunitidname;
					getData[i].owneridname = getData[i].owneridname == null ? "" : getData[i].owneridname;
					echartsDataName.push(getData[i].businessunitidname + "--" + getData[i].owneridname);
					echartsDataValue.push(getData[i].total_amount == null ? 0 : rt.xrmRound(getData[i].total_amount, 2));
				}
			}
			var option = {
				tooltip: {
					trigger: 'axis',
					formatter: '{b}<br/>{a}:{c}'
				},
				xAxis: [{
					type: 'value',
					boundaryGap: [0, 0.01],
					axisLabel: {
						formatter: '{value} 万元'
					}
				}],
				yAxis: [{
					type: 'category',
					data: echartsDataName,
					axisLabel: {
						interval: 0,
						formatter: function formatter(params) {
							var newParamsName = "";
							var paramsNameNumber = params.length;
							var provideNumber = 15;
							var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
							if (paramsNameNumber > provideNumber) {
								for (var p = 0; p < rowNumber; p++) {
									var tempStr = "";
									var start = p * provideNumber;
									var end = start + provideNumber;
									if (p == rowNumber - 1) {
										tempStr = params.substring(start, paramsNameNumber);
									} else {
										tempStr = params.substring(start, end) + "\n";
									}
									newParamsName += tempStr;
								}
							} else {
								newParamsName = params;
							}
							return newParamsName;
						}
					}
				}],
				grid: { // 控制图的大小，调整下面这些值就可以，
					x: 150
					// y2:300,
					// y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
				},
				series: [{
					name: '金额',
					type: 'bar',
					data: echartsDataValue,
					itemStyle: {
						normal: {
							label: {
								show: true,
								position: 'right',
								formatter: "{c}万元"
							},
							labelLine: { show: true }

						}
					}
				}]
			};
			myChart.setOption(option);
		}

		function _showChart2() {
			var myChart = echarts.init(document.getElementById("report2"), "shine");
			var echartsDataValue = [];
			var echartsDataName = [];

			var getData = $scope.vm.echartData2.DataList;
			if (getData != null && getData.length > 0) {
				for (var i = getData.length - 1; i >= 0; i--) {
					getData[i].businessunitidname = getData[i].businessunitidname == null ? "" : getData[i].businessunitidname;
					getData[i].owneridname = getData[i].owneridname == null ? "" : getData[i].owneridname;
					echartsDataName.push(getData[i].businessunitidname + "--" + getData[i].owneridname);
					echartsDataValue.push(getData[i].total_qty);
				}
			}
			var option = {
				tooltip: {
					trigger: 'axis',
					formatter: '{b}<br/>{a}:{c}'
				},
				xAxis: [{
					type: 'value',
					boundaryGap: [0, 0.01],
					axisLabel: {
						formatter: '{value}'
					}
				}],
				yAxis: [{
					type: 'category',
					data: echartsDataName,
					axisLabel: {
						interval: 0,
						formatter: function formatter(params) {
							var newParamsName = "";
							var paramsNameNumber = params.length;
							var provideNumber = 15;
							var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
							if (paramsNameNumber > provideNumber) {
								for (var p = 0; p < rowNumber; p++) {
									var tempStr = "";
									var start = p * provideNumber;
									var end = start + provideNumber;
									if (p == rowNumber - 1) {
										tempStr = params.substring(start, paramsNameNumber);
									} else {
										tempStr = params.substring(start, end) + "\n";
									}
									newParamsName += tempStr;
								}
							} else {
								newParamsName = params;
							}
							return newParamsName;
						}
					}
				}],
				grid: { // 控制图的大小，调整下面这些值就可以，
					x: 150
					// y2:300,
					// y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
				},
				series: [{
					name: '数量',
					type: 'bar',
					data: echartsDataValue,
					itemStyle: {
						normal: {
							label: {
								show: true,
								position: 'right'
							},
							labelLine: { show: true }

						}
					}
				}]
			};
			myChart.setOption(option);
		}

		init();
	}
	angular.module('xrmApp').service('BusiSaleRankService', ['entityService', function (entityService) {
		var rt = entityService.rt;
		angular.extend(this, entityService);
		// @@设置WebAPI的控制器名称
		this.controllerName = 'AlijkBusiSalesRank';
		// @@ 选项集
		this.picklists = [];
	}]);
	angular.module('xrmApp').controller("BusiSaleRankController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'BusiSaleRankService', BusiSaleRankController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-02-08
 说明     : 市场活动微信签到统计
 ********************************************************/
(function () {
    'use strict';

    function campaignsigninreportController($scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: $scope.vm.bigDepSelected.id });
            var unitids = _CalculateUnitids();
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "campaignName", Value: $scope.vm.campaignName });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.sYm = moment().format('YYYY-MM-01');
            $scope.vm.eYm = moment($scope.vm.eYm).format('YYYY-MM-DD');
            $scope.vm.campaignName = "";

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                var msg = _checkOption();
                if (!rt.isNullOrWhiteSpace(msg)) {
                    rt.errorMessage(msg);
                    return false;
                }
                var unitids = _CalculateUnitids();
                var bigUnitId = $scope.vm.bigDepSelected.id;
                var buId = $scope.vm.buidSelected.id;
                _getReportData(buId, bigUnitId, unitids);
            };
            _getAllBuid();
        }

        //条件检查
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "开始时间不能为空";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "结束时间不能为空";
            }
            if (moment($scope.vm.sYm) > moment($scope.vm.eYm)) {
                return "参数异常[开始日期必须小于等于结束日期.]";
            }
        }

        //获取业务线//大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            });
        }

        //获取市场活动出勤统计
        function _getReportData(buId, bigUnitId, unitids) {
            var waiting = rt.showLoading2();
            var url = 'api/CampaignSigninReport/GetCampaignSigninReport?sYm=' + encodeURIComponent($scope.vm.sYm) + '&eYm=' + encodeURIComponent($scope.vm.eYm) + '&campaignName=' + encodeURIComponent($scope.vm.campaignName) + '&buId=' + encodeURIComponent(buId) + '&bigDepId=' + encodeURIComponent(bigUnitId) + '&unitIds=' + encodeURIComponent(unitids) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                //导出权限
                return myService.getPrivilege().then(function (resp) {
                    $scope.vm.privilege = resp.data;
                });
            }).finally(function () {
                waiting.close();
            });
        }

        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join("','");
            }
            return unitids;
        }
    }

    angular.module('xrmApp').service('campaignsigninreportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'CampaignSigninReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("campaignsigninreportController", ['$scope', '$injector', 'rt', 'campaignsigninreportService', campaignsigninreportController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lecrean Pan
 创建时间 : 2018-1-8
 说明     :连锁生动化分析 
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('chainVividService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'ChainVivid';

        //查询区域生动化分析数据
        this.GetChainVivid = function (sYm, eYm, unitids, chainAccountId, accountLevel, pageSize, pageIndex) {
            return rt.post("api/ChainVivid/GetChainVivid?sYm=" + sYm + "&eYm=" + eYm + "&chainAccountId=" + chainAccountId + "&accountLevel=" + accountLevel + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex, unitids);
        };
    }]).controller('chainVividListController', ['$scope', '$injector', 'rt', 'chainVividService', chainVividListController]);

    function chainVividListController($scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            //区域(业务部门)Id
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";
            //初始化选中的连锁总部(门店名)
            var chainAccount_selectedId = "";
            if (!rt.isNull($scope.vm.chainAccount_selected) && !rt.isNull($scope.vm.chainAccount_selected.Id)) {
                chainAccount_selectedId = $scope.vm.chainAccount_selected.Id;
            }
            //初始化选中的客户分级
            var accountLevel_selectedValue = "";
            if (!rt.isNull($scope.vm.accountLevel_selected) && !rt.isNull($scope.vm.accountLevel_selected.Value)) {
                accountLevel_selectedValue = $scope.vm.accountLevel_selected.Value;
            }
            _that.searchList.length = 0;
            _that.searchList.push({
                Type: 1,
                Key: "sYm",
                Value: $scope.vm.sYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "eYm",
                Value: $scope.vm.eYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "unitids",
                Value: unitids
            });
            _that.searchList.push({
                Type: 1,
                Key: "chainAccountId",
                Value: chainAccount_selectedId
            });
            _that.searchList.push({
                Type: 1,
                Key: "accountLevel_selectedValue",
                Value: accountLevel_selectedValue
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageSize",
                Value: $scope.vm.pageSize
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageIndex",
                Value: $scope.vm.pageIndex
            });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();
        //初始化
        function init() {
            //时间筛选，默认全年，时间段范围为月份
            $scope.dateSelect = 'fullYear';
            $scope.vm.sYm = moment().format('YYYY-01');
            $scope.vm.eYm = moment().format('YYYY-12');
            //门店级别默认为空
            $scope.vm.accountLevel = [''];
            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.changeDate = _changeDate; //改变日期
            $scope.vm.getReportData = _getData; //获取报表数据

            //获取门店级别
            _getAccountLevel();
        }

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            return "";
        }

        //选择时间筛选
        function _changeDate(dateType) {
            $scope.dateSelect = dateType;

            switch (dateType) {
                case "fullYear":
                    $scope.vm.sYm = moment().format('YYYY-01');
                    $scope.vm.eYm = moment().format('YYYY-12');
                    break;
                case "thisMonth":
                    $scope.vm.sYm = moment().format('YYYY-MM');
                    $scope.vm.eYm = moment().format('YYYY-MM');
                    break;
                case "lastMonth":
                    $scope.vm.sYm = moment().add(-1, 'months').format('YYYY-MM');
                    $scope.vm.eYm = moment().add(-1, 'months').format('YYYY-MM');
                    break;
                case "thisQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-10');
                            $scope.vm.eYm = moment().format('YYYY-12');
                            break;
                    }
                    break;
                case "lastQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().add(-1, 'years').format('YYYY-10');
                            $scope.vm.eYm = moment().add(-1, 'years').format('YYYY-12');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                    }
                    break;
            }
        }
        //获取门店级别(客户分级)
        function _getAccountLevel() {
            var url = "api/businessaccount/GetPickListData?fieldCodes=account_grade_level";
            rt.get(url).then(function (resp) {
                if (!rt.isNull(resp.data) && !rt.isNull(resp.data.account_grade_level)) {
                    $scope.vm.accountLevel = resp.data.account_grade_level;
                    $scope.vm.accountLevel_selected = "";
                }
            });
        }
        // //获取查询数据
        function _getData() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            //获取区域Id,多条记录需要进行json转换
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            //初始化连锁总部(门店名)
            var chainAccount_selectedId = "";
            if (!rt.isNull($scope.vm.chainAccount_selected) && !rt.isNull($scope.vm.chainAccount_selected.Id)) {
                chainAccount_selectedId = $scope.vm.chainAccount_selected.Id;
            }
            //初始化门店级别
            var accountLevel_selectedValue = "";
            if (!rt.isNull($scope.vm.accountLevel_selected) && !rt.isNull($scope.vm.accountLevel_selected.Value)) {
                accountLevel_selectedValue = $scope.vm.accountLevel_selected.Value;
            }
            var waiting = rt.showLoading2();
            //获取门店分级
            myService.GetChainVivid($scope.vm.sYm, $scope.vm.eYm, unitids, chainAccount_selectedId, accountLevel_selectedValue, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            });
        }
        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
        }
    }
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
//* 创建人   :oscargao
//* 创建时间 :2016-01-21
//* 说明     :商业经营特性分析(按企业)
//******************************************************************
// #endregion
(function () {
	'use strict';

	function CharacterByEntController($scope, $q, rt) {

		init();
		function init() {
			var cw = document.documentElement.clientWidth || document.body.clientWidth;
			$scope.chartWidth = cw - 50;
			$scope.vm = {};
			$scope.vm.reportData = [];
			$scope.vm.showReport = function () {
				_getReportData().then(_show, function (message) {
					rt.errorMessage(message);
				});
			};

			$scope.selectedTabId = "tab1";
			$scope.selectTab = _selectTab;
			//$scope.getBusiNameList=_getBusiNameList;
			_getAllProduct();
			_getAllProvince();
		}
		//获取产品
		function _getAllProduct() {
			var url = 'api/AlijkProduct/GetAllProduct';
			return rt.get(url).then(function (resp) {
				$scope.vm.productList = resp.data;
				$scope.vm.productSelected = null;
			});
		}
		//获取省份
		function _getAllProvince() {
			var url = 'api/AlijkProvince/GetAllProvince';
			return rt.get(url).then(function (resp) {
				$scope.vm.provinceList = resp.data;
				$scope.vm.provinceSelected = null;
			});
		}
		//计算开始结束时间大小关系 间隔天数
		function _CalculateDays(startDate, endDate) {
			var sArr = startDate.split("-");
			var eArr = endDate.split("-");
			var sRDate = new Date(sArr[0], sArr[1]);
			var eRDate = new Date(eArr[0], eArr[1]);
			var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
			return result;
		}
		//获取商业公司
		//function  _getBusiNameList(name) {
		//	if(!rt.isNullOrWhiteSpace(name)) {
		//		if (rt.isNullOrWhiteSpace($scope.vm.startYm) || rt.isNullOrWhiteSpace($scope.vm.endYm)) {
		//			var deferred = $q.defer();
		//			deferred.reject("请填写开始结束年月。");
		//			return deferred.promise;
		//			//alert('请填写开始结束年月');
		//			//return false;
		//		}
		//		var waiting = rt.showWaiting();
		//		var url = 'api/AlijkEntAllBusiNameList/GetEntAllBusiNameList';
		//		url+="?startYm="+encodeURIComponent($scope.vm.startYm);
		//		url+="&endYm="+encodeURIComponent($scope.vm.endYm);
		//		url+="&busiName="+encodeURIComponent(name);
		//		return rt.get(url).then(function (resp) {
		//			$scope.vm.busiList = resp.data;
		//			$scope.vm.busiSelected = null;
		//			waiting.close();
		//		},function(){ waiting.close(); });
		//	}
		//}

		function _selectTab(id) {
			$scope.selectedTabId = id;
			_show();
		}

		function _show() {
			var t = $scope.selectedTabId;
			if (t == "tab1") {
				_showReport1();
			} else if (t == "tab2") {
				_showReport2();
			} else if (t == "tab3") {
				_showReport3();
			}
		}

		function _getReportData() {
			if (rt.isNull($scope.vm.productSelected)) {
				var deferred = $q.defer();
				deferred.reject("药品名称不能为空。");
				return deferred.promise;
			}
			if (rt.isNull($scope.vm.busiSelected) || rt.isNullOrWhiteSpace($scope.vm.busiSelected.Name)) {
				var deferred = $q.defer();
				deferred.reject("商业公司不能为空。");
				return deferred.promise;
			}
			if (rt.isNullOrWhiteSpace($scope.vm.startYm)) {
				var deferred = $q.defer();
				deferred.reject("开始年月不能为空。");
				return deferred.promise;
			}
			if (rt.isNullOrWhiteSpace($scope.vm.endYm)) {
				var deferred = $q.defer();
				deferred.reject("结束年月不能为空。");
				return deferred.promise;
			}
			if (_CalculateDays($scope.vm.startYm, $scope.vm.endYm) < 0) {
				var deferred = $q.defer();
				deferred.reject("参数异常[开始日期必须小于等于结束日期.]");
				return deferred.promise;
			}
			if (_CalculateDays($scope.vm.startYm, $scope.vm.endYm) >= 365) {
				var deferred = $q.defer();
				deferred.reject("参数异常[日期区间最大为12个月.]");
				return deferred.promise;
			}
			var waiting = rt.showLoading2();
			var url = 'api/AlijkBusiOperateCharacter/BusiOperateCharacterByEnt?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&entInfoName=' + encodeURIComponent($scope.vm.busiSelected.Name) + '&startYm=' + encodeURIComponent($scope.vm.startYm) + '&endYm=' + encodeURIComponent($scope.vm.endYm);
			return rt.get(url).then(function (resp) {
				$scope.vm.reportData = resp.data;
				waiting.close();
			}, function () {
				waiting.close();
			});
		}
		//图标1
		function _showReport1() {

			var myChart = echarts.init(document.getElementById("report1"), "shine");
			angular.element(window).on('resize', myChart.resize);
			var echartXName = []; //['1月','2月','3月','4月','5月','6月','7月','8月','9月','10月','11月','12月']; //月份
			var inData = []; //进货量
			var outData = []; //出货量
			var getData = $scope.vm.reportData.InOutMods;
			angular.forEach(getData, function (d) {
				inData.push(d.InCount);
				outData.push(d.OutCount);
				echartXName.push(d.MonthId);
			});
			var itemStyle = {
				normal: {
					barBorderRadius: 0,
					label: {
						show: true,
						position: 'top'
					}
				}
			};
			var option = {
				tooltip: {
					show: true
				},
				legend: {
					data: ['进货量', '出货量']
				},

				xAxis: [{
					type: 'category',
					data: echartXName
				}],
				yAxis: [{
					type: 'value'
				}],
				series: [{
					"name": "进货量",
					"type": "bar",
					"data": inData,
					"itemStyle": itemStyle
				}, {
					"name": "出货量",
					"type": "bar",
					"data": outData,
					"itemStyle": itemStyle
				}]
			};
			myChart.clear();
			myChart.setOption(option);
		}
		//图表2
		function _showReport2() {

			var myChart2 = echarts.init(document.getElementById("report2"), "shine");
			angular.element(window).on('resize', myChart2.resize);
			var xName = []; //['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月']; //横轴标题
			var pureData = []; //纯销售
			var batchData = []; //批发
			var getData = $scope.vm.reportData.BatchPures;
			angular.forEach(getData, function (d) {
				pureData.push(d.PureCount);
				batchData.push(d.BatchCount);
				xName.push(d.MonthId);
			});
			var itemStyle = {
				normal: {
					barBorderRadius: 0,
					label: {
						show: true,
						position: 'top'
					}
				}
			};
			var option = {
				tooltip: {
					show: true
				},
				legend: {
					data: ['纯销', '批发']
				},
				itemStyle: {
					normal: {
						barBorderRadius: 0,
						label: {
							show: true,
							position: 'top'
						}
					}
				},
				xAxis: [{
					type: 'category',
					data: xName
				}],
				yAxis: [{
					type: 'value'
				}],
				series: [{
					"name": "纯销",
					"type": "bar",
					"data": pureData,
					"itemStyle": itemStyle
				}, {
					"name": "批发",
					"type": "bar",
					"data": batchData,
					"itemStyle": itemStyle
				}]
			};
			myChart2.clear();
			myChart2.setOption(option);
		}
		//图表3
		function _showReport3() {

			var myChart3 = echarts.init(document.getElementById("report3"), "shine");
			angular.element(window).on('resize', myChart3.resize);
			var xName = []; //['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月']; //横轴标题
			var expData = []; //异常销售
			var totalData = []; //总销量
			var getData = $scope.vm.reportData.Abnormals;
			angular.forEach(getData, function (d) {
				expData.push(d.AbnormalCount);
				totalData.push(d.TotalCount);
				xName.push(d.MonthId);
			});
			var itemStyle = {
				normal: {
					barBorderRadius: 0,
					label: {
						show: true,
						position: 'top'
					}
				}
			};
			var option = {
				tooltip: {
					show: true
				},
				legend: {
					data: ['窜货销量', '总销量']
				},
				itemStyle: {
					normal: {
						barBorderRadius: 0,
						label: {
							show: true,
							position: 'top'
						}
					}
				},
				xAxis: [{
					type: 'category',
					data: xName
				}],
				yAxis: [{
					type: 'value'
				}],
				series: [{
					"name": "窜货销量",
					"type": "bar",
					"data": expData,
					"itemStyle": itemStyle
				}, {
					"name": "总销量",
					"type": "bar",
					"data": totalData,
					"itemStyle": itemStyle
				}]
			};
			myChart3.clear();
			myChart3.setOption(option);
		}
	}

	angular.module('xrmApp').controller("CharacterByEntController", ['$scope', '$q', 'rt', CharacterByEntController]);
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
//* 创建人   :oscargao
//* 创建时间 :2016-01-21
//* 说明     :商业经营特性分析
//******************************************************************
// #endregion

(function () {
    'use strict';

    function CharacterByProvController($scope, $q, rt) {
        init();
        function init() {
            $scope.vm = {};

            $scope.vm.buidList = []; //事业部下拉
            $scope.vm.buidSelected = { Id: '' }; //事业部选择
            $scope.vm.bigDepList = []; //业务线/大区下拉
            $scope.vm.bigDepSelected = { Id: '' }; //业务线/大区选择
            $scope.vm.businessUnitList = []; //省区/地区下拉
            $scope.vm.businessUnitSelected = null; //省区/地区选择

            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.getCrossOutByPage = _getCrossOutByPage;
            $scope.vm.showReport = function () {
                $scope.vm.pageIndex = 1;
                _getReportData().then(_show, function (message) {
                    rt.errorMessage(message);
                });
            };
            var cw = document.documentElement.clientWidth || document.body.clientWidth;
            $scope.chartWidth = cw - 40;
            $scope.selectedTabId = "tab1";
            $scope.selectTab = _selectTab;
            _getAllProduct();
            _getAllProvince();
            _getTops();
            _getAllBuid(); //获取所有事业部
        }

        //获取窜货明细数据
        function _getCrossOutByPage() {
            var url = 'api/AlijkBusiOperateCharacter/GetCrossDataByPagerDepartment?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&buId=' + encodeURIComponent($scope.vm.buidSelected.id) + '&bigUnitId=' + encodeURIComponent($scope.vm.bigDepSelected.id) + '&unitIds=' + encodeURIComponent(unitids) + '&startYm=' + encodeURIComponent($scope.vm.startDate) + '&endYm=' + encodeURIComponent($scope.vm.endDate) + '&pageIndex=' + $scope.vm.pageIndex + '&pageSize=' + $scope.vm.pageSize;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData.CrossOuts = resp.data.CrossOuts;
                $scope.vm.reportData.CrossOutsTotalCount = resp.data.CrossOutsTotalCount;
            });
        }

        //获取产品
        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }

        //获取省份
        function _getAllProvince() {
            var url = 'api/AlijkProvince/GetAllProvince';
            return rt.get(url).then(function (resp) {
                $scope.vm.provinceList = resp.data;
                $scope.vm.provinceSelected = null;
            });
        }

        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[0];
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        //获取业务线/大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { Id: '' };
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                        $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        function _selectTab(id) {
            $scope.selectedTabId = id;
            if (id == "tab1") {
                //调拨纯销
                _showReport1();
            } else if (id == "tab2") {
                //终端销售
                _showReport2();
            } else if (id == "tab3") {
                //正常异常销售
                _showReport3();
            }
        }

        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        function _show() {
            var t = $scope.selectedTabId;
            if (t == "tab1") {
                _showReport1();
            } else if (t == "tab2") {
                _showReport2();
            } else if (t == "tab3") {
                _showReport3();
            }
        }

        function _getReportData() {
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                var deferred = $q.defer();
                deferred.reject("开始年月不能为空。");
                return deferred.promise;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                var deferred = $q.defer();
                deferred.reject("结束年月不能为空。");
                return deferred.promise;
            }

            if (rt.isNull($scope.vm.productSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }

            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                rt.errorMessage("请选择事业部");
                return false;
            }

            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) < 0) {
                var deferred = $q.defer();
                deferred.reject("参数异常[开始日期必须小于等于结束日期.]");
                return deferred.promise;
            }

            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) >= 365) {
                var deferred = $q.defer();
                deferred.reject("参数异常[日期区间最大为12个月.]");
                return deferred.promise;
            }

            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join("','");
            }

            var waiting = rt.showLoading2();
            var url = 'api/AlijkBusiOperateCharacter/BusiOperateCharacterByDepartment?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&buId=' + encodeURIComponent($scope.vm.buidSelected.id) + '&bigUnitId=' + encodeURIComponent($scope.vm.bigDepSelected.id) + '&unitIds=' + encodeURIComponent(unitids) + '&startYm=' + encodeURIComponent($scope.vm.startDate) + '&endYm=' + encodeURIComponent($scope.vm.endDate) + '&top=' + $scope.vm.topsSelected;

            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        function _showReport1() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            var echartYName = []; //商业公司
            var batchData = []; //批发
            var pureData = []; //纯销
            var getData = $scope.vm.reportData.SaleTypes;
            for (var i = 0; i < getData.length; i++) {
                echartYName.push(getData[i].EntInfoName);
                batchData.push(getData[i].BatchCount);
                pureData.push(-getData[i].PureCount);
            }
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: function formatter(params) {
                        var s = "";
                        s += params[0].name + "</br>";
                        s += params[1].seriesName + "：";
                        s += -params[1].value + "</br>";
                        s += params[0].seriesName + "：";
                        s += params[0].value;
                        return s;
                    },
                    axisPointer: { // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    }
                },
                grid: {
                    x: '100', y: '20'
                },
                legend: {
                    data: ['批发', '纯销']
                },
                xAxis: [{
                    type: 'value'
                }],
                yAxis: [{
                    type: 'category',
                    axisTick: { show: false },
                    data: echartYName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '批发',
                    type: 'bar',
                    stack: '总量',
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right'
                            }
                        }
                    },
                    data: batchData
                }, {
                    name: '纯销',
                    type: 'bar',
                    stack: '总量',
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'left',
                                formatter: function formatter(params) {
                                    return -params.value === 0 ? '' : -params.value;
                                }
                            }
                        }
                    },
                    data: pureData
                }]
            };

            myChart.setOption(option);
        }

        //图表2
        function _showReport2() {

            var Chart2 = echarts.init(document.getElementById("report2"), "shine");
            angular.element(window).on('resize', Chart2.resize);
            var echartYName = []; //商业公司
            var busiData = []; //商业
            var retailData = []; //零售
            var medicalData = []; //医疗
            var thirdData = []; //第三终端
            var getData = $scope.vm.reportData.EntRoles;
            for (var i = 0; i < getData.length; i++) {
                echartYName.push(getData[i].EntInfoName);
                busiData.push(getData[i].BusiSaleCount);
                retailData.push(getData[i].RetailCount);
                medicalData.push(getData[i].MedicalCount);
                thirdData.push(getData[i].ThirdCount);
            }
            var itemStyle = { normal: { label: { show: false, position: '' } } };
            var option = {
                tooltip: {
                    trigger: 'axis',
                    axisPointer: { // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    }
                },
                legend: {
                    data: ['零售终端', '医疗终端', '第三终端']
                },
                grid: {
                    x: '100', y: '20'
                },
                xAxis: [{
                    type: 'value'
                }],
                yAxis: [{
                    type: 'category',
                    data: echartYName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '零售终端',
                    type: 'bar',
                    stack: '总量',
                    itemStyle: itemStyle,
                    data: retailData
                }, {
                    name: '医疗终端',
                    type: 'bar',
                    stack: '总量',
                    itemStyle: itemStyle,
                    data: medicalData
                }, {
                    name: '第三终端',
                    type: 'bar',
                    stack: '总量',
                    itemStyle: itemStyle,
                    data: thirdData
                }]
            };
            Chart2.clear();
            Chart2.setOption(option);
        }

        //图表3
        function _showReport3() {

            var Chart3 = echarts.init(document.getElementById("report3"), "shine");
            angular.element(window).on('resize', Chart3.resize);
            var echartYName = []; //商业公司
            var normalData = []; //正常
            var abnormalData = []; //异常
            var getData = $scope.vm.reportData.SaleNormals;
            for (var i = 0; i < getData.length; i++) {
                echartYName.push(getData[i].EntInfoName);
                normalData.push(getData[i].SaleNormalCount);
                abnormalData.push(-getData[i].SaleAbnormalCount);
            }
            var option = {
                tooltip: {
                    trigger: 'axis',
                    formatter: function formatter(params) {
                        var s = "";
                        s += params[0].name + "</br>";
                        s += params[1].seriesName + "：";
                        s += -params[1].value + "</br>";
                        s += params[0].seriesName + "：";
                        s += params[0].value;
                        return s;
                    },
                    axisPointer: {
                        // 坐标轴指示器，坐标轴触发有效
                        type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                    }
                },
                legend: {
                    data: ['正常销量', '窜货销量']
                },
                grid: {
                    x: '100', y: '20'
                },
                xAxis: [{
                    type: 'value'
                }],
                yAxis: [{
                    type: 'category',
                    data: echartYName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '正常销量',
                    type: 'bar',
                    stack: '总量',
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right'
                            }
                        }
                    },
                    data: normalData
                }, {
                    name: '窜货销量',
                    type: 'bar',
                    stack: '总量',
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'left',
                                formatter: function formatter(params) {
                                    return -params.value === 0 ? '' : -params.value;
                                }
                            }
                        }
                    },
                    data: abnormalData
                }]
            };
            Chart3.clear();
            Chart3.setOption(option);
        }
    }

    angular.module('xrmApp').controller("CharacterByProvController", ['$scope', '$q', 'rt', CharacterByProvController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2017-01-16
 说明     : 代表拜访排名
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('DelegateVisitRankListService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'RepresentativeVisitRank';
        // @@ 选项集
        this.picklists = [];
    }]).controller("DelegateVisitRankListController", ['$scope', '$q', 'rt', '$injector', 'DelegateVisitRankListService', DelegateVisitRankListController]);
    function DelegateVisitRankListController($scope, $q, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.startYM });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.endYM });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "visitTypeId", Value: $scope.vm.visitTypeSelected.id });
            var unitids = _CalculateUnitids();
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.startYM = moment(moment().format('YYYY-MM') + '-01').format('YYYY-MM-DD');
            $scope.vm.endYM = moment($scope.vm.endYM).format('YYYY-MM-DD');
            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };
            //查询
            $scope.vm.showReport = function () {
                var msg = _checkOption();
                if (!rt.isNullOrWhiteSpace(msg)) {
                    rt.errorMessage(msg);
                    return false;
                }
                var unitids = _CalculateUnitids();
                var bigUnitId = $scope.vm.bigDepSelected.id;
                var buId = $scope.vm.buidSelected.id;
                var visitTypeId = $scope.vm.visitTypeSelected.id;

                //获取终端热度总拜访数和均拜访数
                _getReportData(buId, bigUnitId, unitids, visitTypeId).then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllType();
            _getAllBuid();
        }

        //条件检查
        function _checkOption() {

            if (rt.isNullOrWhiteSpace($scope.vm.startYM)) {
                return "开始时间不能为空";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.endYM)) {
                return "结束时间不能为空";
            }

            if (_CalculateDays($scope.vm.startYM, $scope.vm.endYM) < 0) {
                return "参数异常[开始日期必须小于等于结束日期.]";
            }
        }

        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];

            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }

            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {

            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;

                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            });
        }

        //获取拜访类型类型
        function _getAllType() {
            rt.queryData("VisitRecord.GetVisitType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;

                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.visitType = data;
                    $scope.vm.visitType.unshift({ name: '全部类型', id: '' });
                    $scope.vm.visitTypeSelected = $scope.vm.visitType[0];
                }
            });
        }

        //获取终端热度总拜访数和均拜访数
        function _getReportData(buId, bigUnitId, unitids, visitTypeId) {
            var waiting = rt.showLoading2();
            var url = 'api/RepresentativeVisitRank/GetDelegateVisitRankList?sYm=' + encodeURIComponent($scope.vm.startYM) + '&eYm=' + encodeURIComponent($scope.vm.endYM) + '&buId=' + encodeURIComponent(buId) + '&bigDepId=' + encodeURIComponent(bigUnitId) + '&unitIds=' + encodeURIComponent(unitids) + '&visitTypeId=' + encodeURIComponent(visitTypeId) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            return unitids;
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-10-31
 说明     : 医院开发进度统计
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('DevelopHospitalRateService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DevelopHospitalRate';
        // @@ 选项集
        this.picklists = [];
    }]).controller("DevelopHospitalRateController", ['$scope', '$q', 'rt', '$injector', 'DevelopHospitalRateService', DevelopHospitalRateController]);
    function DevelopHospitalRateController($scope, $q, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sDate });
            _that.searchList.push({ Type: 1, Key: "eDate", Value: $scope.vm.eDate });
            _that.searchList.push({ Type: 1, Key: "buId", Value: rt.isNull($scope.vm.Buid) ? "" : $scope.vm.Buid.Id });
            _that.searchList.push({ Type: 1, Key: "businessUnitIds", Value: rt.isNull($scope.vm.nodeSelected) ? "" : $scope.vm.nodeSelected.ids });
            _that.searchList.push({ Type: 1, Key: "ownerId", Value: rt.isNull($scope.vm.OwnerId) ? "" : $scope.vm.OwnerId.Id });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.sDate = moment(moment().format('YYYY-MM') + '-01').format('YYYY-MM-DD');
            $scope.vm.eDate = moment(moment().add('months', 1).format('YYYY-MM') + '-01').add('days', -1).format('YYYY-MM-DD');
            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };
            //查询
            $scope.vm.showReport = function () {
                var msg = _checkOption();
                if (!rt.isNullOrWhiteSpace(msg)) {
                    rt.errorMessage(msg);
                    return false;
                }
                var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
                var OwnerId = rt.isNull($scope.vm.OwnerId) ? "" : $scope.vm.OwnerId.Id;

                //获取终端热度总拜访数和均拜访数
                _getReportData(unitids, OwnerId).then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
        }

        //条件检查
        function _checkOption() {

            if (rt.isNullOrWhiteSpace($scope.vm.sDate)) {
                return "开始时间不能为空";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                return "结束时间不能为空";
            }

            if (_CalculateDays($scope.vm.sDate, $scope.vm.eDate) < 0) {
                return "参数异常[开始日期必须小于等于结束日期.]";
            }
        }

        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            if (startDate > endDate) {
                return -1;
            }
            return 0;
        }

        //获取终端热度总拜访数和均拜访数
        function _getReportData(unitids, OwnerId) {
            var waiting = rt.showLoading2();

            return rt.post('api/DevelopHospitalRate/GetDevelopHospitalRateData?sDate=' + encodeURIComponent($scope.vm.sDate) + '&eDate=' + encodeURIComponent($scope.vm.eDate) + '&ownerId=' + encodeURIComponent(OwnerId) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize), unitids).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }
    }
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Berry Ding
//* 创建时间 :2016-1-19
//* 说明     :基础-流向查询（按批次）
//******************************************************************
// #endregion

(function () {
    'use strict';

    angular.module('xrmApp').controller("drugflowbybatchnoController", ['$scope', '$q', 'rt', drugflowbybatchnoController]);
    function drugflowbybatchnoController($scope, $q, rt) {
        init();

        function init() {
            $scope.vm = {};
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;

            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            $scope.vm.showReport = function () {
                _getReportData().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };

            // 根据产品名称查询产品ID
            //$scope.$watch('vm.productSelected', function () {
            //    $scope.vm.batchNoList = null;
            //    $scope.vm.batchNoSelected = null;
            //    if(!rt.isNull($scope.vm.productSelected)) {
            //        _getProductID().then(function(message){
            //        })
            //    }
            //});

            // 根据产品ID查询产品批次
            //$scope.$watch('vm.productIDSelected', function () {
            //    if(!rt.isNull($scope.vm.productIDSelected)) {
            //        $scope.vm.batchNoList = null;
            //        $scope.vm.batchNoSelected = null;
            //    }
            //});

            _getAllProduct();
            $scope.getBatchNo = _getBatchNo;
        }

        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }

        function _getProductID() {
            var url = 'api/AlijkGetDrugName/GetDrugName?drugName=' + encodeURIComponent($scope.vm.productSelected.NAME);
            return rt.get(url).then(function (resp) {
                $scope.vm.productIDList = resp.data;
                $scope.vm.productIDSelected = null;
            });
        }

        function _getBatchNo(batchNo) {
            if (rt.isNullOrWhiteSpace(batchNo)) return;

            var url = 'api/AlijkGetBatchNo/GetBatchNo2?prodSeqNo=' + encodeURIComponent($scope.vm.productIDSelected.VAL) + "&batchNo=" + encodeURIComponent(batchNo);
            return rt.get(url).then(function (resp) {
                $scope.vm.batchNoList = resp.data;
                $scope.vm.batchNoSelected = null;
            });
        }

        function _getReportData() {
            if (rt.isNull($scope.vm.productSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }
            //if (rt.isNull($scope.vm.productIDSelected)) {
            //    var deferred = $q.defer();
            //    deferred.reject("查询的药品规格不能为空。");
            //    return deferred.promise;
            //}
            if (rt.isNullOrWhiteSpace($scope.vm.batchNoSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品批次不能为空。");
                return deferred.promise;
            }
            var waiting = rt.showLoading2();
            var url = 'api/AlijkGetAllDrugFlowList/GetAllDrugFlowList?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&batchNo=' + encodeURIComponent($scope.vm.batchNoSelected) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.GetAllDrugFlowList;
                $scope.vm.recordCount = resp.data.TotalRecordCount;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
    }
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Berry Ding
//* 创建时间 :2016-1-20
//* 说明     :基础-流向查询（按月）
//******************************************************************
// #endregion

(function () {
    'use strict';

    angular.module('xrmApp').controller("drugflowbymonthController", ['$scope', '$q', 'rt', drugflowbymonthController]);
    function drugflowbymonthController($scope, $q, rt) {
        init();

        function init() {
            $scope.vm = {};
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;

            $scope.vm.pageSize = rt.getPaginationSize();

            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            $scope.vm.showReport = function () {
                _getReportData().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };

            _getAllProvince();
            _getAllDrugNamesByEnt();
        }

        function _getAllProvince() {
            var url = 'api/AlijkProvince/GetAllProvince';
            return rt.get(url).then(function (resp) {
                $scope.vm.provinceList = resp.data;
                $scope.vm.provinceSelected = null;
            });
        }

        function _getAllDrugNamesByEnt() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }

        function _getReportData() {
            if (rt.isNull($scope.vm.productSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.provinceSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的省份不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的年月不能为空。");
                return deferred.promise;
            }
            var waiting = rt.showLoading2();
            var url = 'api/AlijkGetEntFlowByProvMonthly/GetEntFlowByProvMonthlyList?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&dataMonthId=' + encodeURIComponent($scope.vm.startDate) + '&fromProvCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.GetEntFlowByProvMonthlyList;
                $scope.vm.recordCount = resp.data.TotalRecordCount;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
    }
})();
"use strict";

//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Mona Xia
//* 创建时间 :2017-04-17
//* 说明     :季度药品医院覆盖率
//******************************************************************
(function () {
    'use strict';

    function drugHospitalCoverageListController($scope, $q, $compile, $timeout, rt, $injector, myService) {

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            // $scope.vm.bigDepList = [];
            // $scope.vm.bigDepSelected = { id: '' };
            // $scope.vm.businessUnitList = [];
            // $scope.vm.businessUnitSelected = [];
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            //$scope.tableMaxHeight = 100;
            $scope.vm.quarterList = [{
                id: "1",
                name: "第一季度"
            }, {
                id: "2",
                name: "第二季度"
            }, {
                id: "3",
                name: "第三季度"
            }, {
                id: "4",
                name: "第四季度"
            }];
            $scope.vm.quarterSelected = $scope.vm.quarterList[0];
            $scope.vm.search = _search;
            //_getAllBuid();
            //_initYmSelected();
        }

        //初始化时间
        // function _initYmSelected() {
        //     var d = new Date();
        //     $scope.vm.sDate = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
        //     $scope.vm.eDate = moment().format('YYYY-MM-DD');
        // }
        // $scope.complateTableheight = function () {
        //     _complateTableheight();
        // };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _search() {
            // var provinceids = '';
            // if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
            //     return rt.errorMessage("请输入开始时间或结束时间");
            // }

            // if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
            //     var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
            //         return item.id;
            //     });
            //     provinceids = "'" + Iprovinceids.join("','") + "'";
            // }

            // var waiting = rt.showWaiting();
            // var url = "api/DrugSalePolicy/DrugSalePolicyRportData?sDate=" + $scope.vm.sDate
            //     + "&eDate=" + $scope.vm.eDate
            //     + "&buId=" + $scope.vm.buidSelected.id
            //     + "&depId=" + $scope.vm.bigDepSelected.id
            //     + "&provinceId=" + provinceids
            //     + "&PageSize=" + $scope.vm.pageSize
            //     + "&PageIndex=" + $scope.vm.pageIndex;
            // return rt.get(url).then(function (resp) {
            //     $scope.vm.dataTable = resp.data.DataList;
            //     $scope.vm.recordCount = resp.data.TotalRecords;
            //     waiting.close();
            //     _complateTableheight();
            // }, function () { waiting.close(); });

            $scope.vm.dataTable = [{
                accountLevel: "三级医院",
                devAmount: 8,
                devTargetAmount: 42,
                coverageRateTarget: 9,
                coverageRateNow: 7
            }, {
                accountLevel: "二级医院",
                devAmount: 220,
                devTargetAmount: 450,
                coverageRateTarget: 12.9,
                coverageRateNow: 10.4
            }, {
                accountLevel: "二级以下医院",
                devAmount: 330,
                devTargetAmount: 700,
                coverageRateTarget: 22,
                coverageRateNow: 13
            }, {
                accountLevel: "县级医院",
                devAmount: 600,
                devTargetAmount: 1800,
                coverageRateTarget: 31,
                coverageRateNow: 28
            }];
            $scope.vm.recordCount = $scope.vm.dataTable.length;
            //_complateTableheight();
        }
        //获取商业大区
        // $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
        //     if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
        //         rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
        //             $scope.vm.bigDepList = [];
        //             $scope.vm.bigDepSelected = { id: '' };
        //             $scope.vm.businessUnitSelected = [];
        //             $scope.vm.businessUnitList = [];
        //             var data = resp.DataList;
        //             if (data != null && data.length > 0) {
        //                 $scope.vm.bigDepList = data;
        //             }
        //             $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
        //             $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        //         }, function (error) {
        //             $scope.vm.bigDepList = [];
        //         });
        //     } else {
        //         $scope.vm.bigDepList = [];
        //         $scope.vm.bigDepSelected = { id: '', name: "全部业务线/大区/大区" };
        //         $scope.vm.businessUnitSelected = [];
        //         $scope.vm.businessUnitList = [];
        //     }
        // });
        // //获取省区/地区
        // $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
        //     if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
        //         rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
        //             $scope.vm.businessUnitSelected = [];
        //             $scope.vm.businessUnitList = [];
        //             var data = resp.DataList;
        //             if (data != null && data.length > 0) {
        //                 $scope.vm.businessUnitList = data;
        //             }
        //         }, function (error) {
        //             $scope.vm.businessUnitList = [];
        //         });
        //     }
        //     $scope.vm.businessUnitList = [];
        // });
        // //获取所有事业部
        // function _getAllBuid() {
        //     rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
        //         var data = resp.DataList;
        //         if (data != null && data.length > 0) {
        //             $scope.vm.quarterList = data;
        //             //$scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
        //             $scope.vm.buidSelected = $scope.vm.quarterList[0];
        //         } else {
        //             //$scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
        //             $scope.vm.buidSelected = $scope.vm.quarterList[0];
        //         }
        //     }, function (error) { });
        // }

        init();
    }
    angular.module('xrmApp').service('drugHospitalCoverageService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'drugHospitalCoverage';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("drugHospitalCoverageListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'drugHospitalCoverageService', drugHospitalCoverageListController]);
})();
"use strict";

//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Mona Xia
//* 创建时间 :2017-04-17
//* 说明     :药品品规替换情况统计
//******************************************************************
(function () {
    'use strict';

    function drugReplaceListController($scope, $q, $compile, $timeout, rt, $injector, myService) {

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            // $scope.vm.bigDepList = [];
            // $scope.vm.bigDepSelected = { id: '' };
            // $scope.vm.businessUnitList = [];
            // $scope.vm.businessUnitSelected = [];
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            //$scope.tableMaxHeight = 100;
            $scope.vm.quarterList = [{
                id: "1",
                name: "第一季度"
            }, {
                id: "2",
                name: "第二季度"
            }, {
                id: "3",
                name: "第三季度"
            }, {
                id: "4",
                name: "第四季度"
            }];
            $scope.vm.quarterSelected = $scope.vm.quarterList[0];
            $scope.vm.search = _search;
            //_getAllBuid();
            //_initYmSelected();
        }

        //初始化时间
        // function _initYmSelected() {
        //     var d = new Date();
        //     $scope.vm.sDate = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
        //     $scope.vm.eDate = moment().format('YYYY-MM-DD');
        // }
        // $scope.complateTableheight = function () {
        //     _complateTableheight();
        // };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _search() {
            // var provinceids = '';
            // if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
            //     return rt.errorMessage("请输入开始时间或结束时间");
            // }

            // if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
            //     var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
            //         return item.id;
            //     });
            //     provinceids = "'" + Iprovinceids.join("','") + "'";
            // }

            // var waiting = rt.showWaiting();
            // var url = "api/DrugSalePolicy/DrugSalePolicyRportData?sDate=" + $scope.vm.sDate
            //     + "&eDate=" + $scope.vm.eDate
            //     + "&buId=" + $scope.vm.buidSelected.id
            //     + "&depId=" + $scope.vm.bigDepSelected.id
            //     + "&provinceId=" + provinceids
            //     + "&PageSize=" + $scope.vm.pageSize
            //     + "&PageIndex=" + $scope.vm.pageIndex;
            // return rt.get(url).then(function (resp) {
            //     $scope.vm.dataTable = resp.data.DataList;
            //     $scope.vm.recordCount = resp.data.TotalRecords;
            //     waiting.close();
            //     _complateTableheight();
            // }, function () { waiting.close(); });

            $scope.vm.dataTable = [{
                accountLevel: "三级医院",
                sales1: 23000,
                sales2: 32000
            }, {
                accountLevel: "二级医院",
                sales1: 16200,
                sales2: 18000
            }, {
                accountLevel: "二级以下医院",
                sales1: 8000,
                sales2: 12000
            }, {
                accountLevel: "门店",
                sales1: 6000,
                sales2: 5000
            }, {
                accountLevel: "其他",
                sales1: 5000,
                sales2: 700
            }];
            $scope.vm.dataTable.forEach(function (row) {
                row.replaceRate = row.sales2 / (row.sales1 + row.sales2) * 100;
                row.levelRate1 = row.sales1 / _.sum($scope.vm.dataTable, 'sales1') * 100;
                row.levelRate2 = row.sales2 / _.sum($scope.vm.dataTable, 'sales2') * 100;
            }, this);
            $scope.vm.dataTable.push({
                accountLevel: "总计",
                sales1: _.sum($scope.vm.dataTable, 'sales1'),
                levelRate1: 100,
                sales2: _.sum($scope.vm.dataTable, 'sales2'),
                levelRate2: 100,
                replaceRate: _.sum($scope.vm.dataTable, 'sales2') / (_.sum($scope.vm.dataTable, 'sales1') + _.sum($scope.vm.dataTable, 'sales2')) * 100
            });

            $scope.vm.recordCount = $scope.vm.dataTable.length;
            //_complateTableheight();
        }
        //获取商业大区
        // $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
        //     if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
        //         rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
        //             $scope.vm.bigDepList = [];
        //             $scope.vm.bigDepSelected = { id: '' };
        //             $scope.vm.businessUnitSelected = [];
        //             $scope.vm.businessUnitList = [];
        //             var data = resp.DataList;
        //             if (data != null && data.length > 0) {
        //                 $scope.vm.bigDepList = data;
        //             }
        //             $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
        //             $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        //         }, function (error) {
        //             $scope.vm.bigDepList = [];
        //         });
        //     } else {
        //         $scope.vm.bigDepList = [];
        //         $scope.vm.bigDepSelected = { id: '', name: "全部业务线/大区/大区" };
        //         $scope.vm.businessUnitSelected = [];
        //         $scope.vm.businessUnitList = [];
        //     }
        // });
        // //获取省区/地区
        // $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
        //     if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
        //         rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
        //             $scope.vm.businessUnitSelected = [];
        //             $scope.vm.businessUnitList = [];
        //             var data = resp.DataList;
        //             if (data != null && data.length > 0) {
        //                 $scope.vm.businessUnitList = data;
        //             }
        //         }, function (error) {
        //             $scope.vm.businessUnitList = [];
        //         });
        //     }
        //     $scope.vm.businessUnitList = [];
        // });
        // //获取所有事业部
        // function _getAllBuid() {
        //     rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
        //         var data = resp.DataList;
        //         if (data != null && data.length > 0) {
        //             $scope.vm.quarterList = data;
        //             //$scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
        //             $scope.vm.buidSelected = $scope.vm.quarterList[0];
        //         } else {
        //             //$scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
        //             $scope.vm.buidSelected = $scope.vm.quarterList[0];
        //         }
        //     }, function (error) { });
        // }

        init();
    }
    angular.module('xrmApp').service('drugReplaceService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'drugReplace';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("drugReplaceListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'drugReplaceService', drugReplaceListController]);
})();
'use strict';

//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Mona Xia
//* 创建时间 :2016-11-25
//* 说明     :门店药品促销情况统计
//******************************************************************
(function () {
    'use strict';

    function drugSalePolicyListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                _initYmSelected();
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sDate });
            _that.searchList.push({ Type: 1, Key: "eDate", Value: $scope.vm.eDate });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected ? $scope.vm.buidSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "depId", Value: $scope.vm.bigDepSelected ? $scope.vm.bigDepSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "province", Value: provinceids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = [];
            $scope.selectedTabId = "tab2";
            $scope.selectTab = _selectTab;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.tableMaxHeight = 100;
            $scope.vm.search = function () {
                _search().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllBuid();
            _initYmSelected();
        }

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sDate = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.eDate = moment().format('YYYY-MM-DD');
        }
        //切换tab
        function _selectTab(id) {
            $scope.selectedTabId = id;
            _showData();
        }
        function _showData() {
            var t = $scope.selectedTabId;
            $scope.vm.pageIndex = 1;
            $scope.vm.dataTable = [];
            switch (t) {
                case "tab1":
                    ;break;
                case "tab2":
                    ;break;
            }
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _search() {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                return rt.errorMessage("请输入开始时间或结束时间");
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }

            var waiting = rt.showLoading2();
            var url = "api/DrugSalePolicy/DrugSalePolicyRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + $scope.vm.bigDepSelected.id + "&provinceId=" + provinceids + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.pageIndex;
            return rt.get(url).then(function (resp) {
                $scope.vm.dataTable = resp.data.DataList;
                $scope.vm.dataTable.forEach(function (row) {
                    $scope.vm.polictList = [];
                    // 这里判断==true不可省略，值为"0"也可以进if子句
                    if (row.RCH == true) {
                        $scope.vm.polictList.push("降价");
                    }
                    if (row.gift == true) {
                        $scope.vm.polictList.push("赠品&礼品");
                    }
                    if (row.terminatBack == true) {
                        $scope.vm.polictList.push("终端返点");
                    }
                    if (row.terminatAgio == true) {
                        $scope.vm.polictList.push("终端折扣");
                    }
                    if (row.memberSales == true) {
                        $scope.vm.polictList.push("会员促销");
                    }
                    if (row.felicitateSales == true) {
                        $scope.vm.polictList.push("店庆促销");
                    }
                    if (row.other == true) {
                        $scope.vm.polictList.push("其他");
                    }
                    row.policies = $scope.vm.polictList.join("，");
                }, this);
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            } else {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = { id: '', name: "全部业务线/大区/大区" };
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
            $scope.vm.businessUnitList = [];
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                } else {
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        init();
    }
    angular.module('xrmApp').service('drugSalePolicyService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DrugSalePolicy';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("drugSalePolicyListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'drugSalePolicyService', drugSalePolicyListController]);
})();
'use strict';

//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Gale Ge
//* 创建时间 :2016-11-25
//* 说明     :门店缺损统计
//******************************************************************
(function () {
    'use strict';

    function drugstoreDefectstatisticsListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                _initYmSelected();
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sDate });
            _that.searchList.push({ Type: 1, Key: "eDate", Value: $scope.vm.eDate });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected ? $scope.vm.buidSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "depId", Value: $scope.vm.bigDepSelected ? $scope.vm.bigDepSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "province", Value: provinceids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = [];
            $scope.selectedTabId = "tab2";
            $scope.selectTab = _selectTab;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.tableMaxHeight = 100;
            $scope.vm.search = function () {
                _search().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllBuid();
            _initYmSelected();
        }

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sDate = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.eDate = moment().format('YYYY-MM-DD');
        }
        //切换tab
        function _selectTab(id) {
            $scope.selectedTabId = id;
            _showData();
        }
        function _showData() {
            var t = $scope.selectedTabId;
            $scope.vm.pageIndex = 1;
            $scope.vm.dataTable = [];
            switch (t) {
                case "tab1":
                    ;break;
                case "tab2":
                    ;break;
            }
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _search() {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                return rt.errorMessage("请输入开始时间或结束时间");
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }

            var waiting = rt.showLoading2();
            var url = "api/DrugStoreDefectStatistics/DrugStoreDefectStatisticsRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + $scope.vm.bigDepSelected.id + "&provinceId=" + provinceids + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.pageIndex;
            return rt.get(url).then(function (resp) {
                $scope.vm.dataTable = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            } else {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = { id: '', name: "全部业务线/大区/大区" };
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
            $scope.vm.businessUnitList = [];
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                } else {
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        init();
    }
    angular.module('xrmApp').service('drugstoreDefectstatisticsService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'drugstoreDefectstatistics';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("drugstoreDefectstatisticsListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'drugstoreDefectstatisticsService', drugstoreDefectstatisticsListController]);
})();
'use strict';

//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Gale Ge
//* 创建时间 :2016-11-25
//* 说明     :门店陈列统计
//******************************************************************
(function () {
    'use strict';

    function drugstoreDisplaystatisticsListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                _initYmSelected();
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sDate });
            _that.searchList.push({ Type: 1, Key: "eDate", Value: $scope.vm.eDate });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected ? $scope.vm.buidSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "depId", Value: $scope.vm.bigDepSelected ? $scope.vm.bigDepSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "province", Value: provinceids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = [];
            $scope.selectedTabId = "tab2";
            $scope.selectTab = _selectTab;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.tableMaxHeight = 100;
            $scope.vm.search = function () {
                _search().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllBuid();
            _initYmSelected();
        }

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sDate = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.eDate = moment().format('YYYY-MM-DD');
        }
        //切换tab
        function _selectTab(id) {
            $scope.selectedTabId = id;
            _showData();
        }
        function _showData() {
            var t = $scope.selectedTabId;
            $scope.vm.pageIndex = 1;
            $scope.vm.dataTable = [];
            switch (t) {
                case "tab1":
                    ;break;
                case "tab2":
                    ;break;
            }
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _search() {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                return rt.errorMessage("请输入开始时间或结束时间");
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }

            var waiting = rt.showLoading2();
            var url = "api/DrugStoreDisplayStatistics/DrugStoreDisplayStatisticsRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + $scope.vm.bigDepSelected.id + "&provinceId=" + provinceids + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.pageIndex;
            return rt.get(url).then(function (resp) {
                $scope.vm.dataTable = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            } else {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = { id: '', name: "全部业务线/大区/大区" };
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
            $scope.vm.businessUnitList = [];
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                } else {
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        init();
    }
    angular.module('xrmApp').service('drugstoreDisplaystatisticsService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'drugstoreDisplaystatistics';
        // @@ 选项集
        this.picklists = ['display_surface'];
    }]);
    angular.module('xrmApp').controller("drugstoreDisplaystatisticsListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'drugstoreDisplaystatisticsService', drugstoreDisplaystatisticsListController]);
})();
'use strict';

//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Ludwig Dong
//* 创建时间 :2016-11-21
//* 说明     :门店进销存统计
//******************************************************************
(function () {
    'use strict';

    function drugstorePSIstatisticsListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                _initYmSelected();
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sDate });
            _that.searchList.push({ Type: 1, Key: "eDate", Value: $scope.vm.eDate });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected ? $scope.vm.buidSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "depId", Value: $scope.vm.bigDepSelected ? $scope.vm.bigDepSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "province", Value: provinceids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = [];
            $scope.selectedTabId = "tab2";
            $scope.selectTab = _selectTab;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.tableMaxHeight = 100;
            $scope.vm.search = function () {
                _search().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllBuid();
            _initYmSelected();
        }

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sDate = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.eDate = moment().format('YYYY-MM-DD');
        }
        //切换tab
        function _selectTab(id) {
            $scope.selectedTabId = id;
            _showData();
        }
        function _showData() {
            var t = $scope.selectedTabId;
            $scope.vm.pageIndex = 1;
            $scope.vm.dataTable = [];
            switch (t) {
                case "tab1":
                    ;break;
                case "tab2":
                    ;break;
            }
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _search() {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                return rt.errorMessage("请输入开始时间或结束时间");
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }

            var waiting = rt.showLoading2();
            var url = "api/drugstorePSIstatistics/drugstorePSIstatisticsRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + $scope.vm.bigDepSelected.id + "&provinceId=" + provinceids + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.pageIndex;
            return rt.get(url).then(function (resp) {
                $scope.vm.dataTable = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            } else {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = { id: '', name: "全部业务线/大区/大区" };
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
            $scope.vm.businessUnitList = [];
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                } else {
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        init();
    }
    angular.module('xrmApp').service('drugstorePSIstatisticsService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'drugstorePSIstatistics';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("drugstorePSIstatisticsListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'drugstorePSIstatisticsService', drugstorePSIstatisticsListController]);
})();
'use strict';

//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Gale Ge
//* 创建时间 :2016-11-25
//* 说明     :门店缺货统计
//******************************************************************
(function () {
    'use strict';

    function drugstoreStockoutstatisticsListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                _initYmSelected();
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sDate });
            _that.searchList.push({ Type: 1, Key: "eDate", Value: $scope.vm.eDate });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected ? $scope.vm.buidSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "depId", Value: $scope.vm.bigDepSelected ? $scope.vm.bigDepSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "province", Value: provinceids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = [];
            $scope.selectedTabId = "tab2";
            $scope.selectTab = _selectTab;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.tableMaxHeight = 100;
            $scope.vm.search = function () {
                _search().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllBuid();
            _initYmSelected();
        }

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sDate = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.eDate = moment().format('YYYY-MM-DD');
        }
        //切换tab
        function _selectTab(id) {
            $scope.selectedTabId = id;
            _showData();
        }
        function _showData() {
            var t = $scope.selectedTabId;
            $scope.vm.pageIndex = 1;
            $scope.vm.dataTable = [];
            switch (t) {
                case "tab1":
                    ;break;
                case "tab2":
                    ;break;
            }
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _search() {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                return rt.errorMessage("请输入开始时间或结束时间");
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }

            var waiting = rt.showLoading2();
            var url = "api/DrugStoreStockoutStatistics/DrugStoreStockoutStatisticsRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + $scope.vm.bigDepSelected.id + "&provinceId=" + provinceids + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.pageIndex;
            return rt.get(url).then(function (resp) {
                $scope.vm.dataTable = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            } else {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = { id: '', name: "全部业务线/大区/大区" };
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
            $scope.vm.businessUnitList = [];
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                } else {
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        init();
    }
    angular.module('xrmApp').service('drugstoreStockoutstatisticsService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'drugstoreStockoutstatistics';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("drugstoreStockoutstatisticsListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'drugstoreStockoutstatisticsService', drugstoreStockoutstatisticsListController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017/06/06
 说明     : 报表 - 门店拜访明细查询
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('drugstorevisitService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'drugstorePSIstatistics';

        this.getAccountLevel = function () {
            var url = "api/SystemParam/GetSystemParamByCode?code=account_level";
            return rt.get(url);
        };
    }]).controller("drugstorevisitListController", ['$scope', '$compile', 'rt', '$injector', 'drugstorevisitService', drugstorevisitListController]);
    function drugstorevisitListController($scope, $compile, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return;
            }
            var unitids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate) && rt.isNullOrWhiteSpace($scope.vm.Ym)) {
                _initYmSelected();
            }
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
                // unitids = "'" + unitmap.join("','") + "'";
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var accountId = rt.isNull($scope.vm.accountId) ? "" : $scope.vm.accountId.Id;
            var userId = rt.isNull($scope.vm.userId) ? "" : $scope.vm.userId.Id;
            var accLevel = rt.isNull($scope.vm.accLevelSelected) ? "" : $scope.vm.accLevelSelected.Value;
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "Ym", Value: $scope.vm.Ym });
            _that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sDate });
            _that.searchList.push({ Type: 1, Key: "eDate", Value: $scope.vm.eDate });
            _that.searchList.push({ Type: 1, Key: "buId", Value: buId });
            _that.searchList.push({ Type: 1, Key: "bigDepId", Value: bigUnitId });
            _that.searchList.push({ Type: 1, Key: "businessUnitId", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "accountId", Value: accountId });
            _that.searchList.push({ Type: 1, Key: "userId", Value: userId });
            _that.searchList.push({ Type: 1, Key: "accLevel", Value: accLevel });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();

        function init() {
            $scope.vm.buidList = [];
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.accSelected = null;
            $scope.vm.accLevelSelected = { Name: '', Value: '' };
            $scope.vm.index = 1;
            $scope.vm.isShow = 'psi';
            $scope.vm.pageSize = rt.getPaginationSize();
            _loadPicklist();
            //查询
            $scope.vm.showReport = function () {
                if ($scope.vm.isShow == 'psi') {
                    _getReportPsiData();
                }
                if ($scope.vm.isShow == 'productdisplay') {
                    _getReportProductDisplayData();
                }
                if ($scope.vm.isShow == 'salepolicy') {
                    _getReportSalepolicyData();
                }
                if ($scope.vm.isShow == 'competing') {
                    _getReportCompetingData();
                }
                if ($scope.vm.isShow == 'expired') {
                    _getReportExpiredData();
                }
                if ($scope.vm.isShow == 'stockout') {
                    _getReportStockoutData();
                }
                if ($scope.vm.isShow == 'defect') {
                    _getReportDefectData();
                }
                if ($scope.vm.isShow == 'promotion') {
                    _getReportPromotionData();
                }
                if ($scope.vm.isShow == 'visitvividcheck') {
                    _getReportVividCheckData();
                }
                if ($scope.vm.isShow == 'barcode') {
                    _getReportBarCodeData();
                }
            };

            //查询按钮
            $scope.vm.showReportButton = function () {
                var msg = _checkOption();
                if (!rt.isNullOrWhiteSpace(msg)) {
                    rt.errorMessage(msg);
                    return;
                } else {
                    $scope.vm.index = 1;
                    _getReportProductDisplayData();
                    _getReportPsiData();
                    _getReportSalepolicyData();
                    _getReportCompetingData();
                    _getReportExpiredData();
                    _getReportStockoutData();
                    _getReportDefectData();
                    _getReportPromotionData();
                    _getReportVividCheckData();
                    _getReportBarCodeData();
                }
            };

            _getAllBuid();
            _initYmSelected();
        }

        //加载选项集
        function _loadPicklist() {
            myService.getAccountLevel().then(function (resp) {
                $scope.vm.account_level = resp.data;
            });
        }

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.Ym = d.getFullYear() + "-" + (d.getMonth() + 1);
            $scope.vm.sDate = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.eDate = moment().format('YYYY-MM-DD');
        }

        //切换tab
        $scope.selectTab = function (id) {
            $scope.vm.index = 1;
            switch (id) {
                case 'tab1':
                    $scope.vm.isShow = 'psi';
                    break;
                case 'tab2':
                    $scope.vm.isShow = 'productdisplay';
                    break;
                case 'tab3':
                    $scope.vm.isShow = 'salepolicy';
                    break;
                case 'tab4':
                    $scope.vm.isShow = 'competing';
                    break;
                case 'tab5':
                    $scope.vm.isShow = 'expired';
                    break;
                case 'tab6':
                    $scope.vm.isShow = 'stockout';
                    break;
                case 'tab7':
                    $scope.vm.isShow = 'defect';
                    break;
                case 'tab8':
                    $scope.vm.isShow = 'promotion';
                    break;
                case 'tab9':
                    $scope.vm.isShow = 'visitvividcheck';
                    break;
                case 'tab10':
                    $scope.vm.isShow = 'barcode';
                    break;
            }
        };

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            });
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function () {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        //获取浏览图片
        $scope.vm.actions.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };

        //条件检查
        function _checkOption() {
            //组合条件
            if (rt.isNullOrWhiteSpace($scope.vm.Ym)) {
                return "请填写年月";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.sDate)) {
                return "请填写开始时间";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                return "请填写结束时间";
            }
            if (moment($scope.vm.sDate).toDate() > moment($scope.vm.eDate).toDate()) {
                return "开始时间不能大于结束时间";
            }
            return "";
        }

        //进销存采集
        function _getReportPsiData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var accountId = rt.isNull($scope.vm.accountId) ? "" : $scope.vm.accountId.Id;
            var userId = rt.isNull($scope.vm.userId) ? "" : $scope.vm.userId.Id;
            var accLevel = rt.isNull($scope.vm.accLevelSelected) ? "" : $scope.vm.accLevelSelected.Value;

            var waiting = rt.showLoading2();
            var url = "api/drugstorePSIstatistics/DrugstorePSIstatisticsRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + bigUnitId + "&provinceId=" + unitids + "&accountId=" + accountId + "&userId=" + userId + "&acclevel=" + accLevel + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.index;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportPsiData = resp.data.DataList;
                $scope.vm.recordPsiCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        //陈列检查
        function _getReportProductDisplayData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var accountId = rt.isNull($scope.vm.accountId) ? "" : $scope.vm.accountId.Id;
            var userId = rt.isNull($scope.vm.userId) ? "" : $scope.vm.userId.Id;
            var accLevel = rt.isNull($scope.vm.accLevelSelected) ? "" : $scope.vm.accLevelSelected.Value;

            var waiting = rt.showLoading2();
            var url = "api/DrugStoreDisplayStatistics/DrugStoreDisplayStatisticsRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + bigUnitId + "&provinceId=" + unitids + "&accountId=" + accountId + "&userId=" + userId + "&acclevel=" + accLevel + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.index;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportProductDisplayData = resp.data.DataList;
                $scope.vm.recordProductDisplayCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        //生动化检查
        function _getReportVividCheckData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var accountId = rt.isNull($scope.vm.accountId) ? "" : $scope.vm.accountId.Id;
            var userId = rt.isNull($scope.vm.userId) ? "" : $scope.vm.userId.Id;
            var accLevel = rt.isNull($scope.vm.accLevelSelected) ? "" : $scope.vm.accLevelSelected.Value;

            var waiting = rt.showLoading2();
            var url = "api/VisitVividCheckReport/GetVividCheckReport?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&bigDepId=" + bigUnitId + "&businessUnitId=" + unitids + "&accountId=" + accountId + "&userId=" + userId + "&acclevel=" + accLevel + "&pageIndex=" + $scope.vm.index + "&pageSize=" + $scope.vm.pageSize;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportVividCheckData = resp.data.DataList;
                $scope.vm.recordVividCheckCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        //促销政策
        function _getReportSalepolicyData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var accountId = rt.isNull($scope.vm.accountId) ? "" : $scope.vm.accountId.Id;
            var userId = rt.isNull($scope.vm.userId) ? "" : $scope.vm.userId.Id;
            var accLevel = rt.isNull($scope.vm.accLevelSelected) ? "" : $scope.vm.accLevelSelected.Value;

            var waiting = rt.showLoading2();
            var url = "api/DrugSalePolicy/DrugSalePolicyRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + bigUnitId + "&provinceId=" + unitids + "&accountId=" + accountId + "&userId=" + userId + "&acclevel=" + accLevel + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.index;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportSalepolicyData = resp.data.DataList;
                $scope.vm.reportSalepolicyData.forEach(function (row) {
                    $scope.vm.polictList = [];
                    // 这里判断==true不可省略，值为"0"也可以进if子句
                    if (row.RCH == true) {
                        $scope.vm.polictList.push("降价");
                    }
                    if (row.gift == true) {
                        $scope.vm.polictList.push("赠品&礼品");
                    }
                    if (row.terminatBack == true) {
                        $scope.vm.polictList.push("终端返点");
                    }
                    if (row.terminatAgio == true) {
                        $scope.vm.polictList.push("终端折扣");
                    }
                    if (row.memberSales == true) {
                        $scope.vm.polictList.push("会员促销");
                    }
                    if (row.felicitateSales == true) {
                        $scope.vm.polictList.push("店庆促销");
                    }
                    if (row.other == true) {
                        $scope.vm.polictList.push("其他");
                    }
                    row.policies = $scope.vm.polictList.join("，");
                }, this);
                $scope.vm.recordSalepolicyCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        //竞品采集
        function _getReportCompetingData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var accountId = rt.isNull($scope.vm.accountId) ? "" : $scope.vm.accountId.Id;
            var userId = rt.isNull($scope.vm.userId) ? "" : $scope.vm.userId.Id;
            var accLevel = rt.isNull($scope.vm.accLevelSelected) ? "" : $scope.vm.accLevelSelected.Value;

            var waiting = rt.showLoading2();
            var url = "api/VisitCompeting/VisitCompetingProductRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + bigUnitId + "&provinceId=" + unitids + "&accountId=" + accountId + "&userId=" + userId + "&acclevel=" + accLevel + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.index;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportCompetingData = resp.data.DataList;
                $scope.vm.recordCompetingCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        //临逾期上报
        function _getReportExpiredData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var accountId = rt.isNull($scope.vm.accountId) ? "" : $scope.vm.accountId.Id;
            var userId = rt.isNull($scope.vm.userId) ? "" : $scope.vm.userId.Id;
            var accLevel = rt.isNull($scope.vm.accLevelSelected) ? "" : $scope.vm.accLevelSelected.Value;
            var waiting = rt.showLoading2();
            var url = "api/VisitexpiredProduct/VisitexpiredProductRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + bigUnitId + "&provinceId=" + unitids + "&accountId=" + accountId + "&userId=" + userId + "&acclevel=" + accLevel + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.index;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportExpiredData = resp.data.DataList;
                $scope.vm.recordExpiredCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        //缺货上报
        function _getReportStockoutData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var accountId = rt.isNull($scope.vm.accountId) ? "" : $scope.vm.accountId.Id;
            var userId = rt.isNull($scope.vm.userId) ? "" : $scope.vm.userId.Id;
            var accLevel = rt.isNull($scope.vm.accLevelSelected) ? "" : $scope.vm.accLevelSelected.Value;
            var waiting = rt.showLoading2();
            var url = "api/DrugStoreStockoutStatistics/DrugStoreStockoutStatisticsRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + bigUnitId + "&provinceId=" + unitids + "&accountId=" + accountId + "&userId=" + userId + "&acclevel=" + accLevel + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.index;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportStockoutData = resp.data.DataList;
                $scope.vm.recordStockoutCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        //缺损上报
        function _getReportDefectData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join("','");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var accountId = rt.isNull($scope.vm.accountId) ? "" : $scope.vm.accountId.Id;
            var userId = rt.isNull($scope.vm.userId) ? "" : $scope.vm.userId.Id;
            var accLevel = rt.isNull($scope.vm.accLevelSelected) ? "" : $scope.vm.accLevelSelected.Value;
            var waiting = rt.showLoading2();
            var url = "api/DrugStoreDefectStatistics/DrugStoreDefectStatisticsRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + bigUnitId + "&provinceId=" + unitids + "&accountId=" + accountId + "&userId=" + userId + "&acclevel=" + accLevel + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.index;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportDefectData = resp.data.DataList;
                $scope.vm.recordDefectCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        //促销执行
        function _getReportPromotionData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var accountId = rt.isNull($scope.vm.accountId) ? "" : $scope.vm.accountId.Id;
            var userId = rt.isNull($scope.vm.userId) ? "" : $scope.vm.userId.Id;
            var accLevel = rt.isNull($scope.vm.accLevelSelected) ? "" : $scope.vm.accLevelSelected.Value;
            var waiting = rt.showLoading2();
            var url = 'api/PromotionActionStatistics/GetPromotionActionReport?Ym=' + $scope.vm.Ym + "&buId=" + $scope.vm.buidSelected.id + "&bigDepId=" + bigUnitId + "&businessUnitId=" + unitids + "&accountId=" + accountId + "&userId=" + userId + "&acclevel=" + accLevel + "&pageIndex=" + $scope.vm.index + "&pageSize=" + $scope.vm.pageSize;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportPromotionData = resp.data.DataList;
                $scope.vm.recordPromotionCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        //扫码上报
        function _getReportBarCodeData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join("','");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var accountId = rt.isNull($scope.vm.accountId) ? "" : $scope.vm.accountId.Id;
            var userId = rt.isNull($scope.vm.userId) ? "" : $scope.vm.userId.Id;
            var accLevel = rt.isNull($scope.vm.accLevelSelected) ? "" : $scope.vm.accLevelSelected.Value;
            var waiting = rt.showLoading2();
            var url = "api/DrugstoreVisitBarCodeReport/DrugSalePolicyRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + bigUnitId + "&provinceId=" + unitids + "&accountId=" + accountId + "&userId=" + userId + "&acclevel=" + accLevel + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.index;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportBarCodeData = resp.data.DataList;
                $scope.vm.recordBarCodeCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Tonny Huang
 创建时间 : 2018/03/19
 说明     :DTP出库查询
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('DTPOutgoingQueryService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DTPOutgoingQuery';
        this.picklists = [];

        this.GetDTPOutgoingQueryData = function (BusinessUnitIds, accountId, productIds, patientIdName, sDate, eDate, pageSize, pageIndex, orderby) {
            var model = {};
            model.BusinessUnitIds = BusinessUnitIds;
            model.productIds = productIds;
            return rt.post("api/DTPOutgoingQuery/GetDataListView?" + "&accountId=" + accountId + "&patientIdName=" + patientIdName + "&sDate=" + encodeURIComponent(sDate) + "&eDate=" + encodeURIComponent(eDate) + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex + "&orderby=" + orderby, model);
        };
    }]).controller('DTPOutgoingQueryListController', ['$scope', '$injector', 'rt', 'DTPOutgoingQueryService', DTPOutgoingQueryListController]);

    function DTPOutgoingQueryListController($scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];

        this.preExport = function () {

            if (!rt.isNullOrWhiteSpace($scope.vm.sDate) && !rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                var patientIdName = !rt.isNull($scope.vm.patientIdName) ? $scope.vm.patientIdName : "";
                //获取区域Id
                var BusinessUnitIds = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";
                //获取门店Id
                var accountId = !rt.isNull($scope.vm.accountSeleted) ? $scope.vm.accountSeleted : "";
                //获取品种Id            
                var productIds = "";
                if (!rt.isNull($scope.vm.salesRegionProductCategory)) {
                    productIds = $scope.vm.salesRegionProductCategory.map(function (item) {
                        return item.Id;
                    }).join(",");
                }

                if (rt.isNull($scope.vm.oldWay) || rt.isNull($scope.vm.orderby)) {
                    $scope.vm.oldWay = "name";
                    $scope.vm.orderby = " desc";
                }

                //添加搜索条件
                _that.searchList.length = 0;
                _that.searchList.push({
                    Type: 1,
                    Key: "BusinessUnitIds",
                    Value: BusinessUnitIds
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "accountId",
                    Value: accountId
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "productIds",
                    Value: productIds
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "patientIdName",
                    Value: patientIdName
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "sDate",
                    Value: $scope.vm.sDate
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "eDate",
                    Value: $scope.vm.eDate
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "pageSize",
                    Value: $scope.vm.pageSize
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "pageIndex",
                    Value: $scope.vm.pageIndex
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "orderby",
                    Value: $scope.vm.oldWay + $scope.vm.orderby
                });
            } else {
                rt.errorMessage("查询日期不能为空");
                return false;
            }
        };

        $scope.vm = {};
        $scope.vm.page = {};
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init(); //初始化
        function init() {
            $scope.vm.recordCount = 0;
        };

        function _search() {
            _getdate();
        }

        function _getdate() {
            $scope.vm.pageIndex = $scope.vm.page.index;
            $scope.vm.pageSize = rt.getPaginationSize();
            var patientIdName = !rt.isNull($scope.vm.patientIdName) ? $scope.vm.patientIdName : "";
            //获取区域Id
            var BusinessUnitIds = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";
            //获取门店Id
            var accountId = !rt.isNull($scope.vm.accountSeleted) ? $scope.vm.accountSeleted : "";
            //获取品种Id            
            var productIds = "";

            if (!rt.isNull($scope.vm.salesRegionProductCategory)) {
                productIds = $scope.vm.salesRegionProductCategory.map(function (item) {
                    return item.Id;
                }).join(",");
            }

            var sDate = $scope.vm.sDate;
            var eDate = $scope.vm.eDate;
            var orderby = $scope.vm.oldWay + $scope.vm.orderby;
            myService.GetDTPOutgoingQueryData(BusinessUnitIds, accountId, productIds, patientIdName, sDate, eDate, $scope.vm.pageSize, $scope.vm.pageIndex, orderby).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            });
        }

        $scope.vm.search = function () {
            $scope.vm.oldWay = "CreatedOn";
            $scope.vm.orderby = " desc";
            $scope.vm.page.index = 1;
            if (!rt.isNullOrWhiteSpace($scope.vm.sDate) && !rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                _search();
            } else {
                rt.errorMessage("查询日期不能为空");
            }
        };
        $scope.vm.updata = function () {
            if (!rt.isNullOrWhiteSpace($scope.vm.sDate) && !rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                _search();
            } else {
                rt.errorMessage("查询日期不能为空");
            }
        };

        //排序
        $scope.vm.getListWay = function (newWay) {

            if ($scope.vm.oldWay == newWay) {
                if ($scope.vm.orderby == " desc") $scope.vm.orderby = " asc";else {
                    $scope.vm.orderby = " desc";
                }
            } else {
                $scope.vm.oldWay = newWay;
                $scope.vm.orderby = " asc";
            }

            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            // _getdate();
        };
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lecrean Pan
 创建时间 : 2018/03/06
 说明     : DTP进销存(PSI)
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('DTPPSIService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DTPPSI';
        this.picklists = [];

        this.GetDTPPSIData = function (Ym, BusinessUnitIds, accountId, productIds, pageSize, pageIndex) {
            var model = {};
            model.BusinessUnitIds = BusinessUnitIds;
            model.productIds = productIds;
            return rt.post("api/DTPPSI/GetDTPPSIData?Ym=" + Ym + "&accountId=" + accountId + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex, model);
        };
    }]).controller('DTPPSIListController', ['$scope', '$injector', 'rt', 'DTPPSIService', DTPPSIListController]);

    function DTPPSIListController($scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];

        this.preExport = function () {
            //获取区域Id
            var BusinessUnitIds = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";
            //获取门店Id
            var accountId = !rt.isNull($scope.vm.accountSeleted) ? $scope.vm.accountSeleted : "";
            //获取品种Id            
            var productIds = "";
            if (!rt.isNull($scope.vm.salesRegionProductCategory)) {
                productIds = $scope.vm.salesRegionProductCategory.map(function (item) {
                    return item.Id;
                }).join(",");
            }
            //添加搜索条件
            _that.searchList.length = 0;
            _that.searchList.push({
                Type: 1,
                Key: "Ym",
                Value: $scope.vm.Ym
            });
            _that.searchList.push({
                Type: 1,
                Key: "BusinessUnitIds",
                Value: BusinessUnitIds
            });
            _that.searchList.push({
                Type: 1,
                Key: "accountId",
                Value: accountId
            });
            _that.searchList.push({
                Type: 1,
                Key: "productIds",
                Value: productIds
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageSize",
                Value: $scope.vm.pageSize
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageIndex",
                Value: $scope.vm.pageIndex
            });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();
        //初始化
        function init() {
            $scope.vm.Ym = moment().format('YYYY-MM');
            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.getReportData = _getData; //获取报表数据
        }

        function _getData() {
            //获取区域Id
            var BusinessUnitIds = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";
            //获取门店Id
            var accountId = !rt.isNull($scope.vm.accountSeleted) ? $scope.vm.accountSeleted : "";
            //获取品种Id            
            var productIds = "";
            if (!rt.isNull($scope.vm.salesRegionProductCategory)) {
                productIds = $scope.vm.salesRegionProductCategory.map(function (item) {
                    return item.Id;
                }).join(",");
            }
            var waiting = rt.showLoading2();
            myService.GetDTPPSIData($scope.vm.Ym, BusinessUnitIds, accountId, productIds, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            });
        }

        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Lecrean Pan
 创建时间 : 2018/03/05
 说明     : DTP库存查询 
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('DTPStockService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DTPStock';
        this.picklists = [];

        this.GetDTPStockData = function (BusinessUnitIds, accountId, productIds, hasBarCode, pageSize, pageIndex) {
            var model = {};
            model.BusinessUnitIds = BusinessUnitIds;
            model.productIds = productIds;
            return rt.post("api/DTPStock/GetDTPStockData?accountId=" + accountId + "&hasBarCode=" + hasBarCode + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex, model);
        };
    }]).controller('DTPStockListController', ['$scope', '$injector', 'rt', 'DTPStockService', DTPStockListController]);

    function DTPStockListController($scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];

        this.preExport = function () {
            //获取区域Id
            var BusinessUnitIds = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";
            //获取门店Id
            var accountId = !rt.isNull($scope.vm.accountSeleted) ? $scope.vm.accountSeleted : "";
            //获取品种Id            
            var productIds = "";
            if (!rt.isNull($scope.vm.salesRegionProductCategory)) {
                productIds = $scope.vm.salesRegionProductCategory.map(function (item) {
                    return item.Id;
                }).join(",");
            }
            //添加搜索条件
            _that.searchList.length = 0;
            _that.searchList.push({
                Type: 1,
                Key: "BusinessUnitIds",
                Value: BusinessUnitIds
            });
            _that.searchList.push({
                Type: 1,
                Key: "accountId",
                Value: accountId
            });
            _that.searchList.push({
                Type: 1,
                Key: "productIds",
                Value: productIds
            });
            _that.searchList.push({
                Type: 1,
                Key: "hasBarCode",
                Value: $scope.vm.hasBarCode
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageSize",
                Value: $scope.vm.pageSize
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageIndex",
                Value: $scope.vm.pageIndex
            });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();
        //初始化
        function init() {
            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.getReportData = _getData; //获取报表数据
            $scope.vm.hasBarCode = 'false';
            //切换tab,是否有条码
            $scope.selectTab = function (id) {
                $scope.vm.index = 1;
                switch (id) {
                    case 'tab1':
                        $scope.vm.hasBarCode = 'false';
                        break;
                    case 'tab2':
                        $scope.vm.hasBarCode = 'true';
                        break;
                }
                $scope.vm.getReportData();
            };
        }

        function _getData() {
            //获取区域Id
            var BusinessUnitIds = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";
            //获取门店Id
            var accountId = !rt.isNull($scope.vm.accountSeleted) ? $scope.vm.accountSeleted : "";
            //获取品种Id            
            var productIds = "";
            if (!rt.isNull($scope.vm.salesRegionProductCategory)) {
                productIds = $scope.vm.salesRegionProductCategory.map(function (item) {
                    return item.Id;
                }).join(",");
            }
            var hasBarCode = $scope.vm.hasBarCode;
            var waiting = rt.showLoading2();
            myService.GetDTPStockData(BusinessUnitIds, accountId, productIds, hasBarCode, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            });
        }

        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Tonny Huang
 创建时间 : 2018/03/15
 说明     :DTP入库查询
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('DTPStorageQueryService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'DTPStorageQuery';
        this.picklists = [];

        this.GetDTPStorageQueryData = function (BusinessUnitIds, accountId, productIds, sDate, eDate, pageSize, pageIndex, orderby) {
            var model = {};
            model.BusinessUnitIds = BusinessUnitIds;
            model.productIds = productIds;
            return rt.post("api/DTPStorageQuery/GetDataListView?" + "&accountId=" + accountId + "&sDate=" + encodeURIComponent(sDate) + "&eDate=" + encodeURIComponent(eDate) + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex + "&orderby=" + orderby, model);
        };
    }]).controller('DTPStorageQueryListController', ['$scope', '$injector', 'rt', 'DTPStorageQueryService', DTPStorageQueryListController]);

    function DTPStorageQueryListController($scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];

        this.preExport = function () {

            if (!rt.isNullOrWhiteSpace($scope.vm.sDate) && !rt.isNullOrWhiteSpace($scope.vm.eDate)) {

                //获取区域Id
                var BusinessUnitIds = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";
                //获取门店Id
                var accountId = !rt.isNull($scope.vm.accountSeleted) ? $scope.vm.accountSeleted : "";
                //获取品种Id            
                var productIds = "";
                if (!rt.isNull($scope.vm.salesRegionProductCategory)) {
                    productIds = $scope.vm.salesRegionProductCategory.map(function (item) {
                        return item.Id;
                    }).join(",");
                }

                if (rt.isNull($scope.vm.oldWay) || rt.isNull($scope.vm.orderby)) {
                    $scope.vm.oldWay = "name";
                    $scope.vm.orderby = " desc";
                }

                //添加搜索条件
                _that.searchList.length = 0;
                _that.searchList.push({
                    Type: 1,
                    Key: "BusinessUnitIds",
                    Value: BusinessUnitIds
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "accountId",
                    Value: accountId
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "productIds",
                    Value: productIds
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "sDate",
                    Value: $scope.vm.sDate
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "eDate",
                    Value: $scope.vm.eDate
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "pageSize",
                    Value: $scope.vm.pageSize
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "pageIndex",
                    Value: $scope.vm.pageIndex
                });
                _that.searchList.push({
                    Type: 1,
                    Key: "orderby",
                    Value: $scope.vm.oldWay + $scope.vm.orderby
                });
            } else {
                rt.errorMessage("查询日期不能为空");
                return false;
            }
        };

        $scope.vm = {};
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init(); //初始化
        function init() {
            $scope.vm.recordCount = 0;
        };

        function _search() {
            _getdate();
        }

        function _getdate() {
            $scope.vm.pageIndex = $scope.vm.page.index;
            $scope.vm.pageSize = rt.getPaginationSize();

            //获取区域Id
            var BusinessUnitIds = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";
            //获取门店Id
            var accountId = !rt.isNull($scope.vm.accountSeleted) ? $scope.vm.accountSeleted : "";
            //获取品种Id            
            var productIds = "";

            if (!rt.isNull($scope.vm.salesRegionProductCategory)) {
                productIds = $scope.vm.salesRegionProductCategory.map(function (item) {
                    return item.Id;
                }).join(",");
            }

            var sDate = $scope.vm.sDate;
            var eDate = $scope.vm.eDate;
            var orderby = $scope.vm.oldWay + $scope.vm.orderby;
            myService.GetDTPStorageQueryData(BusinessUnitIds, accountId, productIds, sDate, eDate, $scope.vm.pageSize, $scope.vm.pageIndex, orderby).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            });
        }

        $scope.vm.search = function () {
            $scope.vm.oldWay = "CreatedOn";
            $scope.vm.orderby = " desc";
            $scope.vm.page.index = 1;
            if (!rt.isNullOrWhiteSpace($scope.vm.sDate) && !rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                _search();
            } else {
                rt.errorMessage("查询日期不能为空");
            }
        };

        $scope.vm.updata = function () {

            if (!rt.isNullOrWhiteSpace($scope.vm.sDate) && !rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                _search();
            } else {
                rt.errorMessage("查询日期不能为空");
            }
        };

        //排序
        $scope.vm.getListWay = function (newWay) {

            if ($scope.vm.oldWay == newWay) {
                if ($scope.vm.orderby == " desc") $scope.vm.orderby = " asc";else {
                    $scope.vm.orderby = " desc";
                }
            } else {
                $scope.vm.oldWay = newWay;
                $scope.vm.orderby = " asc";
            }

            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            // _getdate();
        };
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2017-01-20
 说明     : 在线考试统计
 ********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('ExamOnlineReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'ExamOnlineReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("ExamOnlineReportController", ['$scope', '$q', 'rt', '$injector', '$timeout', 'ExamOnlineReportService', ExamOnlineReportController]);
    function ExamOnlineReportController($scope, $q, rt, $injector, $timeout, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.startYM });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.endYM });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "searchText", Value: $scope.vm.searchText });
            var unitids = _CalculateUnitids();
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.searchText = "";
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.complateTableheight = _complateTableheight;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.startYM = moment(moment().format('YYYY-MM') + '-01').format('YYYY-MM-DD');
            $scope.vm.endYM = moment($scope.vm.endYM).format('YYYY-MM-DD');
            //查询按钮
            _getAllBuid(); //获取所有事业部
            _complateTableheight();
        }
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        $scope.vm.showReportButton = function () {
            $scope.vm.index = 1;
            $scope.vm.showReport();
        };
        //查询
        $scope.vm.showReport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var unitids = _CalculateUnitids();
            var bigUnitId = $scope.vm.bigDepSelected.id;
            var buId = $scope.vm.buidSelected.id;
            var searchText = $scope.vm.searchText;

            //获取终端热度总拜访数和均拜访数
            _getReportData(buId, bigUnitId, unitids, searchText).then(null, function (message) {
                rt.errorMessage(message);
            });
        };

        //获取终端热度总拜访数和均拜访数
        function _getReportData(buId, bigUnitId, unitids, searchText) {
            var waiting = rt.showLoading2();
            var url = 'api/ExamOnlineReport/GetExamOnlineReportList?sYm=' + encodeURIComponent($scope.vm.startYM) + '&eYm=' + encodeURIComponent($scope.vm.endYM) + '&buId=' + encodeURIComponent(buId) + '&bigDepId=' + encodeURIComponent(bigUnitId) + '&unitIds=' + encodeURIComponent(unitids) + '&searchText=' + encodeURIComponent(searchText) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                }
                $scope.vm.buidList.unshift({ id: "", name: "全部事业部" });
                $scope.vm.buidSelected = $scope.vm.buidList[0];
            }, function (error) {});
        }

        //获取业务线/大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [{ id: '', name: '全部业务线/大区' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    var data = resp.DataList;
                    if (!rt.isNull(data) && data.length > 0) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(data);
                        $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                    }
                    $scope.vm.bigDepList.unshift({ id: '', name: '全部业务线/大区' });
                    $scope.vm.bigDepSelected = { id: '', name: '全部业务线/大区' };
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                return;
            }
            if (oldValue != newValue) {
                getBusinessUnitList($scope.vm.buidSelected.id, $scope.vm.bigDepSelected.id);
            }
        });
        //获取省区地区
        function getBusinessUnitList(buId, bigDepId) {
            rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                '@queryValue': '',
                '@ParentBusinessUnitId': bigDepId,
                '@businesstype': 10
            }, function (resp) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                var data = resp.DataList;
                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.businessUnitList = data;
                }
            }, function (error) {
                $scope.vm.businessUnitList = [];
            });
        }
        //条件检查
        function _checkOption() {

            if (rt.isNullOrWhiteSpace($scope.vm.startYM)) {
                return "开始时间不能为空";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.endYM)) {
                return "结束时间不能为空";
            }

            if (_CalculateDays($scope.vm.startYM, $scope.vm.endYM) < 0) {
                return "参数异常[开始日期必须小于等于结束日期.]";
            }
        }

        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            return unitids;
        }
        init();
    }
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Berry Ding
//* 创建时间 :2016-01-21
//* 说明     :基础-窜货明细查询
//******************************************************************
// #endregion

(function () {
    'use strict';

    function fleeinggoodsdetailController($scope, $q, rt) {
        function init() {
            $scope.vm = {};
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;

            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            $scope.vm.showReport = function () {
                _getReportData().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };

            _getAllProduct();
            _getCuanWay();
            _getAllProvince();
        }
        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }

        function _getCuanWay() {
            $scope.vm.cWayList = [{ Name: '窜入', Value: '1' }, { Name: '窜出', Value: '2' }];
            $scope.vm.cWaySelected = null;
        }
        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        //获取省份
        function _getAllProvince() {
            var url = 'api/AlijkProvince/GetAllProvince';
            return rt.get(url).then(function (resp) {
                $scope.vm.provinceList = resp.data;
                $scope.vm.provinceSelected = null;
            });
        }
        function _getReportData() {
            if (rt.isNullOrWhiteSpace($scope.vm.startYM)) {
                var deferred = $q.defer();
                deferred.reject("开始年月不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endYM)) {
                var deferred = $q.defer();
                deferred.reject("结束年月不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.cWaySelected)) {
                var deferred = $q.defer();
                deferred.reject("窜入/窜出不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.productSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.provinceSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的省份不能为空。");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startYM, $scope.vm.endYM) < 0) {
                var deferred = $q.defer();
                deferred.reject("参数异常[开始日期必须小于等于结束日期.]");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startYM, $scope.vm.endYM) >= 365) {
                var deferred = $q.defer();
                deferred.reject("参数异常[日期区间最大为12个月.]");
                return deferred.promise;
            }

            var waiting = rt.showLoading2();
            var url;
            if ($scope.vm.cWaySelected.Value == '1') {
                url = 'api/AlijkGetEntCrossInSaleByDis/GetEntCrossInSaleByDisList?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&startYm=' + encodeURIComponent($scope.vm.startYM) + '&endYm=' + encodeURIComponent($scope.vm.endYM) + '&toProvCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
                return rt.get(url).then(function (resp) {
                    $scope.vm.reportData = resp.data.GetEntCrossInSaleByDisList;
                    $scope.vm.recordCount = resp.data.TotalRecordCount;
                    waiting.close();
                }, function () {
                    waiting.close();
                });
            } else {
                url = 'api/AlijkGetEntCrossOutSaleByDis/GetEntCrossOutSaleByDisList?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&startYm=' + encodeURIComponent($scope.vm.startYM) + '&endYm=' + encodeURIComponent($scope.vm.endYM) + '&fromProvCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
                return rt.get(url).then(function (resp) {
                    $scope.vm.reportData = resp.data.GetEntCrossOutSaleByDisList;
                    $scope.vm.recordCount = resp.data.TotalRecordCount;
                    waiting.close();
                }, function () {
                    waiting.close();
                });
            }
        }
        init();
    }

    angular.module('xrmApp').controller("fleeinggoodsdetailController", ['$scope', '$q', 'rt', fleeinggoodsdetailController]);
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
//* 创建人   :oscargao
//* 创建时间 :2016-01-13
//* 说明     :省份窜货分析
//******************************************************************
// #endregion

(function () {
	'use strict';

	function GetFleeingDatasController($scope, $q, rt) {
		function init() {
			var cw = document.documentElement.clientWidth || document.body.clientWidth;
			$scope.chartWidth = cw - 50;
			$scope.selectedTabId = "tab1";
			$scope.vm = {};
			$scope.vm.reportData = [];
			$scope.vm.pageIndex = 1;
			$scope.vm.pageSize = rt.getPaginationSize();
			$scope.vm.getCrossDataByPage = _getCrossDataByPage; //获取分页
			$scope.vm.showReport = function () {
				_getReportData().then(_show, function (message) {
					rt.errorMessage(message);
				});
			};
			_getAllProduct();
			_getCuanWay();
			_getAllProvince();
			$scope.selectTab = _selectTab;
		}
		//获取窜入数据分页
		function _getCrossDataByPage() {
			if (!rt.isNull($scope.vm.cWaySelected)) {
				if ($scope.vm.cWaySelected.Value === '1') {
					//窜入
					var url = 'api/AlijkFleeingGoods/GetCrossInDataByPage?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&toProvCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE) + '&startYm=' + encodeURIComponent($scope.vm.startYM) + '&endYm=' + encodeURIComponent($scope.vm.endYM) + '&pageIndex=' + $scope.vm.pageIndex + '&pageSize=' + $scope.vm.pageSize;
					return rt.get(url).then(function (resp) {
						$scope.vm.reportData.TabData = resp.data.TabData;
						$scope.vm.reportData.totalCount = resp.data.totalCount;
					});
				} else {
					var url = 'api/AlijkFleeingGoods/GetEntCrossOutDataByPage?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&fromProvCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE) + '&startYm=' + encodeURIComponent($scope.vm.startYM) + '&endYm=' + encodeURIComponent($scope.vm.endYM) + '&pageIndex=' + $scope.vm.pageIndex + '&pageSize=' + $scope.vm.pageSize;
					return rt.get(url).then(function (resp) {
						$scope.vm.reportData.TabData = resp.data.TabData;
						$scope.vm.reportData.totalCount = resp.data.totalCount;
					});
				}
				$scope.$apply();
			}
		}
		function _selectTab(id) {
			$scope.selectedTabId = id;
			if (id == "tab1") {
				_show();
			} else if (id == "tab2") {
				_show();
			}
			_getCrossDataByPage();
		}
		function _getAllProduct() {
			var url = 'api/AlijkProduct/GetAllProduct';
			return rt.get(url).then(function (resp) {
				$scope.vm.productList = resp.data;
				$scope.vm.productSelected = null;
			});
		}

		function _getCuanWay() {
			$scope.vm.cWayList = [{ Name: '窜入', Value: '1' }, { Name: '窜出', Value: '2' }];
			$scope.vm.cWaySelected = null;
		}
		//获取省份
		function _getAllProvince() {
			var url = 'api/AlijkProvince/GetAllProvince';
			return rt.get(url).then(function (resp) {
				$scope.vm.provinceList = resp.data;
				$scope.vm.provinceSelected = null;
			});
		}
		function _CalculateDays(startDate, endDate) {
			var sArr = startDate.split("-");
			var eArr = endDate.split("-");
			var sRDate = new Date(sArr[0], sArr[1]);
			var eRDate = new Date(eArr[0], eArr[1]);
			var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
			return result;
		}
		function _getReportData() {
			if (rt.isNullOrWhiteSpace($scope.vm.startYM)) {
				var deferred = $q.defer();
				deferred.reject("开始年月不能为空。");
				return deferred.promise;
			}
			if (rt.isNullOrWhiteSpace($scope.vm.endYM)) {
				var deferred = $q.defer();
				deferred.reject("结束年月不能为空。");
				return deferred.promise;
			}
			if (_CalculateDays($scope.vm.startYM, $scope.vm.endYM) < 0) {
				var deferred = $q.defer();
				deferred.reject("参数异常[开始日期必须小于等于结束日期.]");
				return deferred.promise;
			}
			if (_CalculateDays($scope.vm.startYM, $scope.vm.endYM) >= 365) {
				var deferred = $q.defer();
				deferred.reject("参数异常[日期区间最大为12个月.]");
				return deferred.promise;
			}
			if (rt.isNull($scope.vm.cWaySelected)) {
				var deferred = $q.defer();
				deferred.reject("窜入/窜出不能为空。");
				return deferred.promise;
			}
			if (rt.isNull($scope.vm.productSelected)) {
				var deferred = $q.defer();
				deferred.reject("查询的药品名称不能为空。");
				return deferred.promise;
			}
			if (rt.isNull($scope.vm.provinceSelected)) {
				var deferred = $q.defer();
				deferred.reject("查询的省份不能为空。");
				return deferred.promise;
			}

			var waiting = rt.showLoading2();
			var url;
			if ($scope.vm.cWaySelected.Value == '1') {
				url = 'api/AlijkFleeingGoods/GetEntCrossInSaleByDis?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&toProvCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE) + '&startYm=' + encodeURIComponent($scope.vm.startYM) + '&endYm=' + encodeURIComponent($scope.vm.endYM);
			} else {
				url = 'api/AlijkFleeingGoods/GetEntCrossOutSaleByDis?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&fromProvCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE) + '&startYm=' + encodeURIComponent($scope.vm.startYM) + '&endYm=' + encodeURIComponent($scope.vm.endYM);
			}
			return rt.get(url).then(function (resp) {
				$scope.vm.reportData = resp.data;
				waiting.close();
			}, function () {
				waiting.close();
			});
		}
		function _show() {
			_getCrossDataByPage();

			var myChart = echarts.init(document.getElementById("reportP"), "shine");
			var echartTitle = [];
			var echartData = [];
			var getData = $scope.vm.reportData.ProvData;
			if (!rt.isNull(getData)) {
				for (var i = 0; i < getData.length; i++) {
					echartTitle.push(getData[i].ProvName);
					echartData.push(getData[i].CrossCount);
				}
			}
			var chartB = echarts.init(document.getElementById("reportB"), "shine");
			var titleB = [];
			var dataB = [];
			var getBData = $scope.vm.reportData.EntData;
			if (!rt.isNull(getBData)) {
				for (var i = 0; i < getBData.length; i++) {
					titleB.push(getBData[i].EntInfoName);
					dataB.push(getBData[i].CrossCount);
				}
			}
			var option = {
				title: {
					text: '',
					subtext: '',
					x: 'center'
				},
				tooltip: {
					trigger: 'axis'
				},
				legend: {
					data: ['窜货量']
				},
				calculable: true,
				xAxis: [{
					type: 'value',
					boundaryGap: [0, 0.1]
				}],
				yAxis: [{
					type: 'category',
					data: echartTitle, //各个省份
					axisLabel: {
						interval: 0,
						formatter: function formatter(params) {
							var newParamsName = "";
							var paramsNameNumber = params.length;
							var provideNumber = 6;
							var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
							if (paramsNameNumber > provideNumber) {
								for (var p = 0; p < rowNumber; p++) {
									var tempStr = "";
									var start = p * provideNumber;
									var end = start + provideNumber;
									if (p == rowNumber - 1) {
										tempStr = params.substring(start, paramsNameNumber);
									} else {
										tempStr = params.substring(start, end) + "\n";
									}
									newParamsName += tempStr;
								}
							} else {
								newParamsName = params;
							}
							return newParamsName;
						}
					}
				}],
				series: [{
					name: '窜货量',
					type: 'bar',
					data: echartData, //省份数据
					itemStyle: {
						normal: {
							label: {
								show: true,
								position: 'right',
								formatter: "{c}"
							},
							labelLine: { show: true }
						}
					}
				}]
			};
			//商业option
			var optionB = {
				title: {
					text: '',
					subtext: '',
					x: 'center'
				},
				tooltip: {
					trigger: 'axis'
				},
				legend: {
					data: ['窜货量']
				},
				calculable: true,
				xAxis: [{
					type: 'value',
					boundaryGap: [0, 0.1]
				}],
				yAxis: [{
					type: 'category',
					data: titleB, //各个商业
					axisLabel: {
						interval: 0,
						formatter: function formatter(params) {
							var newParamsName = "";
							var paramsNameNumber = params.length;
							var provideNumber = 6;
							var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
							if (paramsNameNumber > provideNumber) {
								for (var p = 0; p < rowNumber; p++) {
									var tempStr = "";
									var start = p * provideNumber;
									var end = start + provideNumber;
									if (p == rowNumber - 1) {
										tempStr = params.substring(start, paramsNameNumber);
									} else {
										tempStr = params.substring(start, end) + "\n";
									}
									newParamsName += tempStr;
								}
							} else {
								newParamsName = params;
							}
							return newParamsName;
						}
					}
				}],
				series: [{
					name: '窜货量',
					type: 'bar',
					data: dataB, //商业数据
					itemStyle: {
						normal: {
							label: {
								show: true,
								position: 'right',
								formatter: "{c}"
							},
							labelLine: { show: true }
						}
					}
				}]
			};

			myChart.setOption(option);
			chartB.setOption(optionB);
		}
		init();
	}

	angular.module('xrmApp').controller("GetFleeingDatasController", ['$scope', '$q', 'rt', GetFleeingDatasController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Jerry Wu
 创建时间 : 2018-2-26
 说明     :医院费效比分析 
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('hospitalCostEffectivenessService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'hospitalCostEffectiveness';

        //查询区域生动化分析数据
        this.GetHospitalCostEffectiveness = function (sYm, eYm, unitids, accountids, pageSize, pageIndex) {
            return rt.post("api/hospitalCostEffectiveness/GetHospitalCostEffectiveness?sYm=" + sYm + "&eYm=" + eYm + "&accountIds=" + encodeURIComponent(accountids) + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex, unitids);
        };
    }]).controller('hospitalCostEffectivenessController', ['$scope', '$injector', 'rt', 'hospitalCostEffectivenessService', hospitalCostEffectivenessListController]);

    function hospitalCostEffectivenessListController($scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            //检查导出条件
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            //区域(业务部门)Id
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";
            var accountids = "";
            if (!rt.isNull($scope.vm.accSelected)) {
                accountids = $scope.vm.accSelected.Id;
            }
            //添加搜索条件
            _that.searchList.length = 0;
            _that.searchList.push({
                Type: 1,
                Key: "sYm",
                Value: $scope.vm.sYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "eYm",
                Value: $scope.vm.eYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "unitids",
                Value: unitids
            });
            _that.searchList.push({
                Type: 1,
                Key: "accountids",
                Value: accountids
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageSize",
                Value: $scope.vm.pageSize
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageIndex",
                Value: $scope.vm.pageIndex
            });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();
        //初始化
        function init() {
            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.accList = []; //医院下拉
            $scope.vm.accSelected = null; //医院选择
            $scope.vm.recordCount = 0;
            $scope.vm.getReportData = _getData; //获取报表数据
        }

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            return "";
        }
        // //获取查询数据
        function _getData() {
            var msg = _checkOption();
            if (!rt.isNull(msg) && msg.length > 0) {
                rt.errorMessage(msg);
                return;
            }
            var accountids = "";
            if (!rt.isNull($scope.vm.accSelected)) {
                accountids = $scope.vm.accSelected.Id;
            }
            //获取区域Id
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();
            myService.GetHospitalCostEffectiveness($scope.vm.sYm, $scope.vm.eYm, unitids, accountids, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            });
        }
        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-02-27
 说明     : 医院覆盖率分析
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('HospitalCoverageService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'HospitalCoverage';
        // @@ 选项集
        this.picklists = [];
    }]).controller("hospitalcoverageController", ['$scope', 'rt', '$injector', 'HospitalCoverageService', activityController]);
    function activityController($scope, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var proids = rt.isNull($scope.vm.proSelected) ? "" : $scope.vm.proSelected.id;
            var unitids = rt.isNull($scope.vm.priSelected) ? "" : $scope.vm.priSelected.id;
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "yM", Value: moment($scope.vm.yM).format('YYYY-MM') });
            var unitids = _CalculateUnitids(); //省份
            var proids = _CalcuproUnitids(); //药品品类
            _that.searchList.push({ Type: 1, Key: "proIds", Value: proids });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.yM = moment().format('YYYY-MM');

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };
        }

        //获取省医院覆盖
        function _getReportData() {
            var unitids = _CalculateUnitids();
            var proids = _CalcuproUnitids();
            var waiting = rt.showLoading2();
            var url = "api/HospitalCoverage/GetHospitalCoverageData";
            url += "?yM=" + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM'));
            url += "&product_categoryid=" + encodeURIComponent(proids);
            url += "&provinceid=" + encodeURIComponent(unitids);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        //获取所有省份
        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.priSelected)) {
                var unitmap = $scope.vm.priSelected.map(function (item) {
                    return item.Id;
                });
                unitids = unitmap.join(",");
            }
            return unitids;
        }

        //获取所有药品品类
        function _CalcuproUnitids() {
            var proids = "";
            if (!rt.isNull($scope.vm.proSelected)) {
                var promap = $scope.vm.proSelected.map(function (item) {
                    return item.Id;
                });
                proids = promap.join(",");
            }
            return proids;
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-03-03
 说明     : 医院终端占有率分析
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('HospitalShareService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'HospitalShare';
        // @@ 选项集
        this.picklists = [];
    }]).controller("hospitalshareController", ['$scope', 'rt', '$injector', 'HospitalShareService', activityController]);
    function activityController($scope, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            if (rt.isNullOrWhiteSpace($scope.vm.yM)) {
                rt.errorMessage("请选择年份");
                return false;
            }

            var proids = rt.isNull($scope.vm.proSelected) ? "" : $scope.vm.proSelected.Id;
            var unitids = rt.isNull($scope.vm.priSelected) ? "" : $scope.vm.priSelected.id;
            if (rt.isNullOrWhiteSpace(proids)) {
                rt.errorMessage("请选择药品品类");
                return false;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "yM", Value: moment($scope.vm.yM).format('YYYY-MM') });
            var unitids = _CalculateUnitids(); //省份
            // var proids = _CalcuproUnitids();//药品品类
            _that.searchList.push({ Type: 1, Key: "proIds", Value: proids });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.chartWidth = "100%"; //设置图表宽度
            $scope.vm.buidList = [];
            $scope.vm.reportData = [];
            $scope.vm.chartData = []; //图表数据
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.yM = moment().format('YYYY-MM');

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };
        }

        //获取省医院覆盖
        function _getReportData() {
            if (rt.isNullOrWhiteSpace($scope.vm.yM)) {
                rt.errorMessage("请选择年份");
                return false;
            }

            var unitids = _CalculateUnitids();
            var proids = rt.isNull($scope.vm.proSelected) ? "" : $scope.vm.proSelected.Id;
            if (rt.isNullOrWhiteSpace(proids)) {
                rt.errorMessage("请选择药品品类");
                return false;
            }

            //获取图表数据
            var waiting1 = rt.showLoading2();
            var url = 'api/HospitalShare/GetHospitalShareChart?yM=' + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM')) + "&provinceId=" + encodeURIComponent(unitids) + "&product_categoryid=" + encodeURIComponent(proids);
            rt.get(url).then(function (resp) {
                $scope.vm.chartData = resp.data;
                _show();
                waiting1.close();
            }, function (message) {
                rt.errorMessage(message);
            }).finally(function () {
                waiting1.close();
            });

            //获取表格数据
            var waiting = rt.showLoading2();
            var url = "api/HospitalShare/GetHospitalShareData";
            url += "?yM=" + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM'));
            url += "&product_categoryid=" + encodeURIComponent(proids);
            url += "&provinceid=" + encodeURIComponent(unitids);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        //图表
        function _show() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            var echartsX = [];
            var echartsCapacityAmount = [];
            var echartsSaletoTotalPrice = [];
            var echartsShare = [];
            for (var i = 0; i < $scope.vm.chartData.length; i++) {
                echartsX.push($scope.vm.chartData[i].toaccountidName == null ? " " : $scope.vm.chartData[i].toaccountidName);
                echartsCapacityAmount.push($scope.vm.chartData[i].capacity_amount == null ? 0 : $scope.vm.chartData[i].capacity_amount);
                echartsSaletoTotalPrice.push($scope.vm.chartData[i].saleto_total_price == null ? 0 : $scope.vm.chartData[i].saleto_total_price);
                echartsShare.push($scope.vm.chartData[i].share == null ? 0 : $scope.vm.chartData[i].share);
            }

            var option = {
                title: {
                    text: '终端医院产品占有率分析',
                    x: 'center'
                },
                tooltip: {
                    trigger: 'axis',
                    formatter: "{b}<br/>{a0}：{c0}<br/>{a1}：{c1}<br/>{a2}：{c2}%"
                },
                calculable: true,
                legend: {
                    data: ['潜力预估金额（万元）', '实际销售额（万元）', '终端占有率'],
                    y: 'bottom'
                },
                xAxis: [{
                    type: 'category',
                    data: echartsX
                }],
                yAxis: [{
                    type: 'value',
                    name: '金额',
                    axisLabel: {
                        formatter: '{value} '
                    },
                    splitLine: {
                        show: false
                    }
                }, {
                    type: 'value',
                    name: '终端占有率',
                    axisLabel: {
                        formatter: '{value} %'
                    }
                }],
                series: [{
                    name: '潜力预估金额（万元）',
                    type: 'bar',
                    data: echartsCapacityAmount
                }, {
                    name: '实际销售额（万元）',
                    type: 'bar',
                    data: echartsSaletoTotalPrice
                }, {
                    name: '终端占有率',
                    type: 'line',
                    yAxisIndex: 1,
                    data: echartsShare
                }]
            };
            myChart.setOption(option);
        }

        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 90);
        }

        //获取所有省份
        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.priSelected)) {
                var unitmap = $scope.vm.priSelected.map(function (item) {
                    return item.Id;
                });
                unitids = unitmap.join(",");
            }
            return unitids;
        }

        //获取所有药品品类
        // function _CalcuproUnitids() {
        //     var proids = "";
        //     if (!rt.isNull($scope.vm.proSelected)) {
        //         var promap = $scope.vm.proSelected.map(function (item) {
        //             return item.Id;
        //         });
        //         proids = promap.join(",");
        //     }
        //     return proids;
        // }
    }
})();
"use strict";

//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Mona Xia
//* 创建时间 :2017/04/17
//* 说明     :药品重点医院态势
//******************************************************************
(function () {
    'use strict';

    function hospitalSituationListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            // $scope.vm.bigDepList = [];
            // $scope.vm.bigDepSelected = { id: '' };
            // $scope.vm.businessUnitList = [];
            // $scope.vm.businessUnitSelected = [];
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            //$scope.tableMaxHeight = 100;
            $scope.vm.quarterList = [{
                id: "1",
                name: "第一季度"
            }, {
                id: "2",
                name: "第二季度"
            }, {
                id: "3",
                name: "第三季度"
            }, {
                id: "4",
                name: "第四季度"
            }];
            $scope.vm.quarterSelected = $scope.vm.quarterList[0];
            $scope.vm.search = _search;
            //_getAllBuid();
            //_initYmSelected();
        }

        //初始化时间
        // function _initYmSelected() {
        //     var d = new Date();
        //     $scope.vm.sDate = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
        //     $scope.vm.eDate = moment().format('YYYY-MM-DD');
        // }
        // $scope.complateTableheight = function () {
        //     _complateTableheight();
        // };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _search() {
            // var provinceids = '';
            // if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
            //     return rt.errorMessage("请输入开始时间或结束时间");
            // }

            // if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
            //     var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
            //         return item.id;
            //     });
            //     provinceids = "'" + Iprovinceids.join("','") + "'";
            // }

            // var waiting = rt.showWaiting();
            // var url = "api/DrugSalePolicy/DrugSalePolicyRportData?sDate=" + $scope.vm.sDate
            //     + "&eDate=" + $scope.vm.eDate
            //     + "&buId=" + $scope.vm.buidSelected.id
            //     + "&depId=" + $scope.vm.bigDepSelected.id
            //     + "&provinceId=" + provinceids
            //     + "&PageSize=" + $scope.vm.pageSize
            //     + "&PageIndex=" + $scope.vm.pageIndex;
            // return rt.get(url).then(function (resp) {
            //     $scope.vm.dataTable = resp.data.DataList;
            //     $scope.vm.recordCount = resp.data.TotalRecords;
            //     waiting.close();
            //     _complateTableheight();
            // }, function () { waiting.close(); });

            $scope.vm.dataTable = [{
                accountidName: "安徽农业大学校医院",
                perMonthLastYear: 874,
                perMonthThisYear: 1050,
                btpPerMonth: 900
            }, {
                accountidName: "安庆石化医院",
                perMonthLastYear: 700,
                perMonthThisYear: 900,
                btpPerMonth: 850
            }, {
                accountidName: "合肥中医院",
                perMonthLastYear: 600,
                perMonthThisYear: 850,
                btpPerMonth: 780
            }, {
                accountidName: "安徽金色童年儿童医院",
                perMonthLastYear: 930,
                perMonthThisYear: 800,
                btpPerMonth: 750
            }, {
                accountidName: "安徽省中西医结合医院",
                perMonthLastYear: 680,
                perMonthThisYear: 700,
                btpPerMonth: 730
            }, {
                accountidName: "安徽西乡人民医院",
                perMonthLastYear: 800,
                perMonthThisYear: 780,
                btpPerMonth: 750
            }, {
                accountidName: "安庆市第二人民医院",
                perMonthLastYear: 900,
                perMonthThisYear: 700,
                btpPerMonth: 650
            }];
            $scope.vm.dataTable.forEach(function (row) {
                row.growthRate = (row.perMonthThisYear - row.perMonthLastYear) / row.perMonthLastYear * 100;
            }, this);
            $scope.vm.recordCount = $scope.vm.dataTable.length;
            //_complateTableheight();
        }
        //获取商业大区
        // $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
        //     if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
        //         rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
        //             $scope.vm.bigDepList = [];
        //             $scope.vm.bigDepSelected = { id: '' };
        //             $scope.vm.businessUnitSelected = [];
        //             $scope.vm.businessUnitList = [];
        //             var data = resp.DataList;
        //             if (data != null && data.length > 0) {
        //                 $scope.vm.bigDepList = data;
        //             }
        //             $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
        //             $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        //         }, function (error) {
        //             $scope.vm.bigDepList = [];
        //         });
        //     } else {
        //         $scope.vm.bigDepList = [];
        //         $scope.vm.bigDepSelected = { id: '', name: "全部业务线/大区/大区" };
        //         $scope.vm.businessUnitSelected = [];
        //         $scope.vm.businessUnitList = [];
        //     }
        // });
        // //获取省区/地区
        // $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
        //     if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
        //         rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
        //             $scope.vm.businessUnitSelected = [];
        //             $scope.vm.businessUnitList = [];
        //             var data = resp.DataList;
        //             if (data != null && data.length > 0) {
        //                 $scope.vm.businessUnitList = data;
        //             }
        //         }, function (error) {
        //             $scope.vm.businessUnitList = [];
        //         });
        //     }
        //     $scope.vm.businessUnitList = [];
        // });
        // //获取所有事业部
        // function _getAllBuid() {
        //     rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
        //         var data = resp.DataList;
        //         if (data != null && data.length > 0) {
        //             $scope.vm.quarterList = data;
        //             //$scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
        //             $scope.vm.buidSelected = $scope.vm.quarterList[0];
        //         } else {
        //             //$scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
        //             $scope.vm.buidSelected = $scope.vm.quarterList[0];
        //         }
        //     }, function (error) { });
        // }

        init();
    }
    angular.module('xrmApp').service('hospitalSituationService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'hospitalSituation';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("hospitalSituationListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'hospitalSituationService', hospitalSituationListController]);
})();
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Gale Ge
 *创建时间：2017/01/10
 *说明：门店促销执行统计
 *************************************************/
(function () {
    'use strict';

    function imagePreviewController($scope, $q, $compile, $timeout, rt, myService) {

        //获取数据
        function _getData() {
            var waiting = rt.showLoading2();
            var url = 'api/PromotionActionStatistics/GetPhotoData?objectId=' + $scope.rtIncludeParams.obiectId;
            return rt.get(url).then(function (resp) {
                // $scope.data = resp.data;
                $scope.data = [];
                for (var i = 0; i < resp.data.length; i++) {
                    //排除pdf附件
                    if (resp.data[i].FileName.toLowerCase().indexOf(".jpg") > 0 || resp.data[i].FileName.toLowerCase().indexOf(".png") > 0 || resp.data[i].FileName.toLowerCase().indexOf(".jpeg") > 0) {
                        $scope.data.push(resp.data[i]);
                    }
                }
            }).finally(function () {
                waiting.close();
            });
        }

        _getData();
    }
    angular.module('xrmApp').service('imagePreviewService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'imagePreviewService';
        // @@ 选项集
        this.picklists = [];
    }]).controller("imagePreviewController", ['$scope', '$q', '$compile', '$timeout', 'rt', 'imagePreviewService', imagePreviewController]);
})();
'use strict';

//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Mona Xia
//* 创建时间 :2017-03-20
//* 说明     :潜在代理商转换率分析
//******************************************************************
(function () {
    'use strict';

    function leadsConversionRateController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var provinceids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = Iprovinceids.join(",");
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sDate });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected ? $scope.vm.buidSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "bigDeptId", Value: $scope.vm.bigDepSelected ? $scope.vm.bigDepSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "businessUnitId", Value: provinceids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = [];
            $scope.vm.sDate = moment().year().toString();
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.tableMaxHeight = 100;
            $scope.vm.search = function () {
                _search().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllBuid();
        }

        $scope.complateTableheight = function () {
            _complateTableheight();
        };

        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _search() {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate)) {
                return rt.errorMessage("请输入年份");
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = Iprovinceids.join(",");
            }

            var waiting = rt.showLoading2();
            var url = "api/LeadsConversionRate/GetReportData?year=" + $scope.vm.sDate + "&buId=" + $scope.vm.buidSelected.id + "&bigDeptId=" + $scope.vm.bigDepSelected.id + "&businessUnitId=" + provinceids + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize;
            return rt.get(url).then(function (resp) {
                $scope.vm.dataTable = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            } else {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = { id: '', name: "全部业务线/大区/大区" };
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
            $scope.vm.businessUnitList = [];
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                } else {
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        init();
    }
    angular.module('xrmApp').service('leadsConversionRateService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'LeadsConversionRate';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("leadsConversionRateController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'leadsConversionRateService', leadsConversionRateController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Lucifer Wang
 创建时间 : 2017-04-20
 说明     : 积分排行榜
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('MemberPointListService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'MemberPoint';
        // @@ 选项集
        this.picklists = [];
    }]).controller("MemberPointListController", ['$scope', '$q', 'rt', '$injector', 'MemberPointListService', MemberPointListController]);
    function MemberPointListController($scope, $q, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];

        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "type", Value: $scope.selectedTab });
            _that.searchList.push({ Type: 1, Key: "yM", Value: $scope.vm.yM });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            var unitids = _CalculateUnitids();
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.yM = moment().format('YYYY-MM');
            $scope.selectedTab = 'all';

            _getAllBuid();
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                } else {
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
                $scope.vm.ownerIdSelected = null;
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
                $scope.vm.ownerIdSelected = null;
            }
        });

        //查询按钮
        $scope.vm.showReportButton = function () {
            $scope.vm.index = 1;
            $scope.vm.showReport();
        };
        //查询
        $scope.vm.showReport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var unitids = _CalculateUnitids();
            var bigUnitId = $scope.vm.bigDepSelected !== undefined ? $scope.vm.bigDepSelected.id : '';
            var buId = $scope.vm.buidSelected !== undefined ? $scope.vm.buidSelected.id : '';

            //获取终端热度总拜访数和均拜访数
            _getReportData(buId, bigUnitId, unitids).then(null, function (message) {
                rt.errorMessage(message);
            });
        };

        function _getReportData(buId, bigUnitId, unitids) {
            var waiting = rt.showLoading2();
            var url = 'api/MemberPoint/GetRankList?' + 'pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize) + '&type=' + encodeURIComponent($scope.selectedTab) + '&yM=' + encodeURIComponent($scope.vm.yM) + '&buId=' + encodeURIComponent(buId) + '&bigDepId=' + encodeURIComponent(bigUnitId) + '&unitIds=' + encodeURIComponent(unitids);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            return unitids;
        }

        //检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.yM)) {
                return "请选择查询年月.";
            }
            return "";
        }

        //切换tab
        $scope.selectTab = function (type) {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.page.index = 1;
            $scope.selectedTab = type;
            $scope.vm.showReport();
        };
    }
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Berry Ding
//* 创建时间 :2016-01-22
//* 说明     :全国串货分析
//******************************************************************
// #endregion

(function () {
    'use strict';

    function nationalfleeinggoodsController($scope, $q, rt) {
        function init() {
            var cw = document.documentElement.clientWidth || document.body.clientWidth;
            $scope.chartWidth = (cw - 50) * 0.7;
            $scope.vm = {};
            $scope.vm.reportData = [];

            $scope.vm.showReport = function () {
                _getReportData().then(_show, function (message) {
                    rt.errorMessage(message);
                });
            };

            _getinOrOutTypeList();
            _getAllProduct();
        }

        function _getinOrOutTypeList() {
            var data = [{ Name: '窜入', Value: '1' }, { Name: '窜出', Value: '2' }];

            $scope.vm.inOrOutList = data;
            $scope.vm.inOrOutSelected = null;
        }

        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }

        function _CalculateDays() {
            var sDate = $scope.vm.startDate;
            var eDate = $scope.vm.endDate;
            var sArr = sDate.split("-");
            var eArr = eDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        function _getReportData() {
            if (rt.isNull($scope.vm.productSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.inOrOutSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的窜货类型不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的开始年月不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的结束年月不能为空。");
                return deferred.promise;
            }
            if (_CalculateDays() < 0) {
                var deferred = $q.defer();
                deferred.reject("参数异常[开始日期必须小于等于结束日期.]");
                return deferred.promise;
            }
            if (_CalculateDays() >= 365) {
                var deferred = $q.defer();
                deferred.reject("参数异常[日期区间最大为12个月.]");
                return deferred.promise;
            }
            var waiting = rt.showLoading2();
            var url = 'api/AlijkNationalFleeingGoods/GetFleeingDatas?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&inOrOut=' + encodeURIComponent($scope.vm.inOrOutSelected.Value) + '&startYm=' + encodeURIComponent($scope.vm.startDate) + '&endYm=' + encodeURIComponent($scope.vm.endDate);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        function _show() {

            var myChart = echarts.init(document.getElementById("report"), "shine");

            var echartsData = [];
            var getData = $scope.vm.reportData;
            var maxValue = _.max(_.map(getData.MapData, function (o) {
                return o.value;
            }));
            for (var i = 0; i < getData.MapData.length; i++) {
                echartsData.push(getData.MapData[i]);
            }

            $.get('lib/echarts/map/json/china.json', function (chinaJson) {
                echarts.registerMap('china', chinaJson);

                var option = {
                    title: {
                        text: '全国窜货分析',
                        subtext: '',
                        x: 'center'
                    },
                    tooltip: {
                        trigger: 'item'
                    },
                    legend: {
                        orient: 'vertical',
                        x: 'left',
                        data: ['']
                    },
                    dataRange: {
                        min: 0,
                        max: maxValue,
                        x: 'left',
                        y: 'bottom',
                        text: ['高', '低'], // 文本，默认为数值文本
                        calculable: true
                    },
                    roamController: {
                        show: true,
                        x: 'right',
                        mapTypeControl: {
                            'china': true
                        }
                    },
                    series: [{
                        name: '窜货量',
                        type: 'map',
                        mapType: 'china',
                        roam: false,
                        label: {
                            normal: { show: true },
                            emphasis: { show: true }
                        },
                        data: echartsData
                    }]
                };
                myChart.setOption(option);
            });
        }

        init();
    }

    angular.module('xrmApp').controller("nationalfleeinggoodsController", ['$scope', '$q', 'rt', nationalfleeinggoodsController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Tonny Huang
 创建时间 : 2018/03/20
 说明     : 患者信息查询列表
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('PatientInformationService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'PatientInformation';
        this.picklists = [];

        this.GetPatientInformationData = function (name, telephone, pageSize, pageIndex, orderby) {
            return rt.post("api/PatientInformation/GetDataListView?name=" + name + "&telephone=" + telephone + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex + "&orderby=" + orderby);
        };
    }]).controller('PatientInformationListController', ['$rootScope', '$scope', '$injector', 'rt', 'PatientInformationService', PatientInformationListController]);

    function PatientInformationListController($rootScope, $scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];

        this.preExport = function () {

            //获取姓名
            var name = !rt.isNull($scope.vm.name) ? $scope.vm.name : "";
            //获取电话
            var telephone = !rt.isNull($scope.vm.telephone) ? $scope.vm.telephone : "";

            if (rt.isNull($scope.vm.oldWay) || rt.isNull($scope.vm.orderby)) {
                $scope.vm.oldWay = "name";
                $scope.vm.orderby = " desc";
            }

            //添加搜索条件
            _that.searchList.length = 0;
            _that.searchList.push({
                Type: 1,
                Key: "name",
                Value: name
            });
            _that.searchList.push({
                Type: 1,
                Key: "telephone",
                Value: telephone
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageSize",
                Value: $scope.vm.pageSize
            });
            _that.searchList.push({
                Type: 1,
                Key: "pageIndex",
                Value: $scope.vm.pageIndex
            });
            _that.searchList.push({
                Type: 1,
                Key: "orderby",
                Value: $scope.vm.oldWay + $scope.vm.orderby
            });
        };
        $rootScope.patientPageindex = 0;
        $scope.vm = {};
        $scope.vm.oldWay = "name";
        $scope.vm.orderby = " desc";
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init(); //初始化
        function init() {
            $scope.vm.recordCount = 0;
        };

        function _search() {

            _getdate();
        }

        function _getdate() {

            //获取姓名
            var name = !rt.isNull($scope.vm.name) ? $scope.vm.name : "";
            //获取电话
            var telephone = !rt.isNull($scope.vm.telephone) ? $scope.vm.telephone : "";

            if (rt.isNull($scope.vm.oldWay)) {
                var orderby = "name desc";
            } else {
                var orderby = $scope.vm.oldWay + $scope.vm.orderby;
            }

            myService.GetPatientInformationData(name, telephone, $scope.vm.pageSize, $scope.vm.pageIndex, orderby).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            });
        }

        $scope.vm.search = function () {
            $scope.vm.oldWay = "name";
            $scope.vm.orderby = " desc";
            $scope.vm.page.index = 1;
            $scope.vm.pageIndex = $scope.vm.page.index;
            $scope.vm.pageSize = rt.getPaginationSize();
            _search();
        };

        $scope.vm.updata = function () {
            $scope.vm.pageIndex = $scope.vm.page.index;

            if ($rootScope.patientPageindex != 0) {
                $scope.vm.page.size = $rootScope.patientPageindex;
                $scope.vm.pageSize = $rootScope.patientPageindex;
                $rootScope.patientPageindex = 0;
            } else {
                $scope.vm.pageSize = $scope.vm.page.size;
            }

            _search();
        };

        //排序
        $scope.vm.getListWay = function (newWay) {

            if ($scope.vm.oldWay == newWay) {
                if ($scope.vm.orderby == " desc") $scope.vm.orderby = " asc";else {
                    $scope.vm.orderby = " desc";
                }
            } else {
                $scope.vm.oldWay = newWay;
                $scope.vm.orderby = " asc";
            }

            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            // _getdate();
        };

        $scope.vm.getPagesize = function () {
            $rootScope.patientPageindex = rt.getPaginationSize();
        };
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Tonny Huang
 创建时间 : 2018/03/20
 说明     : 患者信息查询只读
 *********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').service('PatientInformationReadonlyService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'PatientInformation';
        this.picklists = [];

        this.GetStorebarCodeOutList = function (patientid, pageSize, pageIndex) {
            var url = "api/PatientInformation/GetStorebarCodeOutList" + "?patientid=" + encodeURIComponent(patientid) + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex;
            return rt.post(url);
        };
    }]).controller('PatientInformationReadonlyController', ['$scope', '$state', '$stateParams', '$injector', 'rt', 'PatientInformationReadonlyService', PatientInformationReadonlyController]);

    function PatientInformationReadonlyController($scope, $state, $stateParams, injector, rt, myService) {
        var rt = myService.rt;
        var $compile = myService.$compile;
        var $stateParams = myService.$stateParams;
        var id = $stateParams.id;
        $scope.vm = {};
        $scope.vm.form = {};
        // $injector.invoke(reportListController, this, {
        //     $scope: $scope,
        //     myService: myService
        // });

        init();

        function init() {
            $scope.vm.hide = _hide;
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            myService.GetStorebarCodeOutList(id, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                $scope.vm.form.data = resp.data.DataList;
                $scope.vm.form.recordCount = resp.data.TotalRecords;
                // $scope.vm.form.data = resp.data;
            });
        }

        $scope.vm.form.updata = function () {
            $scope.vm.pageIndex = $scope.vm.page.index;
            $scope.vm.pageSize = rt.getPaginationSize();
            myService.GetStorebarCodeOutList(id, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                $scope.vm.form.data = resp.data.DataList;
                $scope.vm.form.recordCount = resp.data.TotalRecords;
                // $scope.vm.form.data = resp.data;
            });
        };

        function _hide() {
            $(".sidebar-right").sidebar('hide');
        }
    }
})();
"use strict";

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Gale Ge
 *创建时间：2017/01/10
 *说明：门店促销执行统计
 *************************************************/
(function () {
    'use strict';

    function promotionActionStatisticsController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "Ym", Value: $scope.vm.Ym });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigDepId", Value: $scope.vm.bigDepSelected.id });
            _that.searchList.push({ Type: 1, Key: "businessUnitId", Value: $scope.vm.unitids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        //初始化
        function _init() {
            $scope.vm.unitids = ""; //用','分割的多个省区地区
            $scope.vm.search = _search; //搜索
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.recordCount = 0;
            _getAllBuid();
            _initYmSelected();
        }
        //搜索代表拜访统计(按医生)(佐力)数据
        function _search() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return;
            }
            var waiting = rt.showLoading2();
            var url = 'api/PromotionActionStatistics/GetPromotionActionReport?Ym=' + $scope.vm.Ym + "&buId=" + $scope.vm.buidSelected.id + "&bigDepId=" + $scope.vm.bigDepSelected.id + "&businessUnitId=" + $scope.vm.unitids + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize;
            rt.get(url).then(function (resp) {
                $scope.vm.data = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
            }).finally(function () {
                waiting.close();
            });
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $(".form-horizontal").outerHeight() + $(".navbar-fixed-bottom").outerHeight() + 80);
            }, 0);
        }

        //条件检查
        function _checkOption() {
            //组合条件
            if (rt.isNullOrWhiteSpace($scope.vm.Ym)) {
                return "请填写年月";
            }
            $scope.vm.unitids = _CaculateUnitIds();
            return "";
        }
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }
        //获取业务线大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                $scope.vm.businessUnitSelected = null;
                $scope.vm.businessUnitList = [];
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });
        //获取省区地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNullOrWhiteSpace(newValue)) {
                $scope.vm.businessUnitList = [];return;
            }
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    $scope.vm.businessUnitList = resp.DataList;
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });
        //给年月默认值
        function _initYmSelected() {
            $scope.vm.Ym = moment().format('YYYY-MM');
        }
        //计算省区/地区的id集合
        function _CaculateUnitIds() {
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                return unitmap.join(",");
            }
            return "";
        }

        $scope.vm.actions.showImage = function (obiectId) {
            var relatedHtml = '';
            var html = '<div rt-include rt-template="Module/ReportData/imagePreviewView.html" rt-controller="imagePreviewController" rt-include-params="{obiectId:\'' + obiectId + '\'' + relatedHtml + '}"></div>';
            $scope.vm.dialog = BootstrapDialog.show({
                title: '',
                type: BootstrapDialog.TYPE_DEFAULT,
                message: html,
                size: BootstrapDialog.SIZE_WIDE,
                onshow: function onshow(dialog) {
                    dialog.getModalHeader().hide();
                    dialog.getModalFooter().hide();
                    var obj = dialog.getModalBody().contents();
                    $compile(obj)($scope);
                }
            });
        };
        _init();
    }
    angular.module('xrmApp').service('promotionActionStatisticsService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'PromotionActionStatistics';
        // @@ 选项集
        this.picklists = [];
    }]).controller("promotionActionStatisticsController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'promotionActionStatisticsService', promotionActionStatisticsController]);
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Berry Ding
//* 创建时间 :2016-1-18
//* 说明     :城市纯销排名
//******************************************************************
// #endregion

(function () {
    'use strict';

    angular.module('xrmApp').controller("purevenditionbycityController", ['$scope', '$q', 'rt', purevenditionbycityController]);
    function purevenditionbycityController($scope, $q, rt) {
        init();

        function init() {
            $scope.selectedTabId = "tab1";
            var cw = document.documentElement.clientWidth || document.body.clientWidth;
            $scope.chartWidth = cw * 0.7;
            $scope.vm = {};
            $scope.vm.reportData = [];
            $scope.vm.showReport = function () {

                if ($scope.selectedTabId == "tab1") {
                    _getReportData1().then(_show1, function (message) {
                        rt.errorMessage(message);
                    });
                } else {
                    _getReportData2().then(_show2, function (message) {
                        rt.errorMessage(message);
                    });
                }
            };

            _getAllProvince();
            _getAllDrugNamesByEnt();
            $scope.selectTab = _selectTab;
        }

        function _selectTab(id) {
            $scope.selectedTabId = id;
            if (id == "tab1") {
                _getReportData1().then(_show1, null);
            } else if (id == "tab2") {
                _getReportData2().then(_show2, null);
            }
        }

        function _getAllProvince() {
            var url = 'api/AlijkProvince/GetAllProvince';
            return rt.get(url).then(function (resp) {
                $scope.vm.provinceList = resp.data;
                $scope.vm.provinceSelected = null;
            });
        }
        function _getAllDrugNamesByEnt() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }
        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        //按省份发货排名 获取数据
        function _getReportData1() {
            if (rt.isNull($scope.vm.provinceSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的省份不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.productSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的开始年月不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的结束年月不能为空。");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) < 0) {
                var deferred = $q.defer();
                deferred.reject("参数异常[开始日期必须小于等于结束日期.]");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) >= 365) {
                var deferred = $q.defer();
                deferred.reject("参数异常[日期区间最大为12个月.]");
                return deferred.promise;
            }
            var waiting = rt.showLoading2();
            var url = 'api/AlijkPureVendition/GetEntSaleByCity?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&toprovCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE) + '&sYm=' + encodeURIComponent($scope.vm.startDate) + '&eYm=' + encodeURIComponent($scope.vm.endDate);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData1 = resp.data;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        function _show1() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");

            var echartsDataValue2 = [];
            var echartsDataName2 = [];
            var getData2 = $scope.vm.reportData1;
            for (var i = 0; i < getData2.ChartData.length; i++) {
                echartsDataValue2.push(getData2.ChartData[i].Value);
                echartsDataName2.push(getData2.ChartData[i].Name);
            }

            var option = {
                title: {
                    text: ''
                },
                tooltip: {
                    trigger: 'axis'
                },
                legend: {
                    data: ['销量']
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01]
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName2
                }],
                series: [{
                    name: '销量',
                    type: 'bar',
                    data: echartsDataValue2,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };

            myChart.setOption(option);
        }

        function _getReportData2() {
            if (rt.isNull($scope.vm.provinceSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的省份不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.productSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的开始年月不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的结束年月不能为空。");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) < 0) {
                var deferred = $q.defer();
                deferred.reject("参数异常[开始日期必须小于等于结束日期.]");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) >= 365) {
                var deferred = $q.defer();
                deferred.reject("参数异常[日期区间最大为12个月.]");
                return deferred.promise;
            }
            var waiting = rt.showLoading2();
            var url = 'api/AlijkPureVendition/GetEntTermiSaleByCity?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&toprovCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE) + '&sYm=' + encodeURIComponent($scope.vm.startDate) + '&eYm=' + encodeURIComponent($scope.vm.endDate);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData2 = resp.data;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        function _show2() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            var echartsDataValue = [];
            var echartsDataName = [];
            var getData = $scope.vm.reportData2;
            for (var i = 0; i < getData.ChartData.length; i++) {
                echartsDataValue.push(getData.ChartData[i].Value);
                echartsDataName.push(getData.ChartData[i].Name);
            }

            var option = {
                title: {
                    text: ''
                },
                tooltip: {
                    trigger: 'axis'
                },
                legend: {
                    data: ['销量']
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01]
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName
                }],
                series: [{
                    name: '销量',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };

            myChart.setOption(option);
        }
    }
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Berry Ding
//* 创建时间 :2016-1-18
//* 说明     :省份纯销、省份发货排名
//******************************************************************
// #endregion

(function () {
    'use strict';

    angular.module('xrmApp').controller("purevenditionbyprovController", ['$scope', '$q', 'rt', purevenditionbyprovController]);
    function purevenditionbyprovController($scope, $q, rt) {
        init();

        function init() {
            $scope.selectedTabId = "tab1";
            var cw = document.documentElement.clientWidth || document.body.clientWidth;
            $scope.chartWidth = cw * 0.7;
            $scope.vm = {};
            $scope.vm.reportData1 = [];
            $scope.vm.reportData2 = [];
            $scope.vm.showReport = function () {
                if ($scope.selectedTabId == "tab1") {
                    _getReportData1().then(_show1, function (message) {
                        rt.errorMessage(message);
                    });
                } else if ($scope.selectedTabId == "tab2") {
                    _getReportData2().then(_show2, function (message) {
                        rt.errorMessage(message);
                    });
                }
            };
            $scope.selectTab = _selectTab;
            _getAllDrugNamesByEnt();
        }

        function _selectTab(id) {
            $scope.selectedTabId = id;
            if (id == "tab1") {
                _getReportData1().then(_show1, null);
            } else if (id == "tab2") {
                _getReportData2().then(_show2, null);
            }
        }

        function _getAllDrugNamesByEnt() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }
        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        //按省份发货排名 获取数据
        function _getReportData1() {
            if (rt.isNull($scope.vm.productSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的开始年月不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的结束年月不能为空。");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) < 0) {
                var deferred = $q.defer();
                deferred.reject("参数异常[开始日期必须小于等于结束日期.]");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) >= 365) {
                var deferred = $q.defer();
                deferred.reject("参数异常[日期区间最大为12个月.]");
                return deferred.promise;
            }
            var waiting = rt.showLoading2();
            var url = 'api/AlijkPureVendition/GetEntSaleByProv?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&sYm=' + encodeURIComponent($scope.vm.startDate) + '&eYm=' + encodeURIComponent($scope.vm.endDate);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData1 = resp.data;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        //按省份发货排名 展示数据
        function _show1() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");

            var echartsDataValue2 = [];
            var echartsDataName2 = [];
            var getData2 = $scope.vm.reportData1;
            for (var i = 0; i < getData2.ChartData.length; i++) {
                echartsDataValue2.push(getData2.ChartData[i].Value);
                echartsDataName2.push(getData2.ChartData[i].Name);
            }

            var option = {
                title: {
                    text: ''
                },
                tooltip: {
                    trigger: 'axis'
                },
                legend: {
                    data: ['销量']
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01]
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName2,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '销量',
                    type: 'bar',
                    data: echartsDataValue2,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };

            myChart.setOption(option);
        }

        //按省份纯销排名 获取数据
        function _getReportData2() {
            if (rt.isNull($scope.vm.productSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的开始年月不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的结束年月不能为空。");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) < 0) {
                var deferred = $q.defer();
                deferred.reject("参数异常[开始日期必须小于等于结束日期.]");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) >= 365) {
                var deferred = $q.defer();
                deferred.reject("参数异常[日期区间最大为12个月.]");
                return deferred.promise;
            }
            var waiting = rt.showLoading2();
            var url = 'api/AlijkPureVendition/GetEntTermiSaleByProv?prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&sYm=' + encodeURIComponent($scope.vm.startDate) + '&eYm=' + encodeURIComponent($scope.vm.endDate);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData2 = resp.data;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        //按省份纯销排名 展示数据
        function _show2() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");

            var echartsDataValue1 = [];
            var echartsDataName1 = [];
            var getData1 = $scope.vm.reportData2;
            for (var i = 0; i < getData1.ChartData.length; i++) {
                echartsDataValue1.push(getData1.ChartData[i].Value);
                echartsDataName1.push(getData1.ChartData[i].Name);
            }

            var option = {
                title: {
                    text: ''
                },
                tooltip: {
                    trigger: 'axis'
                },
                legend: {
                    data: ['销量']
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01]
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName1,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 6;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                series: [{
                    name: '销量',
                    type: 'bar',
                    data: echartsDataValue1,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };

            myChart.setOption(option);
        }
    }
})();
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Gale Ge
 *创建时间：2017/08/03
 *说明：显示备注
 *************************************************/
(function () {
    'use strict';

    function remarksPreviewController($scope, rt, myService) {
        $scope.title = $scope.rtIncludeParams.title;
        $scope.remarks = $scope.rtIncludeParams.remarks;
    }
    angular.module('xrmApp').service('remarksPreviewService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'remarksPreviewService';
        // @@ 选项集
        this.picklists = [];
    }]).controller("remarksPreviewController", ['$scope', 'rt', 'imagePreviewService', remarksPreviewController]);
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Joe Song
创建时间 : 2016-04-28
说明     : 系统中所有的报表的统一菜单
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller("reportMenuController", ['$scope', '$q', '$stateParams', 'rt', reportMenuController]);

    function reportMenuController($scope, $q, $stateParams, rt) {
        var _vm = $scope.vm = {};
        var _workSpaceHeight = 0;
        _init();

        function _init() {
            // _vm.isHideMenu = true;
            var ch = document.documentElement.clientHeight || document.body.clientHeight;
            _workSpaceHeight = ch - 82;
            $('#divMenus').css("height", 0);
            $('#divModule').css("height", _workSpaceHeight);
            $('#iframeStartPage').css("height", _workSpaceHeight - 82);

            _vm.url = "";

            // $scope.$watch("vm.isHideMenu",function(){
            //     $('#divMenus').css("height", _workSpaceHeight);
            // });

            $scope.openUrl = _openUrl;
            $scope.showMenu = _showMenu;
            $scope.hideMenu = _hideMenu;

            _loadMenuData();
        }

        function _openUrl(url, name) {
            _vm.url = url;
            _vm.name = name;
            //$('#divMenus').hide(500);
            //_vm.isHideMenu = true;
        }

        function _showMenu() {
            // $('#divMenus').show(500);
            // _vm.isHideMenu = true;
        }

        function _hideMenu() {
            // $('#divMenus').hide(500);
            // _vm.isHideMenu = true;
        }

        function _loadMenuData() {
            var apiUrl = "api/SystemMenu/GetSystemMenusForReport";
            rt.get(apiUrl).then(function (resp) {
                _vm.menus = resp.data;
            });
        }
        $scope.selectReportMenu = function (menu) {
            $scope.$emit("rt-selectSubMenu-emit", menu);
        };
    }
})();
'use strict';

//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Ludwig Dong
//* 创建时间 :2016-11-22
//* 说明     :代表市场活动分析
//******************************************************************
(function () {
    'use strict';

    function representstatisticsbycampaignController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                _initYmSelected();
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = Iprovinceids.join(",");
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sDate });
            _that.searchList.push({ Type: 1, Key: "eDate", Value: $scope.vm.eDate });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected ? $scope.vm.buidSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "depId", Value: $scope.vm.bigDepSelected ? $scope.vm.bigDepSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "province", Value: provinceids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        function init() {
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = [];
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.tableMaxHeight = 100;
            $scope.vm.search = function () {
                _search().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllBuid();
            _initYmSelected();
        }

        //初始化时间
        function _initYmSelected() {
            $scope.vm.sDate = moment(moment().format('YYYY-MM') + '-01').format('YYYY-MM-DD');
            $scope.vm.eDate = moment().format('YYYY-MM-DD');
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _search() {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                return rt.errorMessage("请输入开始时间或结束时间");
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = Iprovinceids.join(",");
            }

            var waiting = rt.showLoading2();
            var url = "api/representstatisticsbycampaign/representstatisticsData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + $scope.vm.bigDepSelected.id + "&provinceId=" + encodeURIComponent(provinceids) + "&accClass=-1" + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.pageIndex;
            return rt.get(url).then(function (resp) {
                $scope.vm.dataTable = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            } else {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = { id: '', name: "全部业务线/大区/大区" };
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
            $scope.vm.businessUnitList = [];
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                } else {
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        init();
    }
    angular.module('xrmApp').service('representstatisticsbycampaignService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'representstatisticsbycampaign';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("representstatisticsbycampaignController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'representstatisticsbycampaignService', representstatisticsbycampaignController]);
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Berry Ding&& Oscar Gao
//* 创建时间 :2016-01-15  updated by gao at 2016-1-22
//* 说明     :终端流失分析
//******************************************************************
// #endregion

(function () {
    'use strict';

    function terminallossController($scope, $q, rt) {
        function init() {
            $scope.vm = {};
            $scope.vm.reportData = [];

            //终端流失查询
            $scope.vm.showReport = function () {
                _getReportData().then(_show, function (message) {
                    rt.errorMessage(message);
                });
            };

            _getAllProvince();
            _getAllProduct();
            _getLastTimeType();
        }

        function _getLastTimeType() {
            var data = [{ Name: '3个月未交易', Value: '1' }, { Name: '6个月未交易', Value: '2' }, { Name: '1年未交易', Value: '3' }];

            $scope.vm.lastTimeList = data;
            $scope.vm.lastTimeSelected = { Name: '6个月未交易', Value: '2' };
        }

        function _getAllProvince() {
            var url = 'api/AlijkProvince/GetAllProvince';
            return rt.get(url).then(function (resp) {
                if (resp.data.length > 0) {
                    $scope.vm.provinceList = resp.data;
                } else {
                    $scope.vm.provinceList = [];
                    return;
                }

                //$scope.vm.provinceSelected = null;
            });
        }

        function _getAllProduct() {
            var url = 'api/AlijkProduct/GetAllProduct';
            return rt.get(url).then(function (resp) {
                if (resp.data.length > 0) {
                    $scope.vm.productList = resp.data;
                } else {
                    $scope.vm.productList = [];
                    return;
                }
                // $scope.vm.productList = resp.data;
                // $scope.vm.productSelected = null;
            });
        }

        function _getReportData() {
            var pids = "";
            var procodes = "";
            if (rt.isNull($scope.vm.productSelected) || $scope.vm.productSelected.length <= 0) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.provinceSelected) || $scope.vm.provinceSelected.length <= 0) {
                var deferred = $q.defer();
                deferred.reject("查询的省份不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.lastTimeSelected)) {
                var deferred = $q.defer();
                deferred.reject("最近时间不能为空。");
                return deferred.promise;
            }

            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join(",");
            }

            if (!rt.isNull($scope.vm.provinceSelected)) {
                var pmap = $scope.vm.provinceSelected.map(function (item) {
                    return item.CODE;
                });
                procodes = pmap.join(",");
            }

            var waiting = rt.showLoading2();
            var url = 'api/AlijkTerminalLoss/GetTerminalLossData?prodId=' + pids + '&provCode=' + procodes + "&lastTimeType=" + $scope.vm.lastTimeSelected.Value;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                waiting.close();
            });
        }

        function _show() {

            var myChart = echarts.init(document.getElementById("report"), "shine");

            var echartsData = [];
            var getData = $scope.vm.reportData.PieList;
            for (var i = 0; i < getData.length; i++) {
                echartsData.push({
                    value: getData[i].LostCunt,
                    name: getData[i].CityName
                });
            }

            var option = {
                title: {
                    text: '',
                    subtext: '',
                    x: 'center'
                },
                tooltip: {
                    trigger: 'item',
                    formatter: "{a} <br/>{b} : {c} ({d}%)"
                },
                calculable: true,
                series: [{
                    name: '终端流失',
                    type: 'pie',
                    radius: '55%',
                    center: ['50%', '60%'],
                    data: echartsData,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                //position: 'top',
                                formatter: "{b} : {c} ({d}%)"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };

            //var option = {
            //    title : {
            //        text: '终端流失分布',
            //        subtext: '',
            //        x:'center'
            //    },
            //    tooltip : {
            //        trigger: 'item',
            //        formatter: "{a} <br/>{b} : {c} ({d}%)"
            //    },
            //    calculable : true,
            //    series : [
            //        {
            //            name:'终端覆盖度',
            //            type:'pie',
            //            radius : '55%',
            //            center: ['50%', '60%'],
            //            data:echartsData,
            //            itemStyle: {
            //                normal: {
            //                    label: {
            //                        show: true,
            //                        //position: 'top',
            //                        formatter: "{b} : {c} ({d}%)"
            //                    },
            //                    labelLine: {show: true}
            //                }
            //            }
            //        }
            //    ]
            //};

            myChart.setOption(option);
        }

        init();
    }

    angular.module('xrmApp').controller("terminallossController", ['$scope', '$q', 'rt', terminallossController]);
})();
'use strict';

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Berry Ding
//* 创建时间 :2016-01-12
//* 说明     :终端销量排名
//******************************************************************
// #endregion

(function () {
    'use strict';

    angular.module('xrmApp').controller("terminalsalescityController", ['$scope', '$q', 'rt', terminalsalescityController]);
    function terminalsalescityController($scope, $q, rt) {
        init();
        function init() {
            var cw = document.documentElement.clientWidth || document.body.clientWidth;
            $scope.chartWidth = (cw - 50) * 0.6;
            $scope.selectedTabId = "tab1";

            $scope.vm = {};
            $scope.vm.reportData = [];

            $scope.vm.showReport = function () {
                _getReportData().then(_show, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllProvince();
            $scope.selectTab = _selectTab;
        }

        function _getAllProvince() {
            var url = 'api/AlijkProvince/GetAllProvince';
            return rt.get(url).then(function (resp) {
                $scope.vm.provinceList = resp.data;
                $scope.vm.provinceSelected = null;
            });
        }

        function _selectTab(id) {
            $scope.selectedTabId = id;
            _show();
        }
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        function _show() {
            var id = $scope.selectedTabId;
            if (id == "tab1") {
                //城市销量排名
                _show1();
            } else if (id == "tab2") {
                //省份终端销量
                _show2();
            }
        }
        //按城市销量、省份终端查询 获取数据
        function _getReportData() {
            if (rt.isNull($scope.vm.productSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }

            if (rt.isNull($scope.vm.provinceSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的省份不能为空。");
                return deferred.promise;
            }

            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的开始年月不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的结束年月不能为空。");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) < 0) {
                var deferred = $q.defer();
                deferred.reject("参数异常[开始日期必须小于等于结束日期.]");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) >= 365) {
                var deferred = $q.defer();
                deferred.reject("参数异常[日期区间最大为12个月.]");
                return deferred.promise;
            }
            var waiting = rt.showLoading2();
            var url = 'api/AlijkTerminalSales/GetTerminalSalesByProv?toProvCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE) + '&prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&sYm=' + encodeURIComponent($scope.vm.startDate) + '&eYm=' + encodeURIComponent($scope.vm.endDate);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        //按城市销量查询 展现数据
        function _show1() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");

            var echartsDataValue = [];
            var echartsDataName = [];
            var getData = $scope.vm.reportData;
            for (var i = 0; i < getData.Chart1Data.length; i++) {
                echartsDataValue.push(getData.Chart1Data[i].Value);
                echartsDataName.push(getData.Chart1Data[i].Name);
            }

            var option1 = {
                tooltip: {
                    trigger: 'axis'
                },
                legend: {
                    data: ['城市纯销']
                },
                calculable: true,
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01]
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName
                }],
                series: [{
                    name: '城市纯销',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            barBorderRadius: 0,
                            label: {
                                show: true,
                                position: 'right'
                            }
                        }
                    }
                }]
            };

            myChart.clear();
            myChart.setOption(option1);
        }

        //按省份终端查询 展现数据
        function _show2() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");

            var echartsData = [];
            var entTypeNameList = [];
            var getData = $scope.vm.reportData.Chart2Data;
            for (var i = 0; i < getData.length; i++) {
                echartsData.push({
                    value: getData[i].Value,
                    name: getData[i].Name
                });
            }

            var option2 = {
                tooltip: {
                    trigger: 'item',
                    formatter: "{a} <br/>{b} : {c} ({d}%)"
                },
                calculable: true,
                series: [{
                    name: '省份终端类型占比',
                    type: 'pie',
                    radius: '55%',
                    center: ['50%', '60%'],
                    data: echartsData,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                formatter: "{b} : {c} ({d}%)"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option2);
        }
    }
})();
"use strict";

// #region 文件描述
//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Berry Ding
//* 创建时间 :2016-01-12
//* 说明     :终端销量排名
//******************************************************************
// #endregion

(function () {
    'use strict';

    function terminalsalesController($scope, $q, rt) {
        function init() {
            var cw = document.documentElement.clientWidth || document.body.clientWidth;
            $scope.chartWidth = (cw - 50) * 0.6;
            $scope.selectedTabId = "tab3";

            $scope.vm = {};
            $scope.vm.reportData = [];

            $scope.vm.showReport = function () {
                if ($scope.selectedTabId == "tab3") {
                    _getReportData().then(_show3, function (message) {
                        rt.errorMessage(message);
                    });
                } else if ($scope.selectedTabId == "tab4") {
                    _getReportData().then(_show4, function (message) {
                        rt.errorMessage(message);
                    });
                }
            };
            _getAllProvince();
            _getTops();

            $scope.selectTab = _selectTab;
        }

        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[1];
        }
        function _getAllProvince() {
            var url = 'api/AlijkProvince/GetAllProvince';
            return rt.get(url).then(function (resp) {
                $scope.vm.provinceList = resp.data;
                $scope.vm.provinceSelected = null;
            });
        }

        function _getCityByProvince() {
            var url = 'api/AlijkCity/GetCity?ProvCode=' + $scope.vm.provinceSelected.CODE;
            return rt.get(url).then(function (resp) {
                $scope.vm.cityList = resp.data;
                $scope.vm.citySelected = null;
            });
        }

        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }
        function _selectTab(id) {
            $scope.selectedTabId = id;
            if (id == "tab3") {
                //城市各终端销量
                _show3();
            } else if (id == "tab4") {
                //城市终端类型销量
                _show4();
            }
        }
        //按城市销量、省份终端查询 获取数据
        function _getReportData() {
            if (rt.isNull($scope.vm.provinceSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的省份不能为空。");
                return deferred.promise;
            }
            if (rt.isNull($scope.vm.productSelected)) {
                var deferred = $q.defer();
                deferred.reject("查询的药品名称不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的开始年月不能为空。");
                return deferred.promise;
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                var deferred = $q.defer();
                deferred.reject("查询的结束年月不能为空。");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) < 0) {
                var deferred = $q.defer();
                deferred.reject("参数异常[开始日期必须小于等于结束日期.]");
                return deferred.promise;
            }
            if (_CalculateDays($scope.vm.startDate, $scope.vm.endDate) >= 365) {
                var deferred = $q.defer();
                deferred.reject("参数异常[日期区间最大为12个月.]");
                return deferred.promise;
            }
            var waiting = rt.showLoading2();
            var url = 'api/AlijkTerminalSales/GetTerminalSalesByCity?toProvCode=' + encodeURIComponent($scope.vm.provinceSelected.CODE) + '&prodId=' + encodeURIComponent($scope.vm.productSelected.Id) + '&sYm=' + $scope.vm.startDate + '&eYm=' + $scope.vm.endDate + '&top=' + $scope.vm.topsSelected;
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
        //按城市终端查询 展现数据
        function _show3() {

            var myChart = echarts.init(document.getElementById("report3"), "shine");

            var echartsDataValue = [];
            var echartsDataName = [];
            var getData = $scope.vm.reportData;
            for (var i = 0; i < getData.Chart3Data.length; i++) {
                echartsDataValue.push(getData.Chart3Data[i].Value);
                echartsDataName.push(getData.Chart3Data[i].Name);
            }

            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                legend: {
                    data: ['']
                },
                calculable: true,
                grid: {
                    x: '150', y: '5'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01]
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName
                }],
                series: [{
                    name: '销量',
                    type: 'bar',
                    data: echartsDataValue,
                    itemStyle: {
                        normal: {
                            barBorderRadius: 0,
                            label: {
                                show: true,
                                position: 'right'
                            }
                        }
                    }
                }]
            };

            myChart.clear();
            myChart.setOption(option);
        }

        //终端年购进查询 展现数据
        function _show4() {

            var myChart = echarts.init(document.getElementById("report4"), "shine");

            var echartsDataValue3 = [];
            var echartsDataValue4 = [];
            var echartsDataValue5 = [];

            var getData = $scope.vm.reportData;
            for (var i = 0; i < 12; i++) {
                echartsDataValue3.push(getData.Chart4Data.EntTyper3[i]);
                echartsDataValue4.push(getData.Chart4Data.EntTyper4[i]);
                echartsDataValue5.push(getData.Chart4Data.EntTyper5[i]);
            }

            var option3 = {
                tooltip: {
                    trigger: 'axis'
                },
                legend: {
                    data: ['医疗终端', '零售终端', '第三终端']
                },
                xAxis: [{
                    type: 'category',
                    axisLabel: {
                        show: true,
                        interval: 'auto',
                        rotate: 45
                    },
                    data: getData.Chart4Data.Category
                }],
                yAxis: [{
                    type: 'value'
                }],
                series: [{
                    name: '医疗终端',
                    type: 'bar',
                    data: echartsDataValue3,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'top'
                            },
                            labelLine: { show: true }
                        }
                    }
                }, {
                    name: '零售终端',
                    type: 'bar',
                    data: echartsDataValue4,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'top'
                            },
                            labelLine: { show: true }
                        }
                    }
                }, {
                    name: '第三终端',
                    type: 'bar',
                    data: echartsDataValue5,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'top'
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };

            myChart.clear();
            myChart.setOption(option3);
        }

        init();
    }

    angular.module('xrmApp').controller("terminalsalesController", ['$scope', '$q', 'rt', terminalsalesController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Orange Hong
 创建时间 : 2017-04-10
 说明     : 培训活动代表邀请明细
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('TrainingActivitiesReprtService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'TrainingActivities';
    }]).controller("trainingactivitiesController", ['$scope', 'rt', '$injector', 'TrainingActivitiesReprtService', trainingactivitiesController]);
    function trainingactivitiesController($scope, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            var ownerid = _CalculateAccids();
            var shdname = rt.isNull($scope.vm.srhdname) ? "" : $scope.vm.srhdname;

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYM", Value: moment($scope.vm.sYM).format('YYYY-MM-DD') });
            _that.searchList.push({ Type: 1, Key: "eYM", Value: moment($scope.vm.eYM).add(1, 'days').format('YYYY-MM-DD') });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "ownerids", Value: ownerid });
            _that.searchList.push({ Type: 1, Key: "shdname", Value: shdname });
            _that.searchList.push({ Type: 1, Key: "exportType", Value: $scope.selectedTab });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.sYM = moment().format('YYYY-MM-DD');
            $scope.vm.eYM = moment().format('YYYY-MM-DD');
            $scope.selectedTab = 'detail';

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };
        }

        function _CalculateAccids() {
            var ownerid = "";
            if (!rt.isNull($scope.vm.ownerSelected)) {
                var accmap = $scope.vm.ownerSelected.map(function (item) {
                    return item.Id;
                });
                ownerid = accmap.join(",");
            }
            return ownerid;
        }

        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYM)) {
                return "请选择开始日期";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYM)) {
                return "请选择结束日期";
            }
            return "";
        }

        //培训活动代表邀请明细
        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var shdname = rt.isNull($scope.vm.srhdname) ? "" : $scope.vm.srhdname;
            var ownerid = _CalculateAccids();
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();
            var url = "";
            switch ($scope.selectedTab) {
                case 'detail':
                    url = "api/TrainingActivities/GetTrainingActivitiesReportData";
                    break;
                case 'groupByAccount':
                    url = "api/TrainingActivities/GetTrainingActivitiesReportDataGroupByAccount";
                    break;
                case 'groupByOwner':
                    url = "api/TrainingActivities/GetTrainingActivitiesReportDataGroupByOwner";
                    break;
                case 'groupByBus':
                    url = "api/TrainingActivities/GetTrainingActivitiesReportDataGroupByBus";
                    break;
            }

            url += "?sYM=" + encodeURIComponent(moment($scope.vm.sYM).format('YYYY-MM-DD'));
            url += "&eYM=" + encodeURIComponent(moment($scope.vm.eYM).add(1, 'days').format('YYYY-MM-DD'));
            url += "&shdname=" + encodeURIComponent(shdname);
            url += "&ownerids=" + encodeURIComponent(ownerid);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            return rt.post(url, unitids).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        //切换tab
        $scope.selectTab = function (type) {
            $scope.selectedTab = type;
            $scope.vm.showReport();
        };
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : jeoli
 创建时间 : 2018-03-01
 说明     :代表费效比分析 
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('UserCostEffectivenessService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'UserCostEffectiveness';

        //查询代表费效比分析数据
        this.GetUserCost = function (sDate, eDate, unitids, ownerid, pageSize, pageIndex) {
            return rt.post("api/UserCostEffectiveness/GetUserCost?sDate=" + sDate + "&eDate=" + eDate + "&ownerid=" + ownerid + "&pageSize=" + pageSize + "&pageIndex=" + pageIndex, unitids);
        };
    }]).controller('UserCostEffectivenessListController', ['$scope', '$injector', 'rt', 'UserCostEffectivenessService', function ($scope, $injector, rt, myService) {
        var that = this;
        that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            //区域(业务部门)Id
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";

            //初始化选中的代表
            var owner_selectedId = "";
            if (!rt.isNull($scope.vm.ownerSelected) && !rt.isNull($scope.vm.ownerSelected.Id)) {
                owner_selectedId = $scope.vm.ownerSelected.Id;
            }
            that.searchList.length = 0;

            that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sDate });
            that.searchList.push({ Type: 1, Key: "eDate", Value: $scope.vm.eDate });
            that.searchList.push({ Type: 1, Key: "ownerid", Value: owner_selectedId });
            that.searchList.push({ Type: 1, Key: "unitids", Value: unitids });
            that.searchList.push({ Type: 1, Key: "pageSize", Value: $scope.vm.pageSize });
            that.searchList.push({ Type: 1, Key: "pageIndex", Value: $scope.vm.pageIndex });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();
        //初始化
        function init() {
            //时间筛选，默认全年，时间段范围为月份
            $scope.dateSelect = 'thisMonth';
            $scope.vm.sDate = moment().format('YYYY-MM');
            $scope.vm.eDate = moment().format('YYYY-MM');
            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.reportData = {};
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.getReportData = _getData; //获取报表数据
        }

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sDate)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sDate > $scope.vm.eDate) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            return "";
        }

        //日期检测
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        // //获取查询数据
        function _getData() {
            var msg = _checkOption();
            if (!rt.isNull(msg) && msg.length > 0) {
                rt.errorMessage(msg);
                return;
            }
            //获取区域Id,多条记录需要进行json转换
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? JSON.stringify($scope.vm.nodeSelected.ids) : "";

            var owner_selectedId = "";
            if (!rt.isNull($scope.vm.ownerSelected) && !rt.isNull($scope.vm.ownerSelected.Id)) {
                owner_selectedId = $scope.vm.ownerSelected.Id;
            }

            var waiting = rt.showLoading2();
            //获取值
            myService.GetUserCost($scope.vm.sDate, $scope.vm.eDate, unitids, owner_selectedId, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            });
        }

        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
        }
    }]);
})();
'use strict';

//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Mona Xia
//* 创建时间 :2017-01-09
//* 说明     :门店竞品采集统计
//******************************************************************
(function () {
    'use strict';

    function visitCompetingProductListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                _initYmSelected();
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = Iprovinceids.join(",");
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sDate });
            _that.searchList.push({ Type: 1, Key: "eDate", Value: $scope.vm.eDate });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected ? $scope.vm.buidSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "depId", Value: $scope.vm.bigDepSelected ? $scope.vm.bigDepSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "province", Value: provinceids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = [];
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.tableMaxHeight = 100;
            $scope.vm.search = function () {
                _search().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllBuid();
            _initYmSelected();
        }

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sDate = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.eDate = moment().format('YYYY-MM-DD');
        }

        //（暂时）计算报表应有高度
        $scope.complateTableheight = function () {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        };

        function _search() {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                return rt.errorMessage("请输入开始时间或结束时间");
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = Iprovinceids.join(",");
            }

            var waiting = rt.showLoading2();
            var url = "api/VisitCompeting/VisitCompetingProductRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + $scope.vm.bigDepSelected.id + "&provinceId=" + provinceids + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.pageIndex;
            return rt.get(url).then(function (resp) {
                $scope.vm.dataTable = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                $scope.complateTableheight();
            }).finally(function () {
                waiting.close();
            });
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            } else {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = { id: '', name: "全部业务线/大区/大区" };
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
            $scope.vm.businessUnitList = [];
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                } else {
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        init();
    }
    angular.module('xrmApp').service('visitCompetingProductService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitCompeting';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("visitCompetingProductListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'visitCompetingProductService', visitCompetingProductListController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016/11/25
 说明     : 门店临逾期药品统计
 *********************************************************/
(function () {
    'use strict';

    function visitexpiredProductListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                _initYmSelected();
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sDate });
            _that.searchList.push({ Type: 1, Key: "eDate", Value: $scope.vm.eDate });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected ? $scope.vm.buidSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "depId", Value: $scope.vm.bigDepSelected ? $scope.vm.bigDepSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "province", Value: provinceids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = [];
            $scope.selectedTabId = "tab2";
            $scope.selectTab = _selectTab;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.tableMaxHeight = 100;
            $scope.vm.search = function () {
                _search().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllBuid();
            _initYmSelected();
        }

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.sDate = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.eDate = moment().format('YYYY-MM-DD');
        }
        //切换tab
        function _selectTab(id) {
            $scope.selectedTabId = id;
            _showData();
        }
        function _showData() {
            var t = $scope.selectedTabId;
            $scope.vm.pageIndex = 1;
            $scope.vm.dataTable = [];
            switch (t) {
                case "tab1":
                    ;break;
                case "tab2":
                    ;break;
            }
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _search() {
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sDate) && rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                return rt.errorMessage("请输入开始时间或结束时间");
            }

            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }

            var waiting = rt.showLoading2();
            var url = "api/VisitexpiredProduct/visitexpiredProductRportData?sDate=" + $scope.vm.sDate + "&eDate=" + $scope.vm.eDate + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + $scope.vm.bigDepSelected.id + "&provinceId=" + provinceids + "&PageSize=" + $scope.vm.pageSize + "&PageIndex=" + $scope.vm.pageIndex;
            return rt.get(url).then(function (resp) {
                $scope.vm.dataTable = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }
        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            } else {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = { id: '', name: "全部业务线/大区/大区" };
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
            $scope.vm.businessUnitList = [];
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                } else {
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        init();
    }
    angular.module('xrmApp').service('visitexpiredProductService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'drugstorePSIstatistics';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("visitexpiredProductListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'visitexpiredProductService', visitexpiredProductListController]);
})();
'use strict';

//******************************************************************
//* Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
//* 创建人   :Ludwig Dong
//* 创建时间 :2016-10-27
//* 说明     :客户拜访频率分析
//******************************************************************
(function () {
    'use strict';

    function visitfrequencyAccListController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var classids = '';
            var provinceids = '';
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                $scope.vm.sYm = moment().format('YYYY-MM');
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }
            if (!rt.isNull($scope.vm.accountClassSelected) && $scope.vm.accountClassSelected.length > 0) {
                var IClassids = $scope.vm.accountClassSelected.map(function (item) {
                    return item.Name;
                });
                classids = "'" + IClassids.join("','") + "'";
            }
            if (rt.isNull($scope.vm.representativeint)) {
                $scope.vm.representativeint = { Id: "" };
            }
            _checkTarget();
            _saveTarget();
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "date", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "buId", Value: $scope.vm.buidSelected ? $scope.vm.buidSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "depId", Value: $scope.vm.bigDepSelected ? $scope.vm.bigDepSelected.id : '' });
            _that.searchList.push({ Type: 1, Key: "province", Value: provinceids });
            _that.searchList.push({ Type: 1, Key: "accountClass", Value: classids });
            _that.searchList.push({ Type: 1, Key: "representative", Value: $scope.vm.representativeint ? $scope.vm.representativeint.Id : '' });
            _that.searchList.push({ Type: 1, Key: "target", Value: localStorage.getItem("visitfrequencyAccMis") });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.sYm = moment().format('YYYY-MM');
            $scope.vm.buidList = [];
            $scope.vm.buidSelected = null;
            $scope.vm.bigDepList = [];
            $scope.vm.bigDepSelected = { id: '' };
            $scope.vm.businessUnitList = [];
            $scope.vm.businessUnitSelected = [];
            $scope.vm.accountClass = [];
            $scope.vm.accountClassSelected = [];
            $scope.vm.acc_ClassLevel = [];
            $scope.vm.representativeint = { Id: '' };
            $scope.vm.depType = 0;
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.tableMaxHeight = 100;
            $scope.vm.search = function () {
                _search().then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllBuid();
            _getAccountClass();
        }
        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = { id: '' };
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            } else {
                $scope.vm.bigDepList = [];
                $scope.vm.bigDepSelected = { id: '', name: "全部业务线/大区/大区" };
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
            $scope.vm.businessUnitList = [];
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                } else {
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        //获取客户分级
        function _getAccountClass() {
            var url = "api/businessaccount/GetPickListData?fieldCodes=account_grade_level";
            rt.get(url).then(function (resp) {
                if (!rt.isNull(resp.data) && !rt.isNull(resp.data.account_grade_level)) {
                    $scope.vm.accountClass = resp.data.account_grade_level;
                    var item = 4;
                    angular.forEach($scope.vm.accountClass, function (entity) {
                        if (item == 0) {
                            item = 1;
                        }
                        entity.target = item;
                        item--;
                    });
                }
                _inItTarget();
            });
        }

        function _saveTarget() {
            var item = 4;
            angular.forEach($scope.vm.accountClass, function (entity) {
                if (rt.isNull(entity.target) || entity.target < 0 || entity.target == 0) {
                    if (item == 0) {
                        item = 1;
                    }
                    entity.target = item;
                    item--;
                }
            });
            localStorage.setItem("visitfrequencyAccMis", JSON.stringify($scope.vm.accountClass));
        }

        function _inItTarget() {
            var targetItem = [];
            targetItem = JSON.parse(localStorage.getItem("visitfrequencyAccMis"));
            angular.forEach($scope.vm.accountClass, function (entity) {
                angular.forEach(targetItem, function (targetentity) {
                    if (entity.Name == targetentity.Name) {
                        entity.target = targetentity.target;
                    }
                });
            });
        }
        function _checkTarget() {
            var item = 4;
            angular.forEach($scope.vm.accountClass, function (entity) {
                if (rt.isNull(entity.target) || entity.target < 0 || entity.target == 0) {
                    if (item == 0) {
                        item = 1;
                    }
                    entity.target = item;
                    item--;
                }
            });
        }

        function _search() {
            var classids = '';
            var provinceids = '';
            if (rt.isNull($scope.vm.sYm)) {
                return rt.errorMessage("请选择年月");
            }
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var Iprovinceids = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                provinceids = "'" + Iprovinceids.join("','") + "'";
            }
            if (!rt.isNull($scope.vm.accountClassSelected) && $scope.vm.accountClassSelected.length > 0) {
                var IClassids = $scope.vm.accountClassSelected.map(function (item) {
                    return item.Name;
                });
                classids = "'" + IClassids.join("','") + "'";
            }
            if (rt.isNull($scope.vm.representativeint)) {
                $scope.vm.representativeint = { Id: "" };
            }
            _checkTarget();
            var waiting = rt.showLoading2();
            var url = "api/Visitownercount/VisitCountAnalysisAccPc?date=" + $scope.vm.sYm + "&buId=" + $scope.vm.buidSelected.id + "&depId=" + $scope.vm.bigDepSelected.id + "&province=" + provinceids + "&accountClass=" + classids + "&representative=" + $scope.vm.representativeint.Id + "&pageIndex=" + $scope.vm.pageIndex + "&pageSize=" + $scope.vm.pageSize;
            return rt.get(url).then(function (resp) {
                _saveTarget();
                $scope.vm.dataTable = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _targetConvert();
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }

        function _targetConvert() {
            if (!rt.isNull($scope.vm.dataTable) && $scope.vm.dataTable.length > 0) {
                var target;
                angular.forEach($scope.vm.dataTable, function (entity) {
                    if (!rt.isNull(entity.account_grade_levelName)) {
                        target = _targetValue(entity.account_grade_levelName);
                        entity.target = target;
                        entity.achievement = Math.round((entity.accountCount == null ? 0 : entity.accountCount / target) * 100);
                    }
                });
            }
        }
        function _targetValue(Code) {
            var target;
            angular.forEach($scope.vm.accountClass, function (entity) {
                if (entity.Name == Code) {
                    target = entity.target;
                }
            });
            if (rt.isNull(target) || target < 0 || target == 0) {
                target = 1;
            }
            return target;
        }

        init();
    }
    angular.module('xrmApp').service('VisitownercountService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'Visitownercount';
        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("visitfrequencyAccListController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'VisitownercountService', visitfrequencyAccListController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/9/28
 说明     : 代表计划完成分析
 *********************************************************/
(function () {
    'use strict';

    function RepresentativeVisitAnalysisController($scope, $q, $compile, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "yM", Value: moment($scope.vm.yM).format('YYYY-MM') });
            _that.searchList.push({ Type: 1, Key: "buId", Value: buId });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: bigUnitId });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        function init() {
            $scope.vm.buidList = []; //事业部下拉
            $scope.vm.buidSelected = { id: '' }; //事业部选择
            $scope.vm.bigDepList = []; //业务线/大区下拉
            $scope.vm.bigDepSelected = { id: '' }; //业务线/大区选择
            $scope.vm.businessUnitList = []; //省区/地区下拉
            $scope.vm.businessUnitSelected = { id: '' }; //省区/地区选择

            $scope.vm.reportData = []; //表格数据
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.yM = moment().format('YYYY-MM');
            $scope.vm.showReportData = _showReportData; //查询按钮
            $scope.vm.getReportData = _getReportData; //查询按钮
            _getAllBuid(); //获取所有事业部
        }

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {
                $scope.vm.buidList = [];
            });
        }

        //获取业务线/大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue == newValue) return;
            $scope.vm.businessUnitSelected = { id: '' };
            $scope.vm.businessUnitList = [];

            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) return;

            rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                '@queryValue': '',
                '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                '@businesstype': 10
            }, function (resp) {
                $scope.vm.businessUnitList = resp.DataList;
            }, function (error) {
                $scope.vm.businessUnitList = [];
            });
        });

        $scope.complateTableheight = function () {
            _complateTableheight();
        };

        //计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        function _showReportData() {
            $scope.vm.pageIndex = 1;
            _getReportData();
        }

        function _getReportData() {
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected) && $scope.vm.businessUnitSelected.length > 0) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            var waiting = rt.showLoading2();
            var apiUrl = "api/RepresentativeVisitAnalysis/GetGridData";
            apiUrl += "?yM=" + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM'));
            apiUrl += "&buId=" + buId;
            apiUrl += "&bigDeptId=" + bigUnitId;
            apiUrl += "&businessUnitId=" + unitids;
            apiUrl += "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex);
            apiUrl += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            rt.get(apiUrl).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
                _complateTableheight();
            }, function () {
                waiting.close();
            });
        }

        init();
    }

    angular.module('xrmApp').service('RepresentativeVisitAnalysisService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);

        // @@设置WebAPI的控制器名称
        this.controllerName = 'RepresentativeVisitAnalysis';

        // @@ 选项集
        this.picklists = [];
    }]);
    angular.module('xrmApp').controller("RepresentativeVisitAnalysisController", ['$scope', '$q', '$compile', '$timeout', 'rt', '$injector', 'RepresentativeVisitAnalysisService', RepresentativeVisitAnalysisController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017-10-31
 说明     : 门店拜访进货统计
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('RetailPsiStatisticsService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'RetailPsiStatistics';
        // @@ 选项集
        this.picklists = [];
    }]).controller("RetailPsiAnalysisListController", ['$scope', '$q', 'rt', '$injector', 'RetailPsiStatisticsService', RetailPsiAnalysisListController]);
    function RetailPsiAnalysisListController($scope, $q, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.sDate });
            _that.searchList.push({ Type: 1, Key: "eDate", Value: $scope.vm.eDate });
            _that.searchList.push({ Type: 1, Key: "businessUnitIds", Value: rt.isNull($scope.vm.nodeSelected) ? "" : $scope.vm.nodeSelected.ids });
            _that.searchList.push({ Type: 1, Key: "ownerId", Value: rt.isNull($scope.vm.OwnerId) ? "" : $scope.vm.OwnerId.Id });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.sDate = moment(moment().format('YYYY-MM') + '-01').format('YYYY-MM-DD');
            $scope.vm.eDate = moment(moment().add('months', 1).format('YYYY-MM') + '-01').add('days', -1).format('YYYY-MM-DD');
            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };
            //查询
            $scope.vm.showReport = function () {
                var msg = _checkOption();
                if (!rt.isNullOrWhiteSpace(msg)) {
                    rt.errorMessage(msg);
                    return false;
                }
                var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
                var OwnerId = rt.isNull($scope.vm.OwnerId) ? "" : $scope.vm.OwnerId.Id;

                //获取终端热度总拜访数和均拜访数
                _getReportData(unitids, OwnerId).then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
        }

        //条件检查
        function _checkOption() {

            if (rt.isNullOrWhiteSpace($scope.vm.sDate)) {
                return "开始时间不能为空";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.eDate)) {
                return "结束时间不能为空";
            }

            if (_CalculateDays($scope.vm.sDate, $scope.vm.eDate) < 0) {
                return "参数异常[开始日期必须小于等于结束日期.]";
            }
        }

        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            if (startDate > endDate) {
                return -1;
            }
            return 0;
        }

        //获取终端热度总拜访数和均拜访数
        function _getReportData(unitids, OwnerId) {
            var waiting = rt.showLoading2();
            return rt.post('api/RetailPsiStatistics/GetRetailPsiStatisticsData?sDate=' + encodeURIComponent($scope.vm.sDate) + '&eDate=' + encodeURIComponent($scope.vm.eDate) + '&ownerId=' + encodeURIComponent(OwnerId) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize) + '&pageIndex=' + encodeURIComponent($scope.vm.index), unitids).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }
    }
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2015-04-25
说明     : 城市表单视图 控制器
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller('saleslogEditController', ['$scope', '$state', '$stateParams', 'rt', saleslogEditController]);
    function saleslogEditController($scope, $state, $stateParams, rt) {
        var _vm = $scope.vm = {};
        _init();

        function _init() {
            /****************** 定义数据对象 ******************/
            _vm.form = {};
            _vm.form.id = $stateParams.id;
            _vm.form.type = $stateParams.id === "" ? "Create" : "Edit";
            _vm.form.data = {};
            _vm.picklist = {};
            _vm.privilege = {};
            _vm.privilege.IsCreate = true;
            _vm.privilege.IsDelete = true;
            _vm.privilege.IsWrite = true;

            /****************** 加载数据 ******************/

            // 加载表单
            _loadForm();

            /****************** 绑定事件 ******************/

            // 删除事件
            _vm.form.del = _del;

            // 保存事件
            _vm.form.save = _saveForm;
        }

        function _loadForm() {
            /// <summary>加载城市表单</summary>


        }

        function _saveForm(createNext) {
            /// <summary>保存表单数据</summary>
            /// <param name="createNext">是否创建下一条记录</param>
            var trigerButtonId = createNext ? "btnSaveAndNew" : "btnSave";
        }

        function _del() {
            /// <summary>删除事件</summary>

        }

        function _reloadForm(id) {
            /// <summary>重新加载表单</summary>

            // 刷新视图页面
        }
    }
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2015-04-15
说明     : 城市列表视图 控制器
*********************************************************/

(function () {
            'use strict';

            angular.module('xrmApp').controller('saleslogListController', ['$scope', '$state', 'rt', saleslogListController]);
            function saleslogListController($scope, $state, rt) {
                        var _vm = $scope.vm = {};
                        _init();

                        function _init() {
                                    /****************** 定义数据对象 ******************/
                                    _vm.view = {};
                                    _vm.view.list = [];
                                    _vm.view.selectedView = {};
                                    _vm.view.searchText = '';
                                    _vm.view.sortField = 'name asc';
                                    _vm.data = {};
                                    _vm.view.selectedIds = [];
                                    _vm.row = {};
                                    _vm.page = {};
                                    _vm.page.index = 1;
                                    _vm.page.size = rt.getPaginationSize();
                                    _vm.page.recordCount = 2;
                                    _vm.privilege = {};
                                    _vm.privilege.IsCreate = true;
                                    _vm.privilege.IsDelete = true;

                                    /****************** 加载数据 ******************/

                                    // 检查实体权限
                                    _loadPrivilege();

                                    // 加载视图和数据
                                    _loadView();

                                    /****************** 数据监控 ******************/

                                    // 选中视图后加载数据
                                    $scope.$watch('vm.view.selectedView', _loadData);

                                    /****************** 绑定事件 ******************/

                                    // 选择视图事件
                                    _vm.view.select = function (view) {
                                                _vm.view.selectedView = view;
                                    };

                                    // 搜索事件
                                    _vm.view.search = _loadData;

                                    // 删除事件
                                    _vm.row.del = function () {};
                        }

                        function _loadPrivilege() {
                                    /// <summary>检查实体的相关操作权限</summary>

                        }

                        function _loadView() {
                                    /// <summary>加载视图列表</summary>


                        }

                        function _loadData() {
                                    /// <summary>加载视图数据</summary>


                        }
            }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2016/5/5
 说明     : 省区纯销指标达成
 *********************************************************/
(function () {
    'use strict';

    function SalesForecastListController($scope, $q, $compile, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            if (!rt.isNullOrWhiteSpace($scope.vm.YmDate)) {
                $scope.vm.Ym = moment($scope.vm.YmDate).format('YYYYMM');
            }
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "Ym", Value: $scope.vm.Ym });
            _that.searchList.push({ Type: 1, Key: "productid", Value: $scope.vm.productid ? $scope.vm.productid.Id : "" });
            _that.searchList.push({ Type: 1, Key: "status", Value: $scope.vm.forecaststatusCode ? $scope.vm.forecaststatusCode.id : "" });
            _that.searchList.push({ Type: 1, Key: "businessUnitIds", Value: unitids });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();
        //初始化
        function init() {
            _getForecaststatus();
            //报表数据
            $scope.vm.Ym = "";
            $scope.vm.productid = "";
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.getReportData = _getReportData;
            _getReportData();
        }

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            return "";
        }
        function _getForecaststatus() {
            $scope.vm.forecaststatusList = [{ id: '', name: '所有数据' }, { id: '1', name: '未提交' }, { id: '2', name: '已提交' }];
            $scope.vm.forecaststatusCode = $scope.vm.forecaststatusList[0];
        }

        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 90);
        }

        //查询报表数据
        function _getReportData() {
            if (!rt.isNullOrWhiteSpace($scope.vm.YmDate)) {
                $scope.vm.Ym = moment($scope.vm.YmDate).format('YYYYMM');
            } else {
                $scope.vm.Ym = '';
            }
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();
            //达成列表
            myService.GetSalesForecastList($scope.vm.Ym, $scope.vm.pageIndex, $scope.vm.pageSize, $scope.vm.productid ? $scope.vm.productid.Id : "", $scope.vm.forecaststatusCode ? $scope.vm.forecaststatusCode.id : "", unitids).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            });
        }
    }

    angular.module('xrmApp').service('SalesForecastService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'SalesForecast';

        //获取销售预测
        this.GetSalesForecastList = function (Ym, pageIndex, pageSize, productid, status, unitids) {
            return rt.post("api/SalesForecast/GetSalesForecastList?Ym=" + Ym + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize + "&productid=" + productid + "&status=" + status, unitids);
        };
    }]);
    angular.module('xrmApp').controller("SalesForecastListController", ['$scope', '$q', '$compile', 'rt', '$injector', 'SalesForecastService', SalesForecastListController]);
})();
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Oscar Gao
 *创建时间：2016/4/11
 *说明：文件描述...
 *************************************************/
(function () {
    'use strict';

    function AccountMultiSelectController($scope, rt) {
        function init() {
            $scope.vm = {};
            $scope.vm.searchText = '';
            $scope.vm.page = {};
            $scope.vm.page.recordCount = 0;
            $scope.vm.page.index = 1;
            $scope.vm.page.pageSize = rt.getPaginationSize();
            $scope.vm.Data = [];
            $scope.vm.DataLeast = [];
            $scope.vm.conQR = _conQR;
            $scope.vm.hide = _hide;
            $scope.vm.getData = _getData;
            var waiting = rt.showLoading2();
            _getData().then(_show(), function (message) {
                rt.errorMessage(message);
            });
            waiting.close();
        }
        function _getData() {
            var name = '';
            if (!rt.isNull($scope.vm.searchText)) {
                name = $scope.vm.searchText;
            }
            var url = 'api/Account/GetAccountDataList?name=' + name;
            url += "&pageIndex=" + $scope.vm.page.index;
            url += "&pageSize=" + $scope.vm.page.pageSize;
            return rt.get(url).then(function (resp) {
                $scope.vm.Data = resp.data.Lists;
                $scope.vm.page.recordCount = resp.data.RecordCount;
            });
        }
        function _hide() {
            $scope.$parent.vm.hideForm();
        }
        function _conQR() {
            var url = 'api/SalesRegionAccount/AddMultiSalesRegionAccount?salesRegionId=' + $scope.rtIncludeParams.saleRegionId;
            rt.post(url, $scope.vm.selectedIds).then(function () {
                $scope.$emit('rt-reload');
                $scope.$parent.vm.hideForm();
            }, function () {});
        }
        function _show() {}
        init();
    }
    angular.module("xrmApp").controller("AccountMultiSelectController", ['$scope', 'rt', AccountMultiSelectController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/2/8
 说明     : 报表 - 招商经理行为统计
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('SamZhsDoneService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'SamZhsDone';

        this.GetSamZhsDoneGridData = function (sYm, eYm, unitids, pageSize, pageIndex) {
            var url = "api/SamZhsDone/GetSamZhsDoneGridData";
            url += "?sYm=" + encodeURIComponent(sYm);
            url += "&eYm=" + encodeURIComponent(eYm);
            url += "&pageIndex=" + encodeURIComponent(pageIndex);
            url += "&pageSize=" + encodeURIComponent(pageSize);
            return rt.post(url, unitids);
        };
    }]).controller("SamZhsDoneController", ['$scope', 'rt', '$injector', 'SamZhsDoneService', SamZhsDoneController]);

    function SamZhsDoneController($scope, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            //检查导出条件
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            //区域(业务部门)Id
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? $scope.vm.nodeSelected.ids : "";

            //添加搜索条件
            _that.searchList.length = 0;
            _that.searchList.push({
                Type: 1,
                Key: "sYm",
                Value: $scope.vm.sYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "eYm",
                Value: $scope.vm.eYm
            });
            _that.searchList.push({
                Type: 1,
                Key: "unitids",
                Value: unitids
            });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();

        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.changeDate = _changeDate; //改变日期
            $scope.dateSelect = 'thisWeek';
            var weekOfday = parseInt(moment().format('E')); //计算今天是这周第几天  
            $scope.vm.sYm = moment().subtract(weekOfday - 1, 'days').format('YYYY-MM-DD'); //周一日期  
            $scope.vm.eYm = moment().subtract(weekOfday - 7, 'days').format('YYYY-MM-DD'); //周日日期   

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.pageIndex = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };
        }

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            if ($scope.vm.sYm.substr(0, 4) !== $scope.vm.eYm.substr(0, 4)) {
                return "只可查询同一年的数据.";
            }
            return "";
        }

        //选择时间筛选
        function _changeDate(dateType) {
            $scope.dateSelect = dateType;

            switch (dateType) {
                case "thisWeek":
                    var weekOfday = parseInt(moment().format('E')); //计算今天是这周第几天  
                    $scope.vm.sYm = moment().subtract(weekOfday - 1, 'days').format('YYYY-MM-DD'); //周一日期  
                    $scope.vm.eYm = moment().subtract(weekOfday - 7, 'days').format('YYYY-MM-DD'); //周日日期   
                    break;
                case "lastWeek":
                    var weekOfday = parseInt(moment().format('E')); //计算今天是这周第几天  
                    $scope.vm.sYm = moment().subtract(weekOfday + 6, 'days').format('YYYY-MM-DD'); //周一日期  
                    $scope.vm.eYm = moment().subtract(weekOfday, 'days').format('YYYY-MM-DD'); //周日日期   
                    break;
                case "thisMonth":
                    $scope.vm.sYm = moment().format('YYYY-MM-01');
                    $scope.vm.eYm = moment(moment().add(1, 'months').format('YYYY-MM-01')).subtract(1, 'days').format('YYYY-MM-DD');
                    break;
                case "lastMonth":
                    $scope.vm.sYm = moment().add(-1, 'months').format('YYYY-MM-01');
                    $scope.vm.eYm = moment(moment().format('YYYY-MM-01')).subtract(1, 'days').format('YYYY-MM-DD');
                    break;
            }
        }

        function _getReportData() {
            var msg = _checkOption();
            if (!rt.isNull(msg) && msg.length > 0) {
                rt.errorMessage(msg);
                return;
            }
            //获取区域Id
            var unitids = !rt.isNull($scope.vm.nodeSelected) ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();
            myService.GetSamZhsDoneGridData($scope.vm.sYm, $scope.vm.eYm, unitids, $scope.vm.pageSize, $scope.vm.pageIndex).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
            }).finally(function () {
                waiting.close();
            });
        }

        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Gale Ge
 创建时间 : 2017/02/28
 说明     : 报表 - 代表结算金额统计
 *********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('SalesRepReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'SalesRepReport';
    }]).controller("SalesRepReportController", ['$scope', 'rt', '$injector', 'SalesRepReportService', SalesRepReportController]);
    function SalesRepReportController($scope, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "Ym", Value: moment($scope.vm.yM).format('YYYY-MM') });
            _that.searchList.push({ Type: 1, Key: "buId", Value: buId });
            _that.searchList.push({ Type: 1, Key: "bigDepId", Value: bigUnitId });
            _that.searchList.push({ Type: 1, Key: "businessUnitId", Value: unitids });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        init();

        function init() {
            $scope.vm.buidList = [];
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.isShow = 'sum';
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.yM = moment().format('YYYY-MM');

            //查询
            $scope.vm.showReport = function () {
                if ($scope.vm.isShow == 'sum') {
                    _getReportSumData();
                }
                if ($scope.vm.isShow == 'detail') {
                    _getReportDetailData();
                }
            };

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                _getReportSumData();
                _getReportDetailData();
            };

            _getAllBuid();
        }

        //切换tab
        $scope.selectTab = function (id) {
            $scope.vm.index = 1;
            switch (id) {
                case 'tab1':
                    $scope.vm.isShow = 'sum';
                    break;
                case 'tab2':
                    $scope.vm.isShow = 'detail';
                    break;
            }
        };

        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            });
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function () {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });

        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });

        function _getReportDetailData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var waiting = rt.showLoading2();
            var url = "api/SalesRepReport/GetSalesRepReportDetailData";
            url += "?Ym=" + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM'));
            url += "&buId=" + encodeURIComponent($scope.vm.buidSelected.id);
            url += "&bigDepId=" + encodeURIComponent(bigUnitId);
            url += "&businessUnitId=" + encodeURIComponent(unitids);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportDetailData = resp.data.DataList;
                $scope.vm.recordDetailCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }

        function _getReportSumData() {
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }

            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var waiting = rt.showLoading2();
            var url = "api/SalesRepReport/GetSalesRepReportSumData";
            url += "?Ym=" + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM'));
            url += "&buId=" + encodeURIComponent($scope.vm.buidSelected.id);
            url += "&bigDepId=" + encodeURIComponent(bigUnitId);
            url += "&businessUnitId=" + encodeURIComponent(unitids);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportSumData = resp.data.DataList;
                $scope.vm.recordSumCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }
    }
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2015-04-25
说明     : 城市表单视图 控制器
*********************************************************/

(function () {
    'use strict';

    angular.module('xrmApp').controller('serviceInvestEditController', ['$scope', '$state', '$stateParams', 'rt', serviceInvestEditController]);
    function serviceInvestEditController($scope, $state, $stateParams, rt) {
        var _vm = $scope.vm = {};
        _init();

        function _init() {
            /****************** 定义数据对象 ******************/
            _vm.form = {};
            _vm.form.id = $stateParams.id;
            _vm.form.type = $stateParams.id === "" ? "Create" : "Edit";
            _vm.form.data = {};
            _vm.picklist = {};
            _vm.privilege = {};
            _vm.privilege.IsCreate = true;
            _vm.privilege.IsDelete = true;
            _vm.privilege.IsWrite = true;

            /****************** 加载数据 ******************/

            // 加载表单
            _loadForm();

            /****************** 绑定事件 ******************/

            // 删除事件
            _vm.form.del = _del;

            // 保存事件
            _vm.form.save = _saveForm;
        }

        function _loadForm() {
            /// <summary>加载城市表单</summary>


        }

        function _saveForm(createNext) {
            /// <summary>保存表单数据</summary>
            /// <param name="createNext">是否创建下一条记录</param>
            var trigerButtonId = createNext ? "btnSaveAndNew" : "btnSave";
        }

        function _del() {
            /// <summary>删除事件</summary>

        }

        function _reloadForm(id) {
            /// <summary>重新加载表单</summary>

            // 刷新视图页面
        }
    }
})();
'use strict';

/********************************************************
Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved. 
创建人   : Chad Chen
创建时间 : 2015-04-15
说明     : 城市列表视图 控制器
*********************************************************/

(function () {
            'use strict';

            angular.module('xrmApp').controller('serviceInvestListController', ['$scope', '$state', 'rt', serviceInvestListController]);
            function serviceInvestListController($scope, $state, rt) {
                        var _vm = $scope.vm = {};
                        _init();

                        function _init() {
                                    /****************** 定义数据对象 ******************/
                                    _vm.view = {};
                                    _vm.view.list = [];
                                    _vm.view.selectedView = {};
                                    _vm.view.searchText = '';
                                    _vm.view.sortField = 'name asc';
                                    _vm.data = {};
                                    _vm.view.selectedIds = [];
                                    _vm.row = {};
                                    _vm.page = {};
                                    _vm.page.index = 1;
                                    _vm.page.size = rt.getPaginationSize();
                                    _vm.page.recordCount = 2;
                                    _vm.privilege = {};
                                    _vm.privilege.IsCreate = true;
                                    _vm.privilege.IsDelete = true;

                                    /****************** 加载数据 ******************/

                                    // 检查实体权限
                                    _loadPrivilege();

                                    // 加载视图和数据
                                    _loadView();

                                    /****************** 数据监控 ******************/

                                    // 选中视图后加载数据
                                    $scope.$watch('vm.view.selectedView', _loadData);

                                    /****************** 绑定事件 ******************/

                                    // 选择视图事件
                                    _vm.view.select = function (view) {
                                                _vm.view.selectedView = view;
                                    };

                                    // 搜索事件
                                    _vm.view.search = _loadData;

                                    // 删除事件
                                    _vm.row.del = function () {};
                        }

                        function _loadPrivilege() {
                                    /// <summary>检查实体的相关操作权限</summary>

                        }

                        function _loadView() {
                                    /// <summary>加载视图列表</summary>


                        }

                        function _loadData() {
                                    /// <summary>加载视图数据</summary>


                        }
            }
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2017/12/7
 说明     : 按部门流向统计
 *********************************************************/
(function () {
    'use strict';

    function ShopShortStoreListController($scope, $q, $compile, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            // var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            var accountLevel_selected = "";
            var pids = "";
            if (!rt.isNull($scope.vm.accountLevel_selected) && !rt.isNull($scope.vm.accountLevel_selected.Value)) {
                accountLevel_selected = $scope.vm.accountLevel_selected.Value;
            }
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join(",");
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "productIds", Value: pids });
            _that.searchList.push({ Type: 1, Key: "accountLevel", Value: accountLevel_selected });
            _that.searchList.push({ Type: 1, Key: "businessunits", Value: unitids });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        function init() {
            //时间筛选，默认全年
            $scope.dateSelect = 'fullYear';
            $scope.vm.sYm = moment().format('YYYY-01');
            $scope.vm.eYm = moment().format('YYYY-12');

            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.accountLevel = [''];
            $scope.vm.accountLevel_selected = '';
            _getAllProduct();
            _getAccountLevel();
        }
        function _getAccountLevel() {
            var url = 'api/businessaccount/GetPickListData?fieldCodes=account_grade_level';
            rt.get(url).then(function (resp) {
                if (!rt.isNull(resp.data) && !rt.isNull(resp.data.account_grade_level)) {
                    $scope.vm.accountLevel = resp.data.account_grade_level;
                }
            });
        }
        //获取产品
        function _getAllProduct() {
            var url = 'api/ProductCategory/GetSmallestDataList';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }

        $scope.typeSelecttClick = function (selected) {
            $scope.typeSelect = selected;
        };

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            return "";
        }

        // function _getHeader(date) {

        //     myService.GetHandelProduct(date)
        //         .then(function (resp) {
        //             $scope.vm.productlist.push(resp.data.length);
        //             for (var j = 0; j < resp.data.length; j++) {
        //                 var ss = resp.data[j].productidname;
        //                 $scope.vm.aa = resp.data.length;
        //                 $scope.vm.TbMessText.push(ss);
        //                 //$scope.vm.ll = resp.data.length;                                                                           
        //             }
        //         });
        // }

        //计算报表应有宽度
        function _complateTableweight() {
            $scope.tableMaxWeight = $(window).width() + "px";
        }

        //选择时间筛选
        $scope.vm.changeDate = function (dateType) {
            $scope.dateSelect = dateType;

            switch (dateType) {
                case "fullYear":
                    $scope.vm.sYm = moment().format('YYYY-01');
                    $scope.vm.eYm = moment().format('YYYY-12');
                    break;
                case "thisMonth":
                    $scope.vm.sYm = moment().format('YYYY-MM');
                    $scope.vm.eYm = moment().format('YYYY-MM');
                    break;
                case "lastMonth":
                    $scope.vm.sYm = moment().add(-1, 'months').format('YYYY-MM');
                    $scope.vm.eYm = moment().add(-1, 'months').format('YYYY-MM');
                    break;
                case "thisQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-10');
                            $scope.vm.eYm = moment().format('YYYY-12');
                            break;
                    }
                    break;
                case "lastQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().add(-1, 'years').format('YYYY-10');
                            $scope.vm.eYm = moment().add(-1, 'years').format('YYYY-12');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                    }
                    break;
            }
        };

        function _getreport(data) {
            var utils = $.pivotUtilities;
            var sam = utils.aggregators["Sum"];
            var sortAs = utils.sortAs;
            $("#rt-report").pivot(data, {
                rows: ["BusinessUnitIdName", "businessunitowneridname", "accountnum"], //区域，负责人，门店数
                cols: ["Product_CategoryIdName", "type"], //品种，缺货数，缺货率
                sorters: { BusinessUnitIdName: function BusinessUnitIdName(a, b) {
                        return a.localeCompare(b, 'zh-Hans-CN', { sensitivity: 'accent' });
                    } }, //排序
                aggregator: function aggregator(data, rowKey, colKey) {
                    return {
                        s1: '',
                        sum: 0,
                        push: function push(record) {
                            if (record["type"] == "缺货数") {
                                this.s1 = "缺货数";
                                if (!isNaN(parseInt(record["result"]))) {
                                    return this.sum += parseInt(record["result"]);
                                }
                            } else {
                                this.s1 = "缺货率";
                                if (!isNaN(parseFloat(record["result"]))) {
                                    return this.sum += record["result"];
                                }
                            }
                        },
                        value: function value() {
                            return this.sum;
                        },
                        format: function format(x) {
                            if (this.s1 == "缺货数") {
                                return x;
                            } else {
                                return (x * 100).toFixed(2) + '%';
                            }
                        }
                    };
                }
            });

            $('th.pvtAxisLabel').map(function (i) {
                if ($('th.pvtAxisLabel')[i].innerText == "BusinessUnitIdName") $('th.pvtAxisLabel')[i].innerText = "区域";
                if ($('th.pvtAxisLabel')[i].innerText == "businessunitowneridname") $('th.pvtAxisLabel')[i].innerText = "负责人";
                if ($('th.pvtAxisLabel')[i].innerText == "accountnum") $('th.pvtAxisLabel')[i].innerText = "门店数";
                if ($('th.pvtAxisLabel')[i].innerText == "Product_CategoryIdName") $('th.pvtAxisLabel')[i].innerText = "品种";
                if ($('th.pvtAxisLabel')[i].innerText == "type") $('th.pvtAxisLabel')[i].innerText = "数据";
            });
            $('th.pvtTotalLabel').map(function (i) {

                $(".pvtTotalLabel").remove();
                $(".pvtTotal").remove();
                $(".pvtGrandTotal").remove();
            });
        }

        //查询报表数据
        $scope.vm.getReportData = function () {
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var accountLevel_selected = "";
            var pids = "";
            if (!rt.isNull($scope.vm.accountLevel_selected) && !rt.isNull($scope.vm.accountLevel_selected.Value)) {
                accountLevel_selected = $scope.vm.accountLevel_selected.Value;
            }
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join(",");
            }
            var waiting = rt.showLoading2();

            $scope.isQtyShow = false;
            //动销，流向铺货率列表
            myService.GetShopShortStoreReport($scope.vm.sYm, $scope.vm.eYm, pids, accountLevel_selected, unitids).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _getreport($scope.vm.reportData.DataList);
                _complateTableweight();
                waiting.close();
            });
        };
        init();
    }
    angular.module('xrmApp').service('ShopShortStoreService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitStockout';
        this.picklists = ['StateCode', 'accountLevel'];

        //动销，流向铺货率列表
        this.GetShopShortStoreReport = function (sYm, eYm, productIds, accountLevel, unitids) {
            return rt.post("api/VisitStockout/ShopShortStoreReport?sYm=" + sYm + "&eYm=" + eYm + "&productIds=" + productIds + "&accountLevel=" + accountLevel, unitids);
        };

        // this.GetHandelProduct = function (Ym) {
        //     return rt.get("api/BusiDrugflowReport/GetHandelProduct?Ym=" + Ym);
        // };
    }]);
    angular.module('xrmApp').controller("ShopShortStoreListController", ['$scope', '$q', '$compile', 'rt', '$injector', 'ShopShortStoreService', ShopShortStoreListController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2017/12/7
 说明     : 按部门流向统计
 *********************************************************/
(function () {
    'use strict';

    function ShopInspectionListController($scope, $q, $compile, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            // var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";
            var accountLevel_selected = "";
            var pids = "";
            if (!rt.isNull($scope.vm.accountLevel_selected) && !rt.isNull($scope.vm.accountLevel_selected.Value)) {
                accountLevel_selected = $scope.vm.accountLevel_selected.Value;
            }
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join(",");
            }

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "productIds", Value: pids });
            _that.searchList.push({ Type: 1, Key: "accountLevel", Value: accountLevel_selected });
            _that.searchList.push({ Type: 1, Key: "businessunits", Value: unitids });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        //初始化
        function init() {
            //时间筛选，默认全年
            $scope.dateSelect = 'fullYear';
            $scope.vm.sYm = moment().format('YYYY-01');
            $scope.vm.eYm = moment().format('YYYY-12');

            //报表数据
            $scope.vm.pageIndex = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.accountLevel = [''];
            $scope.vm.accountLevel_selected = '';
            _getAllProduct();
            _getAccountLevel();
        }
        function _getAccountLevel() {
            var url = 'api/businessaccount/GetPickListData?fieldCodes=account_grade_level';
            rt.get(url).then(function (resp) {
                if (!rt.isNull(resp.data) && !rt.isNull(resp.data.account_grade_level)) {
                    $scope.vm.accountLevel = resp.data.account_grade_level;
                }
            });
        }
        //获取产品
        function _getAllProduct() {
            var url = 'api/ProductCategory/GetSmallestDataList';
            return rt.get(url).then(function (resp) {
                $scope.vm.productList = resp.data;
                $scope.vm.productSelected = null;
            });
        }

        $scope.typeSelecttClick = function (selected) {
            $scope.typeSelect = selected;
        };

        //查询、导出前检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择时间筛选中的开始时间.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择时间筛选中的结束时间.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "时间筛选中的开始时间不能大于结束时间.";
            }
            return "";
        }

        // function _getHeader(date) {

        //     myService.GetHandelProduct(date)
        //         .then(function (resp) {
        //             $scope.vm.productlist.push(resp.data.length);
        //             for (var j = 0; j < resp.data.length; j++) {
        //                 var ss = resp.data[j].productidname;
        //                 $scope.vm.aa = resp.data.length;
        //                 $scope.vm.TbMessText.push(ss);
        //                 //$scope.vm.ll = resp.data.length;                                                                           
        //             }
        //         });
        // }

        //计算报表应有宽度
        function _complateTableweight() {
            $scope.tableMaxWeight = $(window).width() + "px";
        }

        //选择时间筛选
        $scope.vm.changeDate = function (dateType) {
            $scope.dateSelect = dateType;

            switch (dateType) {
                case "fullYear":
                    $scope.vm.sYm = moment().format('YYYY-01');
                    $scope.vm.eYm = moment().format('YYYY-12');
                    break;
                case "thisMonth":
                    $scope.vm.sYm = moment().format('YYYY-MM');
                    $scope.vm.eYm = moment().format('YYYY-MM');
                    break;
                case "lastMonth":
                    $scope.vm.sYm = moment().add(-1, 'months').format('YYYY-MM');
                    $scope.vm.eYm = moment().add(-1, 'months').format('YYYY-MM');
                    break;
                case "thisQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-10');
                            $scope.vm.eYm = moment().format('YYYY-12');
                            break;
                    }
                    break;
                case "lastQuarter":
                    switch (moment().quarter()) {
                        case 1:
                            $scope.vm.sYm = moment().add(-1, 'years').format('YYYY-10');
                            $scope.vm.eYm = moment().add(-1, 'years').format('YYYY-12');
                            break;
                        case 2:
                            $scope.vm.sYm = moment().format('YYYY-01');
                            $scope.vm.eYm = moment().format('YYYY-03');
                            break;
                        case 3:
                            $scope.vm.sYm = moment().format('YYYY-04');
                            $scope.vm.eYm = moment().format('YYYY-06');
                            break;
                        case 4:
                            $scope.vm.sYm = moment().format('YYYY-07');
                            $scope.vm.eYm = moment().format('YYYY-09');
                            break;
                    }
                    break;
            }
        };

        function _getreport(data) {
            var utils = $.pivotUtilities;
            var sam = utils.aggregators["Sum"];
            var sortAs = utils.sortAs;
            $("#rt-report").pivot(data, {
                rows: ["BusinessUnitIdName", "businessunitowneridname", "accountnum"], //区域，负责人，门店数
                cols: ["Product_CategoryIdName", "type"], //品种，铺货数，铺货率
                sorters: { BusinessUnitIdName: function BusinessUnitIdName(a, b) {
                        return a.localeCompare(b, 'zh-Hans-CN', { sensitivity: 'accent' });
                    } }, //排序
                aggregator: function aggregator(data, rowKey, colKey) {
                    return {
                        s1: '',
                        sum: 0,
                        push: function push(record) {
                            if (record["type"] == "铺货数") {
                                this.s1 = "铺货数";
                                if (!isNaN(parseInt(record["result"]))) {
                                    return this.sum += parseInt(record["result"]);
                                }
                            } else {
                                this.s1 = "铺货率";
                                if (!isNaN(parseFloat(record["result"]))) {
                                    return this.sum += record["result"];
                                }
                            }
                        },
                        value: function value() {
                            return this.sum;
                        },
                        format: function format(x) {
                            if (this.s1 == "铺货数") {
                                return x;
                            } else {
                                return (x * 100).toFixed(2) + '%';
                            }
                        }
                    };
                }
            });

            $('th.pvtAxisLabel').map(function (i) {
                if ($('th.pvtAxisLabel')[i].innerText == "BusinessUnitIdName") $('th.pvtAxisLabel')[i].innerText = "区域";
                if ($('th.pvtAxisLabel')[i].innerText == "businessunitowneridname") $('th.pvtAxisLabel')[i].innerText = "负责人";
                if ($('th.pvtAxisLabel')[i].innerText == "accountnum") $('th.pvtAxisLabel')[i].innerText = "门店数";
                if ($('th.pvtAxisLabel')[i].innerText == "Product_CategoryIdName") $('th.pvtAxisLabel')[i].innerText = "品种";
                if ($('th.pvtAxisLabel')[i].innerText == "type") $('th.pvtAxisLabel')[i].innerText = "数据";
            });
            $('th.pvtTotalLabel').map(function (i) {
                $(".pvtTotalLabel").remove();
                $(".pvtTotal").remove();
                $(".pvtGrandTotal").remove();
            });
        }

        //查询报表数据
        $scope.vm.getReportData = function () {
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var accountLevel_selected = "";
            var pids = "";
            if (!rt.isNull($scope.vm.accountLevel_selected) && !rt.isNull($scope.vm.accountLevel_selected.Value)) {
                accountLevel_selected = $scope.vm.accountLevel_selected.Value;
            }
            if (!rt.isNull($scope.vm.productSelected)) {
                var pmap = $scope.vm.productSelected.map(function (item) {
                    return item.Id;
                });
                pids = pmap.join(",");
            }
            var waiting = rt.showLoading2();

            $scope.isQtyShow = false;
            //动销，巡店铺货率列表
            myService.ShopInspectionReport($scope.vm.sYm, $scope.vm.eYm, pids, accountLevel_selected, unitids).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _getreport($scope.vm.reportData.DataList);
                _complateTableweight();
                waiting.close();
            });
        };
        init();
    }
    angular.module('xrmApp').service('ShopInspectionService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitPSI';
        this.picklists = ['StateCode', 'accountLevel'];

        //动销，巡店铺货率列表
        this.ShopInspectionReport = function (sYm, eYm, productIds, accountLevel, unitids) {
            return rt.post("api/VisitPSI/ShopInspectionReport?sYm=" + sYm + "&eYm=" + eYm + "&productIds=" + productIds + "&accountLevel=" + accountLevel, unitids);
        };

        // this.GetHandelProduct = function (Ym) {
        //     return rt.get("api/BusiDrugflowReport/GetHandelProduct?Ym=" + Ym);
        // };
    }]);
    angular.module('xrmApp').controller("ShopInspectionListController", ['$scope', '$q', '$compile', 'rt', '$injector', 'ShopInspectionService', ShopInspectionListController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Berry Ding
 创建时间 : 2017/6/23
 说明     : 代表签到打印
 *********************************************************/
(function () {
    'use strict';

    function SignInLogController($scope, $q, rt, $injector, $timeout, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "ym", Value: $scope.vm.ym });
            _that.searchList.push({ Type: 1, Key: "ownerid", Value: $scope.vm.ownerSelected.Id });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });

        function init() {
            $scope.vm.reportData = []; //表格数据
            $scope.vm.printData = []; //打印数据
            $scope.vm.ym = moment().add('months', -1).format('YYYY-MM');
            $scope.vm.pageIndex = 1;
            $scope.vm.recordCount = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.getReportData = _getReportData; //查询按钮
            $scope.complateTableheight = _complateTableheight;
            myService.getCurrentUser().then(function (resp) {
                $scope.vm.currentUser = { Id: resp.data.Id, Name: resp.data.Name };
                $scope.vm.ownerSelected = $scope.vm.currentUser;
            });
        }

        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        //检查条件
        function checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.ym)) {
                return "请选择查询年月";
            }

            if (rt.isNull($scope.vm.ownerSelected)) {
                return "请选择代表";
            }
            return "";
        }

        function _getReportData() {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var waiting = rt.showLoading2();
            var url = 'api/SigninLogReport/GetSignInLog?ym=' + encodeURIComponent($scope.vm.ym) + "&ownerId=" + encodeURIComponent($scope.vm.ownerSelected.Id) + "&pageIndex=" + encodeURIComponent($scope.vm.pageIndex) + "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data;
                $scope.vm.recordCount = resp.data.TotalRecords;
                _complateTableheight();
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
        init();

        $scope.vm.print = function () {
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var url = 'api/SigninLogReport/GetSignInLog?ym=' + encodeURIComponent($scope.vm.ym) + "&ownerId=" + encodeURIComponent($scope.vm.ownerSelected.Id) + "&pageIndex=1&pageSize=31";

            rt.get(url).then(function (resp) {
                $scope.vm.printData = resp.data.DataList;
                myService.getUserBusinessUnit(encodeURIComponent($scope.vm.ownerSelected.Id)).then(function (resp) {
                    if ($scope.vm.printData.length > 0) $scope.vm.BusinessUnitIdName = $scope.vm.printData[0].BusinessUnitIdName;else $scope.vm.BusinessUnitIdName = resp.data;

                    var newWin = window.open("Module/SignInLog/printView.html");
                    var html = '<html>' + '<style>' + '.label {' + 'float: left;' + 'width: 33.3%;' + 'text-align: left;' + '}' + 'table {' + 'width: 200px;' + 'min-height: 25px;' + 'line-height: 25px;' + 'text-align: center;' + 'border-collapse: collapse;' + '}' + 'tr {' + 'line-height:20px;' + '}' + 'table tr td {' + 'border: 1px solid black;' + '}' + '@media print {' + '.noPrint {' + 'display: none;' + '}' + '}' + '</style>' + '<head>' + '<meta charset="UTF-8">' + '<title>行程记录单</title>' + '</head>' + '<body>' + '<h3 style="text-align:center";>行程记录单</h3><button class="noPrint" style="position: absolute;top: 10;right: 10;" onclick="window.print();">打印</button>' + '<div style="padding-bottom:40px;">' + '<div class="label">部门：' + $scope.vm.BusinessUnitIdName + '</div>' + '<div class="label">代表：' + $scope.vm.ownerSelected.Name + '</div>' + '<div class="label">工作月份：' + $scope.vm.ym + '</div>' + '</div>' + '<table style="margin: 0 auto;width:100%;font-size:14px;">' + '<tr>' + '<td style="white-space: nowrap;">日期</td>' + '<td>行程足迹</td>' + '</tr>' + '<tr>';

                    for (var i = 0; i < $scope.vm.printData.length; i++) {
                        html += "<td style='white-space: nowrap;'>" + $scope.vm.printData[i].signin_date.substring(0, 10) + "</td><td style='text-align: left;padding-left: 1%;'>" + $scope.vm.printData[i].signin_locations + "</td></tr>";
                    }

                    html += "</table><div style='padding-top:40px;'><div class='label'>打印人：" + $scope.vm.currentUser.Name + "</div>" + "<div class='label'>打印时间：" + moment().format('YYYY-MM-DD HH:mm') + "</div></div></body></html>";

                    newWin.document.write(html); //向新窗口添加内容
                    //newWin.print();
                    newWin.document.location.reload();
                });
            }, function (err) {
                rt.errorMessage(err);
            });
        };
    }
    angular.module('xrmApp').service('SignInLogService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'SigninLogReport';

        //获取当前登录用户
        this.getCurrentUser = function () {
            var api = "api/SigninLogReport/GetCurrentUser";
            return rt.get(api);
        };

        //获取用户所在部门
        this.getUserBusinessUnit = function (id) {
            var api = "api/SigninLogReport/GetUserBusinessUnit?id=" + id;
            return rt.get(api);
        };
    }]).controller("SignInLogController", ['$scope', '$q', 'rt', '$injector', '$timeout', 'SignInLogService', SignInLogController]);
})();
'use strict';

/*************************************************
 * Copyright @ 苏州瑞云信息技术有限公司 All Rights Reserved.
 *创建人： Ludwig Dong
 *创建时间：2016/8/11
 *说明： 操作记录分析
 *************************************************/
(function () {
    'use strict';

    function OperatingAnalysisController($scope, $q, $timeout, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var mdlids = '';
            if (!rt.isNull($scope.vm.MdlSelected)) {
                var mdlmap = $scope.vm.MdlSelected.map(function (item) {
                    return item.TblMdlId;
                });
                mdlids = mdlmap.join("','");
            }
            if (rt.isNull($scope.vm.clientSelected)) {
                $scope.vm.clientSelected = { Id: "" };
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sDate", Value: $scope.vm.startDate });
            _that.searchList.push({ Type: 1, Key: "eDate", Value: $scope.vm.endDate });
            _that.searchList.push({ Type: 1, Key: "tModel", Value: mdlids });
            _that.searchList.push({ Type: 1, Key: "tForm", Value: $scope.vm.clientSelected.Id });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.textXList = []; //月份数据
            $scope.vm.TbMessText = []; //月份对应文本数据
            $scope.vm.TblMdl = [];
            $scope.vm.TblMdlList = [];
            $scope.vm.RepoteData = [];
            $scope.vm.clientList = [];
            $scope.vm.clientSelected = '';
            $scope.vm.pageIndex = 1;
            $scope.vm.TotalRecords = 0;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.showReport = _getReportData;
            $scope.vm.MdlSelected = null;
            _getTblMdl();
            _initYmSelected();
            _initClientType();
        }

        //检查条件
        function checkOption() {

            if (rt.isNullOrWhiteSpace($scope.vm.startDate)) {
                return "开始年月不能为空。";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.endDate)) {
                return "结束年月不能为空。";
            }

            return "";
        }

        //初始化时间
        function _initYmSelected() {
            var d = new Date();
            $scope.vm.startDate = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + "01";
            $scope.vm.endDate = moment().format('YYYY-MM-DD');
        }

        function _initClientType() {
            $scope.vm.clientList = [{ Id: '', Name: '所有' }, { Id: '1', Name: 'PC端' }, { Id: '0', Name: 'Mobile端' }];
            $scope.vm.clientSelected = $scope.vm.clientList[0];
        }

        function _getTblMdl() {
            try {

                var url = 'api/OperatingAnalysis/GetTblMdlDt';
                return rt.get(url, true).then(function (resp) {
                    if (!rt.isNull(resp.data)) {
                        $scope.vm.TblMdl = resp.data.DataList;
                        angular.forEach($scope.vm.TblMdl, function (model) {
                            switch (model.MDLTYPE) {
                                case 'mobile':
                                    model.MdlDesc = model.MdlDesc + "(mobile)";
                                    break;
                                case 'B/S':
                                    model.MdlDesc = model.MdlDesc + "(pc)";
                                    break;
                                case 'report':
                                    model.MdlDesc = model.MdlDesc + "(pc-report)";
                                    break;
                                case 'mobilereport':
                                    model.MdlDesc = model.MdlDesc + "(mobile-report)";
                                    break;
                            }
                            $scope.vm.TblMdlList.push(model);
                        });
                    }
                });
            } catch (e) {}
        }

        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //（暂时）计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        //通过接口获取图表数据
        function _getReportData() {
            var mdlids = [];
            $scope.vm.RepoteData = [];
            if (!rt.isNull($scope.vm.MdlSelected)) {
                var mdlmap = $scope.vm.MdlSelected.map(function (item) {
                    return item.TblMdlId;
                });
                mdlids = mdlmap.join("','");
            }
            var msg = checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var waiting = rt.showLoading2();
            var href = "api/OperatingAnalysis/OpertaingReport?" + "sDate=" + $scope.vm.startDate + "&eDate=" + $scope.vm.endDate + "&mdlIds=" + mdlids + "&clientType=" + $scope.vm.clientSelected.Id;
            _complateTableheight();

            return rt.get(href, true).then(function (resp) {
                waiting.close();
                if (!rt.isNull(resp.data.DataList) && resp.data.DataList.length > 0) {
                    _DayDataList($scope.vm.startDate, $scope.vm.endDate);
                    $scope.vm.RepoteData = resp.data.DataList;
                }
            }, function () {
                waiting.close();
            });
        }

        function _DayDataList(startDate, endDate) {
            $scope.vm.DayDataList = [];
            $scope.vm.DayDataListName = [];
            for (var d = moment(startDate).toDate(); d <= moment(endDate).toDate(); d = moment(d).add('days', 1).toDate()) {
                $scope.vm.DayDataList.push(moment(d).format('YYYY-MM-DD'));
                $scope.vm.DayDataListName.push('使用总计', '人数总计');
            }
        }

        init();
    }

    angular.module('xrmApp').service('OperateAnnalService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'OperatingAnalysis';
        // @@ 选项集
        this.picklists = [];
    }]).controller("OperatingAnalysisController", ['$scope', '$q', '$timeout', 'rt', '$injector', 'OperateAnnalService', OperatingAnalysisController]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Kevin Zhou
 创建时间 : 2016-04-13
 说明     : 终端热度查询
 ********************************************************/
(function () {
    'use strict';

    function terminalheatreportController($scope, $injector, rt, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.startYM });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.endYM });
            _that.searchList.push({ Type: 1, Key: "buid", Value: $scope.vm.buidSelected.id });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: $scope.vm.bigDepSelected.id });
            var unitids = _CalculateUnitids();
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "acclevel", Value: $scope.vm.acclevelSelected.code });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.startYM = moment(moment().format('YYYY-MM') + '-01').format('YYYY-MM-DD');
            $scope.vm.endYM = moment($scope.vm.endYM).format('YYYY-MM-DD');
            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };
            //查询
            $scope.vm.showReport = function () {
                var msg = _checkOption();
                if (!rt.isNullOrWhiteSpace(msg)) {
                    rt.errorMessage(msg);
                    return false;
                }
                var unitids = _CalculateUnitids();
                var bigUnitId = $scope.vm.bigDepSelected.id;
                var buId = $scope.vm.buidSelected.id;
                var acclevel = $scope.vm.acclevelSelected.code;

                //获取终端热度总拜访数和均拜访数
                _getAverage(buId, bigUnitId, unitids, acclevel).then(null, function (message) {
                    rt.errorMessage(message);
                });

                //筛选终端热度明细
                _getReportData(buId, bigUnitId, unitids, acclevel).then(null, function (message) {
                    rt.errorMessage(message);
                });
            };
            _getAllBuid();
            _getAllAcclevel();
        }

        //条件检查
        function _checkOption() {

            if (rt.isNullOrWhiteSpace($scope.vm.startYM)) {
                return "开始时间不能为空";
            }

            if (rt.isNullOrWhiteSpace($scope.vm.endYM)) {
                return "结束时间不能为空";
            }

            if (_CalculateDays($scope.vm.startYM, $scope.vm.endYM) < 0) {
                return "参数异常[开始日期必须小于等于结束日期.]";
            }
        }

        //计算开始结束时间大小关系 间隔天数
        function _CalculateDays(startDate, endDate) {
            var sArr = startDate.split("-");
            var eArr = endDate.split("-");
            var sRDate = new Date(sArr[0], sArr[1]);
            var eRDate = new Date(eArr[0], eArr[1]);
            var result = (eRDate - sRDate) / (24 * 60 * 60 * 1000);
            return result;
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];

            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                        '@queryValue': '',
                        '@ParentBusinessUnitId': $scope.vm.buidSelected.id,
                        '@businesstype': 20
                    }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }

            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {

            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", {
                    '@queryValue': '',
                    '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id,
                    '@businesstype': 10
                }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;

                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            });
        }

        //获取所有客户分级
        function _getAllAcclevel() {
            rt.queryData("Account.AccountGradeLevel", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;

                if (!rt.isNull(data) && data.length > 0) {
                    $scope.vm.acclevelList = data;
                    $scope.vm.acclevelList.unshift({ name: '全部客户分级', code: 0 });
                    $scope.vm.acclevelSelected = $scope.vm.acclevelList[0];
                }
            });
        }

        //获取终端热度总拜访数和均拜访数
        function _getReportData(buId, bigUnitId, unitids, acclevel) {
            var waiting = rt.showLoading2();
            var url = 'api/TerminalHeatReport/GetTerminalHeatReportNew?sYm=' + encodeURIComponent($scope.vm.startYM) + '&eYm=' + encodeURIComponent($scope.vm.endYM) + '&buId=' + encodeURIComponent(buId) + '&bigDepId=' + encodeURIComponent(bigUnitId) + '&unitIds=' + encodeURIComponent(unitids) + '&acclevel=' + encodeURIComponent(acclevel) + '&pageIndex=' + encodeURIComponent($scope.vm.index) + '&pageSize=' + encodeURIComponent($scope.vm.pageSize);
            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }

        //获取均值
        function _getAverage(buId, bigUnitId, unitids, acclevel) {
            var url = 'api/TerminalHeatReport/GetTerminalHeatAvgDataNew?sYm=' + encodeURIComponent($scope.vm.startYM) + '&eYm=' + encodeURIComponent($scope.vm.endYM) + '&buId=' + encodeURIComponent(buId) + '&bigDepId=' + encodeURIComponent(bigUnitId) + '&unitIds=' + encodeURIComponent(unitids) + '&acclevel=' + encodeURIComponent(acclevel);
            return rt.get(url).then(function (resp) {
                $scope.avgNum = resp.data[0].avgNum;
                $scope.avgDayCount = resp.data[0].avgDayCount;
                $scope.sumNum = resp.data[0].sumNum;
            });
        }

        function _CalculateUnitids() {
            var unitids = "";
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            return unitids;
        }
    }

    angular.module('xrmApp').service('TerminalHeatReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'TerminalHeatReport';
        // @@ 选项集
        this.picklists = [];
    }]).controller("terminalheatreportController", ['$scope', '$injector', 'rt', 'TerminalHeatReportService', terminalheatreportController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2017-04-20
 说明     : 终端销量分析报表
 ********************************************************/
(function () {
    function TerminalSalesAnalysisReport($scope, $injector, rt, myService) {
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.tabIndex = 1;
            _getIntialDate();
            _getTops();
            _getAllBuid();
            $scope.vm.search = _search; //查询报表
        }

        $scope.chooseTab = function (index) {
            $scope.vm.tabIndex = index;
            _search();
        };

        function _getIntialDate() {
            $scope.vm.startYM = moment().format('YYYY-01-01');
            $scope.vm.endYM = moment().format('YYYY-MM-01');
        }

        function _getTops() {
            $scope.vm.topsList = [10, 20, 50];
            $scope.vm.topsSelected = $scope.vm.topsList[0];
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.buidSelected) || rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                $scope.vm.bigDepList = [{ name: '全部业务线/大区', id: '' }];
                $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                return;
            }
            if (oldValue != newValue) {
                rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                    $scope.vm.bigDepList = [];
                    $scope.vm.bigDepSelected = null;
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.bigDepList = data;
                    }
                    $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
                    $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
                }, function (error) {
                    $scope.vm.bigDepList = [];
                });
            }
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (rt.isNull($scope.vm.bigDepSelected) || rt.isNullOrWhiteSpace($scope.vm.bigDepSelected.id)) {
                $scope.vm.businessUnitSelected = [];
                $scope.vm.businessUnitList = [];
                return;
            }
            if (oldValue != newValue && !rt.isNullOrWhiteSpace(newValue)) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = [];
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
            $scope.vm.businessUnitList = [];
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                var data = resp.DataList;
                if (data != null && data.length > 0) {
                    $scope.vm.buidList = data;
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
                $scope.vm.buidList.unshift({ id: "", name: "全部事业部" });
                $scope.vm.buidSelected = $scope.vm.buidList[0];
            }, function (error) {});
        }

        //搜索报表数据
        function _search() {
            var msg = _checkOption();
            if (!rt.isNullOrEmptyString(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var productCategoryId = $scope.vm.product_categoryid.Id;
            var buid = "";
            if (!rt.isNull($scope.vm.buidSelected) && !rt.isNullOrEmptyString($scope.vm.buidSelected.id)) {
                buid = $scope.vm.buidSelected.id;
            }
            var bigDepId = "";
            if (!rt.isNull($scope.vm.bigDepSelected) && !rt.isNullOrEmptyString($scope.vm.bigDepSelected.id)) {
                bigDepId = $scope.vm.bigDepSelected.id;
            }
            var businessunitids = "";
            if ($scope.vm.businessUnitSelected.length > 0) {
                var idmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                businessunitids = idmap.join(",");
            }
            switch ($scope.vm.tabIndex) {
                case 1:
                    if (rt.isNull($scope.vm.competing_productid) || rt.isNullOrEmptyString($scope.vm.competing_productid.Id)) {
                        rt.errorMessage("请选择竞品");
                        return false;
                    }
                    var competing_productid = $scope.vm.competing_productid.Id;
                    myService.GetTotalMoney($scope.vm.startYM, $scope.vm.endYM, productCategoryId, competing_productid, buid, bigDepId, businessunitids, $scope.vm.topsSelected).then(function (resp) {
                        $scope.vm.rptData1 = resp.data;
                        _showReport1();
                    });
                    break;
                case 2:
                    myService.GetTotalQty($scope.vm.startYM, $scope.vm.endYM, productCategoryId, buid, bigDepId, businessunitids, $scope.vm.topsSelected).then(function (resp) {
                        $scope.vm.rptData2 = resp.data;
                        _showReport2();
                    });
                    break;
                case 3:
                    if (rt.isNull($scope.vm.competing_productid) || rt.isNullOrEmptyString($scope.vm.competing_productid.Id)) {
                        rt.errorMessage("请选择竞品");
                        return false;
                    }
                    var competing_productid = $scope.vm.competing_productid.Id;
                    myService.GetAvgMoney($scope.vm.startYM, $scope.vm.endYM, productCategoryId, competing_productid, buid, bigDepId, businessunitids, $scope.vm.topsSelected).then(function (resp) {
                        $scope.vm.rptData3 = resp.data;
                        _showReport3();
                    });
                    break;
                case 4:
                    myService.GetAvgQty($scope.vm.startYM, $scope.vm.endYM, productCategoryId, buid, bigDepId, businessunitids, $scope.vm.topsSelected).then(function (resp) {
                        $scope.vm.rptData4 = resp.data;
                        _showReport4();
                    });
                    break;
            }
        }

        //检查条件
        function _checkOption() {
            if (rt.isNullOrEmptyString($scope.vm.startYM) || rt.isNullOrEmptyString($scope.vm.endYM)) {
                return "请选择开始和结束年月";
            }
            if (moment($scope.vm.startYM).format('YYYY') != moment($scope.vm.endYM).format('YYYY')) {
                return "请查询同一年数据";
            }
            if (moment($scope.vm.startYM).format('YYYY-MM') > moment($scope.vm.endYM).format('YYYY-MM')) {
                return "结束年月必须大于等于开始年月";
            }
            if (rt.isNull($scope.vm.product_categoryid) || rt.isNullOrEmptyString($scope.vm.product_categoryid.Id)) {
                return "请选择品类";
            }

            return "";
        }

        //按金额全部
        function _showReport1() {

            var myChart = echarts.init(document.getElementById("report1"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue1 = [];
            var echartsDataValue2 = [];
            var echartsDataValue3 = [];
            var echartsDataName = [];
            var dataList = $scope.vm.rptData1;
            if (dataList) {
                dataList = _.sortBy(dataList, function (item) {
                    return item.mineAmount;
                });
                echartsDataValue1 = _.map(dataList, function (e) {
                    return e.mineAmount.toFixed(2);
                });
                echartsDataValue2 = _.map(dataList, function (e) {
                    return e.lastMineAmount.toFixed(2);
                });
                echartsDataValue3 = _.map(dataList, function (e) {
                    return e.competingAmount.toFixed(2);
                });
                echartsDataName = _.map(dataList, function (e) {
                    return e.accountidname;
                });
            }
            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}万元'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '竞品',
                    type: 'bar',
                    data: echartsDataValue3,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}万元"
                            },
                            labelLine: { show: true }
                        }
                    }
                }, {
                    name: '去年',
                    type: 'bar',
                    data: echartsDataValue2,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}万元"
                            },
                            labelLine: { show: true }
                        }
                    }
                }, {
                    name: '今年',
                    type: 'bar',
                    data: echartsDataValue1,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}万元"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        //按金额月均
        function _showReport3() {

            var myChart = echarts.init(document.getElementById("report3"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue1 = [];
            var echartsDataValue2 = [];
            var echartsDataValue3 = [];
            var echartsDataName = [];
            var dataList = $scope.vm.rptData3;
            if (dataList) {
                dataList = _.sortBy(dataList, function (item) {
                    return item.currentAvgAmount;
                });
                echartsDataValue1 = _.map(dataList, function (e) {
                    return e.currentAvgAmount.toFixed(2);
                });
                echartsDataValue2 = _.map(dataList, function (e) {
                    return e.lastAvgAmount.toFixed(2);
                });
                echartsDataValue3 = _.map(dataList, function (e) {
                    return e.competingAvgAmount.toFixed(2);
                });
                echartsDataName = _.map(dataList, function (e) {
                    return e.accountidname + "|" + '增长率:' + e.amount_per.toFixed(2) + '%';
                });
            }
            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}万元'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsArray = params.split('|');
                            var paramsNameNumber = paramsArray[0].length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = paramsArray[0].substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = paramsArray[0].substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = paramsArray[0];
                            }
                            newParamsName += "\n" + paramsArray[1];
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '竞品',
                    type: 'bar',
                    data: echartsDataValue3,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}万元"
                            },
                            labelLine: { show: true }
                        }
                    }
                }, {
                    name: '去年',
                    type: 'bar',
                    data: echartsDataValue2,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}万元"
                            },
                            labelLine: { show: true }
                        }
                    }
                }, {
                    name: '今年',
                    type: 'bar',
                    data: echartsDataValue1,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}万元"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        //按数量全部
        function _showReport2() {

            var myChart = echarts.init(document.getElementById("report2"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue1 = [];
            var echartsDataValue2 = [];
            var echartsDataValue3 = [];
            var echartsDataName = [];
            var dataList = $scope.vm.rptData2;
            if (dataList) {
                dataList = _.sortBy(dataList, function (item) {
                    return item.currentQty;
                });
                echartsDataValue1 = _.map(dataList, function (e) {
                    return e.currentQty.toFixed(0);
                });
                echartsDataValue2 = _.map(dataList, function (e) {
                    return e.lastQty.toFixed(0);
                });
                echartsDataName = _.map(dataList, function (e) {
                    return e.accountidname;
                });
            }
            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsNameNumber = params.length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = params.substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = params.substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = params;
                            }
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '去年',
                    type: 'bar',
                    data: echartsDataValue2,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}"
                            },
                            labelLine: { show: true }
                        }
                    }
                }, {
                    name: '今年',
                    type: 'bar',
                    data: echartsDataValue1,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        //按数量月均
        function _showReport4() {

            var myChart = echarts.init(document.getElementById("report4"), "shine");
            angular.element(window).on('resize', myChart.resize);
            var echartsDataValue1 = [];
            var echartsDataValue2 = [];
            var echartsDataName = [];
            var dataList = $scope.vm.rptData4;
            if (dataList) {
                dataList = _.sortBy(dataList, function (item) {
                    return item.currentAvgQty;
                });
                echartsDataValue1 = _.map(dataList, function (e) {
                    return e.currentAvgQty.toFixed(0);
                });
                echartsDataValue2 = _.map(dataList, function (e) {
                    return e.lastAvgQty.toFixed(0);
                });
                echartsDataName = _.map(dataList, function (e) {
                    return e.accountidname + "|" + '增长率:' + e.qty_per.toFixed(2) + '%';
                });
            }
            var option = {
                tooltip: {
                    trigger: 'axis'
                },
                xAxis: [{
                    type: 'value',
                    boundaryGap: [0, 0.01],
                    axisLabel: {
                        formatter: '{value}'
                    }
                }],
                yAxis: [{
                    type: 'category',
                    data: echartsDataName,
                    axisLabel: {
                        interval: 0,
                        formatter: function formatter(params) {
                            var newParamsName = "";
                            var paramsArray = params.split('|');
                            var paramsNameNumber = paramsArray[0].length;
                            var provideNumber = 15;
                            var rowNumber = Math.ceil(paramsNameNumber / provideNumber);
                            if (paramsNameNumber > provideNumber) {
                                for (var p = 0; p < rowNumber; p++) {
                                    var tempStr = "";
                                    var start = p * provideNumber;
                                    var end = start + provideNumber;
                                    if (p == rowNumber - 1) {
                                        tempStr = paramsArray[0].substring(start, paramsNameNumber);
                                    } else {
                                        tempStr = paramsArray[0].substring(start, end) + "\n";
                                    }
                                    newParamsName += tempStr;
                                }
                            } else {
                                newParamsName = paramsArray[0];
                            }
                            newParamsName += "\n" + paramsArray[1];
                            return newParamsName;
                        }
                    }
                }],
                grid: { // 控制图的大小，调整下面这些值就可以，
                    x: 150
                    // y2:300,
                    // y1: 300,// y2可以控制 X轴跟Zoom控件之间的间隔，避免以为倾斜后造成 label重叠到zoom上
                },
                series: [{
                    name: '去年',
                    type: 'bar',
                    data: echartsDataValue2,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}"
                            },
                            labelLine: { show: true }
                        }
                    }
                }, {
                    name: '今年',
                    type: 'bar',
                    data: echartsDataValue1,
                    itemStyle: {
                        normal: {
                            label: {
                                show: true,
                                position: 'right',
                                formatter: "{c}"
                            },
                            labelLine: { show: true }
                        }
                    }
                }]
            };
            myChart.clear();
            myChart.setOption(option);
        }

        init();
    }
    angular.module('xrmApp').service('TerminalSalesAnalysisReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'TerminalSalesAnalysisReport';
        // @@ 选项集
        this.picklists = [];
        //按金额全部
        this.GetTotalMoney = function (sYm, eYm, productCategoryId, competingProductId, buid, bigDepId, businessUnitIds, top) {
            var api = "api/TerminalSalesAnalysisReport/GetTotalMoney?sYm=" + encodeURIComponent(sYm) + "&eYm=" + encodeURIComponent(eYm) + "&productCategoryId=" + encodeURIComponent(productCategoryId) + "&competingProductId=" + encodeURIComponent(competingProductId) + "&buid=" + buid + "&bigDepId=" + encodeURIComponent(bigDepId) + "&businessUnitIds=" + businessUnitIds + "&top=" + top;
            return rt.get(api);
        };

        //按数量全部
        this.GetTotalQty = function (sYm, eYm, productCategoryId, buid, bigDepId, businessUnitIds, top) {
            var api = "api/TerminalSalesAnalysisReport/GetTotalQty?sYm=" + encodeURIComponent(sYm) + "&eYm=" + encodeURIComponent(eYm) + "&productCategoryId=" + encodeURIComponent(productCategoryId) + "&buid=" + buid + "&bigDepId=" + encodeURIComponent(bigDepId) + "&businessUnitIds=" + businessUnitIds + "&top=" + top;
            return rt.get(api);
        };

        //按金额月均
        this.GetAvgMoney = function (sYm, eYm, productCategoryId, competingProductId, buid, bigDepId, businessUnitIds, top) {
            var api = "api/TerminalSalesAnalysisReport/GetAvgMoney?sYm=" + encodeURIComponent(sYm) + "&eYm=" + encodeURIComponent(eYm) + "&productCategoryId=" + encodeURIComponent(productCategoryId) + "&competingProductId=" + encodeURIComponent(competingProductId) + "&buid=" + buid + "&bigDepId=" + encodeURIComponent(bigDepId) + "&businessUnitIds=" + businessUnitIds + "&top=" + top;
            return rt.get(api);
        };

        //按数量月均
        this.GetAvgQty = function (sYm, eYm, productCategoryId, buid, bigDepId, businessUnitIds, top) {
            var api = "api/TerminalSalesAnalysisReport/GetAvgQty?sYm=" + encodeURIComponent(sYm) + "&eYm=" + encodeURIComponent(eYm) + "&productCategoryId=" + encodeURIComponent(productCategoryId) + "&buid=" + buid + "&bigDepId=" + encodeURIComponent(bigDepId) + "&businessUnitIds=" + businessUnitIds + "&top=" + top;
            return rt.get(api);
        };
    }]).controller("TerminalSalesAnalysisReportController", ['$scope', '$injector', 'rt', 'TerminalSalesAnalysisReportService', TerminalSalesAnalysisReport]);
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Oscar Gao
 创建时间 : 2017-03-15
 说明     : 终端纯销统计报表
 ********************************************************/
(function () {
    function TerminalSalesReportController($scope, $injector, rt, myService) {
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }

            var productids = '';
            if (!rt.isNull($scope.vm.products)) {
                var idList = $scope.vm.products.map(function (item) {
                    return item.Id;
                });
                productids = idList.join(",");
            }

            $scope.vm.view.searchList = [];
            $scope.vm.view.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.startYM });
            $scope.vm.view.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.endYM });
            $scope.vm.view.searchList.push({ Type: 1, Key: "provinceId", Value: $scope.vm.provinceSelected.id });
            $scope.vm.view.searchList.push({ Type: 1, Key: "cityId", Value: $scope.vm.citySelected.id });
            $scope.vm.view.searchList.push({ Type: 1, Key: "entType", Value: $scope.vm.entTypeSelected.Value });
            $scope.vm.view.searchList.push({ Type: 1, Key: "productIds", Value: productids });
        };

        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            _getAllProvince();
            _getAllEntType();
            _getIntialDate();
            $scope.vm.search = _search; //查询报表
        }

        function _getIntialDate() {
            $scope.vm.startYM = moment().format('YYYY-01-01');
            $scope.vm.endYM = moment().format('YYYY-MM-01');
        }

        //获取省份
        function _getAllProvince() {
            rt.queryData("Province.GetProvince", { '@queryValue': '' }, function (data) {
                $scope.vm.provinceList = data.DataList;
                if ($scope.vm.provinceList) {
                    var ap = [{ id: '', name: '全部省份' }];
                    $scope.vm.provinceList = ap.concat($scope.vm.provinceList);
                }
            });
            $scope.vm.provinceSelected = { id: '', name: '全部省份' };
            $scope.vm.citySelected = { id: '', name: '全部城市' };
        }

        //获取城市 
        $scope.$watch("vm.provinceSelected.id", function (newValue, oldValue) {
            if (newValue != oldValue) {
                if (rt.isNullOrEmptyString(newValue)) {
                    $scope.vm.cityList = [{ id: '', name: '全部城市' }];
                    return;
                }
                rt.queryData("Province.GetCity", { '@queryValue': '', '@provinceid': $scope.vm.provinceSelected ? $scope.vm.provinceSelected.id : '' }, function (data) {
                    $scope.vm.cityList = data.DataList;
                    if ($scope.vm.cityList) {
                        var ac = [{ id: '', name: '全部城市' }];
                        $scope.vm.cityList = ac.concat($scope.vm.cityList);
                        $scope.vm.citySelected = $scope.vm.cityList[0];
                    }
                });
            }
        });

        function _getAllEntType() {
            $scope.vm.entTypeList = [{ Name: "全部类型", Value: 0 }, { Name: "商业", Value: 1 }, { Name: "医院", Value: 2 }, { Name: "零售终端", Value: 3 }, { Name: "基层医疗机构", Value: 4 }, { Name: "代理商", Value: 5 }, { Name: "连锁总部", Value: 6 }];
            $scope.vm.entTypeSelected = $scope.vm.entTypeList[0];
        }

        //搜索报表数据
        function _search() {
            $scope.vm.monthtotal = []; //所有查询月销量合计
            $scope.vm.everymonthtotal = []; //每月销量合计
            $scope.vm.pagetotal = 0;
            $scope.vm.totalSum = 0;
            var monthsum = 0;
            var everymonthsum = 0;

            var msg = _checkOption();
            if (!rt.isNullOrEmptyString(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            _calculateMonthColName($scope.vm.startYM, $scope.vm.endYM);
            var provinceid = $scope.vm.provinceSelected.id;
            var cityid = $scope.vm.citySelected.id;
            var entType = $scope.vm.entTypeSelected.Value;
            var productids = '';
            if (!rt.isNull($scope.vm.products)) {
                var idList = $scope.vm.products.map(function (item) {
                    return item.Id;
                });
                productids = idList.join(",");
            }
            var waiting = rt.showLoading2();
            myService.getTerminalSalesReport($scope.vm.startYM, $scope.vm.endYM, provinceid, cityid, entType, productids, $scope.vm.index, $scope.vm.pageSize).then(function (resp) {
                var data = resp.data;
                var sArr = $scope.vm.startYM.split("-");
                var eArr = $scope.vm.endYM.split("-");
                if (data) {
                    $scope.vm.reportData = data.DataList;
                    $scope.vm.recordCount = data.TotalRecords;

                    for (var i = 0, n = $scope.vm.reportData.length; i < n; i++) {
                        for (var j = 0, k = $scope.vm.reportData[i].monthList.length; j < k; j++) {
                            monthsum += $scope.vm.reportData[i].monthList[j];
                            $scope.vm.pagetotal += $scope.vm.reportData[i].monthList[j];
                        }
                        $scope.vm.monthtotal.push(monthsum);
                        monthsum = 0;
                    }

                    //获取每月销量统计
                    for (var l = 0, m = eArr[1] - sArr[1] + 1; l < m; l++) {
                        for (var a = 0, b = $scope.vm.reportData.length; a < b; a++) {
                            everymonthsum += $scope.vm.reportData[a].monthList[l];
                        }
                        $scope.vm.everymonthtotal.push(everymonthsum);
                        everymonthsum = 0;
                    }
                }
                myService.getTerminalSalesReport($scope.vm.startYM, $scope.vm.endYM, provinceid, cityid, entType, productids, 1, $scope.vm.recordCount + 1).then(function (resp) {
                    var data = resp.data;
                    if (data) {
                        for (var i = 0, n = data.TotalRecords; i < n; i++) {
                            for (var j = 0, k = data.DataList[i].monthList.length; j < k; j++) {
                                $scope.vm.totalSum += data.DataList[i].monthList[j];
                            }
                        }
                    }
                    waiting.close();
                });
                _complateTableheight();
            });
        }

        //检查条件
        function _checkOption() {
            if (rt.isNullOrEmptyString($scope.vm.startYM) || rt.isNullOrEmptyString($scope.vm.endYM)) {
                return "请选择开始和结束年月";
            }
            if (moment($scope.vm.startYM).format('YYYY') != moment($scope.vm.endYM).format('YYYY')) {
                return "请查询同一年数据";
            }
            if (moment($scope.vm.startYM).format('YYYY-MM') > moment($scope.vm.endYM).format('YYYY-MM')) {
                return "结束年月必须大于等于开始年月";
            }
            return "";
        }

        //计算月份列名称
        function _calculateMonthColName(sYm, eYm) {
            var sm = new Date(sYm).getMonth() + 1;
            var em = new Date(eYm).getMonth() + 1;
            $scope.vm.monthColName = [];
            for (var i = sm; i <= em; i++) {
                $scope.vm.monthColName.push(i + '月销量');
            }
        }

        //计算报表应有高度
        function _complateTableheight() {
            $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 90);
        }

        init();
    }
    angular.module('xrmApp').service('TerminalSalesReportService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'TerminalSalesReport';
        // @@ 选项集
        this.picklists = [];
        //获取终端纯销明细
        this.getTerminalSalesReport = function (sYm, eYm, provinceid, cityid, toentType, productids, pageIndex, pageSize) {
            var api = "api/TerminalSalesReport/GetTerminalSalesReportData?sYm=" + encodeURIComponent(sYm) + "&eYm=" + encodeURIComponent(eYm) + "&provinceId=" + encodeURIComponent(provinceid) + "&cityId=" + encodeURIComponent(cityid) + "&entType=" + toentType + "&productIds=" + encodeURIComponent(productids) + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize;
            return rt.get(api);
        };
    }]).controller("TerminalSalesReportController", ['$scope', '$injector', 'rt', 'TerminalSalesReportService', TerminalSalesReportController]);
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 创建人   : Cherry Xu
 创建时间 : 2016-11-8
 说明     : 代表拜访时长分析
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('VisitdurationService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'VisitDurationAnalysis';
        // @@ 选项集
        this.picklists = [];
    }]).controller("visitdurationController", ['$scope', 'rt', '$injector', 'VisitdurationService', visitdurationController]);
    function visitdurationController($scope, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "yM", Value: moment($scope.vm.yM).format('YYYY-MM') });
            _that.searchList.push({ Type: 1, Key: "buId", Value: "" });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: "" });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: rt.isNull($scope.vm.nodeSelected) ? "" : $scope.vm.nodeSelected.ids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.yM = moment().format('YYYY-MM');

            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            //查询
            $scope.vm.showReport = function () {
                _getReportData();
            };
        }

        function _getReportData() {
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();
            var url = "api/VisitDurationAnalysis/GetVisitDurationGridData";
            url += "?yM=" + encodeURIComponent(moment($scope.vm.yM).format('YYYY-MM'));
            url += "&buId=";
            url += "&bigDeptId=";
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            return rt.post(url, unitids).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
            }).finally(function () {
                waiting.close();
            });
        }
    }
})();
'use strict';

/********************************************************
 Copyright @ 苏州瑞泰信息技术有限公司 All rights reserved.
 创建人   : Mona Xia
 创建时间 : 2016-10-27
 说明     : 代表拜访频率分析
 ********************************************************/
(function () {
    'use strict';

    angular.module('xrmApp').service('VisitFrequencyService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'Visitownercount';
        // @@ 选项集
        this.picklists = [];

        //获取客户分级
        this.getAccountLevel = function () {
            var url = "api/businessaccount/GetPickListData?fieldCodes=account_grade_level";
            return rt.get(url);
        };
    }]).controller("visitFrequencyController", ['$scope', '$q', 'rt', '$injector', 'VisitFrequencyService', visitFrequencyController]);
    function visitFrequencyController($scope, $q, rt, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "yM", Value: moment($scope.vm.yM).format('YYYY-MM') });
            _that.searchList.push({ Type: 1, Key: "buId", Value: buId });
            _that.searchList.push({ Type: 1, Key: "bigUnitId", Value: bigUnitId });
            _that.searchList.push({ Type: 1, Key: "unitIds", Value: unitids });
            _that.searchList.push({ Type: 1, Key: "targets", Value: JSON.stringify($scope.vm.account_grade_levelPickList) });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        init();
        function init() {
            $scope.vm.buidList = [];
            $scope.vm.reportData = [];
            $scope.vm.recordCount = 0;
            $scope.vm.index = 1;
            $scope.vm.pageSize = rt.getPaginationSize();
            $scope.vm.yM = moment().format('YYYY-MM');
            $scope.vm.account_grade_levelPickList = [];
            //查询按钮
            $scope.vm.showReportButton = function () {
                $scope.vm.index = 1;
                $scope.vm.showReport();
            };

            _getAccountLevel();
            //查询
            $scope.vm.showReport = function () {
                _getReportData();
                //保存指标
                window.localStorage.setItem("account_grade_levelPickList", JSON.stringify($scope.vm.account_grade_levelPickList));
            };
            _getAllBuid();
        }

        function _getAccountLevel() {
            var waiting = rt.showLoading2();
            myService.getAccountLevel().then(function (resp) {
                $scope.vm.account_grade_levelPickList = resp.data.account_grade_level;
                var len = $scope.vm.account_grade_levelPickList.length;
                var tempList = JSON.parse(window.localStorage.getItem("account_grade_levelPickList"));
                if (rt.isNull(tempList)) {
                    for (var k = len; k > 0; k--) {
                        $scope.vm.account_grade_levelPickList[k - 1].content = len - k + 1;
                    }
                } else {
                    for (var i = 0; i < len; i++) {
                        for (var j = 0; j < tempList.length; j++) {
                            if ($scope.vm.account_grade_levelPickList[i].Name == tempList[j].Name) {
                                $scope.vm.account_grade_levelPickList[i].content = tempList[j].content;
                                break;
                            } else {
                                $scope.vm.account_grade_levelPickList[i].content = 0;
                            }
                        }
                    }
                }
            }).catch(function (err) {
                rt.errorMessage(err);
            }).finally(function () {
                waiting.close();
            });
        }

        //获取商业大区
        $scope.$watch("vm.buidSelected.id", function (newValue, oldValue) {
            $scope.vm.bigDepList = [];
            if (oldValue != newValue) {
                //获取业务线/大区
                if (!rt.isNullOrWhiteSpace($scope.vm.buidSelected.id)) {
                    rt.queryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.buidSelected.id, '@businesstype': 20 }, function (resp) {
                        $scope.vm.bigDepList = $scope.vm.bigDepList.concat(resp.DataList);
                    }, function (error) {
                        $scope.vm.bigDepList = [];
                    });
                }
            }
            $scope.vm.bigDepList.unshift({ name: '全部业务线/大区', id: '' });
            $scope.vm.bigDepSelected = $scope.vm.bigDepList[0];
        });
        //获取省区/地区
        $scope.$watch("vm.bigDepSelected.id", function (newValue, oldValue) {
            if (oldValue != newValue) {
                rt.filteredQueryData("TblBusinessUnit.ChildBusinessUnitIdWithType", { '@queryValue': '', '@ParentBusinessUnitId': $scope.vm.bigDepSelected.id, '@businesstype': 10 }, function (resp) {
                    $scope.vm.businessUnitSelected = null;
                    $scope.vm.businessUnitList = [];
                    var data = resp.DataList;
                    if (data != null && data.length > 0) {
                        $scope.vm.businessUnitList = data;
                    }
                }, function (error) {
                    $scope.vm.businessUnitList = [];
                });
            }
        });
        //获取所有事业部
        function _getAllBuid() {
            rt.queryData("TblBusinessUnit.BuidBusinessUnitIdWithType", { '@queryValue': '' }, function (resp) {
                $scope.vm.buidList = resp.DataList;
                $scope.vm.buidList.unshift({ name: '全部事业部', id: '' });
                if ($scope.vm.buidList != null && $scope.vm.buidList.length > 0) {
                    $scope.vm.buidSelected = $scope.vm.buidList[0];
                }
            }, function (error) {});
        }

        //检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.yM)) {
                return "请选择时间段";
            }
            return "";
        }

        $scope.$watch("vm.reportData", function (newValue, oldValue) {
            if (newValue != oldValue) {
                angular.forEach($scope.vm.reportData, function (data) {
                    data.donePercent = 0;
                    angular.forEach($scope.vm.account_grade_levelPickList, function (target) {
                        if (data.Account_LevelName == target.Name) {
                            if (target.content != 0 && data.accountQty != 0) {
                                data.donePercent = data.visitQty * 1.0 / data.accountQty / target.content * 100;
                            }
                        }
                    });
                });
            }
        });

        function _getReportData() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var unitids = '';
            if (!rt.isNull($scope.vm.businessUnitSelected)) {
                var unitmap = $scope.vm.businessUnitSelected.map(function (item) {
                    return item.id;
                });
                unitids = unitmap.join(",");
            }
            var buId = rt.isNull($scope.vm.buidSelected) ? "" : $scope.vm.buidSelected.id;
            var bigUnitId = rt.isNull($scope.vm.bigDepSelected) ? "" : $scope.vm.bigDepSelected.id;
            var waiting = rt.showLoading2();
            var url = "api/Visitownercount/VisitFrequencyLevel";
            url += "?yM=" + moment($scope.vm.yM).format('YYYY-MM');
            url += "&buId=" + encodeURIComponent(buId);
            url += "&bigDeptId=" + encodeURIComponent(bigUnitId);
            url += "&businessUnitId=" + encodeURIComponent(unitids);
            url += "&pageIndex=" + encodeURIComponent($scope.vm.index);
            url += "&pageSize=" + encodeURIComponent($scope.vm.pageSize);

            return rt.get(url).then(function (resp) {
                $scope.vm.reportData = resp.data.DataList;
                $scope.vm.recordCount = resp.data.TotalRecords;
                waiting.close();
            }, function () {
                waiting.close();
            });
        }
    }
})();
"use strict";

/********************************************************
 Copyright @ 苏州瑞云信息技术有限公司 All rights reserved.
 修改人   : Oscar Gao
 创建时间 : 2016/12/8
 说明     : 日报统计分析
 *********************************************************/
(function () {
    'use strict';

    function workReportStatisticsListController($scope, $timeout, $injector, myService) {
        var _that = this;
        _that.searchList = [];
        this.preExport = function () {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                return msg;
            }
            var unitids = $scope.vm.nodeSelected != null ? $scope.vm.nodeSelected.ids : "";

            _that.searchList.length = 0;
            _that.searchList.push({ Type: 1, Key: "sYm", Value: $scope.vm.sYm });
            _that.searchList.push({ Type: 1, Key: "eYm", Value: $scope.vm.eYm });
            _that.searchList.push({ Type: 1, Key: "type", Value: $scope.vm.type });
            _that.searchList.push({ Type: 1, Key: "businessUnitId", Value: unitids });
        };
        $injector.invoke(reportListController, this, {
            $scope: $scope,
            myService: myService
        });
        var rt = myService.rt;

        function init() {
            $scope.selectedTabId = "tab1";
            $scope.dateSelect = 'today';
            $scope.typeSelect = "daily";
            $scope.vm.type = 'daily_report';
            $scope.vm.typename = '日报';
            $scope.selectTab = _selectTab;
            $scope.vm.search = _search;
            _initYmSelected();
        }

        $scope.complateTableheight = function () {
            _complateTableheight();
        };
        //计算报表应有高度
        function _complateTableheight() {
            $timeout(function () {
                $scope.tableMaxHeight = $(window).height() - ($("nav.navbar-static-top").outerHeight() + $("#divModule .panel-heading").outerHeight() + $("ul.nav-tabs").outerHeight() + $(".form-horizontal").outerHeight() + 110);
            }, 0);
        }

        //切换tab
        function _selectTab(id) {
            $scope.vm.page.index = 1;
            $scope.selectedTabId = id;
            _search();
        }

        //初始化日期
        function _initYmSelected() {
            $scope.vm.sYm = moment().format('YYYY-MM-DD');
            $scope.vm.eYm = moment().format('YYYY-MM-DD');
        }

        //检查条件
        function _checkOption() {
            if (rt.isNullOrWhiteSpace($scope.vm.sYm)) {
                return "请选择开始日期.";
            }
            if (rt.isNullOrWhiteSpace($scope.vm.eYm)) {
                return "请选择结束日期.";
            }
            if ($scope.vm.sYm > $scope.vm.eYm) {
                return "开始日期必须小于等于结束日期.";
            }
            return "";
        }

        function _search() {
            var msg = _checkOption();
            if (!rt.isNullOrWhiteSpace(msg)) {
                rt.errorMessage(msg);
                return false;
            }
            var unitids = $scope.vm.nodeSelected != null ? JSON.stringify($scope.vm.nodeSelected.ids) : "";
            var waiting = rt.showLoading2();
            if ($scope.selectedTabId === "tab1") {
                myService.GetDailyReportStatistics($scope.vm.sYm, $scope.vm.eYm, $scope.vm.type, $scope.vm.page.index, $scope.vm.page.size, unitids).then(function (resp) {
                    $scope.vm.data = resp.data.DataList;
                    $scope.vm.recordCount = resp.data.TotalRecords;
                    waiting.close();
                    _complateTableheight();
                });
            }
            if ($scope.selectedTabId === "tab2") {
                myService.GetDailyReportStatisticsByOwner($scope.vm.sYm, $scope.vm.eYm, $scope.vm.type, $scope.vm.page.index, $scope.vm.page.size, unitids).then(function (resp) {
                    $scope.vm.data = resp.data.DataList;
                    $scope.vm.recordCount = resp.data.TotalRecords;
                    waiting.close();
                    _complateTableheight();
                });
            }
            if ($scope.selectedTabId === "tab3") {
                myService.GetUnSubmitDailyReportUser($scope.vm.sYm, $scope.vm.eYm, $scope.vm.type, $scope.vm.page.index, $scope.vm.page.size, unitids).then(function (resp) {
                    $scope.vm.data = resp.data.DataList;
                    $scope.vm.recordCount = resp.data.TotalRecords;
                    waiting.close();
                    _complateTableheight();
                });
            }
        }

        init();

        $scope.vm.changeType = function (type) {
            $scope.typeSelect = type;

            switch (type) {
                case "daily":
                    $scope.vm.type = 'daily_report';
                    $scope.vm.typename = '日报';
                    break;
                case "weekly":
                    $scope.vm.type = 'weekly_report';
                    $scope.vm.typename = '周报';
                    break;
                case "monthly":
                    $scope.vm.type = 'monthly_report';
                    $scope.vm.typename = '月报';
                    break;
            }
        };

        $scope.vm.changeDate = function (date) {
            $scope.dateSelect = date;

            switch (date) {
                case "today":
                    $scope.vm.sYm = moment().format('YYYY-MM-DD');
                    $scope.vm.eYm = moment().format('YYYY-MM-DD');
                    break;
                case "yesterday":
                    $scope.vm.sYm = moment().add(-1, 'days').format('YYYY-MM-DD');
                    $scope.vm.eYm = moment().add(-1, 'days').format('YYYY-MM-DD');
                    break;
                case "thisweek":
                    $scope.vm.sYm = moment().add(-moment().format('d') + 1, 'days').format('YYYY-MM-DD');
                    $scope.vm.eYm = moment().format('YYYY-MM-DD');
                    break;
                case "thismonth":
                    $scope.vm.sYm = moment().format('YYYY-MM') + '-01';
                    $scope.vm.eYm = moment().format('YYYY-MM-DD');
                    break;
            }
        };
    }

    angular.module('xrmApp').service('WorkReportStatisticsService', ['entityService', function (entityService) {
        var rt = entityService.rt;
        angular.extend(this, entityService);
        // @@设置WebAPI的控制器名称
        this.controllerName = 'WorkReportStatistics';
        // @@ 选项集
        this.picklists = [];

        //按部门统计提交情况
        this.GetDailyReportStatistics = function (sYm, eYm, type, pageIndex, pageSize, unitids) {
            return rt.post("api/WorkReportStatistics/GetDailyReportStatistics?sYm=" + sYm + "&eYm=" + eYm + "&type=" + type + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize, unitids);
        };

        //按代表统计提交情况
        this.GetDailyReportStatisticsByOwner = function (sYm, eYm, type, pageIndex, pageSize, unitids) {
            return rt.post("api/WorkReportStatistics/GetDailyReportStatisticsByOwner?sYm=" + sYm + "&eYm=" + eYm + "&type=" + type + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize, unitids);
        };

        //获取未提交人员清单
        this.GetUnSubmitDailyReportUser = function (sYm, eYm, type, pageIndex, pageSize, unitids) {
            return rt.post("api/WorkReportStatistics/GetUnSubmitDailyReportUser?sYm=" + sYm + "&eYm=" + eYm + "&type=" + type + "&pageIndex=" + pageIndex + "&pageSize=" + pageSize, unitids);
        };
    }]);
    angular.module('xrmApp').controller("workReportStatisticsListController", ['$scope', '$timeout', '$injector', 'WorkReportStatisticsService', workReportStatisticsListController]);
})();
//# sourceMappingURL=business.jcy.js.map
